/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* AArch64PreLegalizerCombinerImpl Combiner Match Table                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GICOMBINER_DEPS
#include "llvm/ADT/SparseBitVector.h"
namespace llvm {
extern cl::OptionCategory GICombinerOptionCategory;
} // end namespace llvm
#endif // ifdef GET_GICOMBINER_DEPS

#ifdef GET_GICOMBINER_TYPES
struct AArch64PreLegalizerCombinerImplRuleConfig {
  SparseBitVector<> DisabledRules;

  bool isRuleEnabled(unsigned RuleID) const;
  bool parseCommandLineOption();
  bool setRuleEnabled(StringRef RuleIdentifier);
  bool setRuleDisabled(StringRef RuleIdentifier);
};

static std::optional<uint64_t> getRuleIdxForIdentifier(StringRef RuleIdentifier) {
  uint64_t I;
  // getAtInteger(...) returns false on success
  bool Parsed = !RuleIdentifier.getAsInteger(0, I);
  if (Parsed)
    return I;

#ifndef NDEBUG
  switch (RuleIdentifier.size()) {
  default: break;
  case 9:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "opy_prop", 8) != 0)
        break;
      return 13;	 // "copy_prop"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ors", 7) != 0)
          break;
        return 192;	 // "match_ors"
      case 'u':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "lo_by_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case '0':	 // 1 string to match.
          return 143;	 // "mulo_by_0"
        case '2':	 // 1 string to match.
          return 142;	 // "mulo_by_2"
        }
        break;
      }
      break;
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "neg_zext", 8) != 0)
        break;
      return 197;	 // "nneg_zext"
    }
    break;
  case 10:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2p_to_p2i", 9) != 0)
        break;
      return 88;	 // "i2p_to_p2i"
    case 'm':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ands", 8) != 0)
          break;
        return 191;	 // "match_ands"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_to_shl", 8) != 0)
          break;
        return 14;	 // "mul_to_shl"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2i_to_i2p", 9) != 0)
        break;
      return 87;	 // "p2i_to_i2p"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_trunc", 8) != 0)
          break;
        return 195;	 // "sext_trunc"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_to_add", 8) != 0)
          break;
        return 15;	 // "sub_to_add"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc", 9) != 0)
        break;
      return 196;	 // "zext_trunc"
    }
    break;
  case 11:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_sub_reg", 10) != 0)
        break;
      return 93;	 // "add_sub_reg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_addos", 10) != 0)
        break;
      return 211;	 // "match_addos"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ub_add_reg", 10) != 0)
        break;
      return 186;	 // "sub_add_reg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_shift", 10) != 0)
        break;
      return 130;	 // "trunc_shift"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_cst", 10) != 0)
        break;
      return 205;	 // "unmerge_cst"
    }
    break;
  case 12:	 // 11 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinusB", 11) != 0)
        break;
      return 2;	 // "APlusBMinusB"
    case 'B':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusAPlusA", 11) != 0)
        break;
      return 3;	 // "BMinusAPlusA"
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dde_to_addo", 11) != 0)
        break;
      return 144;	 // "adde_to_addo"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "sub_to_fneg", 11) != 0)
        break;
      return 188;	 // "fsub_to_fneg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ulh_to_lshr", 11) != 0)
        break;
      return 174;	 // "mulh_to_lshr"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ot_cmp_fold", 11) != 0)
        break;
      return 131;	 // "not_cmp_fold"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_or", 11) != 0)
        break;
      return 126;	 // "redundant_or"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_pow2", 10) != 0)
          break;
        return 172;	 // "sdiv_by_pow2"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_of_sext", 10) != 0)
          break;
        return 48;	 // "sext_of_sext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "div_by_pow2", 11) != 0)
        break;
      return 173;	 // "udiv_by_pow2"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_zext", 11) != 0)
        break;
      return 46;	 // "zext_of_zext"
    }
    break;
  case 13:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_of_vscale", 12) != 0)
        break;
      return 37;	 // "add_of_vscale"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_shift", 12) != 0)
        break;
      return 160;	 // "commute_shift"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_and_mask", 12) != 0)
        break;
      return 68;	 // "load_and_mask"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_selects", 11) != 0)
          break;
        return 123;	 // "match_selects"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "rge_unmerge", 11) != 0)
          break;
        return 204;	 // "merge_unmerge"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 38;	 // "mul_of_vscale"
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_and", 12) != 0)
        break;
      return 124;	 // "redundant_and"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 171;	 // "sdiv_by_const"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 39;	 // "shl_of_vscale"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_of_vscale", 11) != 0)
          break;
        return 40;	 // "sub_of_vscale"
      }
      break;
    case 'u':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 170;	 // "udiv_by_const"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "merge_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case 'm':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "erge", 4) != 0)
            break;
          return 203;	 // "unmerge_merge"
        case 'u':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "ndef", 4) != 0)
            break;
          return 206;	 // "unmerge_undef"
        }
        break;
      }
      break;
    }
    break;
  case 14:	 // 15 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1PlusC2", 12) != 0)
          break;
        return 12;	 // "AMinusC1PlusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusC1MinusC2", 12) != 0)
          break;
        return 8;	 // "APlusC1MinusC2"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2MinusAPlusC1", 13) != 0)
        break;
      return 9;	 // "C2MinusAPlusC1"
    case 'a':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_", 9) != 0)
        break;
      switch (RuleIdentifier[10]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 52;	 // "anyext_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 51;	 // "anyext_of_zext"
      }
      break;
    case 'b':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'i')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "op_same_val", 11) != 0)
          break;
        return 84;	 // "binop_same_val"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "reverse_shl", 11) != 0)
          break;
        return 158;	 // "bitreverse_shl"
      }
      break;
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "bs_fneg_fold", 12) != 0)
          break;
        return 169;	 // "fabs_fneg_fold"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "eg_fneg_fold", 12) != 0)
          break;
        return 90;	 // "fneg_fneg_fold"
      }
      break;
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ul_by_neg_one", 13) != 0)
        break;
      return 17;	 // "mul_by_neg_one"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eassoc_ptradd", 13) != 0)
        break;
      return 105;	 // "reassoc_ptradd"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 2 strings to match.
        switch (RuleIdentifier[2]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "ect_of_zext", 11) != 0)
            break;
          return 53;	 // "select_of_zext"
        case 'x':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "t_of_anyext", 11) != 0)
            break;
          return 49;	 // "sext_of_anyext"
        }
        break;
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ifts_too_big", 12) != 0)
          break;
        return 104;	 // "shifts_too_big"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_anyext", 13) != 0)
        break;
      return 47;	 // "zext_of_anyext"
    }
    break;
  case 15:	 // 12 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1MinusC2", 13) != 0)
          break;
        return 10;	 // "AMinusC1MinusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusZeroMinusB", 13) != 0)
          break;
        return 1;	 // "APlusZeroMinusB"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "1Minus2MinusC2", 14) != 0)
        break;
      return 11;	 // "C1Minus2MinusC2"
    case 'Z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eroMinusAPlusB", 14) != 0)
        break;
      return 0;	 // "ZeroMinusAPlusB"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itreverse_lshr", 14) != 0)
        break;
      return 159;	 // "bitreverse_lshr"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtending_loads", 14) != 0)
        break;
      return 67;	 // "extending_loads"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dempotent_prop", 14) != 0)
        break;
      return 18;	 // "idempotent_prop"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_or_combine", 14) != 0)
        break;
      return 151;	 // "load_or_combine"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_or", 14) != 0)
        break;
      return 61;	 // "narrow_binop_or"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "verlapping_and", 14) != 0)
        break;
      return 141;	 // "overlapping_and"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_same_val", 14) != 0)
        break;
      return 82;	 // "select_same_val"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc_fold", 14) != 0)
        break;
      return 128;	 // "zext_trunc_fold"
    }
    break;
  case 16:	 // 12 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_anyext", 15) != 0)
        break;
      return 50;	 // "anyext_of_anyext"
    case 'n':	 // 5 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_", 12) != 0)
        break;
      switch (RuleIdentifier[13]) {
      default: break;
      case 'a':	 // 2 strings to match.
        switch (RuleIdentifier[14]) {
        default: break;
        case 'd':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 57;	 // "narrow_binop_add"
        case 'n':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 60;	 // "narrow_binop_and"
        }
        break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ul", 2) != 0)
          break;
        return 59;	 // "narrow_binop_mul"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ub", 2) != 0)
          break;
        return 58;	 // "narrow_binop_sub"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "or", 2) != 0)
          break;
        return 62;	 // "narrow_binop_xor"
      }
      break;
    case 's':	 // 3 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_", 6) != 0)
        break;
      switch (RuleIdentifier[7]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "f_anyext", 8) != 0)
          break;
        return 54;	 // "select_of_anyext"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "o_minmax", 8) != 0)
          break;
        return 187;	 // "select_to_minmax"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "ndef_cmp", 8) != 0)
          break;
        return 120;	 // "select_undef_cmp"
      }
      break;
    case 't':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_", 11) != 0)
        break;
      switch (RuleIdentifier[12]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 44;	 // "truncate_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 43;	 // "truncate_of_zext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ndef_to_fp_zero", 15) != 0)
        break;
      return 70;	 // "undef_to_fp_zero"
    }
    break;
  case 17:	 // 14 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'A':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "plusC", 5) != 0)
          break;
        return 6;	 // "APlusBMinusAplusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "PlusA", 5) != 0)
          break;
        return 7;	 // "APlusBMinusCPlusA"
      }
      break;
    case 'a':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "d_p2i_to_ptradd", 15) != 0)
          break;
        return 16;	 // "add_p2i_to_ptradd"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "yext_trunc_fold", 15) != 0)
          break;
        return 89;	 // "anyext_trunc_fold"
      }
      break;
    case 'c':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nonicalize_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 109;	 // "canonicalize_fcmp"
        case 'i':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 108;	 // "canonicalize_icmp"
        }
        break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "nstant_fold_fma", 15) != 0)
          break;
        return 167;	 // "constant_fold_fma"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "iv_rem_to_divrem", 16) != 0)
        break;
      return 152;	 // "div_rem_to_divrem"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "rase_undef_store", 16) != 0)
        break;
      return 80;	 // "erase_undef_store"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_with_zero", 16) != 0)
        break;
      return 148;	 // "ptr_add_with_zero"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_to_iminmax", 15) != 0)
          break;
        return 122;	 // "select_to_iminmax"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ift_immed_chain", 15) != 0)
          break;
        return 149;	 // "shift_immed_chain"
      }
      break;
    case 'u':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "def_to_int_zero", 15) != 0)
          break;
        return 71;	 // "undef_to_int_zero"
      case 'r':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "em_pow2_to_mask", 15) != 0)
          break;
        return 127;	 // "urem_pow2_to_mask"
      }
      break;
    }
    break;
  case 18:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusBPlus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'B':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusC", 6) != 0)
          break;
        return 5;	 // "AMinusBPlusBMinusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusA", 6) != 0)
          break;
        return 4;	 // "AMinusBPlusCMinusA"
      }
      break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_to_zero", 17) != 0)
        break;
      return 85;	 // "binop_left_to_zero"
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_minmax_nan", 15) != 0)
          break;
        return 145;	 // "combine_minmax_nan"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_f", 12) != 0)
          break;
        switch (RuleIdentifier[15]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "bs", 2) != 0)
            break;
          return 134;	 // "constant_fold_fabs"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "eg", 2) != 0)
            break;
          return 133;	 // "constant_fold_fneg"
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xpand_const_fpowi", 17) != 0)
        break;
      return 146;	 // "expand_const_fpowi"
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_global_offset", 16) != 0)
          break;
        return 215;	 // "fold_global_offset"
      case 'p':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "trunc_fpext_fold", 16) != 0)
          break;
        return 98;	 // "fptrunc_fpext_fold"
      }
      break;
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 2 strings to match.
        switch (RuleIdentifier[2]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "ect_of_truncate", 15) != 0)
            break;
          return 55;	 // "select_of_truncate"
        case 'x':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "t_inreg_of_load", 15) != 0)
            break;
          return 117;	 // "sext_inreg_of_load"
        }
        break;
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "uffle_to_extract", 16) != 0)
          break;
        return 216;	 // "shuffle_to_extract"
      }
      break;
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_anyext", 17) != 0)
        break;
      return 45;	 // "truncate_of_anyext"
    }
    break;
  case 19:	 // 16 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_to_zero", 18) != 0)
        break;
      return 86;	 // "binop_right_to_zero"
    case 'c':	 // 4 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "onst", 4) != 0)
        break;
      switch (RuleIdentifier[5]) {
      default: break;
      case '_':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+6, "ptradd_to_i2p", 13) != 0)
          break;
        return 140;	 // "const_ptradd_to_i2p"
      case 'a':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "nt_fold_", 8) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'b':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "inop", 4) != 0)
            break;
          return 165;	 // "constant_fold_binop"
        case 'f':	 // 2 strings to match.
          switch (RuleIdentifier[15]) {
          default: break;
          case 'l':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "og2", 3) != 0)
              break;
            return 136;	 // "constant_fold_flog2"
          case 's':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "qrt", 3) != 0)
              break;
            return 135;	 // "constant_fold_fsqrt"
          }
          break;
        }
        break;
      }
      break;
    case 'e':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "xt", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case '_':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "uaddv_to_uaddlv", 15) != 0)
          break;
        return 218;	 // "ext_uaddv_to_uaddlv"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "nd_through_phis", 15) != 0)
          break;
        return 101;	 // "extend_through_phis"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nteger_of_truncate", 18) != 0)
        break;
      return 63;	 // "integer_of_truncate"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_zero", 18) != 0)
        break;
      return 210;	 // "merge_of_x_and_zero"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_immed_chain", 18) != 0)
        break;
      return 107;	 // "ptr_add_immed_chain"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "assoc_comm_binops", 17) != 0)
          break;
        return 106;	 // "reassoc_comm_binops"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_zero", 17) != 0)
          break;
        return 83;	 // "right_identity_zero"
      }
      break;
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_constant_cmp", 17) != 0)
          break;
        return 121;	 // "select_constant_cmp"
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "mplify_", 7) != 0)
          break;
        switch (RuleIdentifier[9]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "dd_to_sub", 9) != 0)
            break;
          return 102;	 // "simplify_add_to_sub"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "eg_minmax", 9) != 0)
            break;
          return 193;	 // "simplify_neg_minmax"
        }
        break;
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nary_undef_to_zero", 18) != 0)
        break;
      return 75;	 // "unary_undef_to_zero"
    }
    break;
  case 20:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nd_or_disjoint_mask", 19) != 0)
        break;
      return 176;	 // "and_or_disjoint_mask"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itcast_bitcast_fold", 19) != 0)
        break;
      return 97;	 // "bitcast_bitcast_fold"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_redundant_trunc", 19) != 0)
        break;
      return 214;	 // "icmp_redundant_trunc"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_undef", 19) != 0)
        break;
      return 209;	 // "merge_of_x_and_undef"
    case 'r':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "edu", 3) != 0)
        break;
      switch (RuleIdentifier[4]) {
      default: break;
      case 'c':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+5, "e_shl_of_extend", 15) != 0)
          break;
        return 118;	 // "reduce_shl_of_extend"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+5, "dant_sext_inreg", 15) != 0)
          break;
        return 125;	 // "redundant_sext_inreg"
      }
      break;
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ry_undef_to_undef", 17) != 0)
          break;
        return 76;	 // "unary_undef_to_undef"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_zext_to_zext", 17) != 0)
          break;
        return 208;	 // "unmerge_zext_to_zext"
      }
      break;
    }
    break;
  case 21:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_concat_vector", 18) != 0)
          break;
        return 194;	 // "combine_concat_vector"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_", 11) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'c':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ast_op", 6) != 0)
            break;
          return 168;	 // "constant_fold_cast_op"
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ptrunc", 6) != 0)
            break;
          return 137;	 // "constant_fold_fptrunc"
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xt_addv_to_udot_addv", 20) != 0)
        break;
      return 217;	 // "ext_addv_to_udot_addv"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "constant_to_constant", 20) != 0)
        break;
      return 213;	 // "fconstant_to_constant"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_vector_elt_oob", 20) != 0)
        break;
      return 24;	 // "insert_vector_elt_oob"
    case 'p':	 // 4 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ush_", 4) != 0)
        break;
      switch (RuleIdentifier[5]) {
      default: break;
      case 'a':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "dd_through_", 11) != 0)
          break;
        switch (RuleIdentifier[17]) {
        default: break;
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+18, "ext", 3) != 0)
            break;
          return 222;	 // "push_add_through_sext"
        case 'z':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+18, "ext", 3) != 0)
            break;
          return 220;	 // "push_add_through_zext"
        }
        break;
      case 's':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "ub_through_", 11) != 0)
          break;
        switch (RuleIdentifier[17]) {
        default: break;
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+18, "ext", 3) != 0)
            break;
          return 221;	 // "push_sub_through_sext"
        case 'z':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+18, "ext", 3) != 0)
            break;
          return 219;	 // "push_sub_through_zext"
        }
        break;
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_fp", 20) != 0)
        break;
      return 92;	 // "right_identity_one_fp"
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ef_to_negative_one", 18) != 0)
          break;
        return 72;	 // "undef_to_negative_one"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_dead_to_trunc", 18) != 0)
          break;
        return 207;	 // "unmerge_dead_to_trunc"
      }
      break;
    }
    break;
  case 22:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_shuffle_concat", 19) != 0)
          break;
        return 198;	 // "combine_shuffle_concat"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_fp_binop", 19) != 0)
          break;
        return 166;	 // "constant_fold_fp_binop"
      }
      break;
    case 'f':	 // 4 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_binop_into_select", 20) != 0)
          break;
        return 185;	 // "fold_binop_into_select"
      case 'u':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nnel_shift_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "eft_zero", 8) != 0)
            break;
          return 156;	 // "funnel_shift_left_zero"
        case 'o':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "vershift", 8) != 0)
            break;
          return 157;	 // "funnel_shift_overshift"
        case 't':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "o_rotate", 8) != 0)
            break;
          return 154;	 // "funnel_shift_to_rotate"
        }
        break;
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_lhs_known_bits", 21) != 0)
        break;
      return 111;	 // "icmp_to_lhs_known_bits"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_subo_no_overflow", 21) != 0)
        break;
      return 212;	 // "match_subo_no_overflow"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_any_op", 21) != 0)
        break;
      return 77;	 // "propagate_undef_any_op"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "dundant_neg_operands", 20) != 0)
          break;
        return 175;	 // "redundant_neg_operands"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_one_int", 20) != 0)
          break;
        return 91;	 // "right_identity_one_int"
      }
      break;
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hl_ashr_to_sext_inreg", 21) != 0)
        break;
      return 115;	 // "shl_ashr_to_sext_inreg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_buildvector_fold", 21) != 0)
        break;
      return 95;	 // "trunc_buildvector_fold"
    }
    break;
  case 23:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "uildvector_of_truncate", 22) != 0)
        break;
      return 56;	 // "buildvector_of_truncate"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_right_zero", 22) != 0)
        break;
      return 155;	 // "funnel_shift_right_zero"
    case 'i':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "tof_const_zero_fold_", 20) != 0)
        break;
      switch (RuleIdentifier[21]) {
      default: break;
      case 's':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 138;	 // "itof_const_zero_fold_si"
      case 'u':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 139;	 // "itof_const_zero_fold_ui"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_all_ops", 22) != 0)
        break;
      return 78;	 // "propagate_undef_all_ops"
    }
    break;
  case 24:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_undef_to_zero", 23) != 0)
        break;
      return 73;	 // "binop_left_undef_to_zero"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element", 23) != 0)
        break;
      return 23;	 // "match_extract_of_element"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_feeding_and", 23) != 0)
        break;
      return 119;	 // "narrow_binop_feeding_and"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_inreg_to_zext_inreg", 23) != 0)
        break;
      return 129;	 // "sext_inreg_to_zext_inreg"
    case 'x':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "or_of_and_with_same_reg", 23) != 0)
        break;
      return 147;	 // "xor_of_and_with_same_reg"
    }
    break;
  case 25:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "tfield_extract_from_", 20) != 0)
          break;
        switch (RuleIdentifier[22]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "nd", 2) != 0)
            break;
          return 162;	 // "bitfield_extract_from_and"
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "hr", 2) != 0)
            break;
          return 163;	 // "bitfield_extract_from_shr"
        }
        break;
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ildvector_identity_fold", 23) != 0)
          break;
        return 94;	 // "buildvector_identity_fold"
      }
      break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_shuffle_undef_rhs", 24) != 0)
        break;
      return 199;	 // "combine_shuffle_undef_rhs"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vec_elt_build_vec", 24) != 0)
        break;
      return 65;	 // "extract_vec_elt_build_vec"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eg_and_one_to_sext_inreg", 24) != 0)
        break;
      return 116;	 // "neg_and_one_to_sext_inreg"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_one_fp", 24) != 0)
        break;
      return 100;	 // "right_identity_neg_one_fp"
    }
    break;
  case 26:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_undef_to_undef", 25) != 0)
        break;
      return 74;	 // "binop_right_undef_to_undef"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_fp_constant_to_rhs", 25) != 0)
        break;
      return 190;	 // "commute_fp_constant_to_rhs"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_from_or_shift", 25) != 0)
        break;
      return 153;	 // "funnel_shift_from_or_shift"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_zero_fp", 25) != 0)
        break;
      return 99;	 // "right_identity_neg_zero_fp"
    }
    break;
  case 27:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "om", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case 'b':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ine_use_vector_truncate", 23) != 0)
          break;
        return 201;	 // "combine_use_vector_truncate"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ute_int_constant_to_rhs", 23) != 0)
          break;
        return 189;	 // "commute_int_constant_to_rhs"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_or_combine", 26) != 0)
        break;
      return 113;	 // "double_icmp_zero_or_combine"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_binop_in_equality", 26) != 0)
        break;
      return 114;	 // "redundant_binop_in_equality"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_lshr_buildvector_fold", 26) != 0)
        break;
      return 96;	 // "trunc_lshr_buildvector_fold"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_anyext_build_vector", 26) != 0)
        break;
      return 202;	 // "unmerge_anyext_build_vector"
    }
    break;
  case 28:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_and_combine", 27) != 0)
        break;
      return 112;	 // "double_icmp_zero_and_combine"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "pt_brcond_by_inverting_cond", 27) != 0)
        break;
      return 132;	 // "opt_brcond_by_inverting_cond"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_shuffle_mask", 27) != 0)
        break;
      return 79;	 // "propagate_undef_shuffle_mask"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hift_of_shifted_logic_chain", 27) != 0)
        break;
      return 150;	 // "shift_of_shifted_logic_chain"
    }
    break;
  case 29:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_shr_and", 28) != 0)
        break;
      return 164;	 // "bitfield_extract_from_shr_and"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "xtracted_vector_load", 20) != 0)
          break;
        return 69;	 // "combine_extracted_vector_load"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "huffle_disjoint_mask", 20) != 0)
          break;
        return 200;	 // "combine_shuffle_disjoint_mask"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_true_false_known_bits", 28) != 0)
        break;
      return 110;	 // "icmp_to_true_false_known_bits"
    }
    break;
  case 30:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "freeze_of_non_undef_non_poison", 30) != 0)
      break;
    return 41;	 // "freeze_of_non_undef_non_poison"
  case 31:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_", 22) != 0)
      break;
    switch (RuleIdentifier[22]) {
    default: break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+23, "lt_undef", 8) != 0)
        break;
      return 22;	 // "insert_vector_element_elt_undef"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+23, "dx_undef", 8) != 0)
        break;
      return 21;	 // "insert_vector_element_idx_undef"
    }
    break;
  case 32:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_sext_inreg", 31) != 0)
        break;
      return 161;	 // "bitfield_extract_from_sext_inreg"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_f", 8) != 0)
        break;
      switch (RuleIdentifier[9]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "dd_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 177;	 // "combine_fadd_fmul_to_fmad_or_fma"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "ub_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 181;	 // "combine_fsub_fmul_to_fmad_or_fma"
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_not_const", 31) != 0)
        break;
      return 25;	 // "extract_vector_element_not_const"
    }
    break;
  case 34:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_all_elts_from_build_vector", 34) != 0)
      break;
    return 66;	 // "extract_all_elts_from_build_vector"
  case 35:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_build_vector", 35) != 0)
      break;
    return 27;	 // "extract_vector_element_build_vector"
  case 36:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'f':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "add_fma_fmul_to_fmad_or_fma", 27) != 0)
          break;
        return 179;	 // "combine_fadd_fma_fmul_to_fmad_or_fma"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "nsert_vec_elts_build_vector", 27) != 0)
          break;
        return 64;	 // "combine_insert_vec_elts_build_vector"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_extract_vec_elt_out_of_bounds", 35) != 0)
        break;
      return 81;	 // "insert_extract_vec_elt_out_of_bounds"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_index", 35) != 0)
        break;
      return 20;	 // "match_extract_of_element_undef_index"
    }
    break;
  case 37:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fsub_fneg_fmul_to_fmad_or_fma", 36) != 0)
        break;
      return 182;	 // "combine_fsub_fneg_fmul_to_fmad_or_fma"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_shuffle_vector", 36) != 0)
        break;
      return 35;	 // "extract_vector_element_shuffle_vector"
    case 'h':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oist_logic_op_with_same_opcode_hands", 36) != 0)
        break;
      return 103;	 // "hoist_logic_op_with_same_opcode_hands"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_vector", 36) != 0)
        break;
      return 19;	 // "match_extract_of_element_undef_vector"
    }
    break;
  case 38:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_f", 9) != 0)
      break;
    switch (RuleIdentifier[9]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "dd_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 178;	 // "combine_fadd_fpext_fmul_to_fmad_or_fma"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "ub_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 183;	 // "combine_fsub_fpext_fmul_to_fmad_or_fma"
    }
    break;
  case 40:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_different_indices", 40) != 0)
      break;
    return 26;	 // "extract_vector_element_different_indices"
  case 42:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fadd_fpext_fma_fmul_to_fmad_or_fma", 41) != 0)
        break;
      return 180;	 // "combine_fadd_fpext_fma_fmul_to_fmad_or_fma"
    case 'e':	 // 7 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_build_vector_trunc", 40) != 0)
        break;
      switch (RuleIdentifier[41]) {
      default: break;
      case '2':	 // 1 string to match.
        return 28;	 // "extract_vector_element_build_vector_trunc2"
      case '3':	 // 1 string to match.
        return 29;	 // "extract_vector_element_build_vector_trunc3"
      case '4':	 // 1 string to match.
        return 30;	 // "extract_vector_element_build_vector_trunc4"
      case '5':	 // 1 string to match.
        return 31;	 // "extract_vector_element_build_vector_trunc5"
      case '6':	 // 1 string to match.
        return 32;	 // "extract_vector_element_build_vector_trunc6"
      case '7':	 // 1 string to match.
        return 33;	 // "extract_vector_element_build_vector_trunc7"
      case '8':	 // 1 string to match.
        return 34;	 // "extract_vector_element_build_vector_trunc8"
      }
      break;
    }
    break;
  case 43:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma", 43) != 0)
      break;
    return 184;	 // "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma"
  case 44:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_extract_vector_element", 44) != 0)
      break;
    return 36;	 // "insert_vector_element_extract_vector_element"
  case 46:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "push_freeze_to_prevent_poison_from_propagating", 46) != 0)
      break;
    return 42;	 // "push_freeze_to_prevent_poison_from_propagating"
  }
#endif // ifndef NDEBUG

  return std::nullopt;
}
static std::optional<std::pair<uint64_t, uint64_t>> getRuleRangeForIdentifier(StringRef RuleIdentifier) {
  std::pair<StringRef, StringRef> RangePair = RuleIdentifier.split('-');
  if (!RangePair.second.empty()) {
    const auto First = getRuleIdxForIdentifier(RangePair.first);
    const auto Last = getRuleIdxForIdentifier(RangePair.second);
    if (!First || !Last)
      return std::nullopt;
    if (First >= Last)
      report_fatal_error("Beginning of range should be before end of range");
    return {{*First, *Last + 1}};
  }
  if (RangePair.first == "*") {
    return {{0, 223}};
  }
  const auto I = getRuleIdxForIdentifier(RangePair.first);
  if (!I)
    return std::nullopt;
  return {{*I, *I + 1}};
}

bool AArch64PreLegalizerCombinerImplRuleConfig::setRuleEnabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.reset(I);
  return true;
}

bool AArch64PreLegalizerCombinerImplRuleConfig::setRuleDisabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.set(I);
  return true;
}

static std::vector<std::string> AArch64PreLegalizerCombinerOption;
static cl::list<std::string> AArch64PreLegalizerCombinerDisableOption(
    "aarch64prelegalizercombiner-disable-rule",
    cl::desc("Disable one or more combiner rules temporarily in the AArch64PreLegalizerCombiner pass"),
    cl::CommaSeparated,
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &Str) {
      AArch64PreLegalizerCombinerOption.push_back(Str);
    }));
static cl::list<std::string> AArch64PreLegalizerCombinerOnlyEnableOption(
    "aarch64prelegalizercombiner-only-enable-rule",
    cl::desc("Disable all rules in the AArch64PreLegalizerCombiner pass then re-enable the specified ones"),
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &CommaSeparatedArg) {
      StringRef Str = CommaSeparatedArg;
      AArch64PreLegalizerCombinerOption.push_back("*");
      do {
        auto X = Str.split(",");
        AArch64PreLegalizerCombinerOption.push_back(("!" + X.first).str());
        Str = X.second;
      } while (!Str.empty());
    }));


bool AArch64PreLegalizerCombinerImplRuleConfig::isRuleEnabled(unsigned RuleID) const {
    return  !DisabledRules.test(RuleID);
}
bool AArch64PreLegalizerCombinerImplRuleConfig::parseCommandLineOption() {
  for (StringRef Identifier : AArch64PreLegalizerCombinerOption) {
    bool Enabled = Identifier.consume_front("!");
    if (Enabled && !setRuleEnabled(Identifier))
      return false;
    if (!Enabled && !setRuleDisabled(Identifier))
      return false;
  }
  return true;
}

#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_TYPES
const unsigned MAX_SUBTARGET_PREDICATES = 1;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_CLASS_MEMBERS
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS
#ifdef GET_GICOMBINER_CLASS_MEMBERS
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64PreLegalizerCombinerImpl::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64PreLegalizerCombinerImpl::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64PreLegalizerCombinerImpl::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64PreLegalizerCombinerImpl::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS

#ifdef GET_GICOMBINER_IMPL
// LLT Objects.
enum {
  GILLT_s1,
};
const static size_t NumTypeObjects = 1;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasDotProdBit = 0,
};

PredicateBitset AArch64PreLegalizerCombinerImpl::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  return Features;
}

void AArch64PreLegalizerCombinerImpl::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64PreLegalizerCombinerImpl::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasDotProd,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasDotProdBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

AArch64PreLegalizerCombinerImpl::ComplexMatcherMemFn
AArch64PreLegalizerCombinerImpl::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

enum {
  GICXXPred_MI_Predicate_GICombiner0 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_GICombiner1,
  GICXXPred_MI_Predicate_GICombiner2,
  GICXXPred_MI_Predicate_GICombiner3,
  GICXXPred_MI_Predicate_GICombiner4,
  GICXXPred_MI_Predicate_GICombiner5,
  GICXXPred_MI_Predicate_GICombiner6,
  GICXXPred_MI_Predicate_GICombiner7,
  GICXXPred_MI_Predicate_GICombiner8,
  GICXXPred_MI_Predicate_GICombiner9,
};
bool AArch64PreLegalizerCombinerImpl::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_GICombiner0: {
    return isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner1: {
    return isGuaranteedNotToBeUndefOrPoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner2: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), 1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner3: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -0.0);
  }
  case GICXXPred_MI_Predicate_GICombiner4: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner5: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_EQ &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner6: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_NE &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner7: {
    return MRI.hasOneNonDBGUse(State.MIs[0]->getOperand(2).getReg()) &&
                    Helper.isLegalOrBeforeLegalizer(
                      {TargetOpcode::G_SEXT_INREG, {MRI.getType(State.MIs[1]->getOperand(1).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner8: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_LSHR,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner9: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_SHL,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PreLegalizerCombinerImpl::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PreLegalizerCombinerImpl::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PreLegalizerCombinerImpl::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
enum {
  GICXXPred_Simple_IsRule0Enabled = GICXXPred_Invalid + 1,
  GICXXPred_Simple_IsRule1Enabled,
  GICXXPred_Simple_IsRule2Enabled,
  GICXXPred_Simple_IsRule3Enabled,
  GICXXPred_Simple_IsRule4Enabled,
  GICXXPred_Simple_IsRule5Enabled,
  GICXXPred_Simple_IsRule6Enabled,
  GICXXPred_Simple_IsRule7Enabled,
  GICXXPred_Simple_IsRule8Enabled,
  GICXXPred_Simple_IsRule9Enabled,
  GICXXPred_Simple_IsRule10Enabled,
  GICXXPred_Simple_IsRule11Enabled,
  GICXXPred_Simple_IsRule12Enabled,
  GICXXPred_Simple_IsRule13Enabled,
  GICXXPred_Simple_IsRule14Enabled,
  GICXXPred_Simple_IsRule15Enabled,
  GICXXPred_Simple_IsRule16Enabled,
  GICXXPred_Simple_IsRule17Enabled,
  GICXXPred_Simple_IsRule18Enabled,
  GICXXPred_Simple_IsRule19Enabled,
  GICXXPred_Simple_IsRule20Enabled,
  GICXXPred_Simple_IsRule21Enabled,
  GICXXPred_Simple_IsRule22Enabled,
  GICXXPred_Simple_IsRule23Enabled,
  GICXXPred_Simple_IsRule24Enabled,
  GICXXPred_Simple_IsRule25Enabled,
  GICXXPred_Simple_IsRule26Enabled,
  GICXXPred_Simple_IsRule27Enabled,
  GICXXPred_Simple_IsRule28Enabled,
  GICXXPred_Simple_IsRule29Enabled,
  GICXXPred_Simple_IsRule30Enabled,
  GICXXPred_Simple_IsRule31Enabled,
  GICXXPred_Simple_IsRule32Enabled,
  GICXXPred_Simple_IsRule33Enabled,
  GICXXPred_Simple_IsRule34Enabled,
  GICXXPred_Simple_IsRule35Enabled,
  GICXXPred_Simple_IsRule36Enabled,
  GICXXPred_Simple_IsRule37Enabled,
  GICXXPred_Simple_IsRule38Enabled,
  GICXXPred_Simple_IsRule39Enabled,
  GICXXPred_Simple_IsRule40Enabled,
  GICXXPred_Simple_IsRule41Enabled,
  GICXXPred_Simple_IsRule42Enabled,
  GICXXPred_Simple_IsRule43Enabled,
  GICXXPred_Simple_IsRule44Enabled,
  GICXXPred_Simple_IsRule45Enabled,
  GICXXPred_Simple_IsRule46Enabled,
  GICXXPred_Simple_IsRule47Enabled,
  GICXXPred_Simple_IsRule48Enabled,
  GICXXPred_Simple_IsRule49Enabled,
  GICXXPred_Simple_IsRule50Enabled,
  GICXXPred_Simple_IsRule51Enabled,
  GICXXPred_Simple_IsRule52Enabled,
  GICXXPred_Simple_IsRule53Enabled,
  GICXXPred_Simple_IsRule54Enabled,
  GICXXPred_Simple_IsRule55Enabled,
  GICXXPred_Simple_IsRule56Enabled,
  GICXXPred_Simple_IsRule57Enabled,
  GICXXPred_Simple_IsRule58Enabled,
  GICXXPred_Simple_IsRule59Enabled,
  GICXXPred_Simple_IsRule60Enabled,
  GICXXPred_Simple_IsRule61Enabled,
  GICXXPred_Simple_IsRule62Enabled,
  GICXXPred_Simple_IsRule63Enabled,
  GICXXPred_Simple_IsRule64Enabled,
  GICXXPred_Simple_IsRule65Enabled,
  GICXXPred_Simple_IsRule66Enabled,
  GICXXPred_Simple_IsRule67Enabled,
  GICXXPred_Simple_IsRule68Enabled,
  GICXXPred_Simple_IsRule69Enabled,
  GICXXPred_Simple_IsRule70Enabled,
  GICXXPred_Simple_IsRule71Enabled,
  GICXXPred_Simple_IsRule72Enabled,
  GICXXPred_Simple_IsRule73Enabled,
  GICXXPred_Simple_IsRule74Enabled,
  GICXXPred_Simple_IsRule75Enabled,
  GICXXPred_Simple_IsRule76Enabled,
  GICXXPred_Simple_IsRule77Enabled,
  GICXXPred_Simple_IsRule78Enabled,
  GICXXPred_Simple_IsRule79Enabled,
  GICXXPred_Simple_IsRule80Enabled,
  GICXXPred_Simple_IsRule81Enabled,
  GICXXPred_Simple_IsRule82Enabled,
  GICXXPred_Simple_IsRule83Enabled,
  GICXXPred_Simple_IsRule84Enabled,
  GICXXPred_Simple_IsRule85Enabled,
  GICXXPred_Simple_IsRule86Enabled,
  GICXXPred_Simple_IsRule87Enabled,
  GICXXPred_Simple_IsRule88Enabled,
  GICXXPred_Simple_IsRule89Enabled,
  GICXXPred_Simple_IsRule90Enabled,
  GICXXPred_Simple_IsRule91Enabled,
  GICXXPred_Simple_IsRule92Enabled,
  GICXXPred_Simple_IsRule93Enabled,
  GICXXPred_Simple_IsRule94Enabled,
  GICXXPred_Simple_IsRule95Enabled,
  GICXXPred_Simple_IsRule96Enabled,
  GICXXPred_Simple_IsRule97Enabled,
  GICXXPred_Simple_IsRule98Enabled,
  GICXXPred_Simple_IsRule99Enabled,
  GICXXPred_Simple_IsRule100Enabled,
  GICXXPred_Simple_IsRule101Enabled,
  GICXXPred_Simple_IsRule102Enabled,
  GICXXPred_Simple_IsRule103Enabled,
  GICXXPred_Simple_IsRule104Enabled,
  GICXXPred_Simple_IsRule105Enabled,
  GICXXPred_Simple_IsRule106Enabled,
  GICXXPred_Simple_IsRule107Enabled,
  GICXXPred_Simple_IsRule108Enabled,
  GICXXPred_Simple_IsRule109Enabled,
  GICXXPred_Simple_IsRule110Enabled,
  GICXXPred_Simple_IsRule111Enabled,
  GICXXPred_Simple_IsRule112Enabled,
  GICXXPred_Simple_IsRule113Enabled,
  GICXXPred_Simple_IsRule114Enabled,
  GICXXPred_Simple_IsRule115Enabled,
  GICXXPred_Simple_IsRule116Enabled,
  GICXXPred_Simple_IsRule117Enabled,
  GICXXPred_Simple_IsRule118Enabled,
  GICXXPred_Simple_IsRule119Enabled,
  GICXXPred_Simple_IsRule120Enabled,
  GICXXPred_Simple_IsRule121Enabled,
  GICXXPred_Simple_IsRule122Enabled,
  GICXXPred_Simple_IsRule123Enabled,
  GICXXPred_Simple_IsRule124Enabled,
  GICXXPred_Simple_IsRule125Enabled,
  GICXXPred_Simple_IsRule126Enabled,
  GICXXPred_Simple_IsRule127Enabled,
  GICXXPred_Simple_IsRule128Enabled,
  GICXXPred_Simple_IsRule129Enabled,
  GICXXPred_Simple_IsRule130Enabled,
  GICXXPred_Simple_IsRule131Enabled,
  GICXXPred_Simple_IsRule132Enabled,
  GICXXPred_Simple_IsRule133Enabled,
  GICXXPred_Simple_IsRule134Enabled,
  GICXXPred_Simple_IsRule135Enabled,
  GICXXPred_Simple_IsRule136Enabled,
  GICXXPred_Simple_IsRule137Enabled,
  GICXXPred_Simple_IsRule138Enabled,
  GICXXPred_Simple_IsRule139Enabled,
  GICXXPred_Simple_IsRule140Enabled,
  GICXXPred_Simple_IsRule141Enabled,
  GICXXPred_Simple_IsRule142Enabled,
  GICXXPred_Simple_IsRule143Enabled,
  GICXXPred_Simple_IsRule144Enabled,
  GICXXPred_Simple_IsRule145Enabled,
  GICXXPred_Simple_IsRule146Enabled,
  GICXXPred_Simple_IsRule147Enabled,
  GICXXPred_Simple_IsRule148Enabled,
  GICXXPred_Simple_IsRule149Enabled,
  GICXXPred_Simple_IsRule150Enabled,
  GICXXPred_Simple_IsRule151Enabled,
  GICXXPred_Simple_IsRule152Enabled,
  GICXXPred_Simple_IsRule153Enabled,
  GICXXPred_Simple_IsRule154Enabled,
  GICXXPred_Simple_IsRule155Enabled,
  GICXXPred_Simple_IsRule156Enabled,
  GICXXPred_Simple_IsRule157Enabled,
  GICXXPred_Simple_IsRule158Enabled,
  GICXXPred_Simple_IsRule159Enabled,
  GICXXPred_Simple_IsRule160Enabled,
  GICXXPred_Simple_IsRule161Enabled,
  GICXXPred_Simple_IsRule162Enabled,
  GICXXPred_Simple_IsRule163Enabled,
  GICXXPred_Simple_IsRule164Enabled,
  GICXXPred_Simple_IsRule165Enabled,
  GICXXPred_Simple_IsRule166Enabled,
  GICXXPred_Simple_IsRule167Enabled,
  GICXXPred_Simple_IsRule168Enabled,
  GICXXPred_Simple_IsRule169Enabled,
  GICXXPred_Simple_IsRule170Enabled,
  GICXXPred_Simple_IsRule171Enabled,
  GICXXPred_Simple_IsRule172Enabled,
  GICXXPred_Simple_IsRule173Enabled,
  GICXXPred_Simple_IsRule174Enabled,
  GICXXPred_Simple_IsRule175Enabled,
  GICXXPred_Simple_IsRule176Enabled,
  GICXXPred_Simple_IsRule177Enabled,
  GICXXPred_Simple_IsRule178Enabled,
  GICXXPred_Simple_IsRule179Enabled,
  GICXXPred_Simple_IsRule180Enabled,
  GICXXPred_Simple_IsRule181Enabled,
  GICXXPred_Simple_IsRule182Enabled,
  GICXXPred_Simple_IsRule183Enabled,
  GICXXPred_Simple_IsRule184Enabled,
  GICXXPred_Simple_IsRule185Enabled,
  GICXXPred_Simple_IsRule186Enabled,
  GICXXPred_Simple_IsRule187Enabled,
  GICXXPred_Simple_IsRule188Enabled,
  GICXXPred_Simple_IsRule189Enabled,
  GICXXPred_Simple_IsRule190Enabled,
  GICXXPred_Simple_IsRule191Enabled,
  GICXXPred_Simple_IsRule192Enabled,
  GICXXPred_Simple_IsRule193Enabled,
  GICXXPred_Simple_IsRule194Enabled,
  GICXXPred_Simple_IsRule195Enabled,
  GICXXPred_Simple_IsRule196Enabled,
  GICXXPred_Simple_IsRule197Enabled,
  GICXXPred_Simple_IsRule198Enabled,
  GICXXPred_Simple_IsRule199Enabled,
  GICXXPred_Simple_IsRule200Enabled,
  GICXXPred_Simple_IsRule201Enabled,
  GICXXPred_Simple_IsRule202Enabled,
  GICXXPred_Simple_IsRule203Enabled,
  GICXXPred_Simple_IsRule204Enabled,
  GICXXPred_Simple_IsRule205Enabled,
  GICXXPred_Simple_IsRule206Enabled,
  GICXXPred_Simple_IsRule207Enabled,
  GICXXPred_Simple_IsRule208Enabled,
  GICXXPred_Simple_IsRule209Enabled,
  GICXXPred_Simple_IsRule210Enabled,
  GICXXPred_Simple_IsRule211Enabled,
  GICXXPred_Simple_IsRule212Enabled,
  GICXXPred_Simple_IsRule213Enabled,
  GICXXPred_Simple_IsRule214Enabled,
  GICXXPred_Simple_IsRule215Enabled,
  GICXXPred_Simple_IsRule216Enabled,
  GICXXPred_Simple_IsRule217Enabled,
  GICXXPred_Simple_IsRule218Enabled,
  GICXXPred_Simple_IsRule219Enabled,
  GICXXPred_Simple_IsRule220Enabled,
  GICXXPred_Simple_IsRule221Enabled,
  GICXXPred_Simple_IsRule222Enabled,
};

bool AArch64PreLegalizerCombinerImpl::testSimplePredicate(unsigned Predicate) const {
    return RuleConfig.isRuleEnabled(Predicate - GICXXPred_Invalid - 1);
}
// Custom renderers.
enum {
  GICR_Invalid,
};
AArch64PreLegalizerCombinerImpl::CustomRendererFn
AArch64PreLegalizerCombinerImpl::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool AArch64PreLegalizerCombinerImpl::tryCombineAllImpl(MachineInstr &I) const {
  const TargetSubtargetInfo &ST = MF.getSubtarget();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  B.setInstrAndDebugLoc(I);
  State.MIs.clear();
  State.MIs.push_back(&I);
  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), *ST.getInstrInfo(), MRI, *MRI.getTargetRegisterInfo(), *ST.getRegBankInfo(), AvailableFeatures, /*CoverageInfo*/ nullptr)) {
    return true;
  }

  return false;
}

enum {
  GICXXCustomAction_GICombiner0 = GICXXCustomAction_Invalid + 1,
  GICXXCustomAction_GICombiner1,
  GICXXCustomAction_GICombiner2,
  GICXXCustomAction_GICombiner3,
  GICXXCustomAction_GICombiner4,
  GICXXCustomAction_GICombiner5,
  GICXXCustomAction_GICombiner6,
  GICXXCustomAction_GICombiner7,
  GICXXCustomAction_GICombiner8,
  GICXXCustomAction_GICombiner9,
  GICXXCustomAction_GICombiner10,
  GICXXCustomAction_GICombiner11,
  GICXXCustomAction_GICombiner12,
  GICXXCustomAction_GICombiner13,
  GICXXCustomAction_GICombiner14,
  GICXXCustomAction_GICombiner15,
  GICXXCustomAction_GICombiner16,
  GICXXCustomAction_GICombiner17,
  GICXXCustomAction_GICombiner18,
  GICXXCustomAction_GICombiner19,
  GICXXCustomAction_GICombiner20,
  GICXXCustomAction_GICombiner21,
  GICXXCustomAction_GICombiner22,
  GICXXCustomAction_GICombiner23,
  GICXXCustomAction_GICombiner24,
  GICXXCustomAction_GICombiner25,
  GICXXCustomAction_GICombiner26,
  GICXXCustomAction_GICombiner27,
  GICXXCustomAction_GICombiner28,
  GICXXCustomAction_GICombiner29,
  GICXXCustomAction_GICombiner30,
  GICXXCustomAction_GICombiner31,
  GICXXCustomAction_GICombiner32,
  GICXXCustomAction_GICombiner33,
  GICXXCustomAction_GICombiner34,
  GICXXCustomAction_GICombiner35,
  GICXXCustomAction_GICombiner36,
  GICXXCustomAction_GICombiner37,
  GICXXCustomAction_GICombiner38,
  GICXXCustomAction_GICombiner39,
  GICXXCustomAction_GICombiner40,
  GICXXCustomAction_GICombiner41,
  GICXXCustomAction_GICombiner42,
  GICXXCustomAction_GICombiner43,
  GICXXCustomAction_GICombiner44,
  GICXXCustomAction_GICombiner45,
  GICXXCustomAction_GICombiner46,
  GICXXCustomAction_GICombiner47,
  GICXXCustomAction_GICombiner48,
  GICXXCustomAction_GICombiner49,
  GICXXCustomAction_GICombiner50,
  GICXXCustomAction_GICombiner51,
  GICXXCustomAction_GICombiner52,
  GICXXCustomAction_GICombiner53,
  GICXXCustomAction_GICombiner54,
  GICXXCustomAction_GICombiner55,
  GICXXCustomAction_GICombiner56,
  GICXXCustomAction_GICombiner57,
  GICXXCustomAction_GICombiner58,
  GICXXCustomAction_GICombiner59,
  GICXXCustomAction_GICombiner60,
  GICXXCustomAction_GICombiner61,
  GICXXCustomAction_GICombiner62,
  GICXXCustomAction_GICombiner63,
  GICXXCustomAction_GICombiner64,
  GICXXCustomAction_GICombiner65,
  GICXXCustomAction_GICombiner66,
  GICXXCustomAction_GICombiner67,
  GICXXCustomAction_GICombiner68,
  GICXXCustomAction_GICombiner69,
  GICXXCustomAction_GICombiner70,
  GICXXCustomAction_GICombiner71,
  GICXXCustomAction_GICombiner72,
  GICXXCustomAction_GICombiner73,
  GICXXCustomAction_GICombiner74,
  GICXXCustomAction_GICombiner75,
  GICXXCustomAction_GICombiner76,
  GICXXCustomAction_GICombiner77,
  GICXXCustomAction_GICombiner78,
  GICXXCustomAction_GICombiner79,
  GICXXCustomAction_GICombiner80,
  GICXXCustomAction_GICombiner81,
  GICXXCustomAction_GICombiner82,
  GICXXCustomAction_GICombiner83,
  GICXXCustomAction_GICombiner84,
  GICXXCustomAction_GICombiner85,
  GICXXCustomAction_GICombiner86,
  GICXXCustomAction_GICombiner87,
  GICXXCustomAction_GICombiner88,
  GICXXCustomAction_GICombiner89,
  GICXXCustomAction_GICombiner90,
  GICXXCustomAction_GICombiner91,
  GICXXCustomAction_GICombiner92,
  GICXXCustomAction_GICombiner93,
  GICXXCustomAction_GICombiner94,
  GICXXCustomAction_GICombiner95,
  GICXXCustomAction_GICombiner96,
  GICXXCustomAction_GICombiner97,
  GICXXCustomAction_GICombiner98,
  GICXXCustomAction_GICombiner99,
  GICXXCustomAction_GICombiner100,
  GICXXCustomAction_GICombiner101,
  GICXXCustomAction_GICombiner102,
  GICXXCustomAction_GICombiner103,
  GICXXCustomAction_GICombiner104,
  GICXXCustomAction_GICombiner105,
  GICXXCustomAction_GICombiner106,
  GICXXCustomAction_GICombiner107,
  GICXXCustomAction_GICombiner108,
  GICXXCustomAction_GICombiner109,
  GICXXCustomAction_GICombiner110,
  GICXXCustomAction_GICombiner111,
  GICXXCustomAction_GICombiner112,
  GICXXCustomAction_GICombiner113,
  GICXXCustomAction_GICombiner114,
  GICXXCustomAction_GICombiner115,
  GICXXCustomAction_GICombiner116,
  GICXXCustomAction_GICombiner117,
  GICXXCustomAction_GICombiner118,
  GICXXCustomAction_GICombiner119,
  GICXXCustomAction_GICombiner120,
  GICXXCustomAction_GICombiner121,
  GICXXCustomAction_GICombiner122,
  GICXXCustomAction_GICombiner123,
  GICXXCustomAction_GICombiner124,
  GICXXCustomAction_GICombiner125,
  GICXXCustomAction_GICombiner126,
  GICXXCustomAction_GICombiner127,
  GICXXCustomAction_GICombiner128,
  GICXXCustomAction_GICombiner129,
  GICXXCustomAction_GICombiner130,
  GICXXCustomAction_GICombiner131,
  GICXXCustomAction_GICombiner132,
  GICXXCustomAction_GICombiner133,
  GICXXCustomAction_GICombiner134,
  GICXXCustomAction_GICombiner135,
  GICXXCustomAction_GICombiner136,
  GICXXCustomAction_GICombiner137,
  GICXXCustomAction_GICombiner138,
  GICXXCustomAction_GICombiner139,
  GICXXCustomAction_GICombiner140,
  GICXXCustomAction_GICombiner141,
  GICXXCustomAction_GICombiner142,
  GICXXCustomAction_GICombiner143,
  GICXXCustomAction_GICombiner144,
  GICXXCustomAction_GICombiner145,
  GICXXCustomAction_GICombiner146,
  GICXXCustomAction_GICombiner147,
  GICXXCustomAction_GICombiner148,
  GICXXCustomAction_GICombiner149,
  GICXXCustomAction_GICombiner150,
  GICXXCustomAction_GICombiner151,
  GICXXCustomAction_GICombiner152,
  GICXXCustomAction_GICombiner153,
  GICXXCustomAction_GICombiner154,
  GICXXCustomAction_GICombiner155,
  GICXXCustomAction_GICombiner156,
};
bool AArch64PreLegalizerCombinerImpl::runCustomAction(unsigned ApplyID, const MatcherState &State, NewMIVector &OutMIs) const {
  Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
  switch(ApplyID) {
  case GICXXCustomAction_GICombiner0:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAPlusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner1:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC2MinusAPlusC1(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner2:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner3:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC1Minus2MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner4:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1PlusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner5:{
    // Match Patterns
    if(![&](){return Helper.matchCombineCopy(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineCopy(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner6:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner7:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineSubToAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner8:{
    std::pair<Register, bool> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner9:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElement(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner10:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchInsertVectorElementOOB(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner11:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithDifferentIndices(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner12:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner13:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVectorTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner14:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithShuffleVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner15:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner16:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner17:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShlOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner18:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner19:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return !isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI) && Helper.matchFreezeOfSingleMaybePoisonOperand(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner20:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncateOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner21:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner22:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfSelect(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner23:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfBuildVector(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner24:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinop(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner25:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfInteger(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner26:{
    SmallVector<Register, 4> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineInsertVecElts(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineInsertVecElts(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner27:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner28:{
    SmallVector<std::pair<Register, MachineInstr*>> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner29:{
    PreferredTuple GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner30:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineLoadWithAndMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner31:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtractedVectorLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner32:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner33:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner34:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], -1);
    return true;
  }
  case GICXXCustomAction_GICombiner35:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner36:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner37:{
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]->getOperand(0).getParent());
    return true;
  }
  case GICXXCustomAction_GICombiner38:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner39:{
    // Match Patterns
    if(![&](){return Helper.matchAllExplicitUsesAreUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner40:{
    // Match Patterns
    if(![&](){return Helper.matchUndefShuffleVectorMask(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner41:{
    // Match Patterns
    if(![&](){return Helper.matchUndefStore(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.eraseInst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner42:{
    // Match Patterns
    if(![&](){return Helper.matchInsertExtractVecEltOutOfBounds(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner43:{
    // Match Patterns
    if(![&](){return Helper.matchSelectSameVal(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 2);
    return true;
  }
  case GICXXCustomAction_GICombiner44:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsZero(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner45:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineI2PToP2I(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineI2PToP2I(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner46:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){GIMatchData_info = State.MIs[1]->getOperand(1).getReg(); return true;}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineP2IToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner47:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineAnyExtTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner48:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchBuildVectorIdentityFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner49:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner50:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncLshrBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner51:{
    // Match Patterns
    if(![&](){return MRI.getType(State.MIs[1]->getOperand(1).getReg()) == MRI.getType(State.MIs[0]->getOperand(0).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner52:{
    MachineInstr* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner53:{
    std::tuple<Register, Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyAddToSub(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyAddToSub(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner54:{
    InstructionStepsMatchInfo GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchHoistLogicOpWithSameOpcodeHands(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildInstructionSteps(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner55:{
    std::optional<int64_t> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftsTooBig(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    if (GIMatchData_matchinfo) {
              Helper.replaceInstWithConstant(*State.MIs[0], *GIMatchData_matchinfo);
            } else {
              Helper.replaceInstWithUndef(*State.MIs[0]);
            }
    return true;
  }
  case GICXXCustomAction_GICombiner56:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocPtrAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner57:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocCommBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner58:{
    PtrAddChain GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner59:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeICmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner60:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeFCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner61:{
    int64_t GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchICmpToTrueFalseKnownBits(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner62:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchICmpToLHSKnownBits(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner63:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchRedundantBinOpInEquality(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner64:{
    std::tuple<Register, int64_t> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAshrShlToSextInreg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyAshShlToSextInreg(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner65:{
    std::tuple<Register, unsigned> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner66:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner67:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinopFeedingAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner68:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantSelectCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner69:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSelectIMinMax(State.MIs[0]->getOperand(0), GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner70:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSelect(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner71:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner72:{
    // Match Patterns
    if(![&](){return Helper.matchRedundantSExtInReg(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner73:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner74:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsKnownToBeAPowerOfTwo(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyURemByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner75:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineZextTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner76:{
    // Match Patterns
    if(![&](){unsigned BitWidth = MRI.getType(State.MIs[0]->getOperand(1).getReg()).getScalarSizeInBits();
                return Helper.getValueTracking()->maskedValueIsZero(State.MIs[0]->getOperand(1).getReg(),
                         APInt::getOneBitSet(BitWidth, State.MIs[0]->getOperand(2).getImm() - 1));}()) {
      return false;
    }
    // Apply Patterns
    Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
              Helper.getBuilder().buildZExtInReg(State.MIs[0]->getOperand(0), State.MIs[0]->getOperand(1), State.MIs[0]->getOperand(2).getImm());
              State.MIs[0]->eraseFromParent();
    return true;
  }
  case GICXXCustomAction_GICombiner77:{
    std::pair<MachineInstr*, LLT> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner78:{
    SmallVector<Register, 4> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchNotCmp(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyNotCmp(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner79:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner80:{
    // Apply Patterns
    Helper.applyCombineConstantFoldFpUnary(*State.MIs[0], State.MIs[1]->getOperand(1).getFPImm());
    return true;
  }
  case GICXXCustomAction_GICombiner81:{
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0]->getOperand(0).getParent(), 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner82:{
    APInt GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner83:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOverlappingAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner84:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner85:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy0(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner86:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddEToAddO(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner87:{
    unsigned GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFMinMaxNaN(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner88:{
    // Match Patterns
    if(![&](){return Helper.matchFPowIExpansion(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExpandFPowI(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());
    return true;
  }
  case GICXXCustomAction_GICombiner89:{
    std::pair<Register, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner90:{
    // Match Patterns
    if(![&](){return Helper.matchPtrAddZero(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddZero(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner91:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner92:{
    ShiftOfShiftedLogic GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner93:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchLoadOrCombine(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner94:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner95:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOrShiftToFunnelShift(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner96:{
    // Match Patterns
    if(![&](){return Helper.matchFunnelShiftToRotate(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftToRotate(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner97:{
    // Match Patterns
    if(![&](){return Helper.matchConstantLargerBitWidth(*State.MIs[0], 3);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftConstantModulo(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner98:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCommuteShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner99:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromSExtInReg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner100:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner101:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShr(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner102:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShrAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner103:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner104:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFPBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner105:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFMA(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner106:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldCastOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner107:{
    // Match Patterns
    if(![&](){return Helper.matchUDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner108:{
    // Match Patterns
    if(![&](){return Helper.matchSDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner109:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/true);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner110:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/false);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner111:{
    // Match Patterns
    if(![&](){return Helper.matchUMulHToLShr(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUMulHToLShr(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner112:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantNegOperands(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner113:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAndOrDisjointMask(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner114:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner115:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner116:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMAFMulToFMadOrFMA(*State.MIs[0],
                                                                     GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner117:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMAAggressive(
                                                          *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner118:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner119:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFNegFMulToFMadOrFMA(*State.MIs[0],
                                                                      GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner120:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner121:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFNegFMulToFMadOrFMA(
                                                    *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner122:{
    unsigned GIMatchData_select_op_no;
    // Match Patterns
    if(![&](){return Helper.matchFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);
    return true;
  }
  case GICXXCustomAction_GICombiner123:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubAddSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner124:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifySelectToMinMax(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner125:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner126:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner127:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteFPConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner128:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner129:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner130:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyNegMinMax(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner131:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner132:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner133:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchZextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner134:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNonNegZext(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner135:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner136:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleUndefRHS(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner137:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleDisjointMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner138:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner139:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUnmergeValuesAnyExtBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner140:{
    SmallVector<Register, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner141:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMergeUnmerge(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner142:{
    SmallVector<APInt, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner143:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeUndef(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner144:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner145:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeZExtToZExt(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeZExtToZExt(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner146:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndUndef(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner147:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndZero(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner148:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOverflow(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner149:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSuboCarryOut(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner150:{
    // Match Patterns
    if(![&](){return matchFConstantToConstant(*State.MIs[0], MRI);}()) {
      return false;
    }
    // Apply Patterns
    applyFConstantToConstant(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner151:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchICmpRedundantTrunc(*State.MIs[0], MRI, Helper.getValueTracking(), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyICmpRedundantTrunc(*State.MIs[0], MRI, B, Observer, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner152:{
    std::pair<uint64_t, uint64_t> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchFoldGlobalOffset(*State.MIs[0], MRI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyFoldGlobalOffset(*State.MIs[0], MRI, B, Observer, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner153:{
    // Match Patterns
    if(![&](){return Helper.matchShuffleToExtract(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShuffleToExtract(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner154:{
    std::tuple<Register, Register, bool> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchExtAddvToUdotAddv(*State.MIs[0], MRI, STI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyExtAddvToUdotAddv(*State.MIs[0], MRI, B, Observer, STI, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner155:{
    std::pair<Register, bool> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchExtUaddvToUaddlv(*State.MIs[0], MRI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyExtUaddvToUaddlv(*State.MIs[0], MRI, B, Observer, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner156:{
    // Match Patterns
    if(![&](){return matchPushAddSubExt(*State.MIs[0], MRI, State.MIs[0]->getOperand(0).getReg(), State.MIs[1]->getOperand(1).getReg(), State.MIs[2]->getOperand(1).getReg());}()) {
      return false;
    }
    // Apply Patterns
    applyPushAddSubExt(*State.MIs[0], MRI, B, State.MIs[1]->getOpcode() == TargetOpcode::G_SEXT, State.MIs[0]->getOperand(0).getReg(), State.MIs[1]->getOperand(1).getReg(), State.MIs[2]->getOperand(1).getReg());
    return true;
  }
  }
  llvm_unreachable("Unknown Apply Action");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64PreLegalizerCombinerImpl::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*    0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(20), GIMT_Encode2(296), /*)*//*default:*//*Label 98*/ GIMT_Encode4(7314),
     /*   10 */ /*TargetOpcode::COPY*//*Label 0*/ GIMT_Encode4(1114), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  142 */ /*TargetOpcode::G_ADD*//*Label 1*/ GIMT_Encode4(1126),
     /*  146 */ /*TargetOpcode::G_SUB*//*Label 2*/ GIMT_Encode4(1741),
     /*  150 */ /*TargetOpcode::G_MUL*//*Label 3*/ GIMT_Encode4(2117),
     /*  154 */ /*TargetOpcode::G_SDIV*//*Label 4*/ GIMT_Encode4(2283),
     /*  158 */ /*TargetOpcode::G_UDIV*//*Label 5*/ GIMT_Encode4(2356),
     /*  162 */ /*TargetOpcode::G_SREM*//*Label 6*/ GIMT_Encode4(2440),
     /*  166 */ /*TargetOpcode::G_UREM*//*Label 7*/ GIMT_Encode4(2485), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  178 */ /*TargetOpcode::G_AND*//*Label 8*/ GIMT_Encode4(2552),
     /*  182 */ /*TargetOpcode::G_OR*//*Label 9*/ GIMT_Encode4(2833),
     /*  186 */ /*TargetOpcode::G_XOR*//*Label 10*/ GIMT_Encode4(3078), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  202 */ /*TargetOpcode::G_PHI*//*Label 11*/ GIMT_Encode4(3179), GIMT_Encode4(0),
     /*  210 */ /*TargetOpcode::G_GLOBAL_VALUE*//*Label 12*/ GIMT_Encode4(3191), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  226 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 13*/ GIMT_Encode4(3203), GIMT_Encode4(0),
     /*  234 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 14*/ GIMT_Encode4(3270),
     /*  238 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 15*/ GIMT_Encode4(3344),
     /*  242 */ /*TargetOpcode::G_BUILD_VECTOR_TRUNC*//*Label 16*/ GIMT_Encode4(3392),
     /*  246 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 17*/ GIMT_Encode4(3404),
     /*  250 */ /*TargetOpcode::G_PTRTOINT*//*Label 18*/ GIMT_Encode4(3416),
     /*  254 */ /*TargetOpcode::G_INTTOPTR*//*Label 19*/ GIMT_Encode4(3459),
     /*  258 */ /*TargetOpcode::G_BITCAST*//*Label 20*/ GIMT_Encode4(3492),
     /*  262 */ /*TargetOpcode::G_FREEZE*//*Label 21*/ GIMT_Encode4(3535), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  302 */ /*TargetOpcode::G_LOAD*//*Label 22*/ GIMT_Encode4(3599),
     /*  306 */ /*TargetOpcode::G_SEXTLOAD*//*Label 23*/ GIMT_Encode4(3611),
     /*  310 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 24*/ GIMT_Encode4(3623), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  326 */ /*TargetOpcode::G_STORE*//*Label 25*/ GIMT_Encode4(3635), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  454 */ /*TargetOpcode::G_ANYEXT*//*Label 26*/ GIMT_Encode4(3647),
     /*  458 */ /*TargetOpcode::G_TRUNC*//*Label 27*/ GIMT_Encode4(3775), GIMT_Encode4(0),
     /*  466 */ /*TargetOpcode::G_FCONSTANT*//*Label 28*/ GIMT_Encode4(4133), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  478 */ /*TargetOpcode::G_SEXT*//*Label 29*/ GIMT_Encode4(4145),
     /*  482 */ /*TargetOpcode::G_SEXT_INREG*//*Label 30*/ GIMT_Encode4(4220),
     /*  486 */ /*TargetOpcode::G_ZEXT*//*Label 31*/ GIMT_Encode4(4265),
     /*  490 */ /*TargetOpcode::G_SHL*//*Label 32*/ GIMT_Encode4(4395),
     /*  494 */ /*TargetOpcode::G_LSHR*//*Label 33*/ GIMT_Encode4(4564),
     /*  498 */ /*TargetOpcode::G_ASHR*//*Label 34*/ GIMT_Encode4(4687),
     /*  502 */ /*TargetOpcode::G_FSHL*//*Label 35*/ GIMT_Encode4(4821),
     /*  506 */ /*TargetOpcode::G_FSHR*//*Label 36*/ GIMT_Encode4(4864),
     /*  510 */ /*TargetOpcode::G_ROTR*//*Label 37*/ GIMT_Encode4(4907),
     /*  514 */ /*TargetOpcode::G_ROTL*//*Label 38*/ GIMT_Encode4(4931),
     /*  518 */ /*TargetOpcode::G_ICMP*//*Label 39*/ GIMT_Encode4(4955),
     /*  522 */ /*TargetOpcode::G_FCMP*//*Label 40*/ GIMT_Encode4(5011), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  534 */ /*TargetOpcode::G_SELECT*//*Label 41*/ GIMT_Encode4(5023),
     /*  538 */ /*TargetOpcode::G_UADDO*//*Label 42*/ GIMT_Encode4(5118),
     /*  542 */ /*TargetOpcode::G_UADDE*//*Label 43*/ GIMT_Encode4(5141),
     /*  546 */ /*TargetOpcode::G_USUBO*//*Label 44*/ GIMT_Encode4(5153),
     /*  550 */ /*TargetOpcode::G_USUBE*//*Label 45*/ GIMT_Encode4(5165),
     /*  554 */ /*TargetOpcode::G_SADDO*//*Label 46*/ GIMT_Encode4(5177),
     /*  558 */ /*TargetOpcode::G_SADDE*//*Label 47*/ GIMT_Encode4(5200),
     /*  562 */ /*TargetOpcode::G_SSUBO*//*Label 48*/ GIMT_Encode4(5212),
     /*  566 */ /*TargetOpcode::G_SSUBE*//*Label 49*/ GIMT_Encode4(5224),
     /*  570 */ /*TargetOpcode::G_UMULO*//*Label 50*/ GIMT_Encode4(5236),
     /*  574 */ /*TargetOpcode::G_SMULO*//*Label 51*/ GIMT_Encode4(5270),
     /*  578 */ /*TargetOpcode::G_UMULH*//*Label 52*/ GIMT_Encode4(5304),
     /*  582 */ /*TargetOpcode::G_SMULH*//*Label 53*/ GIMT_Encode4(5327),
     /*  586 */ /*TargetOpcode::G_UADDSAT*//*Label 54*/ GIMT_Encode4(5339),
     /*  590 */ /*TargetOpcode::G_SADDSAT*//*Label 55*/ GIMT_Encode4(5351), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  602 */ /*TargetOpcode::G_USHLSAT*//*Label 56*/ GIMT_Encode4(5363),
     /*  606 */ /*TargetOpcode::G_SSHLSAT*//*Label 57*/ GIMT_Encode4(5386),
     /*  610 */ /*TargetOpcode::G_SMULFIX*//*Label 58*/ GIMT_Encode4(5409),
     /*  614 */ /*TargetOpcode::G_UMULFIX*//*Label 59*/ GIMT_Encode4(5421),
     /*  618 */ /*TargetOpcode::G_SMULFIXSAT*//*Label 60*/ GIMT_Encode4(5433),
     /*  622 */ /*TargetOpcode::G_UMULFIXSAT*//*Label 61*/ GIMT_Encode4(5445), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  642 */ /*TargetOpcode::G_FADD*//*Label 62*/ GIMT_Encode4(5457),
     /*  646 */ /*TargetOpcode::G_FSUB*//*Label 63*/ GIMT_Encode4(5569),
     /*  650 */ /*TargetOpcode::G_FMUL*//*Label 64*/ GIMT_Encode4(5658),
     /*  654 */ /*TargetOpcode::G_FMA*//*Label 65*/ GIMT_Encode4(5746),
     /*  658 */ /*TargetOpcode::G_FMAD*//*Label 66*/ GIMT_Encode4(5769),
     /*  662 */ /*TargetOpcode::G_FDIV*//*Label 67*/ GIMT_Encode4(5792),
     /*  666 */ /*TargetOpcode::G_FREM*//*Label 68*/ GIMT_Encode4(5826), GIMT_Encode4(0),
     /*  674 */ /*TargetOpcode::G_FPOWI*//*Label 69*/ GIMT_Encode4(5838), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  694 */ /*TargetOpcode::G_FLOG2*//*Label 70*/ GIMT_Encode4(5860), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  710 */ /*TargetOpcode::G_FNEG*//*Label 71*/ GIMT_Encode4(5882), GIMT_Encode4(0),
     /*  718 */ /*TargetOpcode::G_FPTRUNC*//*Label 72*/ GIMT_Encode4(5933),
     /*  722 */ /*TargetOpcode::G_FPTOSI*//*Label 73*/ GIMT_Encode4(5976),
     /*  726 */ /*TargetOpcode::G_FPTOUI*//*Label 74*/ GIMT_Encode4(5998),
     /*  730 */ /*TargetOpcode::G_SITOFP*//*Label 75*/ GIMT_Encode4(6020),
     /*  734 */ /*TargetOpcode::G_UITOFP*//*Label 76*/ GIMT_Encode4(6047), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  746 */ /*TargetOpcode::G_FABS*//*Label 77*/ GIMT_Encode4(6074), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  758 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 78*/ GIMT_Encode4(6153),
     /*  762 */ /*TargetOpcode::G_FMINNUM*//*Label 79*/ GIMT_Encode4(6183),
     /*  766 */ /*TargetOpcode::G_FMAXNUM*//*Label 80*/ GIMT_Encode4(6217),
     /*  770 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 81*/ GIMT_Encode4(6251),
     /*  774 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 82*/ GIMT_Encode4(6263),
     /*  778 */ /*TargetOpcode::G_FMINIMUM*//*Label 83*/ GIMT_Encode4(6275),
     /*  782 */ /*TargetOpcode::G_FMAXIMUM*//*Label 84*/ GIMT_Encode4(6309), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  810 */ /*TargetOpcode::G_PTR_ADD*//*Label 85*/ GIMT_Encode4(6343), GIMT_Encode4(0),
     /*  818 */ /*TargetOpcode::G_SMIN*//*Label 86*/ GIMT_Encode4(6433),
     /*  822 */ /*TargetOpcode::G_SMAX*//*Label 87*/ GIMT_Encode4(6467),
     /*  826 */ /*TargetOpcode::G_UMIN*//*Label 88*/ GIMT_Encode4(6501),
     /*  830 */ /*TargetOpcode::G_UMAX*//*Label 89*/ GIMT_Encode4(6535),
     /*  834 */ /*TargetOpcode::G_ABS*//*Label 90*/ GIMT_Encode4(6569), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  846 */ /*TargetOpcode::G_BR*//*Label 91*/ GIMT_Encode4(6581), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  866 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 92*/ GIMT_Encode4(6593),
     /*  870 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 93*/ GIMT_Encode4(6723),
     /*  874 */ /*TargetOpcode::G_SHUFFLE_VECTOR*//*Label 94*/ GIMT_Encode4(7100), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  914 */ /*TargetOpcode::G_BITREVERSE*//*Label 95*/ GIMT_Encode4(7177), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  966 */ /*TargetOpcode::G_FSQRT*//*Label 96*/ GIMT_Encode4(7266), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 1110 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 97*/ GIMT_Encode4(7288),
     /* 1114 */ // Label 0: @1114
     /* 1114 */ GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1125), // Rule ID 13 //
     /* 1119 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule13Enabled),
     /* 1122 */   // MIs[0] d
     /* 1122 */   // No operand predicates
     /* 1122 */   // MIs[0] s
     /* 1122 */   // No operand predicates
     /* 1122 */   // Combiner Rule #13: copy_prop
     /* 1122 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 1125 */ // Label 99: @1125
     /* 1125 */ GIM_Reject,
     /* 1126 */ // Label 1: @1126
     /* 1126 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1137), // Rule ID 16 //
     /* 1131 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /* 1134 */   // Combiner Rule #16: add_p2i_to_ptradd; wip_match_opcode 'G_ADD'
     /* 1134 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner8),
     /* 1137 */ // Label 100: @1137
     /* 1137 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1148), // Rule ID 93 //
     /* 1142 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 1145 */   // Combiner Rule #77: propagate_undef_any_op; wip_match_opcode 'G_ADD'
     /* 1145 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 1148 */ // Label 101: @1148
     /* 1148 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1159), // Rule ID 140 //
     /* 1153 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule102Enabled),
     /* 1156 */   // Combiner Rule #102: simplify_add_to_sub; wip_match_opcode 'G_ADD'
     /* 1156 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner53),
     /* 1159 */ // Label 102: @1159
     /* 1159 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1170), // Rule ID 230 //
     /* 1164 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 1167 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_ADD'
     /* 1167 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 1170 */ // Label 103: @1170
     /* 1170 */ GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1181), // Rule ID 278 //
     /* 1175 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 1178 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_ADD'
     /* 1178 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 1181 */ // Label 104: @1181
     /* 1181 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1192), // Rule ID 307 //
     /* 1186 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 1189 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_ADD'
     /* 1189 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 1192 */ // Label 105: @1192
     /* 1192 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1226), // Rule ID 0 //
     /* 1197 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule0Enabled),
     /* 1200 */   // MIs[0] root
     /* 1200 */   // No operand predicates
     /* 1200 */   // MIs[0] sub
     /* 1200 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1204 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1208 */   // MIs[1] Operand 1
     /* 1208 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 1212 */   // MIs[1] A
     /* 1212 */   // No operand predicates
     /* 1212 */   // MIs[0] B
     /* 1212 */   // No operand predicates
     /* 1212 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1214 */   // Combiner Rule #0: ZeroMinusAPlusB
     /* 1214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1217 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1219 */   GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 1221 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /* 1225 */   GIR_EraseRootFromParent_Done,
     /* 1226 */ // Label 106: @1226
     /* 1226 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1263), // Rule ID 12 //
     /* 1231 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule12Enabled),
     /* 1234 */   // MIs[0] root
     /* 1234 */   // No operand predicates
     /* 1234 */   // MIs[0] sub
     /* 1234 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1238 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1242 */   // MIs[1] A
     /* 1242 */   // No operand predicates
     /* 1242 */   // MIs[1] c1
     /* 1242 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1246 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1250 */   // MIs[2] imm1
     /* 1250 */   // No operand predicates
     /* 1250 */   // MIs[0] c2
     /* 1250 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1254 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1258 */   // MIs[3] imm2
     /* 1258 */   // No operand predicates
     /* 1258 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1260 */   // Combiner Rule #12: AMinusC1PlusC2
     /* 1260 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner4),
     /* 1263 */ // Label 107: @1263
     /* 1263 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1297), // Rule ID 3 //
     /* 1268 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule3Enabled),
     /* 1271 */   // MIs[0] root
     /* 1271 */   // No operand predicates
     /* 1271 */   // MIs[0] sub
     /* 1271 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1275 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1279 */   // MIs[1] B
     /* 1279 */   // No operand predicates
     /* 1279 */   // MIs[1] A
     /* 1279 */   // No operand predicates
     /* 1279 */   // MIs[0] A
     /* 1279 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1284 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1289 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1291 */   // Combiner Rule #3: BMinusAPlusA
     /* 1291 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1296 */   GIR_EraseRootFromParent_Done,
     /* 1297 */ // Label 108: @1297
     /* 1297 */ GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1331), // Rule ID 130 //
     /* 1302 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule93Enabled),
     /* 1305 */   // MIs[0] dst
     /* 1305 */   // No operand predicates
     /* 1305 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 1305 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1309 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1313 */   // MIs[1] src
     /* 1313 */   // No operand predicates
     /* 1313 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1313 */   // No operand predicates
     /* 1313 */   // MIs[0] __add_sub_reg_match_0.x
     /* 1313 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1318 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1323 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1325 */   // Combiner Rule #93: add_sub_reg @ [__add_sub_reg_match_0[1]]
     /* 1325 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1330 */   GIR_EraseRootFromParent_Done,
     /* 1331 */ // Label 109: @1331
     /* 1331 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1376), // Rule ID 5 //
     /* 1336 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1339 */   // MIs[0] root
     /* 1339 */   // No operand predicates
     /* 1339 */   // MIs[0] sub1
     /* 1339 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1343 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1347 */   // MIs[1] A
     /* 1347 */   // No operand predicates
     /* 1347 */   // MIs[1] B
     /* 1347 */   // No operand predicates
     /* 1347 */   // MIs[0] sub2
     /* 1347 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1351 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1355 */   // MIs[2] B
     /* 1355 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1360 */   // MIs[2] C
     /* 1360 */   // No operand predicates
     /* 1360 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1362 */   // Combiner Rule #5: AMinusBPlusBMinusC
     /* 1362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1365 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1367 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 1371 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 1375 */   GIR_EraseRootFromParent_Done,
     /* 1376 */ // Label 110: @1376
     /* 1376 */ GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1421), // Rule ID 4 //
     /* 1381 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule4Enabled),
     /* 1384 */   // MIs[0] root
     /* 1384 */   // No operand predicates
     /* 1384 */   // MIs[0] sub1
     /* 1384 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1388 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1392 */   // MIs[1] A
     /* 1392 */   // No operand predicates
     /* 1392 */   // MIs[1] B
     /* 1392 */   // No operand predicates
     /* 1392 */   // MIs[0] sub2
     /* 1392 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1396 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1400 */   // MIs[2] C
     /* 1400 */   // No operand predicates
     /* 1400 */   // MIs[2] A
     /* 1400 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 1405 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1407 */   // Combiner Rule #4: AMinusBPlusCMinusA
     /* 1407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1410 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1412 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 1416 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 1420 */   GIR_EraseRootFromParent_Done,
     /* 1421 */ // Label 111: @1421
     /* 1421 */ GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1450), // Rule ID 369 //
     /* 1426 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule222Enabled),
     /* 1429 */   // MIs[0] dst
     /* 1429 */   // No operand predicates
     /* 1429 */   // MIs[0] ext1
     /* 1429 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1433 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 1437 */   // MIs[1] src1
     /* 1437 */   // No operand predicates
     /* 1437 */   // MIs[0] ext2
     /* 1437 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1441 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 1445 */   // MIs[2] src2
     /* 1445 */   // No operand predicates
     /* 1445 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1447 */   // Combiner Rule #222: push_add_through_sext
     /* 1447 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner156),
     /* 1450 */ // Label 112: @1450
     /* 1450 */ GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1485), // Rule ID 39 //
     /* 1455 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule37Enabled),
     /* 1458 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 1464 */   // MIs[0] root
     /* 1464 */   // No operand predicates
     /* 1464 */   // MIs[0] left
     /* 1464 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1468 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1472 */   // MIs[1] imm1
     /* 1472 */   // No operand predicates
     /* 1472 */   // MIs[0] right
     /* 1472 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1476 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1480 */   // MIs[2] imm2
     /* 1480 */   // No operand predicates
     /* 1480 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1482 */   // Combiner Rule #37: add_of_vscale
     /* 1482 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1485 */ // Label 113: @1485
     /* 1485 */ GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(1514), // Rule ID 367 //
     /* 1490 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule220Enabled),
     /* 1493 */   // MIs[0] dst
     /* 1493 */   // No operand predicates
     /* 1493 */   // MIs[0] ext1
     /* 1493 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1497 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 1501 */   // MIs[1] src1
     /* 1501 */   // No operand predicates
     /* 1501 */   // MIs[0] ext2
     /* 1501 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1505 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 1509 */   // MIs[2] src2
     /* 1509 */   // No operand predicates
     /* 1509 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1511 */   // Combiner Rule #220: push_add_through_zext
     /* 1511 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner156),
     /* 1514 */ // Label 114: @1514
     /* 1514 */ GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(1548), // Rule ID 1 //
     /* 1519 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 1522 */   // MIs[0] root
     /* 1522 */   // No operand predicates
     /* 1522 */   // MIs[0] A
     /* 1522 */   // No operand predicates
     /* 1522 */   // MIs[0] sub
     /* 1522 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1526 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1530 */   // MIs[1] Operand 1
     /* 1530 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 1534 */   // MIs[1] B
     /* 1534 */   // No operand predicates
     /* 1534 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1536 */   // Combiner Rule #1: APlusZeroMinusB
     /* 1536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1539 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1541 */   GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 1543 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 1547 */   GIR_EraseRootFromParent_Done,
     /* 1548 */ // Label 115: @1548
     /* 1548 */ GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(1582), // Rule ID 2 //
     /* 1553 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule2Enabled),
     /* 1556 */   // MIs[0] root
     /* 1556 */   // No operand predicates
     /* 1556 */   // MIs[0] A
     /* 1556 */   // No operand predicates
     /* 1556 */   // MIs[0] sub
     /* 1556 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1560 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1564 */   // MIs[1] B
     /* 1564 */   // No operand predicates
     /* 1564 */   // MIs[1] A
     /* 1564 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1569 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1574 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1576 */   // Combiner Rule #2: APlusBMinusB
     /* 1576 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1581 */   GIR_EraseRootFromParent_Done,
     /* 1582 */ // Label 116: @1582
     /* 1582 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1616), // Rule ID 129 //
     /* 1587 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule93Enabled),
     /* 1590 */   // MIs[0] dst
     /* 1590 */   // No operand predicates
     /* 1590 */   // MIs[0] __add_sub_reg_match_0.x
     /* 1590 */   // No operand predicates
     /* 1590 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 1590 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1594 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1598 */   // MIs[1] src
     /* 1598 */   // No operand predicates
     /* 1598 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1598 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1603 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1608 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1610 */   // Combiner Rule #93: add_sub_reg @ [__add_sub_reg_match_0[0]]
     /* 1610 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1615 */   GIR_EraseRootFromParent_Done,
     /* 1616 */ // Label 117: @1616
     /* 1616 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1661), // Rule ID 6 //
     /* 1621 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 1624 */   // MIs[0] root
     /* 1624 */   // No operand predicates
     /* 1624 */   // MIs[0] A
     /* 1624 */   // No operand predicates
     /* 1624 */   // MIs[0] sub1
     /* 1624 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1628 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1632 */   // MIs[1] B
     /* 1632 */   // No operand predicates
     /* 1632 */   // MIs[1] add1
     /* 1632 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1636 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1640 */   // MIs[2] A
     /* 1640 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1645 */   // MIs[2] C
     /* 1645 */   // No operand predicates
     /* 1645 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1647 */   // Combiner Rule #6: APlusBMinusAplusC
     /* 1647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1650 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1652 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 1656 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 1660 */   GIR_EraseRootFromParent_Done,
     /* 1661 */ // Label 118: @1661
     /* 1661 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(1706), // Rule ID 7 //
     /* 1666 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 1669 */   // MIs[0] root
     /* 1669 */   // No operand predicates
     /* 1669 */   // MIs[0] A
     /* 1669 */   // No operand predicates
     /* 1669 */   // MIs[0] sub1
     /* 1669 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1673 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1677 */   // MIs[1] B
     /* 1677 */   // No operand predicates
     /* 1677 */   // MIs[1] add1
     /* 1677 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1681 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1685 */   // MIs[2] C
     /* 1685 */   // No operand predicates
     /* 1685 */   // MIs[2] A
     /* 1685 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1690 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1692 */   // Combiner Rule #7: APlusBMinusCPlusA
     /* 1692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1695 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1697 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 1701 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 1705 */   GIR_EraseRootFromParent_Done,
     /* 1706 */ // Label 119: @1706
     /* 1706 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1729), // Rule ID 104 //
     /* 1711 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 1714 */   // MIs[0] dst
     /* 1714 */   // No operand predicates
     /* 1714 */   // MIs[0] lhs
     /* 1714 */   // No operand predicates
     /* 1714 */   // MIs[0] Operand 2
     /* 1714 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1718 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1723 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[1]]
     /* 1723 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1728 */   GIR_EraseRootFromParent_Done,
     /* 1729 */ // Label 120: @1729
     /* 1729 */ GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1740), // Rule ID 148 //
     /* 1734 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule106Enabled),
     /* 1737 */   // MIs[0] root
     /* 1737 */   // No operand predicates
     /* 1737 */   // MIs[0] src1
     /* 1737 */   // No operand predicates
     /* 1737 */   // MIs[0] src2
     /* 1737 */   // No operand predicates
     /* 1737 */   // Combiner Rule #106: reassoc_comm_binops
     /* 1737 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner57),
     /* 1740 */ // Label 121: @1740
     /* 1740 */ GIM_Reject,
     /* 1741 */ // Label 2: @1741
     /* 1741 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(1752), // Rule ID 94 //
     /* 1746 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 1749 */   // Combiner Rule #77: propagate_undef_any_op; wip_match_opcode 'G_SUB'
     /* 1749 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 1752 */ // Label 122: @1752
     /* 1752 */ GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(1763), // Rule ID 238 //
     /* 1757 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 1760 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_SUB'
     /* 1760 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 1763 */ // Label 123: @1763
     /* 1763 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(1774), // Rule ID 279 //
     /* 1768 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 1771 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_SUB'
     /* 1771 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 1774 */ // Label 124: @1774
     /* 1774 */ GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(1785), // Rule ID 304 //
     /* 1779 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 1782 */   // Combiner Rule #186: sub_add_reg; wip_match_opcode 'G_SUB'
     /* 1782 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 1785 */ // Label 125: @1785
     /* 1785 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(1796), // Rule ID 338 //
     /* 1790 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule193Enabled),
     /* 1793 */   // Combiner Rule #193: simplify_neg_minmax; wip_match_opcode 'G_SUB'
     /* 1793 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner130),
     /* 1796 */ // Label 126: @1796
     /* 1796 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(1833), // Rule ID 8 //
     /* 1801 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule8Enabled),
     /* 1804 */   // MIs[0] root
     /* 1804 */   // No operand predicates
     /* 1804 */   // MIs[0] add
     /* 1804 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1808 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1812 */   // MIs[1] A
     /* 1812 */   // No operand predicates
     /* 1812 */   // MIs[1] c1
     /* 1812 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1816 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1820 */   // MIs[2] imm1
     /* 1820 */   // No operand predicates
     /* 1820 */   // MIs[0] c2
     /* 1820 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1824 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1828 */   // MIs[3] imm2
     /* 1828 */   // No operand predicates
     /* 1828 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1830 */   // Combiner Rule #8: APlusC1MinusC2
     /* 1830 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner0),
     /* 1833 */ // Label 127: @1833
     /* 1833 */ GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(1870), // Rule ID 11 //
     /* 1838 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule11Enabled),
     /* 1841 */   // MIs[0] root
     /* 1841 */   // No operand predicates
     /* 1841 */   // MIs[0] sub1
     /* 1841 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1845 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1849 */   // MIs[1] c1
     /* 1849 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 1853 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1857 */   // MIs[2] imm1
     /* 1857 */   // No operand predicates
     /* 1857 */   // MIs[1] A
     /* 1857 */   // No operand predicates
     /* 1857 */   // MIs[0] c2
     /* 1857 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1861 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1865 */   // MIs[3] imm2
     /* 1865 */   // No operand predicates
     /* 1865 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1867 */   // Combiner Rule #11: C1Minus2MinusC2
     /* 1867 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner3),
     /* 1870 */ // Label 128: @1870
     /* 1870 */ GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(1907), // Rule ID 10 //
     /* 1875 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule10Enabled),
     /* 1878 */   // MIs[0] root
     /* 1878 */   // No operand predicates
     /* 1878 */   // MIs[0] sub1
     /* 1878 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1882 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1886 */   // MIs[1] A
     /* 1886 */   // No operand predicates
     /* 1886 */   // MIs[1] c1
     /* 1886 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1890 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1894 */   // MIs[2] imm1
     /* 1894 */   // No operand predicates
     /* 1894 */   // MIs[0] c2
     /* 1894 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1898 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1902 */   // MIs[3] imm2
     /* 1902 */   // No operand predicates
     /* 1902 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1904 */   // Combiner Rule #10: AMinusC1MinusC2
     /* 1904 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 1907 */ // Label 129: @1907
     /* 1907 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(1936), // Rule ID 368 //
     /* 1912 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule221Enabled),
     /* 1915 */   // MIs[0] dst
     /* 1915 */   // No operand predicates
     /* 1915 */   // MIs[0] ext1
     /* 1915 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1919 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 1923 */   // MIs[1] src1
     /* 1923 */   // No operand predicates
     /* 1923 */   // MIs[0] ext2
     /* 1923 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1927 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 1931 */   // MIs[2] src2
     /* 1931 */   // No operand predicates
     /* 1931 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1933 */   // Combiner Rule #221: push_sub_through_sext
     /* 1933 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner156),
     /* 1936 */ // Label 130: @1936
     /* 1936 */ GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(1965), // Rule ID 366 //
     /* 1941 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule219Enabled),
     /* 1944 */   // MIs[0] dst
     /* 1944 */   // No operand predicates
     /* 1944 */   // MIs[0] ext1
     /* 1944 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1948 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 1952 */   // MIs[1] src1
     /* 1952 */   // No operand predicates
     /* 1952 */   // MIs[0] ext2
     /* 1952 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1956 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 1960 */   // MIs[2] src2
     /* 1960 */   // No operand predicates
     /* 1960 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1962 */   // Combiner Rule #219: push_sub_through_zext
     /* 1962 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner156),
     /* 1965 */ // Label 131: @1965
     /* 1965 */ GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(2008), // Rule ID 158 //
     /* 1970 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule116Enabled),
     /* 1973 */   // MIs[0] dst
     /* 1973 */   // No operand predicates
     /* 1973 */   // MIs[0] Operand 1
     /* 1973 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 1977 */   // MIs[0] and
     /* 1977 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1981 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 1985 */   // MIs[1] x
     /* 1985 */   // No operand predicates
     /* 1985 */   // MIs[1] Operand 2
     /* 1985 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 1989 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner7),
     /* 1993 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1995 */   // Combiner Rule #116: neg_and_one_to_sext_inreg
     /* 1995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 1998 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 2000 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 2004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2007 */   GIR_EraseRootFromParent_Done,
     /* 2008 */ // Label 132: @2008
     /* 2008 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(2045), // Rule ID 9 //
     /* 2013 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule9Enabled),
     /* 2016 */   // MIs[0] root
     /* 2016 */   // No operand predicates
     /* 2016 */   // MIs[0] c2
     /* 2016 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2020 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024 */   // MIs[1] imm2
     /* 2024 */   // No operand predicates
     /* 2024 */   // MIs[0] add
     /* 2024 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2028 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 2032 */   // MIs[2] A
     /* 2032 */   // No operand predicates
     /* 2032 */   // MIs[2] c1
     /* 2032 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 2036 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2040 */   // MIs[3] imm1
     /* 2040 */   // No operand predicates
     /* 2040 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2042 */   // Combiner Rule #9: C2MinusAPlusC1
     /* 2042 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 2045 */ // Label 133: @2045
     /* 2045 */ GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(2072), // Rule ID 42 //
     /* 2050 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule40Enabled),
     /* 2053 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 2059 */   // MIs[0] root
     /* 2059 */   // No operand predicates
     /* 2059 */   // MIs[0] x
     /* 2059 */   // No operand predicates
     /* 2059 */   // MIs[0] right
     /* 2059 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2063 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 2067 */   // MIs[1] imm
     /* 2067 */   // No operand predicates
     /* 2067 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2069 */   // Combiner Rule #40: sub_of_vscale
     /* 2069 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner18),
     /* 2072 */ // Label 134: @2072
     /* 2072 */ GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(2095), // Rule ID 103 //
     /* 2077 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 2080 */   // MIs[0] dst
     /* 2080 */   // No operand predicates
     /* 2080 */   // MIs[0] lhs
     /* 2080 */   // No operand predicates
     /* 2080 */   // MIs[0] Operand 2
     /* 2080 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2084 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2089 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[0]]
     /* 2089 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2094 */   GIR_EraseRootFromParent_Done,
     /* 2095 */ // Label 135: @2095
     /* 2095 */ GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(2116), // Rule ID 15 //
     /* 2100 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /* 2103 */   // MIs[0] d
     /* 2103 */   // No operand predicates
     /* 2103 */   // MIs[0] op1
     /* 2103 */   // No operand predicates
     /* 2103 */   // MIs[0] c
     /* 2103 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2107 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2111 */   // MIs[1] imm
     /* 2111 */   // No operand predicates
     /* 2111 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2113 */   // Combiner Rule #15: sub_to_add
     /* 2113 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 2116 */ // Label 136: @2116
     /* 2116 */ GIM_Reject,
     /* 2117 */ // Label 3: @2117
     /* 2117 */ GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(2128), // Rule ID 77 //
     /* 2122 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 2125 */   // Combiner Rule #71: undef_to_int_zero; wip_match_opcode 'G_MUL'
     /* 2125 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 2128 */ // Label 137: @2128
     /* 2128 */ GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2139), // Rule ID 235 //
     /* 2133 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 2136 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_MUL'
     /* 2136 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2139 */ // Label 138: @2139
     /* 2139 */ GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(2150), // Rule ID 308 //
     /* 2144 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 2147 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_MUL'
     /* 2147 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 2150 */ // Label 139: @2150
     /* 2150 */ GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(2190), // Rule ID 17 //
     /* 2155 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 2158 */   // MIs[0] dst
     /* 2158 */   GIM_RecordRegType, /*MI*/0, /*Op*/0, /*TempTypeIdx*/uint8_t(-1),
     /* 2162 */   // MIs[0] x
     /* 2162 */   // No operand predicates
     /* 2162 */   // MIs[0] Operand 2
     /* 2162 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 2166 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2169 */   GIR_BuildConstant, /*TempRegID*/0, /*Val*/GIMT_Encode8(0),
     /* 2179 */   // Combiner Rule #17: mul_by_neg_one
     /* 2179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 2182 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 2184 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2187 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 2189 */   GIR_EraseRootFromParent_Done,
     /* 2190 */ // Label 140: @2190
     /* 2190 */ GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(2225), // Rule ID 40 //
     /* 2195 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule38Enabled),
     /* 2198 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 2204 */   // MIs[0] root
     /* 2204 */   // No operand predicates
     /* 2204 */   // MIs[0] left
     /* 2204 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2208 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 2212 */   // MIs[1] scale
     /* 2212 */   // No operand predicates
     /* 2212 */   // MIs[0] x
     /* 2212 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2216 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2220 */   // MIs[2] imm1
     /* 2220 */   // No operand predicates
     /* 2220 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222 */   // Combiner Rule #38: mul_of_vscale
     /* 2222 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner16),
     /* 2225 */ // Label 141: @2225
     /* 2225 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(2248), // Rule ID 122 //
     /* 2230 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2233 */   // MIs[0] dst
     /* 2233 */   // No operand predicates
     /* 2233 */   // MIs[0] lhs
     /* 2233 */   // No operand predicates
     /* 2233 */   // MIs[0] zero
     /* 2233 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2237 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 2242 */   // Combiner Rule #86: binop_right_to_zero
     /* 2242 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 2247 */   GIR_EraseRootFromParent_Done,
     /* 2248 */ // Label 142: @2248
     /* 2248 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(2271), // Rule ID 127 //
     /* 2253 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule91Enabled),
     /* 2256 */   // MIs[0] dst
     /* 2256 */   // No operand predicates
     /* 2256 */   // MIs[0] x
     /* 2256 */   // No operand predicates
     /* 2256 */   // MIs[0] Operand 2
     /* 2256 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 2260 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2265 */   // Combiner Rule #91: right_identity_one_int
     /* 2265 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2270 */   GIR_EraseRootFromParent_Done,
     /* 2271 */ // Label 143: @2271
     /* 2271 */ GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(2282), // Rule ID 14 //
     /* 2276 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule14Enabled),
     /* 2279 */   // MIs[0] d
     /* 2279 */   // No operand predicates
     /* 2279 */   // MIs[0] op1
     /* 2279 */   // No operand predicates
     /* 2279 */   // MIs[0] op2
     /* 2279 */   // No operand predicates
     /* 2279 */   // Combiner Rule #14: mul_to_shl
     /* 2279 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner6),
     /* 2282 */ // Label 144: @2282
     /* 2282 */ GIM_Reject,
     /* 2283 */ // Label 4: @2283
     /* 2283 */ GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(2294), // Rule ID 118 //
     /* 2288 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2291 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_SDIV'
     /* 2291 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 2294 */ // Label 145: @2294
     /* 2294 */ GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(2305), // Rule ID 210 //
     /* 2299 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule152Enabled),
     /* 2302 */   // Combiner Rule #152: div_rem_to_divrem; wip_match_opcode 'G_SDIV'
     /* 2302 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2305 */ // Label 146: @2305
     /* 2305 */ GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(2316), // Rule ID 241 //
     /* 2310 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 2313 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_SDIV'
     /* 2313 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2316 */ // Label 147: @2316
     /* 2316 */ GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(2327), // Rule ID 259 //
     /* 2321 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule171Enabled),
     /* 2324 */   // Combiner Rule #171: sdiv_by_const; wip_match_opcode 'G_SDIV'
     /* 2324 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner108),
     /* 2327 */ // Label 148: @2327
     /* 2327 */ GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(2338), // Rule ID 284 //
     /* 2332 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 2335 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_SDIV'
     /* 2335 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2338 */ // Label 149: @2338
     /* 2338 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2355), // Rule ID 260 //
     /* 2343 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 2346 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 2352 */   // MIs[0] dst
     /* 2352 */   // No operand predicates
     /* 2352 */   // MIs[0] x
     /* 2352 */   // No operand predicates
     /* 2352 */   // MIs[0] y
     /* 2352 */   // No operand predicates
     /* 2352 */   // Combiner Rule #172: sdiv_by_pow2
     /* 2352 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 2355 */ // Label 150: @2355
     /* 2355 */ GIM_Reject,
     /* 2356 */ // Label 5: @2356
     /* 2356 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2367), // Rule ID 80 //
     /* 2361 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 2364 */   // Combiner Rule #73: binop_left_undef_to_zero; wip_match_opcode 'G_UDIV'
     /* 2364 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 2367 */ // Label 151: @2367
     /* 2367 */ GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(2378), // Rule ID 119 //
     /* 2372 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2375 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_UDIV'
     /* 2375 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 2378 */ // Label 152: @2378
     /* 2378 */ GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(2389), // Rule ID 211 //
     /* 2383 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule152Enabled),
     /* 2386 */   // Combiner Rule #152: div_rem_to_divrem; wip_match_opcode 'G_UDIV'
     /* 2386 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2389 */ // Label 153: @2389
     /* 2389 */ GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(2400), // Rule ID 240 //
     /* 2394 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 2397 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_UDIV'
     /* 2397 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2400 */ // Label 154: @2400
     /* 2400 */ GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(2411), // Rule ID 258 //
     /* 2405 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule170Enabled),
     /* 2408 */   // Combiner Rule #170: udiv_by_const; wip_match_opcode 'G_UDIV'
     /* 2408 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 2411 */ // Label 155: @2411
     /* 2411 */ GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(2422), // Rule ID 286 //
     /* 2416 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 2419 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_UDIV'
     /* 2419 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2422 */ // Label 156: @2422
     /* 2422 */ GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(2439), // Rule ID 261 //
     /* 2427 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule173Enabled),
     /* 2430 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 2436 */   // MIs[0] dst
     /* 2436 */   // No operand predicates
     /* 2436 */   // MIs[0] x
     /* 2436 */   // No operand predicates
     /* 2436 */   // MIs[0] y
     /* 2436 */   // No operand predicates
     /* 2436 */   // Combiner Rule #173: udiv_by_pow2
     /* 2436 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner110),
     /* 2439 */ // Label 157: @2439
     /* 2439 */ GIM_Reject,
     /* 2440 */ // Label 6: @2440
     /* 2440 */ GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(2451), // Rule ID 120 //
     /* 2445 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2448 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_SREM'
     /* 2448 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 2451 */ // Label 158: @2451
     /* 2451 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(2462), // Rule ID 212 //
     /* 2456 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule152Enabled),
     /* 2459 */   // Combiner Rule #152: div_rem_to_divrem; wip_match_opcode 'G_SREM'
     /* 2459 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2462 */ // Label 159: @2462
     /* 2462 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(2473), // Rule ID 243 //
     /* 2467 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 2470 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_SREM'
     /* 2470 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2473 */ // Label 160: @2473
     /* 2473 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(2484), // Rule ID 285 //
     /* 2478 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 2481 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_SREM'
     /* 2481 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2484 */ // Label 161: @2484
     /* 2484 */ GIM_Reject,
     /* 2485 */ // Label 7: @2485
     /* 2485 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(2496), // Rule ID 81 //
     /* 2490 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 2493 */   // Combiner Rule #73: binop_left_undef_to_zero; wip_match_opcode 'G_UREM'
     /* 2493 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 2496 */ // Label 162: @2496
     /* 2496 */ GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(2507), // Rule ID 121 //
     /* 2501 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2504 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_UREM'
     /* 2504 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 2507 */ // Label 163: @2507
     /* 2507 */ GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(2518), // Rule ID 169 //
     /* 2512 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule127Enabled),
     /* 2515 */   // Combiner Rule #127: urem_pow2_to_mask; wip_match_opcode 'G_UREM'
     /* 2515 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner74),
     /* 2518 */ // Label 164: @2518
     /* 2518 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(2529), // Rule ID 213 //
     /* 2523 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule152Enabled),
     /* 2526 */   // Combiner Rule #152: div_rem_to_divrem; wip_match_opcode 'G_UREM'
     /* 2526 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2529 */ // Label 165: @2529
     /* 2529 */ GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(2540), // Rule ID 242 //
     /* 2534 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 2537 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_UREM'
     /* 2537 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2540 */ // Label 166: @2540
     /* 2540 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(2551), // Rule ID 287 //
     /* 2545 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 2548 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_UREM'
     /* 2548 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2551 */ // Label 167: @2551
     /* 2551 */ GIM_Reject,
     /* 2552 */ // Label 8: @2552
     /* 2552 */ GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(2563), // Rule ID 72 //
     /* 2557 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 2560 */   // Combiner Rule #68: load_and_mask; wip_match_opcode 'G_AND'
     /* 2560 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 2563 */ // Label 168: @2563
     /* 2563 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2574), // Rule ID 76 //
     /* 2568 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 2571 */   // Combiner Rule #71: undef_to_int_zero; wip_match_opcode 'G_AND'
     /* 2571 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 2574 */ // Label 169: @2574
     /* 2574 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2585), // Rule ID 141 //
     /* 2579 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 2582 */   // Combiner Rule #103: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_AND'
     /* 2582 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 2585 */ // Label 170: @2585
     /* 2585 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2596), // Rule ID 161 //
     /* 2590 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule119Enabled),
     /* 2593 */   // Combiner Rule #119: narrow_binop_feeding_and; wip_match_opcode 'G_AND'
     /* 2593 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 2596 */ // Label 171: @2596
     /* 2596 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2607), // Rule ID 166 //
     /* 2601 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule124Enabled),
     /* 2604 */   // Combiner Rule #124: redundant_and; wip_match_opcode 'G_AND'
     /* 2604 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner71),
     /* 2607 */ // Label 172: @2607
     /* 2607 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2618), // Rule ID 183 //
     /* 2612 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule141Enabled),
     /* 2615 */   // Combiner Rule #141: overlapping_and; wip_match_opcode 'G_AND'
     /* 2615 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner83),
     /* 2618 */ // Label 173: @2618
     /* 2618 */ GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(2629), // Rule ID 232 //
     /* 2623 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 2626 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_AND'
     /* 2626 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2629 */ // Label 174: @2629
     /* 2629 */ GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(2640), // Rule ID 269 //
     /* 2634 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 2637 */   // Combiner Rule #176: and_or_disjoint_mask; wip_match_opcode 'G_AND'
     /* 2637 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 2640 */ // Label 175: @2640
     /* 2640 */ GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(2651), // Rule ID 281 //
     /* 2645 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 2648 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_AND'
     /* 2648 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2651 */ // Label 176: @2651
     /* 2651 */ GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(2662), // Rule ID 309 //
     /* 2656 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 2659 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_AND'
     /* 2659 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 2662 */ // Label 177: @2662
     /* 2662 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(2673), // Rule ID 336 //
     /* 2667 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 2670 */   // Combiner Rule #191: match_ands; wip_match_opcode 'G_AND'
     /* 2670 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 2673 */ // Label 178: @2673
     /* 2673 */ GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(2771), // Rule ID 154 //
     /* 2678 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule112Enabled),
     /* 2681 */   // MIs[0] root
     /* 2681 */   // No operand predicates
     /* 2681 */   // MIs[0] d1
     /* 2681 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2685 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2689 */   // MIs[1] p
     /* 2689 */   // No operand predicates
     /* 2689 */   // MIs[1] s1
     /* 2689 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 2693 */   // MIs[1] Operand 3
     /* 2693 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 2697 */   // MIs[0] d2
     /* 2697 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2701 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2705 */   // MIs[2] p
     /* 2705 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 2710 */   // MIs[2] s2
     /* 2710 */   // No operand predicates
     /* 2710 */   // MIs[2] Operand 3
     /* 2710 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 2714 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner5),
     /* 2718 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2720 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 2723 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 2733 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2736 */   // Combiner Rule #112: double_icmp_zero_and_combine
     /* 2736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 2739 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2744 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 2748 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 2752 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2756 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 2760 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 2764 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 2767 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2770 */   GIR_EraseRootFromParent_Done,
     /* 2771 */ // Label 179: @2771
     /* 2771 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2808), // Rule ID 225 //
     /* 2776 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule162Enabled),
     /* 2779 */   // MIs[0] root
     /* 2779 */   // No operand predicates
     /* 2779 */   // MIs[0] shift
     /* 2779 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2783 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 2787 */   // MIs[1] x
     /* 2787 */   // No operand predicates
     /* 2787 */   // MIs[1] lsb
     /* 2787 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 2791 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2795 */   // MIs[2] imm1
     /* 2795 */   // No operand predicates
     /* 2795 */   // MIs[0] mask
     /* 2795 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2799 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2803 */   // MIs[3] imm2
     /* 2803 */   // No operand predicates
     /* 2803 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2805 */   // Combiner Rule #162: bitfield_extract_from_and
     /* 2805 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner100),
     /* 2808 */ // Label 180: @2808
     /* 2808 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2832), // Rule ID 113 //
     /* 2813 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 2816 */   // MIs[0] dst
     /* 2816 */   // No operand predicates
     /* 2816 */   // MIs[0] src
     /* 2816 */   // No operand predicates
     /* 2816 */   // MIs[0] src
     /* 2816 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 2821 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2826 */   // Combiner Rule #84: binop_same_val @ [__binop_same_val_match_0[0]]
     /* 2826 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2831 */   GIR_EraseRootFromParent_Done,
     /* 2832 */ // Label 181: @2832
     /* 2832 */ GIM_Reject,
     /* 2833 */ // Label 9: @2833
     /* 2833 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(2844), // Rule ID 78 //
     /* 2838 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 2841 */   // Combiner Rule #72: undef_to_negative_one; wip_match_opcode 'G_OR'
     /* 2841 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 2844 */ // Label 182: @2844
     /* 2844 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(2855), // Rule ID 142 //
     /* 2849 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 2852 */   // Combiner Rule #103: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_OR'
     /* 2852 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 2855 */ // Label 183: @2855
     /* 2855 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(2866), // Rule ID 168 //
     /* 2860 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule126Enabled),
     /* 2863 */   // Combiner Rule #126: redundant_or; wip_match_opcode 'G_OR'
     /* 2863 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner73),
     /* 2866 */ // Label 184: @2866
     /* 2866 */ GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(2877), // Rule ID 209 //
     /* 2871 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 2874 */   // Combiner Rule #151: load_or_combine; wip_match_opcode 'G_OR'
     /* 2874 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 2877 */ // Label 185: @2877
     /* 2877 */ GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(2888), // Rule ID 214 //
     /* 2882 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2885 */   // Combiner Rule #153: funnel_shift_from_or_shift; wip_match_opcode 'G_OR'
     /* 2885 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2888 */ // Label 186: @2888
     /* 2888 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(2899), // Rule ID 236 //
     /* 2893 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 2896 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_OR'
     /* 2896 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2899 */ // Label 187: @2899
     /* 2899 */ GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(2910), // Rule ID 282 //
     /* 2904 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 2907 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_OR'
     /* 2907 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2910 */ // Label 188: @2910
     /* 2910 */ GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(2921), // Rule ID 310 //
     /* 2915 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 2918 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_OR'
     /* 2918 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 2921 */ // Label 189: @2921
     /* 2921 */ GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(2932), // Rule ID 337 //
     /* 2926 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 2929 */   // Combiner Rule #192: match_ors; wip_match_opcode 'G_OR'
     /* 2929 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner129),
     /* 2932 */ // Label 190: @2932
     /* 2932 */ GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(3030), // Rule ID 155 //
     /* 2937 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule113Enabled),
     /* 2940 */   // MIs[0] root
     /* 2940 */   // No operand predicates
     /* 2940 */   // MIs[0] d1
     /* 2940 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2944 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2948 */   // MIs[1] p
     /* 2948 */   // No operand predicates
     /* 2948 */   // MIs[1] s1
     /* 2948 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 2952 */   // MIs[1] Operand 3
     /* 2952 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 2956 */   // MIs[0] d2
     /* 2956 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2960 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2964 */   // MIs[2] p
     /* 2964 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 2969 */   // MIs[2] s2
     /* 2969 */   // No operand predicates
     /* 2969 */   // MIs[2] Operand 3
     /* 2969 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 2973 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner6),
     /* 2977 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2979 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 2982 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 2992 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2995 */   // Combiner Rule #113: double_icmp_zero_or_combine
     /* 2995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 2998 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 3003 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 3007 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 3011 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 3015 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 3019 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 3023 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 3026 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 3029 */   GIR_EraseRootFromParent_Done,
     /* 3030 */ // Label 191: @3030
     /* 3030 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(3054), // Rule ID 114 //
     /* 3035 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 3038 */   // MIs[0] dst
     /* 3038 */   // No operand predicates
     /* 3038 */   // MIs[0] src
     /* 3038 */   // No operand predicates
     /* 3038 */   // MIs[0] src
     /* 3038 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 3043 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3048 */   // Combiner Rule #84: binop_same_val @ [__binop_same_val_match_0[1]]
     /* 3048 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3053 */   GIR_EraseRootFromParent_Done,
     /* 3054 */ // Label 192: @3054
     /* 3054 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(3077), // Rule ID 105 //
     /* 3059 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 3062 */   // MIs[0] dst
     /* 3062 */   // No operand predicates
     /* 3062 */   // MIs[0] lhs
     /* 3062 */   // No operand predicates
     /* 3062 */   // MIs[0] Operand 2
     /* 3062 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 3066 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3071 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[2]]
     /* 3071 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3076 */   GIR_EraseRootFromParent_Done,
     /* 3077 */ // Label 193: @3077
     /* 3077 */ GIM_Reject,
     /* 3078 */ // Label 10: @3078
     /* 3078 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(3089), // Rule ID 95 //
     /* 3083 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3086 */   // Combiner Rule #77: propagate_undef_any_op; wip_match_opcode 'G_XOR'
     /* 3086 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3089 */ // Label 194: @3089
     /* 3089 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(3100), // Rule ID 143 //
     /* 3094 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 3097 */   // Combiner Rule #103: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_XOR'
     /* 3097 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 3100 */ // Label 195: @3100
     /* 3100 */ GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(3111), // Rule ID 173 //
     /* 3105 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule131Enabled),
     /* 3108 */   // Combiner Rule #131: not_cmp_fold; wip_match_opcode 'G_XOR'
     /* 3108 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner78),
     /* 3111 */ // Label 196: @3111
     /* 3111 */ GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(3122), // Rule ID 197 //
     /* 3116 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule147Enabled),
     /* 3119 */   // Combiner Rule #147: xor_of_and_with_same_reg; wip_match_opcode 'G_XOR'
     /* 3119 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner89),
     /* 3122 */ // Label 197: @3122
     /* 3122 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(3133), // Rule ID 239 //
     /* 3127 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 3130 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_XOR'
     /* 3130 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 3133 */ // Label 198: @3133
     /* 3133 */ GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(3144), // Rule ID 283 //
     /* 3138 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 3141 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_XOR'
     /* 3141 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 3144 */ // Label 199: @3144
     /* 3144 */ GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(3155), // Rule ID 311 //
     /* 3149 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 3152 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_XOR'
     /* 3152 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 3155 */ // Label 200: @3155
     /* 3155 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(3178), // Rule ID 106 //
     /* 3160 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 3163 */   // MIs[0] dst
     /* 3163 */   // No operand predicates
     /* 3163 */   // MIs[0] lhs
     /* 3163 */   // No operand predicates
     /* 3163 */   // MIs[0] Operand 2
     /* 3163 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 3167 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3172 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[3]]
     /* 3172 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3177 */   GIR_EraseRootFromParent_Done,
     /* 3178 */ // Label 201: @3178
     /* 3178 */ GIM_Reject,
     /* 3179 */ // Label 11: @3179
     /* 3179 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(3190), // Rule ID 139 //
     /* 3184 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule101Enabled),
     /* 3187 */   // Combiner Rule #101: extend_through_phis; wip_match_opcode 'G_PHI'
     /* 3187 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 3190 */ // Label 202: @3190
     /* 3190 */ GIM_Reject,
     /* 3191 */ // Label 12: @3191
     /* 3191 */ GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(3202), // Rule ID 362 //
     /* 3196 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule215Enabled),
     /* 3199 */   // Combiner Rule #215: fold_global_offset; wip_match_opcode 'G_GLOBAL_VALUE'
     /* 3199 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner152),
     /* 3202 */ // Label 203: @3202
     /* 3202 */ GIM_Reject,
     /* 3203 */ // Label 13: @3203
     /* 3203 */ GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(3214), // Rule ID 347 //
     /* 3208 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule202Enabled),
     /* 3211 */   // Combiner Rule #202: unmerge_anyext_build_vector; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3211 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner139),
     /* 3214 */ // Label 204: @3214
     /* 3214 */ GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(3225), // Rule ID 348 //
     /* 3219 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule203Enabled),
     /* 3222 */   // Combiner Rule #203: unmerge_merge; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3222 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner140),
     /* 3225 */ // Label 205: @3225
     /* 3225 */ GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(3236), // Rule ID 350 //
     /* 3230 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule205Enabled),
     /* 3233 */   // Combiner Rule #205: unmerge_cst; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3233 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner142),
     /* 3236 */ // Label 206: @3236
     /* 3236 */ GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(3247), // Rule ID 351 //
     /* 3241 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule206Enabled),
     /* 3244 */   // Combiner Rule #206: unmerge_undef; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3244 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner143),
     /* 3247 */ // Label 207: @3247
     /* 3247 */ GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(3258), // Rule ID 352 //
     /* 3252 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule207Enabled),
     /* 3255 */   // Combiner Rule #207: unmerge_dead_to_trunc; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3255 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner144),
     /* 3258 */ // Label 208: @3258
     /* 3258 */ GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(3269), // Rule ID 353 //
     /* 3263 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule208Enabled),
     /* 3266 */   // Combiner Rule #208: unmerge_zext_to_zext; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3266 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner145),
     /* 3269 */ // Label 209: @3269
     /* 3269 */ GIM_Reject,
     /* 3270 */ // Label 14: @3270
     /* 3270 */ GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(3281), // Rule ID 349 //
     /* 3275 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule204Enabled),
     /* 3278 */   // Combiner Rule #204: merge_unmerge; wip_match_opcode 'G_MERGE_VALUES'
     /* 3278 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner141),
     /* 3281 */ // Label 210: @3281
     /* 3281 */ GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(3343),
     /* 3286 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 3289 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(3310), // Rule ID 354 //
     /* 3294 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule209Enabled),
     /* 3297 */     // MIs[0] root
     /* 3297 */     // No operand predicates
     /* 3297 */     // MIs[0] x
     /* 3297 */     // No operand predicates
     /* 3297 */     // MIs[0] undef
     /* 3297 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 3301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3307 */     // Combiner Rule #209: merge_of_x_and_undef
     /* 3307 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner146),
     /* 3310 */   // Label 212: @3310
     /* 3310 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(3342), // Rule ID 355 //
     /* 3315 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule210Enabled),
     /* 3318 */     // MIs[0] root
     /* 3318 */     // No operand predicates
     /* 3318 */     // MIs[0] x
     /* 3318 */     // No operand predicates
     /* 3318 */     // MIs[0] zero
     /* 3318 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 3322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3326 */     // MIs[1] Operand 1
     /* 3326 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/1, GIMT_Encode8(0),
     /* 3337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3339 */     // Combiner Rule #210: merge_of_x_and_zero
     /* 3339 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner147),
     /* 3342 */   // Label 213: @3342
     /* 3342 */   GIM_Reject,
     /* 3343 */ // Label 211: @3343
     /* 3343 */ GIM_Reject,
     /* 3344 */ // Label 15: @3344
     /* 3344 */ GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(3355), // Rule ID 68 //
     /* 3349 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule66Enabled),
     /* 3352 */   // Combiner Rule #66: extract_all_elts_from_build_vector; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3352 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner28),
     /* 3355 */ // Label 214: @3355
     /* 3355 */ GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(3366), // Rule ID 97 //
     /* 3360 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 3363 */   // Combiner Rule #78: propagate_undef_all_ops; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3363 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 3366 */ // Label 215: @3366
     /* 3366 */ GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(3377), // Rule ID 132 //
     /* 3371 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 3374 */   // Combiner Rule #94: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3374 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 3377 */ // Label 216: @3377
     /* 3377 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(3391), // Rule ID 346 //
     /* 3382 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule201Enabled),
     /* 3385 */   GIM_CheckNumOperandsGE, /*MI*/0, /*Expected*/2,
     /* 3388 */   // MIs[0] dst
     /* 3388 */   // No operand predicates
     /* 3388 */   // MIs[0] unused
     /* 3388 */   // No operand predicates
     /* 3388 */   // Combiner Rule #201: combine_use_vector_truncate
     /* 3388 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner138),
     /* 3391 */ // Label 217: @3391
     /* 3391 */ GIM_Reject,
     /* 3392 */ // Label 16: @3392
     /* 3392 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(3403), // Rule ID 131 //
     /* 3397 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 3400 */   // Combiner Rule #94: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR_TRUNC'
     /* 3400 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 3403 */ // Label 218: @3403
     /* 3403 */ GIM_Reject,
     /* 3404 */ // Label 17: @3404
     /* 3404 */ GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(3415), // Rule ID 339 //
     /* 3409 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule194Enabled),
     /* 3412 */   // Combiner Rule #194: combine_concat_vector; wip_match_opcode 'G_CONCAT_VECTORS'
     /* 3412 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner131),
     /* 3415 */ // Label 219: @3415
     /* 3415 */ GIM_Reject,
     /* 3416 */ // Label 18: @3416
     /* 3416 */ GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(3437), // Rule ID 124 //
     /* 3421 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3424 */   // MIs[0] dst
     /* 3424 */   // No operand predicates
     /* 3424 */   // MIs[0] t
     /* 3424 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3428 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTTOPTR),
     /* 3432 */   // MIs[1] ptr
     /* 3432 */   // No operand predicates
     /* 3432 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3434 */   // Combiner Rule #88: i2p_to_p2i
     /* 3434 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner46),
     /* 3437 */ // Label 220: @3437
     /* 3437 */ GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(3458), // Rule ID 89 //
     /* 3442 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 3445 */   // MIs[0] dst
     /* 3445 */   // No operand predicates
     /* 3445 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3445 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3449 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3453 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3455 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[3]]
     /* 3455 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 3458 */ // Label 221: @3458
     /* 3458 */ GIM_Reject,
     /* 3459 */ // Label 19: @3459
     /* 3459 */ GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(3470), // Rule ID 123 //
     /* 3464 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3467 */   // Combiner Rule #87: p2i_to_i2p; wip_match_opcode 'G_INTTOPTR'
     /* 3467 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 3470 */ // Label 222: @3470
     /* 3470 */ GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(3491), // Rule ID 90 //
     /* 3475 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 3478 */   // MIs[0] dst
     /* 3478 */   // No operand predicates
     /* 3478 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3478 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3482 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3486 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3488 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[4]]
     /* 3488 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 3491 */ // Label 223: @3491
     /* 3491 */ GIM_Reject,
     /* 3492 */ // Label 20: @3492
     /* 3492 */ GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(3513), // Rule ID 135 //
     /* 3497 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule97Enabled),
     /* 3500 */   // MIs[0] dst
     /* 3500 */   // No operand predicates
     /* 3500 */   // MIs[0] src1
     /* 3500 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3504 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 3508 */   // MIs[1] src0
     /* 3508 */   // No operand predicates
     /* 3508 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3510 */   // Combiner Rule #97: bitcast_bitcast_fold
     /* 3510 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 3513 */ // Label 224: @3513
     /* 3513 */ GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(3534), // Rule ID 87 //
     /* 3518 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 3521 */   // MIs[0] dst
     /* 3521 */   // No operand predicates
     /* 3521 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3521 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3525 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3529 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3531 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[1]]
     /* 3531 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 3534 */ // Label 225: @3534
     /* 3534 */ GIM_Reject,
     /* 3535 */ // Label 21: @3535
     /* 3535 */ GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(3564), // Rule ID 18 //
     /* 3540 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 3543 */   // MIs[0] dst
     /* 3543 */   // No operand predicates
     /* 3543 */   // MIs[0] src
     /* 3543 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3547 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FREEZE),
     /* 3551 */   // MIs[1] __idempotent_prop_match_0.x
     /* 3551 */   // No operand predicates
     /* 3551 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3556 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3558 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[0]]
     /* 3558 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3563 */   GIR_EraseRootFromParent_Done,
     /* 3564 */ // Label 226: @3564
     /* 3564 */ GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(3587), // Rule ID 43 //
     /* 3569 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule41Enabled),
     /* 3572 */   // MIs[0] root
     /* 3572 */   // No operand predicates
     /* 3572 */   // MIs[0] src
     /* 3572 */   // No operand predicates
     /* 3572 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner1),
     /* 3576 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3581 */   // Combiner Rule #41: freeze_of_non_undef_non_poison
     /* 3581 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3586 */   GIR_EraseRootFromParent_Done,
     /* 3587 */ // Label 227: @3587
     /* 3587 */ GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(3598), // Rule ID 44 //
     /* 3592 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule42Enabled),
     /* 3595 */   // MIs[0] dst
     /* 3595 */   // No operand predicates
     /* 3595 */   // MIs[0] src
     /* 3595 */   // No operand predicates
     /* 3595 */   // Combiner Rule #42: push_freeze_to_prevent_poison_from_propagating
     /* 3595 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner19),
     /* 3598 */ // Label 228: @3598
     /* 3598 */ GIM_Reject,
     /* 3599 */ // Label 22: @3599
     /* 3599 */ GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(3610), // Rule ID 69 //
     /* 3604 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3607 */   // Combiner Rule #67: extending_loads; wip_match_opcode 'G_LOAD'
     /* 3607 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 3610 */ // Label 229: @3610
     /* 3610 */ GIM_Reject,
     /* 3611 */ // Label 23: @3611
     /* 3611 */ GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(3622), // Rule ID 70 //
     /* 3616 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3619 */   // Combiner Rule #67: extending_loads; wip_match_opcode 'G_SEXTLOAD'
     /* 3619 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 3622 */ // Label 230: @3622
     /* 3622 */ GIM_Reject,
     /* 3623 */ // Label 24: @3623
     /* 3623 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(3634), // Rule ID 71 //
     /* 3628 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3631 */   // Combiner Rule #67: extending_loads; wip_match_opcode 'G_ZEXTLOAD'
     /* 3631 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 3634 */ // Label 231: @3634
     /* 3634 */ GIM_Reject,
     /* 3635 */ // Label 25: @3635
     /* 3635 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(3646), // Rule ID 99 //
     /* 3640 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule80Enabled),
     /* 3643 */   // Combiner Rule #80: erase_undef_store; wip_match_opcode 'G_STORE'
     /* 3643 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner41),
     /* 3646 */ // Label 232: @3646
     /* 3646 */ GIM_Reject,
     /* 3647 */ // Label 26: @3647
     /* 3647 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(3658), // Rule ID 125 //
     /* 3652 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule89Enabled),
     /* 3655 */   // Combiner Rule #89: anyext_trunc_fold; wip_match_opcode 'G_ANYEXT'
     /* 3655 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner47),
     /* 3658 */ // Label 233: @3658
     /* 3658 */ GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(3669), // Rule ID 256 //
     /* 3663 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 3666 */   // Combiner Rule #168: constant_fold_cast_op; wip_match_opcode 'G_ANYEXT'
     /* 3666 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 3669 */ // Label 234: @3669
     /* 3669 */ GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(3690), // Rule ID 56 //
     /* 3674 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule54Enabled),
     /* 3677 */   // MIs[0] root
     /* 3677 */   // No operand predicates
     /* 3677 */   // MIs[0] select
     /* 3677 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3681 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3685 */   // MIs[1] cond
     /* 3685 */   // No operand predicates
     /* 3685 */   // MIs[1] true
     /* 3685 */   // No operand predicates
     /* 3685 */   // MIs[1] false
     /* 3685 */   // No operand predicates
     /* 3685 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3687 */   // Combiner Rule #54: select_of_anyext
     /* 3687 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 3690 */ // Label 235: @3690
     /* 3690 */ GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(3711), // Rule ID 52 //
     /* 3695 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule50Enabled),
     /* 3698 */   // MIs[0] root
     /* 3698 */   // No operand predicates
     /* 3698 */   // MIs[0] second
     /* 3698 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3702 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3706 */   // MIs[1] src
     /* 3706 */   // No operand predicates
     /* 3706 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3708 */   // Combiner Rule #50: anyext_of_anyext
     /* 3708 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3711 */ // Label 236: @3711
     /* 3711 */ GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(3732), // Rule ID 54 //
     /* 3716 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule52Enabled),
     /* 3719 */   // MIs[0] root
     /* 3719 */   // No operand predicates
     /* 3719 */   // MIs[0] second
     /* 3719 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3723 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 3727 */   // MIs[1] src
     /* 3727 */   // No operand predicates
     /* 3727 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3729 */   // Combiner Rule #52: anyext_of_sext
     /* 3729 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3732 */ // Label 237: @3732
     /* 3732 */ GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(3753), // Rule ID 53 //
     /* 3737 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 3740 */   // MIs[0] root
     /* 3740 */   // No operand predicates
     /* 3740 */   // MIs[0] second
     /* 3740 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3744 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 3748 */   // MIs[1] src
     /* 3748 */   // No operand predicates
     /* 3748 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3750 */   // Combiner Rule #51: anyext_of_zext
     /* 3750 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3753 */ // Label 238: @3753
     /* 3753 */ GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(3774), // Rule ID 88 //
     /* 3758 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 3761 */   // MIs[0] dst
     /* 3761 */   // No operand predicates
     /* 3761 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3761 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3765 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3769 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3771 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[2]]
     /* 3771 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 3774 */ // Label 239: @3774
     /* 3774 */ GIM_Reject,
     /* 3775 */ // Label 27: @3775
     /* 3775 */ GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(3786), // Rule ID 133 //
     /* 3780 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule95Enabled),
     /* 3783 */   // Combiner Rule #95: trunc_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 3783 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 3786 */ // Label 240: @3786
     /* 3786 */ GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(3797), // Rule ID 134 //
     /* 3791 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule96Enabled),
     /* 3794 */   // Combiner Rule #96: trunc_lshr_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 3794 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner50),
     /* 3797 */ // Label 241: @3797
     /* 3797 */ GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(3808), // Rule ID 172 //
     /* 3802 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule130Enabled),
     /* 3805 */   // Combiner Rule #130: trunc_shift; wip_match_opcode 'G_TRUNC'
     /* 3805 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner77),
     /* 3808 */ // Label 242: @3808
     /* 3808 */ GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(3829), // Rule ID 57 //
     /* 3813 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule55Enabled),
     /* 3816 */   // MIs[0] root
     /* 3816 */   // No operand predicates
     /* 3816 */   // MIs[0] select
     /* 3816 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3820 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3824 */   // MIs[1] cond
     /* 3824 */   // No operand predicates
     /* 3824 */   // MIs[1] true
     /* 3824 */   // No operand predicates
     /* 3824 */   // MIs[1] false
     /* 3824 */   // No operand predicates
     /* 3824 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3826 */   // Combiner Rule #55: select_of_truncate
     /* 3826 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 3829 */ // Label 243: @3829
     /* 3829 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(3858), // Rule ID 59 //
     /* 3834 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule57Enabled),
     /* 3837 */   // MIs[0] root
     /* 3837 */   // No operand predicates
     /* 3837 */   // MIs[0] binop
     /* 3837 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3841 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 3845 */   // MIs[1] x
     /* 3845 */   // No operand predicates
     /* 3845 */   // MIs[1] const
     /* 3845 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3849 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3853 */   // MIs[2] imm
     /* 3853 */   // No operand predicates
     /* 3853 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3855 */   // Combiner Rule #57: narrow_binop_add
     /* 3855 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3858 */ // Label 244: @3858
     /* 3858 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(3887), // Rule ID 62 //
     /* 3863 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule60Enabled),
     /* 3866 */   // MIs[0] root
     /* 3866 */   // No operand predicates
     /* 3866 */   // MIs[0] binop
     /* 3866 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3870 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 3874 */   // MIs[1] x
     /* 3874 */   // No operand predicates
     /* 3874 */   // MIs[1] const
     /* 3874 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3878 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3882 */   // MIs[2] imm
     /* 3882 */   // No operand predicates
     /* 3882 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3884 */   // Combiner Rule #60: narrow_binop_and
     /* 3884 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3887 */ // Label 245: @3887
     /* 3887 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(3916), // Rule ID 61 //
     /* 3892 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule59Enabled),
     /* 3895 */   // MIs[0] root
     /* 3895 */   // No operand predicates
     /* 3895 */   // MIs[0] binop
     /* 3895 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3899 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 3903 */   // MIs[1] x
     /* 3903 */   // No operand predicates
     /* 3903 */   // MIs[1] const
     /* 3903 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3907 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3911 */   // MIs[2] imm
     /* 3911 */   // No operand predicates
     /* 3911 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3913 */   // Combiner Rule #59: narrow_binop_mul
     /* 3913 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3916 */ // Label 246: @3916
     /* 3916 */ GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(3945), // Rule ID 63 //
     /* 3921 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule61Enabled),
     /* 3924 */   // MIs[0] root
     /* 3924 */   // No operand predicates
     /* 3924 */   // MIs[0] binop
     /* 3924 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3928 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 3932 */   // MIs[1] x
     /* 3932 */   // No operand predicates
     /* 3932 */   // MIs[1] const
     /* 3932 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3936 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3940 */   // MIs[2] imm
     /* 3940 */   // No operand predicates
     /* 3940 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3942 */   // Combiner Rule #61: narrow_binop_or
     /* 3942 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3945 */ // Label 247: @3945
     /* 3945 */ GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(3974), // Rule ID 60 //
     /* 3950 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule58Enabled),
     /* 3953 */   // MIs[0] root
     /* 3953 */   // No operand predicates
     /* 3953 */   // MIs[0] binop
     /* 3953 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3957 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 3961 */   // MIs[1] x
     /* 3961 */   // No operand predicates
     /* 3961 */   // MIs[1] const
     /* 3961 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3965 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3969 */   // MIs[2] imm
     /* 3969 */   // No operand predicates
     /* 3969 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3971 */   // Combiner Rule #58: narrow_binop_sub
     /* 3971 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3974 */ // Label 248: @3974
     /* 3974 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(4003), // Rule ID 64 //
     /* 3979 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule62Enabled),
     /* 3982 */   // MIs[0] root
     /* 3982 */   // No operand predicates
     /* 3982 */   // MIs[0] binop
     /* 3982 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3986 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 3990 */   // MIs[1] x
     /* 3990 */   // No operand predicates
     /* 3990 */   // MIs[1] const
     /* 3990 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3994 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3998 */   // MIs[2] imm
     /* 3998 */   // No operand predicates
     /* 3998 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 4000 */   // Combiner Rule #62: narrow_binop_xor
     /* 4000 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 4003 */ // Label 249: @4003
     /* 4003 */ GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(4024), // Rule ID 47 //
     /* 4008 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule45Enabled),
     /* 4011 */   // MIs[0] root
     /* 4011 */   // No operand predicates
     /* 4011 */   // MIs[0] ext
     /* 4011 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4015 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 4019 */   // MIs[1] src
     /* 4019 */   // No operand predicates
     /* 4019 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4021 */   // Combiner Rule #45: truncate_of_anyext
     /* 4021 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 4024 */ // Label 250: @4024
     /* 4024 */ GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(4048), // Rule ID 58 //
     /* 4029 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule56Enabled),
     /* 4032 */   // MIs[0] root
     /* 4032 */   // No operand predicates
     /* 4032 */   // MIs[0] bv
     /* 4032 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4036 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 4040 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 4043 */   // MIs[1] unused
     /* 4043 */   // No operand predicates
     /* 4043 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4045 */   // Combiner Rule #56: buildvector_of_truncate
     /* 4045 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 4048 */ // Label 251: @4048
     /* 4048 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(4069), // Rule ID 46 //
     /* 4053 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule44Enabled),
     /* 4056 */   // MIs[0] root
     /* 4056 */   // No operand predicates
     /* 4056 */   // MIs[0] ext
     /* 4056 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4060 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 4064 */   // MIs[1] src
     /* 4064 */   // No operand predicates
     /* 4064 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4066 */   // Combiner Rule #44: truncate_of_sext
     /* 4066 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 4069 */ // Label 252: @4069
     /* 4069 */ GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(4090), // Rule ID 45 //
     /* 4074 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule43Enabled),
     /* 4077 */   // MIs[0] root
     /* 4077 */   // No operand predicates
     /* 4077 */   // MIs[0] ext
     /* 4077 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4081 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 4085 */   // MIs[1] src
     /* 4085 */   // No operand predicates
     /* 4085 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4087 */   // Combiner Rule #43: truncate_of_zext
     /* 4087 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 4090 */ // Label 253: @4090
     /* 4090 */ GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(4111), // Rule ID 86 //
     /* 4095 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 4098 */   // MIs[0] dst
     /* 4098 */   // No operand predicates
     /* 4098 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 4098 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4102 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 4106 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4108 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[0]]
     /* 4108 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 4111 */ // Label 254: @4111
     /* 4111 */ GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(4132), // Rule ID 65 //
     /* 4116 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule63Enabled),
     /* 4119 */   // MIs[0] root
     /* 4119 */   // No operand predicates
     /* 4119 */   // MIs[0] int
     /* 4119 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4123 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 4127 */   // MIs[1] imm
     /* 4127 */   // No operand predicates
     /* 4127 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4129 */   // Combiner Rule #63: integer_of_truncate
     /* 4129 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 4132 */ // Label 255: @4132
     /* 4132 */ GIM_Reject,
     /* 4133 */ // Label 28: @4133
     /* 4133 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(4144), // Rule ID 360 //
     /* 4138 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule213Enabled),
     /* 4141 */   // MIs[0] dst
     /* 4141 */   // No operand predicates
     /* 4141 */   // MIs[0] src
     /* 4141 */   // No operand predicates
     /* 4141 */   // Combiner Rule #213: fconstant_to_constant
     /* 4141 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner150),
     /* 4144 */ // Label 256: @4144
     /* 4144 */ GIM_Reject,
     /* 4145 */ // Label 29: @4145
     /* 4145 */ GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(4156), // Rule ID 255 //
     /* 4150 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 4153 */   // Combiner Rule #168: constant_fold_cast_op; wip_match_opcode 'G_SEXT'
     /* 4153 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 4156 */ // Label 257: @4156
     /* 4156 */ GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(4177), // Rule ID 51 //
     /* 4161 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 4164 */   // MIs[0] root
     /* 4164 */   // No operand predicates
     /* 4164 */   // MIs[0] second
     /* 4164 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4168 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 4172 */   // MIs[1] src
     /* 4172 */   // No operand predicates
     /* 4172 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4174 */   // Combiner Rule #49: sext_of_anyext
     /* 4174 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4177 */ // Label 258: @4177
     /* 4177 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(4198), // Rule ID 50 //
     /* 4182 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 4185 */   // MIs[0] root
     /* 4185 */   // No operand predicates
     /* 4185 */   // MIs[0] second
     /* 4185 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4189 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 4193 */   // MIs[1] src
     /* 4193 */   // No operand predicates
     /* 4193 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4195 */   // Combiner Rule #48: sext_of_sext
     /* 4195 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4198 */ // Label 259: @4198
     /* 4198 */ GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(4219), // Rule ID 340 //
     /* 4203 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule195Enabled),
     /* 4206 */   // MIs[0] root
     /* 4206 */   // No operand predicates
     /* 4206 */   // MIs[0] src
     /* 4206 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4210 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 4214 */   // MIs[1] x
     /* 4214 */   // No operand predicates
     /* 4214 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4216 */   // Combiner Rule #195: sext_trunc
     /* 4216 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner132),
     /* 4219 */ // Label 260: @4219
     /* 4219 */ GIM_Reject,
     /* 4220 */ // Label 30: @4220
     /* 4220 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(4231), // Rule ID 159 //
     /* 4225 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule117Enabled),
     /* 4228 */   // Combiner Rule #117: sext_inreg_of_load; wip_match_opcode 'G_SEXT_INREG'
     /* 4228 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner65),
     /* 4231 */ // Label 261: @4231
     /* 4231 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(4242), // Rule ID 167 //
     /* 4236 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule125Enabled),
     /* 4239 */   // Combiner Rule #125: redundant_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 4239 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner72),
     /* 4242 */ // Label 262: @4242
     /* 4242 */ GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(4253), // Rule ID 224 //
     /* 4247 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule161Enabled),
     /* 4250 */   // Combiner Rule #161: bitfield_extract_from_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 4250 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner99),
     /* 4253 */ // Label 263: @4253
     /* 4253 */ GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(4264), // Rule ID 171 //
     /* 4258 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule129Enabled),
     /* 4261 */   // MIs[0] dst
     /* 4261 */   // No operand predicates
     /* 4261 */   // MIs[0] src
     /* 4261 */   // No operand predicates
     /* 4261 */   // MIs[0] imm
     /* 4261 */   // No operand predicates
     /* 4261 */   // Combiner Rule #129: sext_inreg_to_zext_inreg
     /* 4261 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner76),
     /* 4264 */ // Label 264: @4264
     /* 4264 */ GIM_Reject,
     /* 4265 */ // Label 31: @4265
     /* 4265 */ GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(4276), // Rule ID 170 //
     /* 4270 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule128Enabled),
     /* 4273 */   // Combiner Rule #128: zext_trunc_fold; wip_match_opcode 'G_ZEXT'
     /* 4273 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner75),
     /* 4276 */ // Label 265: @4276
     /* 4276 */ GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(4287), // Rule ID 254 //
     /* 4281 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 4284 */   // Combiner Rule #168: constant_fold_cast_op; wip_match_opcode 'G_ZEXT'
     /* 4284 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 4287 */ // Label 266: @4287
     /* 4287 */ GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(4308), // Rule ID 55 //
     /* 4292 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 4295 */   // MIs[0] root
     /* 4295 */   // No operand predicates
     /* 4295 */   // MIs[0] select
     /* 4295 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4299 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 4303 */   // MIs[1] cond
     /* 4303 */   // No operand predicates
     /* 4303 */   // MIs[1] true
     /* 4303 */   // No operand predicates
     /* 4303 */   // MIs[1] false
     /* 4303 */   // No operand predicates
     /* 4303 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4305 */   // Combiner Rule #53: select_of_zext
     /* 4305 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 4308 */ // Label 267: @4308
     /* 4308 */ GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(4329), // Rule ID 49 //
     /* 4313 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule47Enabled),
     /* 4316 */   // MIs[0] root
     /* 4316 */   // No operand predicates
     /* 4316 */   // MIs[0] second
     /* 4316 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4320 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 4324 */   // MIs[1] src
     /* 4324 */   // No operand predicates
     /* 4324 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4326 */   // Combiner Rule #47: zext_of_anyext
     /* 4326 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4329 */ // Label 268: @4329
     /* 4329 */ GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(4356), // Rule ID 341 //
     /* 4334 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule196Enabled),
     /* 4337 */   // MIs[0] root
     /* 4337 */   // No operand predicates
     /* 4337 */   // MIs[0] src
     /* 4337 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4341 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 4345 */   GIM_MIFlags, /*MI*/1, GIMT_Encode4(MachineInstr::NoUWrap),
     /* 4351 */   // MIs[1] x
     /* 4351 */   // No operand predicates
     /* 4351 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4353 */   // Combiner Rule #196: zext_trunc
     /* 4353 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner133),
     /* 4356 */ // Label 269: @4356
     /* 4356 */ GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(4377), // Rule ID 48 //
     /* 4361 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule46Enabled),
     /* 4364 */   // MIs[0] root
     /* 4364 */   // No operand predicates
     /* 4364 */   // MIs[0] second
     /* 4364 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4368 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 4372 */   // MIs[1] src
     /* 4372 */   // No operand predicates
     /* 4372 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4374 */   // Combiner Rule #46: zext_of_zext
     /* 4374 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4377 */ // Label 270: @4377
     /* 4377 */ GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(4394), // Rule ID 342 //
     /* 4382 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule197Enabled),
     /* 4385 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NonNeg),
     /* 4391 */   // MIs[0] root
     /* 4391 */   // No operand predicates
     /* 4391 */   // MIs[0] x
     /* 4391 */   // No operand predicates
     /* 4391 */   // Combiner Rule #197: nneg_zext
     /* 4391 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner134),
     /* 4394 */ // Label 271: @4394
     /* 4394 */ GIM_Reject,
     /* 4395 */ // Label 32: @4395
     /* 4395 */ GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(4406), // Rule ID 79 //
     /* 4400 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 4403 */   // Combiner Rule #73: binop_left_undef_to_zero; wip_match_opcode 'G_SHL'
     /* 4403 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 4406 */ // Label 272: @4406
     /* 4406 */ GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(4417), // Rule ID 82 //
     /* 4411 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 4414 */   // Combiner Rule #74: binop_right_undef_to_undef; wip_match_opcode 'G_SHL'
     /* 4414 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 4417 */ // Label 273: @4417
     /* 4417 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(4428), // Rule ID 115 //
     /* 4422 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 4425 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_SHL'
     /* 4425 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 4428 */ // Label 274: @4428
     /* 4428 */ GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(4439), // Rule ID 199 //
     /* 4433 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 4436 */   // Combiner Rule #149: shift_immed_chain; wip_match_opcode 'G_SHL'
     /* 4436 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 4439 */ // Label 275: @4439
     /* 4439 */ GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(4450), // Rule ID 204 //
     /* 4444 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4447 */   // Combiner Rule #150: shift_of_shifted_logic_chain; wip_match_opcode 'G_SHL'
     /* 4447 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4450 */ // Label 276: @4450
     /* 4450 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(4461), // Rule ID 223 //
     /* 4455 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule160Enabled),
     /* 4458 */   // Combiner Rule #160: commute_shift; wip_match_opcode 'G_SHL'
     /* 4458 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner98),
     /* 4461 */ // Label 277: @4461
     /* 4461 */ GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(4472), // Rule ID 237 //
     /* 4466 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 4469 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_SHL'
     /* 4469 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4472 */ // Label 278: @4472
     /* 4472 */ GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(4483), // Rule ID 290 //
     /* 4477 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 4480 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_SHL'
     /* 4480 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 4483 */ // Label 279: @4483
     /* 4483 */ GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(4518), // Rule ID 41 //
     /* 4488 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule39Enabled),
     /* 4491 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 4497 */   // MIs[0] root
     /* 4497 */   // No operand predicates
     /* 4497 */   // MIs[0] left
     /* 4497 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4501 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 4505 */   // MIs[1] imm
     /* 4505 */   // No operand predicates
     /* 4505 */   // MIs[0] x
     /* 4505 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 4509 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 4513 */   // MIs[2] imm1
     /* 4513 */   // No operand predicates
     /* 4513 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 4515 */   // Combiner Rule #39: shl_of_vscale
     /* 4515 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner17),
     /* 4518 */ // Label 280: @4518
     /* 4518 */ GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(4541), // Rule ID 107 //
     /* 4523 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4526 */   // MIs[0] dst
     /* 4526 */   // No operand predicates
     /* 4526 */   // MIs[0] lhs
     /* 4526 */   // No operand predicates
     /* 4526 */   // MIs[0] Operand 2
     /* 4526 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4530 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4535 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[4]]
     /* 4535 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4540 */   GIR_EraseRootFromParent_Done,
     /* 4541 */ // Label 281: @4541
     /* 4541 */ GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(4552), // Rule ID 144 //
     /* 4546 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 4549 */   // MIs[0] root
     /* 4549 */   // No operand predicates
     /* 4549 */   // MIs[0] mi.shifted
     /* 4549 */   // No operand predicates
     /* 4549 */   // MIs[0] mi.amt
     /* 4549 */   // No operand predicates
     /* 4549 */   // Combiner Rule #104: shifts_too_big @ [mi[0]]
     /* 4549 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 4552 */ // Label 282: @4552
     /* 4552 */ GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(4563), // Rule ID 160 //
     /* 4557 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule118Enabled),
     /* 4560 */   // MIs[0] dst
     /* 4560 */   // No operand predicates
     /* 4560 */   // MIs[0] src0
     /* 4560 */   // No operand predicates
     /* 4560 */   // MIs[0] src1
     /* 4560 */   // No operand predicates
     /* 4560 */   // Combiner Rule #118: reduce_shl_of_extend
     /* 4560 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner66),
     /* 4563 */ // Label 283: @4563
     /* 4563 */ GIM_Reject,
     /* 4564 */ // Label 33: @4564
     /* 4564 */ GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(4575), // Rule ID 84 //
     /* 4569 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 4572 */   // Combiner Rule #74: binop_right_undef_to_undef; wip_match_opcode 'G_LSHR'
     /* 4572 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 4575 */ // Label 284: @4575
     /* 4575 */ GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(4586), // Rule ID 116 //
     /* 4580 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 4583 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_LSHR'
     /* 4583 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 4586 */ // Label 285: @4586
     /* 4586 */ GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(4597), // Rule ID 201 //
     /* 4591 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 4594 */   // Combiner Rule #149: shift_immed_chain; wip_match_opcode 'G_LSHR'
     /* 4594 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 4597 */ // Label 286: @4597
     /* 4597 */ GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(4608), // Rule ID 206 //
     /* 4602 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4605 */   // Combiner Rule #150: shift_of_shifted_logic_chain; wip_match_opcode 'G_LSHR'
     /* 4605 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4608 */ // Label 287: @4608
     /* 4608 */ GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(4619), // Rule ID 227 //
     /* 4613 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule163Enabled),
     /* 4616 */   // Combiner Rule #163: bitfield_extract_from_shr; wip_match_opcode 'G_LSHR'
     /* 4616 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner101),
     /* 4619 */ // Label 288: @4619
     /* 4619 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(4630), // Rule ID 229 //
     /* 4624 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4627 */   // Combiner Rule #164: bitfield_extract_from_shr_and; wip_match_opcode 'G_LSHR'
     /* 4627 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 4630 */ // Label 289: @4630
     /* 4630 */ GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(4641), // Rule ID 234 //
     /* 4635 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 4638 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_LSHR'
     /* 4638 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4641 */ // Label 290: @4641
     /* 4641 */ GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(4652), // Rule ID 288 //
     /* 4646 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 4649 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_LSHR'
     /* 4649 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 4652 */ // Label 291: @4652
     /* 4652 */ GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(4675), // Rule ID 109 //
     /* 4657 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4660 */   // MIs[0] dst
     /* 4660 */   // No operand predicates
     /* 4660 */   // MIs[0] lhs
     /* 4660 */   // No operand predicates
     /* 4660 */   // MIs[0] Operand 2
     /* 4660 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4664 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4669 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[6]]
     /* 4669 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4674 */   GIR_EraseRootFromParent_Done,
     /* 4675 */ // Label 292: @4675
     /* 4675 */ GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(4686), // Rule ID 146 //
     /* 4680 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 4683 */   // MIs[0] root
     /* 4683 */   // No operand predicates
     /* 4683 */   // MIs[0] mi.shifted
     /* 4683 */   // No operand predicates
     /* 4683 */   // MIs[0] mi.amt
     /* 4683 */   // No operand predicates
     /* 4683 */   // Combiner Rule #104: shifts_too_big @ [mi[2]]
     /* 4683 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 4686 */ // Label 293: @4686
     /* 4686 */ GIM_Reject,
     /* 4687 */ // Label 34: @4687
     /* 4687 */ GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(4698), // Rule ID 83 //
     /* 4692 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 4695 */   // Combiner Rule #74: binop_right_undef_to_undef; wip_match_opcode 'G_ASHR'
     /* 4695 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 4698 */ // Label 294: @4698
     /* 4698 */ GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(4709), // Rule ID 117 //
     /* 4703 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 4706 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_ASHR'
     /* 4706 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 4709 */ // Label 295: @4709
     /* 4709 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(4720), // Rule ID 157 //
     /* 4714 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule115Enabled),
     /* 4717 */   // Combiner Rule #115: shl_ashr_to_sext_inreg; wip_match_opcode 'G_ASHR'
     /* 4717 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner64),
     /* 4720 */ // Label 296: @4720
     /* 4720 */ GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(4731), // Rule ID 200 //
     /* 4725 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 4728 */   // Combiner Rule #149: shift_immed_chain; wip_match_opcode 'G_ASHR'
     /* 4728 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 4731 */ // Label 297: @4731
     /* 4731 */ GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(4742), // Rule ID 205 //
     /* 4736 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4739 */   // Combiner Rule #150: shift_of_shifted_logic_chain; wip_match_opcode 'G_ASHR'
     /* 4739 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4742 */ // Label 298: @4742
     /* 4742 */ GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(4753), // Rule ID 226 //
     /* 4747 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule163Enabled),
     /* 4750 */   // Combiner Rule #163: bitfield_extract_from_shr; wip_match_opcode 'G_ASHR'
     /* 4750 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner101),
     /* 4753 */ // Label 299: @4753
     /* 4753 */ GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(4764), // Rule ID 228 //
     /* 4758 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4761 */   // Combiner Rule #164: bitfield_extract_from_shr_and; wip_match_opcode 'G_ASHR'
     /* 4761 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 4764 */ // Label 300: @4764
     /* 4764 */ GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(4775), // Rule ID 233 //
     /* 4769 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 4772 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_ASHR'
     /* 4772 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4775 */ // Label 301: @4775
     /* 4775 */ GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(4786), // Rule ID 289 //
     /* 4780 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 4783 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_ASHR'
     /* 4783 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 4786 */ // Label 302: @4786
     /* 4786 */ GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(4809), // Rule ID 108 //
     /* 4791 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4794 */   // MIs[0] dst
     /* 4794 */   // No operand predicates
     /* 4794 */   // MIs[0] lhs
     /* 4794 */   // No operand predicates
     /* 4794 */   // MIs[0] Operand 2
     /* 4794 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4798 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4803 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[5]]
     /* 4803 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4808 */   GIR_EraseRootFromParent_Done,
     /* 4809 */ // Label 303: @4809
     /* 4809 */ GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(4820), // Rule ID 145 //
     /* 4814 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 4817 */   // MIs[0] root
     /* 4817 */   // No operand predicates
     /* 4817 */   // MIs[0] mi.shifted
     /* 4817 */   // No operand predicates
     /* 4817 */   // MIs[0] mi.amt
     /* 4817 */   // No operand predicates
     /* 4817 */   // Combiner Rule #104: shifts_too_big @ [mi[1]]
     /* 4817 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 4820 */ // Label 304: @4820
     /* 4820 */ GIM_Reject,
     /* 4821 */ // Label 35: @4821
     /* 4821 */ GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(4832), // Rule ID 215 //
     /* 4826 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule154Enabled),
     /* 4829 */   // Combiner Rule #154: funnel_shift_to_rotate; wip_match_opcode 'G_FSHL'
     /* 4829 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner96),
     /* 4832 */ // Label 305: @4832
     /* 4832 */ GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(4843), // Rule ID 219 //
     /* 4837 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule157Enabled),
     /* 4840 */   // Combiner Rule #157: funnel_shift_overshift; wip_match_opcode 'G_FSHL'
     /* 4840 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 4843 */ // Label 306: @4843
     /* 4843 */ GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(4863), // Rule ID 218 //
     /* 4848 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule156Enabled),
     /* 4851 */   // MIs[0] x
     /* 4851 */   // No operand predicates
     /* 4851 */   // MIs[0] y
     /* 4851 */   // No operand predicates
     /* 4851 */   // MIs[0] z
     /* 4851 */   // No operand predicates
     /* 4851 */   // MIs[0] Operand 3
     /* 4851 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 4855 */   // Combiner Rule #156: funnel_shift_left_zero
     /* 4855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 4858 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 4860 */   GIR_RootToRootCopy, /*OpIdx*/1, // y
     /* 4862 */   GIR_EraseRootFromParent_Done,
     /* 4863 */ // Label 307: @4863
     /* 4863 */ GIM_Reject,
     /* 4864 */ // Label 36: @4864
     /* 4864 */ GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(4875), // Rule ID 216 //
     /* 4869 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule154Enabled),
     /* 4872 */   // Combiner Rule #154: funnel_shift_to_rotate; wip_match_opcode 'G_FSHR'
     /* 4872 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner96),
     /* 4875 */ // Label 308: @4875
     /* 4875 */ GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(4886), // Rule ID 220 //
     /* 4880 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule157Enabled),
     /* 4883 */   // Combiner Rule #157: funnel_shift_overshift; wip_match_opcode 'G_FSHR'
     /* 4883 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 4886 */ // Label 309: @4886
     /* 4886 */ GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(4906), // Rule ID 217 //
     /* 4891 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule155Enabled),
     /* 4894 */   // MIs[0] x
     /* 4894 */   // No operand predicates
     /* 4894 */   // MIs[0] y
     /* 4894 */   // No operand predicates
     /* 4894 */   // MIs[0] z
     /* 4894 */   // No operand predicates
     /* 4894 */   // MIs[0] Operand 3
     /* 4894 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 4898 */   // Combiner Rule #155: funnel_shift_right_zero
     /* 4898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 4901 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 4903 */   GIR_RootToRootCopy, /*OpIdx*/2, // z
     /* 4905 */   GIR_EraseRootFromParent_Done,
     /* 4906 */ // Label 310: @4906
     /* 4906 */ GIM_Reject,
     /* 4907 */ // Label 37: @4907
     /* 4907 */ GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(4930), // Rule ID 112 //
     /* 4912 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4915 */   // MIs[0] dst
     /* 4915 */   // No operand predicates
     /* 4915 */   // MIs[0] lhs
     /* 4915 */   // No operand predicates
     /* 4915 */   // MIs[0] Operand 2
     /* 4915 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4919 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4924 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[9]]
     /* 4924 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4929 */   GIR_EraseRootFromParent_Done,
     /* 4930 */ // Label 311: @4930
     /* 4930 */ GIM_Reject,
     /* 4931 */ // Label 38: @4931
     /* 4931 */ GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(4954), // Rule ID 111 //
     /* 4936 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4939 */   // MIs[0] dst
     /* 4939 */   // No operand predicates
     /* 4939 */   // MIs[0] lhs
     /* 4939 */   // No operand predicates
     /* 4939 */   // MIs[0] Operand 2
     /* 4939 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4943 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4948 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[8]]
     /* 4948 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4953 */   GIR_EraseRootFromParent_Done,
     /* 4954 */ // Label 312: @4954
     /* 4954 */ GIM_Reject,
     /* 4955 */ // Label 39: @4955
     /* 4955 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(4966), // Rule ID 152 //
     /* 4960 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule110Enabled),
     /* 4963 */   // Combiner Rule #110: icmp_to_true_false_known_bits; wip_match_opcode 'G_ICMP'
     /* 4963 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner61),
     /* 4966 */ // Label 313: @4966
     /* 4966 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(4977), // Rule ID 153 //
     /* 4971 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule111Enabled),
     /* 4974 */   // Combiner Rule #111: icmp_to_lhs_known_bits; wip_match_opcode 'G_ICMP'
     /* 4974 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner62),
     /* 4977 */ // Label 314: @4977
     /* 4977 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(4988), // Rule ID 156 //
     /* 4982 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule114Enabled),
     /* 4985 */   // Combiner Rule #114: redundant_binop_in_equality; wip_match_opcode 'G_ICMP'
     /* 4985 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner63),
     /* 4988 */ // Label 315: @4988
     /* 4988 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(4999), // Rule ID 150 //
     /* 4993 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule108Enabled),
     /* 4996 */   // MIs[0] root
     /* 4996 */   // No operand predicates
     /* 4996 */   // MIs[0] pred
     /* 4996 */   // No operand predicates
     /* 4996 */   // MIs[0] lhs
     /* 4996 */   // No operand predicates
     /* 4996 */   // MIs[0] rhs
     /* 4996 */   // No operand predicates
     /* 4996 */   // Combiner Rule #108: canonicalize_icmp
     /* 4996 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner59),
     /* 4999 */ // Label 316: @4999
     /* 4999 */ GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(5010), // Rule ID 361 //
     /* 5004 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule214Enabled),
     /* 5007 */   // MIs[0] dst
     /* 5007 */   // No operand predicates
     /* 5007 */   // MIs[0] tst
     /* 5007 */   // No operand predicates
     /* 5007 */   // MIs[0] src1
     /* 5007 */   // No operand predicates
     /* 5007 */   // MIs[0] src2
     /* 5007 */   // No operand predicates
     /* 5007 */   // Combiner Rule #214: icmp_redundant_trunc
     /* 5007 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner151),
     /* 5010 */ // Label 317: @5010
     /* 5010 */ GIM_Reject,
     /* 5011 */ // Label 40: @5011
     /* 5011 */ GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(5022), // Rule ID 151 //
     /* 5016 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule109Enabled),
     /* 5019 */   // MIs[0] root
     /* 5019 */   // No operand predicates
     /* 5019 */   // MIs[0] pred
     /* 5019 */   // No operand predicates
     /* 5019 */   // MIs[0] lhs
     /* 5019 */   // No operand predicates
     /* 5019 */   // MIs[0] rhs
     /* 5019 */   // No operand predicates
     /* 5019 */   // Combiner Rule #109: canonicalize_fcmp
     /* 5019 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner60),
     /* 5022 */ // Label 318: @5022
     /* 5022 */ GIM_Reject,
     /* 5023 */ // Label 41: @5023
     /* 5023 */ GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(5034), // Rule ID 102 //
     /* 5028 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 5031 */   // Combiner Rule #82: select_same_val; wip_match_opcode 'G_SELECT'
     /* 5031 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 5034 */ // Label 319: @5034
     /* 5034 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(5045), // Rule ID 163 //
     /* 5039 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule121Enabled),
     /* 5042 */   // Combiner Rule #121: select_constant_cmp; wip_match_opcode 'G_SELECT'
     /* 5042 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 5045 */ // Label 320: @5045
     /* 5045 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(5056), // Rule ID 165 //
     /* 5050 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule123Enabled),
     /* 5053 */   // Combiner Rule #123: match_selects; wip_match_opcode 'G_SELECT'
     /* 5053 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner70),
     /* 5056 */ // Label 321: @5056
     /* 5056 */ GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(5067), // Rule ID 305 //
     /* 5061 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule187Enabled),
     /* 5064 */   // Combiner Rule #187: select_to_minmax; wip_match_opcode 'G_SELECT'
     /* 5064 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner124),
     /* 5067 */ // Label 322: @5067
     /* 5067 */ GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(5088), // Rule ID 164 //
     /* 5072 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule122Enabled),
     /* 5075 */   // MIs[0] root
     /* 5075 */   // No operand predicates
     /* 5075 */   // MIs[0] tst
     /* 5075 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5079 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 5083 */   // MIs[1] tst1
     /* 5083 */   // No operand predicates
     /* 5083 */   // MIs[1] a
     /* 5083 */   // No operand predicates
     /* 5083 */   // MIs[1] b
     /* 5083 */   // No operand predicates
     /* 5083 */   // MIs[0] x
     /* 5083 */   // No operand predicates
     /* 5083 */   // MIs[0] y
     /* 5083 */   // No operand predicates
     /* 5083 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5085 */   // Combiner Rule #122: select_to_iminmax
     /* 5085 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner69),
     /* 5088 */ // Label 323: @5088
     /* 5088 */ GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(5117), // Rule ID 162 //
     /* 5093 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule120Enabled),
     /* 5096 */   // MIs[0] dst
     /* 5096 */   // No operand predicates
     /* 5096 */   // MIs[0] undef
     /* 5096 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5100 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 5104 */   // MIs[0] x
     /* 5104 */   // No operand predicates
     /* 5104 */   // MIs[0] y
     /* 5104 */   // No operand predicates
     /* 5104 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 5109 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5111 */   // Combiner Rule #120: select_undef_cmp
     /* 5111 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 5116 */   GIR_EraseRootFromParent_Done,
     /* 5117 */ // Label 324: @5117
     /* 5117 */ GIM_Reject,
     /* 5118 */ // Label 42: @5118
     /* 5118 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(5129), // Rule ID 316 //
     /* 5123 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5126 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDO'
     /* 5126 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5129 */ // Label 325: @5129
     /* 5129 */ GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(5140), // Rule ID 357 //
     /* 5134 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule211Enabled),
     /* 5137 */   // Combiner Rule #211: match_addos; wip_match_opcode 'G_UADDO'
     /* 5137 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner148),
     /* 5140 */ // Label 326: @5140
     /* 5140 */ GIM_Reject,
     /* 5141 */ // Label 43: @5141
     /* 5141 */ GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(5152), // Rule ID 188 //
     /* 5146 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 5149 */   // Combiner Rule #144: adde_to_addo; wip_match_opcode 'G_UADDE'
     /* 5149 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 5152 */ // Label 327: @5152
     /* 5152 */ GIM_Reject,
     /* 5153 */ // Label 44: @5153
     /* 5153 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(5164), // Rule ID 359 //
     /* 5158 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule212Enabled),
     /* 5161 */   // Combiner Rule #212: match_subo_no_overflow; wip_match_opcode 'G_USUBO'
     /* 5161 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 5164 */ // Label 328: @5164
     /* 5164 */ GIM_Reject,
     /* 5165 */ // Label 45: @5165
     /* 5165 */ GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(5176), // Rule ID 190 //
     /* 5170 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 5173 */   // Combiner Rule #144: adde_to_addo; wip_match_opcode 'G_USUBE'
     /* 5173 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 5176 */ // Label 329: @5176
     /* 5176 */ GIM_Reject,
     /* 5177 */ // Label 46: @5177
     /* 5177 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(5188), // Rule ID 317 //
     /* 5182 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5185 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDO'
     /* 5185 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5188 */ // Label 330: @5188
     /* 5188 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(5199), // Rule ID 356 //
     /* 5193 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule211Enabled),
     /* 5196 */   // Combiner Rule #211: match_addos; wip_match_opcode 'G_SADDO'
     /* 5196 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner148),
     /* 5199 */ // Label 331: @5199
     /* 5199 */ GIM_Reject,
     /* 5200 */ // Label 47: @5200
     /* 5200 */ GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(5211), // Rule ID 189 //
     /* 5205 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 5208 */   // Combiner Rule #144: adde_to_addo; wip_match_opcode 'G_SADDE'
     /* 5208 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 5211 */ // Label 332: @5211
     /* 5211 */ GIM_Reject,
     /* 5212 */ // Label 48: @5212
     /* 5212 */ GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(5223), // Rule ID 358 //
     /* 5217 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule212Enabled),
     /* 5220 */   // Combiner Rule #212: match_subo_no_overflow; wip_match_opcode 'G_SSUBO'
     /* 5220 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 5223 */ // Label 333: @5223
     /* 5223 */ GIM_Reject,
     /* 5224 */ // Label 49: @5224
     /* 5224 */ GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(5235), // Rule ID 191 //
     /* 5229 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 5232 */   // Combiner Rule #144: adde_to_addo; wip_match_opcode 'G_SSUBE'
     /* 5232 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 5235 */ // Label 334: @5235
     /* 5235 */ GIM_Reject,
     /* 5236 */ // Label 50: @5236
     /* 5236 */ GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(5247), // Rule ID 184 //
     /* 5241 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule142Enabled),
     /* 5244 */   // Combiner Rule #142: mulo_by_2; wip_match_opcode 'G_UMULO'
     /* 5244 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner84),
     /* 5247 */ // Label 335: @5247
     /* 5247 */ GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(5258), // Rule ID 186 //
     /* 5252 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 5255 */   // Combiner Rule #143: mulo_by_0; wip_match_opcode 'G_UMULO'
     /* 5255 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 5258 */ // Label 336: @5258
     /* 5258 */ GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(5269), // Rule ID 318 //
     /* 5263 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5266 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULO'
     /* 5266 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5269 */ // Label 337: @5269
     /* 5269 */ GIM_Reject,
     /* 5270 */ // Label 51: @5270
     /* 5270 */ GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(5281), // Rule ID 185 //
     /* 5275 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule142Enabled),
     /* 5278 */   // Combiner Rule #142: mulo_by_2; wip_match_opcode 'G_SMULO'
     /* 5278 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner84),
     /* 5281 */ // Label 338: @5281
     /* 5281 */ GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(5292), // Rule ID 187 //
     /* 5286 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 5289 */   // Combiner Rule #143: mulo_by_0; wip_match_opcode 'G_SMULO'
     /* 5289 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 5292 */ // Label 339: @5292
     /* 5292 */ GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(5303), // Rule ID 319 //
     /* 5297 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5300 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULO'
     /* 5300 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5303 */ // Label 340: @5303
     /* 5303 */ GIM_Reject,
     /* 5304 */ // Label 52: @5304
     /* 5304 */ GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(5315), // Rule ID 262 //
     /* 5309 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 5312 */   // Combiner Rule #174: mulh_to_lshr; wip_match_opcode 'G_UMULH'
     /* 5312 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner111),
     /* 5315 */ // Label 341: @5315
     /* 5315 */ GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(5326), // Rule ID 320 //
     /* 5320 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5323 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULH'
     /* 5323 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5326 */ // Label 342: @5326
     /* 5326 */ GIM_Reject,
     /* 5327 */ // Label 53: @5327
     /* 5327 */ GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(5338), // Rule ID 321 //
     /* 5332 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5335 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULH'
     /* 5335 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5338 */ // Label 343: @5338
     /* 5338 */ GIM_Reject,
     /* 5339 */ // Label 54: @5339
     /* 5339 */ GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(5350), // Rule ID 322 //
     /* 5344 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5347 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDSAT'
     /* 5347 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5350 */ // Label 344: @5350
     /* 5350 */ GIM_Reject,
     /* 5351 */ // Label 55: @5351
     /* 5351 */ GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(5362), // Rule ID 323 //
     /* 5356 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5359 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDSAT'
     /* 5359 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5362 */ // Label 345: @5362
     /* 5362 */ GIM_Reject,
     /* 5363 */ // Label 56: @5363
     /* 5363 */ GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(5374), // Rule ID 203 //
     /* 5368 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 5371 */   // Combiner Rule #149: shift_immed_chain; wip_match_opcode 'G_USHLSAT'
     /* 5371 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 5374 */ // Label 346: @5374
     /* 5374 */ GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(5385), // Rule ID 207 //
     /* 5379 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 5382 */   // Combiner Rule #150: shift_of_shifted_logic_chain; wip_match_opcode 'G_USHLSAT'
     /* 5382 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 5385 */ // Label 347: @5385
     /* 5385 */ GIM_Reject,
     /* 5386 */ // Label 57: @5386
     /* 5386 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(5397), // Rule ID 202 //
     /* 5391 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 5394 */   // Combiner Rule #149: shift_immed_chain; wip_match_opcode 'G_SSHLSAT'
     /* 5394 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 5397 */ // Label 348: @5397
     /* 5397 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(5408), // Rule ID 208 //
     /* 5402 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 5405 */   // Combiner Rule #150: shift_of_shifted_logic_chain; wip_match_opcode 'G_SSHLSAT'
     /* 5405 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 5408 */ // Label 349: @5408
     /* 5408 */ GIM_Reject,
     /* 5409 */ // Label 58: @5409
     /* 5409 */ GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(5420), // Rule ID 324 //
     /* 5414 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5417 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIX'
     /* 5417 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5420 */ // Label 350: @5420
     /* 5420 */ GIM_Reject,
     /* 5421 */ // Label 59: @5421
     /* 5421 */ GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(5432), // Rule ID 325 //
     /* 5426 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5429 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIX'
     /* 5429 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5432 */ // Label 351: @5432
     /* 5432 */ GIM_Reject,
     /* 5433 */ // Label 60: @5433
     /* 5433 */ GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(5444), // Rule ID 326 //
     /* 5438 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5441 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIXSAT'
     /* 5441 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5444 */ // Label 352: @5444
     /* 5444 */ GIM_Reject,
     /* 5445 */ // Label 61: @5445
     /* 5445 */ GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(5456), // Rule ID 327 //
     /* 5450 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5453 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIXSAT'
     /* 5453 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5456 */ // Label 353: @5456
     /* 5456 */ GIM_Reject,
     /* 5457 */ // Label 62: @5457
     /* 5457 */ GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(5468), // Rule ID 248 //
     /* 5462 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 5465 */   // Combiner Rule #166: constant_fold_fp_binop; wip_match_opcode 'G_FADD'
     /* 5465 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 5468 */ // Label 354: @5468
     /* 5468 */ GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(5479), // Rule ID 263 //
     /* 5473 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5476 */   // Combiner Rule #175: redundant_neg_operands; wip_match_opcode 'G_FADD'
     /* 5476 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5479 */ // Label 355: @5479
     /* 5479 */ GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(5490), // Rule ID 270 //
     /* 5484 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule177Enabled),
     /* 5487 */   // Combiner Rule #177: combine_fadd_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5487 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner114),
     /* 5490 */ // Label 356: @5490
     /* 5490 */ GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(5501), // Rule ID 271 //
     /* 5495 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule178Enabled),
     /* 5498 */   // Combiner Rule #178: combine_fadd_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5498 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner115),
     /* 5501 */ // Label 357: @5501
     /* 5501 */ GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(5512), // Rule ID 272 //
     /* 5506 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule179Enabled),
     /* 5509 */   // Combiner Rule #179: combine_fadd_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5509 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner116),
     /* 5512 */ // Label 358: @5512
     /* 5512 */ GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(5523), // Rule ID 273 //
     /* 5517 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule180Enabled),
     /* 5520 */   // Combiner Rule #180: combine_fadd_fpext_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5520 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner117),
     /* 5523 */ // Label 359: @5523
     /* 5523 */ GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(5534), // Rule ID 296 //
     /* 5528 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5531 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FADD'
     /* 5531 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5534 */ // Label 360: @5534
     /* 5534 */ GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(5545), // Rule ID 328 //
     /* 5539 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5542 */   // Combiner Rule #190: commute_fp_constant_to_rhs; wip_match_opcode 'G_FADD'
     /* 5542 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5545 */ // Label 361: @5545
     /* 5545 */ GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(5568), // Rule ID 137 //
     /* 5550 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule99Enabled),
     /* 5553 */   // MIs[0] dst
     /* 5553 */   // No operand predicates
     /* 5553 */   // MIs[0] x
     /* 5553 */   // No operand predicates
     /* 5553 */   // MIs[0] y
     /* 5553 */   // No operand predicates
     /* 5553 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner3),
     /* 5557 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5562 */   // Combiner Rule #99: right_identity_neg_zero_fp
     /* 5562 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5567 */   GIR_EraseRootFromParent_Done,
     /* 5568 */ // Label 362: @5568
     /* 5568 */ GIM_Reject,
     /* 5569 */ // Label 63: @5569
     /* 5569 */ GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(5580), // Rule ID 249 //
     /* 5574 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 5577 */   // Combiner Rule #166: constant_fold_fp_binop; wip_match_opcode 'G_FSUB'
     /* 5577 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 5580 */ // Label 363: @5580
     /* 5580 */ GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(5591), // Rule ID 264 //
     /* 5585 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5588 */   // Combiner Rule #175: redundant_neg_operands; wip_match_opcode 'G_FSUB'
     /* 5588 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5591 */ // Label 364: @5591
     /* 5591 */ GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(5602), // Rule ID 274 //
     /* 5596 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule181Enabled),
     /* 5599 */   // Combiner Rule #181: combine_fsub_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5599 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner118),
     /* 5602 */ // Label 365: @5602
     /* 5602 */ GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(5613), // Rule ID 275 //
     /* 5607 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 5610 */   // Combiner Rule #182: combine_fsub_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5610 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 5613 */ // Label 366: @5613
     /* 5613 */ GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(5624), // Rule ID 276 //
     /* 5618 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule183Enabled),
     /* 5621 */   // Combiner Rule #183: combine_fsub_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5621 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner120),
     /* 5624 */ // Label 367: @5624
     /* 5624 */ GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(5635), // Rule ID 277 //
     /* 5629 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 5632 */   // Combiner Rule #184: combine_fsub_fpext_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5632 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner121),
     /* 5635 */ // Label 368: @5635
     /* 5635 */ GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(5646), // Rule ID 297 //
     /* 5640 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5643 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FSUB'
     /* 5643 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5646 */ // Label 369: @5646
     /* 5646 */ GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(5657), // Rule ID 306 //
     /* 5651 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5654 */   // Combiner Rule #188: fsub_to_fneg; wip_match_opcode 'G_FSUB'
     /* 5654 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner125),
     /* 5657 */ // Label 370: @5657
     /* 5657 */ GIM_Reject,
     /* 5658 */ // Label 64: @5658
     /* 5658 */ GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(5669), // Rule ID 250 //
     /* 5663 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 5666 */   // Combiner Rule #166: constant_fold_fp_binop; wip_match_opcode 'G_FMUL'
     /* 5666 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 5669 */ // Label 371: @5669
     /* 5669 */ GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(5680), // Rule ID 265 //
     /* 5674 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5677 */   // Combiner Rule #175: redundant_neg_operands; wip_match_opcode 'G_FMUL'
     /* 5677 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5680 */ // Label 372: @5680
     /* 5680 */ GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(5691), // Rule ID 295 //
     /* 5685 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5688 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FMUL'
     /* 5688 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5691 */ // Label 373: @5691
     /* 5691 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(5702), // Rule ID 329 //
     /* 5696 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5699 */   // Combiner Rule #190: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMUL'
     /* 5699 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5702 */ // Label 374: @5702
     /* 5702 */ GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(5725), // Rule ID 128 //
     /* 5707 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule92Enabled),
     /* 5710 */   // MIs[0] dst
     /* 5710 */   // No operand predicates
     /* 5710 */   // MIs[0] x
     /* 5710 */   // No operand predicates
     /* 5710 */   // MIs[0] y
     /* 5710 */   // No operand predicates
     /* 5710 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner2),
     /* 5714 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5719 */   // Combiner Rule #92: right_identity_one_fp
     /* 5719 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5724 */   GIR_EraseRootFromParent_Done,
     /* 5725 */ // Label 375: @5725
     /* 5725 */ GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(5745), // Rule ID 138 //
     /* 5730 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule100Enabled),
     /* 5733 */   // MIs[0] dst
     /* 5733 */   // No operand predicates
     /* 5733 */   // MIs[0] x
     /* 5733 */   // No operand predicates
     /* 5733 */   // MIs[0] y
     /* 5733 */   // No operand predicates
     /* 5733 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner4),
     /* 5737 */   // Combiner Rule #100: right_identity_neg_one_fp
     /* 5737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5740 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 5742 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 5744 */   GIR_EraseRootFromParent_Done,
     /* 5745 */ // Label 376: @5745
     /* 5745 */ GIM_Reject,
     /* 5746 */ // Label 65: @5746
     /* 5746 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(5757), // Rule ID 253 //
     /* 5751 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5754 */   // Combiner Rule #167: constant_fold_fma; wip_match_opcode 'G_FMA'
     /* 5754 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5757 */ // Label 377: @5757
     /* 5757 */ GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(5768), // Rule ID 268 //
     /* 5762 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5765 */   // Combiner Rule #175: redundant_neg_operands; wip_match_opcode 'G_FMA'
     /* 5765 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5768 */ // Label 378: @5768
     /* 5768 */ GIM_Reject,
     /* 5769 */ // Label 66: @5769
     /* 5769 */ GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(5780), // Rule ID 252 //
     /* 5774 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5777 */   // Combiner Rule #167: constant_fold_fma; wip_match_opcode 'G_FMAD'
     /* 5777 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5780 */ // Label 379: @5780
     /* 5780 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(5791), // Rule ID 267 //
     /* 5785 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5788 */   // Combiner Rule #175: redundant_neg_operands; wip_match_opcode 'G_FMAD'
     /* 5788 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5791 */ // Label 380: @5791
     /* 5791 */ GIM_Reject,
     /* 5792 */ // Label 67: @5792
     /* 5792 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(5803), // Rule ID 251 //
     /* 5797 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 5800 */   // Combiner Rule #166: constant_fold_fp_binop; wip_match_opcode 'G_FDIV'
     /* 5800 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 5803 */ // Label 381: @5803
     /* 5803 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(5814), // Rule ID 266 //
     /* 5808 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5811 */   // Combiner Rule #175: redundant_neg_operands; wip_match_opcode 'G_FDIV'
     /* 5811 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5814 */ // Label 382: @5814
     /* 5814 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(5825), // Rule ID 298 //
     /* 5819 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5822 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FDIV'
     /* 5822 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5825 */ // Label 383: @5825
     /* 5825 */ GIM_Reject,
     /* 5826 */ // Label 68: @5826
     /* 5826 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(5837), // Rule ID 299 //
     /* 5831 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5834 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FREM'
     /* 5834 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5837 */ // Label 384: @5837
     /* 5837 */ GIM_Reject,
     /* 5838 */ // Label 69: @5838
     /* 5838 */ GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(5859), // Rule ID 196 //
     /* 5843 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 5846 */   // MIs[0] dst
     /* 5846 */   // No operand predicates
     /* 5846 */   // MIs[0] float
     /* 5846 */   // No operand predicates
     /* 5846 */   // MIs[0] int
     /* 5846 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 5850 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 5854 */   // MIs[1] imm
     /* 5854 */   // No operand predicates
     /* 5854 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5856 */   // Combiner Rule #146: expand_const_fpowi
     /* 5856 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 5859 */ // Label 385: @5859
     /* 5859 */ GIM_Reject,
     /* 5860 */ // Label 70: @5860
     /* 5860 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(5881), // Rule ID 178 //
     /* 5865 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule136Enabled),
     /* 5868 */   // MIs[0] dst
     /* 5868 */   // No operand predicates
     /* 5868 */   // MIs[0] src0
     /* 5868 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5872 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5876 */   // MIs[1] cst
     /* 5876 */   // No operand predicates
     /* 5876 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5878 */   // Combiner Rule #136: constant_fold_flog2
     /* 5878 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 5881 */ // Label 386: @5881
     /* 5881 */ GIM_Reject,
     /* 5882 */ // Label 71: @5882
     /* 5882 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(5903), // Rule ID 175 //
     /* 5887 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule133Enabled),
     /* 5890 */   // MIs[0] dst
     /* 5890 */   // No operand predicates
     /* 5890 */   // MIs[0] src0
     /* 5890 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5894 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5898 */   // MIs[1] cst
     /* 5898 */   // No operand predicates
     /* 5898 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5900 */   // Combiner Rule #133: constant_fold_fneg
     /* 5900 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 5903 */ // Label 387: @5903
     /* 5903 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(5932), // Rule ID 126 //
     /* 5908 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule90Enabled),
     /* 5911 */   // MIs[0] dst
     /* 5911 */   // No operand predicates
     /* 5911 */   // MIs[0] t
     /* 5911 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5915 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5919 */   // MIs[1] src
     /* 5919 */   // No operand predicates
     /* 5919 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 5924 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5926 */   // Combiner Rule #90: fneg_fneg_fold
     /* 5926 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 5931 */   GIR_EraseRootFromParent_Done,
     /* 5932 */ // Label 388: @5932
     /* 5932 */ GIM_Reject,
     /* 5933 */ // Label 72: @5933
     /* 5933 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(5954), // Rule ID 179 //
     /* 5938 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule137Enabled),
     /* 5941 */   // MIs[0] dst
     /* 5941 */   // No operand predicates
     /* 5941 */   // MIs[0] src0
     /* 5941 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5945 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5949 */   // MIs[1] cst
     /* 5949 */   // No operand predicates
     /* 5949 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5951 */   // Combiner Rule #137: constant_fold_fptrunc
     /* 5951 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 5954 */ // Label 389: @5954
     /* 5954 */ GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(5975), // Rule ID 136 //
     /* 5959 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule98Enabled),
     /* 5962 */   // MIs[0] dst
     /* 5962 */   // No operand predicates
     /* 5962 */   // MIs[0] src1
     /* 5962 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5966 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPEXT),
     /* 5970 */   // MIs[1] src0
     /* 5970 */   // No operand predicates
     /* 5970 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5972 */   // Combiner Rule #98: fptrunc_fpext_fold
     /* 5972 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 5975 */ // Label 390: @5975
     /* 5975 */ GIM_Reject,
     /* 5976 */ // Label 73: @5976
     /* 5976 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(5997), // Rule ID 91 //
     /* 5981 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 5984 */   // MIs[0] dst
     /* 5984 */   // No operand predicates
     /* 5984 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 5984 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5988 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 5992 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5994 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[5]]
     /* 5994 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 5997 */ // Label 391: @5997
     /* 5997 */ GIM_Reject,
     /* 5998 */ // Label 74: @5998
     /* 5998 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(6019), // Rule ID 92 //
     /* 6003 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 6006 */   // MIs[0] dst
     /* 6006 */   // No operand predicates
     /* 6006 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 6006 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6010 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6014 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6016 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[6]]
     /* 6016 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 6019 */ // Label 392: @6019
     /* 6019 */ GIM_Reject,
     /* 6020 */ // Label 75: @6020
     /* 6020 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(6031), // Rule ID 75 //
     /* 6025 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 6028 */   // Combiner Rule #70: undef_to_fp_zero; wip_match_opcode 'G_SITOFP'
     /* 6028 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 6031 */ // Label 393: @6031
     /* 6031 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(6046), // Rule ID 180 //
     /* 6036 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule138Enabled),
     /* 6039 */   // MIs[0] dst
     /* 6039 */   // No operand predicates
     /* 6039 */   // MIs[0] Operand 1
     /* 6039 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 6043 */   // Combiner Rule #138: itof_const_zero_fold_si
     /* 6043 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 6046 */ // Label 394: @6046
     /* 6046 */ GIM_Reject,
     /* 6047 */ // Label 76: @6047
     /* 6047 */ GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(6058), // Rule ID 74 //
     /* 6052 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 6055 */   // Combiner Rule #70: undef_to_fp_zero; wip_match_opcode 'G_UITOFP'
     /* 6055 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 6058 */ // Label 395: @6058
     /* 6058 */ GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(6073), // Rule ID 181 //
     /* 6063 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule139Enabled),
     /* 6066 */   // MIs[0] dst
     /* 6066 */   // No operand predicates
     /* 6066 */   // MIs[0] Operand 1
     /* 6066 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 6070 */   // Combiner Rule #139: itof_const_zero_fold_ui
     /* 6070 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 6073 */ // Label 396: @6073
     /* 6073 */ GIM_Reject,
     /* 6074 */ // Label 77: @6074
     /* 6074 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(6103), // Rule ID 19 //
     /* 6079 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 6082 */   // MIs[0] dst
     /* 6082 */   // No operand predicates
     /* 6082 */   // MIs[0] src
     /* 6082 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6086 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 6090 */   // MIs[1] __idempotent_prop_match_0.x
     /* 6090 */   // No operand predicates
     /* 6090 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6095 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6097 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[1]]
     /* 6097 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6102 */   GIR_EraseRootFromParent_Done,
     /* 6103 */ // Label 397: @6103
     /* 6103 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(6124), // Rule ID 176 //
     /* 6108 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule134Enabled),
     /* 6111 */   // MIs[0] dst
     /* 6111 */   // No operand predicates
     /* 6111 */   // MIs[0] src0
     /* 6111 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6115 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 6119 */   // MIs[1] cst
     /* 6119 */   // No operand predicates
     /* 6119 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6121 */   // Combiner Rule #134: constant_fold_fabs
     /* 6121 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 6124 */ // Label 398: @6124
     /* 6124 */ GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(6152), // Rule ID 257 //
     /* 6129 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 6132 */   // MIs[0] dst
     /* 6132 */   // No operand predicates
     /* 6132 */   // MIs[0] tmp
     /* 6132 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6136 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 6140 */   // MIs[1] x
     /* 6140 */   // No operand predicates
     /* 6140 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6142 */   // Combiner Rule #169: fabs_fneg_fold
     /* 6142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FABS),
     /* 6145 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 6147 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 6151 */   GIR_EraseRootFromParent_Done,
     /* 6152 */ // Label 399: @6152
     /* 6152 */ GIM_Reject,
     /* 6153 */ // Label 78: @6153
     /* 6153 */ GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(6182), // Rule ID 20 //
     /* 6158 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 6161 */   // MIs[0] dst
     /* 6161 */   // No operand predicates
     /* 6161 */   // MIs[0] src
     /* 6161 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6165 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 6169 */   // MIs[1] __idempotent_prop_match_0.x
     /* 6169 */   // No operand predicates
     /* 6169 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6174 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6176 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[2]]
     /* 6176 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6181 */   GIR_EraseRootFromParent_Done,
     /* 6182 */ // Label 400: @6182
     /* 6182 */ GIM_Reject,
     /* 6183 */ // Label 79: @6183
     /* 6183 */ GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(6194), // Rule ID 192 //
     /* 6188 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 6191 */   // Combiner Rule #145: combine_minmax_nan; wip_match_opcode 'G_FMINNUM'
     /* 6191 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 6194 */ // Label 401: @6194
     /* 6194 */ GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(6205), // Rule ID 300 //
     /* 6199 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 6202 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FMINNUM'
     /* 6202 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6205 */ // Label 402: @6205
     /* 6205 */ GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(6216), // Rule ID 330 //
     /* 6210 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6213 */   // Combiner Rule #190: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM'
     /* 6213 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6216 */ // Label 403: @6216
     /* 6216 */ GIM_Reject,
     /* 6217 */ // Label 80: @6217
     /* 6217 */ GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(6228), // Rule ID 193 //
     /* 6222 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 6225 */   // Combiner Rule #145: combine_minmax_nan; wip_match_opcode 'G_FMAXNUM'
     /* 6225 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 6228 */ // Label 404: @6228
     /* 6228 */ GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(6239), // Rule ID 301 //
     /* 6233 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 6236 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FMAXNUM'
     /* 6236 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6239 */ // Label 405: @6239
     /* 6239 */ GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(6250), // Rule ID 331 //
     /* 6244 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6247 */   // Combiner Rule #190: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM'
     /* 6247 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6250 */ // Label 406: @6250
     /* 6250 */ GIM_Reject,
     /* 6251 */ // Label 81: @6251
     /* 6251 */ GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(6262), // Rule ID 332 //
     /* 6256 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6259 */   // Combiner Rule #190: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM_IEEE'
     /* 6259 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6262 */ // Label 407: @6262
     /* 6262 */ GIM_Reject,
     /* 6263 */ // Label 82: @6263
     /* 6263 */ GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(6274), // Rule ID 333 //
     /* 6268 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6271 */   // Combiner Rule #190: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM_IEEE'
     /* 6271 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6274 */ // Label 408: @6274
     /* 6274 */ GIM_Reject,
     /* 6275 */ // Label 83: @6275
     /* 6275 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(6286), // Rule ID 194 //
     /* 6280 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 6283 */   // Combiner Rule #145: combine_minmax_nan; wip_match_opcode 'G_FMINIMUM'
     /* 6283 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 6286 */ // Label 409: @6286
     /* 6286 */ GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(6297), // Rule ID 302 //
     /* 6291 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 6294 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FMINIMUM'
     /* 6294 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6297 */ // Label 410: @6297
     /* 6297 */ GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(6308), // Rule ID 334 //
     /* 6302 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6305 */   // Combiner Rule #190: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINIMUM'
     /* 6305 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6308 */ // Label 411: @6308
     /* 6308 */ GIM_Reject,
     /* 6309 */ // Label 84: @6309
     /* 6309 */ GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(6320), // Rule ID 195 //
     /* 6314 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 6317 */   // Combiner Rule #145: combine_minmax_nan; wip_match_opcode 'G_FMAXIMUM'
     /* 6317 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 6320 */ // Label 412: @6320
     /* 6320 */ GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(6331), // Rule ID 303 //
     /* 6325 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 6328 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FMAXIMUM'
     /* 6328 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6331 */ // Label 413: @6331
     /* 6331 */ GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(6342), // Rule ID 335 //
     /* 6336 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6339 */   // Combiner Rule #190: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXIMUM'
     /* 6339 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6342 */ // Label 414: @6342
     /* 6342 */ GIM_Reject,
     /* 6343 */ // Label 85: @6343
     /* 6343 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(6354), // Rule ID 147 //
     /* 6348 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 6351 */   // Combiner Rule #105: reassoc_ptradd; wip_match_opcode 'G_PTR_ADD'
     /* 6351 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 6354 */ // Label 415: @6354
     /* 6354 */ GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(6365), // Rule ID 149 //
     /* 6359 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule107Enabled),
     /* 6362 */   // Combiner Rule #107: ptr_add_immed_chain; wip_match_opcode 'G_PTR_ADD'
     /* 6362 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 6365 */ // Label 416: @6365
     /* 6365 */ GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(6376), // Rule ID 182 //
     /* 6370 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule140Enabled),
     /* 6373 */   // Combiner Rule #140: const_ptradd_to_i2p; wip_match_opcode 'G_PTR_ADD'
     /* 6373 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner82),
     /* 6376 */ // Label 417: @6376
     /* 6376 */ GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(6387), // Rule ID 198 //
     /* 6381 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 6384 */   // Combiner Rule #148: ptr_add_with_zero; wip_match_opcode 'G_PTR_ADD'
     /* 6384 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner90),
     /* 6387 */ // Label 418: @6387
     /* 6387 */ GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(6398), // Rule ID 231 //
     /* 6392 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 6395 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_PTR_ADD'
     /* 6395 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6398 */ // Label 419: @6398
     /* 6398 */ GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(6409), // Rule ID 280 //
     /* 6403 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 6406 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_PTR_ADD'
     /* 6406 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6409 */ // Label 420: @6409
     /* 6409 */ GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(6432), // Rule ID 110 //
     /* 6414 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 6417 */   // MIs[0] dst
     /* 6417 */   // No operand predicates
     /* 6417 */   // MIs[0] lhs
     /* 6417 */   // No operand predicates
     /* 6417 */   // MIs[0] Operand 2
     /* 6417 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 6421 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6426 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[7]]
     /* 6426 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6431 */   GIR_EraseRootFromParent_Done,
     /* 6432 */ // Label 421: @6432
     /* 6432 */ GIM_Reject,
     /* 6433 */ // Label 86: @6433
     /* 6433 */ GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(6444), // Rule ID 244 //
     /* 6438 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 6441 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_SMIN'
     /* 6441 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6444 */ // Label 422: @6444
     /* 6444 */ GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(6455), // Rule ID 291 //
     /* 6449 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 6452 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_SMIN'
     /* 6452 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6455 */ // Label 423: @6455
     /* 6455 */ GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(6466), // Rule ID 312 //
     /* 6460 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 6463 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_SMIN'
     /* 6463 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 6466 */ // Label 424: @6466
     /* 6466 */ GIM_Reject,
     /* 6467 */ // Label 87: @6467
     /* 6467 */ GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(6478), // Rule ID 245 //
     /* 6472 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 6475 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_SMAX'
     /* 6475 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6478 */ // Label 425: @6478
     /* 6478 */ GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(6489), // Rule ID 292 //
     /* 6483 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 6486 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_SMAX'
     /* 6486 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6489 */ // Label 426: @6489
     /* 6489 */ GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(6500), // Rule ID 313 //
     /* 6494 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 6497 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_SMAX'
     /* 6497 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 6500 */ // Label 427: @6500
     /* 6500 */ GIM_Reject,
     /* 6501 */ // Label 88: @6501
     /* 6501 */ GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(6512), // Rule ID 246 //
     /* 6506 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 6509 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_UMIN'
     /* 6509 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6512 */ // Label 428: @6512
     /* 6512 */ GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(6523), // Rule ID 293 //
     /* 6517 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 6520 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_UMIN'
     /* 6520 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6523 */ // Label 429: @6523
     /* 6523 */ GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(6534), // Rule ID 314 //
     /* 6528 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 6531 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_UMIN'
     /* 6531 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 6534 */ // Label 430: @6534
     /* 6534 */ GIM_Reject,
     /* 6535 */ // Label 89: @6535
     /* 6535 */ GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(6546), // Rule ID 247 //
     /* 6540 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 6543 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_UMAX'
     /* 6543 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6546 */ // Label 431: @6546
     /* 6546 */ GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(6557), // Rule ID 294 //
     /* 6551 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 6554 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_UMAX'
     /* 6554 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6557 */ // Label 432: @6557
     /* 6557 */ GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(6568), // Rule ID 315 //
     /* 6562 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 6565 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_UMAX'
     /* 6565 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 6568 */ // Label 433: @6568
     /* 6568 */ GIM_Reject,
     /* 6569 */ // Label 90: @6569
     /* 6569 */ GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(6580), // Rule ID 85 //
     /* 6574 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 6577 */   // Combiner Rule #75: unary_undef_to_zero; wip_match_opcode 'G_ABS'
     /* 6577 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 6580 */ // Label 434: @6580
     /* 6580 */ GIM_Reject,
     /* 6581 */ // Label 91: @6581
     /* 6581 */ GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(6592), // Rule ID 174 //
     /* 6586 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule132Enabled),
     /* 6589 */   // Combiner Rule #132: opt_brcond_by_inverting_cond; wip_match_opcode 'G_BR'
     /* 6589 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner79),
     /* 6592 */ // Label 435: @6592
     /* 6592 */ GIM_Reject,
     /* 6593 */ // Label 92: @6593
     /* 6593 */ GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(6604), // Rule ID 26 //
     /* 6598 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 6601 */   // Combiner Rule #24: insert_vector_elt_oob; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6601 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner10),
     /* 6604 */ // Label 436: @6604
     /* 6604 */ GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(6615), // Rule ID 66 //
     /* 6609 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule64Enabled),
     /* 6612 */   // Combiner Rule #64: combine_insert_vec_elts_build_vector; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6612 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner26),
     /* 6615 */ // Label 437: @6615
     /* 6615 */ GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(6626), // Rule ID 100 //
     /* 6620 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 6623 */   // Combiner Rule #81: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6623 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 6626 */ // Label 438: @6626
     /* 6626 */ GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(6665), // Rule ID 38 //
     /* 6631 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule36Enabled),
     /* 6634 */   // MIs[0] root
     /* 6634 */   // No operand predicates
     /* 6634 */   // MIs[0] src
     /* 6634 */   // No operand predicates
     /* 6634 */   // MIs[0] elt
     /* 6634 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6638 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 6642 */   // MIs[1] src
     /* 6642 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 6647 */   // MIs[1] idx
     /* 6647 */   // No operand predicates
     /* 6647 */   // MIs[0] idx
     /* 6647 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 6652 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6657 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6659 */   // Combiner Rule #36: insert_vector_element_extract_vector_element
     /* 6659 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6664 */   GIR_EraseRootFromParent_Done,
     /* 6665 */ // Label 439: @6665
     /* 6665 */ GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(6698), // Rule ID 24 //
     /* 6670 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule22Enabled),
     /* 6673 */   // MIs[0] root
     /* 6673 */   // No operand predicates
     /* 6673 */   // MIs[0] src
     /* 6673 */   // No operand predicates
     /* 6673 */   // MIs[0] elt
     /* 6673 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6677 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6681 */   // MIs[0] idx
     /* 6681 */   // No operand predicates
     /* 6681 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner0),
     /* 6685 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6690 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6692 */   // Combiner Rule #22: insert_vector_element_elt_undef
     /* 6692 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6697 */   GIR_EraseRootFromParent_Done,
     /* 6698 */ // Label 440: @6698
     /* 6698 */ GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(6722), // Rule ID 23 //
     /* 6703 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule21Enabled),
     /* 6706 */   // MIs[0] root
     /* 6706 */   // No operand predicates
     /* 6706 */   // MIs[0] src
     /* 6706 */   // No operand predicates
     /* 6706 */   // MIs[0] elt
     /* 6706 */   // No operand predicates
     /* 6706 */   // MIs[0] idx
     /* 6706 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 6710 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6714 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6716 */   // Combiner Rule #21: insert_vector_element_idx_undef
     /* 6716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6719 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 6721 */   GIR_EraseRootFromParent_Done,
     /* 6722 */ // Label 441: @6722
     /* 6722 */ GIM_Reject,
     /* 6723 */ // Label 93: @6723
     /* 6723 */ GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(6734), // Rule ID 25 //
     /* 6728 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 6731 */   // Combiner Rule #23: match_extract_of_element; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6731 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 6734 */ // Label 442: @6734
     /* 6734 */ GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(6745), // Rule ID 67 //
     /* 6739 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule65Enabled),
     /* 6742 */   // Combiner Rule #65: extract_vec_elt_build_vec; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6742 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner27),
     /* 6745 */ // Label 443: @6745
     /* 6745 */ GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(6756), // Rule ID 73 //
     /* 6750 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule69Enabled),
     /* 6753 */   // Combiner Rule #69: combine_extracted_vector_load; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6753 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner31),
     /* 6756 */ // Label 444: @6756
     /* 6756 */ GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(6767), // Rule ID 101 //
     /* 6761 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 6764 */   // Combiner Rule #81: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6764 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 6767 */ // Label 445: @6767
     /* 6767 */ GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(6791), // Rule ID 36 //
     /* 6772 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule34Enabled),
     /* 6775 */   // MIs[0] root
     /* 6775 */   // No operand predicates
     /* 6775 */   // MIs[0] src
     /* 6775 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6779 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6783 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/9,
     /* 6786 */   // MIs[1] x
     /* 6786 */   // No operand predicates
     /* 6786 */   // MIs[1] y
     /* 6786 */   // No operand predicates
     /* 6786 */   // MIs[1] z
     /* 6786 */   // No operand predicates
     /* 6786 */   // MIs[1] a
     /* 6786 */   // No operand predicates
     /* 6786 */   // MIs[1] b
     /* 6786 */   // No operand predicates
     /* 6786 */   // MIs[1] c
     /* 6786 */   // No operand predicates
     /* 6786 */   // MIs[1] d
     /* 6786 */   // No operand predicates
     /* 6786 */   // MIs[1] e
     /* 6786 */   // No operand predicates
     /* 6786 */   // MIs[0] idx
     /* 6786 */   // No operand predicates
     /* 6786 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6788 */   // Combiner Rule #34: extract_vector_element_build_vector_trunc8
     /* 6788 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6791 */ // Label 446: @6791
     /* 6791 */ GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(6815), // Rule ID 35 //
     /* 6796 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule33Enabled),
     /* 6799 */   // MIs[0] root
     /* 6799 */   // No operand predicates
     /* 6799 */   // MIs[0] src
     /* 6799 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6803 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6807 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/8,
     /* 6810 */   // MIs[1] x
     /* 6810 */   // No operand predicates
     /* 6810 */   // MIs[1] y
     /* 6810 */   // No operand predicates
     /* 6810 */   // MIs[1] z
     /* 6810 */   // No operand predicates
     /* 6810 */   // MIs[1] a
     /* 6810 */   // No operand predicates
     /* 6810 */   // MIs[1] b
     /* 6810 */   // No operand predicates
     /* 6810 */   // MIs[1] c
     /* 6810 */   // No operand predicates
     /* 6810 */   // MIs[1] d
     /* 6810 */   // No operand predicates
     /* 6810 */   // MIs[0] idx
     /* 6810 */   // No operand predicates
     /* 6810 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6812 */   // Combiner Rule #33: extract_vector_element_build_vector_trunc7
     /* 6812 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6815 */ // Label 447: @6815
     /* 6815 */ GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(6839), // Rule ID 34 //
     /* 6820 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule32Enabled),
     /* 6823 */   // MIs[0] root
     /* 6823 */   // No operand predicates
     /* 6823 */   // MIs[0] src
     /* 6823 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6827 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6831 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/7,
     /* 6834 */   // MIs[1] x
     /* 6834 */   // No operand predicates
     /* 6834 */   // MIs[1] y
     /* 6834 */   // No operand predicates
     /* 6834 */   // MIs[1] z
     /* 6834 */   // No operand predicates
     /* 6834 */   // MIs[1] a
     /* 6834 */   // No operand predicates
     /* 6834 */   // MIs[1] b
     /* 6834 */   // No operand predicates
     /* 6834 */   // MIs[1] c
     /* 6834 */   // No operand predicates
     /* 6834 */   // MIs[0] idx
     /* 6834 */   // No operand predicates
     /* 6834 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6836 */   // Combiner Rule #32: extract_vector_element_build_vector_trunc6
     /* 6836 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6839 */ // Label 448: @6839
     /* 6839 */ GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(6863), // Rule ID 33 //
     /* 6844 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule31Enabled),
     /* 6847 */   // MIs[0] root
     /* 6847 */   // No operand predicates
     /* 6847 */   // MIs[0] src
     /* 6847 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6851 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6855 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/6,
     /* 6858 */   // MIs[1] x
     /* 6858 */   // No operand predicates
     /* 6858 */   // MIs[1] y
     /* 6858 */   // No operand predicates
     /* 6858 */   // MIs[1] z
     /* 6858 */   // No operand predicates
     /* 6858 */   // MIs[1] a
     /* 6858 */   // No operand predicates
     /* 6858 */   // MIs[1] b
     /* 6858 */   // No operand predicates
     /* 6858 */   // MIs[0] idx
     /* 6858 */   // No operand predicates
     /* 6858 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6860 */   // Combiner Rule #31: extract_vector_element_build_vector_trunc5
     /* 6860 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6863 */ // Label 449: @6863
     /* 6863 */ GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(6887), // Rule ID 32 //
     /* 6868 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule30Enabled),
     /* 6871 */   // MIs[0] root
     /* 6871 */   // No operand predicates
     /* 6871 */   // MIs[0] src
     /* 6871 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6875 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6879 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 6882 */   // MIs[1] x
     /* 6882 */   // No operand predicates
     /* 6882 */   // MIs[1] y
     /* 6882 */   // No operand predicates
     /* 6882 */   // MIs[1] z
     /* 6882 */   // No operand predicates
     /* 6882 */   // MIs[1] a
     /* 6882 */   // No operand predicates
     /* 6882 */   // MIs[0] idx
     /* 6882 */   // No operand predicates
     /* 6882 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6884 */   // Combiner Rule #30: extract_vector_element_build_vector_trunc4
     /* 6884 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6887 */ // Label 450: @6887
     /* 6887 */ GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(6911), // Rule ID 31 //
     /* 6892 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule29Enabled),
     /* 6895 */   // MIs[0] root
     /* 6895 */   // No operand predicates
     /* 6895 */   // MIs[0] src
     /* 6895 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6899 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6903 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 6906 */   // MIs[1] x
     /* 6906 */   // No operand predicates
     /* 6906 */   // MIs[1] y
     /* 6906 */   // No operand predicates
     /* 6906 */   // MIs[1] z
     /* 6906 */   // No operand predicates
     /* 6906 */   // MIs[0] idx
     /* 6906 */   // No operand predicates
     /* 6906 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6908 */   // Combiner Rule #29: extract_vector_element_build_vector_trunc3
     /* 6908 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6911 */ // Label 451: @6911
     /* 6911 */ GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(6945), // Rule ID 27 //
     /* 6916 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 6919 */   // MIs[0] root
     /* 6919 */   // No operand predicates
     /* 6919 */   // MIs[0] src
     /* 6919 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6923 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 6927 */   // MIs[1] x
     /* 6927 */   // No operand predicates
     /* 6927 */   // MIs[1] value
     /* 6927 */   // No operand predicates
     /* 6927 */   // MIs[1] idx
     /* 6927 */   // No operand predicates
     /* 6927 */   // MIs[0] idx
     /* 6927 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/3,
     /* 6932 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 6937 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6939 */   // Combiner Rule #25: extract_vector_element_not_const
     /* 6939 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 6944 */   GIR_EraseRootFromParent_Done,
     /* 6945 */ // Label 452: @6945
     /* 6945 */ GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(6966), // Rule ID 28 //
     /* 6950 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule26Enabled),
     /* 6953 */   // MIs[0] root
     /* 6953 */   // No operand predicates
     /* 6953 */   // MIs[0] src
     /* 6953 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6957 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 6961 */   // MIs[1] x
     /* 6961 */   // No operand predicates
     /* 6961 */   // MIs[1] value
     /* 6961 */   // No operand predicates
     /* 6961 */   // MIs[1] idx2
     /* 6961 */   // No operand predicates
     /* 6961 */   // MIs[0] idx1
     /* 6961 */   // No operand predicates
     /* 6961 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6963 */   // Combiner Rule #26: extract_vector_element_different_indices
     /* 6963 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 6966 */ // Label 453: @6966
     /* 6966 */ GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(6995), // Rule ID 37 //
     /* 6971 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule35Enabled),
     /* 6974 */   // MIs[0] root
     /* 6974 */   // No operand predicates
     /* 6974 */   // MIs[0] src
     /* 6974 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6978 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHUFFLE_VECTOR),
     /* 6982 */   // MIs[1] src1
     /* 6982 */   // No operand predicates
     /* 6982 */   // MIs[1] src2
     /* 6982 */   // No operand predicates
     /* 6982 */   // MIs[1] mask
     /* 6982 */   // No operand predicates
     /* 6982 */   // MIs[0] idx
     /* 6982 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 6986 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 6990 */   // MIs[2] imm
     /* 6990 */   // No operand predicates
     /* 6990 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 6992 */   // Combiner Rule #35: extract_vector_element_shuffle_vector
     /* 6992 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 6995 */ // Label 454: @6995
     /* 6995 */ GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(7019), // Rule ID 30 //
     /* 7000 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule28Enabled),
     /* 7003 */   // MIs[0] root
     /* 7003 */   // No operand predicates
     /* 7003 */   // MIs[0] src
     /* 7003 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7007 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 7011 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 7014 */   // MIs[1] x
     /* 7014 */   // No operand predicates
     /* 7014 */   // MIs[1] y
     /* 7014 */   // No operand predicates
     /* 7014 */   // MIs[0] idx
     /* 7014 */   // No operand predicates
     /* 7014 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7016 */   // Combiner Rule #28: extract_vector_element_build_vector_trunc2
     /* 7016 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 7019 */ // Label 455: @7019
     /* 7019 */ GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(7051), // Rule ID 29 //
     /* 7024 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule27Enabled),
     /* 7027 */   // MIs[0] root
     /* 7027 */   // No operand predicates
     /* 7027 */   // MIs[0] src
     /* 7027 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7031 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 7035 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 7038 */   // MIs[1] unused
     /* 7038 */   // No operand predicates
     /* 7038 */   // MIs[0] idx
     /* 7038 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 7042 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 7046 */   // MIs[2] imm
     /* 7046 */   // No operand predicates
     /* 7046 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 7048 */   // Combiner Rule #27: extract_vector_element_build_vector
     /* 7048 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 7051 */ // Label 456: @7051
     /* 7051 */ GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(7075), // Rule ID 21 //
     /* 7056 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 7059 */   // MIs[0] root
     /* 7059 */   // No operand predicates
     /* 7059 */   // MIs[0] vector
     /* 7059 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7063 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7067 */   // MIs[0] idx
     /* 7067 */   // No operand predicates
     /* 7067 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7069 */   // Combiner Rule #19: match_extract_of_element_undef_vector
     /* 7069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7072 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 7074 */   GIR_EraseRootFromParent_Done,
     /* 7075 */ // Label 457: @7075
     /* 7075 */ GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(7099), // Rule ID 22 //
     /* 7080 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule20Enabled),
     /* 7083 */   // MIs[0] root
     /* 7083 */   // No operand predicates
     /* 7083 */   // MIs[0] vector
     /* 7083 */   // No operand predicates
     /* 7083 */   // MIs[0] idx
     /* 7083 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 7087 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7091 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7093 */   // Combiner Rule #20: match_extract_of_element_undef_index
     /* 7093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7096 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 7098 */   GIR_EraseRootFromParent_Done,
     /* 7099 */ // Label 458: @7099
     /* 7099 */ GIM_Reject,
     /* 7100 */ // Label 94: @7100
     /* 7100 */ GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(7111), // Rule ID 96 //
     /* 7105 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 7108 */   // Combiner Rule #78: propagate_undef_all_ops; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7108 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 7111 */ // Label 459: @7111
     /* 7111 */ GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(7122), // Rule ID 98 //
     /* 7116 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 7119 */   // Combiner Rule #79: propagate_undef_shuffle_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7119 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 7122 */ // Label 460: @7122
     /* 7122 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(7133), // Rule ID 343 //
     /* 7127 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule198Enabled),
     /* 7130 */   // Combiner Rule #198: combine_shuffle_concat; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7130 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner135),
     /* 7133 */ // Label 461: @7133
     /* 7133 */ GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(7144), // Rule ID 345 //
     /* 7138 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule200Enabled),
     /* 7141 */   // Combiner Rule #200: combine_shuffle_disjoint_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7141 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner137),
     /* 7144 */ // Label 462: @7144
     /* 7144 */ GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(7155), // Rule ID 363 //
     /* 7149 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule216Enabled),
     /* 7152 */   // Combiner Rule #216: shuffle_to_extract; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7152 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner153),
     /* 7155 */ // Label 463: @7155
     /* 7155 */ GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(7176), // Rule ID 344 //
     /* 7160 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule199Enabled),
     /* 7163 */   // MIs[0] root
     /* 7163 */   // No operand predicates
     /* 7163 */   // MIs[0] src1
     /* 7163 */   // No operand predicates
     /* 7163 */   // MIs[0] undef
     /* 7163 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 7167 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7171 */   // MIs[0] mask
     /* 7171 */   // No operand predicates
     /* 7171 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7173 */   // Combiner Rule #199: combine_shuffle_undef_rhs
     /* 7173 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner136),
     /* 7176 */ // Label 464: @7176
     /* 7176 */ GIM_Reject,
     /* 7177 */ // Label 95: @7177
     /* 7177 */ GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(7221), // Rule ID 222 //
     /* 7182 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule159Enabled),
     /* 7185 */   // MIs[0] d
     /* 7185 */   // No operand predicates
     /* 7185 */   // MIs[0] src
     /* 7185 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7189 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 7193 */   // MIs[1] rev
     /* 7193 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 7197 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 7201 */   // MIs[2] val
     /* 7201 */   // No operand predicates
     /* 7201 */   // MIs[1] amt
     /* 7201 */   // No operand predicates
     /* 7201 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner9),
     /* 7205 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 7207 */   // Combiner Rule #159: bitreverse_lshr
     /* 7207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SHL),
     /* 7210 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 7212 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 7216 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 7220 */   GIR_EraseRootFromParent_Done,
     /* 7221 */ // Label 465: @7221
     /* 7221 */ GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(7265), // Rule ID 221 //
     /* 7226 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule158Enabled),
     /* 7229 */   // MIs[0] d
     /* 7229 */   // No operand predicates
     /* 7229 */   // MIs[0] src
     /* 7229 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7233 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 7237 */   // MIs[1] rev
     /* 7237 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 7241 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 7245 */   // MIs[2] val
     /* 7245 */   // No operand predicates
     /* 7245 */   // MIs[1] amt
     /* 7245 */   // No operand predicates
     /* 7245 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner8),
     /* 7249 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 7251 */   // Combiner Rule #158: bitreverse_shl
     /* 7251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 7254 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 7256 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 7260 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 7264 */   GIR_EraseRootFromParent_Done,
     /* 7265 */ // Label 466: @7265
     /* 7265 */ GIM_Reject,
     /* 7266 */ // Label 96: @7266
     /* 7266 */ GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(7287), // Rule ID 177 //
     /* 7271 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule135Enabled),
     /* 7274 */   // MIs[0] dst
     /* 7274 */   // No operand predicates
     /* 7274 */   // MIs[0] src0
     /* 7274 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7278 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 7282 */   // MIs[1] cst
     /* 7282 */   // No operand predicates
     /* 7282 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7284 */   // Combiner Rule #135: constant_fold_fsqrt
     /* 7284 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 7287 */ // Label 467: @7287
     /* 7287 */ GIM_Reject,
     /* 7288 */ // Label 97: @7288
     /* 7288 */ GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(7302), // Rule ID 364 //
     /* 7293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 7296 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule217Enabled),
     /* 7299 */   // Combiner Rule #217: ext_addv_to_udot_addv; wip_match_opcode 'G_VECREDUCE_ADD'
     /* 7299 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner154),
     /* 7302 */ // Label 468: @7302
     /* 7302 */ GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(7313), // Rule ID 365 //
     /* 7307 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule218Enabled),
     /* 7310 */   // Combiner Rule #218: ext_uaddv_to_uaddlv; wip_match_opcode 'G_VECREDUCE_ADD'
     /* 7310 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner155),
     /* 7313 */ // Label 469: @7313
     /* 7313 */ GIM_Reject,
     /* 7314 */ // Label 98: @7314
     /* 7314 */ GIM_Reject,
     /* 7315 */ }; // Size: 7315 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GICOMBINER_IMPL

#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS

