/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* AMDGPUPreLegalizerCombinerImpl Combiner Match Table                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GICOMBINER_DEPS
#include "llvm/ADT/SparseBitVector.h"
namespace llvm {
extern cl::OptionCategory GICombinerOptionCategory;
} // end namespace llvm
#endif // ifdef GET_GICOMBINER_DEPS

#ifdef GET_GICOMBINER_TYPES
struct AMDGPUPreLegalizerCombinerImplRuleConfig {
  SparseBitVector<> DisabledRules;

  bool isRuleEnabled(unsigned RuleID) const;
  bool parseCommandLineOption();
  bool setRuleEnabled(StringRef RuleIdentifier);
  bool setRuleDisabled(StringRef RuleIdentifier);
};

static std::optional<uint64_t> getRuleIdxForIdentifier(StringRef RuleIdentifier) {
  uint64_t I;
  // getAtInteger(...) returns false on success
  bool Parsed = !RuleIdentifier.getAsInteger(0, I);
  if (Parsed)
    return I;

#ifndef NDEBUG
  switch (RuleIdentifier.size()) {
  default: break;
  case 9:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "opy_prop", 8) != 0)
        break;
      return 13;	 // "copy_prop"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ors", 7) != 0)
          break;
        return 192;	 // "match_ors"
      case 'u':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "lo_by_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case '0':	 // 1 string to match.
          return 143;	 // "mulo_by_0"
        case '2':	 // 1 string to match.
          return 142;	 // "mulo_by_2"
        }
        break;
      }
      break;
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "neg_zext", 8) != 0)
        break;
      return 197;	 // "nneg_zext"
    }
    break;
  case 10:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2p_to_p2i", 9) != 0)
        break;
      return 88;	 // "i2p_to_p2i"
    case 'm':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ands", 8) != 0)
          break;
        return 191;	 // "match_ands"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_to_shl", 8) != 0)
          break;
        return 14;	 // "mul_to_shl"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2i_to_i2p", 9) != 0)
        break;
      return 87;	 // "p2i_to_i2p"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_trunc", 8) != 0)
          break;
        return 195;	 // "sext_trunc"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_to_add", 8) != 0)
          break;
        return 15;	 // "sub_to_add"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc", 9) != 0)
        break;
      return 196;	 // "zext_trunc"
    }
    break;
  case 11:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_sub_reg", 10) != 0)
        break;
      return 93;	 // "add_sub_reg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_addos", 10) != 0)
        break;
      return 211;	 // "match_addos"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ub_add_reg", 10) != 0)
        break;
      return 186;	 // "sub_add_reg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_shift", 10) != 0)
        break;
      return 130;	 // "trunc_shift"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_cst", 10) != 0)
        break;
      return 205;	 // "unmerge_cst"
    }
    break;
  case 12:	 // 11 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinusB", 11) != 0)
        break;
      return 2;	 // "APlusBMinusB"
    case 'B':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusAPlusA", 11) != 0)
        break;
      return 3;	 // "BMinusAPlusA"
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dde_to_addo", 11) != 0)
        break;
      return 144;	 // "adde_to_addo"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "sub_to_fneg", 11) != 0)
        break;
      return 188;	 // "fsub_to_fneg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ulh_to_lshr", 11) != 0)
        break;
      return 174;	 // "mulh_to_lshr"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ot_cmp_fold", 11) != 0)
        break;
      return 131;	 // "not_cmp_fold"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_or", 11) != 0)
        break;
      return 126;	 // "redundant_or"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_pow2", 10) != 0)
          break;
        return 172;	 // "sdiv_by_pow2"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_of_sext", 10) != 0)
          break;
        return 48;	 // "sext_of_sext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "div_by_pow2", 11) != 0)
        break;
      return 173;	 // "udiv_by_pow2"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_zext", 11) != 0)
        break;
      return 46;	 // "zext_of_zext"
    }
    break;
  case 13:	 // 14 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_of_vscale", 12) != 0)
        break;
      return 37;	 // "add_of_vscale"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_shift", 12) != 0)
        break;
      return 160;	 // "commute_shift"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oldable_fneg", 12) != 0)
        break;
      return 215;	 // "foldable_fneg"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_and_mask", 12) != 0)
        break;
      return 68;	 // "load_and_mask"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_selects", 11) != 0)
          break;
        return 123;	 // "match_selects"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "rge_unmerge", 11) != 0)
          break;
        return 204;	 // "merge_unmerge"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 38;	 // "mul_of_vscale"
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_and", 12) != 0)
        break;
      return 124;	 // "redundant_and"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 171;	 // "sdiv_by_const"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 39;	 // "shl_of_vscale"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_of_vscale", 11) != 0)
          break;
        return 40;	 // "sub_of_vscale"
      }
      break;
    case 'u':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 170;	 // "udiv_by_const"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "merge_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case 'm':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "erge", 4) != 0)
            break;
          return 203;	 // "unmerge_merge"
        case 'u':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "ndef", 4) != 0)
            break;
          return 206;	 // "unmerge_undef"
        }
        break;
      }
      break;
    }
    break;
  case 14:	 // 15 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1PlusC2", 12) != 0)
          break;
        return 12;	 // "AMinusC1PlusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusC1MinusC2", 12) != 0)
          break;
        return 8;	 // "APlusC1MinusC2"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2MinusAPlusC1", 13) != 0)
        break;
      return 9;	 // "C2MinusAPlusC1"
    case 'a':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_", 9) != 0)
        break;
      switch (RuleIdentifier[10]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 52;	 // "anyext_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 51;	 // "anyext_of_zext"
      }
      break;
    case 'b':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'i')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "op_same_val", 11) != 0)
          break;
        return 84;	 // "binop_same_val"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "reverse_shl", 11) != 0)
          break;
        return 158;	 // "bitreverse_shl"
      }
      break;
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "bs_fneg_fold", 12) != 0)
          break;
        return 169;	 // "fabs_fneg_fold"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "eg_fneg_fold", 12) != 0)
          break;
        return 90;	 // "fneg_fneg_fold"
      }
      break;
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ul_by_neg_one", 13) != 0)
        break;
      return 17;	 // "mul_by_neg_one"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eassoc_ptradd", 13) != 0)
        break;
      return 105;	 // "reassoc_ptradd"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 2 strings to match.
        switch (RuleIdentifier[2]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "ect_of_zext", 11) != 0)
            break;
          return 53;	 // "select_of_zext"
        case 'x':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "t_of_anyext", 11) != 0)
            break;
          return 49;	 // "sext_of_anyext"
        }
        break;
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ifts_too_big", 12) != 0)
          break;
        return 104;	 // "shifts_too_big"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_anyext", 13) != 0)
        break;
      return 47;	 // "zext_of_anyext"
    }
    break;
  case 15:	 // 12 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1MinusC2", 13) != 0)
          break;
        return 10;	 // "AMinusC1MinusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusZeroMinusB", 13) != 0)
          break;
        return 1;	 // "APlusZeroMinusB"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "1Minus2MinusC2", 14) != 0)
        break;
      return 11;	 // "C1Minus2MinusC2"
    case 'Z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eroMinusAPlusB", 14) != 0)
        break;
      return 0;	 // "ZeroMinusAPlusB"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itreverse_lshr", 14) != 0)
        break;
      return 159;	 // "bitreverse_lshr"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtending_loads", 14) != 0)
        break;
      return 67;	 // "extending_loads"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dempotent_prop", 14) != 0)
        break;
      return 18;	 // "idempotent_prop"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_or_combine", 14) != 0)
        break;
      return 151;	 // "load_or_combine"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_or", 14) != 0)
        break;
      return 61;	 // "narrow_binop_or"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "verlapping_and", 14) != 0)
        break;
      return 141;	 // "overlapping_and"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_same_val", 14) != 0)
        break;
      return 82;	 // "select_same_val"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc_fold", 14) != 0)
        break;
      return 128;	 // "zext_trunc_fold"
    }
    break;
  case 16:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_anyext", 15) != 0)
        break;
      return 50;	 // "anyext_of_anyext"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "lamp_i64_to_i16", 15) != 0)
        break;
      return 214;	 // "clamp_i64_to_i16"
    case 'n':	 // 5 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_", 12) != 0)
        break;
      switch (RuleIdentifier[13]) {
      default: break;
      case 'a':	 // 2 strings to match.
        switch (RuleIdentifier[14]) {
        default: break;
        case 'd':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 57;	 // "narrow_binop_add"
        case 'n':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 60;	 // "narrow_binop_and"
        }
        break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ul", 2) != 0)
          break;
        return 59;	 // "narrow_binop_mul"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ub", 2) != 0)
          break;
        return 58;	 // "narrow_binop_sub"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "or", 2) != 0)
          break;
        return 62;	 // "narrow_binop_xor"
      }
      break;
    case 's':	 // 3 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_", 6) != 0)
        break;
      switch (RuleIdentifier[7]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "f_anyext", 8) != 0)
          break;
        return 54;	 // "select_of_anyext"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "o_minmax", 8) != 0)
          break;
        return 187;	 // "select_to_minmax"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "ndef_cmp", 8) != 0)
          break;
        return 120;	 // "select_undef_cmp"
      }
      break;
    case 't':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_", 11) != 0)
        break;
      switch (RuleIdentifier[12]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 44;	 // "truncate_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 43;	 // "truncate_of_zext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ndef_to_fp_zero", 15) != 0)
        break;
      return 70;	 // "undef_to_fp_zero"
    }
    break;
  case 17:	 // 14 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'A':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "plusC", 5) != 0)
          break;
        return 6;	 // "APlusBMinusAplusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "PlusA", 5) != 0)
          break;
        return 7;	 // "APlusBMinusCPlusA"
      }
      break;
    case 'a':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "d_p2i_to_ptradd", 15) != 0)
          break;
        return 16;	 // "add_p2i_to_ptradd"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "yext_trunc_fold", 15) != 0)
          break;
        return 89;	 // "anyext_trunc_fold"
      }
      break;
    case 'c':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nonicalize_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 109;	 // "canonicalize_fcmp"
        case 'i':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 108;	 // "canonicalize_icmp"
        }
        break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "nstant_fold_fma", 15) != 0)
          break;
        return 167;	 // "constant_fold_fma"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "iv_rem_to_divrem", 16) != 0)
        break;
      return 152;	 // "div_rem_to_divrem"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "rase_undef_store", 16) != 0)
        break;
      return 80;	 // "erase_undef_store"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_with_zero", 16) != 0)
        break;
      return 148;	 // "ptr_add_with_zero"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_to_iminmax", 15) != 0)
          break;
        return 122;	 // "select_to_iminmax"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ift_immed_chain", 15) != 0)
          break;
        return 149;	 // "shift_immed_chain"
      }
      break;
    case 'u':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "def_to_int_zero", 15) != 0)
          break;
        return 71;	 // "undef_to_int_zero"
      case 'r':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "em_pow2_to_mask", 15) != 0)
          break;
        return 127;	 // "urem_pow2_to_mask"
      }
      break;
    }
    break;
  case 18:	 // 11 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusBPlus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'B':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusC", 6) != 0)
          break;
        return 5;	 // "AMinusBPlusBMinusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusA", 6) != 0)
          break;
        return 4;	 // "AMinusBPlusCMinusA"
      }
      break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_to_zero", 17) != 0)
        break;
      return 85;	 // "binop_left_to_zero"
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_minmax_nan", 15) != 0)
          break;
        return 145;	 // "combine_minmax_nan"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_f", 12) != 0)
          break;
        switch (RuleIdentifier[15]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "bs", 2) != 0)
            break;
          return 134;	 // "constant_fold_fabs"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "eg", 2) != 0)
            break;
          return 133;	 // "constant_fold_fneg"
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xpand_const_fpowi", 17) != 0)
        break;
      return 146;	 // "expand_const_fpowi"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ptrunc_fpext_fold", 17) != 0)
        break;
      return 98;	 // "fptrunc_fpext_fold"
    case 's':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'e')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'l':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ect_of_truncate", 15) != 0)
          break;
        return 55;	 // "select_of_truncate"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "t_inreg_of_load", 15) != 0)
          break;
        return 117;	 // "sext_inreg_of_load"
      }
      break;
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_anyext", 17) != 0)
        break;
      return 45;	 // "truncate_of_anyext"
    }
    break;
  case 19:	 // 15 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_to_zero", 18) != 0)
        break;
      return 86;	 // "binop_right_to_zero"
    case 'c':	 // 4 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "onst", 4) != 0)
        break;
      switch (RuleIdentifier[5]) {
      default: break;
      case '_':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+6, "ptradd_to_i2p", 13) != 0)
          break;
        return 140;	 // "const_ptradd_to_i2p"
      case 'a':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "nt_fold_", 8) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'b':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "inop", 4) != 0)
            break;
          return 165;	 // "constant_fold_binop"
        case 'f':	 // 2 strings to match.
          switch (RuleIdentifier[15]) {
          default: break;
          case 'l':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "og2", 3) != 0)
              break;
            return 136;	 // "constant_fold_flog2"
          case 's':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "qrt", 3) != 0)
              break;
            return 135;	 // "constant_fold_fsqrt"
          }
          break;
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtend_through_phis", 18) != 0)
        break;
      return 101;	 // "extend_through_phis"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nteger_of_truncate", 18) != 0)
        break;
      return 63;	 // "integer_of_truncate"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_zero", 18) != 0)
        break;
      return 210;	 // "merge_of_x_and_zero"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_immed_chain", 18) != 0)
        break;
      return 107;	 // "ptr_add_immed_chain"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "assoc_comm_binops", 17) != 0)
          break;
        return 106;	 // "reassoc_comm_binops"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_zero", 17) != 0)
          break;
        return 83;	 // "right_identity_zero"
      }
      break;
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_constant_cmp", 17) != 0)
          break;
        return 121;	 // "select_constant_cmp"
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "mplify_", 7) != 0)
          break;
        switch (RuleIdentifier[9]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "dd_to_sub", 9) != 0)
            break;
          return 102;	 // "simplify_add_to_sub"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "eg_minmax", 9) != 0)
            break;
          return 193;	 // "simplify_neg_minmax"
        }
        break;
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nary_undef_to_zero", 18) != 0)
        break;
      return 75;	 // "unary_undef_to_zero"
    }
    break;
  case 20:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nd_or_disjoint_mask", 19) != 0)
        break;
      return 176;	 // "and_or_disjoint_mask"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itcast_bitcast_fold", 19) != 0)
        break;
      return 97;	 // "bitcast_bitcast_fold"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_undef", 19) != 0)
        break;
      return 209;	 // "merge_of_x_and_undef"
    case 'r':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "edu", 3) != 0)
        break;
      switch (RuleIdentifier[4]) {
      default: break;
      case 'c':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+5, "e_shl_of_extend", 15) != 0)
          break;
        return 118;	 // "reduce_shl_of_extend"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+5, "dant_sext_inreg", 15) != 0)
          break;
        return 125;	 // "redundant_sext_inreg"
      }
      break;
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ry_undef_to_undef", 17) != 0)
          break;
        return 76;	 // "unary_undef_to_undef"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_zext_to_zext", 17) != 0)
          break;
        return 208;	 // "unmerge_zext_to_zext"
      }
      break;
    }
    break;
  case 21:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_concat_vector", 18) != 0)
          break;
        return 194;	 // "combine_concat_vector"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_", 11) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'c':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ast_op", 6) != 0)
            break;
          return 168;	 // "constant_fold_cast_op"
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ptrunc", 6) != 0)
            break;
          return 137;	 // "constant_fold_fptrunc"
        }
        break;
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_vector_elt_oob", 20) != 0)
        break;
      return 24;	 // "insert_vector_elt_oob"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_fp", 20) != 0)
        break;
      return 92;	 // "right_identity_one_fp"
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ef_to_negative_one", 18) != 0)
          break;
        return 72;	 // "undef_to_negative_one"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_dead_to_trunc", 18) != 0)
          break;
        return 207;	 // "unmerge_dead_to_trunc"
      }
      break;
    }
    break;
  case 22:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_shuffle_concat", 19) != 0)
          break;
        return 198;	 // "combine_shuffle_concat"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_fp_binop", 19) != 0)
          break;
        return 166;	 // "constant_fold_fp_binop"
      }
      break;
    case 'f':	 // 4 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_binop_into_select", 20) != 0)
          break;
        return 185;	 // "fold_binop_into_select"
      case 'u':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nnel_shift_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "eft_zero", 8) != 0)
            break;
          return 156;	 // "funnel_shift_left_zero"
        case 'o':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "vershift", 8) != 0)
            break;
          return 157;	 // "funnel_shift_overshift"
        case 't':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "o_rotate", 8) != 0)
            break;
          return 154;	 // "funnel_shift_to_rotate"
        }
        break;
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_lhs_known_bits", 21) != 0)
        break;
      return 111;	 // "icmp_to_lhs_known_bits"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_subo_no_overflow", 21) != 0)
        break;
      return 212;	 // "match_subo_no_overflow"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_any_op", 21) != 0)
        break;
      return 77;	 // "propagate_undef_any_op"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "dundant_neg_operands", 20) != 0)
          break;
        return 175;	 // "redundant_neg_operands"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_one_int", 20) != 0)
          break;
        return 91;	 // "right_identity_one_int"
      }
      break;
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hl_ashr_to_sext_inreg", 21) != 0)
        break;
      return 115;	 // "shl_ashr_to_sext_inreg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_buildvector_fold", 21) != 0)
        break;
      return 95;	 // "trunc_buildvector_fold"
    }
    break;
  case 23:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "uildvector_of_truncate", 22) != 0)
        break;
      return 56;	 // "buildvector_of_truncate"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_right_zero", 22) != 0)
        break;
      return 155;	 // "funnel_shift_right_zero"
    case 'i':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "tof_const_zero_fold_", 20) != 0)
        break;
      switch (RuleIdentifier[21]) {
      default: break;
      case 's':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 138;	 // "itof_const_zero_fold_si"
      case 'u':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 139;	 // "itof_const_zero_fold_ui"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_all_ops", 22) != 0)
        break;
      return 78;	 // "propagate_undef_all_ops"
    }
    break;
  case 24:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_undef_to_zero", 23) != 0)
        break;
      return 73;	 // "binop_left_undef_to_zero"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element", 23) != 0)
        break;
      return 23;	 // "match_extract_of_element"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_feeding_and", 23) != 0)
        break;
      return 119;	 // "narrow_binop_feeding_and"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_inreg_to_zext_inreg", 23) != 0)
        break;
      return 129;	 // "sext_inreg_to_zext_inreg"
    case 'x':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "or_of_and_with_same_reg", 23) != 0)
        break;
      return 147;	 // "xor_of_and_with_same_reg"
    }
    break;
  case 25:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "tfield_extract_from_", 20) != 0)
          break;
        switch (RuleIdentifier[22]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "nd", 2) != 0)
            break;
          return 162;	 // "bitfield_extract_from_and"
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "hr", 2) != 0)
            break;
          return 163;	 // "bitfield_extract_from_shr"
        }
        break;
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ildvector_identity_fold", 23) != 0)
          break;
        return 94;	 // "buildvector_identity_fold"
      }
      break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_shuffle_undef_rhs", 24) != 0)
        break;
      return 199;	 // "combine_shuffle_undef_rhs"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vec_elt_build_vec", 24) != 0)
        break;
      return 65;	 // "extract_vec_elt_build_vec"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eg_and_one_to_sext_inreg", 24) != 0)
        break;
      return 116;	 // "neg_and_one_to_sext_inreg"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_one_fp", 24) != 0)
        break;
      return 100;	 // "right_identity_neg_one_fp"
    }
    break;
  case 26:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_undef_to_undef", 25) != 0)
        break;
      return 74;	 // "binop_right_undef_to_undef"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_fp_constant_to_rhs", 25) != 0)
        break;
      return 190;	 // "commute_fp_constant_to_rhs"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_from_or_shift", 25) != 0)
        break;
      return 153;	 // "funnel_shift_from_or_shift"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_zero_fp", 25) != 0)
        break;
      return 99;	 // "right_identity_neg_zero_fp"
    }
    break;
  case 27:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "om", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case 'b':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ine_use_vector_truncate", 23) != 0)
          break;
        return 201;	 // "combine_use_vector_truncate"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ute_int_constant_to_rhs", 23) != 0)
          break;
        return 189;	 // "commute_int_constant_to_rhs"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_or_combine", 26) != 0)
        break;
      return 113;	 // "double_icmp_zero_or_combine"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_binop_in_equality", 26) != 0)
        break;
      return 114;	 // "redundant_binop_in_equality"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_lshr_buildvector_fold", 26) != 0)
        break;
      return 96;	 // "trunc_lshr_buildvector_fold"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_anyext_build_vector", 26) != 0)
        break;
      return 202;	 // "unmerge_anyext_build_vector"
    }
    break;
  case 28:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_and_combine", 27) != 0)
        break;
      return 112;	 // "double_icmp_zero_and_combine"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "pt_brcond_by_inverting_cond", 27) != 0)
        break;
      return 132;	 // "opt_brcond_by_inverting_cond"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_shuffle_mask", 27) != 0)
        break;
      return 79;	 // "propagate_undef_shuffle_mask"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hift_of_shifted_logic_chain", 27) != 0)
        break;
      return 150;	 // "shift_of_shifted_logic_chain"
    }
    break;
  case 29:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_shr_and", 28) != 0)
        break;
      return 164;	 // "bitfield_extract_from_shr_and"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "xtracted_vector_load", 20) != 0)
          break;
        return 69;	 // "combine_extracted_vector_load"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "huffle_disjoint_mask", 20) != 0)
          break;
        return 200;	 // "combine_shuffle_disjoint_mask"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_true_false_known_bits", 28) != 0)
        break;
      return 110;	 // "icmp_to_true_false_known_bits"
    }
    break;
  case 30:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "freeze_of_non_undef_non_poison", 30) != 0)
      break;
    return 41;	 // "freeze_of_non_undef_non_poison"
  case 31:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_", 22) != 0)
      break;
    switch (RuleIdentifier[22]) {
    default: break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+23, "lt_undef", 8) != 0)
        break;
      return 22;	 // "insert_vector_element_elt_undef"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+23, "dx_undef", 8) != 0)
        break;
      return 21;	 // "insert_vector_element_idx_undef"
    }
    break;
  case 32:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_sext_inreg", 31) != 0)
        break;
      return 161;	 // "bitfield_extract_from_sext_inreg"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_f", 8) != 0)
        break;
      switch (RuleIdentifier[9]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "dd_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 177;	 // "combine_fadd_fmul_to_fmad_or_fma"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "ub_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 181;	 // "combine_fsub_fmul_to_fmad_or_fma"
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_not_const", 31) != 0)
        break;
      return 25;	 // "extract_vector_element_not_const"
    }
    break;
  case 34:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fmul_with_select_to_fldexp", 33) != 0)
        break;
      return 213;	 // "combine_fmul_with_select_to_fldexp"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_all_elts_from_build_vector", 33) != 0)
        break;
      return 66;	 // "extract_all_elts_from_build_vector"
    }
    break;
  case 35:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_build_vector", 35) != 0)
      break;
    return 27;	 // "extract_vector_element_build_vector"
  case 36:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'f':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "add_fma_fmul_to_fmad_or_fma", 27) != 0)
          break;
        return 179;	 // "combine_fadd_fma_fmul_to_fmad_or_fma"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "nsert_vec_elts_build_vector", 27) != 0)
          break;
        return 64;	 // "combine_insert_vec_elts_build_vector"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_extract_vec_elt_out_of_bounds", 35) != 0)
        break;
      return 81;	 // "insert_extract_vec_elt_out_of_bounds"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_index", 35) != 0)
        break;
      return 20;	 // "match_extract_of_element_undef_index"
    }
    break;
  case 37:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fsub_fneg_fmul_to_fmad_or_fma", 36) != 0)
        break;
      return 182;	 // "combine_fsub_fneg_fmul_to_fmad_or_fma"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_shuffle_vector", 36) != 0)
        break;
      return 35;	 // "extract_vector_element_shuffle_vector"
    case 'h':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oist_logic_op_with_same_opcode_hands", 36) != 0)
        break;
      return 103;	 // "hoist_logic_op_with_same_opcode_hands"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_vector", 36) != 0)
        break;
      return 19;	 // "match_extract_of_element_undef_vector"
    }
    break;
  case 38:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_f", 9) != 0)
      break;
    switch (RuleIdentifier[9]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "dd_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 178;	 // "combine_fadd_fpext_fmul_to_fmad_or_fma"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "ub_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 183;	 // "combine_fsub_fpext_fmul_to_fmad_or_fma"
    }
    break;
  case 40:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_different_indices", 40) != 0)
      break;
    return 26;	 // "extract_vector_element_different_indices"
  case 42:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fadd_fpext_fma_fmul_to_fmad_or_fma", 41) != 0)
        break;
      return 180;	 // "combine_fadd_fpext_fma_fmul_to_fmad_or_fma"
    case 'e':	 // 7 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_build_vector_trunc", 40) != 0)
        break;
      switch (RuleIdentifier[41]) {
      default: break;
      case '2':	 // 1 string to match.
        return 28;	 // "extract_vector_element_build_vector_trunc2"
      case '3':	 // 1 string to match.
        return 29;	 // "extract_vector_element_build_vector_trunc3"
      case '4':	 // 1 string to match.
        return 30;	 // "extract_vector_element_build_vector_trunc4"
      case '5':	 // 1 string to match.
        return 31;	 // "extract_vector_element_build_vector_trunc5"
      case '6':	 // 1 string to match.
        return 32;	 // "extract_vector_element_build_vector_trunc6"
      case '7':	 // 1 string to match.
        return 33;	 // "extract_vector_element_build_vector_trunc7"
      case '8':	 // 1 string to match.
        return 34;	 // "extract_vector_element_build_vector_trunc8"
      }
      break;
    }
    break;
  case 43:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma", 43) != 0)
      break;
    return 184;	 // "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma"
  case 44:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_extract_vector_element", 44) != 0)
      break;
    return 36;	 // "insert_vector_element_extract_vector_element"
  case 46:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "push_freeze_to_prevent_poison_from_propagating", 46) != 0)
      break;
    return 42;	 // "push_freeze_to_prevent_poison_from_propagating"
  }
#endif // ifndef NDEBUG

  return std::nullopt;
}
static std::optional<std::pair<uint64_t, uint64_t>> getRuleRangeForIdentifier(StringRef RuleIdentifier) {
  std::pair<StringRef, StringRef> RangePair = RuleIdentifier.split('-');
  if (!RangePair.second.empty()) {
    const auto First = getRuleIdxForIdentifier(RangePair.first);
    const auto Last = getRuleIdxForIdentifier(RangePair.second);
    if (!First || !Last)
      return std::nullopt;
    if (First >= Last)
      report_fatal_error("Beginning of range should be before end of range");
    return {{*First, *Last + 1}};
  }
  if (RangePair.first == "*") {
    return {{0, 216}};
  }
  const auto I = getRuleIdxForIdentifier(RangePair.first);
  if (!I)
    return std::nullopt;
  return {{*I, *I + 1}};
}

bool AMDGPUPreLegalizerCombinerImplRuleConfig::setRuleEnabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.reset(I);
  return true;
}

bool AMDGPUPreLegalizerCombinerImplRuleConfig::setRuleDisabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.set(I);
  return true;
}

static std::vector<std::string> AMDGPUPreLegalizerCombinerOption;
static cl::list<std::string> AMDGPUPreLegalizerCombinerDisableOption(
    "amdgpuprelegalizercombiner-disable-rule",
    cl::desc("Disable one or more combiner rules temporarily in the AMDGPUPreLegalizerCombiner pass"),
    cl::CommaSeparated,
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &Str) {
      AMDGPUPreLegalizerCombinerOption.push_back(Str);
    }));
static cl::list<std::string> AMDGPUPreLegalizerCombinerOnlyEnableOption(
    "amdgpuprelegalizercombiner-only-enable-rule",
    cl::desc("Disable all rules in the AMDGPUPreLegalizerCombiner pass then re-enable the specified ones"),
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &CommaSeparatedArg) {
      StringRef Str = CommaSeparatedArg;
      AMDGPUPreLegalizerCombinerOption.push_back("*");
      do {
        auto X = Str.split(",");
        AMDGPUPreLegalizerCombinerOption.push_back(("!" + X.first).str());
        Str = X.second;
      } while (!Str.empty());
    }));


bool AMDGPUPreLegalizerCombinerImplRuleConfig::isRuleEnabled(unsigned RuleID) const {
    return  !DisabledRules.test(RuleID);
}
bool AMDGPUPreLegalizerCombinerImplRuleConfig::parseCommandLineOption() {
  for (StringRef Identifier : AMDGPUPreLegalizerCombinerOption) {
    bool Enabled = Identifier.consume_front("!");
    if (Enabled && !setRuleEnabled(Identifier))
      return false;
    if (!Enabled && !setRuleDisabled(Identifier))
      return false;
  }
  return true;
}

#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_TYPES
const unsigned MAX_SUBTARGET_PREDICATES = 0;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_CLASS_MEMBERS
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AMDGPUSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AMDGPUSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS
#ifdef GET_GICOMBINER_CLASS_MEMBERS
  mutable MatcherState State;
  typedef ComplexRendererFns(AMDGPUPreLegalizerCombinerImpl::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AMDGPUPreLegalizerCombinerImpl::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AMDGPUPreLegalizerCombinerImpl::ComplexMatcherMemFn ComplexPredicateFns[];
  static AMDGPUPreLegalizerCombinerImpl::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS

#ifdef GET_GICOMBINER_IMPL
// LLT Objects.
enum {
  GILLT_s1,
};
const static size_t NumTypeObjects = 1;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
};

PredicateBitset AMDGPUPreLegalizerCombinerImpl::
computeAvailableModuleFeatures(const AMDGPUSubtarget *Subtarget) const {
  PredicateBitset Features{};
  return Features;
}

void AMDGPUPreLegalizerCombinerImpl::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AMDGPUSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AMDGPUPreLegalizerCombinerImpl::
computeAvailableFunctionFeatures(const AMDGPUSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

AMDGPUPreLegalizerCombinerImpl::ComplexMatcherMemFn
AMDGPUPreLegalizerCombinerImpl::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

enum {
  GICXXPred_MI_Predicate_GICombiner0 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_GICombiner1,
  GICXXPred_MI_Predicate_GICombiner2,
  GICXXPred_MI_Predicate_GICombiner3,
  GICXXPred_MI_Predicate_GICombiner4,
  GICXXPred_MI_Predicate_GICombiner5,
  GICXXPred_MI_Predicate_GICombiner6,
  GICXXPred_MI_Predicate_GICombiner7,
  GICXXPred_MI_Predicate_GICombiner8,
  GICXXPred_MI_Predicate_GICombiner9,
};
bool AMDGPUPreLegalizerCombinerImpl::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_GICombiner0: {
    return isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner1: {
    return isGuaranteedNotToBeUndefOrPoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner2: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), 1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner3: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -0.0);
  }
  case GICXXPred_MI_Predicate_GICombiner4: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner5: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_EQ &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner6: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_NE &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner7: {
    return MRI.hasOneNonDBGUse(State.MIs[0]->getOperand(2).getReg()) &&
                    Helper.isLegalOrBeforeLegalizer(
                      {TargetOpcode::G_SEXT_INREG, {MRI.getType(State.MIs[1]->getOperand(1).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner8: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_LSHR,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner9: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_SHL,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AMDGPUPreLegalizerCombinerImpl::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AMDGPUPreLegalizerCombinerImpl::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AMDGPUPreLegalizerCombinerImpl::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
enum {
  GICXXPred_Simple_IsRule0Enabled = GICXXPred_Invalid + 1,
  GICXXPred_Simple_IsRule1Enabled,
  GICXXPred_Simple_IsRule2Enabled,
  GICXXPred_Simple_IsRule3Enabled,
  GICXXPred_Simple_IsRule4Enabled,
  GICXXPred_Simple_IsRule5Enabled,
  GICXXPred_Simple_IsRule6Enabled,
  GICXXPred_Simple_IsRule7Enabled,
  GICXXPred_Simple_IsRule8Enabled,
  GICXXPred_Simple_IsRule9Enabled,
  GICXXPred_Simple_IsRule10Enabled,
  GICXXPred_Simple_IsRule11Enabled,
  GICXXPred_Simple_IsRule12Enabled,
  GICXXPred_Simple_IsRule13Enabled,
  GICXXPred_Simple_IsRule14Enabled,
  GICXXPred_Simple_IsRule15Enabled,
  GICXXPred_Simple_IsRule16Enabled,
  GICXXPred_Simple_IsRule17Enabled,
  GICXXPred_Simple_IsRule18Enabled,
  GICXXPred_Simple_IsRule19Enabled,
  GICXXPred_Simple_IsRule20Enabled,
  GICXXPred_Simple_IsRule21Enabled,
  GICXXPred_Simple_IsRule22Enabled,
  GICXXPred_Simple_IsRule23Enabled,
  GICXXPred_Simple_IsRule24Enabled,
  GICXXPred_Simple_IsRule25Enabled,
  GICXXPred_Simple_IsRule26Enabled,
  GICXXPred_Simple_IsRule27Enabled,
  GICXXPred_Simple_IsRule28Enabled,
  GICXXPred_Simple_IsRule29Enabled,
  GICXXPred_Simple_IsRule30Enabled,
  GICXXPred_Simple_IsRule31Enabled,
  GICXXPred_Simple_IsRule32Enabled,
  GICXXPred_Simple_IsRule33Enabled,
  GICXXPred_Simple_IsRule34Enabled,
  GICXXPred_Simple_IsRule35Enabled,
  GICXXPred_Simple_IsRule36Enabled,
  GICXXPred_Simple_IsRule37Enabled,
  GICXXPred_Simple_IsRule38Enabled,
  GICXXPred_Simple_IsRule39Enabled,
  GICXXPred_Simple_IsRule40Enabled,
  GICXXPred_Simple_IsRule41Enabled,
  GICXXPred_Simple_IsRule42Enabled,
  GICXXPred_Simple_IsRule43Enabled,
  GICXXPred_Simple_IsRule44Enabled,
  GICXXPred_Simple_IsRule45Enabled,
  GICXXPred_Simple_IsRule46Enabled,
  GICXXPred_Simple_IsRule47Enabled,
  GICXXPred_Simple_IsRule48Enabled,
  GICXXPred_Simple_IsRule49Enabled,
  GICXXPred_Simple_IsRule50Enabled,
  GICXXPred_Simple_IsRule51Enabled,
  GICXXPred_Simple_IsRule52Enabled,
  GICXXPred_Simple_IsRule53Enabled,
  GICXXPred_Simple_IsRule54Enabled,
  GICXXPred_Simple_IsRule55Enabled,
  GICXXPred_Simple_IsRule56Enabled,
  GICXXPred_Simple_IsRule57Enabled,
  GICXXPred_Simple_IsRule58Enabled,
  GICXXPred_Simple_IsRule59Enabled,
  GICXXPred_Simple_IsRule60Enabled,
  GICXXPred_Simple_IsRule61Enabled,
  GICXXPred_Simple_IsRule62Enabled,
  GICXXPred_Simple_IsRule63Enabled,
  GICXXPred_Simple_IsRule64Enabled,
  GICXXPred_Simple_IsRule65Enabled,
  GICXXPred_Simple_IsRule66Enabled,
  GICXXPred_Simple_IsRule67Enabled,
  GICXXPred_Simple_IsRule68Enabled,
  GICXXPred_Simple_IsRule69Enabled,
  GICXXPred_Simple_IsRule70Enabled,
  GICXXPred_Simple_IsRule71Enabled,
  GICXXPred_Simple_IsRule72Enabled,
  GICXXPred_Simple_IsRule73Enabled,
  GICXXPred_Simple_IsRule74Enabled,
  GICXXPred_Simple_IsRule75Enabled,
  GICXXPred_Simple_IsRule76Enabled,
  GICXXPred_Simple_IsRule77Enabled,
  GICXXPred_Simple_IsRule78Enabled,
  GICXXPred_Simple_IsRule79Enabled,
  GICXXPred_Simple_IsRule80Enabled,
  GICXXPred_Simple_IsRule81Enabled,
  GICXXPred_Simple_IsRule82Enabled,
  GICXXPred_Simple_IsRule83Enabled,
  GICXXPred_Simple_IsRule84Enabled,
  GICXXPred_Simple_IsRule85Enabled,
  GICXXPred_Simple_IsRule86Enabled,
  GICXXPred_Simple_IsRule87Enabled,
  GICXXPred_Simple_IsRule88Enabled,
  GICXXPred_Simple_IsRule89Enabled,
  GICXXPred_Simple_IsRule90Enabled,
  GICXXPred_Simple_IsRule91Enabled,
  GICXXPred_Simple_IsRule92Enabled,
  GICXXPred_Simple_IsRule93Enabled,
  GICXXPred_Simple_IsRule94Enabled,
  GICXXPred_Simple_IsRule95Enabled,
  GICXXPred_Simple_IsRule96Enabled,
  GICXXPred_Simple_IsRule97Enabled,
  GICXXPred_Simple_IsRule98Enabled,
  GICXXPred_Simple_IsRule99Enabled,
  GICXXPred_Simple_IsRule100Enabled,
  GICXXPred_Simple_IsRule101Enabled,
  GICXXPred_Simple_IsRule102Enabled,
  GICXXPred_Simple_IsRule103Enabled,
  GICXXPred_Simple_IsRule104Enabled,
  GICXXPred_Simple_IsRule105Enabled,
  GICXXPred_Simple_IsRule106Enabled,
  GICXXPred_Simple_IsRule107Enabled,
  GICXXPred_Simple_IsRule108Enabled,
  GICXXPred_Simple_IsRule109Enabled,
  GICXXPred_Simple_IsRule110Enabled,
  GICXXPred_Simple_IsRule111Enabled,
  GICXXPred_Simple_IsRule112Enabled,
  GICXXPred_Simple_IsRule113Enabled,
  GICXXPred_Simple_IsRule114Enabled,
  GICXXPred_Simple_IsRule115Enabled,
  GICXXPred_Simple_IsRule116Enabled,
  GICXXPred_Simple_IsRule117Enabled,
  GICXXPred_Simple_IsRule118Enabled,
  GICXXPred_Simple_IsRule119Enabled,
  GICXXPred_Simple_IsRule120Enabled,
  GICXXPred_Simple_IsRule121Enabled,
  GICXXPred_Simple_IsRule122Enabled,
  GICXXPred_Simple_IsRule123Enabled,
  GICXXPred_Simple_IsRule124Enabled,
  GICXXPred_Simple_IsRule125Enabled,
  GICXXPred_Simple_IsRule126Enabled,
  GICXXPred_Simple_IsRule127Enabled,
  GICXXPred_Simple_IsRule128Enabled,
  GICXXPred_Simple_IsRule129Enabled,
  GICXXPred_Simple_IsRule130Enabled,
  GICXXPred_Simple_IsRule131Enabled,
  GICXXPred_Simple_IsRule132Enabled,
  GICXXPred_Simple_IsRule133Enabled,
  GICXXPred_Simple_IsRule134Enabled,
  GICXXPred_Simple_IsRule135Enabled,
  GICXXPred_Simple_IsRule136Enabled,
  GICXXPred_Simple_IsRule137Enabled,
  GICXXPred_Simple_IsRule138Enabled,
  GICXXPred_Simple_IsRule139Enabled,
  GICXXPred_Simple_IsRule140Enabled,
  GICXXPred_Simple_IsRule141Enabled,
  GICXXPred_Simple_IsRule142Enabled,
  GICXXPred_Simple_IsRule143Enabled,
  GICXXPred_Simple_IsRule144Enabled,
  GICXXPred_Simple_IsRule145Enabled,
  GICXXPred_Simple_IsRule146Enabled,
  GICXXPred_Simple_IsRule147Enabled,
  GICXXPred_Simple_IsRule148Enabled,
  GICXXPred_Simple_IsRule149Enabled,
  GICXXPred_Simple_IsRule150Enabled,
  GICXXPred_Simple_IsRule151Enabled,
  GICXXPred_Simple_IsRule152Enabled,
  GICXXPred_Simple_IsRule153Enabled,
  GICXXPred_Simple_IsRule154Enabled,
  GICXXPred_Simple_IsRule155Enabled,
  GICXXPred_Simple_IsRule156Enabled,
  GICXXPred_Simple_IsRule157Enabled,
  GICXXPred_Simple_IsRule158Enabled,
  GICXXPred_Simple_IsRule159Enabled,
  GICXXPred_Simple_IsRule160Enabled,
  GICXXPred_Simple_IsRule161Enabled,
  GICXXPred_Simple_IsRule162Enabled,
  GICXXPred_Simple_IsRule163Enabled,
  GICXXPred_Simple_IsRule164Enabled,
  GICXXPred_Simple_IsRule165Enabled,
  GICXXPred_Simple_IsRule166Enabled,
  GICXXPred_Simple_IsRule167Enabled,
  GICXXPred_Simple_IsRule168Enabled,
  GICXXPred_Simple_IsRule169Enabled,
  GICXXPred_Simple_IsRule170Enabled,
  GICXXPred_Simple_IsRule171Enabled,
  GICXXPred_Simple_IsRule172Enabled,
  GICXXPred_Simple_IsRule173Enabled,
  GICXXPred_Simple_IsRule174Enabled,
  GICXXPred_Simple_IsRule175Enabled,
  GICXXPred_Simple_IsRule176Enabled,
  GICXXPred_Simple_IsRule177Enabled,
  GICXXPred_Simple_IsRule178Enabled,
  GICXXPred_Simple_IsRule179Enabled,
  GICXXPred_Simple_IsRule180Enabled,
  GICXXPred_Simple_IsRule181Enabled,
  GICXXPred_Simple_IsRule182Enabled,
  GICXXPred_Simple_IsRule183Enabled,
  GICXXPred_Simple_IsRule184Enabled,
  GICXXPred_Simple_IsRule185Enabled,
  GICXXPred_Simple_IsRule186Enabled,
  GICXXPred_Simple_IsRule187Enabled,
  GICXXPred_Simple_IsRule188Enabled,
  GICXXPred_Simple_IsRule189Enabled,
  GICXXPred_Simple_IsRule190Enabled,
  GICXXPred_Simple_IsRule191Enabled,
  GICXXPred_Simple_IsRule192Enabled,
  GICXXPred_Simple_IsRule193Enabled,
  GICXXPred_Simple_IsRule194Enabled,
  GICXXPred_Simple_IsRule195Enabled,
  GICXXPred_Simple_IsRule196Enabled,
  GICXXPred_Simple_IsRule197Enabled,
  GICXXPred_Simple_IsRule198Enabled,
  GICXXPred_Simple_IsRule199Enabled,
  GICXXPred_Simple_IsRule200Enabled,
  GICXXPred_Simple_IsRule201Enabled,
  GICXXPred_Simple_IsRule202Enabled,
  GICXXPred_Simple_IsRule203Enabled,
  GICXXPred_Simple_IsRule204Enabled,
  GICXXPred_Simple_IsRule205Enabled,
  GICXXPred_Simple_IsRule206Enabled,
  GICXXPred_Simple_IsRule207Enabled,
  GICXXPred_Simple_IsRule208Enabled,
  GICXXPred_Simple_IsRule209Enabled,
  GICXXPred_Simple_IsRule210Enabled,
  GICXXPred_Simple_IsRule211Enabled,
  GICXXPred_Simple_IsRule212Enabled,
  GICXXPred_Simple_IsRule213Enabled,
  GICXXPred_Simple_IsRule214Enabled,
  GICXXPred_Simple_IsRule215Enabled,
};

bool AMDGPUPreLegalizerCombinerImpl::testSimplePredicate(unsigned Predicate) const {
    return RuleConfig.isRuleEnabled(Predicate - GICXXPred_Invalid - 1);
}
// Custom renderers.
enum {
  GICR_Invalid,
};
AMDGPUPreLegalizerCombinerImpl::CustomRendererFn
AMDGPUPreLegalizerCombinerImpl::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool AMDGPUPreLegalizerCombinerImpl::tryCombineAllImpl(MachineInstr &I) const {
  const TargetSubtargetInfo &ST = MF.getSubtarget();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  B.setInstrAndDebugLoc(I);
  State.MIs.clear();
  State.MIs.push_back(&I);
  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), *ST.getInstrInfo(), MRI, *MRI.getTargetRegisterInfo(), *ST.getRegBankInfo(), AvailableFeatures, /*CoverageInfo*/ nullptr)) {
    return true;
  }

  return false;
}

enum {
  GICXXCustomAction_GICombiner0 = GICXXCustomAction_Invalid + 1,
  GICXXCustomAction_GICombiner1,
  GICXXCustomAction_GICombiner2,
  GICXXCustomAction_GICombiner3,
  GICXXCustomAction_GICombiner4,
  GICXXCustomAction_GICombiner5,
  GICXXCustomAction_GICombiner6,
  GICXXCustomAction_GICombiner7,
  GICXXCustomAction_GICombiner8,
  GICXXCustomAction_GICombiner9,
  GICXXCustomAction_GICombiner10,
  GICXXCustomAction_GICombiner11,
  GICXXCustomAction_GICombiner12,
  GICXXCustomAction_GICombiner13,
  GICXXCustomAction_GICombiner14,
  GICXXCustomAction_GICombiner15,
  GICXXCustomAction_GICombiner16,
  GICXXCustomAction_GICombiner17,
  GICXXCustomAction_GICombiner18,
  GICXXCustomAction_GICombiner19,
  GICXXCustomAction_GICombiner20,
  GICXXCustomAction_GICombiner21,
  GICXXCustomAction_GICombiner22,
  GICXXCustomAction_GICombiner23,
  GICXXCustomAction_GICombiner24,
  GICXXCustomAction_GICombiner25,
  GICXXCustomAction_GICombiner26,
  GICXXCustomAction_GICombiner27,
  GICXXCustomAction_GICombiner28,
  GICXXCustomAction_GICombiner29,
  GICXXCustomAction_GICombiner30,
  GICXXCustomAction_GICombiner31,
  GICXXCustomAction_GICombiner32,
  GICXXCustomAction_GICombiner33,
  GICXXCustomAction_GICombiner34,
  GICXXCustomAction_GICombiner35,
  GICXXCustomAction_GICombiner36,
  GICXXCustomAction_GICombiner37,
  GICXXCustomAction_GICombiner38,
  GICXXCustomAction_GICombiner39,
  GICXXCustomAction_GICombiner40,
  GICXXCustomAction_GICombiner41,
  GICXXCustomAction_GICombiner42,
  GICXXCustomAction_GICombiner43,
  GICXXCustomAction_GICombiner44,
  GICXXCustomAction_GICombiner45,
  GICXXCustomAction_GICombiner46,
  GICXXCustomAction_GICombiner47,
  GICXXCustomAction_GICombiner48,
  GICXXCustomAction_GICombiner49,
  GICXXCustomAction_GICombiner50,
  GICXXCustomAction_GICombiner51,
  GICXXCustomAction_GICombiner52,
  GICXXCustomAction_GICombiner53,
  GICXXCustomAction_GICombiner54,
  GICXXCustomAction_GICombiner55,
  GICXXCustomAction_GICombiner56,
  GICXXCustomAction_GICombiner57,
  GICXXCustomAction_GICombiner58,
  GICXXCustomAction_GICombiner59,
  GICXXCustomAction_GICombiner60,
  GICXXCustomAction_GICombiner61,
  GICXXCustomAction_GICombiner62,
  GICXXCustomAction_GICombiner63,
  GICXXCustomAction_GICombiner64,
  GICXXCustomAction_GICombiner65,
  GICXXCustomAction_GICombiner66,
  GICXXCustomAction_GICombiner67,
  GICXXCustomAction_GICombiner68,
  GICXXCustomAction_GICombiner69,
  GICXXCustomAction_GICombiner70,
  GICXXCustomAction_GICombiner71,
  GICXXCustomAction_GICombiner72,
  GICXXCustomAction_GICombiner73,
  GICXXCustomAction_GICombiner74,
  GICXXCustomAction_GICombiner75,
  GICXXCustomAction_GICombiner76,
  GICXXCustomAction_GICombiner77,
  GICXXCustomAction_GICombiner78,
  GICXXCustomAction_GICombiner79,
  GICXXCustomAction_GICombiner80,
  GICXXCustomAction_GICombiner81,
  GICXXCustomAction_GICombiner82,
  GICXXCustomAction_GICombiner83,
  GICXXCustomAction_GICombiner84,
  GICXXCustomAction_GICombiner85,
  GICXXCustomAction_GICombiner86,
  GICXXCustomAction_GICombiner87,
  GICXXCustomAction_GICombiner88,
  GICXXCustomAction_GICombiner89,
  GICXXCustomAction_GICombiner90,
  GICXXCustomAction_GICombiner91,
  GICXXCustomAction_GICombiner92,
  GICXXCustomAction_GICombiner93,
  GICXXCustomAction_GICombiner94,
  GICXXCustomAction_GICombiner95,
  GICXXCustomAction_GICombiner96,
  GICXXCustomAction_GICombiner97,
  GICXXCustomAction_GICombiner98,
  GICXXCustomAction_GICombiner99,
  GICXXCustomAction_GICombiner100,
  GICXXCustomAction_GICombiner101,
  GICXXCustomAction_GICombiner102,
  GICXXCustomAction_GICombiner103,
  GICXXCustomAction_GICombiner104,
  GICXXCustomAction_GICombiner105,
  GICXXCustomAction_GICombiner106,
  GICXXCustomAction_GICombiner107,
  GICXXCustomAction_GICombiner108,
  GICXXCustomAction_GICombiner109,
  GICXXCustomAction_GICombiner110,
  GICXXCustomAction_GICombiner111,
  GICXXCustomAction_GICombiner112,
  GICXXCustomAction_GICombiner113,
  GICXXCustomAction_GICombiner114,
  GICXXCustomAction_GICombiner115,
  GICXXCustomAction_GICombiner116,
  GICXXCustomAction_GICombiner117,
  GICXXCustomAction_GICombiner118,
  GICXXCustomAction_GICombiner119,
  GICXXCustomAction_GICombiner120,
  GICXXCustomAction_GICombiner121,
  GICXXCustomAction_GICombiner122,
  GICXXCustomAction_GICombiner123,
  GICXXCustomAction_GICombiner124,
  GICXXCustomAction_GICombiner125,
  GICXXCustomAction_GICombiner126,
  GICXXCustomAction_GICombiner127,
  GICXXCustomAction_GICombiner128,
  GICXXCustomAction_GICombiner129,
  GICXXCustomAction_GICombiner130,
  GICXXCustomAction_GICombiner131,
  GICXXCustomAction_GICombiner132,
  GICXXCustomAction_GICombiner133,
  GICXXCustomAction_GICombiner134,
  GICXXCustomAction_GICombiner135,
  GICXXCustomAction_GICombiner136,
  GICXXCustomAction_GICombiner137,
  GICXXCustomAction_GICombiner138,
  GICXXCustomAction_GICombiner139,
  GICXXCustomAction_GICombiner140,
  GICXXCustomAction_GICombiner141,
  GICXXCustomAction_GICombiner142,
  GICXXCustomAction_GICombiner143,
  GICXXCustomAction_GICombiner144,
  GICXXCustomAction_GICombiner145,
  GICXXCustomAction_GICombiner146,
  GICXXCustomAction_GICombiner147,
  GICXXCustomAction_GICombiner148,
  GICXXCustomAction_GICombiner149,
  GICXXCustomAction_GICombiner150,
  GICXXCustomAction_GICombiner151,
  GICXXCustomAction_GICombiner152,
};
bool AMDGPUPreLegalizerCombinerImpl::runCustomAction(unsigned ApplyID, const MatcherState &State, NewMIVector &OutMIs) const {
  Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
  switch(ApplyID) {
  case GICXXCustomAction_GICombiner0:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAPlusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner1:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC2MinusAPlusC1(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner2:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner3:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC1Minus2MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner4:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1PlusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner5:{
    // Match Patterns
    if(![&](){return Helper.matchCombineCopy(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineCopy(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner6:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner7:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineSubToAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner8:{
    std::pair<Register, bool> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner9:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElement(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner10:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchInsertVectorElementOOB(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner11:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithDifferentIndices(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner12:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner13:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVectorTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner14:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithShuffleVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner15:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner16:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner17:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShlOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner18:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner19:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return !isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI) && Helper.matchFreezeOfSingleMaybePoisonOperand(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner20:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncateOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner21:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner22:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfSelect(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner23:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfBuildVector(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner24:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinop(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner25:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfInteger(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner26:{
    SmallVector<Register, 4> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineInsertVecElts(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineInsertVecElts(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner27:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner28:{
    SmallVector<std::pair<Register, MachineInstr*>> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner29:{
    PreferredTuple GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner30:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineLoadWithAndMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner31:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtractedVectorLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner32:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner33:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner34:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], -1);
    return true;
  }
  case GICXXCustomAction_GICombiner35:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner36:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner37:{
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]->getOperand(0).getParent());
    return true;
  }
  case GICXXCustomAction_GICombiner38:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner39:{
    // Match Patterns
    if(![&](){return Helper.matchAllExplicitUsesAreUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner40:{
    // Match Patterns
    if(![&](){return Helper.matchUndefShuffleVectorMask(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner41:{
    // Match Patterns
    if(![&](){return Helper.matchUndefStore(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.eraseInst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner42:{
    // Match Patterns
    if(![&](){return Helper.matchInsertExtractVecEltOutOfBounds(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner43:{
    // Match Patterns
    if(![&](){return Helper.matchSelectSameVal(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 2);
    return true;
  }
  case GICXXCustomAction_GICombiner44:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsZero(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner45:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineI2PToP2I(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineI2PToP2I(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner46:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){GIMatchData_info = State.MIs[1]->getOperand(1).getReg(); return true;}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineP2IToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner47:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineAnyExtTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner48:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchBuildVectorIdentityFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner49:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner50:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncLshrBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner51:{
    // Match Patterns
    if(![&](){return MRI.getType(State.MIs[1]->getOperand(1).getReg()) == MRI.getType(State.MIs[0]->getOperand(0).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner52:{
    MachineInstr* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner53:{
    std::tuple<Register, Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyAddToSub(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyAddToSub(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner54:{
    InstructionStepsMatchInfo GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchHoistLogicOpWithSameOpcodeHands(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildInstructionSteps(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner55:{
    std::optional<int64_t> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftsTooBig(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    if (GIMatchData_matchinfo) {
              Helper.replaceInstWithConstant(*State.MIs[0], *GIMatchData_matchinfo);
            } else {
              Helper.replaceInstWithUndef(*State.MIs[0]);
            }
    return true;
  }
  case GICXXCustomAction_GICombiner56:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocPtrAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner57:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocCommBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner58:{
    PtrAddChain GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner59:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeICmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner60:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeFCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner61:{
    int64_t GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchICmpToTrueFalseKnownBits(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner62:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchICmpToLHSKnownBits(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner63:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchRedundantBinOpInEquality(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner64:{
    std::tuple<Register, int64_t> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAshrShlToSextInreg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyAshShlToSextInreg(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner65:{
    std::tuple<Register, unsigned> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner66:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner67:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinopFeedingAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner68:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantSelectCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner69:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSelectIMinMax(State.MIs[0]->getOperand(0), GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner70:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSelect(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner71:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner72:{
    // Match Patterns
    if(![&](){return Helper.matchRedundantSExtInReg(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner73:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner74:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsKnownToBeAPowerOfTwo(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyURemByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner75:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineZextTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner76:{
    // Match Patterns
    if(![&](){unsigned BitWidth = MRI.getType(State.MIs[0]->getOperand(1).getReg()).getScalarSizeInBits();
                return Helper.getValueTracking()->maskedValueIsZero(State.MIs[0]->getOperand(1).getReg(),
                         APInt::getOneBitSet(BitWidth, State.MIs[0]->getOperand(2).getImm() - 1));}()) {
      return false;
    }
    // Apply Patterns
    Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
              Helper.getBuilder().buildZExtInReg(State.MIs[0]->getOperand(0), State.MIs[0]->getOperand(1), State.MIs[0]->getOperand(2).getImm());
              State.MIs[0]->eraseFromParent();
    return true;
  }
  case GICXXCustomAction_GICombiner77:{
    std::pair<MachineInstr*, LLT> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner78:{
    SmallVector<Register, 4> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchNotCmp(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyNotCmp(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner79:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner80:{
    // Apply Patterns
    Helper.applyCombineConstantFoldFpUnary(*State.MIs[0], State.MIs[1]->getOperand(1).getFPImm());
    return true;
  }
  case GICXXCustomAction_GICombiner81:{
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0]->getOperand(0).getParent(), 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner82:{
    APInt GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner83:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOverlappingAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner84:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner85:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy0(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner86:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddEToAddO(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner87:{
    unsigned GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFMinMaxNaN(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner88:{
    // Match Patterns
    if(![&](){return Helper.matchFPowIExpansion(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExpandFPowI(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());
    return true;
  }
  case GICXXCustomAction_GICombiner89:{
    std::pair<Register, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner90:{
    // Match Patterns
    if(![&](){return Helper.matchPtrAddZero(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddZero(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner91:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner92:{
    ShiftOfShiftedLogic GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner93:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchLoadOrCombine(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner94:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner95:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOrShiftToFunnelShift(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner96:{
    // Match Patterns
    if(![&](){return Helper.matchFunnelShiftToRotate(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftToRotate(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner97:{
    // Match Patterns
    if(![&](){return Helper.matchConstantLargerBitWidth(*State.MIs[0], 3);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftConstantModulo(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner98:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCommuteShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner99:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromSExtInReg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner100:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner101:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShr(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner102:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShrAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner103:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner104:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFPBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner105:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFMA(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner106:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldCastOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner107:{
    // Match Patterns
    if(![&](){return Helper.matchUDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner108:{
    // Match Patterns
    if(![&](){return Helper.matchSDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner109:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/true);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner110:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/false);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner111:{
    // Match Patterns
    if(![&](){return Helper.matchUMulHToLShr(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUMulHToLShr(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner112:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantNegOperands(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner113:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAndOrDisjointMask(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner114:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner115:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner116:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMAFMulToFMadOrFMA(*State.MIs[0],
                                                                     GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner117:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMAAggressive(
                                                          *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner118:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner119:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFNegFMulToFMadOrFMA(*State.MIs[0],
                                                                      GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner120:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner121:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFNegFMulToFMadOrFMA(
                                                    *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner122:{
    unsigned GIMatchData_select_op_no;
    // Match Patterns
    if(![&](){return Helper.matchFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);
    return true;
  }
  case GICXXCustomAction_GICombiner123:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubAddSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner124:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifySelectToMinMax(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner125:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner126:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner127:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteFPConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner128:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner129:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner130:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyNegMinMax(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner131:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner132:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner133:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchZextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner134:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNonNegZext(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner135:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner136:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleUndefRHS(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner137:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleDisjointMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner138:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner139:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUnmergeValuesAnyExtBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner140:{
    SmallVector<Register, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner141:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMergeUnmerge(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner142:{
    SmallVector<APInt, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner143:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeUndef(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner144:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner145:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeZExtToZExt(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeZExtToZExt(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner146:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndUndef(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner147:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndZero(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner148:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOverflow(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner149:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSuboCarryOut(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner150:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineFmulWithSelectToFldexp(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner151:{
    ClampI64ToI16MatchInfo GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchClampI64ToI16(*State.MIs[0], MRI, MF, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyClampI64ToI16(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner152:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldableFneg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFoldableFneg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  }
  llvm_unreachable("Unknown Apply Action");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AMDGPUPreLegalizerCombinerImpl::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*    0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(20), GIMT_Encode2(260), /*)*//*default:*//*Label 95*/ GIMT_Encode4(7025),
     /*   10 */ /*TargetOpcode::COPY*//*Label 0*/ GIMT_Encode4(970), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  142 */ /*TargetOpcode::G_ADD*//*Label 1*/ GIMT_Encode4(982),
     /*  146 */ /*TargetOpcode::G_SUB*//*Label 2*/ GIMT_Encode4(1539),
     /*  150 */ /*TargetOpcode::G_MUL*//*Label 3*/ GIMT_Encode4(1857),
     /*  154 */ /*TargetOpcode::G_SDIV*//*Label 4*/ GIMT_Encode4(2023),
     /*  158 */ /*TargetOpcode::G_UDIV*//*Label 5*/ GIMT_Encode4(2096),
     /*  162 */ /*TargetOpcode::G_SREM*//*Label 6*/ GIMT_Encode4(2180),
     /*  166 */ /*TargetOpcode::G_UREM*//*Label 7*/ GIMT_Encode4(2225), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  178 */ /*TargetOpcode::G_AND*//*Label 8*/ GIMT_Encode4(2292),
     /*  182 */ /*TargetOpcode::G_OR*//*Label 9*/ GIMT_Encode4(2573),
     /*  186 */ /*TargetOpcode::G_XOR*//*Label 10*/ GIMT_Encode4(2818), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  202 */ /*TargetOpcode::G_PHI*//*Label 11*/ GIMT_Encode4(2919), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  226 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 12*/ GIMT_Encode4(2931), GIMT_Encode4(0),
     /*  234 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 13*/ GIMT_Encode4(2998),
     /*  238 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 14*/ GIMT_Encode4(3072),
     /*  242 */ /*TargetOpcode::G_BUILD_VECTOR_TRUNC*//*Label 15*/ GIMT_Encode4(3120),
     /*  246 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 16*/ GIMT_Encode4(3132),
     /*  250 */ /*TargetOpcode::G_PTRTOINT*//*Label 17*/ GIMT_Encode4(3144),
     /*  254 */ /*TargetOpcode::G_INTTOPTR*//*Label 18*/ GIMT_Encode4(3187),
     /*  258 */ /*TargetOpcode::G_BITCAST*//*Label 19*/ GIMT_Encode4(3220),
     /*  262 */ /*TargetOpcode::G_FREEZE*//*Label 20*/ GIMT_Encode4(3263), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  302 */ /*TargetOpcode::G_LOAD*//*Label 21*/ GIMT_Encode4(3327),
     /*  306 */ /*TargetOpcode::G_SEXTLOAD*//*Label 22*/ GIMT_Encode4(3339),
     /*  310 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 23*/ GIMT_Encode4(3351), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  326 */ /*TargetOpcode::G_STORE*//*Label 24*/ GIMT_Encode4(3363), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  454 */ /*TargetOpcode::G_ANYEXT*//*Label 25*/ GIMT_Encode4(3375),
     /*  458 */ /*TargetOpcode::G_TRUNC*//*Label 26*/ GIMT_Encode4(3503), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  478 */ /*TargetOpcode::G_SEXT*//*Label 27*/ GIMT_Encode4(3872),
     /*  482 */ /*TargetOpcode::G_SEXT_INREG*//*Label 28*/ GIMT_Encode4(3947),
     /*  486 */ /*TargetOpcode::G_ZEXT*//*Label 29*/ GIMT_Encode4(3992),
     /*  490 */ /*TargetOpcode::G_SHL*//*Label 30*/ GIMT_Encode4(4122),
     /*  494 */ /*TargetOpcode::G_LSHR*//*Label 31*/ GIMT_Encode4(4291),
     /*  498 */ /*TargetOpcode::G_ASHR*//*Label 32*/ GIMT_Encode4(4414),
     /*  502 */ /*TargetOpcode::G_FSHL*//*Label 33*/ GIMT_Encode4(4548),
     /*  506 */ /*TargetOpcode::G_FSHR*//*Label 34*/ GIMT_Encode4(4591),
     /*  510 */ /*TargetOpcode::G_ROTR*//*Label 35*/ GIMT_Encode4(4634),
     /*  514 */ /*TargetOpcode::G_ROTL*//*Label 36*/ GIMT_Encode4(4658),
     /*  518 */ /*TargetOpcode::G_ICMP*//*Label 37*/ GIMT_Encode4(4682),
     /*  522 */ /*TargetOpcode::G_FCMP*//*Label 38*/ GIMT_Encode4(4727), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  534 */ /*TargetOpcode::G_SELECT*//*Label 39*/ GIMT_Encode4(4739),
     /*  538 */ /*TargetOpcode::G_UADDO*//*Label 40*/ GIMT_Encode4(4834),
     /*  542 */ /*TargetOpcode::G_UADDE*//*Label 41*/ GIMT_Encode4(4857),
     /*  546 */ /*TargetOpcode::G_USUBO*//*Label 42*/ GIMT_Encode4(4869),
     /*  550 */ /*TargetOpcode::G_USUBE*//*Label 43*/ GIMT_Encode4(4881),
     /*  554 */ /*TargetOpcode::G_SADDO*//*Label 44*/ GIMT_Encode4(4893),
     /*  558 */ /*TargetOpcode::G_SADDE*//*Label 45*/ GIMT_Encode4(4916),
     /*  562 */ /*TargetOpcode::G_SSUBO*//*Label 46*/ GIMT_Encode4(4928),
     /*  566 */ /*TargetOpcode::G_SSUBE*//*Label 47*/ GIMT_Encode4(4940),
     /*  570 */ /*TargetOpcode::G_UMULO*//*Label 48*/ GIMT_Encode4(4952),
     /*  574 */ /*TargetOpcode::G_SMULO*//*Label 49*/ GIMT_Encode4(4986),
     /*  578 */ /*TargetOpcode::G_UMULH*//*Label 50*/ GIMT_Encode4(5020),
     /*  582 */ /*TargetOpcode::G_SMULH*//*Label 51*/ GIMT_Encode4(5043),
     /*  586 */ /*TargetOpcode::G_UADDSAT*//*Label 52*/ GIMT_Encode4(5055),
     /*  590 */ /*TargetOpcode::G_SADDSAT*//*Label 53*/ GIMT_Encode4(5067), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  602 */ /*TargetOpcode::G_USHLSAT*//*Label 54*/ GIMT_Encode4(5079),
     /*  606 */ /*TargetOpcode::G_SSHLSAT*//*Label 55*/ GIMT_Encode4(5102),
     /*  610 */ /*TargetOpcode::G_SMULFIX*//*Label 56*/ GIMT_Encode4(5125),
     /*  614 */ /*TargetOpcode::G_UMULFIX*//*Label 57*/ GIMT_Encode4(5137),
     /*  618 */ /*TargetOpcode::G_SMULFIXSAT*//*Label 58*/ GIMT_Encode4(5149),
     /*  622 */ /*TargetOpcode::G_UMULFIXSAT*//*Label 59*/ GIMT_Encode4(5161), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  642 */ /*TargetOpcode::G_FADD*//*Label 60*/ GIMT_Encode4(5173),
     /*  646 */ /*TargetOpcode::G_FSUB*//*Label 61*/ GIMT_Encode4(5285),
     /*  650 */ /*TargetOpcode::G_FMUL*//*Label 62*/ GIMT_Encode4(5374),
     /*  654 */ /*TargetOpcode::G_FMA*//*Label 63*/ GIMT_Encode4(5483),
     /*  658 */ /*TargetOpcode::G_FMAD*//*Label 64*/ GIMT_Encode4(5506),
     /*  662 */ /*TargetOpcode::G_FDIV*//*Label 65*/ GIMT_Encode4(5529),
     /*  666 */ /*TargetOpcode::G_FREM*//*Label 66*/ GIMT_Encode4(5563), GIMT_Encode4(0),
     /*  674 */ /*TargetOpcode::G_FPOWI*//*Label 67*/ GIMT_Encode4(5575), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  694 */ /*TargetOpcode::G_FLOG2*//*Label 68*/ GIMT_Encode4(5597), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  710 */ /*TargetOpcode::G_FNEG*//*Label 69*/ GIMT_Encode4(5619), GIMT_Encode4(0),
     /*  718 */ /*TargetOpcode::G_FPTRUNC*//*Label 70*/ GIMT_Encode4(5681),
     /*  722 */ /*TargetOpcode::G_FPTOSI*//*Label 71*/ GIMT_Encode4(5724),
     /*  726 */ /*TargetOpcode::G_FPTOUI*//*Label 72*/ GIMT_Encode4(5746),
     /*  730 */ /*TargetOpcode::G_SITOFP*//*Label 73*/ GIMT_Encode4(5768),
     /*  734 */ /*TargetOpcode::G_UITOFP*//*Label 74*/ GIMT_Encode4(5795), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  746 */ /*TargetOpcode::G_FABS*//*Label 75*/ GIMT_Encode4(5822), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  758 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 76*/ GIMT_Encode4(5901),
     /*  762 */ /*TargetOpcode::G_FMINNUM*//*Label 77*/ GIMT_Encode4(5931),
     /*  766 */ /*TargetOpcode::G_FMAXNUM*//*Label 78*/ GIMT_Encode4(5965),
     /*  770 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 79*/ GIMT_Encode4(5999),
     /*  774 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 80*/ GIMT_Encode4(6011),
     /*  778 */ /*TargetOpcode::G_FMINIMUM*//*Label 81*/ GIMT_Encode4(6023),
     /*  782 */ /*TargetOpcode::G_FMAXIMUM*//*Label 82*/ GIMT_Encode4(6057), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  810 */ /*TargetOpcode::G_PTR_ADD*//*Label 83*/ GIMT_Encode4(6091), GIMT_Encode4(0),
     /*  818 */ /*TargetOpcode::G_SMIN*//*Label 84*/ GIMT_Encode4(6181),
     /*  822 */ /*TargetOpcode::G_SMAX*//*Label 85*/ GIMT_Encode4(6215),
     /*  826 */ /*TargetOpcode::G_UMIN*//*Label 86*/ GIMT_Encode4(6249),
     /*  830 */ /*TargetOpcode::G_UMAX*//*Label 87*/ GIMT_Encode4(6283),
     /*  834 */ /*TargetOpcode::G_ABS*//*Label 88*/ GIMT_Encode4(6317), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  846 */ /*TargetOpcode::G_BR*//*Label 89*/ GIMT_Encode4(6329), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  866 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 90*/ GIMT_Encode4(6341),
     /*  870 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 91*/ GIMT_Encode4(6471),
     /*  874 */ /*TargetOpcode::G_SHUFFLE_VECTOR*//*Label 92*/ GIMT_Encode4(6848), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  914 */ /*TargetOpcode::G_BITREVERSE*//*Label 93*/ GIMT_Encode4(6914), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  966 */ /*TargetOpcode::G_FSQRT*//*Label 94*/ GIMT_Encode4(7003),
     /*  970 */ // Label 0: @970
     /*  970 */ GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(981), // Rule ID 13 //
     /*  975 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule13Enabled),
     /*  978 */   // MIs[0] d
     /*  978 */   // No operand predicates
     /*  978 */   // MIs[0] s
     /*  978 */   // No operand predicates
     /*  978 */   // Combiner Rule #13: copy_prop
     /*  978 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /*  981 */ // Label 96: @981
     /*  981 */ GIM_Reject,
     /*  982 */ // Label 1: @982
     /*  982 */ GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(993), // Rule ID 16 //
     /*  987 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /*  990 */   // Combiner Rule #16: add_p2i_to_ptradd; wip_match_opcode 'G_ADD'
     /*  990 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner8),
     /*  993 */ // Label 97: @993
     /*  993 */ GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1004), // Rule ID 93 //
     /*  998 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 1001 */   // Combiner Rule #77: propagate_undef_any_op; wip_match_opcode 'G_ADD'
     /* 1001 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 1004 */ // Label 98: @1004
     /* 1004 */ GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1015), // Rule ID 140 //
     /* 1009 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule102Enabled),
     /* 1012 */   // Combiner Rule #102: simplify_add_to_sub; wip_match_opcode 'G_ADD'
     /* 1012 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner53),
     /* 1015 */ // Label 99: @1015
     /* 1015 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1026), // Rule ID 230 //
     /* 1020 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 1023 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_ADD'
     /* 1023 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 1026 */ // Label 100: @1026
     /* 1026 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1037), // Rule ID 278 //
     /* 1031 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 1034 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_ADD'
     /* 1034 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 1037 */ // Label 101: @1037
     /* 1037 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1048), // Rule ID 307 //
     /* 1042 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 1045 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_ADD'
     /* 1045 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 1048 */ // Label 102: @1048
     /* 1048 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1082), // Rule ID 0 //
     /* 1053 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule0Enabled),
     /* 1056 */   // MIs[0] root
     /* 1056 */   // No operand predicates
     /* 1056 */   // MIs[0] sub
     /* 1056 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1060 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1064 */   // MIs[1] Operand 1
     /* 1064 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 1068 */   // MIs[1] A
     /* 1068 */   // No operand predicates
     /* 1068 */   // MIs[0] B
     /* 1068 */   // No operand predicates
     /* 1068 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1070 */   // Combiner Rule #0: ZeroMinusAPlusB
     /* 1070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1073 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1075 */   GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 1077 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /* 1081 */   GIR_EraseRootFromParent_Done,
     /* 1082 */ // Label 103: @1082
     /* 1082 */ GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1119), // Rule ID 12 //
     /* 1087 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule12Enabled),
     /* 1090 */   // MIs[0] root
     /* 1090 */   // No operand predicates
     /* 1090 */   // MIs[0] sub
     /* 1090 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1094 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1098 */   // MIs[1] A
     /* 1098 */   // No operand predicates
     /* 1098 */   // MIs[1] c1
     /* 1098 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1102 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1106 */   // MIs[2] imm1
     /* 1106 */   // No operand predicates
     /* 1106 */   // MIs[0] c2
     /* 1106 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1110 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1114 */   // MIs[3] imm2
     /* 1114 */   // No operand predicates
     /* 1114 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1116 */   // Combiner Rule #12: AMinusC1PlusC2
     /* 1116 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner4),
     /* 1119 */ // Label 104: @1119
     /* 1119 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1153), // Rule ID 3 //
     /* 1124 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule3Enabled),
     /* 1127 */   // MIs[0] root
     /* 1127 */   // No operand predicates
     /* 1127 */   // MIs[0] sub
     /* 1127 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1131 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1135 */   // MIs[1] B
     /* 1135 */   // No operand predicates
     /* 1135 */   // MIs[1] A
     /* 1135 */   // No operand predicates
     /* 1135 */   // MIs[0] A
     /* 1135 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1140 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1145 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1147 */   // Combiner Rule #3: BMinusAPlusA
     /* 1147 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1152 */   GIR_EraseRootFromParent_Done,
     /* 1153 */ // Label 105: @1153
     /* 1153 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1187), // Rule ID 130 //
     /* 1158 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule93Enabled),
     /* 1161 */   // MIs[0] dst
     /* 1161 */   // No operand predicates
     /* 1161 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 1161 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1165 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1169 */   // MIs[1] src
     /* 1169 */   // No operand predicates
     /* 1169 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1169 */   // No operand predicates
     /* 1169 */   // MIs[0] __add_sub_reg_match_0.x
     /* 1169 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1174 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1179 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1181 */   // Combiner Rule #93: add_sub_reg @ [__add_sub_reg_match_0[1]]
     /* 1181 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1186 */   GIR_EraseRootFromParent_Done,
     /* 1187 */ // Label 106: @1187
     /* 1187 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1232), // Rule ID 5 //
     /* 1192 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1195 */   // MIs[0] root
     /* 1195 */   // No operand predicates
     /* 1195 */   // MIs[0] sub1
     /* 1195 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1199 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1203 */   // MIs[1] A
     /* 1203 */   // No operand predicates
     /* 1203 */   // MIs[1] B
     /* 1203 */   // No operand predicates
     /* 1203 */   // MIs[0] sub2
     /* 1203 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1207 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1211 */   // MIs[2] B
     /* 1211 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1216 */   // MIs[2] C
     /* 1216 */   // No operand predicates
     /* 1216 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1218 */   // Combiner Rule #5: AMinusBPlusBMinusC
     /* 1218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1221 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1223 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 1227 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 1231 */   GIR_EraseRootFromParent_Done,
     /* 1232 */ // Label 107: @1232
     /* 1232 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1277), // Rule ID 4 //
     /* 1237 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule4Enabled),
     /* 1240 */   // MIs[0] root
     /* 1240 */   // No operand predicates
     /* 1240 */   // MIs[0] sub1
     /* 1240 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1244 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1248 */   // MIs[1] A
     /* 1248 */   // No operand predicates
     /* 1248 */   // MIs[1] B
     /* 1248 */   // No operand predicates
     /* 1248 */   // MIs[0] sub2
     /* 1248 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1252 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1256 */   // MIs[2] C
     /* 1256 */   // No operand predicates
     /* 1256 */   // MIs[2] A
     /* 1256 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 1261 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1263 */   // Combiner Rule #4: AMinusBPlusCMinusA
     /* 1263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1266 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1268 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 1272 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 1276 */   GIR_EraseRootFromParent_Done,
     /* 1277 */ // Label 108: @1277
     /* 1277 */ GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1312), // Rule ID 39 //
     /* 1282 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule37Enabled),
     /* 1285 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 1291 */   // MIs[0] root
     /* 1291 */   // No operand predicates
     /* 1291 */   // MIs[0] left
     /* 1291 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1295 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1299 */   // MIs[1] imm1
     /* 1299 */   // No operand predicates
     /* 1299 */   // MIs[0] right
     /* 1299 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1303 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1307 */   // MIs[2] imm2
     /* 1307 */   // No operand predicates
     /* 1307 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1309 */   // Combiner Rule #37: add_of_vscale
     /* 1309 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1312 */ // Label 109: @1312
     /* 1312 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1346), // Rule ID 1 //
     /* 1317 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 1320 */   // MIs[0] root
     /* 1320 */   // No operand predicates
     /* 1320 */   // MIs[0] A
     /* 1320 */   // No operand predicates
     /* 1320 */   // MIs[0] sub
     /* 1320 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1324 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1328 */   // MIs[1] Operand 1
     /* 1328 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 1332 */   // MIs[1] B
     /* 1332 */   // No operand predicates
     /* 1332 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1334 */   // Combiner Rule #1: APlusZeroMinusB
     /* 1334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1337 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1339 */   GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 1341 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 1345 */   GIR_EraseRootFromParent_Done,
     /* 1346 */ // Label 110: @1346
     /* 1346 */ GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1380), // Rule ID 2 //
     /* 1351 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule2Enabled),
     /* 1354 */   // MIs[0] root
     /* 1354 */   // No operand predicates
     /* 1354 */   // MIs[0] A
     /* 1354 */   // No operand predicates
     /* 1354 */   // MIs[0] sub
     /* 1354 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1358 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1362 */   // MIs[1] B
     /* 1362 */   // No operand predicates
     /* 1362 */   // MIs[1] A
     /* 1362 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1367 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1372 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1374 */   // Combiner Rule #2: APlusBMinusB
     /* 1374 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1379 */   GIR_EraseRootFromParent_Done,
     /* 1380 */ // Label 111: @1380
     /* 1380 */ GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1414), // Rule ID 129 //
     /* 1385 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule93Enabled),
     /* 1388 */   // MIs[0] dst
     /* 1388 */   // No operand predicates
     /* 1388 */   // MIs[0] __add_sub_reg_match_0.x
     /* 1388 */   // No operand predicates
     /* 1388 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 1388 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1392 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1396 */   // MIs[1] src
     /* 1396 */   // No operand predicates
     /* 1396 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1396 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1401 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1406 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1408 */   // Combiner Rule #93: add_sub_reg @ [__add_sub_reg_match_0[0]]
     /* 1408 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1413 */   GIR_EraseRootFromParent_Done,
     /* 1414 */ // Label 112: @1414
     /* 1414 */ GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1459), // Rule ID 6 //
     /* 1419 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 1422 */   // MIs[0] root
     /* 1422 */   // No operand predicates
     /* 1422 */   // MIs[0] A
     /* 1422 */   // No operand predicates
     /* 1422 */   // MIs[0] sub1
     /* 1422 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1426 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1430 */   // MIs[1] B
     /* 1430 */   // No operand predicates
     /* 1430 */   // MIs[1] add1
     /* 1430 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1434 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1438 */   // MIs[2] A
     /* 1438 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1443 */   // MIs[2] C
     /* 1443 */   // No operand predicates
     /* 1443 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1445 */   // Combiner Rule #6: APlusBMinusAplusC
     /* 1445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1448 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1450 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 1454 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 1458 */   GIR_EraseRootFromParent_Done,
     /* 1459 */ // Label 113: @1459
     /* 1459 */ GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(1504), // Rule ID 7 //
     /* 1464 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 1467 */   // MIs[0] root
     /* 1467 */   // No operand predicates
     /* 1467 */   // MIs[0] A
     /* 1467 */   // No operand predicates
     /* 1467 */   // MIs[0] sub1
     /* 1467 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1471 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1475 */   // MIs[1] B
     /* 1475 */   // No operand predicates
     /* 1475 */   // MIs[1] add1
     /* 1475 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1479 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1483 */   // MIs[2] C
     /* 1483 */   // No operand predicates
     /* 1483 */   // MIs[2] A
     /* 1483 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1488 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1490 */   // Combiner Rule #7: APlusBMinusCPlusA
     /* 1490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1493 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1495 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 1499 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 1503 */   GIR_EraseRootFromParent_Done,
     /* 1504 */ // Label 114: @1504
     /* 1504 */ GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(1527), // Rule ID 104 //
     /* 1509 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 1512 */   // MIs[0] dst
     /* 1512 */   // No operand predicates
     /* 1512 */   // MIs[0] lhs
     /* 1512 */   // No operand predicates
     /* 1512 */   // MIs[0] Operand 2
     /* 1512 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1516 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1521 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[1]]
     /* 1521 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1526 */   GIR_EraseRootFromParent_Done,
     /* 1527 */ // Label 115: @1527
     /* 1527 */ GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(1538), // Rule ID 148 //
     /* 1532 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule106Enabled),
     /* 1535 */   // MIs[0] root
     /* 1535 */   // No operand predicates
     /* 1535 */   // MIs[0] src1
     /* 1535 */   // No operand predicates
     /* 1535 */   // MIs[0] src2
     /* 1535 */   // No operand predicates
     /* 1535 */   // Combiner Rule #106: reassoc_comm_binops
     /* 1535 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner57),
     /* 1538 */ // Label 116: @1538
     /* 1538 */ GIM_Reject,
     /* 1539 */ // Label 2: @1539
     /* 1539 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1550), // Rule ID 94 //
     /* 1544 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 1547 */   // Combiner Rule #77: propagate_undef_any_op; wip_match_opcode 'G_SUB'
     /* 1547 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 1550 */ // Label 117: @1550
     /* 1550 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1561), // Rule ID 238 //
     /* 1555 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 1558 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_SUB'
     /* 1558 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 1561 */ // Label 118: @1561
     /* 1561 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(1572), // Rule ID 279 //
     /* 1566 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 1569 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_SUB'
     /* 1569 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 1572 */ // Label 119: @1572
     /* 1572 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1583), // Rule ID 304 //
     /* 1577 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 1580 */   // Combiner Rule #186: sub_add_reg; wip_match_opcode 'G_SUB'
     /* 1580 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 1583 */ // Label 120: @1583
     /* 1583 */ GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1594), // Rule ID 338 //
     /* 1588 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule193Enabled),
     /* 1591 */   // Combiner Rule #193: simplify_neg_minmax; wip_match_opcode 'G_SUB'
     /* 1591 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner130),
     /* 1594 */ // Label 121: @1594
     /* 1594 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(1631), // Rule ID 8 //
     /* 1599 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule8Enabled),
     /* 1602 */   // MIs[0] root
     /* 1602 */   // No operand predicates
     /* 1602 */   // MIs[0] add
     /* 1602 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1606 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1610 */   // MIs[1] A
     /* 1610 */   // No operand predicates
     /* 1610 */   // MIs[1] c1
     /* 1610 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1614 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1618 */   // MIs[2] imm1
     /* 1618 */   // No operand predicates
     /* 1618 */   // MIs[0] c2
     /* 1618 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1622 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1626 */   // MIs[3] imm2
     /* 1626 */   // No operand predicates
     /* 1626 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1628 */   // Combiner Rule #8: APlusC1MinusC2
     /* 1628 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner0),
     /* 1631 */ // Label 122: @1631
     /* 1631 */ GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(1668), // Rule ID 11 //
     /* 1636 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule11Enabled),
     /* 1639 */   // MIs[0] root
     /* 1639 */   // No operand predicates
     /* 1639 */   // MIs[0] sub1
     /* 1639 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1643 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1647 */   // MIs[1] c1
     /* 1647 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 1651 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1655 */   // MIs[2] imm1
     /* 1655 */   // No operand predicates
     /* 1655 */   // MIs[1] A
     /* 1655 */   // No operand predicates
     /* 1655 */   // MIs[0] c2
     /* 1655 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1659 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1663 */   // MIs[3] imm2
     /* 1663 */   // No operand predicates
     /* 1663 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1665 */   // Combiner Rule #11: C1Minus2MinusC2
     /* 1665 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner3),
     /* 1668 */ // Label 123: @1668
     /* 1668 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(1705), // Rule ID 10 //
     /* 1673 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule10Enabled),
     /* 1676 */   // MIs[0] root
     /* 1676 */   // No operand predicates
     /* 1676 */   // MIs[0] sub1
     /* 1676 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1680 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1684 */   // MIs[1] A
     /* 1684 */   // No operand predicates
     /* 1684 */   // MIs[1] c1
     /* 1684 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1688 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1692 */   // MIs[2] imm1
     /* 1692 */   // No operand predicates
     /* 1692 */   // MIs[0] c2
     /* 1692 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1696 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1700 */   // MIs[3] imm2
     /* 1700 */   // No operand predicates
     /* 1700 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1702 */   // Combiner Rule #10: AMinusC1MinusC2
     /* 1702 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 1705 */ // Label 124: @1705
     /* 1705 */ GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(1748), // Rule ID 158 //
     /* 1710 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule116Enabled),
     /* 1713 */   // MIs[0] dst
     /* 1713 */   // No operand predicates
     /* 1713 */   // MIs[0] Operand 1
     /* 1713 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 1717 */   // MIs[0] and
     /* 1717 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1721 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 1725 */   // MIs[1] x
     /* 1725 */   // No operand predicates
     /* 1725 */   // MIs[1] Operand 2
     /* 1725 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 1729 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner7),
     /* 1733 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1735 */   // Combiner Rule #116: neg_and_one_to_sext_inreg
     /* 1735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 1738 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 1740 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 1744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1747 */   GIR_EraseRootFromParent_Done,
     /* 1748 */ // Label 125: @1748
     /* 1748 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(1785), // Rule ID 9 //
     /* 1753 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule9Enabled),
     /* 1756 */   // MIs[0] root
     /* 1756 */   // No operand predicates
     /* 1756 */   // MIs[0] c2
     /* 1756 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1760 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1764 */   // MIs[1] imm2
     /* 1764 */   // No operand predicates
     /* 1764 */   // MIs[0] add
     /* 1764 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1768 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1772 */   // MIs[2] A
     /* 1772 */   // No operand predicates
     /* 1772 */   // MIs[2] c1
     /* 1772 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 1776 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1780 */   // MIs[3] imm1
     /* 1780 */   // No operand predicates
     /* 1780 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1782 */   // Combiner Rule #9: C2MinusAPlusC1
     /* 1782 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 1785 */ // Label 126: @1785
     /* 1785 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(1812), // Rule ID 42 //
     /* 1790 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule40Enabled),
     /* 1793 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 1799 */   // MIs[0] root
     /* 1799 */   // No operand predicates
     /* 1799 */   // MIs[0] x
     /* 1799 */   // No operand predicates
     /* 1799 */   // MIs[0] right
     /* 1799 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1803 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1807 */   // MIs[1] imm
     /* 1807 */   // No operand predicates
     /* 1807 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1809 */   // Combiner Rule #40: sub_of_vscale
     /* 1809 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner18),
     /* 1812 */ // Label 127: @1812
     /* 1812 */ GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(1835), // Rule ID 103 //
     /* 1817 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 1820 */   // MIs[0] dst
     /* 1820 */   // No operand predicates
     /* 1820 */   // MIs[0] lhs
     /* 1820 */   // No operand predicates
     /* 1820 */   // MIs[0] Operand 2
     /* 1820 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1824 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1829 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[0]]
     /* 1829 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1834 */   GIR_EraseRootFromParent_Done,
     /* 1835 */ // Label 128: @1835
     /* 1835 */ GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(1856), // Rule ID 15 //
     /* 1840 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /* 1843 */   // MIs[0] d
     /* 1843 */   // No operand predicates
     /* 1843 */   // MIs[0] op1
     /* 1843 */   // No operand predicates
     /* 1843 */   // MIs[0] c
     /* 1843 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1847 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1851 */   // MIs[1] imm
     /* 1851 */   // No operand predicates
     /* 1851 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1853 */   // Combiner Rule #15: sub_to_add
     /* 1853 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 1856 */ // Label 129: @1856
     /* 1856 */ GIM_Reject,
     /* 1857 */ // Label 3: @1857
     /* 1857 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(1868), // Rule ID 77 //
     /* 1862 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 1865 */   // Combiner Rule #71: undef_to_int_zero; wip_match_opcode 'G_MUL'
     /* 1865 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 1868 */ // Label 130: @1868
     /* 1868 */ GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(1879), // Rule ID 235 //
     /* 1873 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 1876 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_MUL'
     /* 1876 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 1879 */ // Label 131: @1879
     /* 1879 */ GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(1890), // Rule ID 308 //
     /* 1884 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 1887 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_MUL'
     /* 1887 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 1890 */ // Label 132: @1890
     /* 1890 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(1930), // Rule ID 17 //
     /* 1895 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 1898 */   // MIs[0] dst
     /* 1898 */   GIM_RecordRegType, /*MI*/0, /*Op*/0, /*TempTypeIdx*/uint8_t(-1),
     /* 1902 */   // MIs[0] x
     /* 1902 */   // No operand predicates
     /* 1902 */   // MIs[0] Operand 2
     /* 1902 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 1906 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 1909 */   GIR_BuildConstant, /*TempRegID*/0, /*Val*/GIMT_Encode8(0),
     /* 1919 */   // Combiner Rule #17: mul_by_neg_one
     /* 1919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1922 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 1924 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 1927 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 1929 */   GIR_EraseRootFromParent_Done,
     /* 1930 */ // Label 133: @1930
     /* 1930 */ GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(1965), // Rule ID 40 //
     /* 1935 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule38Enabled),
     /* 1938 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 1944 */   // MIs[0] root
     /* 1944 */   // No operand predicates
     /* 1944 */   // MIs[0] left
     /* 1944 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1948 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1952 */   // MIs[1] scale
     /* 1952 */   // No operand predicates
     /* 1952 */   // MIs[0] x
     /* 1952 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1956 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1960 */   // MIs[2] imm1
     /* 1960 */   // No operand predicates
     /* 1960 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1962 */   // Combiner Rule #38: mul_of_vscale
     /* 1962 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner16),
     /* 1965 */ // Label 134: @1965
     /* 1965 */ GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(1988), // Rule ID 122 //
     /* 1970 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 1973 */   // MIs[0] dst
     /* 1973 */   // No operand predicates
     /* 1973 */   // MIs[0] lhs
     /* 1973 */   // No operand predicates
     /* 1973 */   // MIs[0] zero
     /* 1973 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1977 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 1982 */   // Combiner Rule #86: binop_right_to_zero
     /* 1982 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 1987 */   GIR_EraseRootFromParent_Done,
     /* 1988 */ // Label 135: @1988
     /* 1988 */ GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(2011), // Rule ID 127 //
     /* 1993 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule91Enabled),
     /* 1996 */   // MIs[0] dst
     /* 1996 */   // No operand predicates
     /* 1996 */   // MIs[0] x
     /* 1996 */   // No operand predicates
     /* 1996 */   // MIs[0] Operand 2
     /* 1996 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 2000 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2005 */   // Combiner Rule #91: right_identity_one_int
     /* 2005 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2010 */   GIR_EraseRootFromParent_Done,
     /* 2011 */ // Label 136: @2011
     /* 2011 */ GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(2022), // Rule ID 14 //
     /* 2016 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule14Enabled),
     /* 2019 */   // MIs[0] d
     /* 2019 */   // No operand predicates
     /* 2019 */   // MIs[0] op1
     /* 2019 */   // No operand predicates
     /* 2019 */   // MIs[0] op2
     /* 2019 */   // No operand predicates
     /* 2019 */   // Combiner Rule #14: mul_to_shl
     /* 2019 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner6),
     /* 2022 */ // Label 137: @2022
     /* 2022 */ GIM_Reject,
     /* 2023 */ // Label 4: @2023
     /* 2023 */ GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2034), // Rule ID 118 //
     /* 2028 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2031 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_SDIV'
     /* 2031 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 2034 */ // Label 138: @2034
     /* 2034 */ GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(2045), // Rule ID 210 //
     /* 2039 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule152Enabled),
     /* 2042 */   // Combiner Rule #152: div_rem_to_divrem; wip_match_opcode 'G_SDIV'
     /* 2042 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2045 */ // Label 139: @2045
     /* 2045 */ GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(2056), // Rule ID 241 //
     /* 2050 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 2053 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_SDIV'
     /* 2053 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2056 */ // Label 140: @2056
     /* 2056 */ GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(2067), // Rule ID 259 //
     /* 2061 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule171Enabled),
     /* 2064 */   // Combiner Rule #171: sdiv_by_const; wip_match_opcode 'G_SDIV'
     /* 2064 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner108),
     /* 2067 */ // Label 141: @2067
     /* 2067 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(2078), // Rule ID 284 //
     /* 2072 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 2075 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_SDIV'
     /* 2075 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2078 */ // Label 142: @2078
     /* 2078 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(2095), // Rule ID 260 //
     /* 2083 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 2086 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 2092 */   // MIs[0] dst
     /* 2092 */   // No operand predicates
     /* 2092 */   // MIs[0] x
     /* 2092 */   // No operand predicates
     /* 2092 */   // MIs[0] y
     /* 2092 */   // No operand predicates
     /* 2092 */   // Combiner Rule #172: sdiv_by_pow2
     /* 2092 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 2095 */ // Label 143: @2095
     /* 2095 */ GIM_Reject,
     /* 2096 */ // Label 5: @2096
     /* 2096 */ GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(2107), // Rule ID 80 //
     /* 2101 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 2104 */   // Combiner Rule #73: binop_left_undef_to_zero; wip_match_opcode 'G_UDIV'
     /* 2104 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 2107 */ // Label 144: @2107
     /* 2107 */ GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(2118), // Rule ID 119 //
     /* 2112 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2115 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_UDIV'
     /* 2115 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 2118 */ // Label 145: @2118
     /* 2118 */ GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(2129), // Rule ID 211 //
     /* 2123 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule152Enabled),
     /* 2126 */   // Combiner Rule #152: div_rem_to_divrem; wip_match_opcode 'G_UDIV'
     /* 2126 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2129 */ // Label 146: @2129
     /* 2129 */ GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(2140), // Rule ID 240 //
     /* 2134 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 2137 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_UDIV'
     /* 2137 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2140 */ // Label 147: @2140
     /* 2140 */ GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(2151), // Rule ID 258 //
     /* 2145 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule170Enabled),
     /* 2148 */   // Combiner Rule #170: udiv_by_const; wip_match_opcode 'G_UDIV'
     /* 2148 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 2151 */ // Label 148: @2151
     /* 2151 */ GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(2162), // Rule ID 286 //
     /* 2156 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 2159 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_UDIV'
     /* 2159 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2162 */ // Label 149: @2162
     /* 2162 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2179), // Rule ID 261 //
     /* 2167 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule173Enabled),
     /* 2170 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 2176 */   // MIs[0] dst
     /* 2176 */   // No operand predicates
     /* 2176 */   // MIs[0] x
     /* 2176 */   // No operand predicates
     /* 2176 */   // MIs[0] y
     /* 2176 */   // No operand predicates
     /* 2176 */   // Combiner Rule #173: udiv_by_pow2
     /* 2176 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner110),
     /* 2179 */ // Label 150: @2179
     /* 2179 */ GIM_Reject,
     /* 2180 */ // Label 6: @2180
     /* 2180 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2191), // Rule ID 120 //
     /* 2185 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2188 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_SREM'
     /* 2188 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 2191 */ // Label 151: @2191
     /* 2191 */ GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(2202), // Rule ID 212 //
     /* 2196 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule152Enabled),
     /* 2199 */   // Combiner Rule #152: div_rem_to_divrem; wip_match_opcode 'G_SREM'
     /* 2199 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2202 */ // Label 152: @2202
     /* 2202 */ GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(2213), // Rule ID 243 //
     /* 2207 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 2210 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_SREM'
     /* 2210 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2213 */ // Label 153: @2213
     /* 2213 */ GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(2224), // Rule ID 285 //
     /* 2218 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 2221 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_SREM'
     /* 2221 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2224 */ // Label 154: @2224
     /* 2224 */ GIM_Reject,
     /* 2225 */ // Label 7: @2225
     /* 2225 */ GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(2236), // Rule ID 81 //
     /* 2230 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 2233 */   // Combiner Rule #73: binop_left_undef_to_zero; wip_match_opcode 'G_UREM'
     /* 2233 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 2236 */ // Label 155: @2236
     /* 2236 */ GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(2247), // Rule ID 121 //
     /* 2241 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2244 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_UREM'
     /* 2244 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 2247 */ // Label 156: @2247
     /* 2247 */ GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(2258), // Rule ID 169 //
     /* 2252 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule127Enabled),
     /* 2255 */   // Combiner Rule #127: urem_pow2_to_mask; wip_match_opcode 'G_UREM'
     /* 2255 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner74),
     /* 2258 */ // Label 157: @2258
     /* 2258 */ GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(2269), // Rule ID 213 //
     /* 2263 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule152Enabled),
     /* 2266 */   // Combiner Rule #152: div_rem_to_divrem; wip_match_opcode 'G_UREM'
     /* 2266 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2269 */ // Label 158: @2269
     /* 2269 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(2280), // Rule ID 242 //
     /* 2274 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 2277 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_UREM'
     /* 2277 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2280 */ // Label 159: @2280
     /* 2280 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(2291), // Rule ID 287 //
     /* 2285 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 2288 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_UREM'
     /* 2288 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2291 */ // Label 160: @2291
     /* 2291 */ GIM_Reject,
     /* 2292 */ // Label 8: @2292
     /* 2292 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(2303), // Rule ID 72 //
     /* 2297 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 2300 */   // Combiner Rule #68: load_and_mask; wip_match_opcode 'G_AND'
     /* 2300 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 2303 */ // Label 161: @2303
     /* 2303 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(2314), // Rule ID 76 //
     /* 2308 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 2311 */   // Combiner Rule #71: undef_to_int_zero; wip_match_opcode 'G_AND'
     /* 2311 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 2314 */ // Label 162: @2314
     /* 2314 */ GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(2325), // Rule ID 141 //
     /* 2319 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 2322 */   // Combiner Rule #103: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_AND'
     /* 2322 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 2325 */ // Label 163: @2325
     /* 2325 */ GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(2336), // Rule ID 161 //
     /* 2330 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule119Enabled),
     /* 2333 */   // Combiner Rule #119: narrow_binop_feeding_and; wip_match_opcode 'G_AND'
     /* 2333 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 2336 */ // Label 164: @2336
     /* 2336 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(2347), // Rule ID 166 //
     /* 2341 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule124Enabled),
     /* 2344 */   // Combiner Rule #124: redundant_and; wip_match_opcode 'G_AND'
     /* 2344 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner71),
     /* 2347 */ // Label 165: @2347
     /* 2347 */ GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(2358), // Rule ID 183 //
     /* 2352 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule141Enabled),
     /* 2355 */   // Combiner Rule #141: overlapping_and; wip_match_opcode 'G_AND'
     /* 2355 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner83),
     /* 2358 */ // Label 166: @2358
     /* 2358 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(2369), // Rule ID 232 //
     /* 2363 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 2366 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_AND'
     /* 2366 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2369 */ // Label 167: @2369
     /* 2369 */ GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(2380), // Rule ID 269 //
     /* 2374 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 2377 */   // Combiner Rule #176: and_or_disjoint_mask; wip_match_opcode 'G_AND'
     /* 2377 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 2380 */ // Label 168: @2380
     /* 2380 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2391), // Rule ID 281 //
     /* 2385 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 2388 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_AND'
     /* 2388 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2391 */ // Label 169: @2391
     /* 2391 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2402), // Rule ID 309 //
     /* 2396 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 2399 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_AND'
     /* 2399 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 2402 */ // Label 170: @2402
     /* 2402 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2413), // Rule ID 336 //
     /* 2407 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 2410 */   // Combiner Rule #191: match_ands; wip_match_opcode 'G_AND'
     /* 2410 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 2413 */ // Label 171: @2413
     /* 2413 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2511), // Rule ID 154 //
     /* 2418 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule112Enabled),
     /* 2421 */   // MIs[0] root
     /* 2421 */   // No operand predicates
     /* 2421 */   // MIs[0] d1
     /* 2421 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2425 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2429 */   // MIs[1] p
     /* 2429 */   // No operand predicates
     /* 2429 */   // MIs[1] s1
     /* 2429 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 2433 */   // MIs[1] Operand 3
     /* 2433 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 2437 */   // MIs[0] d2
     /* 2437 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2441 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2445 */   // MIs[2] p
     /* 2445 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 2450 */   // MIs[2] s2
     /* 2450 */   // No operand predicates
     /* 2450 */   // MIs[2] Operand 3
     /* 2450 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 2454 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner5),
     /* 2458 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2460 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 2463 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 2473 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2476 */   // Combiner Rule #112: double_icmp_zero_and_combine
     /* 2476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 2479 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2484 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 2488 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 2492 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2496 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 2500 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 2504 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 2507 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2510 */   GIR_EraseRootFromParent_Done,
     /* 2511 */ // Label 172: @2511
     /* 2511 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2548), // Rule ID 225 //
     /* 2516 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule162Enabled),
     /* 2519 */   // MIs[0] root
     /* 2519 */   // No operand predicates
     /* 2519 */   // MIs[0] shift
     /* 2519 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2523 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 2527 */   // MIs[1] x
     /* 2527 */   // No operand predicates
     /* 2527 */   // MIs[1] lsb
     /* 2527 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 2531 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2535 */   // MIs[2] imm1
     /* 2535 */   // No operand predicates
     /* 2535 */   // MIs[0] mask
     /* 2535 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2539 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2543 */   // MIs[3] imm2
     /* 2543 */   // No operand predicates
     /* 2543 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2545 */   // Combiner Rule #162: bitfield_extract_from_and
     /* 2545 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner100),
     /* 2548 */ // Label 173: @2548
     /* 2548 */ GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(2572), // Rule ID 113 //
     /* 2553 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 2556 */   // MIs[0] dst
     /* 2556 */   // No operand predicates
     /* 2556 */   // MIs[0] src
     /* 2556 */   // No operand predicates
     /* 2556 */   // MIs[0] src
     /* 2556 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 2561 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2566 */   // Combiner Rule #84: binop_same_val @ [__binop_same_val_match_0[0]]
     /* 2566 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2571 */   GIR_EraseRootFromParent_Done,
     /* 2572 */ // Label 174: @2572
     /* 2572 */ GIM_Reject,
     /* 2573 */ // Label 9: @2573
     /* 2573 */ GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(2584), // Rule ID 78 //
     /* 2578 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 2581 */   // Combiner Rule #72: undef_to_negative_one; wip_match_opcode 'G_OR'
     /* 2581 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 2584 */ // Label 175: @2584
     /* 2584 */ GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(2595), // Rule ID 142 //
     /* 2589 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 2592 */   // Combiner Rule #103: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_OR'
     /* 2592 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 2595 */ // Label 176: @2595
     /* 2595 */ GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(2606), // Rule ID 168 //
     /* 2600 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule126Enabled),
     /* 2603 */   // Combiner Rule #126: redundant_or; wip_match_opcode 'G_OR'
     /* 2603 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner73),
     /* 2606 */ // Label 177: @2606
     /* 2606 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(2617), // Rule ID 209 //
     /* 2611 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 2614 */   // Combiner Rule #151: load_or_combine; wip_match_opcode 'G_OR'
     /* 2614 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 2617 */ // Label 178: @2617
     /* 2617 */ GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(2628), // Rule ID 214 //
     /* 2622 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2625 */   // Combiner Rule #153: funnel_shift_from_or_shift; wip_match_opcode 'G_OR'
     /* 2625 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2628 */ // Label 179: @2628
     /* 2628 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2639), // Rule ID 236 //
     /* 2633 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 2636 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_OR'
     /* 2636 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2639 */ // Label 180: @2639
     /* 2639 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2650), // Rule ID 282 //
     /* 2644 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 2647 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_OR'
     /* 2647 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2650 */ // Label 181: @2650
     /* 2650 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(2661), // Rule ID 310 //
     /* 2655 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 2658 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_OR'
     /* 2658 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 2661 */ // Label 182: @2661
     /* 2661 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(2672), // Rule ID 337 //
     /* 2666 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 2669 */   // Combiner Rule #192: match_ors; wip_match_opcode 'G_OR'
     /* 2669 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner129),
     /* 2672 */ // Label 183: @2672
     /* 2672 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(2770), // Rule ID 155 //
     /* 2677 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule113Enabled),
     /* 2680 */   // MIs[0] root
     /* 2680 */   // No operand predicates
     /* 2680 */   // MIs[0] d1
     /* 2680 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2684 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2688 */   // MIs[1] p
     /* 2688 */   // No operand predicates
     /* 2688 */   // MIs[1] s1
     /* 2688 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 2692 */   // MIs[1] Operand 3
     /* 2692 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 2696 */   // MIs[0] d2
     /* 2696 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2700 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2704 */   // MIs[2] p
     /* 2704 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 2709 */   // MIs[2] s2
     /* 2709 */   // No operand predicates
     /* 2709 */   // MIs[2] Operand 3
     /* 2709 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 2713 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner6),
     /* 2717 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2719 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 2722 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 2732 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2735 */   // Combiner Rule #113: double_icmp_zero_or_combine
     /* 2735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 2738 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2743 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 2747 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 2751 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2755 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 2759 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 2763 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 2766 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2769 */   GIR_EraseRootFromParent_Done,
     /* 2770 */ // Label 184: @2770
     /* 2770 */ GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(2794), // Rule ID 114 //
     /* 2775 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 2778 */   // MIs[0] dst
     /* 2778 */   // No operand predicates
     /* 2778 */   // MIs[0] src
     /* 2778 */   // No operand predicates
     /* 2778 */   // MIs[0] src
     /* 2778 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 2783 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2788 */   // Combiner Rule #84: binop_same_val @ [__binop_same_val_match_0[1]]
     /* 2788 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2793 */   GIR_EraseRootFromParent_Done,
     /* 2794 */ // Label 185: @2794
     /* 2794 */ GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(2817), // Rule ID 105 //
     /* 2799 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 2802 */   // MIs[0] dst
     /* 2802 */   // No operand predicates
     /* 2802 */   // MIs[0] lhs
     /* 2802 */   // No operand predicates
     /* 2802 */   // MIs[0] Operand 2
     /* 2802 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2806 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2811 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[2]]
     /* 2811 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2816 */   GIR_EraseRootFromParent_Done,
     /* 2817 */ // Label 186: @2817
     /* 2817 */ GIM_Reject,
     /* 2818 */ // Label 10: @2818
     /* 2818 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(2829), // Rule ID 95 //
     /* 2823 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 2826 */   // Combiner Rule #77: propagate_undef_any_op; wip_match_opcode 'G_XOR'
     /* 2826 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 2829 */ // Label 187: @2829
     /* 2829 */ GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(2840), // Rule ID 143 //
     /* 2834 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 2837 */   // Combiner Rule #103: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_XOR'
     /* 2837 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 2840 */ // Label 188: @2840
     /* 2840 */ GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(2851), // Rule ID 173 //
     /* 2845 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule131Enabled),
     /* 2848 */   // Combiner Rule #131: not_cmp_fold; wip_match_opcode 'G_XOR'
     /* 2848 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner78),
     /* 2851 */ // Label 189: @2851
     /* 2851 */ GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(2862), // Rule ID 197 //
     /* 2856 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule147Enabled),
     /* 2859 */   // Combiner Rule #147: xor_of_and_with_same_reg; wip_match_opcode 'G_XOR'
     /* 2859 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner89),
     /* 2862 */ // Label 190: @2862
     /* 2862 */ GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(2873), // Rule ID 239 //
     /* 2867 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 2870 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_XOR'
     /* 2870 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 2873 */ // Label 191: @2873
     /* 2873 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(2884), // Rule ID 283 //
     /* 2878 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 2881 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_XOR'
     /* 2881 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 2884 */ // Label 192: @2884
     /* 2884 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(2895), // Rule ID 311 //
     /* 2889 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 2892 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_XOR'
     /* 2892 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 2895 */ // Label 193: @2895
     /* 2895 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(2918), // Rule ID 106 //
     /* 2900 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 2903 */   // MIs[0] dst
     /* 2903 */   // No operand predicates
     /* 2903 */   // MIs[0] lhs
     /* 2903 */   // No operand predicates
     /* 2903 */   // MIs[0] Operand 2
     /* 2903 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2907 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2912 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[3]]
     /* 2912 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2917 */   GIR_EraseRootFromParent_Done,
     /* 2918 */ // Label 194: @2918
     /* 2918 */ GIM_Reject,
     /* 2919 */ // Label 11: @2919
     /* 2919 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(2930), // Rule ID 139 //
     /* 2924 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule101Enabled),
     /* 2927 */   // Combiner Rule #101: extend_through_phis; wip_match_opcode 'G_PHI'
     /* 2927 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 2930 */ // Label 195: @2930
     /* 2930 */ GIM_Reject,
     /* 2931 */ // Label 12: @2931
     /* 2931 */ GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(2942), // Rule ID 347 //
     /* 2936 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule202Enabled),
     /* 2939 */   // Combiner Rule #202: unmerge_anyext_build_vector; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2939 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner139),
     /* 2942 */ // Label 196: @2942
     /* 2942 */ GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(2953), // Rule ID 348 //
     /* 2947 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule203Enabled),
     /* 2950 */   // Combiner Rule #203: unmerge_merge; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2950 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner140),
     /* 2953 */ // Label 197: @2953
     /* 2953 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(2964), // Rule ID 350 //
     /* 2958 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule205Enabled),
     /* 2961 */   // Combiner Rule #205: unmerge_cst; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2961 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner142),
     /* 2964 */ // Label 198: @2964
     /* 2964 */ GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(2975), // Rule ID 351 //
     /* 2969 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule206Enabled),
     /* 2972 */   // Combiner Rule #206: unmerge_undef; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2972 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner143),
     /* 2975 */ // Label 199: @2975
     /* 2975 */ GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(2986), // Rule ID 352 //
     /* 2980 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule207Enabled),
     /* 2983 */   // Combiner Rule #207: unmerge_dead_to_trunc; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2983 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner144),
     /* 2986 */ // Label 200: @2986
     /* 2986 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(2997), // Rule ID 353 //
     /* 2991 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule208Enabled),
     /* 2994 */   // Combiner Rule #208: unmerge_zext_to_zext; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2994 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner145),
     /* 2997 */ // Label 201: @2997
     /* 2997 */ GIM_Reject,
     /* 2998 */ // Label 13: @2998
     /* 2998 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(3009), // Rule ID 349 //
     /* 3003 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule204Enabled),
     /* 3006 */   // Combiner Rule #204: merge_unmerge; wip_match_opcode 'G_MERGE_VALUES'
     /* 3006 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner141),
     /* 3009 */ // Label 202: @3009
     /* 3009 */ GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(3071),
     /* 3014 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 3017 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(3038), // Rule ID 354 //
     /* 3022 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule209Enabled),
     /* 3025 */     // MIs[0] root
     /* 3025 */     // No operand predicates
     /* 3025 */     // MIs[0] x
     /* 3025 */     // No operand predicates
     /* 3025 */     // MIs[0] undef
     /* 3025 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 3029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3035 */     // Combiner Rule #209: merge_of_x_and_undef
     /* 3035 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner146),
     /* 3038 */   // Label 204: @3038
     /* 3038 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(3070), // Rule ID 355 //
     /* 3043 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule210Enabled),
     /* 3046 */     // MIs[0] root
     /* 3046 */     // No operand predicates
     /* 3046 */     // MIs[0] x
     /* 3046 */     // No operand predicates
     /* 3046 */     // MIs[0] zero
     /* 3046 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 3050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3054 */     // MIs[1] Operand 1
     /* 3054 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/1, GIMT_Encode8(0),
     /* 3065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3067 */     // Combiner Rule #210: merge_of_x_and_zero
     /* 3067 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner147),
     /* 3070 */   // Label 205: @3070
     /* 3070 */   GIM_Reject,
     /* 3071 */ // Label 203: @3071
     /* 3071 */ GIM_Reject,
     /* 3072 */ // Label 14: @3072
     /* 3072 */ GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(3083), // Rule ID 68 //
     /* 3077 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule66Enabled),
     /* 3080 */   // Combiner Rule #66: extract_all_elts_from_build_vector; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3080 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner28),
     /* 3083 */ // Label 206: @3083
     /* 3083 */ GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(3094), // Rule ID 97 //
     /* 3088 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 3091 */   // Combiner Rule #78: propagate_undef_all_ops; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3091 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 3094 */ // Label 207: @3094
     /* 3094 */ GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(3105), // Rule ID 132 //
     /* 3099 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 3102 */   // Combiner Rule #94: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3102 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 3105 */ // Label 208: @3105
     /* 3105 */ GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(3119), // Rule ID 346 //
     /* 3110 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule201Enabled),
     /* 3113 */   GIM_CheckNumOperandsGE, /*MI*/0, /*Expected*/2,
     /* 3116 */   // MIs[0] dst
     /* 3116 */   // No operand predicates
     /* 3116 */   // MIs[0] unused
     /* 3116 */   // No operand predicates
     /* 3116 */   // Combiner Rule #201: combine_use_vector_truncate
     /* 3116 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner138),
     /* 3119 */ // Label 209: @3119
     /* 3119 */ GIM_Reject,
     /* 3120 */ // Label 15: @3120
     /* 3120 */ GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(3131), // Rule ID 131 //
     /* 3125 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 3128 */   // Combiner Rule #94: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR_TRUNC'
     /* 3128 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 3131 */ // Label 210: @3131
     /* 3131 */ GIM_Reject,
     /* 3132 */ // Label 16: @3132
     /* 3132 */ GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(3143), // Rule ID 339 //
     /* 3137 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule194Enabled),
     /* 3140 */   // Combiner Rule #194: combine_concat_vector; wip_match_opcode 'G_CONCAT_VECTORS'
     /* 3140 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner131),
     /* 3143 */ // Label 211: @3143
     /* 3143 */ GIM_Reject,
     /* 3144 */ // Label 17: @3144
     /* 3144 */ GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(3165), // Rule ID 124 //
     /* 3149 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3152 */   // MIs[0] dst
     /* 3152 */   // No operand predicates
     /* 3152 */   // MIs[0] t
     /* 3152 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3156 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTTOPTR),
     /* 3160 */   // MIs[1] ptr
     /* 3160 */   // No operand predicates
     /* 3160 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3162 */   // Combiner Rule #88: i2p_to_p2i
     /* 3162 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner46),
     /* 3165 */ // Label 212: @3165
     /* 3165 */ GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(3186), // Rule ID 89 //
     /* 3170 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 3173 */   // MIs[0] dst
     /* 3173 */   // No operand predicates
     /* 3173 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3173 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3177 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3181 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3183 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[3]]
     /* 3183 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 3186 */ // Label 213: @3186
     /* 3186 */ GIM_Reject,
     /* 3187 */ // Label 18: @3187
     /* 3187 */ GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(3198), // Rule ID 123 //
     /* 3192 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3195 */   // Combiner Rule #87: p2i_to_i2p; wip_match_opcode 'G_INTTOPTR'
     /* 3195 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 3198 */ // Label 214: @3198
     /* 3198 */ GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(3219), // Rule ID 90 //
     /* 3203 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 3206 */   // MIs[0] dst
     /* 3206 */   // No operand predicates
     /* 3206 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3206 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3210 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3214 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3216 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[4]]
     /* 3216 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 3219 */ // Label 215: @3219
     /* 3219 */ GIM_Reject,
     /* 3220 */ // Label 19: @3220
     /* 3220 */ GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(3241), // Rule ID 135 //
     /* 3225 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule97Enabled),
     /* 3228 */   // MIs[0] dst
     /* 3228 */   // No operand predicates
     /* 3228 */   // MIs[0] src1
     /* 3228 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3232 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 3236 */   // MIs[1] src0
     /* 3236 */   // No operand predicates
     /* 3236 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3238 */   // Combiner Rule #97: bitcast_bitcast_fold
     /* 3238 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 3241 */ // Label 216: @3241
     /* 3241 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(3262), // Rule ID 87 //
     /* 3246 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 3249 */   // MIs[0] dst
     /* 3249 */   // No operand predicates
     /* 3249 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3249 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3253 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3257 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3259 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[1]]
     /* 3259 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 3262 */ // Label 217: @3262
     /* 3262 */ GIM_Reject,
     /* 3263 */ // Label 20: @3263
     /* 3263 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(3292), // Rule ID 18 //
     /* 3268 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 3271 */   // MIs[0] dst
     /* 3271 */   // No operand predicates
     /* 3271 */   // MIs[0] src
     /* 3271 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3275 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FREEZE),
     /* 3279 */   // MIs[1] __idempotent_prop_match_0.x
     /* 3279 */   // No operand predicates
     /* 3279 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3284 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3286 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[0]]
     /* 3286 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3291 */   GIR_EraseRootFromParent_Done,
     /* 3292 */ // Label 218: @3292
     /* 3292 */ GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(3315), // Rule ID 43 //
     /* 3297 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule41Enabled),
     /* 3300 */   // MIs[0] root
     /* 3300 */   // No operand predicates
     /* 3300 */   // MIs[0] src
     /* 3300 */   // No operand predicates
     /* 3300 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner1),
     /* 3304 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3309 */   // Combiner Rule #41: freeze_of_non_undef_non_poison
     /* 3309 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3314 */   GIR_EraseRootFromParent_Done,
     /* 3315 */ // Label 219: @3315
     /* 3315 */ GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(3326), // Rule ID 44 //
     /* 3320 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule42Enabled),
     /* 3323 */   // MIs[0] dst
     /* 3323 */   // No operand predicates
     /* 3323 */   // MIs[0] src
     /* 3323 */   // No operand predicates
     /* 3323 */   // Combiner Rule #42: push_freeze_to_prevent_poison_from_propagating
     /* 3323 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner19),
     /* 3326 */ // Label 220: @3326
     /* 3326 */ GIM_Reject,
     /* 3327 */ // Label 21: @3327
     /* 3327 */ GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(3338), // Rule ID 69 //
     /* 3332 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3335 */   // Combiner Rule #67: extending_loads; wip_match_opcode 'G_LOAD'
     /* 3335 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 3338 */ // Label 221: @3338
     /* 3338 */ GIM_Reject,
     /* 3339 */ // Label 22: @3339
     /* 3339 */ GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(3350), // Rule ID 70 //
     /* 3344 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3347 */   // Combiner Rule #67: extending_loads; wip_match_opcode 'G_SEXTLOAD'
     /* 3347 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 3350 */ // Label 222: @3350
     /* 3350 */ GIM_Reject,
     /* 3351 */ // Label 23: @3351
     /* 3351 */ GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(3362), // Rule ID 71 //
     /* 3356 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3359 */   // Combiner Rule #67: extending_loads; wip_match_opcode 'G_ZEXTLOAD'
     /* 3359 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 3362 */ // Label 223: @3362
     /* 3362 */ GIM_Reject,
     /* 3363 */ // Label 24: @3363
     /* 3363 */ GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(3374), // Rule ID 99 //
     /* 3368 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule80Enabled),
     /* 3371 */   // Combiner Rule #80: erase_undef_store; wip_match_opcode 'G_STORE'
     /* 3371 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner41),
     /* 3374 */ // Label 224: @3374
     /* 3374 */ GIM_Reject,
     /* 3375 */ // Label 25: @3375
     /* 3375 */ GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(3386), // Rule ID 125 //
     /* 3380 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule89Enabled),
     /* 3383 */   // Combiner Rule #89: anyext_trunc_fold; wip_match_opcode 'G_ANYEXT'
     /* 3383 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner47),
     /* 3386 */ // Label 225: @3386
     /* 3386 */ GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(3397), // Rule ID 256 //
     /* 3391 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 3394 */   // Combiner Rule #168: constant_fold_cast_op; wip_match_opcode 'G_ANYEXT'
     /* 3394 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 3397 */ // Label 226: @3397
     /* 3397 */ GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(3418), // Rule ID 56 //
     /* 3402 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule54Enabled),
     /* 3405 */   // MIs[0] root
     /* 3405 */   // No operand predicates
     /* 3405 */   // MIs[0] select
     /* 3405 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3409 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3413 */   // MIs[1] cond
     /* 3413 */   // No operand predicates
     /* 3413 */   // MIs[1] true
     /* 3413 */   // No operand predicates
     /* 3413 */   // MIs[1] false
     /* 3413 */   // No operand predicates
     /* 3413 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3415 */   // Combiner Rule #54: select_of_anyext
     /* 3415 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 3418 */ // Label 227: @3418
     /* 3418 */ GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(3439), // Rule ID 52 //
     /* 3423 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule50Enabled),
     /* 3426 */   // MIs[0] root
     /* 3426 */   // No operand predicates
     /* 3426 */   // MIs[0] second
     /* 3426 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3430 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3434 */   // MIs[1] src
     /* 3434 */   // No operand predicates
     /* 3434 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3436 */   // Combiner Rule #50: anyext_of_anyext
     /* 3436 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3439 */ // Label 228: @3439
     /* 3439 */ GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(3460), // Rule ID 54 //
     /* 3444 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule52Enabled),
     /* 3447 */   // MIs[0] root
     /* 3447 */   // No operand predicates
     /* 3447 */   // MIs[0] second
     /* 3447 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3451 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 3455 */   // MIs[1] src
     /* 3455 */   // No operand predicates
     /* 3455 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3457 */   // Combiner Rule #52: anyext_of_sext
     /* 3457 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3460 */ // Label 229: @3460
     /* 3460 */ GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(3481), // Rule ID 53 //
     /* 3465 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 3468 */   // MIs[0] root
     /* 3468 */   // No operand predicates
     /* 3468 */   // MIs[0] second
     /* 3468 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3472 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 3476 */   // MIs[1] src
     /* 3476 */   // No operand predicates
     /* 3476 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3478 */   // Combiner Rule #51: anyext_of_zext
     /* 3478 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3481 */ // Label 230: @3481
     /* 3481 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(3502), // Rule ID 88 //
     /* 3486 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 3489 */   // MIs[0] dst
     /* 3489 */   // No operand predicates
     /* 3489 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3489 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3493 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3497 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3499 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[2]]
     /* 3499 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 3502 */ // Label 231: @3502
     /* 3502 */ GIM_Reject,
     /* 3503 */ // Label 26: @3503
     /* 3503 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(3514), // Rule ID 133 //
     /* 3508 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule95Enabled),
     /* 3511 */   // Combiner Rule #95: trunc_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 3511 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 3514 */ // Label 232: @3514
     /* 3514 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(3525), // Rule ID 134 //
     /* 3519 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule96Enabled),
     /* 3522 */   // Combiner Rule #96: trunc_lshr_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 3522 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner50),
     /* 3525 */ // Label 233: @3525
     /* 3525 */ GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(3536), // Rule ID 172 //
     /* 3530 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule130Enabled),
     /* 3533 */   // Combiner Rule #130: trunc_shift; wip_match_opcode 'G_TRUNC'
     /* 3533 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner77),
     /* 3536 */ // Label 234: @3536
     /* 3536 */ GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(3547), // Rule ID 361 //
     /* 3541 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule214Enabled),
     /* 3544 */   // Combiner Rule #214: clamp_i64_to_i16; wip_match_opcode 'G_TRUNC'
     /* 3544 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner151),
     /* 3547 */ // Label 235: @3547
     /* 3547 */ GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(3568), // Rule ID 57 //
     /* 3552 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule55Enabled),
     /* 3555 */   // MIs[0] root
     /* 3555 */   // No operand predicates
     /* 3555 */   // MIs[0] select
     /* 3555 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3559 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3563 */   // MIs[1] cond
     /* 3563 */   // No operand predicates
     /* 3563 */   // MIs[1] true
     /* 3563 */   // No operand predicates
     /* 3563 */   // MIs[1] false
     /* 3563 */   // No operand predicates
     /* 3563 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3565 */   // Combiner Rule #55: select_of_truncate
     /* 3565 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 3568 */ // Label 236: @3568
     /* 3568 */ GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(3597), // Rule ID 59 //
     /* 3573 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule57Enabled),
     /* 3576 */   // MIs[0] root
     /* 3576 */   // No operand predicates
     /* 3576 */   // MIs[0] binop
     /* 3576 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3580 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 3584 */   // MIs[1] x
     /* 3584 */   // No operand predicates
     /* 3584 */   // MIs[1] const
     /* 3584 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3588 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3592 */   // MIs[2] imm
     /* 3592 */   // No operand predicates
     /* 3592 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3594 */   // Combiner Rule #57: narrow_binop_add
     /* 3594 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3597 */ // Label 237: @3597
     /* 3597 */ GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(3626), // Rule ID 62 //
     /* 3602 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule60Enabled),
     /* 3605 */   // MIs[0] root
     /* 3605 */   // No operand predicates
     /* 3605 */   // MIs[0] binop
     /* 3605 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3609 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 3613 */   // MIs[1] x
     /* 3613 */   // No operand predicates
     /* 3613 */   // MIs[1] const
     /* 3613 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3617 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3621 */   // MIs[2] imm
     /* 3621 */   // No operand predicates
     /* 3621 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3623 */   // Combiner Rule #60: narrow_binop_and
     /* 3623 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3626 */ // Label 238: @3626
     /* 3626 */ GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(3655), // Rule ID 61 //
     /* 3631 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule59Enabled),
     /* 3634 */   // MIs[0] root
     /* 3634 */   // No operand predicates
     /* 3634 */   // MIs[0] binop
     /* 3634 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3638 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 3642 */   // MIs[1] x
     /* 3642 */   // No operand predicates
     /* 3642 */   // MIs[1] const
     /* 3642 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3646 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3650 */   // MIs[2] imm
     /* 3650 */   // No operand predicates
     /* 3650 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3652 */   // Combiner Rule #59: narrow_binop_mul
     /* 3652 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3655 */ // Label 239: @3655
     /* 3655 */ GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(3684), // Rule ID 63 //
     /* 3660 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule61Enabled),
     /* 3663 */   // MIs[0] root
     /* 3663 */   // No operand predicates
     /* 3663 */   // MIs[0] binop
     /* 3663 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3667 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 3671 */   // MIs[1] x
     /* 3671 */   // No operand predicates
     /* 3671 */   // MIs[1] const
     /* 3671 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3675 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3679 */   // MIs[2] imm
     /* 3679 */   // No operand predicates
     /* 3679 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3681 */   // Combiner Rule #61: narrow_binop_or
     /* 3681 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3684 */ // Label 240: @3684
     /* 3684 */ GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(3713), // Rule ID 60 //
     /* 3689 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule58Enabled),
     /* 3692 */   // MIs[0] root
     /* 3692 */   // No operand predicates
     /* 3692 */   // MIs[0] binop
     /* 3692 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3696 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 3700 */   // MIs[1] x
     /* 3700 */   // No operand predicates
     /* 3700 */   // MIs[1] const
     /* 3700 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3704 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3708 */   // MIs[2] imm
     /* 3708 */   // No operand predicates
     /* 3708 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3710 */   // Combiner Rule #58: narrow_binop_sub
     /* 3710 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3713 */ // Label 241: @3713
     /* 3713 */ GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(3742), // Rule ID 64 //
     /* 3718 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule62Enabled),
     /* 3721 */   // MIs[0] root
     /* 3721 */   // No operand predicates
     /* 3721 */   // MIs[0] binop
     /* 3721 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3725 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 3729 */   // MIs[1] x
     /* 3729 */   // No operand predicates
     /* 3729 */   // MIs[1] const
     /* 3729 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3733 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3737 */   // MIs[2] imm
     /* 3737 */   // No operand predicates
     /* 3737 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3739 */   // Combiner Rule #62: narrow_binop_xor
     /* 3739 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3742 */ // Label 242: @3742
     /* 3742 */ GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(3763), // Rule ID 47 //
     /* 3747 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule45Enabled),
     /* 3750 */   // MIs[0] root
     /* 3750 */   // No operand predicates
     /* 3750 */   // MIs[0] ext
     /* 3750 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3754 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3758 */   // MIs[1] src
     /* 3758 */   // No operand predicates
     /* 3758 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3760 */   // Combiner Rule #45: truncate_of_anyext
     /* 3760 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 3763 */ // Label 243: @3763
     /* 3763 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(3787), // Rule ID 58 //
     /* 3768 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule56Enabled),
     /* 3771 */   // MIs[0] root
     /* 3771 */   // No operand predicates
     /* 3771 */   // MIs[0] bv
     /* 3771 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3775 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 3779 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 3782 */   // MIs[1] unused
     /* 3782 */   // No operand predicates
     /* 3782 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3784 */   // Combiner Rule #56: buildvector_of_truncate
     /* 3784 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 3787 */ // Label 244: @3787
     /* 3787 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(3808), // Rule ID 46 //
     /* 3792 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule44Enabled),
     /* 3795 */   // MIs[0] root
     /* 3795 */   // No operand predicates
     /* 3795 */   // MIs[0] ext
     /* 3795 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3799 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 3803 */   // MIs[1] src
     /* 3803 */   // No operand predicates
     /* 3803 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3805 */   // Combiner Rule #44: truncate_of_sext
     /* 3805 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 3808 */ // Label 245: @3808
     /* 3808 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(3829), // Rule ID 45 //
     /* 3813 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule43Enabled),
     /* 3816 */   // MIs[0] root
     /* 3816 */   // No operand predicates
     /* 3816 */   // MIs[0] ext
     /* 3816 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3820 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 3824 */   // MIs[1] src
     /* 3824 */   // No operand predicates
     /* 3824 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3826 */   // Combiner Rule #43: truncate_of_zext
     /* 3826 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 3829 */ // Label 246: @3829
     /* 3829 */ GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(3850), // Rule ID 86 //
     /* 3834 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 3837 */   // MIs[0] dst
     /* 3837 */   // No operand predicates
     /* 3837 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3837 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3841 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3845 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3847 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[0]]
     /* 3847 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 3850 */ // Label 247: @3850
     /* 3850 */ GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(3871), // Rule ID 65 //
     /* 3855 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule63Enabled),
     /* 3858 */   // MIs[0] root
     /* 3858 */   // No operand predicates
     /* 3858 */   // MIs[0] int
     /* 3858 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3862 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3866 */   // MIs[1] imm
     /* 3866 */   // No operand predicates
     /* 3866 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3868 */   // Combiner Rule #63: integer_of_truncate
     /* 3868 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3871 */ // Label 248: @3871
     /* 3871 */ GIM_Reject,
     /* 3872 */ // Label 27: @3872
     /* 3872 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(3883), // Rule ID 255 //
     /* 3877 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 3880 */   // Combiner Rule #168: constant_fold_cast_op; wip_match_opcode 'G_SEXT'
     /* 3880 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 3883 */ // Label 249: @3883
     /* 3883 */ GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(3904), // Rule ID 51 //
     /* 3888 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 3891 */   // MIs[0] root
     /* 3891 */   // No operand predicates
     /* 3891 */   // MIs[0] second
     /* 3891 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3895 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3899 */   // MIs[1] src
     /* 3899 */   // No operand predicates
     /* 3899 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3901 */   // Combiner Rule #49: sext_of_anyext
     /* 3901 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3904 */ // Label 250: @3904
     /* 3904 */ GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(3925), // Rule ID 50 //
     /* 3909 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 3912 */   // MIs[0] root
     /* 3912 */   // No operand predicates
     /* 3912 */   // MIs[0] second
     /* 3912 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3916 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 3920 */   // MIs[1] src
     /* 3920 */   // No operand predicates
     /* 3920 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3922 */   // Combiner Rule #48: sext_of_sext
     /* 3922 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3925 */ // Label 251: @3925
     /* 3925 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(3946), // Rule ID 340 //
     /* 3930 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule195Enabled),
     /* 3933 */   // MIs[0] root
     /* 3933 */   // No operand predicates
     /* 3933 */   // MIs[0] src
     /* 3933 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3937 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 3941 */   // MIs[1] x
     /* 3941 */   // No operand predicates
     /* 3941 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3943 */   // Combiner Rule #195: sext_trunc
     /* 3943 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner132),
     /* 3946 */ // Label 252: @3946
     /* 3946 */ GIM_Reject,
     /* 3947 */ // Label 28: @3947
     /* 3947 */ GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(3958), // Rule ID 159 //
     /* 3952 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule117Enabled),
     /* 3955 */   // Combiner Rule #117: sext_inreg_of_load; wip_match_opcode 'G_SEXT_INREG'
     /* 3955 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner65),
     /* 3958 */ // Label 253: @3958
     /* 3958 */ GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(3969), // Rule ID 167 //
     /* 3963 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule125Enabled),
     /* 3966 */   // Combiner Rule #125: redundant_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 3966 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner72),
     /* 3969 */ // Label 254: @3969
     /* 3969 */ GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(3980), // Rule ID 224 //
     /* 3974 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule161Enabled),
     /* 3977 */   // Combiner Rule #161: bitfield_extract_from_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 3977 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner99),
     /* 3980 */ // Label 255: @3980
     /* 3980 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(3991), // Rule ID 171 //
     /* 3985 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule129Enabled),
     /* 3988 */   // MIs[0] dst
     /* 3988 */   // No operand predicates
     /* 3988 */   // MIs[0] src
     /* 3988 */   // No operand predicates
     /* 3988 */   // MIs[0] imm
     /* 3988 */   // No operand predicates
     /* 3988 */   // Combiner Rule #129: sext_inreg_to_zext_inreg
     /* 3988 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner76),
     /* 3991 */ // Label 256: @3991
     /* 3991 */ GIM_Reject,
     /* 3992 */ // Label 29: @3992
     /* 3992 */ GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(4003), // Rule ID 170 //
     /* 3997 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule128Enabled),
     /* 4000 */   // Combiner Rule #128: zext_trunc_fold; wip_match_opcode 'G_ZEXT'
     /* 4000 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner75),
     /* 4003 */ // Label 257: @4003
     /* 4003 */ GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(4014), // Rule ID 254 //
     /* 4008 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 4011 */   // Combiner Rule #168: constant_fold_cast_op; wip_match_opcode 'G_ZEXT'
     /* 4011 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 4014 */ // Label 258: @4014
     /* 4014 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(4035), // Rule ID 55 //
     /* 4019 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 4022 */   // MIs[0] root
     /* 4022 */   // No operand predicates
     /* 4022 */   // MIs[0] select
     /* 4022 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4026 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 4030 */   // MIs[1] cond
     /* 4030 */   // No operand predicates
     /* 4030 */   // MIs[1] true
     /* 4030 */   // No operand predicates
     /* 4030 */   // MIs[1] false
     /* 4030 */   // No operand predicates
     /* 4030 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4032 */   // Combiner Rule #53: select_of_zext
     /* 4032 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 4035 */ // Label 259: @4035
     /* 4035 */ GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(4056), // Rule ID 49 //
     /* 4040 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule47Enabled),
     /* 4043 */   // MIs[0] root
     /* 4043 */   // No operand predicates
     /* 4043 */   // MIs[0] second
     /* 4043 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4047 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 4051 */   // MIs[1] src
     /* 4051 */   // No operand predicates
     /* 4051 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4053 */   // Combiner Rule #47: zext_of_anyext
     /* 4053 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4056 */ // Label 260: @4056
     /* 4056 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(4083), // Rule ID 341 //
     /* 4061 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule196Enabled),
     /* 4064 */   // MIs[0] root
     /* 4064 */   // No operand predicates
     /* 4064 */   // MIs[0] src
     /* 4064 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4068 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 4072 */   GIM_MIFlags, /*MI*/1, GIMT_Encode4(MachineInstr::NoUWrap),
     /* 4078 */   // MIs[1] x
     /* 4078 */   // No operand predicates
     /* 4078 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4080 */   // Combiner Rule #196: zext_trunc
     /* 4080 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner133),
     /* 4083 */ // Label 261: @4083
     /* 4083 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(4104), // Rule ID 48 //
     /* 4088 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule46Enabled),
     /* 4091 */   // MIs[0] root
     /* 4091 */   // No operand predicates
     /* 4091 */   // MIs[0] second
     /* 4091 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4095 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 4099 */   // MIs[1] src
     /* 4099 */   // No operand predicates
     /* 4099 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4101 */   // Combiner Rule #46: zext_of_zext
     /* 4101 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4104 */ // Label 262: @4104
     /* 4104 */ GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(4121), // Rule ID 342 //
     /* 4109 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule197Enabled),
     /* 4112 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NonNeg),
     /* 4118 */   // MIs[0] root
     /* 4118 */   // No operand predicates
     /* 4118 */   // MIs[0] x
     /* 4118 */   // No operand predicates
     /* 4118 */   // Combiner Rule #197: nneg_zext
     /* 4118 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner134),
     /* 4121 */ // Label 263: @4121
     /* 4121 */ GIM_Reject,
     /* 4122 */ // Label 30: @4122
     /* 4122 */ GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(4133), // Rule ID 79 //
     /* 4127 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 4130 */   // Combiner Rule #73: binop_left_undef_to_zero; wip_match_opcode 'G_SHL'
     /* 4130 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 4133 */ // Label 264: @4133
     /* 4133 */ GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(4144), // Rule ID 82 //
     /* 4138 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 4141 */   // Combiner Rule #74: binop_right_undef_to_undef; wip_match_opcode 'G_SHL'
     /* 4141 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 4144 */ // Label 265: @4144
     /* 4144 */ GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(4155), // Rule ID 115 //
     /* 4149 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 4152 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_SHL'
     /* 4152 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 4155 */ // Label 266: @4155
     /* 4155 */ GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(4166), // Rule ID 199 //
     /* 4160 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 4163 */   // Combiner Rule #149: shift_immed_chain; wip_match_opcode 'G_SHL'
     /* 4163 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 4166 */ // Label 267: @4166
     /* 4166 */ GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(4177), // Rule ID 204 //
     /* 4171 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4174 */   // Combiner Rule #150: shift_of_shifted_logic_chain; wip_match_opcode 'G_SHL'
     /* 4174 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4177 */ // Label 268: @4177
     /* 4177 */ GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(4188), // Rule ID 223 //
     /* 4182 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule160Enabled),
     /* 4185 */   // Combiner Rule #160: commute_shift; wip_match_opcode 'G_SHL'
     /* 4185 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner98),
     /* 4188 */ // Label 269: @4188
     /* 4188 */ GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(4199), // Rule ID 237 //
     /* 4193 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 4196 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_SHL'
     /* 4196 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4199 */ // Label 270: @4199
     /* 4199 */ GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(4210), // Rule ID 290 //
     /* 4204 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 4207 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_SHL'
     /* 4207 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 4210 */ // Label 271: @4210
     /* 4210 */ GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(4245), // Rule ID 41 //
     /* 4215 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule39Enabled),
     /* 4218 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 4224 */   // MIs[0] root
     /* 4224 */   // No operand predicates
     /* 4224 */   // MIs[0] left
     /* 4224 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4228 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 4232 */   // MIs[1] imm
     /* 4232 */   // No operand predicates
     /* 4232 */   // MIs[0] x
     /* 4232 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 4236 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 4240 */   // MIs[2] imm1
     /* 4240 */   // No operand predicates
     /* 4240 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 4242 */   // Combiner Rule #39: shl_of_vscale
     /* 4242 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner17),
     /* 4245 */ // Label 272: @4245
     /* 4245 */ GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(4268), // Rule ID 107 //
     /* 4250 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4253 */   // MIs[0] dst
     /* 4253 */   // No operand predicates
     /* 4253 */   // MIs[0] lhs
     /* 4253 */   // No operand predicates
     /* 4253 */   // MIs[0] Operand 2
     /* 4253 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4257 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4262 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[4]]
     /* 4262 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4267 */   GIR_EraseRootFromParent_Done,
     /* 4268 */ // Label 273: @4268
     /* 4268 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(4279), // Rule ID 144 //
     /* 4273 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 4276 */   // MIs[0] root
     /* 4276 */   // No operand predicates
     /* 4276 */   // MIs[0] mi.shifted
     /* 4276 */   // No operand predicates
     /* 4276 */   // MIs[0] mi.amt
     /* 4276 */   // No operand predicates
     /* 4276 */   // Combiner Rule #104: shifts_too_big @ [mi[0]]
     /* 4276 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 4279 */ // Label 274: @4279
     /* 4279 */ GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(4290), // Rule ID 160 //
     /* 4284 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule118Enabled),
     /* 4287 */   // MIs[0] dst
     /* 4287 */   // No operand predicates
     /* 4287 */   // MIs[0] src0
     /* 4287 */   // No operand predicates
     /* 4287 */   // MIs[0] src1
     /* 4287 */   // No operand predicates
     /* 4287 */   // Combiner Rule #118: reduce_shl_of_extend
     /* 4287 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner66),
     /* 4290 */ // Label 275: @4290
     /* 4290 */ GIM_Reject,
     /* 4291 */ // Label 31: @4291
     /* 4291 */ GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(4302), // Rule ID 84 //
     /* 4296 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 4299 */   // Combiner Rule #74: binop_right_undef_to_undef; wip_match_opcode 'G_LSHR'
     /* 4299 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 4302 */ // Label 276: @4302
     /* 4302 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(4313), // Rule ID 116 //
     /* 4307 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 4310 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_LSHR'
     /* 4310 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 4313 */ // Label 277: @4313
     /* 4313 */ GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(4324), // Rule ID 201 //
     /* 4318 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 4321 */   // Combiner Rule #149: shift_immed_chain; wip_match_opcode 'G_LSHR'
     /* 4321 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 4324 */ // Label 278: @4324
     /* 4324 */ GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(4335), // Rule ID 206 //
     /* 4329 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4332 */   // Combiner Rule #150: shift_of_shifted_logic_chain; wip_match_opcode 'G_LSHR'
     /* 4332 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4335 */ // Label 279: @4335
     /* 4335 */ GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(4346), // Rule ID 227 //
     /* 4340 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule163Enabled),
     /* 4343 */   // Combiner Rule #163: bitfield_extract_from_shr; wip_match_opcode 'G_LSHR'
     /* 4343 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner101),
     /* 4346 */ // Label 280: @4346
     /* 4346 */ GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(4357), // Rule ID 229 //
     /* 4351 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4354 */   // Combiner Rule #164: bitfield_extract_from_shr_and; wip_match_opcode 'G_LSHR'
     /* 4354 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 4357 */ // Label 281: @4357
     /* 4357 */ GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(4368), // Rule ID 234 //
     /* 4362 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 4365 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_LSHR'
     /* 4365 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4368 */ // Label 282: @4368
     /* 4368 */ GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(4379), // Rule ID 288 //
     /* 4373 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 4376 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_LSHR'
     /* 4376 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 4379 */ // Label 283: @4379
     /* 4379 */ GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(4402), // Rule ID 109 //
     /* 4384 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4387 */   // MIs[0] dst
     /* 4387 */   // No operand predicates
     /* 4387 */   // MIs[0] lhs
     /* 4387 */   // No operand predicates
     /* 4387 */   // MIs[0] Operand 2
     /* 4387 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4391 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4396 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[6]]
     /* 4396 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4401 */   GIR_EraseRootFromParent_Done,
     /* 4402 */ // Label 284: @4402
     /* 4402 */ GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(4413), // Rule ID 146 //
     /* 4407 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 4410 */   // MIs[0] root
     /* 4410 */   // No operand predicates
     /* 4410 */   // MIs[0] mi.shifted
     /* 4410 */   // No operand predicates
     /* 4410 */   // MIs[0] mi.amt
     /* 4410 */   // No operand predicates
     /* 4410 */   // Combiner Rule #104: shifts_too_big @ [mi[2]]
     /* 4410 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 4413 */ // Label 285: @4413
     /* 4413 */ GIM_Reject,
     /* 4414 */ // Label 32: @4414
     /* 4414 */ GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(4425), // Rule ID 83 //
     /* 4419 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 4422 */   // Combiner Rule #74: binop_right_undef_to_undef; wip_match_opcode 'G_ASHR'
     /* 4422 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 4425 */ // Label 286: @4425
     /* 4425 */ GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(4436), // Rule ID 117 //
     /* 4430 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 4433 */   // Combiner Rule #85: binop_left_to_zero; wip_match_opcode 'G_ASHR'
     /* 4433 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 4436 */ // Label 287: @4436
     /* 4436 */ GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(4447), // Rule ID 157 //
     /* 4441 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule115Enabled),
     /* 4444 */   // Combiner Rule #115: shl_ashr_to_sext_inreg; wip_match_opcode 'G_ASHR'
     /* 4444 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner64),
     /* 4447 */ // Label 288: @4447
     /* 4447 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(4458), // Rule ID 200 //
     /* 4452 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 4455 */   // Combiner Rule #149: shift_immed_chain; wip_match_opcode 'G_ASHR'
     /* 4455 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 4458 */ // Label 289: @4458
     /* 4458 */ GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(4469), // Rule ID 205 //
     /* 4463 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4466 */   // Combiner Rule #150: shift_of_shifted_logic_chain; wip_match_opcode 'G_ASHR'
     /* 4466 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4469 */ // Label 290: @4469
     /* 4469 */ GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(4480), // Rule ID 226 //
     /* 4474 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule163Enabled),
     /* 4477 */   // Combiner Rule #163: bitfield_extract_from_shr; wip_match_opcode 'G_ASHR'
     /* 4477 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner101),
     /* 4480 */ // Label 291: @4480
     /* 4480 */ GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(4491), // Rule ID 228 //
     /* 4485 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4488 */   // Combiner Rule #164: bitfield_extract_from_shr_and; wip_match_opcode 'G_ASHR'
     /* 4488 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 4491 */ // Label 292: @4491
     /* 4491 */ GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(4502), // Rule ID 233 //
     /* 4496 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 4499 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_ASHR'
     /* 4499 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4502 */ // Label 293: @4502
     /* 4502 */ GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(4513), // Rule ID 289 //
     /* 4507 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 4510 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_ASHR'
     /* 4510 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 4513 */ // Label 294: @4513
     /* 4513 */ GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(4536), // Rule ID 108 //
     /* 4518 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4521 */   // MIs[0] dst
     /* 4521 */   // No operand predicates
     /* 4521 */   // MIs[0] lhs
     /* 4521 */   // No operand predicates
     /* 4521 */   // MIs[0] Operand 2
     /* 4521 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4525 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4530 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[5]]
     /* 4530 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4535 */   GIR_EraseRootFromParent_Done,
     /* 4536 */ // Label 295: @4536
     /* 4536 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(4547), // Rule ID 145 //
     /* 4541 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 4544 */   // MIs[0] root
     /* 4544 */   // No operand predicates
     /* 4544 */   // MIs[0] mi.shifted
     /* 4544 */   // No operand predicates
     /* 4544 */   // MIs[0] mi.amt
     /* 4544 */   // No operand predicates
     /* 4544 */   // Combiner Rule #104: shifts_too_big @ [mi[1]]
     /* 4544 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 4547 */ // Label 296: @4547
     /* 4547 */ GIM_Reject,
     /* 4548 */ // Label 33: @4548
     /* 4548 */ GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(4559), // Rule ID 215 //
     /* 4553 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule154Enabled),
     /* 4556 */   // Combiner Rule #154: funnel_shift_to_rotate; wip_match_opcode 'G_FSHL'
     /* 4556 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner96),
     /* 4559 */ // Label 297: @4559
     /* 4559 */ GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(4570), // Rule ID 219 //
     /* 4564 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule157Enabled),
     /* 4567 */   // Combiner Rule #157: funnel_shift_overshift; wip_match_opcode 'G_FSHL'
     /* 4567 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 4570 */ // Label 298: @4570
     /* 4570 */ GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(4590), // Rule ID 218 //
     /* 4575 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule156Enabled),
     /* 4578 */   // MIs[0] x
     /* 4578 */   // No operand predicates
     /* 4578 */   // MIs[0] y
     /* 4578 */   // No operand predicates
     /* 4578 */   // MIs[0] z
     /* 4578 */   // No operand predicates
     /* 4578 */   // MIs[0] Operand 3
     /* 4578 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 4582 */   // Combiner Rule #156: funnel_shift_left_zero
     /* 4582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 4585 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 4587 */   GIR_RootToRootCopy, /*OpIdx*/1, // y
     /* 4589 */   GIR_EraseRootFromParent_Done,
     /* 4590 */ // Label 299: @4590
     /* 4590 */ GIM_Reject,
     /* 4591 */ // Label 34: @4591
     /* 4591 */ GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(4602), // Rule ID 216 //
     /* 4596 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule154Enabled),
     /* 4599 */   // Combiner Rule #154: funnel_shift_to_rotate; wip_match_opcode 'G_FSHR'
     /* 4599 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner96),
     /* 4602 */ // Label 300: @4602
     /* 4602 */ GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(4613), // Rule ID 220 //
     /* 4607 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule157Enabled),
     /* 4610 */   // Combiner Rule #157: funnel_shift_overshift; wip_match_opcode 'G_FSHR'
     /* 4610 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 4613 */ // Label 301: @4613
     /* 4613 */ GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(4633), // Rule ID 217 //
     /* 4618 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule155Enabled),
     /* 4621 */   // MIs[0] x
     /* 4621 */   // No operand predicates
     /* 4621 */   // MIs[0] y
     /* 4621 */   // No operand predicates
     /* 4621 */   // MIs[0] z
     /* 4621 */   // No operand predicates
     /* 4621 */   // MIs[0] Operand 3
     /* 4621 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 4625 */   // Combiner Rule #155: funnel_shift_right_zero
     /* 4625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 4628 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 4630 */   GIR_RootToRootCopy, /*OpIdx*/2, // z
     /* 4632 */   GIR_EraseRootFromParent_Done,
     /* 4633 */ // Label 302: @4633
     /* 4633 */ GIM_Reject,
     /* 4634 */ // Label 35: @4634
     /* 4634 */ GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(4657), // Rule ID 112 //
     /* 4639 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4642 */   // MIs[0] dst
     /* 4642 */   // No operand predicates
     /* 4642 */   // MIs[0] lhs
     /* 4642 */   // No operand predicates
     /* 4642 */   // MIs[0] Operand 2
     /* 4642 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4646 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4651 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[9]]
     /* 4651 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4656 */   GIR_EraseRootFromParent_Done,
     /* 4657 */ // Label 303: @4657
     /* 4657 */ GIM_Reject,
     /* 4658 */ // Label 36: @4658
     /* 4658 */ GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(4681), // Rule ID 111 //
     /* 4663 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4666 */   // MIs[0] dst
     /* 4666 */   // No operand predicates
     /* 4666 */   // MIs[0] lhs
     /* 4666 */   // No operand predicates
     /* 4666 */   // MIs[0] Operand 2
     /* 4666 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4670 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4675 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[8]]
     /* 4675 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4680 */   GIR_EraseRootFromParent_Done,
     /* 4681 */ // Label 304: @4681
     /* 4681 */ GIM_Reject,
     /* 4682 */ // Label 37: @4682
     /* 4682 */ GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(4693), // Rule ID 152 //
     /* 4687 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule110Enabled),
     /* 4690 */   // Combiner Rule #110: icmp_to_true_false_known_bits; wip_match_opcode 'G_ICMP'
     /* 4690 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner61),
     /* 4693 */ // Label 305: @4693
     /* 4693 */ GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(4704), // Rule ID 153 //
     /* 4698 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule111Enabled),
     /* 4701 */   // Combiner Rule #111: icmp_to_lhs_known_bits; wip_match_opcode 'G_ICMP'
     /* 4701 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner62),
     /* 4704 */ // Label 306: @4704
     /* 4704 */ GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(4715), // Rule ID 156 //
     /* 4709 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule114Enabled),
     /* 4712 */   // Combiner Rule #114: redundant_binop_in_equality; wip_match_opcode 'G_ICMP'
     /* 4712 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner63),
     /* 4715 */ // Label 307: @4715
     /* 4715 */ GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(4726), // Rule ID 150 //
     /* 4720 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule108Enabled),
     /* 4723 */   // MIs[0] root
     /* 4723 */   // No operand predicates
     /* 4723 */   // MIs[0] pred
     /* 4723 */   // No operand predicates
     /* 4723 */   // MIs[0] lhs
     /* 4723 */   // No operand predicates
     /* 4723 */   // MIs[0] rhs
     /* 4723 */   // No operand predicates
     /* 4723 */   // Combiner Rule #108: canonicalize_icmp
     /* 4723 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner59),
     /* 4726 */ // Label 308: @4726
     /* 4726 */ GIM_Reject,
     /* 4727 */ // Label 38: @4727
     /* 4727 */ GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(4738), // Rule ID 151 //
     /* 4732 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule109Enabled),
     /* 4735 */   // MIs[0] root
     /* 4735 */   // No operand predicates
     /* 4735 */   // MIs[0] pred
     /* 4735 */   // No operand predicates
     /* 4735 */   // MIs[0] lhs
     /* 4735 */   // No operand predicates
     /* 4735 */   // MIs[0] rhs
     /* 4735 */   // No operand predicates
     /* 4735 */   // Combiner Rule #109: canonicalize_fcmp
     /* 4735 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner60),
     /* 4738 */ // Label 309: @4738
     /* 4738 */ GIM_Reject,
     /* 4739 */ // Label 39: @4739
     /* 4739 */ GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(4750), // Rule ID 102 //
     /* 4744 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 4747 */   // Combiner Rule #82: select_same_val; wip_match_opcode 'G_SELECT'
     /* 4747 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 4750 */ // Label 310: @4750
     /* 4750 */ GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(4761), // Rule ID 163 //
     /* 4755 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule121Enabled),
     /* 4758 */   // Combiner Rule #121: select_constant_cmp; wip_match_opcode 'G_SELECT'
     /* 4758 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 4761 */ // Label 311: @4761
     /* 4761 */ GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(4772), // Rule ID 165 //
     /* 4766 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule123Enabled),
     /* 4769 */   // Combiner Rule #123: match_selects; wip_match_opcode 'G_SELECT'
     /* 4769 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner70),
     /* 4772 */ // Label 312: @4772
     /* 4772 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(4783), // Rule ID 305 //
     /* 4777 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule187Enabled),
     /* 4780 */   // Combiner Rule #187: select_to_minmax; wip_match_opcode 'G_SELECT'
     /* 4780 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner124),
     /* 4783 */ // Label 313: @4783
     /* 4783 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(4804), // Rule ID 164 //
     /* 4788 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule122Enabled),
     /* 4791 */   // MIs[0] root
     /* 4791 */   // No operand predicates
     /* 4791 */   // MIs[0] tst
     /* 4791 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4795 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 4799 */   // MIs[1] tst1
     /* 4799 */   // No operand predicates
     /* 4799 */   // MIs[1] a
     /* 4799 */   // No operand predicates
     /* 4799 */   // MIs[1] b
     /* 4799 */   // No operand predicates
     /* 4799 */   // MIs[0] x
     /* 4799 */   // No operand predicates
     /* 4799 */   // MIs[0] y
     /* 4799 */   // No operand predicates
     /* 4799 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4801 */   // Combiner Rule #122: select_to_iminmax
     /* 4801 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner69),
     /* 4804 */ // Label 314: @4804
     /* 4804 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(4833), // Rule ID 162 //
     /* 4809 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule120Enabled),
     /* 4812 */   // MIs[0] dst
     /* 4812 */   // No operand predicates
     /* 4812 */   // MIs[0] undef
     /* 4812 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4816 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 4820 */   // MIs[0] x
     /* 4820 */   // No operand predicates
     /* 4820 */   // MIs[0] y
     /* 4820 */   // No operand predicates
     /* 4820 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 4825 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4827 */   // Combiner Rule #120: select_undef_cmp
     /* 4827 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 4832 */   GIR_EraseRootFromParent_Done,
     /* 4833 */ // Label 315: @4833
     /* 4833 */ GIM_Reject,
     /* 4834 */ // Label 40: @4834
     /* 4834 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(4845), // Rule ID 316 //
     /* 4839 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 4842 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDO'
     /* 4842 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 4845 */ // Label 316: @4845
     /* 4845 */ GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(4856), // Rule ID 357 //
     /* 4850 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule211Enabled),
     /* 4853 */   // Combiner Rule #211: match_addos; wip_match_opcode 'G_UADDO'
     /* 4853 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner148),
     /* 4856 */ // Label 317: @4856
     /* 4856 */ GIM_Reject,
     /* 4857 */ // Label 41: @4857
     /* 4857 */ GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(4868), // Rule ID 188 //
     /* 4862 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 4865 */   // Combiner Rule #144: adde_to_addo; wip_match_opcode 'G_UADDE'
     /* 4865 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 4868 */ // Label 318: @4868
     /* 4868 */ GIM_Reject,
     /* 4869 */ // Label 42: @4869
     /* 4869 */ GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(4880), // Rule ID 359 //
     /* 4874 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule212Enabled),
     /* 4877 */   // Combiner Rule #212: match_subo_no_overflow; wip_match_opcode 'G_USUBO'
     /* 4877 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 4880 */ // Label 319: @4880
     /* 4880 */ GIM_Reject,
     /* 4881 */ // Label 43: @4881
     /* 4881 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(4892), // Rule ID 190 //
     /* 4886 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 4889 */   // Combiner Rule #144: adde_to_addo; wip_match_opcode 'G_USUBE'
     /* 4889 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 4892 */ // Label 320: @4892
     /* 4892 */ GIM_Reject,
     /* 4893 */ // Label 44: @4893
     /* 4893 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(4904), // Rule ID 317 //
     /* 4898 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 4901 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDO'
     /* 4901 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 4904 */ // Label 321: @4904
     /* 4904 */ GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(4915), // Rule ID 356 //
     /* 4909 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule211Enabled),
     /* 4912 */   // Combiner Rule #211: match_addos; wip_match_opcode 'G_SADDO'
     /* 4912 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner148),
     /* 4915 */ // Label 322: @4915
     /* 4915 */ GIM_Reject,
     /* 4916 */ // Label 45: @4916
     /* 4916 */ GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(4927), // Rule ID 189 //
     /* 4921 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 4924 */   // Combiner Rule #144: adde_to_addo; wip_match_opcode 'G_SADDE'
     /* 4924 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 4927 */ // Label 323: @4927
     /* 4927 */ GIM_Reject,
     /* 4928 */ // Label 46: @4928
     /* 4928 */ GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(4939), // Rule ID 358 //
     /* 4933 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule212Enabled),
     /* 4936 */   // Combiner Rule #212: match_subo_no_overflow; wip_match_opcode 'G_SSUBO'
     /* 4936 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 4939 */ // Label 324: @4939
     /* 4939 */ GIM_Reject,
     /* 4940 */ // Label 47: @4940
     /* 4940 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(4951), // Rule ID 191 //
     /* 4945 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 4948 */   // Combiner Rule #144: adde_to_addo; wip_match_opcode 'G_SSUBE'
     /* 4948 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 4951 */ // Label 325: @4951
     /* 4951 */ GIM_Reject,
     /* 4952 */ // Label 48: @4952
     /* 4952 */ GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(4963), // Rule ID 184 //
     /* 4957 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule142Enabled),
     /* 4960 */   // Combiner Rule #142: mulo_by_2; wip_match_opcode 'G_UMULO'
     /* 4960 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner84),
     /* 4963 */ // Label 326: @4963
     /* 4963 */ GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(4974), // Rule ID 186 //
     /* 4968 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 4971 */   // Combiner Rule #143: mulo_by_0; wip_match_opcode 'G_UMULO'
     /* 4971 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 4974 */ // Label 327: @4974
     /* 4974 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(4985), // Rule ID 318 //
     /* 4979 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 4982 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULO'
     /* 4982 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 4985 */ // Label 328: @4985
     /* 4985 */ GIM_Reject,
     /* 4986 */ // Label 49: @4986
     /* 4986 */ GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(4997), // Rule ID 185 //
     /* 4991 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule142Enabled),
     /* 4994 */   // Combiner Rule #142: mulo_by_2; wip_match_opcode 'G_SMULO'
     /* 4994 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner84),
     /* 4997 */ // Label 329: @4997
     /* 4997 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(5008), // Rule ID 187 //
     /* 5002 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 5005 */   // Combiner Rule #143: mulo_by_0; wip_match_opcode 'G_SMULO'
     /* 5005 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 5008 */ // Label 330: @5008
     /* 5008 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(5019), // Rule ID 319 //
     /* 5013 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5016 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULO'
     /* 5016 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5019 */ // Label 331: @5019
     /* 5019 */ GIM_Reject,
     /* 5020 */ // Label 50: @5020
     /* 5020 */ GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(5031), // Rule ID 262 //
     /* 5025 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 5028 */   // Combiner Rule #174: mulh_to_lshr; wip_match_opcode 'G_UMULH'
     /* 5028 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner111),
     /* 5031 */ // Label 332: @5031
     /* 5031 */ GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(5042), // Rule ID 320 //
     /* 5036 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5039 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULH'
     /* 5039 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5042 */ // Label 333: @5042
     /* 5042 */ GIM_Reject,
     /* 5043 */ // Label 51: @5043
     /* 5043 */ GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(5054), // Rule ID 321 //
     /* 5048 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5051 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULH'
     /* 5051 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5054 */ // Label 334: @5054
     /* 5054 */ GIM_Reject,
     /* 5055 */ // Label 52: @5055
     /* 5055 */ GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(5066), // Rule ID 322 //
     /* 5060 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5063 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDSAT'
     /* 5063 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5066 */ // Label 335: @5066
     /* 5066 */ GIM_Reject,
     /* 5067 */ // Label 53: @5067
     /* 5067 */ GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(5078), // Rule ID 323 //
     /* 5072 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5075 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDSAT'
     /* 5075 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5078 */ // Label 336: @5078
     /* 5078 */ GIM_Reject,
     /* 5079 */ // Label 54: @5079
     /* 5079 */ GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(5090), // Rule ID 203 //
     /* 5084 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 5087 */   // Combiner Rule #149: shift_immed_chain; wip_match_opcode 'G_USHLSAT'
     /* 5087 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 5090 */ // Label 337: @5090
     /* 5090 */ GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(5101), // Rule ID 207 //
     /* 5095 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 5098 */   // Combiner Rule #150: shift_of_shifted_logic_chain; wip_match_opcode 'G_USHLSAT'
     /* 5098 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 5101 */ // Label 338: @5101
     /* 5101 */ GIM_Reject,
     /* 5102 */ // Label 55: @5102
     /* 5102 */ GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(5113), // Rule ID 202 //
     /* 5107 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 5110 */   // Combiner Rule #149: shift_immed_chain; wip_match_opcode 'G_SSHLSAT'
     /* 5110 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 5113 */ // Label 339: @5113
     /* 5113 */ GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(5124), // Rule ID 208 //
     /* 5118 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 5121 */   // Combiner Rule #150: shift_of_shifted_logic_chain; wip_match_opcode 'G_SSHLSAT'
     /* 5121 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 5124 */ // Label 340: @5124
     /* 5124 */ GIM_Reject,
     /* 5125 */ // Label 56: @5125
     /* 5125 */ GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(5136), // Rule ID 324 //
     /* 5130 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5133 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIX'
     /* 5133 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5136 */ // Label 341: @5136
     /* 5136 */ GIM_Reject,
     /* 5137 */ // Label 57: @5137
     /* 5137 */ GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(5148), // Rule ID 325 //
     /* 5142 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5145 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIX'
     /* 5145 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5148 */ // Label 342: @5148
     /* 5148 */ GIM_Reject,
     /* 5149 */ // Label 58: @5149
     /* 5149 */ GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(5160), // Rule ID 326 //
     /* 5154 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5157 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIXSAT'
     /* 5157 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5160 */ // Label 343: @5160
     /* 5160 */ GIM_Reject,
     /* 5161 */ // Label 59: @5161
     /* 5161 */ GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(5172), // Rule ID 327 //
     /* 5166 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5169 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIXSAT'
     /* 5169 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5172 */ // Label 344: @5172
     /* 5172 */ GIM_Reject,
     /* 5173 */ // Label 60: @5173
     /* 5173 */ GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(5184), // Rule ID 248 //
     /* 5178 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 5181 */   // Combiner Rule #166: constant_fold_fp_binop; wip_match_opcode 'G_FADD'
     /* 5181 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 5184 */ // Label 345: @5184
     /* 5184 */ GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(5195), // Rule ID 263 //
     /* 5189 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5192 */   // Combiner Rule #175: redundant_neg_operands; wip_match_opcode 'G_FADD'
     /* 5192 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5195 */ // Label 346: @5195
     /* 5195 */ GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(5206), // Rule ID 270 //
     /* 5200 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule177Enabled),
     /* 5203 */   // Combiner Rule #177: combine_fadd_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5203 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner114),
     /* 5206 */ // Label 347: @5206
     /* 5206 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(5217), // Rule ID 271 //
     /* 5211 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule178Enabled),
     /* 5214 */   // Combiner Rule #178: combine_fadd_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5214 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner115),
     /* 5217 */ // Label 348: @5217
     /* 5217 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(5228), // Rule ID 272 //
     /* 5222 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule179Enabled),
     /* 5225 */   // Combiner Rule #179: combine_fadd_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5225 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner116),
     /* 5228 */ // Label 349: @5228
     /* 5228 */ GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(5239), // Rule ID 273 //
     /* 5233 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule180Enabled),
     /* 5236 */   // Combiner Rule #180: combine_fadd_fpext_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5236 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner117),
     /* 5239 */ // Label 350: @5239
     /* 5239 */ GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(5250), // Rule ID 296 //
     /* 5244 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5247 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FADD'
     /* 5247 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5250 */ // Label 351: @5250
     /* 5250 */ GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(5261), // Rule ID 328 //
     /* 5255 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5258 */   // Combiner Rule #190: commute_fp_constant_to_rhs; wip_match_opcode 'G_FADD'
     /* 5258 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5261 */ // Label 352: @5261
     /* 5261 */ GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(5284), // Rule ID 137 //
     /* 5266 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule99Enabled),
     /* 5269 */   // MIs[0] dst
     /* 5269 */   // No operand predicates
     /* 5269 */   // MIs[0] x
     /* 5269 */   // No operand predicates
     /* 5269 */   // MIs[0] y
     /* 5269 */   // No operand predicates
     /* 5269 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner3),
     /* 5273 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5278 */   // Combiner Rule #99: right_identity_neg_zero_fp
     /* 5278 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5283 */   GIR_EraseRootFromParent_Done,
     /* 5284 */ // Label 353: @5284
     /* 5284 */ GIM_Reject,
     /* 5285 */ // Label 61: @5285
     /* 5285 */ GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(5296), // Rule ID 249 //
     /* 5290 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 5293 */   // Combiner Rule #166: constant_fold_fp_binop; wip_match_opcode 'G_FSUB'
     /* 5293 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 5296 */ // Label 354: @5296
     /* 5296 */ GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(5307), // Rule ID 264 //
     /* 5301 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5304 */   // Combiner Rule #175: redundant_neg_operands; wip_match_opcode 'G_FSUB'
     /* 5304 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5307 */ // Label 355: @5307
     /* 5307 */ GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(5318), // Rule ID 274 //
     /* 5312 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule181Enabled),
     /* 5315 */   // Combiner Rule #181: combine_fsub_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5315 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner118),
     /* 5318 */ // Label 356: @5318
     /* 5318 */ GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(5329), // Rule ID 275 //
     /* 5323 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 5326 */   // Combiner Rule #182: combine_fsub_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5326 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 5329 */ // Label 357: @5329
     /* 5329 */ GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(5340), // Rule ID 276 //
     /* 5334 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule183Enabled),
     /* 5337 */   // Combiner Rule #183: combine_fsub_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5337 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner120),
     /* 5340 */ // Label 358: @5340
     /* 5340 */ GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(5351), // Rule ID 277 //
     /* 5345 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 5348 */   // Combiner Rule #184: combine_fsub_fpext_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5348 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner121),
     /* 5351 */ // Label 359: @5351
     /* 5351 */ GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(5362), // Rule ID 297 //
     /* 5356 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5359 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FSUB'
     /* 5359 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5362 */ // Label 360: @5362
     /* 5362 */ GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(5373), // Rule ID 306 //
     /* 5367 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5370 */   // Combiner Rule #188: fsub_to_fneg; wip_match_opcode 'G_FSUB'
     /* 5370 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner125),
     /* 5373 */ // Label 361: @5373
     /* 5373 */ GIM_Reject,
     /* 5374 */ // Label 62: @5374
     /* 5374 */ GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(5385), // Rule ID 250 //
     /* 5379 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 5382 */   // Combiner Rule #166: constant_fold_fp_binop; wip_match_opcode 'G_FMUL'
     /* 5382 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 5385 */ // Label 362: @5385
     /* 5385 */ GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(5396), // Rule ID 265 //
     /* 5390 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5393 */   // Combiner Rule #175: redundant_neg_operands; wip_match_opcode 'G_FMUL'
     /* 5393 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5396 */ // Label 363: @5396
     /* 5396 */ GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(5407), // Rule ID 295 //
     /* 5401 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5404 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FMUL'
     /* 5404 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5407 */ // Label 364: @5407
     /* 5407 */ GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(5418), // Rule ID 329 //
     /* 5412 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5415 */   // Combiner Rule #190: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMUL'
     /* 5415 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5418 */ // Label 365: @5418
     /* 5418 */ GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(5439), // Rule ID 360 //
     /* 5423 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule213Enabled),
     /* 5426 */   // MIs[0] dst
     /* 5426 */   // No operand predicates
     /* 5426 */   // MIs[0] x
     /* 5426 */   // No operand predicates
     /* 5426 */   // MIs[0] select
     /* 5426 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 5430 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 5434 */   // MIs[1] y
     /* 5434 */   // No operand predicates
     /* 5434 */   // MIs[1] A
     /* 5434 */   // No operand predicates
     /* 5434 */   // MIs[1] B
     /* 5434 */   // No operand predicates
     /* 5434 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5436 */   // Combiner Rule #213: combine_fmul_with_select_to_fldexp
     /* 5436 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner150),
     /* 5439 */ // Label 366: @5439
     /* 5439 */ GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(5462), // Rule ID 128 //
     /* 5444 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule92Enabled),
     /* 5447 */   // MIs[0] dst
     /* 5447 */   // No operand predicates
     /* 5447 */   // MIs[0] x
     /* 5447 */   // No operand predicates
     /* 5447 */   // MIs[0] y
     /* 5447 */   // No operand predicates
     /* 5447 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner2),
     /* 5451 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5456 */   // Combiner Rule #92: right_identity_one_fp
     /* 5456 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5461 */   GIR_EraseRootFromParent_Done,
     /* 5462 */ // Label 367: @5462
     /* 5462 */ GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(5482), // Rule ID 138 //
     /* 5467 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule100Enabled),
     /* 5470 */   // MIs[0] dst
     /* 5470 */   // No operand predicates
     /* 5470 */   // MIs[0] x
     /* 5470 */   // No operand predicates
     /* 5470 */   // MIs[0] y
     /* 5470 */   // No operand predicates
     /* 5470 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner4),
     /* 5474 */   // Combiner Rule #100: right_identity_neg_one_fp
     /* 5474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5477 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 5479 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 5481 */   GIR_EraseRootFromParent_Done,
     /* 5482 */ // Label 368: @5482
     /* 5482 */ GIM_Reject,
     /* 5483 */ // Label 63: @5483
     /* 5483 */ GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(5494), // Rule ID 253 //
     /* 5488 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5491 */   // Combiner Rule #167: constant_fold_fma; wip_match_opcode 'G_FMA'
     /* 5491 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5494 */ // Label 369: @5494
     /* 5494 */ GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(5505), // Rule ID 268 //
     /* 5499 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5502 */   // Combiner Rule #175: redundant_neg_operands; wip_match_opcode 'G_FMA'
     /* 5502 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5505 */ // Label 370: @5505
     /* 5505 */ GIM_Reject,
     /* 5506 */ // Label 64: @5506
     /* 5506 */ GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(5517), // Rule ID 252 //
     /* 5511 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5514 */   // Combiner Rule #167: constant_fold_fma; wip_match_opcode 'G_FMAD'
     /* 5514 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5517 */ // Label 371: @5517
     /* 5517 */ GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(5528), // Rule ID 267 //
     /* 5522 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5525 */   // Combiner Rule #175: redundant_neg_operands; wip_match_opcode 'G_FMAD'
     /* 5525 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5528 */ // Label 372: @5528
     /* 5528 */ GIM_Reject,
     /* 5529 */ // Label 65: @5529
     /* 5529 */ GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(5540), // Rule ID 251 //
     /* 5534 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 5537 */   // Combiner Rule #166: constant_fold_fp_binop; wip_match_opcode 'G_FDIV'
     /* 5537 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 5540 */ // Label 373: @5540
     /* 5540 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(5551), // Rule ID 266 //
     /* 5545 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5548 */   // Combiner Rule #175: redundant_neg_operands; wip_match_opcode 'G_FDIV'
     /* 5548 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5551 */ // Label 374: @5551
     /* 5551 */ GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(5562), // Rule ID 298 //
     /* 5556 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5559 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FDIV'
     /* 5559 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5562 */ // Label 375: @5562
     /* 5562 */ GIM_Reject,
     /* 5563 */ // Label 66: @5563
     /* 5563 */ GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(5574), // Rule ID 299 //
     /* 5568 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5571 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FREM'
     /* 5571 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5574 */ // Label 376: @5574
     /* 5574 */ GIM_Reject,
     /* 5575 */ // Label 67: @5575
     /* 5575 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(5596), // Rule ID 196 //
     /* 5580 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 5583 */   // MIs[0] dst
     /* 5583 */   // No operand predicates
     /* 5583 */   // MIs[0] float
     /* 5583 */   // No operand predicates
     /* 5583 */   // MIs[0] int
     /* 5583 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 5587 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 5591 */   // MIs[1] imm
     /* 5591 */   // No operand predicates
     /* 5591 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5593 */   // Combiner Rule #146: expand_const_fpowi
     /* 5593 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 5596 */ // Label 377: @5596
     /* 5596 */ GIM_Reject,
     /* 5597 */ // Label 68: @5597
     /* 5597 */ GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(5618), // Rule ID 178 //
     /* 5602 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule136Enabled),
     /* 5605 */   // MIs[0] dst
     /* 5605 */   // No operand predicates
     /* 5605 */   // MIs[0] src0
     /* 5605 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5609 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5613 */   // MIs[1] cst
     /* 5613 */   // No operand predicates
     /* 5613 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5615 */   // Combiner Rule #136: constant_fold_flog2
     /* 5615 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 5618 */ // Label 378: @5618
     /* 5618 */ GIM_Reject,
     /* 5619 */ // Label 69: @5619
     /* 5619 */ GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(5630), // Rule ID 362 //
     /* 5624 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule215Enabled),
     /* 5627 */   // Combiner Rule #215: foldable_fneg; wip_match_opcode 'G_FNEG'
     /* 5627 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner152),
     /* 5630 */ // Label 379: @5630
     /* 5630 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(5651), // Rule ID 175 //
     /* 5635 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule133Enabled),
     /* 5638 */   // MIs[0] dst
     /* 5638 */   // No operand predicates
     /* 5638 */   // MIs[0] src0
     /* 5638 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5642 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5646 */   // MIs[1] cst
     /* 5646 */   // No operand predicates
     /* 5646 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5648 */   // Combiner Rule #133: constant_fold_fneg
     /* 5648 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 5651 */ // Label 380: @5651
     /* 5651 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(5680), // Rule ID 126 //
     /* 5656 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule90Enabled),
     /* 5659 */   // MIs[0] dst
     /* 5659 */   // No operand predicates
     /* 5659 */   // MIs[0] t
     /* 5659 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5663 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5667 */   // MIs[1] src
     /* 5667 */   // No operand predicates
     /* 5667 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 5672 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5674 */   // Combiner Rule #90: fneg_fneg_fold
     /* 5674 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 5679 */   GIR_EraseRootFromParent_Done,
     /* 5680 */ // Label 381: @5680
     /* 5680 */ GIM_Reject,
     /* 5681 */ // Label 70: @5681
     /* 5681 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(5702), // Rule ID 179 //
     /* 5686 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule137Enabled),
     /* 5689 */   // MIs[0] dst
     /* 5689 */   // No operand predicates
     /* 5689 */   // MIs[0] src0
     /* 5689 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5693 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5697 */   // MIs[1] cst
     /* 5697 */   // No operand predicates
     /* 5697 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5699 */   // Combiner Rule #137: constant_fold_fptrunc
     /* 5699 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 5702 */ // Label 382: @5702
     /* 5702 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(5723), // Rule ID 136 //
     /* 5707 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule98Enabled),
     /* 5710 */   // MIs[0] dst
     /* 5710 */   // No operand predicates
     /* 5710 */   // MIs[0] src1
     /* 5710 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5714 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPEXT),
     /* 5718 */   // MIs[1] src0
     /* 5718 */   // No operand predicates
     /* 5718 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5720 */   // Combiner Rule #98: fptrunc_fpext_fold
     /* 5720 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 5723 */ // Label 383: @5723
     /* 5723 */ GIM_Reject,
     /* 5724 */ // Label 71: @5724
     /* 5724 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(5745), // Rule ID 91 //
     /* 5729 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 5732 */   // MIs[0] dst
     /* 5732 */   // No operand predicates
     /* 5732 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 5732 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5736 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 5740 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5742 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[5]]
     /* 5742 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 5745 */ // Label 384: @5745
     /* 5745 */ GIM_Reject,
     /* 5746 */ // Label 72: @5746
     /* 5746 */ GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(5767), // Rule ID 92 //
     /* 5751 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 5754 */   // MIs[0] dst
     /* 5754 */   // No operand predicates
     /* 5754 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 5754 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5758 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 5762 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5764 */   // Combiner Rule #76: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[6]]
     /* 5764 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 5767 */ // Label 385: @5767
     /* 5767 */ GIM_Reject,
     /* 5768 */ // Label 73: @5768
     /* 5768 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(5779), // Rule ID 75 //
     /* 5773 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 5776 */   // Combiner Rule #70: undef_to_fp_zero; wip_match_opcode 'G_SITOFP'
     /* 5776 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 5779 */ // Label 386: @5779
     /* 5779 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(5794), // Rule ID 180 //
     /* 5784 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule138Enabled),
     /* 5787 */   // MIs[0] dst
     /* 5787 */   // No operand predicates
     /* 5787 */   // MIs[0] Operand 1
     /* 5787 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 5791 */   // Combiner Rule #138: itof_const_zero_fold_si
     /* 5791 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5794 */ // Label 387: @5794
     /* 5794 */ GIM_Reject,
     /* 5795 */ // Label 74: @5795
     /* 5795 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(5806), // Rule ID 74 //
     /* 5800 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 5803 */   // Combiner Rule #70: undef_to_fp_zero; wip_match_opcode 'G_UITOFP'
     /* 5803 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 5806 */ // Label 388: @5806
     /* 5806 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(5821), // Rule ID 181 //
     /* 5811 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule139Enabled),
     /* 5814 */   // MIs[0] dst
     /* 5814 */   // No operand predicates
     /* 5814 */   // MIs[0] Operand 1
     /* 5814 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 5818 */   // Combiner Rule #139: itof_const_zero_fold_ui
     /* 5818 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5821 */ // Label 389: @5821
     /* 5821 */ GIM_Reject,
     /* 5822 */ // Label 75: @5822
     /* 5822 */ GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(5851), // Rule ID 19 //
     /* 5827 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 5830 */   // MIs[0] dst
     /* 5830 */   // No operand predicates
     /* 5830 */   // MIs[0] src
     /* 5830 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5834 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 5838 */   // MIs[1] __idempotent_prop_match_0.x
     /* 5838 */   // No operand predicates
     /* 5838 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5843 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5845 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[1]]
     /* 5845 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5850 */   GIR_EraseRootFromParent_Done,
     /* 5851 */ // Label 390: @5851
     /* 5851 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(5872), // Rule ID 176 //
     /* 5856 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule134Enabled),
     /* 5859 */   // MIs[0] dst
     /* 5859 */   // No operand predicates
     /* 5859 */   // MIs[0] src0
     /* 5859 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5863 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5867 */   // MIs[1] cst
     /* 5867 */   // No operand predicates
     /* 5867 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5869 */   // Combiner Rule #134: constant_fold_fabs
     /* 5869 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 5872 */ // Label 391: @5872
     /* 5872 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(5900), // Rule ID 257 //
     /* 5877 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 5880 */   // MIs[0] dst
     /* 5880 */   // No operand predicates
     /* 5880 */   // MIs[0] tmp
     /* 5880 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5884 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5888 */   // MIs[1] x
     /* 5888 */   // No operand predicates
     /* 5888 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5890 */   // Combiner Rule #169: fabs_fneg_fold
     /* 5890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FABS),
     /* 5893 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 5895 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 5899 */   GIR_EraseRootFromParent_Done,
     /* 5900 */ // Label 392: @5900
     /* 5900 */ GIM_Reject,
     /* 5901 */ // Label 76: @5901
     /* 5901 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(5930), // Rule ID 20 //
     /* 5906 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 5909 */   // MIs[0] dst
     /* 5909 */   // No operand predicates
     /* 5909 */   // MIs[0] src
     /* 5909 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5913 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 5917 */   // MIs[1] __idempotent_prop_match_0.x
     /* 5917 */   // No operand predicates
     /* 5917 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5922 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5924 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[2]]
     /* 5924 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5929 */   GIR_EraseRootFromParent_Done,
     /* 5930 */ // Label 393: @5930
     /* 5930 */ GIM_Reject,
     /* 5931 */ // Label 77: @5931
     /* 5931 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(5942), // Rule ID 192 //
     /* 5936 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 5939 */   // Combiner Rule #145: combine_minmax_nan; wip_match_opcode 'G_FMINNUM'
     /* 5939 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5942 */ // Label 394: @5942
     /* 5942 */ GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(5953), // Rule ID 300 //
     /* 5947 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5950 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FMINNUM'
     /* 5950 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5953 */ // Label 395: @5953
     /* 5953 */ GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(5964), // Rule ID 330 //
     /* 5958 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5961 */   // Combiner Rule #190: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM'
     /* 5961 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5964 */ // Label 396: @5964
     /* 5964 */ GIM_Reject,
     /* 5965 */ // Label 78: @5965
     /* 5965 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(5976), // Rule ID 193 //
     /* 5970 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 5973 */   // Combiner Rule #145: combine_minmax_nan; wip_match_opcode 'G_FMAXNUM'
     /* 5973 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5976 */ // Label 397: @5976
     /* 5976 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(5987), // Rule ID 301 //
     /* 5981 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5984 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FMAXNUM'
     /* 5984 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5987 */ // Label 398: @5987
     /* 5987 */ GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(5998), // Rule ID 331 //
     /* 5992 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5995 */   // Combiner Rule #190: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM'
     /* 5995 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5998 */ // Label 399: @5998
     /* 5998 */ GIM_Reject,
     /* 5999 */ // Label 79: @5999
     /* 5999 */ GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(6010), // Rule ID 332 //
     /* 6004 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6007 */   // Combiner Rule #190: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM_IEEE'
     /* 6007 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6010 */ // Label 400: @6010
     /* 6010 */ GIM_Reject,
     /* 6011 */ // Label 80: @6011
     /* 6011 */ GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(6022), // Rule ID 333 //
     /* 6016 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6019 */   // Combiner Rule #190: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM_IEEE'
     /* 6019 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6022 */ // Label 401: @6022
     /* 6022 */ GIM_Reject,
     /* 6023 */ // Label 81: @6023
     /* 6023 */ GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(6034), // Rule ID 194 //
     /* 6028 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 6031 */   // Combiner Rule #145: combine_minmax_nan; wip_match_opcode 'G_FMINIMUM'
     /* 6031 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 6034 */ // Label 402: @6034
     /* 6034 */ GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(6045), // Rule ID 302 //
     /* 6039 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 6042 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FMINIMUM'
     /* 6042 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6045 */ // Label 403: @6045
     /* 6045 */ GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(6056), // Rule ID 334 //
     /* 6050 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6053 */   // Combiner Rule #190: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINIMUM'
     /* 6053 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6056 */ // Label 404: @6056
     /* 6056 */ GIM_Reject,
     /* 6057 */ // Label 82: @6057
     /* 6057 */ GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(6068), // Rule ID 195 //
     /* 6062 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 6065 */   // Combiner Rule #145: combine_minmax_nan; wip_match_opcode 'G_FMAXIMUM'
     /* 6065 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 6068 */ // Label 405: @6068
     /* 6068 */ GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(6079), // Rule ID 303 //
     /* 6073 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 6076 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_FMAXIMUM'
     /* 6076 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6079 */ // Label 406: @6079
     /* 6079 */ GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(6090), // Rule ID 335 //
     /* 6084 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6087 */   // Combiner Rule #190: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXIMUM'
     /* 6087 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6090 */ // Label 407: @6090
     /* 6090 */ GIM_Reject,
     /* 6091 */ // Label 83: @6091
     /* 6091 */ GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(6102), // Rule ID 147 //
     /* 6096 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 6099 */   // Combiner Rule #105: reassoc_ptradd; wip_match_opcode 'G_PTR_ADD'
     /* 6099 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 6102 */ // Label 408: @6102
     /* 6102 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(6113), // Rule ID 149 //
     /* 6107 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule107Enabled),
     /* 6110 */   // Combiner Rule #107: ptr_add_immed_chain; wip_match_opcode 'G_PTR_ADD'
     /* 6110 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 6113 */ // Label 409: @6113
     /* 6113 */ GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(6124), // Rule ID 182 //
     /* 6118 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule140Enabled),
     /* 6121 */   // Combiner Rule #140: const_ptradd_to_i2p; wip_match_opcode 'G_PTR_ADD'
     /* 6121 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner82),
     /* 6124 */ // Label 410: @6124
     /* 6124 */ GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(6135), // Rule ID 198 //
     /* 6129 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 6132 */   // Combiner Rule #148: ptr_add_with_zero; wip_match_opcode 'G_PTR_ADD'
     /* 6132 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner90),
     /* 6135 */ // Label 411: @6135
     /* 6135 */ GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(6146), // Rule ID 231 //
     /* 6140 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 6143 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_PTR_ADD'
     /* 6143 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6146 */ // Label 412: @6146
     /* 6146 */ GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(6157), // Rule ID 280 //
     /* 6151 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 6154 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_PTR_ADD'
     /* 6154 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6157 */ // Label 413: @6157
     /* 6157 */ GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(6180), // Rule ID 110 //
     /* 6162 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 6165 */   // MIs[0] dst
     /* 6165 */   // No operand predicates
     /* 6165 */   // MIs[0] lhs
     /* 6165 */   // No operand predicates
     /* 6165 */   // MIs[0] Operand 2
     /* 6165 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 6169 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6174 */   // Combiner Rule #83: right_identity_zero @ [__right_identity_zero_match_0[7]]
     /* 6174 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6179 */   GIR_EraseRootFromParent_Done,
     /* 6180 */ // Label 414: @6180
     /* 6180 */ GIM_Reject,
     /* 6181 */ // Label 84: @6181
     /* 6181 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(6192), // Rule ID 244 //
     /* 6186 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 6189 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_SMIN'
     /* 6189 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6192 */ // Label 415: @6192
     /* 6192 */ GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(6203), // Rule ID 291 //
     /* 6197 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 6200 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_SMIN'
     /* 6200 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6203 */ // Label 416: @6203
     /* 6203 */ GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(6214), // Rule ID 312 //
     /* 6208 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 6211 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_SMIN'
     /* 6211 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 6214 */ // Label 417: @6214
     /* 6214 */ GIM_Reject,
     /* 6215 */ // Label 85: @6215
     /* 6215 */ GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(6226), // Rule ID 245 //
     /* 6220 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 6223 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_SMAX'
     /* 6223 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6226 */ // Label 418: @6226
     /* 6226 */ GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(6237), // Rule ID 292 //
     /* 6231 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 6234 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_SMAX'
     /* 6234 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6237 */ // Label 419: @6237
     /* 6237 */ GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(6248), // Rule ID 313 //
     /* 6242 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 6245 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_SMAX'
     /* 6245 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 6248 */ // Label 420: @6248
     /* 6248 */ GIM_Reject,
     /* 6249 */ // Label 86: @6249
     /* 6249 */ GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(6260), // Rule ID 246 //
     /* 6254 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 6257 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_UMIN'
     /* 6257 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6260 */ // Label 421: @6260
     /* 6260 */ GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(6271), // Rule ID 293 //
     /* 6265 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 6268 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_UMIN'
     /* 6268 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6271 */ // Label 422: @6271
     /* 6271 */ GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(6282), // Rule ID 314 //
     /* 6276 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 6279 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_UMIN'
     /* 6279 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 6282 */ // Label 423: @6282
     /* 6282 */ GIM_Reject,
     /* 6283 */ // Label 87: @6283
     /* 6283 */ GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(6294), // Rule ID 247 //
     /* 6288 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 6291 */   // Combiner Rule #165: constant_fold_binop; wip_match_opcode 'G_UMAX'
     /* 6291 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 6294 */ // Label 424: @6294
     /* 6294 */ GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(6305), // Rule ID 294 //
     /* 6299 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 6302 */   // Combiner Rule #185: fold_binop_into_select; wip_match_opcode 'G_UMAX'
     /* 6302 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 6305 */ // Label 425: @6305
     /* 6305 */ GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(6316), // Rule ID 315 //
     /* 6310 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 6313 */   // Combiner Rule #189: commute_int_constant_to_rhs; wip_match_opcode 'G_UMAX'
     /* 6313 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 6316 */ // Label 426: @6316
     /* 6316 */ GIM_Reject,
     /* 6317 */ // Label 88: @6317
     /* 6317 */ GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(6328), // Rule ID 85 //
     /* 6322 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 6325 */   // Combiner Rule #75: unary_undef_to_zero; wip_match_opcode 'G_ABS'
     /* 6325 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 6328 */ // Label 427: @6328
     /* 6328 */ GIM_Reject,
     /* 6329 */ // Label 89: @6329
     /* 6329 */ GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(6340), // Rule ID 174 //
     /* 6334 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule132Enabled),
     /* 6337 */   // Combiner Rule #132: opt_brcond_by_inverting_cond; wip_match_opcode 'G_BR'
     /* 6337 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner79),
     /* 6340 */ // Label 428: @6340
     /* 6340 */ GIM_Reject,
     /* 6341 */ // Label 90: @6341
     /* 6341 */ GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(6352), // Rule ID 26 //
     /* 6346 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 6349 */   // Combiner Rule #24: insert_vector_elt_oob; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6349 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner10),
     /* 6352 */ // Label 429: @6352
     /* 6352 */ GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(6363), // Rule ID 66 //
     /* 6357 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule64Enabled),
     /* 6360 */   // Combiner Rule #64: combine_insert_vec_elts_build_vector; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6360 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner26),
     /* 6363 */ // Label 430: @6363
     /* 6363 */ GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(6374), // Rule ID 100 //
     /* 6368 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 6371 */   // Combiner Rule #81: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6371 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 6374 */ // Label 431: @6374
     /* 6374 */ GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(6413), // Rule ID 38 //
     /* 6379 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule36Enabled),
     /* 6382 */   // MIs[0] root
     /* 6382 */   // No operand predicates
     /* 6382 */   // MIs[0] src
     /* 6382 */   // No operand predicates
     /* 6382 */   // MIs[0] elt
     /* 6382 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6386 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 6390 */   // MIs[1] src
     /* 6390 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 6395 */   // MIs[1] idx
     /* 6395 */   // No operand predicates
     /* 6395 */   // MIs[0] idx
     /* 6395 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 6400 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6405 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6407 */   // Combiner Rule #36: insert_vector_element_extract_vector_element
     /* 6407 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6412 */   GIR_EraseRootFromParent_Done,
     /* 6413 */ // Label 432: @6413
     /* 6413 */ GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(6446), // Rule ID 24 //
     /* 6418 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule22Enabled),
     /* 6421 */   // MIs[0] root
     /* 6421 */   // No operand predicates
     /* 6421 */   // MIs[0] src
     /* 6421 */   // No operand predicates
     /* 6421 */   // MIs[0] elt
     /* 6421 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6425 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6429 */   // MIs[0] idx
     /* 6429 */   // No operand predicates
     /* 6429 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner0),
     /* 6433 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6438 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6440 */   // Combiner Rule #22: insert_vector_element_elt_undef
     /* 6440 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6445 */   GIR_EraseRootFromParent_Done,
     /* 6446 */ // Label 433: @6446
     /* 6446 */ GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(6470), // Rule ID 23 //
     /* 6451 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule21Enabled),
     /* 6454 */   // MIs[0] root
     /* 6454 */   // No operand predicates
     /* 6454 */   // MIs[0] src
     /* 6454 */   // No operand predicates
     /* 6454 */   // MIs[0] elt
     /* 6454 */   // No operand predicates
     /* 6454 */   // MIs[0] idx
     /* 6454 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 6458 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6462 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6464 */   // Combiner Rule #21: insert_vector_element_idx_undef
     /* 6464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6467 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 6469 */   GIR_EraseRootFromParent_Done,
     /* 6470 */ // Label 434: @6470
     /* 6470 */ GIM_Reject,
     /* 6471 */ // Label 91: @6471
     /* 6471 */ GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(6482), // Rule ID 25 //
     /* 6476 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 6479 */   // Combiner Rule #23: match_extract_of_element; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6479 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 6482 */ // Label 435: @6482
     /* 6482 */ GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(6493), // Rule ID 67 //
     /* 6487 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule65Enabled),
     /* 6490 */   // Combiner Rule #65: extract_vec_elt_build_vec; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6490 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner27),
     /* 6493 */ // Label 436: @6493
     /* 6493 */ GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(6504), // Rule ID 73 //
     /* 6498 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule69Enabled),
     /* 6501 */   // Combiner Rule #69: combine_extracted_vector_load; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6501 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner31),
     /* 6504 */ // Label 437: @6504
     /* 6504 */ GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(6515), // Rule ID 101 //
     /* 6509 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 6512 */   // Combiner Rule #81: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6512 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 6515 */ // Label 438: @6515
     /* 6515 */ GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(6539), // Rule ID 36 //
     /* 6520 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule34Enabled),
     /* 6523 */   // MIs[0] root
     /* 6523 */   // No operand predicates
     /* 6523 */   // MIs[0] src
     /* 6523 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6527 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6531 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/9,
     /* 6534 */   // MIs[1] x
     /* 6534 */   // No operand predicates
     /* 6534 */   // MIs[1] y
     /* 6534 */   // No operand predicates
     /* 6534 */   // MIs[1] z
     /* 6534 */   // No operand predicates
     /* 6534 */   // MIs[1] a
     /* 6534 */   // No operand predicates
     /* 6534 */   // MIs[1] b
     /* 6534 */   // No operand predicates
     /* 6534 */   // MIs[1] c
     /* 6534 */   // No operand predicates
     /* 6534 */   // MIs[1] d
     /* 6534 */   // No operand predicates
     /* 6534 */   // MIs[1] e
     /* 6534 */   // No operand predicates
     /* 6534 */   // MIs[0] idx
     /* 6534 */   // No operand predicates
     /* 6534 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6536 */   // Combiner Rule #34: extract_vector_element_build_vector_trunc8
     /* 6536 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6539 */ // Label 439: @6539
     /* 6539 */ GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(6563), // Rule ID 35 //
     /* 6544 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule33Enabled),
     /* 6547 */   // MIs[0] root
     /* 6547 */   // No operand predicates
     /* 6547 */   // MIs[0] src
     /* 6547 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6551 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6555 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/8,
     /* 6558 */   // MIs[1] x
     /* 6558 */   // No operand predicates
     /* 6558 */   // MIs[1] y
     /* 6558 */   // No operand predicates
     /* 6558 */   // MIs[1] z
     /* 6558 */   // No operand predicates
     /* 6558 */   // MIs[1] a
     /* 6558 */   // No operand predicates
     /* 6558 */   // MIs[1] b
     /* 6558 */   // No operand predicates
     /* 6558 */   // MIs[1] c
     /* 6558 */   // No operand predicates
     /* 6558 */   // MIs[1] d
     /* 6558 */   // No operand predicates
     /* 6558 */   // MIs[0] idx
     /* 6558 */   // No operand predicates
     /* 6558 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6560 */   // Combiner Rule #33: extract_vector_element_build_vector_trunc7
     /* 6560 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6563 */ // Label 440: @6563
     /* 6563 */ GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(6587), // Rule ID 34 //
     /* 6568 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule32Enabled),
     /* 6571 */   // MIs[0] root
     /* 6571 */   // No operand predicates
     /* 6571 */   // MIs[0] src
     /* 6571 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6575 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6579 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/7,
     /* 6582 */   // MIs[1] x
     /* 6582 */   // No operand predicates
     /* 6582 */   // MIs[1] y
     /* 6582 */   // No operand predicates
     /* 6582 */   // MIs[1] z
     /* 6582 */   // No operand predicates
     /* 6582 */   // MIs[1] a
     /* 6582 */   // No operand predicates
     /* 6582 */   // MIs[1] b
     /* 6582 */   // No operand predicates
     /* 6582 */   // MIs[1] c
     /* 6582 */   // No operand predicates
     /* 6582 */   // MIs[0] idx
     /* 6582 */   // No operand predicates
     /* 6582 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6584 */   // Combiner Rule #32: extract_vector_element_build_vector_trunc6
     /* 6584 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6587 */ // Label 441: @6587
     /* 6587 */ GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(6611), // Rule ID 33 //
     /* 6592 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule31Enabled),
     /* 6595 */   // MIs[0] root
     /* 6595 */   // No operand predicates
     /* 6595 */   // MIs[0] src
     /* 6595 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6599 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6603 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/6,
     /* 6606 */   // MIs[1] x
     /* 6606 */   // No operand predicates
     /* 6606 */   // MIs[1] y
     /* 6606 */   // No operand predicates
     /* 6606 */   // MIs[1] z
     /* 6606 */   // No operand predicates
     /* 6606 */   // MIs[1] a
     /* 6606 */   // No operand predicates
     /* 6606 */   // MIs[1] b
     /* 6606 */   // No operand predicates
     /* 6606 */   // MIs[0] idx
     /* 6606 */   // No operand predicates
     /* 6606 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6608 */   // Combiner Rule #31: extract_vector_element_build_vector_trunc5
     /* 6608 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6611 */ // Label 442: @6611
     /* 6611 */ GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(6635), // Rule ID 32 //
     /* 6616 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule30Enabled),
     /* 6619 */   // MIs[0] root
     /* 6619 */   // No operand predicates
     /* 6619 */   // MIs[0] src
     /* 6619 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6623 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6627 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 6630 */   // MIs[1] x
     /* 6630 */   // No operand predicates
     /* 6630 */   // MIs[1] y
     /* 6630 */   // No operand predicates
     /* 6630 */   // MIs[1] z
     /* 6630 */   // No operand predicates
     /* 6630 */   // MIs[1] a
     /* 6630 */   // No operand predicates
     /* 6630 */   // MIs[0] idx
     /* 6630 */   // No operand predicates
     /* 6630 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6632 */   // Combiner Rule #30: extract_vector_element_build_vector_trunc4
     /* 6632 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6635 */ // Label 443: @6635
     /* 6635 */ GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(6659), // Rule ID 31 //
     /* 6640 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule29Enabled),
     /* 6643 */   // MIs[0] root
     /* 6643 */   // No operand predicates
     /* 6643 */   // MIs[0] src
     /* 6643 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6647 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6651 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 6654 */   // MIs[1] x
     /* 6654 */   // No operand predicates
     /* 6654 */   // MIs[1] y
     /* 6654 */   // No operand predicates
     /* 6654 */   // MIs[1] z
     /* 6654 */   // No operand predicates
     /* 6654 */   // MIs[0] idx
     /* 6654 */   // No operand predicates
     /* 6654 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6656 */   // Combiner Rule #29: extract_vector_element_build_vector_trunc3
     /* 6656 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6659 */ // Label 444: @6659
     /* 6659 */ GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(6693), // Rule ID 27 //
     /* 6664 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 6667 */   // MIs[0] root
     /* 6667 */   // No operand predicates
     /* 6667 */   // MIs[0] src
     /* 6667 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6671 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 6675 */   // MIs[1] x
     /* 6675 */   // No operand predicates
     /* 6675 */   // MIs[1] value
     /* 6675 */   // No operand predicates
     /* 6675 */   // MIs[1] idx
     /* 6675 */   // No operand predicates
     /* 6675 */   // MIs[0] idx
     /* 6675 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/3,
     /* 6680 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 6685 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6687 */   // Combiner Rule #25: extract_vector_element_not_const
     /* 6687 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 6692 */   GIR_EraseRootFromParent_Done,
     /* 6693 */ // Label 445: @6693
     /* 6693 */ GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(6714), // Rule ID 28 //
     /* 6698 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule26Enabled),
     /* 6701 */   // MIs[0] root
     /* 6701 */   // No operand predicates
     /* 6701 */   // MIs[0] src
     /* 6701 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6705 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 6709 */   // MIs[1] x
     /* 6709 */   // No operand predicates
     /* 6709 */   // MIs[1] value
     /* 6709 */   // No operand predicates
     /* 6709 */   // MIs[1] idx2
     /* 6709 */   // No operand predicates
     /* 6709 */   // MIs[0] idx1
     /* 6709 */   // No operand predicates
     /* 6709 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6711 */   // Combiner Rule #26: extract_vector_element_different_indices
     /* 6711 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 6714 */ // Label 446: @6714
     /* 6714 */ GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(6743), // Rule ID 37 //
     /* 6719 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule35Enabled),
     /* 6722 */   // MIs[0] root
     /* 6722 */   // No operand predicates
     /* 6722 */   // MIs[0] src
     /* 6722 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6726 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHUFFLE_VECTOR),
     /* 6730 */   // MIs[1] src1
     /* 6730 */   // No operand predicates
     /* 6730 */   // MIs[1] src2
     /* 6730 */   // No operand predicates
     /* 6730 */   // MIs[1] mask
     /* 6730 */   // No operand predicates
     /* 6730 */   // MIs[0] idx
     /* 6730 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 6734 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 6738 */   // MIs[2] imm
     /* 6738 */   // No operand predicates
     /* 6738 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 6740 */   // Combiner Rule #35: extract_vector_element_shuffle_vector
     /* 6740 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 6743 */ // Label 447: @6743
     /* 6743 */ GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(6767), // Rule ID 30 //
     /* 6748 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule28Enabled),
     /* 6751 */   // MIs[0] root
     /* 6751 */   // No operand predicates
     /* 6751 */   // MIs[0] src
     /* 6751 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6755 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6759 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 6762 */   // MIs[1] x
     /* 6762 */   // No operand predicates
     /* 6762 */   // MIs[1] y
     /* 6762 */   // No operand predicates
     /* 6762 */   // MIs[0] idx
     /* 6762 */   // No operand predicates
     /* 6762 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6764 */   // Combiner Rule #28: extract_vector_element_build_vector_trunc2
     /* 6764 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6767 */ // Label 448: @6767
     /* 6767 */ GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(6799), // Rule ID 29 //
     /* 6772 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule27Enabled),
     /* 6775 */   // MIs[0] root
     /* 6775 */   // No operand predicates
     /* 6775 */   // MIs[0] src
     /* 6775 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6779 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 6783 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 6786 */   // MIs[1] unused
     /* 6786 */   // No operand predicates
     /* 6786 */   // MIs[0] idx
     /* 6786 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 6790 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 6794 */   // MIs[2] imm
     /* 6794 */   // No operand predicates
     /* 6794 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 6796 */   // Combiner Rule #27: extract_vector_element_build_vector
     /* 6796 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 6799 */ // Label 449: @6799
     /* 6799 */ GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(6823), // Rule ID 21 //
     /* 6804 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 6807 */   // MIs[0] root
     /* 6807 */   // No operand predicates
     /* 6807 */   // MIs[0] vector
     /* 6807 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6811 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6815 */   // MIs[0] idx
     /* 6815 */   // No operand predicates
     /* 6815 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6817 */   // Combiner Rule #19: match_extract_of_element_undef_vector
     /* 6817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6820 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 6822 */   GIR_EraseRootFromParent_Done,
     /* 6823 */ // Label 450: @6823
     /* 6823 */ GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(6847), // Rule ID 22 //
     /* 6828 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule20Enabled),
     /* 6831 */   // MIs[0] root
     /* 6831 */   // No operand predicates
     /* 6831 */   // MIs[0] vector
     /* 6831 */   // No operand predicates
     /* 6831 */   // MIs[0] idx
     /* 6831 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6835 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6839 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6841 */   // Combiner Rule #20: match_extract_of_element_undef_index
     /* 6841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6844 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 6846 */   GIR_EraseRootFromParent_Done,
     /* 6847 */ // Label 451: @6847
     /* 6847 */ GIM_Reject,
     /* 6848 */ // Label 92: @6848
     /* 6848 */ GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(6859), // Rule ID 96 //
     /* 6853 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 6856 */   // Combiner Rule #78: propagate_undef_all_ops; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 6856 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 6859 */ // Label 452: @6859
     /* 6859 */ GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(6870), // Rule ID 98 //
     /* 6864 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 6867 */   // Combiner Rule #79: propagate_undef_shuffle_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 6867 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 6870 */ // Label 453: @6870
     /* 6870 */ GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(6881), // Rule ID 343 //
     /* 6875 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule198Enabled),
     /* 6878 */   // Combiner Rule #198: combine_shuffle_concat; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 6878 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner135),
     /* 6881 */ // Label 454: @6881
     /* 6881 */ GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(6892), // Rule ID 345 //
     /* 6886 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule200Enabled),
     /* 6889 */   // Combiner Rule #200: combine_shuffle_disjoint_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 6889 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner137),
     /* 6892 */ // Label 455: @6892
     /* 6892 */ GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(6913), // Rule ID 344 //
     /* 6897 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule199Enabled),
     /* 6900 */   // MIs[0] root
     /* 6900 */   // No operand predicates
     /* 6900 */   // MIs[0] src1
     /* 6900 */   // No operand predicates
     /* 6900 */   // MIs[0] undef
     /* 6900 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6904 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6908 */   // MIs[0] mask
     /* 6908 */   // No operand predicates
     /* 6908 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6910 */   // Combiner Rule #199: combine_shuffle_undef_rhs
     /* 6910 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner136),
     /* 6913 */ // Label 456: @6913
     /* 6913 */ GIM_Reject,
     /* 6914 */ // Label 93: @6914
     /* 6914 */ GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(6958), // Rule ID 222 //
     /* 6919 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule159Enabled),
     /* 6922 */   // MIs[0] d
     /* 6922 */   // No operand predicates
     /* 6922 */   // MIs[0] src
     /* 6922 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6926 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 6930 */   // MIs[1] rev
     /* 6930 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 6934 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 6938 */   // MIs[2] val
     /* 6938 */   // No operand predicates
     /* 6938 */   // MIs[1] amt
     /* 6938 */   // No operand predicates
     /* 6938 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner9),
     /* 6942 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 6944 */   // Combiner Rule #159: bitreverse_lshr
     /* 6944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SHL),
     /* 6947 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 6949 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 6953 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 6957 */   GIR_EraseRootFromParent_Done,
     /* 6958 */ // Label 457: @6958
     /* 6958 */ GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(7002), // Rule ID 221 //
     /* 6963 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule158Enabled),
     /* 6966 */   // MIs[0] d
     /* 6966 */   // No operand predicates
     /* 6966 */   // MIs[0] src
     /* 6966 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6970 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 6974 */   // MIs[1] rev
     /* 6974 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 6978 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 6982 */   // MIs[2] val
     /* 6982 */   // No operand predicates
     /* 6982 */   // MIs[1] amt
     /* 6982 */   // No operand predicates
     /* 6982 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner8),
     /* 6986 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 6988 */   // Combiner Rule #158: bitreverse_shl
     /* 6988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 6991 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 6993 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 6997 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 7001 */   GIR_EraseRootFromParent_Done,
     /* 7002 */ // Label 458: @7002
     /* 7002 */ GIM_Reject,
     /* 7003 */ // Label 94: @7003
     /* 7003 */ GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(7024), // Rule ID 177 //
     /* 7008 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule135Enabled),
     /* 7011 */   // MIs[0] dst
     /* 7011 */   // No operand predicates
     /* 7011 */   // MIs[0] src0
     /* 7011 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7015 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 7019 */   // MIs[1] cst
     /* 7019 */   // No operand predicates
     /* 7019 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7021 */   // Combiner Rule #135: constant_fold_fsqrt
     /* 7021 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 7024 */ // Label 459: @7024
     /* 7024 */ GIM_Reject,
     /* 7025 */ // Label 95: @7025
     /* 7025 */ GIM_Reject,
     /* 7026 */ }; // Size: 7026 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GICOMBINER_IMPL

#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS

