/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* DAG Instruction Selector for the WebAssembly target                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

// *** NOTE: This file is #included into the middle of the target
// *** instruction selector class.  These functions are really methods.

// If GET_DAGISEL_DECL is #defined with any value, only function
// declarations will be included when this file is included.
// If GET_DAGISEL_BODY is #defined, its value should be the name of
// the instruction selector class. Function bodies will be emitted
// and each function's name will be qualified with the name of the
// class.
//
// When neither of the GET_DAGISEL* macros is defined, the functions
// are emitted inline.

#if defined(GET_DAGISEL_DECL) && defined(GET_DAGISEL_BODY)
#error GET_DAGISEL_DECL and GET_DAGISEL_BODY cannot be both defined, undef both for inline definitions
#endif

#ifdef GET_DAGISEL_BODY
#define LOCAL_DAGISEL_STRINGIZE(X) LOCAL_DAGISEL_STRINGIZE_(X)
#define LOCAL_DAGISEL_STRINGIZE_(X) #X
static_assert(sizeof(LOCAL_DAGISEL_STRINGIZE(GET_DAGISEL_BODY)) > 1,
   "GET_DAGISEL_BODY is empty: it should be defined with the class name");
#undef LOCAL_DAGISEL_STRINGIZE_
#undef LOCAL_DAGISEL_STRINGIZE
#endif

#if !defined(GET_DAGISEL_DECL) && !defined(GET_DAGISEL_BODY)
#define DAGISEL_INLINE 1
#else
#define DAGISEL_INLINE 0
#endif

#if !DAGISEL_INLINE
#define DAGISEL_CLASS_COLONCOLON GET_DAGISEL_BODY ::
#else
#define DAGISEL_CLASS_COLONCOLON
#endif

#ifdef GET_DAGISEL_DECL
void SelectCode(SDNode *N);
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
void DAGISEL_CLASS_COLONCOLON SelectCode(SDNode *N)
{
  // Some target values are emitted as 2 bytes, TARGET_VAL handles
  // this. Coverage indexes are emitted as 4 bytes,
  // COVERAGE_IDX_VAL handles this.
  #define TARGET_VAL(X) X & 255, unsigned(X) >> 8
  #define COVERAGE_IDX_VAL(X) X & 255, (unsigned(X) >> 8) & 255, (unsigned(X) >> 16) & 255, (unsigned(X) >> 24) & 255
  static const unsigned char MatcherTable[] = {
/*     0*/ OPC_SwitchOpcode /*123 cases */, 44|128,9/*1196*/, TARGET_VAL(ISD::ZERO_EXTEND),// ->1201
/*     5*/  OPC_Scope, 32|128,9/*1184*/, /*->1192*/ // 2 children in Scope
/*     8*/   OPC_MoveChild0,
/*     9*/   OPC_SwitchOpcode /*9 cases */, 124, TARGET_VAL(ISD::AssertZext),// ->137
/*    13*/    OPC_MoveChild0,
/*    14*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*    17*/    OPC_RecordMemRef,
/*    18*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*    19*/    OPC_CheckFoldableChainNode,
/*    20*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*    21*/    OPC_Scope, 56, /*->79*/ // 2 children in Scope
/*    23*/     OPC_CheckChild1TypeI32,
/*    24*/     OPC_MoveChild2,
/*    25*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    28*/     OPC_RecordChild0, // #2 = $exp
/*    29*/     OPC_MoveSibling3,
/*    30*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    33*/     OPC_RecordChild0, // #3 = $new
/*    34*/     OPC_MoveParent,
/*    35*/     OPC_Scope, 20, /*->57*/ // 2 children in Scope
/*    37*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*    38*/      OPC_MoveParent,
/*    39*/      OPC_MoveParent,
/*    40*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    41*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*    43*/      OPC_EmitMergeInputChains1_0,
/*    44*/      OPC_EmitInteger32, 0,  // 0 #6
/*    46*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*    57*/     /*Scope*/ 20, /*->78*/
/*    58*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*    59*/      OPC_MoveParent,
/*    60*/      OPC_MoveParent,
/*    61*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    62*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*    64*/      OPC_EmitMergeInputChains1_0,
/*    65*/      OPC_EmitInteger32, 0,  // 0 #6
/*    67*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*    78*/     0, /*End of Scope*/
/*    79*/    /*Scope*/ 56, /*->136*/
/*    80*/     OPC_CheckChild1TypeI64,
/*    81*/     OPC_MoveChild2,
/*    82*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    85*/     OPC_RecordChild0, // #2 = $exp
/*    86*/     OPC_MoveSibling3,
/*    87*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    90*/     OPC_RecordChild0, // #3 = $new
/*    91*/     OPC_MoveParent,
/*    92*/     OPC_Scope, 20, /*->114*/ // 2 children in Scope
/*    94*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*    95*/      OPC_MoveParent,
/*    96*/      OPC_MoveParent,
/*    97*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    98*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   100*/      OPC_EmitMergeInputChains1_0,
/*   101*/      OPC_EmitInteger32, 0,  // 0 #6
/*   103*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   114*/     /*Scope*/ 20, /*->135*/
/*   115*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*   116*/      OPC_MoveParent,
/*   117*/      OPC_MoveParent,
/*   118*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   119*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   121*/      OPC_EmitMergeInputChains1_0,
/*   122*/      OPC_EmitInteger32, 0,  // 0 #6
/*   124*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   135*/     0, /*End of Scope*/
/*   136*/    0, /*End of Scope*/
/*   137*/   /*SwitchOpcode*/ 69, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->209
/*   140*/    OPC_RecordMemRef,
/*   141*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*   142*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   143*/    OPC_Scope, 31, /*->176*/ // 2 children in Scope
/*   145*/     OPC_CheckChild1TypeI32,
/*   146*/     OPC_MoveChild2,
/*   147*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   150*/     OPC_RecordChild0, // #2 = $exp
/*   151*/     OPC_MoveSibling3,
/*   152*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   155*/     OPC_RecordChild0, // #3 = $new
/*   156*/     OPC_MoveParent,
/*   157*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*   158*/     OPC_MoveParent,
/*   159*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   160*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*   162*/     OPC_EmitMergeInputChains1_0,
/*   163*/     OPC_EmitInteger32, 0,  // 0 #6
/*   165*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i32>>) - Complexity = 22
               // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   176*/    /*Scope*/ 31, /*->208*/
/*   177*/     OPC_CheckChild1TypeI64,
/*   178*/     OPC_MoveChild2,
/*   179*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   182*/     OPC_RecordChild0, // #2 = $exp
/*   183*/     OPC_MoveSibling3,
/*   184*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   187*/     OPC_RecordChild0, // #3 = $new
/*   188*/     OPC_MoveParent,
/*   189*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*   190*/     OPC_MoveParent,
/*   191*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   192*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   194*/     OPC_EmitMergeInputChains1_0,
/*   195*/     OPC_EmitInteger32, 0,  // 0 #6
/*   197*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i32>>) - Complexity = 22
               // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   208*/    0, /*End of Scope*/
/*   209*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->352
/*   213*/    OPC_RecordMemRef,
/*   214*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*   215*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   216*/    OPC_Scope, 66, /*->284*/ // 2 children in Scope
/*   218*/     OPC_CheckChild1TypeI32,
/*   219*/     OPC_MoveChild2,
/*   220*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   223*/     OPC_RecordChild0, // #2 = $val
/*   224*/     OPC_MoveParent,
/*   225*/     OPC_Scope, 18, /*->245*/ // 3 children in Scope
/*   227*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*   228*/      OPC_MoveParent,
/*   229*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   230*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   232*/      OPC_EmitMergeInputChains1_0,
/*   233*/      OPC_EmitInteger32, 0,  // 0 #5
/*   235*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   245*/     /*Scope*/ 18, /*->264*/
/*   246*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*   247*/      OPC_MoveParent,
/*   248*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   249*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   251*/      OPC_EmitMergeInputChains1_0,
/*   252*/      OPC_EmitInteger32, 0,  // 0 #5
/*   254*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   264*/     /*Scope*/ 18, /*->283*/
/*   265*/      OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*   266*/      OPC_MoveParent,
/*   267*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   268*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   270*/      OPC_EmitMergeInputChains1_0,
/*   271*/      OPC_EmitInteger32, 0,  // 0 #5
/*   273*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   283*/     0, /*End of Scope*/
/*   284*/    /*Scope*/ 66, /*->351*/
/*   285*/     OPC_CheckChild1TypeI64,
/*   286*/     OPC_MoveChild2,
/*   287*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   290*/     OPC_RecordChild0, // #2 = $val
/*   291*/     OPC_MoveParent,
/*   292*/     OPC_Scope, 18, /*->312*/ // 3 children in Scope
/*   294*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*   295*/      OPC_MoveParent,
/*   296*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   297*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   299*/      OPC_EmitMergeInputChains1_0,
/*   300*/      OPC_EmitInteger32, 0,  // 0 #5
/*   302*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   312*/     /*Scope*/ 18, /*->331*/
/*   313*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*   314*/      OPC_MoveParent,
/*   315*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   316*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   318*/      OPC_EmitMergeInputChains1_0,
/*   319*/      OPC_EmitInteger32, 0,  // 0 #5
/*   321*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   331*/     /*Scope*/ 18, /*->350*/
/*   332*/      OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*   333*/      OPC_MoveParent,
/*   334*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   335*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   337*/      OPC_EmitMergeInputChains1_0,
/*   338*/      OPC_EmitInteger32, 0,  // 0 #5
/*   340*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   350*/     0, /*End of Scope*/
/*   351*/    0, /*End of Scope*/
/*   352*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->495
/*   356*/    OPC_RecordMemRef,
/*   357*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*   358*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   359*/    OPC_Scope, 66, /*->427*/ // 2 children in Scope
/*   361*/     OPC_CheckChild1TypeI32,
/*   362*/     OPC_MoveChild2,
/*   363*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   366*/     OPC_RecordChild0, // #2 = $val
/*   367*/     OPC_MoveParent,
/*   368*/     OPC_Scope, 18, /*->388*/ // 3 children in Scope
/*   370*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*   371*/      OPC_MoveParent,
/*   372*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   373*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   375*/      OPC_EmitMergeInputChains1_0,
/*   376*/      OPC_EmitInteger32, 0,  // 0 #5
/*   378*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   388*/     /*Scope*/ 18, /*->407*/
/*   389*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*   390*/      OPC_MoveParent,
/*   391*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   392*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   394*/      OPC_EmitMergeInputChains1_0,
/*   395*/      OPC_EmitInteger32, 0,  // 0 #5
/*   397*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   407*/     /*Scope*/ 18, /*->426*/
/*   408*/      OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*   409*/      OPC_MoveParent,
/*   410*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   411*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   413*/      OPC_EmitMergeInputChains1_0,
/*   414*/      OPC_EmitInteger32, 0,  // 0 #5
/*   416*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   426*/     0, /*End of Scope*/
/*   427*/    /*Scope*/ 66, /*->494*/
/*   428*/     OPC_CheckChild1TypeI64,
/*   429*/     OPC_MoveChild2,
/*   430*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   433*/     OPC_RecordChild0, // #2 = $val
/*   434*/     OPC_MoveParent,
/*   435*/     OPC_Scope, 18, /*->455*/ // 3 children in Scope
/*   437*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*   438*/      OPC_MoveParent,
/*   439*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   440*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   442*/      OPC_EmitMergeInputChains1_0,
/*   443*/      OPC_EmitInteger32, 0,  // 0 #5
/*   445*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   455*/     /*Scope*/ 18, /*->474*/
/*   456*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*   457*/      OPC_MoveParent,
/*   458*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   459*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   461*/      OPC_EmitMergeInputChains1_0,
/*   462*/      OPC_EmitInteger32, 0,  // 0 #5
/*   464*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   474*/     /*Scope*/ 18, /*->493*/
/*   475*/      OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*   476*/      OPC_MoveParent,
/*   477*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   478*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   480*/      OPC_EmitMergeInputChains1_0,
/*   481*/      OPC_EmitInteger32, 0,  // 0 #5
/*   483*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   493*/     0, /*End of Scope*/
/*   494*/    0, /*End of Scope*/
/*   495*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->638
/*   499*/    OPC_RecordMemRef,
/*   500*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*   501*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   502*/    OPC_Scope, 66, /*->570*/ // 2 children in Scope
/*   504*/     OPC_CheckChild1TypeI32,
/*   505*/     OPC_MoveChild2,
/*   506*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   509*/     OPC_RecordChild0, // #2 = $val
/*   510*/     OPC_MoveParent,
/*   511*/     OPC_Scope, 18, /*->531*/ // 3 children in Scope
/*   513*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*   514*/      OPC_MoveParent,
/*   515*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   516*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   518*/      OPC_EmitMergeInputChains1_0,
/*   519*/      OPC_EmitInteger32, 0,  // 0 #5
/*   521*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   531*/     /*Scope*/ 18, /*->550*/
/*   532*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*   533*/      OPC_MoveParent,
/*   534*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   535*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   537*/      OPC_EmitMergeInputChains1_0,
/*   538*/      OPC_EmitInteger32, 0,  // 0 #5
/*   540*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   550*/     /*Scope*/ 18, /*->569*/
/*   551*/      OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*   552*/      OPC_MoveParent,
/*   553*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   554*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   556*/      OPC_EmitMergeInputChains1_0,
/*   557*/      OPC_EmitInteger32, 0,  // 0 #5
/*   559*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   569*/     0, /*End of Scope*/
/*   570*/    /*Scope*/ 66, /*->637*/
/*   571*/     OPC_CheckChild1TypeI64,
/*   572*/     OPC_MoveChild2,
/*   573*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   576*/     OPC_RecordChild0, // #2 = $val
/*   577*/     OPC_MoveParent,
/*   578*/     OPC_Scope, 18, /*->598*/ // 3 children in Scope
/*   580*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*   581*/      OPC_MoveParent,
/*   582*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   583*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   585*/      OPC_EmitMergeInputChains1_0,
/*   586*/      OPC_EmitInteger32, 0,  // 0 #5
/*   588*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   598*/     /*Scope*/ 18, /*->617*/
/*   599*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*   600*/      OPC_MoveParent,
/*   601*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   602*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   604*/      OPC_EmitMergeInputChains1_0,
/*   605*/      OPC_EmitInteger32, 0,  // 0 #5
/*   607*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   617*/     /*Scope*/ 18, /*->636*/
/*   618*/      OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*   619*/      OPC_MoveParent,
/*   620*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   621*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   623*/      OPC_EmitMergeInputChains1_0,
/*   624*/      OPC_EmitInteger32, 0,  // 0 #5
/*   626*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   636*/     0, /*End of Scope*/
/*   637*/    0, /*End of Scope*/
/*   638*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->781
/*   642*/    OPC_RecordMemRef,
/*   643*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*   644*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   645*/    OPC_Scope, 66, /*->713*/ // 2 children in Scope
/*   647*/     OPC_CheckChild1TypeI32,
/*   648*/     OPC_MoveChild2,
/*   649*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   652*/     OPC_RecordChild0, // #2 = $val
/*   653*/     OPC_MoveParent,
/*   654*/     OPC_Scope, 18, /*->674*/ // 3 children in Scope
/*   656*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*   657*/      OPC_MoveParent,
/*   658*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   659*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   661*/      OPC_EmitMergeInputChains1_0,
/*   662*/      OPC_EmitInteger32, 0,  // 0 #5
/*   664*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   674*/     /*Scope*/ 18, /*->693*/
/*   675*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*   676*/      OPC_MoveParent,
/*   677*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   678*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   680*/      OPC_EmitMergeInputChains1_0,
/*   681*/      OPC_EmitInteger32, 0,  // 0 #5
/*   683*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   693*/     /*Scope*/ 18, /*->712*/
/*   694*/      OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*   695*/      OPC_MoveParent,
/*   696*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   697*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   699*/      OPC_EmitMergeInputChains1_0,
/*   700*/      OPC_EmitInteger32, 0,  // 0 #5
/*   702*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   712*/     0, /*End of Scope*/
/*   713*/    /*Scope*/ 66, /*->780*/
/*   714*/     OPC_CheckChild1TypeI64,
/*   715*/     OPC_MoveChild2,
/*   716*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   719*/     OPC_RecordChild0, // #2 = $val
/*   720*/     OPC_MoveParent,
/*   721*/     OPC_Scope, 18, /*->741*/ // 3 children in Scope
/*   723*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*   724*/      OPC_MoveParent,
/*   725*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   726*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   728*/      OPC_EmitMergeInputChains1_0,
/*   729*/      OPC_EmitInteger32, 0,  // 0 #5
/*   731*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   741*/     /*Scope*/ 18, /*->760*/
/*   742*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*   743*/      OPC_MoveParent,
/*   744*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   745*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   747*/      OPC_EmitMergeInputChains1_0,
/*   748*/      OPC_EmitInteger32, 0,  // 0 #5
/*   750*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   760*/     /*Scope*/ 18, /*->779*/
/*   761*/      OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*   762*/      OPC_MoveParent,
/*   763*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   764*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   766*/      OPC_EmitMergeInputChains1_0,
/*   767*/      OPC_EmitInteger32, 0,  // 0 #5
/*   769*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   779*/     0, /*End of Scope*/
/*   780*/    0, /*End of Scope*/
/*   781*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->924
/*   785*/    OPC_RecordMemRef,
/*   786*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*   787*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   788*/    OPC_Scope, 66, /*->856*/ // 2 children in Scope
/*   790*/     OPC_CheckChild1TypeI32,
/*   791*/     OPC_MoveChild2,
/*   792*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   795*/     OPC_RecordChild0, // #2 = $val
/*   796*/     OPC_MoveParent,
/*   797*/     OPC_Scope, 18, /*->817*/ // 3 children in Scope
/*   799*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*   800*/      OPC_MoveParent,
/*   801*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   802*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   804*/      OPC_EmitMergeInputChains1_0,
/*   805*/      OPC_EmitInteger32, 0,  // 0 #5
/*   807*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   817*/     /*Scope*/ 18, /*->836*/
/*   818*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*   819*/      OPC_MoveParent,
/*   820*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   821*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   823*/      OPC_EmitMergeInputChains1_0,
/*   824*/      OPC_EmitInteger32, 0,  // 0 #5
/*   826*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   836*/     /*Scope*/ 18, /*->855*/
/*   837*/      OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*   838*/      OPC_MoveParent,
/*   839*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   840*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   842*/      OPC_EmitMergeInputChains1_0,
/*   843*/      OPC_EmitInteger32, 0,  // 0 #5
/*   845*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   855*/     0, /*End of Scope*/
/*   856*/    /*Scope*/ 66, /*->923*/
/*   857*/     OPC_CheckChild1TypeI64,
/*   858*/     OPC_MoveChild2,
/*   859*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   862*/     OPC_RecordChild0, // #2 = $val
/*   863*/     OPC_MoveParent,
/*   864*/     OPC_Scope, 18, /*->884*/ // 3 children in Scope
/*   866*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*   867*/      OPC_MoveParent,
/*   868*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   869*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   871*/      OPC_EmitMergeInputChains1_0,
/*   872*/      OPC_EmitInteger32, 0,  // 0 #5
/*   874*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   884*/     /*Scope*/ 18, /*->903*/
/*   885*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*   886*/      OPC_MoveParent,
/*   887*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   888*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   890*/      OPC_EmitMergeInputChains1_0,
/*   891*/      OPC_EmitInteger32, 0,  // 0 #5
/*   893*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   903*/     /*Scope*/ 18, /*->922*/
/*   904*/      OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*   905*/      OPC_MoveParent,
/*   906*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   907*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   909*/      OPC_EmitMergeInputChains1_0,
/*   910*/      OPC_EmitInteger32, 0,  // 0 #5
/*   912*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   922*/     0, /*End of Scope*/
/*   923*/    0, /*End of Scope*/
/*   924*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->1067
/*   928*/    OPC_RecordMemRef,
/*   929*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*   930*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   931*/    OPC_Scope, 66, /*->999*/ // 2 children in Scope
/*   933*/     OPC_CheckChild1TypeI32,
/*   934*/     OPC_MoveChild2,
/*   935*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   938*/     OPC_RecordChild0, // #2 = $val
/*   939*/     OPC_MoveParent,
/*   940*/     OPC_Scope, 18, /*->960*/ // 3 children in Scope
/*   942*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*   943*/      OPC_MoveParent,
/*   944*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   945*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   947*/      OPC_EmitMergeInputChains1_0,
/*   948*/      OPC_EmitInteger32, 0,  // 0 #5
/*   950*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   960*/     /*Scope*/ 18, /*->979*/
/*   961*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*   962*/      OPC_MoveParent,
/*   963*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   964*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   966*/      OPC_EmitMergeInputChains1_0,
/*   967*/      OPC_EmitInteger32, 0,  // 0 #5
/*   969*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   979*/     /*Scope*/ 18, /*->998*/
/*   980*/      OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*   981*/      OPC_MoveParent,
/*   982*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   983*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   985*/      OPC_EmitMergeInputChains1_0,
/*   986*/      OPC_EmitInteger32, 0,  // 0 #5
/*   988*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   998*/     0, /*End of Scope*/
/*   999*/    /*Scope*/ 66, /*->1066*/
/*  1000*/     OPC_CheckChild1TypeI64,
/*  1001*/     OPC_MoveChild2,
/*  1002*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1005*/     OPC_RecordChild0, // #2 = $val
/*  1006*/     OPC_MoveParent,
/*  1007*/     OPC_Scope, 18, /*->1027*/ // 3 children in Scope
/*  1009*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  1010*/      OPC_MoveParent,
/*  1011*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1012*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1014*/      OPC_EmitMergeInputChains1_0,
/*  1015*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1017*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1027*/     /*Scope*/ 18, /*->1046*/
/*  1028*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  1029*/      OPC_MoveParent,
/*  1030*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1031*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1033*/      OPC_EmitMergeInputChains1_0,
/*  1034*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1036*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1046*/     /*Scope*/ 18, /*->1065*/
/*  1047*/      OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*  1048*/      OPC_MoveParent,
/*  1049*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1050*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1052*/      OPC_EmitMergeInputChains1_0,
/*  1053*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1055*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1065*/     0, /*End of Scope*/
/*  1066*/    0, /*End of Scope*/
/*  1067*/   /*SwitchOpcode*/ 121, TARGET_VAL(ISD::ATOMIC_LOAD),// ->1191
/*  1070*/    OPC_RecordMemRef,
/*  1071*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  1072*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1073*/    OPC_Scope, 57, /*->1132*/ // 2 children in Scope
/*  1075*/     OPC_CheckChild1TypeI32,
/*  1076*/     OPC_Scope, 17, /*->1095*/ // 3 children in Scope
/*  1078*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  1079*/      OPC_MoveParent,
/*  1080*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1081*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1083*/      OPC_EmitMergeInputChains1_0,
/*  1084*/      OPC_EmitInteger32, 0,  // 0 #4
/*  1086*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1095*/     /*Scope*/ 17, /*->1113*/
/*  1096*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  1097*/      OPC_MoveParent,
/*  1098*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1099*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1101*/      OPC_EmitMergeInputChains1_0,
/*  1102*/      OPC_EmitInteger32, 0,  // 0 #4
/*  1104*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1113*/     /*Scope*/ 17, /*->1131*/
/*  1114*/      OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  1115*/      OPC_MoveParent,
/*  1116*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1117*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1119*/      OPC_EmitMergeInputChains1_0,
/*  1120*/      OPC_EmitInteger32, 0,  // 0 #4
/*  1122*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1131*/     0, /*End of Scope*/
/*  1132*/    /*Scope*/ 57, /*->1190*/
/*  1133*/     OPC_CheckChild1TypeI64,
/*  1134*/     OPC_Scope, 17, /*->1153*/ // 3 children in Scope
/*  1136*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  1137*/      OPC_MoveParent,
/*  1138*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  1139*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1141*/      OPC_EmitMergeInputChains1_0,
/*  1142*/      OPC_EmitInteger32, 0,  // 0 #4
/*  1144*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1153*/     /*Scope*/ 17, /*->1171*/
/*  1154*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  1155*/      OPC_MoveParent,
/*  1156*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  1157*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1159*/      OPC_EmitMergeInputChains1_0,
/*  1160*/      OPC_EmitInteger32, 0,  // 0 #4
/*  1162*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1171*/     /*Scope*/ 17, /*->1189*/
/*  1172*/      OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  1173*/      OPC_MoveParent,
/*  1174*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  1175*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1177*/      OPC_EmitMergeInputChains1_0,
/*  1178*/      OPC_EmitInteger32, 0,  // 0 #4
/*  1180*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_32>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1189*/     0, /*End of Scope*/
/*  1190*/    0, /*End of Scope*/
/*  1191*/   0, // EndSwitchOpcode
/*  1192*/  /*Scope*/ 7, /*->1200*/
/*  1193*/   OPC_RecordChild0, // #0 = $src
/*  1194*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (zext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  1200*/  0, /*End of Scope*/
/*  1201*/ /*SwitchOpcode*/ 86|128,6/*854*/, TARGET_VAL(ISD::ANY_EXTEND),// ->2059
/*  1205*/  OPC_Scope, 74|128,6/*842*/, /*->2050*/ // 2 children in Scope
/*  1208*/   OPC_MoveChild0,
/*  1209*/   OPC_SwitchOpcode /*8 cases */, 124, TARGET_VAL(ISD::AssertZext),// ->1337
/*  1213*/    OPC_MoveChild0,
/*  1214*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*  1217*/    OPC_RecordMemRef,
/*  1218*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  1219*/    OPC_CheckFoldableChainNode,
/*  1220*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1221*/    OPC_Scope, 56, /*->1279*/ // 2 children in Scope
/*  1223*/     OPC_CheckChild1TypeI32,
/*  1224*/     OPC_MoveChild2,
/*  1225*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1228*/     OPC_RecordChild0, // #2 = $exp
/*  1229*/     OPC_MoveSibling3,
/*  1230*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1233*/     OPC_RecordChild0, // #3 = $new
/*  1234*/     OPC_MoveParent,
/*  1235*/     OPC_Scope, 20, /*->1257*/ // 2 children in Scope
/*  1237*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  1238*/      OPC_MoveParent,
/*  1239*/      OPC_MoveParent,
/*  1240*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1241*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  1243*/      OPC_EmitMergeInputChains1_0,
/*  1244*/      OPC_EmitInteger32, 0,  // 0 #6
/*  1246*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1257*/     /*Scope*/ 20, /*->1278*/
/*  1258*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  1259*/      OPC_MoveParent,
/*  1260*/      OPC_MoveParent,
/*  1261*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1262*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  1264*/      OPC_EmitMergeInputChains1_0,
/*  1265*/      OPC_EmitInteger32, 0,  // 0 #6
/*  1267*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1278*/     0, /*End of Scope*/
/*  1279*/    /*Scope*/ 56, /*->1336*/
/*  1280*/     OPC_CheckChild1TypeI64,
/*  1281*/     OPC_MoveChild2,
/*  1282*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1285*/     OPC_RecordChild0, // #2 = $exp
/*  1286*/     OPC_MoveSibling3,
/*  1287*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1290*/     OPC_RecordChild0, // #3 = $new
/*  1291*/     OPC_MoveParent,
/*  1292*/     OPC_Scope, 20, /*->1314*/ // 2 children in Scope
/*  1294*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  1295*/      OPC_MoveParent,
/*  1296*/      OPC_MoveParent,
/*  1297*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1298*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  1300*/      OPC_EmitMergeInputChains1_0,
/*  1301*/      OPC_EmitInteger32, 0,  // 0 #6
/*  1303*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1314*/     /*Scope*/ 20, /*->1335*/
/*  1315*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  1316*/      OPC_MoveParent,
/*  1317*/      OPC_MoveParent,
/*  1318*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1319*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  1321*/      OPC_EmitMergeInputChains1_0,
/*  1322*/      OPC_EmitInteger32, 0,  // 0 #6
/*  1324*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1335*/     0, /*End of Scope*/
/*  1336*/    0, /*End of Scope*/
/*  1337*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->1441
/*  1340*/    OPC_RecordMemRef,
/*  1341*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  1342*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1343*/    OPC_Scope, 47, /*->1392*/ // 2 children in Scope
/*  1345*/     OPC_CheckChild1TypeI32,
/*  1346*/     OPC_MoveChild2,
/*  1347*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1350*/     OPC_RecordChild0, // #2 = $val
/*  1351*/     OPC_MoveParent,
/*  1352*/     OPC_Scope, 18, /*->1372*/ // 2 children in Scope
/*  1354*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  1355*/      OPC_MoveParent,
/*  1356*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1357*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1359*/      OPC_EmitMergeInputChains1_0,
/*  1360*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1362*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1372*/     /*Scope*/ 18, /*->1391*/
/*  1373*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  1374*/      OPC_MoveParent,
/*  1375*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1376*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1378*/      OPC_EmitMergeInputChains1_0,
/*  1379*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1381*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1391*/     0, /*End of Scope*/
/*  1392*/    /*Scope*/ 47, /*->1440*/
/*  1393*/     OPC_CheckChild1TypeI64,
/*  1394*/     OPC_MoveChild2,
/*  1395*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1398*/     OPC_RecordChild0, // #2 = $val
/*  1399*/     OPC_MoveParent,
/*  1400*/     OPC_Scope, 18, /*->1420*/ // 2 children in Scope
/*  1402*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  1403*/      OPC_MoveParent,
/*  1404*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1405*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1407*/      OPC_EmitMergeInputChains1_0,
/*  1408*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1410*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1420*/     /*Scope*/ 18, /*->1439*/
/*  1421*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  1422*/      OPC_MoveParent,
/*  1423*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1424*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1426*/      OPC_EmitMergeInputChains1_0,
/*  1427*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1429*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1439*/     0, /*End of Scope*/
/*  1440*/    0, /*End of Scope*/
/*  1441*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->1545
/*  1444*/    OPC_RecordMemRef,
/*  1445*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  1446*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1447*/    OPC_Scope, 47, /*->1496*/ // 2 children in Scope
/*  1449*/     OPC_CheckChild1TypeI32,
/*  1450*/     OPC_MoveChild2,
/*  1451*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1454*/     OPC_RecordChild0, // #2 = $val
/*  1455*/     OPC_MoveParent,
/*  1456*/     OPC_Scope, 18, /*->1476*/ // 2 children in Scope
/*  1458*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  1459*/      OPC_MoveParent,
/*  1460*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1461*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1463*/      OPC_EmitMergeInputChains1_0,
/*  1464*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1466*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1476*/     /*Scope*/ 18, /*->1495*/
/*  1477*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  1478*/      OPC_MoveParent,
/*  1479*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1480*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1482*/      OPC_EmitMergeInputChains1_0,
/*  1483*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1485*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1495*/     0, /*End of Scope*/
/*  1496*/    /*Scope*/ 47, /*->1544*/
/*  1497*/     OPC_CheckChild1TypeI64,
/*  1498*/     OPC_MoveChild2,
/*  1499*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1502*/     OPC_RecordChild0, // #2 = $val
/*  1503*/     OPC_MoveParent,
/*  1504*/     OPC_Scope, 18, /*->1524*/ // 2 children in Scope
/*  1506*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  1507*/      OPC_MoveParent,
/*  1508*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1509*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1511*/      OPC_EmitMergeInputChains1_0,
/*  1512*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1514*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1524*/     /*Scope*/ 18, /*->1543*/
/*  1525*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  1526*/      OPC_MoveParent,
/*  1527*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1528*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1530*/      OPC_EmitMergeInputChains1_0,
/*  1531*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1533*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1543*/     0, /*End of Scope*/
/*  1544*/    0, /*End of Scope*/
/*  1545*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->1649
/*  1548*/    OPC_RecordMemRef,
/*  1549*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  1550*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1551*/    OPC_Scope, 47, /*->1600*/ // 2 children in Scope
/*  1553*/     OPC_CheckChild1TypeI32,
/*  1554*/     OPC_MoveChild2,
/*  1555*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1558*/     OPC_RecordChild0, // #2 = $val
/*  1559*/     OPC_MoveParent,
/*  1560*/     OPC_Scope, 18, /*->1580*/ // 2 children in Scope
/*  1562*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  1563*/      OPC_MoveParent,
/*  1564*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1565*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1567*/      OPC_EmitMergeInputChains1_0,
/*  1568*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1570*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1580*/     /*Scope*/ 18, /*->1599*/
/*  1581*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  1582*/      OPC_MoveParent,
/*  1583*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1584*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1586*/      OPC_EmitMergeInputChains1_0,
/*  1587*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1589*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1599*/     0, /*End of Scope*/
/*  1600*/    /*Scope*/ 47, /*->1648*/
/*  1601*/     OPC_CheckChild1TypeI64,
/*  1602*/     OPC_MoveChild2,
/*  1603*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1606*/     OPC_RecordChild0, // #2 = $val
/*  1607*/     OPC_MoveParent,
/*  1608*/     OPC_Scope, 18, /*->1628*/ // 2 children in Scope
/*  1610*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  1611*/      OPC_MoveParent,
/*  1612*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1613*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1615*/      OPC_EmitMergeInputChains1_0,
/*  1616*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1618*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1628*/     /*Scope*/ 18, /*->1647*/
/*  1629*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  1630*/      OPC_MoveParent,
/*  1631*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1632*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1634*/      OPC_EmitMergeInputChains1_0,
/*  1635*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1637*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1647*/     0, /*End of Scope*/
/*  1648*/    0, /*End of Scope*/
/*  1649*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->1753
/*  1652*/    OPC_RecordMemRef,
/*  1653*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  1654*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1655*/    OPC_Scope, 47, /*->1704*/ // 2 children in Scope
/*  1657*/     OPC_CheckChild1TypeI32,
/*  1658*/     OPC_MoveChild2,
/*  1659*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1662*/     OPC_RecordChild0, // #2 = $val
/*  1663*/     OPC_MoveParent,
/*  1664*/     OPC_Scope, 18, /*->1684*/ // 2 children in Scope
/*  1666*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  1667*/      OPC_MoveParent,
/*  1668*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1669*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1671*/      OPC_EmitMergeInputChains1_0,
/*  1672*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1674*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1684*/     /*Scope*/ 18, /*->1703*/
/*  1685*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  1686*/      OPC_MoveParent,
/*  1687*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1688*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1690*/      OPC_EmitMergeInputChains1_0,
/*  1691*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1693*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1703*/     0, /*End of Scope*/
/*  1704*/    /*Scope*/ 47, /*->1752*/
/*  1705*/     OPC_CheckChild1TypeI64,
/*  1706*/     OPC_MoveChild2,
/*  1707*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1710*/     OPC_RecordChild0, // #2 = $val
/*  1711*/     OPC_MoveParent,
/*  1712*/     OPC_Scope, 18, /*->1732*/ // 2 children in Scope
/*  1714*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  1715*/      OPC_MoveParent,
/*  1716*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1717*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1719*/      OPC_EmitMergeInputChains1_0,
/*  1720*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1722*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1732*/     /*Scope*/ 18, /*->1751*/
/*  1733*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  1734*/      OPC_MoveParent,
/*  1735*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1736*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1738*/      OPC_EmitMergeInputChains1_0,
/*  1739*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1741*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1751*/     0, /*End of Scope*/
/*  1752*/    0, /*End of Scope*/
/*  1753*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->1857
/*  1756*/    OPC_RecordMemRef,
/*  1757*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  1758*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1759*/    OPC_Scope, 47, /*->1808*/ // 2 children in Scope
/*  1761*/     OPC_CheckChild1TypeI32,
/*  1762*/     OPC_MoveChild2,
/*  1763*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1766*/     OPC_RecordChild0, // #2 = $val
/*  1767*/     OPC_MoveParent,
/*  1768*/     OPC_Scope, 18, /*->1788*/ // 2 children in Scope
/*  1770*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  1771*/      OPC_MoveParent,
/*  1772*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1773*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1775*/      OPC_EmitMergeInputChains1_0,
/*  1776*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1778*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1788*/     /*Scope*/ 18, /*->1807*/
/*  1789*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  1790*/      OPC_MoveParent,
/*  1791*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1792*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1794*/      OPC_EmitMergeInputChains1_0,
/*  1795*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1797*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1807*/     0, /*End of Scope*/
/*  1808*/    /*Scope*/ 47, /*->1856*/
/*  1809*/     OPC_CheckChild1TypeI64,
/*  1810*/     OPC_MoveChild2,
/*  1811*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1814*/     OPC_RecordChild0, // #2 = $val
/*  1815*/     OPC_MoveParent,
/*  1816*/     OPC_Scope, 18, /*->1836*/ // 2 children in Scope
/*  1818*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  1819*/      OPC_MoveParent,
/*  1820*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1821*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1823*/      OPC_EmitMergeInputChains1_0,
/*  1824*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1826*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1836*/     /*Scope*/ 18, /*->1855*/
/*  1837*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  1838*/      OPC_MoveParent,
/*  1839*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1840*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1842*/      OPC_EmitMergeInputChains1_0,
/*  1843*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1845*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1855*/     0, /*End of Scope*/
/*  1856*/    0, /*End of Scope*/
/*  1857*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_SWAP),// ->1961
/*  1860*/    OPC_RecordMemRef,
/*  1861*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  1862*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1863*/    OPC_Scope, 47, /*->1912*/ // 2 children in Scope
/*  1865*/     OPC_CheckChild1TypeI32,
/*  1866*/     OPC_MoveChild2,
/*  1867*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1870*/     OPC_RecordChild0, // #2 = $val
/*  1871*/     OPC_MoveParent,
/*  1872*/     OPC_Scope, 18, /*->1892*/ // 2 children in Scope
/*  1874*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  1875*/      OPC_MoveParent,
/*  1876*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1877*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1879*/      OPC_EmitMergeInputChains1_0,
/*  1880*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1882*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1892*/     /*Scope*/ 18, /*->1911*/
/*  1893*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  1894*/      OPC_MoveParent,
/*  1895*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1896*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1898*/      OPC_EmitMergeInputChains1_0,
/*  1899*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1901*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1911*/     0, /*End of Scope*/
/*  1912*/    /*Scope*/ 47, /*->1960*/
/*  1913*/     OPC_CheckChild1TypeI64,
/*  1914*/     OPC_MoveChild2,
/*  1915*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1918*/     OPC_RecordChild0, // #2 = $val
/*  1919*/     OPC_MoveParent,
/*  1920*/     OPC_Scope, 18, /*->1940*/ // 2 children in Scope
/*  1922*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  1923*/      OPC_MoveParent,
/*  1924*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1925*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1927*/      OPC_EmitMergeInputChains1_0,
/*  1928*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1930*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1940*/     /*Scope*/ 18, /*->1959*/
/*  1941*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  1942*/      OPC_MoveParent,
/*  1943*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1944*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1946*/      OPC_EmitMergeInputChains1_0,
/*  1947*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1949*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1959*/     0, /*End of Scope*/
/*  1960*/    0, /*End of Scope*/
/*  1961*/   /*SwitchOpcode*/ 85, TARGET_VAL(ISD::ATOMIC_LOAD),// ->2049
/*  1964*/    OPC_RecordMemRef,
/*  1965*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  1966*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1967*/    OPC_Scope, 39, /*->2008*/ // 2 children in Scope
/*  1969*/     OPC_CheckChild1TypeI32,
/*  1970*/     OPC_Scope, 17, /*->1989*/ // 2 children in Scope
/*  1972*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  1973*/      OPC_MoveParent,
/*  1974*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1975*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1977*/      OPC_EmitMergeInputChains1_0,
/*  1978*/      OPC_EmitInteger32, 0,  // 0 #4
/*  1980*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1989*/     /*Scope*/ 17, /*->2007*/
/*  1990*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  1991*/      OPC_MoveParent,
/*  1992*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1993*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1995*/      OPC_EmitMergeInputChains1_0,
/*  1996*/      OPC_EmitInteger32, 0,  // 0 #4
/*  1998*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  2007*/     0, /*End of Scope*/
/*  2008*/    /*Scope*/ 39, /*->2048*/
/*  2009*/     OPC_CheckChild1TypeI64,
/*  2010*/     OPC_Scope, 17, /*->2029*/ // 2 children in Scope
/*  2012*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  2013*/      OPC_MoveParent,
/*  2014*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2015*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2017*/      OPC_EmitMergeInputChains1_0,
/*  2018*/      OPC_EmitInteger32, 0,  // 0 #4
/*  2020*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2029*/     /*Scope*/ 17, /*->2047*/
/*  2030*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  2031*/      OPC_MoveParent,
/*  2032*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2033*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2035*/      OPC_EmitMergeInputChains1_0,
/*  2036*/      OPC_EmitInteger32, 0,  // 0 #4
/*  2038*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2047*/     0, /*End of Scope*/
/*  2048*/    0, /*End of Scope*/
/*  2049*/   0, // EndSwitchOpcode
/*  2050*/  /*Scope*/ 7, /*->2058*/
/*  2051*/   OPC_RecordChild0, // #0 = $src
/*  2052*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (anyext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  2058*/  0, /*End of Scope*/
/*  2059*/ /*SwitchOpcode*/ 67|128,7/*963*/, TARGET_VAL(ISD::STORE),// ->3026
/*  2063*/  OPC_RecordMemRef,
/*  2064*/  OPC_RecordNode, // #0 = 'st' chained node
/*  2065*/  OPC_Scope, 127|128,1/*255*/, /*->2323*/ // 2 children in Scope
/*  2068*/   OPC_MoveChild1,
/*  2069*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  2072*/   OPC_RecordChild0, // #1 = $vec
/*  2073*/   OPC_Scope, 64, /*->2139*/ // 4 children in Scope
/*  2075*/    OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/*  2077*/    OPC_RecordChild1, // #2 = $idx
/*  2078*/    OPC_MoveChild1,
/*  2079*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2082*/    OPC_CheckPredicate, 18, // Predicate_LaneIdx16
/*  2084*/    OPC_CheckTypeI32,
/*  2085*/    OPC_MoveParent,
/*  2086*/    OPC_CheckTypeI32,
/*  2087*/    OPC_MoveParent,
/*  2088*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2089*/    OPC_Scope, 23, /*->2114*/ // 2 children in Scope
/*  2091*/     OPC_CheckChild2TypeI32,
/*  2092*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2093*/     OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2095*/     OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2097*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2098*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2100*/     OPC_EmitMergeInputChains1_0,
/*  2101*/     OPC_EmitInteger32, 0,  // 0 #6
/*  2103*/     OPC_EmitConvertToTarget2, // #7
/*  2104*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 21
               // Dst: (STORE_LANE_I8x16_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/*  2114*/    /*Scope*/ 23, /*->2138*/
/*  2115*/     OPC_CheckChild2TypeI64,
/*  2116*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2117*/     OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2119*/     OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2121*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2122*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2124*/     OPC_EmitMergeInputChains1_0,
/*  2125*/     OPC_EmitInteger32, 0,  // 0 #6
/*  2127*/     OPC_EmitConvertToTarget2, // #7
/*  2128*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 21
               // Dst: (STORE_LANE_I8x16_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/*  2138*/    0, /*End of Scope*/
/*  2139*/   /*Scope*/ 64, /*->2204*/
/*  2140*/    OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/*  2142*/    OPC_RecordChild1, // #2 = $idx
/*  2143*/    OPC_MoveChild1,
/*  2144*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2147*/    OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/*  2149*/    OPC_CheckTypeI32,
/*  2150*/    OPC_MoveParent,
/*  2151*/    OPC_CheckTypeI32,
/*  2152*/    OPC_MoveParent,
/*  2153*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2154*/    OPC_Scope, 23, /*->2179*/ // 2 children in Scope
/*  2156*/     OPC_CheckChild2TypeI32,
/*  2157*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2158*/     OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2160*/     OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2162*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2163*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2165*/     OPC_EmitMergeInputChains1_0,
/*  2166*/     OPC_EmitInteger32, 0,  // 0 #6
/*  2168*/     OPC_EmitConvertToTarget2, // #7
/*  2169*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 21
               // Dst: (STORE_LANE_I16x8_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/*  2179*/    /*Scope*/ 23, /*->2203*/
/*  2180*/     OPC_CheckChild2TypeI64,
/*  2181*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2182*/     OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2184*/     OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2186*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2187*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2189*/     OPC_EmitMergeInputChains1_0,
/*  2190*/     OPC_EmitInteger32, 0,  // 0 #6
/*  2192*/     OPC_EmitConvertToTarget2, // #7
/*  2193*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 21
               // Dst: (STORE_LANE_I16x8_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/*  2203*/    0, /*End of Scope*/
/*  2204*/   /*Scope*/ 58, /*->2263*/
/*  2205*/    OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/*  2207*/    OPC_RecordChild1, // #2 = $idx
/*  2208*/    OPC_MoveChild1,
/*  2209*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2212*/    OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/*  2214*/    OPC_CheckTypeI32,
/*  2215*/    OPC_MoveParent,
/*  2216*/    OPC_CheckTypeI32,
/*  2217*/    OPC_MoveParent,
/*  2218*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2219*/    OPC_Scope, 20, /*->2241*/ // 2 children in Scope
/*  2221*/     OPC_CheckChild2TypeI32,
/*  2222*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2223*/     OPC_CheckPredicate5,  // Predicate_store
/*  2224*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2225*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2227*/     OPC_EmitMergeInputChains1_0,
/*  2228*/     OPC_EmitInteger32, 0,  // 0 #6
/*  2230*/     OPC_EmitConvertToTarget2, // #7
/*  2231*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I32x4_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/*  2241*/    /*Scope*/ 20, /*->2262*/
/*  2242*/     OPC_CheckChild2TypeI64,
/*  2243*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2244*/     OPC_CheckPredicate5,  // Predicate_store
/*  2245*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2246*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2248*/     OPC_EmitMergeInputChains1_0,
/*  2249*/     OPC_EmitInteger32, 0,  // 0 #6
/*  2251*/     OPC_EmitConvertToTarget2, // #7
/*  2252*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I32x4_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/*  2262*/    0, /*End of Scope*/
/*  2263*/   /*Scope*/ 58, /*->2322*/
/*  2264*/    OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/*  2266*/    OPC_RecordChild1, // #2 = $idx
/*  2267*/    OPC_MoveChild1,
/*  2268*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2271*/    OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/*  2273*/    OPC_CheckTypeI32,
/*  2274*/    OPC_MoveParent,
/*  2275*/    OPC_CheckTypeI64,
/*  2276*/    OPC_MoveParent,
/*  2277*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2278*/    OPC_Scope, 20, /*->2300*/ // 2 children in Scope
/*  2280*/     OPC_CheckChild2TypeI32,
/*  2281*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2282*/     OPC_CheckPredicate5,  // Predicate_store
/*  2283*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2284*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2286*/     OPC_EmitMergeInputChains1_0,
/*  2287*/     OPC_EmitInteger32, 0,  // 0 #6
/*  2289*/     OPC_EmitConvertToTarget2, // #7
/*  2290*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I64x2_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/*  2300*/    /*Scope*/ 20, /*->2321*/
/*  2301*/     OPC_CheckChild2TypeI64,
/*  2302*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2303*/     OPC_CheckPredicate5,  // Predicate_store
/*  2304*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2305*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2307*/     OPC_EmitMergeInputChains1_0,
/*  2308*/     OPC_EmitInteger32, 0,  // 0 #6
/*  2310*/     OPC_EmitConvertToTarget2, // #7
/*  2311*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I64x2_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/*  2321*/    0, /*End of Scope*/
/*  2322*/   0, /*End of Scope*/
/*  2323*/  /*Scope*/ 60|128,5/*700*/, /*->3025*/
/*  2325*/   OPC_RecordChild1, // #1 = $val
/*  2326*/   OPC_Scope, 2|128,1/*130*/, /*->2459*/ // 11 children in Scope
/*  2329*/    OPC_CheckChild1TypeI32,
/*  2330*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2331*/    OPC_Scope, 62, /*->2395*/ // 2 children in Scope
/*  2333*/     OPC_CheckChild2TypeI32,
/*  2334*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2335*/     OPC_Scope, 16, /*->2353*/ // 2 children in Scope
/*  2337*/      OPC_CheckPredicate5,  // Predicate_store
/*  2338*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2339*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2341*/      OPC_EmitMergeInputChains1_0,
/*  2342*/      OPC_EmitInteger32, 0,  // 0 #5
/*  2344*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2353*/     /*Scope*/ 40, /*->2394*/
/*  2354*/      OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2356*/      OPC_Scope, 17, /*->2375*/ // 2 children in Scope
/*  2358*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2360*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2361*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2363*/       OPC_EmitMergeInputChains1_0,
/*  2364*/       OPC_EmitInteger32, 0,  // 0 #5
/*  2366*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2375*/      /*Scope*/ 17, /*->2393*/
/*  2376*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2378*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2379*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2381*/       OPC_EmitMergeInputChains1_0,
/*  2382*/       OPC_EmitInteger32, 0,  // 0 #5
/*  2384*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2393*/      0, /*End of Scope*/
/*  2394*/     0, /*End of Scope*/
/*  2395*/    /*Scope*/ 62, /*->2458*/
/*  2396*/     OPC_CheckChild2TypeI64,
/*  2397*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2398*/     OPC_Scope, 16, /*->2416*/ // 2 children in Scope
/*  2400*/      OPC_CheckPredicate5,  // Predicate_store
/*  2401*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2402*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2404*/      OPC_EmitMergeInputChains1_0,
/*  2405*/      OPC_EmitInteger32, 0,  // 0 #5
/*  2407*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2416*/     /*Scope*/ 40, /*->2457*/
/*  2417*/      OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2419*/      OPC_Scope, 17, /*->2438*/ // 2 children in Scope
/*  2421*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2423*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2424*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2426*/       OPC_EmitMergeInputChains1_0,
/*  2427*/       OPC_EmitInteger32, 0,  // 0 #5
/*  2429*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2438*/      /*Scope*/ 17, /*->2456*/
/*  2439*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2441*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2442*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2444*/       OPC_EmitMergeInputChains1_0,
/*  2445*/       OPC_EmitInteger32, 0,  // 0 #5
/*  2447*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2456*/      0, /*End of Scope*/
/*  2457*/     0, /*End of Scope*/
/*  2458*/    0, /*End of Scope*/
/*  2459*/   /*Scope*/ 38|128,1/*166*/, /*->2627*/
/*  2461*/    OPC_CheckChild1TypeI64,
/*  2462*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2463*/    OPC_Scope, 80, /*->2545*/ // 2 children in Scope
/*  2465*/     OPC_CheckChild2TypeI32,
/*  2466*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2467*/     OPC_Scope, 16, /*->2485*/ // 2 children in Scope
/*  2469*/      OPC_CheckPredicate5,  // Predicate_store
/*  2470*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2471*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2473*/      OPC_EmitMergeInputChains1_0,
/*  2474*/      OPC_EmitInteger32, 0,  // 0 #5
/*  2476*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2485*/     /*Scope*/ 58, /*->2544*/
/*  2486*/      OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2488*/      OPC_Scope, 17, /*->2507*/ // 3 children in Scope
/*  2490*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2492*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2493*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2495*/       OPC_EmitMergeInputChains1_0,
/*  2496*/       OPC_EmitInteger32, 0,  // 0 #5
/*  2498*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2507*/      /*Scope*/ 17, /*->2525*/
/*  2508*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2510*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2511*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2513*/       OPC_EmitMergeInputChains1_0,
/*  2514*/       OPC_EmitInteger32, 0,  // 0 #5
/*  2516*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2525*/      /*Scope*/ 17, /*->2543*/
/*  2526*/       OPC_CheckPredicate, 25, // Predicate_truncstorei32
/*  2528*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2529*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2531*/       OPC_EmitMergeInputChains1_0,
/*  2532*/       OPC_EmitInteger32, 0,  // 0 #5
/*  2534*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                 // Dst: (STORE32_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2543*/      0, /*End of Scope*/
/*  2544*/     0, /*End of Scope*/
/*  2545*/    /*Scope*/ 80, /*->2626*/
/*  2546*/     OPC_CheckChild2TypeI64,
/*  2547*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2548*/     OPC_Scope, 16, /*->2566*/ // 2 children in Scope
/*  2550*/      OPC_CheckPredicate5,  // Predicate_store
/*  2551*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2552*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2554*/      OPC_EmitMergeInputChains1_0,
/*  2555*/      OPC_EmitInteger32, 0,  // 0 #5
/*  2557*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2566*/     /*Scope*/ 58, /*->2625*/
/*  2567*/      OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2569*/      OPC_Scope, 17, /*->2588*/ // 3 children in Scope
/*  2571*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2573*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2574*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2576*/       OPC_EmitMergeInputChains1_0,
/*  2577*/       OPC_EmitInteger32, 0,  // 0 #5
/*  2579*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2588*/      /*Scope*/ 17, /*->2606*/
/*  2589*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2591*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2592*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2594*/       OPC_EmitMergeInputChains1_0,
/*  2595*/       OPC_EmitInteger32, 0,  // 0 #5
/*  2597*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2606*/      /*Scope*/ 17, /*->2624*/
/*  2607*/       OPC_CheckPredicate, 25, // Predicate_truncstorei32
/*  2609*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2610*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2612*/       OPC_EmitMergeInputChains1_0,
/*  2613*/       OPC_EmitInteger32, 0,  // 0 #5
/*  2615*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                 // Dst: (STORE32_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2624*/      0, /*End of Scope*/
/*  2625*/     0, /*End of Scope*/
/*  2626*/    0, /*End of Scope*/
/*  2627*/   /*Scope*/ 43, /*->2671*/
/*  2628*/    OPC_CheckChild1Type, /*MVT::f32*/12, 
/*  2630*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2631*/    OPC_Scope, 18, /*->2651*/ // 2 children in Scope
/*  2633*/     OPC_CheckChild2TypeI32,
/*  2634*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2635*/     OPC_CheckPredicate5,  // Predicate_store
/*  2636*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2637*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2639*/     OPC_EmitMergeInputChains1_0,
/*  2640*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2642*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f32:{ *:[f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/*  2651*/    /*Scope*/ 18, /*->2670*/
/*  2652*/     OPC_CheckChild2TypeI64,
/*  2653*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2654*/     OPC_CheckPredicate5,  // Predicate_store
/*  2655*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2656*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2658*/     OPC_EmitMergeInputChains1_0,
/*  2659*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2661*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f32:{ *:[f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f32:{ *:[f32] }:$val)
/*  2670*/    0, /*End of Scope*/
/*  2671*/   /*Scope*/ 43, /*->2715*/
/*  2672*/    OPC_CheckChild1Type, /*MVT::f64*/13, 
/*  2674*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2675*/    OPC_Scope, 18, /*->2695*/ // 2 children in Scope
/*  2677*/     OPC_CheckChild2TypeI32,
/*  2678*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2679*/     OPC_CheckPredicate5,  // Predicate_store
/*  2680*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2681*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2683*/     OPC_EmitMergeInputChains1_0,
/*  2684*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2686*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f64:{ *:[f64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f64:{ *:[f64] }:$val)
/*  2695*/    /*Scope*/ 18, /*->2714*/
/*  2696*/     OPC_CheckChild2TypeI64,
/*  2697*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2698*/     OPC_CheckPredicate5,  // Predicate_store
/*  2699*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2700*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2702*/     OPC_EmitMergeInputChains1_0,
/*  2703*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2705*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f64:{ *:[f64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f64:{ *:[f64] }:$val)
/*  2714*/    0, /*End of Scope*/
/*  2715*/   /*Scope*/ 43, /*->2759*/
/*  2716*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  2718*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2719*/    OPC_Scope, 18, /*->2739*/ // 2 children in Scope
/*  2721*/     OPC_CheckChild2TypeI32,
/*  2722*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2723*/     OPC_CheckPredicate5,  // Predicate_store
/*  2724*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2725*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2727*/     OPC_EmitMergeInputChains1_0,
/*  2728*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2730*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v16i8:{ *:[v16i8] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v16i8:{ *:[v16i8] }:$val)
/*  2739*/    /*Scope*/ 18, /*->2758*/
/*  2740*/     OPC_CheckChild2TypeI64,
/*  2741*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2742*/     OPC_CheckPredicate5,  // Predicate_store
/*  2743*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2744*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2746*/     OPC_EmitMergeInputChains1_0,
/*  2747*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2749*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v16i8:{ *:[v16i8] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v16i8:{ *:[v16i8] }:$val)
/*  2758*/    0, /*End of Scope*/
/*  2759*/   /*Scope*/ 43, /*->2803*/
/*  2760*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  2762*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2763*/    OPC_Scope, 18, /*->2783*/ // 2 children in Scope
/*  2765*/     OPC_CheckChild2TypeI32,
/*  2766*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2767*/     OPC_CheckPredicate5,  // Predicate_store
/*  2768*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2769*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2771*/     OPC_EmitMergeInputChains1_0,
/*  2772*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2774*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8i16:{ *:[v8i16] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v8i16:{ *:[v8i16] }:$val)
/*  2783*/    /*Scope*/ 18, /*->2802*/
/*  2784*/     OPC_CheckChild2TypeI64,
/*  2785*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2786*/     OPC_CheckPredicate5,  // Predicate_store
/*  2787*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2788*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2790*/     OPC_EmitMergeInputChains1_0,
/*  2791*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2793*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8i16:{ *:[v8i16] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v8i16:{ *:[v8i16] }:$val)
/*  2802*/    0, /*End of Scope*/
/*  2803*/   /*Scope*/ 43, /*->2847*/
/*  2804*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  2806*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2807*/    OPC_Scope, 18, /*->2827*/ // 2 children in Scope
/*  2809*/     OPC_CheckChild2TypeI32,
/*  2810*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2811*/     OPC_CheckPredicate5,  // Predicate_store
/*  2812*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2813*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2815*/     OPC_EmitMergeInputChains1_0,
/*  2816*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2818*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4i32:{ *:[v4i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v4i32:{ *:[v4i32] }:$val)
/*  2827*/    /*Scope*/ 18, /*->2846*/
/*  2828*/     OPC_CheckChild2TypeI64,
/*  2829*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2830*/     OPC_CheckPredicate5,  // Predicate_store
/*  2831*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2832*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2834*/     OPC_EmitMergeInputChains1_0,
/*  2835*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2837*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4i32:{ *:[v4i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v4i32:{ *:[v4i32] }:$val)
/*  2846*/    0, /*End of Scope*/
/*  2847*/   /*Scope*/ 43, /*->2891*/
/*  2848*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  2850*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2851*/    OPC_Scope, 18, /*->2871*/ // 2 children in Scope
/*  2853*/     OPC_CheckChild2TypeI32,
/*  2854*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2855*/     OPC_CheckPredicate5,  // Predicate_store
/*  2856*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2857*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2859*/     OPC_EmitMergeInputChains1_0,
/*  2860*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2862*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2i64:{ *:[v2i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v2i64:{ *:[v2i64] }:$val)
/*  2871*/    /*Scope*/ 18, /*->2890*/
/*  2872*/     OPC_CheckChild2TypeI64,
/*  2873*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2874*/     OPC_CheckPredicate5,  // Predicate_store
/*  2875*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2876*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2878*/     OPC_EmitMergeInputChains1_0,
/*  2879*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2881*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2i64:{ *:[v2i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v2i64:{ *:[v2i64] }:$val)
/*  2890*/    0, /*End of Scope*/
/*  2891*/   /*Scope*/ 43, /*->2935*/
/*  2892*/    OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/*  2894*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2895*/    OPC_Scope, 18, /*->2915*/ // 2 children in Scope
/*  2897*/     OPC_CheckChild2TypeI32,
/*  2898*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2899*/     OPC_CheckPredicate5,  // Predicate_store
/*  2900*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2901*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2903*/     OPC_EmitMergeInputChains1_0,
/*  2904*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2906*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4f32:{ *:[v4f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v4f32:{ *:[v4f32] }:$val)
/*  2915*/    /*Scope*/ 18, /*->2934*/
/*  2916*/     OPC_CheckChild2TypeI64,
/*  2917*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2918*/     OPC_CheckPredicate5,  // Predicate_store
/*  2919*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2920*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2922*/     OPC_EmitMergeInputChains1_0,
/*  2923*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2925*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4f32:{ *:[v4f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v4f32:{ *:[v4f32] }:$val)
/*  2934*/    0, /*End of Scope*/
/*  2935*/   /*Scope*/ 44, /*->2980*/
/*  2936*/    OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/*  2939*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2940*/    OPC_Scope, 18, /*->2960*/ // 2 children in Scope
/*  2942*/     OPC_CheckChild2TypeI32,
/*  2943*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2944*/     OPC_CheckPredicate5,  // Predicate_store
/*  2945*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2946*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2948*/     OPC_EmitMergeInputChains1_0,
/*  2949*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2951*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2f64:{ *:[v2f64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v2f64:{ *:[v2f64] }:$val)
/*  2960*/    /*Scope*/ 18, /*->2979*/
/*  2961*/     OPC_CheckChild2TypeI64,
/*  2962*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2963*/     OPC_CheckPredicate5,  // Predicate_store
/*  2964*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2965*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2967*/     OPC_EmitMergeInputChains1_0,
/*  2968*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2970*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2f64:{ *:[v2f64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v2f64:{ *:[v2f64] }:$val)
/*  2979*/    0, /*End of Scope*/
/*  2980*/   /*Scope*/ 43, /*->3024*/
/*  2981*/    OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/*  2983*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2984*/    OPC_Scope, 18, /*->3004*/ // 2 children in Scope
/*  2986*/     OPC_CheckChild2TypeI32,
/*  2987*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2988*/     OPC_CheckPredicate5,  // Predicate_store
/*  2989*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2990*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2992*/     OPC_EmitMergeInputChains1_0,
/*  2993*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2995*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8f16:{ *:[v8f16] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v8f16:{ *:[v8f16] }:$val)
/*  3004*/    /*Scope*/ 18, /*->3023*/
/*  3005*/     OPC_CheckChild2TypeI64,
/*  3006*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  3007*/     OPC_CheckPredicate5,  // Predicate_store
/*  3008*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  3009*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3011*/     OPC_EmitMergeInputChains1_0,
/*  3012*/     OPC_EmitInteger32, 0,  // 0 #5
/*  3014*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8f16:{ *:[v8f16] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v8f16:{ *:[v8f16] }:$val)
/*  3023*/    0, /*End of Scope*/
/*  3024*/   0, /*End of Scope*/
/*  3025*/  0, /*End of Scope*/
/*  3026*/ /*SwitchOpcode*/ 7|128,2/*263*/, TARGET_VAL(ISD::INTRINSIC_VOID),// ->3293
/*  3030*/  OPC_Scope, 40, /*->3072*/ // 3 children in Scope
/*  3032*/   OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  3033*/   OPC_CheckChild1Integer, 54|128,78|128,1/*26422*/, 
/*  3037*/   OPC_MoveChild2,
/*  3038*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3041*/   OPC_RecordChild0, // #1 = $table1
/*  3042*/   OPC_MoveChild0,
/*  3043*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3046*/   OPC_MoveParent,
/*  3047*/   OPC_MoveSibling3,
/*  3048*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3051*/   OPC_RecordChild0, // #2 = $table2
/*  3052*/   OPC_MoveChild0,
/*  3053*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3056*/   OPC_MoveParent,
/*  3057*/   OPC_MoveParent,
/*  3058*/   OPC_RecordChild4, // #3 = $d
/*  3059*/   OPC_RecordChild5, // #4 = $s
/*  3060*/   OPC_RecordChild6, // #5 = $n
/*  3061*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3062*/   OPC_EmitMergeInputChains1_0,
/*  3063*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_COPY),
                 5/*#Ops*/, 1, 2, 3, 4, 5, 
             // Src: (intrinsic_void 13211:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table1), (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table2), I32:{ *:[i32] }:$d, I32:{ *:[i32] }:$s, I32:{ *:[i32] }:$n) - Complexity = 20
             // Dst: (TABLE_COPY (tglobaladdr:{ *:[i32] }):$table1, (tglobaladdr:{ *:[i32] }):$table2, I32:{ *:[i32] }:$d, I32:{ *:[i32] }:$s, I32:{ *:[i32] }:$n)
/*  3072*/  /*Scope*/ 44, /*->3117*/
/*  3073*/   OPC_RecordMemRef,
/*  3074*/   OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  3075*/   OPC_CheckChild1Integer, 50|128,78|128,1/*26418*/, 
/*  3079*/   OPC_RecordChild2, // #1 = $val
/*  3080*/   OPC_RecordChild3, // #2 = $AddrOps32:offset:addr
/*  3081*/   OPC_Scope, 16, /*->3099*/ // 2 children in Scope
/*  3083*/    OPC_CheckChild3TypeI32,
/*  3084*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  3085*/    OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3087*/    OPC_EmitMergeInputChains1_0,
/*  3088*/    OPC_EmitInteger32, 0,  // 0 #5
/*  3090*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F16_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  4/*#Ops*/, 5, 3, 4, 1, 
              // Src: (intrinsic_void 13209:{ *:[iPTR] }, f32:{ *:[f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)) - Complexity = 17
              // Dst: (STORE_F16_F32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/*  3099*/   /*Scope*/ 16, /*->3116*/
/*  3100*/    OPC_CheckChild3TypeI64,
/*  3101*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  3102*/    OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3104*/    OPC_EmitMergeInputChains1_0,
/*  3105*/    OPC_EmitInteger32, 0,  // 0 #5
/*  3107*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F16_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  4/*#Ops*/, 5, 3, 4, 1, 
              // Src: (intrinsic_void 13209:{ *:[iPTR] }, f32:{ *:[f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)) - Complexity = 17
              // Dst: (STORE_F16_F32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f32:{ *:[f32] }:$val)
/*  3116*/   0, /*End of Scope*/
/*  3117*/  /*Scope*/ 45|128,1/*173*/, /*->3292*/
/*  3119*/   OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  3120*/   OPC_Scope, 26, /*->3148*/ // 6 children in Scope
/*  3122*/    OPC_CheckChild1Integer, 78|128,78|128,1/*26446*/, 
/*  3126*/    OPC_MoveChild2,
/*  3127*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3130*/    OPC_RecordChild0, // #1 = $table
/*  3131*/    OPC_MoveChild0,
/*  3132*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3135*/    OPC_MoveParent,
/*  3136*/    OPC_MoveParent,
/*  3137*/    OPC_RecordChild3, // #2 = $i
/*  3138*/    OPC_RecordChild4, // #3 = $val
/*  3139*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3140*/    OPC_EmitMergeInputChains1_0,
/*  3141*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF),
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_void 13223:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val) - Complexity = 14
              // Dst: (TABLE_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val)
/*  3148*/   /*Scope*/ 28, /*->3177*/
/*  3149*/    OPC_CheckChild1Integer, 60|128,78|128,1/*26428*/, 
/*  3153*/    OPC_MoveChild2,
/*  3154*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3157*/    OPC_RecordChild0, // #1 = $table
/*  3158*/    OPC_MoveChild0,
/*  3159*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3162*/    OPC_MoveParent,
/*  3163*/    OPC_MoveParent,
/*  3164*/    OPC_RecordChild3, // #2 = $i
/*  3165*/    OPC_RecordChild4, // #3 = $val
/*  3166*/    OPC_RecordChild5, // #4 = $n
/*  3167*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3168*/    OPC_EmitMergeInputChains1_0,
/*  3169*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_FUNCREF),
                  4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 13214:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_FILL_FUNCREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n)
/*  3177*/   /*Scope*/ 26, /*->3204*/
/*  3178*/    OPC_CheckChild1Integer, 76|128,78|128,1/*26444*/, 
/*  3182*/    OPC_MoveChild2,
/*  3183*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3186*/    OPC_RecordChild0, // #1 = $table
/*  3187*/    OPC_MoveChild0,
/*  3188*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3191*/    OPC_MoveParent,
/*  3192*/    OPC_MoveParent,
/*  3193*/    OPC_RecordChild3, // #2 = $i
/*  3194*/    OPC_RecordChild4, // #3 = $val
/*  3195*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3196*/    OPC_EmitMergeInputChains1_0,
/*  3197*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF),
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_void 13222:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val) - Complexity = 14
              // Dst: (TABLE_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val)
/*  3204*/   /*Scope*/ 28, /*->3233*/
/*  3205*/    OPC_CheckChild1Integer, 58|128,78|128,1/*26426*/, 
/*  3209*/    OPC_MoveChild2,
/*  3210*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3213*/    OPC_RecordChild0, // #1 = $table
/*  3214*/    OPC_MoveChild0,
/*  3215*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3218*/    OPC_MoveParent,
/*  3219*/    OPC_MoveParent,
/*  3220*/    OPC_RecordChild3, // #2 = $i
/*  3221*/    OPC_RecordChild4, // #3 = $val
/*  3222*/    OPC_RecordChild5, // #4 = $n
/*  3223*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3224*/    OPC_EmitMergeInputChains1_0,
/*  3225*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_EXTERNREF),
                  4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 13213:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_FILL_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n)
/*  3233*/   /*Scope*/ 27, /*->3261*/
/*  3234*/    OPC_CheckChild1Integer, 74|128,78|128,1/*26442*/, 
/*  3238*/    OPC_MoveChild2,
/*  3239*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3242*/    OPC_RecordChild0, // #1 = $table
/*  3243*/    OPC_MoveChild0,
/*  3244*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3247*/    OPC_MoveParent,
/*  3248*/    OPC_MoveParent,
/*  3249*/    OPC_RecordChild3, // #2 = $i
/*  3250*/    OPC_RecordChild4, // #3 = $val
/*  3251*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3253*/    OPC_EmitMergeInputChains1_0,
/*  3254*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_EXNREF),
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_void 13221:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val) - Complexity = 14
              // Dst: (TABLE_SET_EXNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val)
/*  3261*/   /*Scope*/ 29, /*->3291*/
/*  3262*/    OPC_CheckChild1Integer, 56|128,78|128,1/*26424*/, 
/*  3266*/    OPC_MoveChild2,
/*  3267*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3270*/    OPC_RecordChild0, // #1 = $table
/*  3271*/    OPC_MoveChild0,
/*  3272*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3275*/    OPC_MoveParent,
/*  3276*/    OPC_MoveParent,
/*  3277*/    OPC_RecordChild3, // #2 = $i
/*  3278*/    OPC_RecordChild4, // #3 = $val
/*  3279*/    OPC_RecordChild5, // #4 = $n
/*  3280*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3282*/    OPC_EmitMergeInputChains1_0,
/*  3283*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_EXNREF),
                  4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 13212:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_FILL_EXNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n)
/*  3291*/   0, /*End of Scope*/
/*  3292*/  0, /*End of Scope*/
/*  3293*/ /*SwitchOpcode*/ 81|128,3/*465*/, TARGET_VAL(ISD::INTRINSIC_W_CHAIN),// ->3762
/*  3297*/  OPC_Scope, 22|128,1/*150*/, /*->3450*/ // 3 children in Scope
/*  3300*/   OPC_RecordMemRef,
/*  3301*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3302*/   OPC_Scope, 45, /*->3349*/ // 3 children in Scope
/*  3304*/    OPC_CheckChild1Integer, 110|128,77|128,1/*26350*/, 
/*  3308*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3309*/    OPC_Scope, 18, /*->3329*/ // 2 children in Scope
/*  3311*/     OPC_CheckChild2TypeI32,
/*  3312*/     OPC_RecordChild3, // #2 = $count
/*  3313*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3314*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  3316*/     OPC_EmitMergeInputChains1_0,
/*  3317*/     OPC_EmitInteger32, 0,  // 0 #5
/*  3319*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 13175:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_NOTIFY_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$count)
/*  3329*/    /*Scope*/ 18, /*->3348*/
/*  3330*/     OPC_CheckChild2TypeI64,
/*  3331*/     OPC_RecordChild3, // #2 = $count
/*  3332*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3333*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  3335*/     OPC_EmitMergeInputChains1_0,
/*  3336*/     OPC_EmitInteger32, 0,  // 0 #5
/*  3338*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 13175:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_NOTIFY_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$count)
/*  3348*/    0, /*End of Scope*/
/*  3349*/   /*Scope*/ 49, /*->3399*/
/*  3350*/    OPC_CheckChild1Integer, 112|128,77|128,1/*26352*/, 
/*  3354*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3355*/    OPC_Scope, 20, /*->3377*/ // 2 children in Scope
/*  3357*/     OPC_CheckChild2TypeI32,
/*  3358*/     OPC_RecordChild3, // #2 = $exp
/*  3359*/     OPC_RecordChild4, // #3 = $timeout
/*  3360*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3361*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  3363*/     OPC_EmitMergeInputChains1_0,
/*  3364*/     OPC_EmitInteger32, 0,  // 0 #6
/*  3366*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 13176:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3377*/    /*Scope*/ 20, /*->3398*/
/*  3378*/     OPC_CheckChild2TypeI64,
/*  3379*/     OPC_RecordChild3, // #2 = $exp
/*  3380*/     OPC_RecordChild4, // #3 = $timeout
/*  3381*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3382*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  3384*/     OPC_EmitMergeInputChains1_0,
/*  3385*/     OPC_EmitInteger32, 0,  // 0 #6
/*  3387*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 13176:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3398*/    0, /*End of Scope*/
/*  3399*/   /*Scope*/ 49, /*->3449*/
/*  3400*/    OPC_CheckChild1Integer, 114|128,77|128,1/*26354*/, 
/*  3404*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3405*/    OPC_Scope, 20, /*->3427*/ // 2 children in Scope
/*  3407*/     OPC_CheckChild2TypeI32,
/*  3408*/     OPC_RecordChild3, // #2 = $exp
/*  3409*/     OPC_RecordChild4, // #3 = $timeout
/*  3410*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3411*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  3413*/     OPC_EmitMergeInputChains1_0,
/*  3414*/     OPC_EmitInteger32, 0,  // 0 #6
/*  3416*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 13177:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT64_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3427*/    /*Scope*/ 20, /*->3448*/
/*  3428*/     OPC_CheckChild2TypeI64,
/*  3429*/     OPC_RecordChild3, // #2 = $exp
/*  3430*/     OPC_RecordChild4, // #3 = $timeout
/*  3431*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3432*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  3434*/     OPC_EmitMergeInputChains1_0,
/*  3435*/     OPC_EmitInteger32, 0,  // 0 #6
/*  3437*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 13177:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT64_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3448*/    0, /*End of Scope*/
/*  3449*/   0, /*End of Scope*/
/*  3450*/  /*Scope*/ 9|128,2/*265*/, /*->3717*/
/*  3452*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3453*/   OPC_Scope, 26, /*->3481*/ // 9 children in Scope
/*  3455*/    OPC_CheckChild1Integer, 66|128,78|128,1/*26434*/, 
/*  3459*/    OPC_MoveChild2,
/*  3460*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3463*/    OPC_RecordChild0, // #1 = $table
/*  3464*/    OPC_MoveChild0,
/*  3465*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3468*/    OPC_MoveParent,
/*  3469*/    OPC_MoveParent,
/*  3470*/    OPC_RecordChild3, // #2 = $i
/*  3471*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3472*/    OPC_EmitMergeInputChains1_0,
/*  3473*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF),
                  /*MVT::funcref*/99|128,1/*227*/, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[funcref] } 13217:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3481*/   /*Scope*/ 27, /*->3509*/
/*  3482*/    OPC_CheckChild1Integer, 72|128,78|128,1/*26440*/, 
/*  3486*/    OPC_MoveChild2,
/*  3487*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3490*/    OPC_RecordChild0, // #1 = $table
/*  3491*/    OPC_MoveChild0,
/*  3492*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3495*/    OPC_MoveParent,
/*  3496*/    OPC_MoveParent,
/*  3497*/    OPC_RecordChild3, // #2 = $val
/*  3498*/    OPC_RecordChild4, // #3 = $n
/*  3499*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3500*/    OPC_EmitMergeInputChains1_0,
/*  3501*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_FUNCREF),
                  /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 13220:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_FUNCREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n)
/*  3509*/   /*Scope*/ 26, /*->3536*/
/*  3510*/    OPC_CheckChild1Integer, 64|128,78|128,1/*26432*/, 
/*  3514*/    OPC_MoveChild2,
/*  3515*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3518*/    OPC_RecordChild0, // #1 = $table
/*  3519*/    OPC_MoveChild0,
/*  3520*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3523*/    OPC_MoveParent,
/*  3524*/    OPC_MoveParent,
/*  3525*/    OPC_RecordChild3, // #2 = $i
/*  3526*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3527*/    OPC_EmitMergeInputChains1_0,
/*  3528*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF),
                  /*MVT::externref*/100|128,1/*228*/, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[externref] } 13216:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3536*/   /*Scope*/ 27, /*->3564*/
/*  3537*/    OPC_CheckChild1Integer, 70|128,78|128,1/*26438*/, 
/*  3541*/    OPC_MoveChild2,
/*  3542*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3545*/    OPC_RecordChild0, // #1 = $table
/*  3546*/    OPC_MoveChild0,
/*  3547*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3550*/    OPC_MoveParent,
/*  3551*/    OPC_MoveParent,
/*  3552*/    OPC_RecordChild3, // #2 = $val
/*  3553*/    OPC_RecordChild4, // #3 = $n
/*  3554*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3555*/    OPC_EmitMergeInputChains1_0,
/*  3556*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_EXTERNREF),
                  /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 13219:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_EXTERNREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n)
/*  3564*/   /*Scope*/ 27, /*->3592*/
/*  3565*/    OPC_CheckChild1Integer, 62|128,78|128,1/*26430*/, 
/*  3569*/    OPC_MoveChild2,
/*  3570*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3573*/    OPC_RecordChild0, // #1 = $table
/*  3574*/    OPC_MoveChild0,
/*  3575*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3578*/    OPC_MoveParent,
/*  3579*/    OPC_MoveParent,
/*  3580*/    OPC_RecordChild3, // #2 = $i
/*  3581*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3583*/    OPC_EmitMergeInputChains1_0,
/*  3584*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_EXNREF),
                  /*MVT::exnref*/101|128,1/*229*/, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[exnref] } 13215:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_EXNREF:{ *:[exnref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3592*/   /*Scope*/ 28, /*->3621*/
/*  3593*/    OPC_CheckChild1Integer, 68|128,78|128,1/*26436*/, 
/*  3597*/    OPC_MoveChild2,
/*  3598*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3601*/    OPC_RecordChild0, // #1 = $table
/*  3602*/    OPC_MoveChild0,
/*  3603*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3606*/    OPC_MoveParent,
/*  3607*/    OPC_MoveParent,
/*  3608*/    OPC_RecordChild3, // #2 = $val
/*  3609*/    OPC_RecordChild4, // #3 = $n
/*  3610*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3612*/    OPC_EmitMergeInputChains1_0,
/*  3613*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_EXNREF),
                  /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 13218:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_EXNREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n)
/*  3621*/   /*Scope*/ 23, /*->3645*/
/*  3622*/    OPC_CheckChild1Integer, 80|128,78|128,1/*26448*/, 
/*  3626*/    OPC_MoveChild2,
/*  3627*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3630*/    OPC_RecordChild0, // #1 = $table
/*  3631*/    OPC_MoveChild0,
/*  3632*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3635*/    OPC_MoveParent,
/*  3636*/    OPC_MoveParent,
/*  3637*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3638*/    OPC_EmitMergeInputChains1_0,
/*  3639*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_SIZE),
                  /*MVT::i32*/7, 1/*#Ops*/, 1, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 13224:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table)) - Complexity = 14
              // Dst: (TABLE_SIZE:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table)
/*  3645*/   /*Scope*/ 32, /*->3678*/
/*  3646*/    OPC_CheckChild1Integer, 118|128,77|128,1/*26358*/, 
/*  3650*/    OPC_RecordChild2, // #1 = $flags
/*  3651*/    OPC_MoveChild2,
/*  3652*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3655*/    OPC_MoveParent,
/*  3656*/    OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->3667
/*  3659*/     OPC_EmitMergeInputChains1_0,
/*  3660*/     OPC_EmitConvertToTarget1, // #2
/*  3661*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8849MEMORY_SIZE_A32),
                   /*MVT::i32*/7, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 13179:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_8849MEMORY_SIZE_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags)
/*  3667*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->3677
/*  3669*/     OPC_EmitMergeInputChains1_0,
/*  3670*/     OPC_EmitConvertToTarget1, // #2
/*  3671*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8850MEMORY_SIZE_A64),
                   /*MVT::i64*/8, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 13179:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_8850MEMORY_SIZE_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags)
/*  3677*/    0, // EndSwitchType
/*  3678*/   /*Scope*/ 37, /*->3716*/
/*  3679*/    OPC_CheckChild1Integer, 116|128,77|128,1/*26356*/, 
/*  3683*/    OPC_RecordChild2, // #1 = $flags
/*  3684*/    OPC_MoveChild2,
/*  3685*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3688*/    OPC_MoveParent,
/*  3689*/    OPC_RecordChild3, // #2 = $delta
/*  3690*/    OPC_SwitchType /*2 cases */, 10, /*MVT::i32*/7, // ->3703
/*  3693*/     OPC_CheckChild3TypeI32,
/*  3694*/     OPC_EmitMergeInputChains1_0,
/*  3695*/     OPC_EmitConvertToTarget1, // #3
/*  3696*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8849MEMORY_GROW_A32),
                   /*MVT::i32*/7, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 13178:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta) - Complexity = 11
               // Dst: (anonymous_8849MEMORY_GROW_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta)
/*  3703*/    /*SwitchType*/ 10, /*MVT::i64*/8, // ->3715
/*  3705*/     OPC_CheckChild3TypeI64,
/*  3706*/     OPC_EmitMergeInputChains1_0,
/*  3707*/     OPC_EmitConvertToTarget1, // #3
/*  3708*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8850MEMORY_GROW_A64),
                   /*MVT::i64*/8, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 13178:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta) - Complexity = 11
               // Dst: (anonymous_8850MEMORY_GROW_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta)
/*  3715*/    0, // EndSwitchType
/*  3716*/   0, /*End of Scope*/
/*  3717*/  /*Scope*/ 43, /*->3761*/
/*  3718*/   OPC_RecordMemRef,
/*  3719*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3720*/   OPC_CheckChild1Integer, 106|128,77|128,1/*26346*/, 
/*  3724*/   OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3725*/   OPC_Scope, 16, /*->3743*/ // 2 children in Scope
/*  3727*/    OPC_CheckChild2TypeI32,
/*  3728*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  3729*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  3731*/    OPC_EmitMergeInputChains1_0,
/*  3732*/    OPC_EmitInteger32, 0,  // 0 #4
/*  3734*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F16_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::f32*/12, 3/*#Ops*/, 4, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[f32] } 13173:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)) - Complexity = 17
              // Dst: (LOAD_F16_F32_A32:{ *:[f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  3743*/   /*Scope*/ 16, /*->3760*/
/*  3744*/    OPC_CheckChild2TypeI64,
/*  3745*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  3746*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  3748*/    OPC_EmitMergeInputChains1_0,
/*  3749*/    OPC_EmitInteger32, 0,  // 0 #4
/*  3751*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F16_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::f32*/12, 3/*#Ops*/, 4, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[f32] } 13173:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)) - Complexity = 17
              // Dst: (LOAD_F16_F32_A64:{ *:[f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  3760*/   0, /*End of Scope*/
/*  3761*/  0, /*End of Scope*/
/*  3762*/ /*SwitchOpcode*/ 29|128,2/*285*/, TARGET_VAL(ISD::ATOMIC_STORE),// ->4051
/*  3766*/  OPC_RecordMemRef,
/*  3767*/  OPC_RecordNode, // #0 = 'atomic_store' chained node
/*  3768*/  OPC_Scope, 119, /*->3889*/ // 2 children in Scope
/*  3770*/   OPC_MoveChild1,
/*  3771*/   OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3774*/   OPC_RecordChild0, // #1 = $val
/*  3775*/   OPC_MoveParent,
/*  3776*/   OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3777*/   OPC_Scope, 54, /*->3833*/ // 2 children in Scope
/*  3779*/    OPC_CheckChild2TypeI32,
/*  3780*/    OPC_Scope, 16, /*->3798*/ // 3 children in Scope
/*  3782*/     OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3783*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3784*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3786*/     OPC_EmitMergeInputChains1_0,
/*  3787*/     OPC_EmitInteger32, 0,  // 0 #5
/*  3789*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 16
               // Dst: (ATOMIC_STORE8_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3798*/    /*Scope*/ 16, /*->3815*/
/*  3799*/     OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3800*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3801*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3803*/     OPC_EmitMergeInputChains1_0,
/*  3804*/     OPC_EmitInteger32, 0,  // 0 #5
/*  3806*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 16
               // Dst: (ATOMIC_STORE16_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3815*/    /*Scope*/ 16, /*->3832*/
/*  3816*/     OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3817*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3818*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3820*/     OPC_EmitMergeInputChains1_0,
/*  3821*/     OPC_EmitInteger32, 0,  // 0 #5
/*  3823*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 16
               // Dst: (ATOMIC_STORE32_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3832*/    0, /*End of Scope*/
/*  3833*/   /*Scope*/ 54, /*->3888*/
/*  3834*/    OPC_CheckChild2TypeI64,
/*  3835*/    OPC_Scope, 16, /*->3853*/ // 3 children in Scope
/*  3837*/     OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3838*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3839*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3841*/     OPC_EmitMergeInputChains1_0,
/*  3842*/     OPC_EmitInteger32, 0,  // 0 #5
/*  3844*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 16
               // Dst: (ATOMIC_STORE8_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3853*/    /*Scope*/ 16, /*->3870*/
/*  3854*/     OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3855*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3856*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3858*/     OPC_EmitMergeInputChains1_0,
/*  3859*/     OPC_EmitInteger32, 0,  // 0 #5
/*  3861*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 16
               // Dst: (ATOMIC_STORE16_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3870*/    /*Scope*/ 16, /*->3887*/
/*  3871*/     OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3872*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3873*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3875*/     OPC_EmitMergeInputChains1_0,
/*  3876*/     OPC_EmitInteger32, 0,  // 0 #5
/*  3878*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 16
               // Dst: (ATOMIC_STORE32_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3887*/    0, /*End of Scope*/
/*  3888*/   0, /*End of Scope*/
/*  3889*/  /*Scope*/ 31|128,1/*159*/, /*->4050*/
/*  3891*/   OPC_RecordChild1, // #1 = $val
/*  3892*/   OPC_Scope, 114, /*->4008*/ // 2 children in Scope
/*  3894*/    OPC_CheckChild1TypeI32,
/*  3895*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3896*/    OPC_Scope, 54, /*->3952*/ // 2 children in Scope
/*  3898*/     OPC_CheckChild2TypeI32,
/*  3899*/     OPC_Scope, 16, /*->3917*/ // 3 children in Scope
/*  3901*/      OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3902*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3903*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3905*/      OPC_EmitMergeInputChains1_0,
/*  3906*/      OPC_EmitInteger32, 0,  // 0 #5
/*  3908*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 13
                // Dst: (ATOMIC_STORE_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  3917*/     /*Scope*/ 16, /*->3934*/
/*  3918*/      OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3919*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3920*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3922*/      OPC_EmitMergeInputChains1_0,
/*  3923*/      OPC_EmitInteger32, 0,  // 0 #5
/*  3925*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 13
                // Dst: (ATOMIC_STORE8_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  3934*/     /*Scope*/ 16, /*->3951*/
/*  3935*/      OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3936*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3937*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3939*/      OPC_EmitMergeInputChains1_0,
/*  3940*/      OPC_EmitInteger32, 0,  // 0 #5
/*  3942*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 13
                // Dst: (ATOMIC_STORE16_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  3951*/     0, /*End of Scope*/
/*  3952*/    /*Scope*/ 54, /*->4007*/
/*  3953*/     OPC_CheckChild2TypeI64,
/*  3954*/     OPC_Scope, 16, /*->3972*/ // 3 children in Scope
/*  3956*/      OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3957*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3958*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3960*/      OPC_EmitMergeInputChains1_0,
/*  3961*/      OPC_EmitInteger32, 0,  // 0 #5
/*  3963*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 13
                // Dst: (ATOMIC_STORE_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  3972*/     /*Scope*/ 16, /*->3989*/
/*  3973*/      OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3974*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3975*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3977*/      OPC_EmitMergeInputChains1_0,
/*  3978*/      OPC_EmitInteger32, 0,  // 0 #5
/*  3980*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 13
                // Dst: (ATOMIC_STORE8_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  3989*/     /*Scope*/ 16, /*->4006*/
/*  3990*/      OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3991*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3992*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3994*/      OPC_EmitMergeInputChains1_0,
/*  3995*/      OPC_EmitInteger32, 0,  // 0 #5
/*  3997*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 13
                // Dst: (ATOMIC_STORE16_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  4006*/     0, /*End of Scope*/
/*  4007*/    0, /*End of Scope*/
/*  4008*/   /*Scope*/ 40, /*->4049*/
/*  4009*/    OPC_CheckChild1TypeI64,
/*  4010*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  4011*/    OPC_Scope, 17, /*->4030*/ // 2 children in Scope
/*  4013*/     OPC_CheckChild2TypeI32,
/*  4014*/     OPC_CheckPredicate7,  // Predicate_atomic_store_64
/*  4015*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4016*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  4018*/     OPC_EmitMergeInputChains1_0,
/*  4019*/     OPC_EmitInteger32, 0,  // 0 #5
/*  4021*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_64>> - Complexity = 13
               // Dst: (ATOMIC_STORE_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  4030*/    /*Scope*/ 17, /*->4048*/
/*  4031*/     OPC_CheckChild2TypeI64,
/*  4032*/     OPC_CheckPredicate7,  // Predicate_atomic_store_64
/*  4033*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4034*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  4036*/     OPC_EmitMergeInputChains1_0,
/*  4037*/     OPC_EmitInteger32, 0,  // 0 #5
/*  4039*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_64>> - Complexity = 13
               // Dst: (ATOMIC_STORE_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  4048*/    0, /*End of Scope*/
/*  4049*/   0, /*End of Scope*/
/*  4050*/  0, /*End of Scope*/
/*  4051*/ /*SwitchOpcode*/ 90|128,2/*346*/, TARGET_VAL(ISD::AND),// ->4401
/*  4055*/  OPC_Scope, 118, /*->4175*/ // 6 children in Scope
/*  4057*/   OPC_MoveChild0,
/*  4058*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/*  4061*/   OPC_Scope, 55, /*->4118*/ // 2 children in Scope
/*  4063*/    OPC_CheckChild0Integer, 82|128,77|128,1/*26322*/, 
/*  4067*/    OPC_RecordChild1, // #0 = $x
/*  4068*/    OPC_Scope, 11, /*->4081*/ // 4 children in Scope
/*  4070*/     OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  4072*/     OPC_MoveParent,
/*  4073*/     OPC_CheckChild1Integer, 2, 
/*  4075*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13161:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4081*/    /*Scope*/ 11, /*->4093*/
/*  4082*/     OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  4084*/     OPC_MoveParent,
/*  4085*/     OPC_CheckChild1Integer, 2, 
/*  4087*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13161:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4093*/    /*Scope*/ 11, /*->4105*/
/*  4094*/     OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  4096*/     OPC_MoveParent,
/*  4097*/     OPC_CheckChild1Integer, 2, 
/*  4099*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13161:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4105*/    /*Scope*/ 11, /*->4117*/
/*  4106*/     OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  4108*/     OPC_MoveParent,
/*  4109*/     OPC_CheckChild1Integer, 2, 
/*  4111*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13161:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4117*/    0, /*End of Scope*/
/*  4118*/   /*Scope*/ 55, /*->4174*/
/*  4119*/    OPC_CheckChild0Integer, 80|128,77|128,1/*26320*/, 
/*  4123*/    OPC_RecordChild1, // #0 = $x
/*  4124*/    OPC_Scope, 11, /*->4137*/ // 4 children in Scope
/*  4126*/     OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  4128*/     OPC_MoveParent,
/*  4129*/     OPC_CheckChild1Integer, 2, 
/*  4131*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13160:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4137*/    /*Scope*/ 11, /*->4149*/
/*  4138*/     OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  4140*/     OPC_MoveParent,
/*  4141*/     OPC_CheckChild1Integer, 2, 
/*  4143*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13160:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4149*/    /*Scope*/ 11, /*->4161*/
/*  4150*/     OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  4152*/     OPC_MoveParent,
/*  4153*/     OPC_CheckChild1Integer, 2, 
/*  4155*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13160:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4161*/    /*Scope*/ 11, /*->4173*/
/*  4162*/     OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  4164*/     OPC_MoveParent,
/*  4165*/     OPC_CheckChild1Integer, 2, 
/*  4167*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13160:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4173*/    0, /*End of Scope*/
/*  4174*/   0, /*End of Scope*/
/*  4175*/  /*Scope*/ 29, /*->4205*/
/*  4176*/   OPC_CheckAndImm, 127|128,1/*255*/, 
/*  4179*/   OPC_MoveChild0,
/*  4180*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  4183*/   OPC_RecordChild0, // #0 = $vec
/*  4184*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/*  4186*/   OPC_RecordChild1, // #1 = $idx
/*  4187*/   OPC_MoveChild1,
/*  4188*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4191*/   OPC_CheckPredicate, 18, // Predicate_LaneIdx16
/*  4193*/   OPC_CheckTypeI32,
/*  4194*/   OPC_MoveParent,
/*  4195*/   OPC_MoveParent,
/*  4196*/   OPC_CheckTypeI32,
/*  4197*/   OPC_EmitConvertToTarget1, // #2
/*  4198*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), 255:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/*  4205*/  /*Scope*/ 30, /*->4236*/
/*  4206*/   OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  4210*/   OPC_MoveChild0,
/*  4211*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  4214*/   OPC_RecordChild0, // #0 = $vec
/*  4215*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/*  4217*/   OPC_RecordChild1, // #1 = $idx
/*  4218*/   OPC_MoveChild1,
/*  4219*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4222*/   OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/*  4224*/   OPC_CheckTypeI32,
/*  4225*/   OPC_MoveParent,
/*  4226*/   OPC_MoveParent,
/*  4227*/   OPC_CheckTypeI32,
/*  4228*/   OPC_EmitConvertToTarget1, // #2
/*  4229*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), 65535:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/*  4236*/  /*Scope*/ 73, /*->4310*/
/*  4237*/   OPC_RecordChild0, // #0 = $lhs
/*  4238*/   OPC_Scope, 21, /*->4261*/ // 2 children in Scope
/*  4240*/    OPC_RecordChild1, // #1 = $rhs
/*  4241*/    OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->4251
/*  4244*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND_I32),
                   /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
               // Dst: (AND_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4251*/    /*SwitchType*/ 7, /*MVT::i64*/8, // ->4260
/*  4253*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND_I64),
                   /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
               // Dst: (AND_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4260*/    0, // EndSwitchType
/*  4261*/   /*Scope*/ 47, /*->4309*/
/*  4262*/    OPC_MoveChild1,
/*  4263*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*  4266*/    OPC_RecordChild0, // #1 = $rhs
/*  4267*/    OPC_MoveChild1,
/*  4268*/    OPC_CheckImmAllOnesV,
/*  4269*/    OPC_MoveParent,
/*  4270*/    OPC_MoveParent,
/*  4271*/    OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->4281
/*  4274*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4281*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->4290
/*  4283*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4290*/    /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->4299
/*  4292*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4299*/    /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->4308
/*  4301*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4308*/    0, // EndSwitchType
/*  4309*/   0, /*End of Scope*/
/*  4310*/  /*Scope*/ 48, /*->4359*/
/*  4311*/   OPC_MoveChild0,
/*  4312*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*  4315*/   OPC_RecordChild0, // #0 = $rhs
/*  4316*/   OPC_MoveChild1,
/*  4317*/   OPC_CheckImmAllOnesV,
/*  4318*/   OPC_MoveParent,
/*  4319*/   OPC_MoveParent,
/*  4320*/   OPC_RecordChild1, // #1 = $lhs
/*  4321*/   OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->4331
/*  4324*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4331*/   /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->4340
/*  4333*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4340*/   /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->4349
/*  4342*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4349*/   /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->4358
/*  4351*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4358*/   0, // EndSwitchType
/*  4359*/  /*Scope*/ 40, /*->4400*/
/*  4360*/   OPC_RecordChild0, // #0 = $lhs
/*  4361*/   OPC_RecordChild1, // #1 = $rhs
/*  4362*/   OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->4372
/*  4365*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4372*/   /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->4381
/*  4374*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4381*/   /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->4390
/*  4383*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4390*/   /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->4399
/*  4392*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4399*/   0, // EndSwitchType
/*  4400*/  0, /*End of Scope*/
/*  4401*/ /*SwitchOpcode*/ 125|128,11/*1533*/, TARGET_VAL(ISD::SETCC),// ->5938
/*  4405*/  OPC_Scope, 126|128,1/*254*/, /*->4662*/ // 2 children in Scope
/*  4408*/   OPC_MoveChild0,
/*  4409*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/*  4412*/   OPC_Scope, 123, /*->4537*/ // 2 children in Scope
/*  4414*/    OPC_CheckChild0Integer, 82|128,77|128,1/*26322*/, 
/*  4418*/    OPC_RecordChild1, // #0 = $x
/*  4419*/    OPC_Scope, 28, /*->4449*/ // 4 children in Scope
/*  4421*/     OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  4423*/     OPC_MoveParent,
/*  4424*/     OPC_CheckTypeI32,
/*  4425*/     OPC_Scope, 10, /*->4437*/ // 2 children in Scope
/*  4427*/      OPC_CheckChild1Integer, 0, 
/*  4429*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4431*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13161:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4437*/     /*Scope*/ 10, /*->4448*/
/*  4438*/      OPC_CheckChild1Integer, 2, 
/*  4440*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4442*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13161:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4448*/     0, /*End of Scope*/
/*  4449*/    /*Scope*/ 28, /*->4478*/
/*  4450*/     OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  4452*/     OPC_MoveParent,
/*  4453*/     OPC_CheckTypeI32,
/*  4454*/     OPC_Scope, 10, /*->4466*/ // 2 children in Scope
/*  4456*/      OPC_CheckChild1Integer, 0, 
/*  4458*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4460*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13161:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4466*/     /*Scope*/ 10, /*->4477*/
/*  4467*/      OPC_CheckChild1Integer, 2, 
/*  4469*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4471*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13161:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4477*/     0, /*End of Scope*/
/*  4478*/    /*Scope*/ 28, /*->4507*/
/*  4479*/     OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  4481*/     OPC_MoveParent,
/*  4482*/     OPC_CheckTypeI32,
/*  4483*/     OPC_Scope, 10, /*->4495*/ // 2 children in Scope
/*  4485*/      OPC_CheckChild1Integer, 0, 
/*  4487*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4489*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13161:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4495*/     /*Scope*/ 10, /*->4506*/
/*  4496*/      OPC_CheckChild1Integer, 2, 
/*  4498*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4500*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13161:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4506*/     0, /*End of Scope*/
/*  4507*/    /*Scope*/ 28, /*->4536*/
/*  4508*/     OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  4510*/     OPC_MoveParent,
/*  4511*/     OPC_CheckTypeI32,
/*  4512*/     OPC_Scope, 10, /*->4524*/ // 2 children in Scope
/*  4514*/      OPC_CheckChild1Integer, 0, 
/*  4516*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4518*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13161:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4524*/     /*Scope*/ 10, /*->4535*/
/*  4525*/      OPC_CheckChild1Integer, 2, 
/*  4527*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4529*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13161:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4535*/     0, /*End of Scope*/
/*  4536*/    0, /*End of Scope*/
/*  4537*/   /*Scope*/ 123, /*->4661*/
/*  4538*/    OPC_CheckChild0Integer, 80|128,77|128,1/*26320*/, 
/*  4542*/    OPC_RecordChild1, // #0 = $x
/*  4543*/    OPC_Scope, 28, /*->4573*/ // 4 children in Scope
/*  4545*/     OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  4547*/     OPC_MoveParent,
/*  4548*/     OPC_CheckTypeI32,
/*  4549*/     OPC_Scope, 10, /*->4561*/ // 2 children in Scope
/*  4551*/      OPC_CheckChild1Integer, 0, 
/*  4553*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4555*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13160:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4561*/     /*Scope*/ 10, /*->4572*/
/*  4562*/      OPC_CheckChild1Integer, 2, 
/*  4564*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4566*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13160:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4572*/     0, /*End of Scope*/
/*  4573*/    /*Scope*/ 28, /*->4602*/
/*  4574*/     OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  4576*/     OPC_MoveParent,
/*  4577*/     OPC_CheckTypeI32,
/*  4578*/     OPC_Scope, 10, /*->4590*/ // 2 children in Scope
/*  4580*/      OPC_CheckChild1Integer, 0, 
/*  4582*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4584*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13160:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4590*/     /*Scope*/ 10, /*->4601*/
/*  4591*/      OPC_CheckChild1Integer, 2, 
/*  4593*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4595*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13160:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4601*/     0, /*End of Scope*/
/*  4602*/    /*Scope*/ 28, /*->4631*/
/*  4603*/     OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  4605*/     OPC_MoveParent,
/*  4606*/     OPC_CheckTypeI32,
/*  4607*/     OPC_Scope, 10, /*->4619*/ // 2 children in Scope
/*  4609*/      OPC_CheckChild1Integer, 0, 
/*  4611*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4613*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13160:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4619*/     /*Scope*/ 10, /*->4630*/
/*  4620*/      OPC_CheckChild1Integer, 2, 
/*  4622*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4624*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13160:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4630*/     0, /*End of Scope*/
/*  4631*/    /*Scope*/ 28, /*->4660*/
/*  4632*/     OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  4634*/     OPC_MoveParent,
/*  4635*/     OPC_CheckTypeI32,
/*  4636*/     OPC_Scope, 10, /*->4648*/ // 2 children in Scope
/*  4638*/      OPC_CheckChild1Integer, 0, 
/*  4640*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4642*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13160:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4648*/     /*Scope*/ 10, /*->4659*/
/*  4649*/      OPC_CheckChild1Integer, 2, 
/*  4651*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4653*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13160:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4659*/     0, /*End of Scope*/
/*  4660*/    0, /*End of Scope*/
/*  4661*/   0, /*End of Scope*/
/*  4662*/  /*Scope*/ 121|128,9/*1273*/, /*->5937*/
/*  4664*/   OPC_RecordChild0, // #0 = $src
/*  4665*/   OPC_SwitchType /*5 cases */, 108|128,3/*492*/, /*MVT::i32*/7, // ->5161
/*  4669*/    OPC_Scope, 118, /*->4789*/ // 4 children in Scope
/*  4671*/     OPC_CheckChild0TypeI32,
/*  4672*/     OPC_Scope, 10, /*->4684*/ // 2 children in Scope
/*  4674*/      OPC_CheckChild1Integer, 0, 
/*  4676*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4678*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQZ_I32),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$src, 0:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/*  4684*/     /*Scope*/ 103, /*->4788*/
/*  4685*/      OPC_RecordChild1, // #1 = $rhs
/*  4686*/      OPC_Scope, 9, /*->4697*/ // 10 children in Scope
/*  4688*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4690*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4697*/      /*Scope*/ 9, /*->4707*/
/*  4698*/       OPC_CheckChild2CondCode, ISD::SETNE,
/*  4700*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4707*/      /*Scope*/ 9, /*->4717*/
/*  4708*/       OPC_CheckChild2CondCode, ISD::SETLT,
/*  4710*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4717*/      /*Scope*/ 9, /*->4727*/
/*  4718*/       OPC_CheckChild2CondCode, ISD::SETULT,
/*  4720*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4727*/      /*Scope*/ 9, /*->4737*/
/*  4728*/       OPC_CheckChild2CondCode, ISD::SETGT,
/*  4730*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4737*/      /*Scope*/ 9, /*->4747*/
/*  4738*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/*  4740*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4747*/      /*Scope*/ 9, /*->4757*/
/*  4748*/       OPC_CheckChild2CondCode, ISD::SETLE,
/*  4750*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4757*/      /*Scope*/ 9, /*->4767*/
/*  4758*/       OPC_CheckChild2CondCode, ISD::SETULE,
/*  4760*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4767*/      /*Scope*/ 9, /*->4777*/
/*  4768*/       OPC_CheckChild2CondCode, ISD::SETGE,
/*  4770*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4777*/      /*Scope*/ 9, /*->4787*/
/*  4778*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/*  4780*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4787*/      0, /*End of Scope*/
/*  4788*/     0, /*End of Scope*/
/*  4789*/    /*Scope*/ 118, /*->4908*/
/*  4790*/     OPC_CheckChild0TypeI64,
/*  4791*/     OPC_Scope, 10, /*->4803*/ // 2 children in Scope
/*  4793*/      OPC_CheckChild1Integer, 0, 
/*  4795*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4797*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQZ_I64),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$src, 0:{ *:[i64] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/*  4803*/     /*Scope*/ 103, /*->4907*/
/*  4804*/      OPC_RecordChild1, // #1 = $rhs
/*  4805*/      OPC_Scope, 9, /*->4816*/ // 10 children in Scope
/*  4807*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4809*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4816*/      /*Scope*/ 9, /*->4826*/
/*  4817*/       OPC_CheckChild2CondCode, ISD::SETNE,
/*  4819*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4826*/      /*Scope*/ 9, /*->4836*/
/*  4827*/       OPC_CheckChild2CondCode, ISD::SETLT,
/*  4829*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4836*/      /*Scope*/ 9, /*->4846*/
/*  4837*/       OPC_CheckChild2CondCode, ISD::SETULT,
/*  4839*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4846*/      /*Scope*/ 9, /*->4856*/
/*  4847*/       OPC_CheckChild2CondCode, ISD::SETGT,
/*  4849*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4856*/      /*Scope*/ 9, /*->4866*/
/*  4857*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/*  4859*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4866*/      /*Scope*/ 9, /*->4876*/
/*  4867*/       OPC_CheckChild2CondCode, ISD::SETLE,
/*  4869*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4876*/      /*Scope*/ 9, /*->4886*/
/*  4877*/       OPC_CheckChild2CondCode, ISD::SETULE,
/*  4879*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4886*/      /*Scope*/ 9, /*->4896*/
/*  4887*/       OPC_CheckChild2CondCode, ISD::SETGE,
/*  4889*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4896*/      /*Scope*/ 9, /*->4906*/
/*  4897*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/*  4899*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4906*/      0, /*End of Scope*/
/*  4907*/     0, /*End of Scope*/
/*  4908*/    /*Scope*/ 125, /*->5034*/
/*  4909*/     OPC_CheckChild0Type, /*MVT::f32*/12, 
/*  4911*/     OPC_RecordChild1, // #1 = $rhs
/*  4912*/     OPC_Scope, 9, /*->4923*/ // 12 children in Scope
/*  4914*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  4916*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4923*/     /*Scope*/ 9, /*->4933*/
/*  4924*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  4926*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4933*/     /*Scope*/ 9, /*->4943*/
/*  4934*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  4936*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4943*/     /*Scope*/ 9, /*->4953*/
/*  4944*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  4946*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4953*/     /*Scope*/ 9, /*->4963*/
/*  4954*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  4956*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4963*/     /*Scope*/ 9, /*->4973*/
/*  4964*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  4966*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4973*/     /*Scope*/ 9, /*->4983*/
/*  4974*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4976*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4983*/     /*Scope*/ 9, /*->4993*/
/*  4984*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4986*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4993*/     /*Scope*/ 9, /*->5003*/
/*  4994*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  4996*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5003*/     /*Scope*/ 9, /*->5013*/
/*  5004*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5006*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5013*/     /*Scope*/ 9, /*->5023*/
/*  5014*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5016*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5023*/     /*Scope*/ 9, /*->5033*/
/*  5024*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5026*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5033*/     0, /*End of Scope*/
/*  5034*/    /*Scope*/ 125, /*->5160*/
/*  5035*/     OPC_CheckChild0Type, /*MVT::f64*/13, 
/*  5037*/     OPC_RecordChild1, // #1 = $rhs
/*  5038*/     OPC_Scope, 9, /*->5049*/ // 12 children in Scope
/*  5040*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5042*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5049*/     /*Scope*/ 9, /*->5059*/
/*  5050*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5052*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5059*/     /*Scope*/ 9, /*->5069*/
/*  5060*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5062*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5069*/     /*Scope*/ 9, /*->5079*/
/*  5070*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5072*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5079*/     /*Scope*/ 9, /*->5089*/
/*  5080*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5082*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5089*/     /*Scope*/ 9, /*->5099*/
/*  5090*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5092*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5099*/     /*Scope*/ 9, /*->5109*/
/*  5100*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5102*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5109*/     /*Scope*/ 9, /*->5119*/
/*  5110*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5112*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5119*/     /*Scope*/ 9, /*->5129*/
/*  5120*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5122*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5129*/     /*Scope*/ 9, /*->5139*/
/*  5130*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5132*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5139*/     /*Scope*/ 9, /*->5149*/
/*  5140*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5142*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5149*/     /*Scope*/ 9, /*->5159*/
/*  5150*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5152*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5159*/     0, /*End of Scope*/
/*  5160*/    0, /*End of Scope*/
/*  5161*/   /*SwitchType*/ 115, /*MVT::v16i8*/39, // ->5278
/*  5163*/    OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/*  5165*/    OPC_RecordChild1, // #1 = $rhs
/*  5166*/    OPC_Scope, 10, /*->5178*/ // 10 children in Scope
/*  5168*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5170*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5171*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
               // Dst: (EQ_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5178*/    /*Scope*/ 10, /*->5189*/
/*  5179*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  5181*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5182*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
               // Dst: (NE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5189*/    /*Scope*/ 10, /*->5200*/
/*  5190*/     OPC_CheckChild2CondCode, ISD::SETLT,
/*  5192*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5193*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5200*/    /*Scope*/ 10, /*->5211*/
/*  5201*/     OPC_CheckChild2CondCode, ISD::SETULT,
/*  5203*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5204*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5211*/    /*Scope*/ 10, /*->5222*/
/*  5212*/     OPC_CheckChild2CondCode, ISD::SETGT,
/*  5214*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5215*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5222*/    /*Scope*/ 10, /*->5233*/
/*  5223*/     OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5225*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5226*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5233*/    /*Scope*/ 10, /*->5244*/
/*  5234*/     OPC_CheckChild2CondCode, ISD::SETLE,
/*  5236*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5237*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5244*/    /*Scope*/ 10, /*->5255*/
/*  5245*/     OPC_CheckChild2CondCode, ISD::SETULE,
/*  5247*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5248*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5255*/    /*Scope*/ 10, /*->5266*/
/*  5256*/     OPC_CheckChild2CondCode, ISD::SETGE,
/*  5258*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5259*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5266*/    /*Scope*/ 10, /*->5277*/
/*  5267*/     OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5269*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5270*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5277*/    0, /*End of Scope*/
/*  5278*/   /*SwitchType*/ 62|128,1/*190*/, /*MVT::v8i16*/50, // ->5471
/*  5281*/    OPC_Scope, 115, /*->5398*/ // 2 children in Scope
/*  5283*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/*  5285*/     OPC_RecordChild1, // #1 = $rhs
/*  5286*/     OPC_Scope, 10, /*->5298*/ // 10 children in Scope
/*  5288*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5290*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5291*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5298*/     /*Scope*/ 10, /*->5309*/
/*  5299*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5301*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5302*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5309*/     /*Scope*/ 10, /*->5320*/
/*  5310*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5312*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5313*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5320*/     /*Scope*/ 10, /*->5331*/
/*  5321*/      OPC_CheckChild2CondCode, ISD::SETULT,
/*  5323*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5324*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5331*/     /*Scope*/ 10, /*->5342*/
/*  5332*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5334*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5335*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5342*/     /*Scope*/ 10, /*->5353*/
/*  5343*/      OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5345*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5346*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5353*/     /*Scope*/ 10, /*->5364*/
/*  5354*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5356*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5357*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5364*/     /*Scope*/ 10, /*->5375*/
/*  5365*/      OPC_CheckChild2CondCode, ISD::SETULE,
/*  5367*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5368*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5375*/     /*Scope*/ 10, /*->5386*/
/*  5376*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5378*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5379*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5386*/     /*Scope*/ 10, /*->5397*/
/*  5387*/      OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5389*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5390*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5397*/     0, /*End of Scope*/
/*  5398*/    /*Scope*/ 71, /*->5470*/
/*  5399*/     OPC_CheckChild0Type, /*MVT::v8f16*/92, 
/*  5401*/     OPC_RecordChild1, // #1 = $rhs
/*  5402*/     OPC_Scope, 10, /*->5414*/ // 6 children in Scope
/*  5404*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5406*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5407*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5414*/     /*Scope*/ 10, /*->5425*/
/*  5415*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5417*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5418*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5425*/     /*Scope*/ 10, /*->5436*/
/*  5426*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5428*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5429*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5436*/     /*Scope*/ 10, /*->5447*/
/*  5437*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5439*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5440*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5447*/     /*Scope*/ 10, /*->5458*/
/*  5448*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5450*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5451*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5458*/     /*Scope*/ 10, /*->5469*/
/*  5459*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5461*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5462*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5469*/     0, /*End of Scope*/
/*  5470*/    0, /*End of Scope*/
/*  5471*/   /*SwitchType*/ 123|128,1/*251*/, /*MVT::v4i32*/60, // ->5725
/*  5474*/    OPC_Scope, 115, /*->5591*/ // 2 children in Scope
/*  5476*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/*  5478*/     OPC_RecordChild1, // #1 = $rhs
/*  5479*/     OPC_Scope, 10, /*->5491*/ // 10 children in Scope
/*  5481*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5483*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5484*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5491*/     /*Scope*/ 10, /*->5502*/
/*  5492*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5494*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5495*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5502*/     /*Scope*/ 10, /*->5513*/
/*  5503*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5505*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5506*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5513*/     /*Scope*/ 10, /*->5524*/
/*  5514*/      OPC_CheckChild2CondCode, ISD::SETULT,
/*  5516*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5517*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5524*/     /*Scope*/ 10, /*->5535*/
/*  5525*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5527*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5528*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5535*/     /*Scope*/ 10, /*->5546*/
/*  5536*/      OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5538*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5539*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5546*/     /*Scope*/ 10, /*->5557*/
/*  5547*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5549*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5550*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5557*/     /*Scope*/ 10, /*->5568*/
/*  5558*/      OPC_CheckChild2CondCode, ISD::SETULE,
/*  5560*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5561*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5568*/     /*Scope*/ 10, /*->5579*/
/*  5569*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5571*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5572*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5579*/     /*Scope*/ 10, /*->5590*/
/*  5580*/      OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5582*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5583*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5590*/     0, /*End of Scope*/
/*  5591*/    /*Scope*/ 3|128,1/*131*/, /*->5724*/
/*  5593*/     OPC_CheckChild0Type, /*MVT::v4f32*/111, 
/*  5595*/     OPC_RecordChild1, // #1 = $rhs
/*  5596*/     OPC_Scope, 10, /*->5608*/ // 12 children in Scope
/*  5598*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5600*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5601*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5608*/     /*Scope*/ 10, /*->5619*/
/*  5609*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5611*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5612*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5619*/     /*Scope*/ 10, /*->5630*/
/*  5620*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5622*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5623*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5630*/     /*Scope*/ 10, /*->5641*/
/*  5631*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5633*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5634*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5641*/     /*Scope*/ 10, /*->5652*/
/*  5642*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5644*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5645*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5652*/     /*Scope*/ 10, /*->5663*/
/*  5653*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5655*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5656*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5663*/     /*Scope*/ 9, /*->5673*/
/*  5664*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5666*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5673*/     /*Scope*/ 9, /*->5683*/
/*  5674*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5676*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5683*/     /*Scope*/ 9, /*->5693*/
/*  5684*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5686*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5693*/     /*Scope*/ 9, /*->5703*/
/*  5694*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5696*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5703*/     /*Scope*/ 9, /*->5713*/
/*  5704*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5706*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5713*/     /*Scope*/ 9, /*->5723*/
/*  5714*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5716*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5723*/     0, /*End of Scope*/
/*  5724*/    0, /*End of Scope*/
/*  5725*/   /*SwitchType*/ 80|128,1/*208*/, /*MVT::v2i64*/78, // ->5936
/*  5728*/    OPC_Scope, 71, /*->5801*/ // 2 children in Scope
/*  5730*/     OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/*  5732*/     OPC_RecordChild1, // #1 = $rhs
/*  5733*/     OPC_Scope, 10, /*->5745*/ // 6 children in Scope
/*  5735*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5737*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5738*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5745*/     /*Scope*/ 10, /*->5756*/
/*  5746*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5748*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5749*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5756*/     /*Scope*/ 10, /*->5767*/
/*  5757*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5759*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5760*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5767*/     /*Scope*/ 10, /*->5778*/
/*  5768*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5770*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5771*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5778*/     /*Scope*/ 10, /*->5789*/
/*  5779*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5781*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5782*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5789*/     /*Scope*/ 10, /*->5800*/
/*  5790*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5792*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5793*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5800*/     0, /*End of Scope*/
/*  5801*/    /*Scope*/ 4|128,1/*132*/, /*->5935*/
/*  5803*/     OPC_CheckChild0Type, /*MVT::v2f64*/1|128,1/*129*/, 
/*  5806*/     OPC_RecordChild1, // #1 = $rhs
/*  5807*/     OPC_Scope, 10, /*->5819*/ // 12 children in Scope
/*  5809*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5811*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5812*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5819*/     /*Scope*/ 10, /*->5830*/
/*  5820*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5822*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5823*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5830*/     /*Scope*/ 10, /*->5841*/
/*  5831*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5833*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5834*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5841*/     /*Scope*/ 10, /*->5852*/
/*  5842*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5844*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5845*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5852*/     /*Scope*/ 10, /*->5863*/
/*  5853*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5855*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5856*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5863*/     /*Scope*/ 10, /*->5874*/
/*  5864*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5866*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5867*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5874*/     /*Scope*/ 9, /*->5884*/
/*  5875*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5877*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5884*/     /*Scope*/ 9, /*->5894*/
/*  5885*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5887*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5894*/     /*Scope*/ 9, /*->5904*/
/*  5895*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5897*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5904*/     /*Scope*/ 9, /*->5914*/
/*  5905*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5907*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5914*/     /*Scope*/ 9, /*->5924*/
/*  5915*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5917*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5924*/     /*Scope*/ 9, /*->5934*/
/*  5925*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5927*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5934*/     0, /*End of Scope*/
/*  5935*/    0, /*End of Scope*/
/*  5936*/   0, // EndSwitchType
/*  5937*/  0, /*End of Scope*/
/*  5938*/ /*SwitchOpcode*/ 59|128,11/*1467*/, TARGET_VAL(ISD::LOAD),// ->7409
/*  5942*/  OPC_RecordMemRef,
/*  5943*/  OPC_RecordNode, // #0 = 'ld' chained node
/*  5944*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  5945*/  OPC_Scope, 89|128,5/*729*/, /*->6677*/ // 2 children in Scope
/*  5948*/   OPC_CheckChild1TypeI32,
/*  5949*/   OPC_CheckPredicate, 8, // Predicate_unindexedload
/*  5951*/   OPC_Scope, 37, /*->5990*/ // 16 children in Scope
/*  5953*/    OPC_CheckPredicate6,  // Predicate_load
/*  5954*/    OPC_SwitchType /*2 cases */, 15, /*MVT::i32*/7, // ->5972
/*  5957*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  5958*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5960*/     OPC_EmitMergeInputChains1_0,
/*  5961*/     OPC_EmitInteger32, 0,  // 0 #4
/*  5963*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5972*/    /*SwitchType*/ 15, /*MVT::i64*/8, // ->5989
/*  5974*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  5975*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5977*/     OPC_EmitMergeInputChains1_0,
/*  5978*/     OPC_EmitInteger32, 0,  // 0 #4
/*  5980*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5989*/    0, // EndSwitchType
/*  5990*/   /*Scope*/ 97, /*->6088*/
/*  5991*/    OPC_CheckPredicate, 15, // Predicate_sextload
/*  5993*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6032
/*  5996*/     OPC_Scope, 16, /*->6014*/ // 2 children in Scope
/*  5998*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  5999*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6000*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6002*/      OPC_EmitMergeInputChains1_0,
/*  6003*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6005*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6014*/     /*Scope*/ 16, /*->6031*/
/*  6015*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6016*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6017*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6019*/      OPC_EmitMergeInputChains1_0,
/*  6020*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6022*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6031*/     0, /*End of Scope*/
/*  6032*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6087
/*  6034*/     OPC_Scope, 16, /*->6052*/ // 3 children in Scope
/*  6036*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6037*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6038*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6040*/      OPC_EmitMergeInputChains1_0,
/*  6041*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6043*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6052*/     /*Scope*/ 16, /*->6069*/
/*  6053*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6054*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6055*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6057*/      OPC_EmitMergeInputChains1_0,
/*  6058*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6060*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6069*/     /*Scope*/ 16, /*->6086*/
/*  6070*/      OPC_CheckPredicate3,  // Predicate_sextloadi32
/*  6071*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6072*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6074*/      OPC_EmitMergeInputChains1_0,
/*  6075*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6077*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LOAD32_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6086*/     0, /*End of Scope*/
/*  6087*/    0, // EndSwitchType
/*  6088*/   /*Scope*/ 97, /*->6186*/
/*  6089*/    OPC_CheckPredicate, 16, // Predicate_zextload
/*  6091*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6130
/*  6094*/     OPC_Scope, 16, /*->6112*/ // 2 children in Scope
/*  6096*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6097*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6098*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6100*/      OPC_EmitMergeInputChains1_0,
/*  6101*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6103*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6112*/     /*Scope*/ 16, /*->6129*/
/*  6113*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6114*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6115*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6117*/      OPC_EmitMergeInputChains1_0,
/*  6118*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6120*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6129*/     0, /*End of Scope*/
/*  6130*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6185
/*  6132*/     OPC_Scope, 16, /*->6150*/ // 3 children in Scope
/*  6134*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6135*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6136*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6138*/      OPC_EmitMergeInputChains1_0,
/*  6139*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6141*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6150*/     /*Scope*/ 16, /*->6167*/
/*  6151*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6152*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6153*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6155*/      OPC_EmitMergeInputChains1_0,
/*  6156*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6158*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6167*/     /*Scope*/ 16, /*->6184*/
/*  6168*/      OPC_CheckPredicate3,  // Predicate_zextloadi32
/*  6169*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6170*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6172*/      OPC_EmitMergeInputChains1_0,
/*  6173*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6175*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6184*/     0, /*End of Scope*/
/*  6185*/    0, // EndSwitchType
/*  6186*/   /*Scope*/ 97, /*->6284*/
/*  6187*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6189*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6228
/*  6192*/     OPC_Scope, 16, /*->6210*/ // 2 children in Scope
/*  6194*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6195*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6196*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6198*/      OPC_EmitMergeInputChains1_0,
/*  6199*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6201*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6210*/     /*Scope*/ 16, /*->6227*/
/*  6211*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6212*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6213*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6215*/      OPC_EmitMergeInputChains1_0,
/*  6216*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6218*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6227*/     0, /*End of Scope*/
/*  6228*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6283
/*  6230*/     OPC_Scope, 16, /*->6248*/ // 3 children in Scope
/*  6232*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6233*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6234*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6236*/      OPC_EmitMergeInputChains1_0,
/*  6237*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6239*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6248*/     /*Scope*/ 16, /*->6265*/
/*  6249*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6250*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6251*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6253*/      OPC_EmitMergeInputChains1_0,
/*  6254*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6256*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6265*/     /*Scope*/ 16, /*->6282*/
/*  6266*/      OPC_CheckPredicate3,  // Predicate_extloadi32
/*  6267*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6268*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6270*/      OPC_EmitMergeInputChains1_0,
/*  6271*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6273*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6282*/     0, /*End of Scope*/
/*  6283*/    0, // EndSwitchType
/*  6284*/   /*Scope*/ 105, /*->6390*/
/*  6285*/    OPC_CheckPredicate6,  // Predicate_load
/*  6286*/    OPC_SwitchType /*6 cases */, 15, /*MVT::f32*/12, // ->6304
/*  6289*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6290*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6292*/     OPC_EmitMergeInputChains1_0,
/*  6293*/     OPC_EmitInteger32, 0,  // 0 #4
/*  6295*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::f32*/12, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F32_A32:{ *:[f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6304*/    /*SwitchType*/ 15, /*MVT::f64*/13, // ->6321
/*  6306*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6307*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6309*/     OPC_EmitMergeInputChains1_0,
/*  6310*/     OPC_EmitInteger32, 0,  // 0 #4
/*  6312*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::f64*/13, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F64_A32:{ *:[f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6321*/    /*SwitchType*/ 15, /*MVT::v16i8*/39, // ->6338
/*  6323*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6324*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6326*/     OPC_EmitMergeInputChains1_0,
/*  6327*/     OPC_EmitInteger32, 0,  // 0 #4
/*  6329*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v16i8*/39, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v16i8] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v16i8] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6338*/    /*SwitchType*/ 15, /*MVT::v8i16*/50, // ->6355
/*  6340*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6341*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6343*/     OPC_EmitMergeInputChains1_0,
/*  6344*/     OPC_EmitInteger32, 0,  // 0 #4
/*  6346*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6355*/    /*SwitchType*/ 15, /*MVT::v4i32*/60, // ->6372
/*  6357*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6358*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6360*/     OPC_EmitMergeInputChains1_0,
/*  6361*/     OPC_EmitInteger32, 0,  // 0 #4
/*  6363*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6372*/    /*SwitchType*/ 15, /*MVT::v2i64*/78, // ->6389
/*  6374*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6375*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6377*/     OPC_EmitMergeInputChains1_0,
/*  6378*/     OPC_EmitInteger32, 0,  // 0 #4
/*  6380*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6389*/    0, // EndSwitchType
/*  6390*/   /*Scope*/ 21, /*->6412*/
/*  6391*/    OPC_CheckPredicate, 15, // Predicate_sextload
/*  6393*/    OPC_CheckPredicate, 21, // Predicate_sextloadvi8
/*  6395*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  6397*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6398*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6400*/    OPC_EmitMergeInputChains1_0,
/*  6401*/    OPC_EmitInteger32, 0,  // 0 #4
/*  6403*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6412*/   /*Scope*/ 21, /*->6434*/
/*  6413*/    OPC_CheckPredicate, 16, // Predicate_zextload
/*  6415*/    OPC_CheckPredicate, 21, // Predicate_zextloadvi8
/*  6417*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  6419*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6420*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6422*/    OPC_EmitMergeInputChains1_0,
/*  6423*/    OPC_EmitInteger32, 0,  // 0 #4
/*  6425*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6434*/   /*Scope*/ 21, /*->6456*/
/*  6435*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6437*/    OPC_CheckPredicate, 21, // Predicate_extloadvi8
/*  6439*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  6441*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6442*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6444*/    OPC_EmitMergeInputChains1_0,
/*  6445*/    OPC_EmitInteger32, 0,  // 0 #4
/*  6447*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6456*/   /*Scope*/ 21, /*->6478*/
/*  6457*/    OPC_CheckPredicate, 15, // Predicate_sextload
/*  6459*/    OPC_CheckPredicate, 22, // Predicate_sextloadvi16
/*  6461*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  6463*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6464*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6466*/    OPC_EmitMergeInputChains1_0,
/*  6467*/    OPC_EmitInteger32, 0,  // 0 #4
/*  6469*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6478*/   /*Scope*/ 21, /*->6500*/
/*  6479*/    OPC_CheckPredicate, 16, // Predicate_zextload
/*  6481*/    OPC_CheckPredicate, 22, // Predicate_zextloadvi16
/*  6483*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  6485*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6486*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6488*/    OPC_EmitMergeInputChains1_0,
/*  6489*/    OPC_EmitInteger32, 0,  // 0 #4
/*  6491*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6500*/   /*Scope*/ 21, /*->6522*/
/*  6501*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6503*/    OPC_CheckPredicate, 22, // Predicate_extloadvi16
/*  6505*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  6507*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6508*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6510*/    OPC_EmitMergeInputChains1_0,
/*  6511*/    OPC_EmitInteger32, 0,  // 0 #4
/*  6513*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6522*/   /*Scope*/ 21, /*->6544*/
/*  6523*/    OPC_CheckPredicate, 15, // Predicate_sextload
/*  6525*/    OPC_CheckPredicate, 23, // Predicate_sextloadvi32
/*  6527*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  6529*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6530*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6532*/    OPC_EmitMergeInputChains1_0,
/*  6533*/    OPC_EmitInteger32, 0,  // 0 #4
/*  6535*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6544*/   /*Scope*/ 21, /*->6566*/
/*  6545*/    OPC_CheckPredicate, 16, // Predicate_zextload
/*  6547*/    OPC_CheckPredicate, 23, // Predicate_zextloadvi32
/*  6549*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  6551*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6552*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6554*/    OPC_EmitMergeInputChains1_0,
/*  6555*/    OPC_EmitInteger32, 0,  // 0 #4
/*  6557*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6566*/   /*Scope*/ 21, /*->6588*/
/*  6567*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6569*/    OPC_CheckPredicate, 23, // Predicate_extloadvi32
/*  6571*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  6573*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6574*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6576*/    OPC_EmitMergeInputChains1_0,
/*  6577*/    OPC_EmitInteger32, 0,  // 0 #4
/*  6579*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6588*/   /*Scope*/ 56, /*->6645*/
/*  6589*/    OPC_CheckPredicate6,  // Predicate_load
/*  6590*/    OPC_SwitchType /*3 cases */, 15, /*MVT::v4f32*/111, // ->6608
/*  6593*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6594*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6596*/     OPC_EmitMergeInputChains1_0,
/*  6597*/     OPC_EmitInteger32, 0,  // 0 #4
/*  6599*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/111, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6608*/    /*SwitchType*/ 16, /*MVT::v2f64*/1|128,1/*129*/, // ->6627
/*  6611*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6612*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6614*/     OPC_EmitMergeInputChains1_0,
/*  6615*/     OPC_EmitInteger32, 0,  // 0 #4
/*  6617*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6627*/    /*SwitchType*/ 15, /*MVT::v8f16*/92, // ->6644
/*  6629*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6630*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6632*/     OPC_EmitMergeInputChains1_0,
/*  6633*/     OPC_EmitInteger32, 0,  // 0 #4
/*  6635*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v8f16*/92, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8f16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v8f16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6644*/    0, // EndSwitchType
/*  6645*/   /*Scope*/ 30, /*->6676*/
/*  6646*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6648*/    OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/*  6651*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6652*/    OPC_EmitMergeInputChains1_0,
/*  6653*/    OPC_EmitInteger32, 0,  // 0 #2
/*  6655*/    OPC_EmitInteger32, 0,  // 0 #3
/*  6657*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v16i8*/39, 3/*#Ops*/, 2, 3, 1,  // Results = #4
/*  6666*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 4,  // Results = #5
/*  6673*/    OPC_CompleteMatch, 1, 5, 
               // Src: (ld:{ *:[v2f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>> - Complexity = 4
               // Dst: (promote_low_F64x2:{ *:[v2f64] } (LOAD_ZERO_64_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr))
/*  6676*/   0, /*End of Scope*/
/*  6677*/  /*Scope*/ 89|128,5/*729*/, /*->7408*/
/*  6679*/   OPC_CheckChild1TypeI64,
/*  6680*/   OPC_CheckPredicate, 8, // Predicate_unindexedload
/*  6682*/   OPC_Scope, 37, /*->6721*/ // 16 children in Scope
/*  6684*/    OPC_CheckPredicate6,  // Predicate_load
/*  6685*/    OPC_SwitchType /*2 cases */, 15, /*MVT::i32*/7, // ->6703
/*  6688*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6689*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6691*/     OPC_EmitMergeInputChains1_0,
/*  6692*/     OPC_EmitInteger32, 0,  // 0 #4
/*  6694*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6703*/    /*SwitchType*/ 15, /*MVT::i64*/8, // ->6720
/*  6705*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6706*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6708*/     OPC_EmitMergeInputChains1_0,
/*  6709*/     OPC_EmitInteger32, 0,  // 0 #4
/*  6711*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6720*/    0, // EndSwitchType
/*  6721*/   /*Scope*/ 97, /*->6819*/
/*  6722*/    OPC_CheckPredicate, 15, // Predicate_sextload
/*  6724*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6763
/*  6727*/     OPC_Scope, 16, /*->6745*/ // 2 children in Scope
/*  6729*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6730*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6731*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6733*/      OPC_EmitMergeInputChains1_0,
/*  6734*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6736*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6745*/     /*Scope*/ 16, /*->6762*/
/*  6746*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6747*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6748*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6750*/      OPC_EmitMergeInputChains1_0,
/*  6751*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6753*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6762*/     0, /*End of Scope*/
/*  6763*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6818
/*  6765*/     OPC_Scope, 16, /*->6783*/ // 3 children in Scope
/*  6767*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6768*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6769*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6771*/      OPC_EmitMergeInputChains1_0,
/*  6772*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6774*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6783*/     /*Scope*/ 16, /*->6800*/
/*  6784*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6785*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6786*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6788*/      OPC_EmitMergeInputChains1_0,
/*  6789*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6791*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6800*/     /*Scope*/ 16, /*->6817*/
/*  6801*/      OPC_CheckPredicate3,  // Predicate_sextloadi32
/*  6802*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6803*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6805*/      OPC_EmitMergeInputChains1_0,
/*  6806*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6808*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LOAD32_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6817*/     0, /*End of Scope*/
/*  6818*/    0, // EndSwitchType
/*  6819*/   /*Scope*/ 97, /*->6917*/
/*  6820*/    OPC_CheckPredicate, 16, // Predicate_zextload
/*  6822*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6861
/*  6825*/     OPC_Scope, 16, /*->6843*/ // 2 children in Scope
/*  6827*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6828*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6829*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6831*/      OPC_EmitMergeInputChains1_0,
/*  6832*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6834*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6843*/     /*Scope*/ 16, /*->6860*/
/*  6844*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6845*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6846*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6848*/      OPC_EmitMergeInputChains1_0,
/*  6849*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6851*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6860*/     0, /*End of Scope*/
/*  6861*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6916
/*  6863*/     OPC_Scope, 16, /*->6881*/ // 3 children in Scope
/*  6865*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6866*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6867*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6869*/      OPC_EmitMergeInputChains1_0,
/*  6870*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6872*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6881*/     /*Scope*/ 16, /*->6898*/
/*  6882*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6883*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6884*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6886*/      OPC_EmitMergeInputChains1_0,
/*  6887*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6889*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6898*/     /*Scope*/ 16, /*->6915*/
/*  6899*/      OPC_CheckPredicate3,  // Predicate_zextloadi32
/*  6900*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6901*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6903*/      OPC_EmitMergeInputChains1_0,
/*  6904*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6906*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6915*/     0, /*End of Scope*/
/*  6916*/    0, // EndSwitchType
/*  6917*/   /*Scope*/ 97, /*->7015*/
/*  6918*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6920*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6959
/*  6923*/     OPC_Scope, 16, /*->6941*/ // 2 children in Scope
/*  6925*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6926*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6927*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6929*/      OPC_EmitMergeInputChains1_0,
/*  6930*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6932*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6941*/     /*Scope*/ 16, /*->6958*/
/*  6942*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6943*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6944*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6946*/      OPC_EmitMergeInputChains1_0,
/*  6947*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6949*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6958*/     0, /*End of Scope*/
/*  6959*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->7014
/*  6961*/     OPC_Scope, 16, /*->6979*/ // 3 children in Scope
/*  6963*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6964*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6965*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6967*/      OPC_EmitMergeInputChains1_0,
/*  6968*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6970*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6979*/     /*Scope*/ 16, /*->6996*/
/*  6980*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6981*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6982*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6984*/      OPC_EmitMergeInputChains1_0,
/*  6985*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6987*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6996*/     /*Scope*/ 16, /*->7013*/
/*  6997*/      OPC_CheckPredicate3,  // Predicate_extloadi32
/*  6998*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6999*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7001*/      OPC_EmitMergeInputChains1_0,
/*  7002*/      OPC_EmitInteger32, 0,  // 0 #4
/*  7004*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7013*/     0, /*End of Scope*/
/*  7014*/    0, // EndSwitchType
/*  7015*/   /*Scope*/ 105, /*->7121*/
/*  7016*/    OPC_CheckPredicate6,  // Predicate_load
/*  7017*/    OPC_SwitchType /*6 cases */, 15, /*MVT::f32*/12, // ->7035
/*  7020*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7021*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7023*/     OPC_EmitMergeInputChains1_0,
/*  7024*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7026*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::f32*/12, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F32_A64:{ *:[f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7035*/    /*SwitchType*/ 15, /*MVT::f64*/13, // ->7052
/*  7037*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7038*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7040*/     OPC_EmitMergeInputChains1_0,
/*  7041*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7043*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::f64*/13, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F64_A64:{ *:[f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7052*/    /*SwitchType*/ 15, /*MVT::v16i8*/39, // ->7069
/*  7054*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7055*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7057*/     OPC_EmitMergeInputChains1_0,
/*  7058*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7060*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v16i8*/39, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v16i8] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v16i8] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7069*/    /*SwitchType*/ 15, /*MVT::v8i16*/50, // ->7086
/*  7071*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7072*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7074*/     OPC_EmitMergeInputChains1_0,
/*  7075*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7077*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7086*/    /*SwitchType*/ 15, /*MVT::v4i32*/60, // ->7103
/*  7088*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7089*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7091*/     OPC_EmitMergeInputChains1_0,
/*  7092*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7094*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7103*/    /*SwitchType*/ 15, /*MVT::v2i64*/78, // ->7120
/*  7105*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7106*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7108*/     OPC_EmitMergeInputChains1_0,
/*  7109*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7111*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7120*/    0, // EndSwitchType
/*  7121*/   /*Scope*/ 21, /*->7143*/
/*  7122*/    OPC_CheckPredicate, 15, // Predicate_sextload
/*  7124*/    OPC_CheckPredicate, 21, // Predicate_sextloadvi8
/*  7126*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  7128*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7129*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7131*/    OPC_EmitMergeInputChains1_0,
/*  7132*/    OPC_EmitInteger32, 0,  // 0 #4
/*  7134*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7143*/   /*Scope*/ 21, /*->7165*/
/*  7144*/    OPC_CheckPredicate, 16, // Predicate_zextload
/*  7146*/    OPC_CheckPredicate, 21, // Predicate_zextloadvi8
/*  7148*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  7150*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7151*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7153*/    OPC_EmitMergeInputChains1_0,
/*  7154*/    OPC_EmitInteger32, 0,  // 0 #4
/*  7156*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7165*/   /*Scope*/ 21, /*->7187*/
/*  7166*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7168*/    OPC_CheckPredicate, 21, // Predicate_extloadvi8
/*  7170*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  7172*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7173*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7175*/    OPC_EmitMergeInputChains1_0,
/*  7176*/    OPC_EmitInteger32, 0,  // 0 #4
/*  7178*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7187*/   /*Scope*/ 21, /*->7209*/
/*  7188*/    OPC_CheckPredicate, 15, // Predicate_sextload
/*  7190*/    OPC_CheckPredicate, 22, // Predicate_sextloadvi16
/*  7192*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  7194*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7195*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7197*/    OPC_EmitMergeInputChains1_0,
/*  7198*/    OPC_EmitInteger32, 0,  // 0 #4
/*  7200*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7209*/   /*Scope*/ 21, /*->7231*/
/*  7210*/    OPC_CheckPredicate, 16, // Predicate_zextload
/*  7212*/    OPC_CheckPredicate, 22, // Predicate_zextloadvi16
/*  7214*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  7216*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7217*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7219*/    OPC_EmitMergeInputChains1_0,
/*  7220*/    OPC_EmitInteger32, 0,  // 0 #4
/*  7222*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7231*/   /*Scope*/ 21, /*->7253*/
/*  7232*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7234*/    OPC_CheckPredicate, 22, // Predicate_extloadvi16
/*  7236*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  7238*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7239*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7241*/    OPC_EmitMergeInputChains1_0,
/*  7242*/    OPC_EmitInteger32, 0,  // 0 #4
/*  7244*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7253*/   /*Scope*/ 21, /*->7275*/
/*  7254*/    OPC_CheckPredicate, 15, // Predicate_sextload
/*  7256*/    OPC_CheckPredicate, 23, // Predicate_sextloadvi32
/*  7258*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  7260*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7261*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7263*/    OPC_EmitMergeInputChains1_0,
/*  7264*/    OPC_EmitInteger32, 0,  // 0 #4
/*  7266*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7275*/   /*Scope*/ 21, /*->7297*/
/*  7276*/    OPC_CheckPredicate, 16, // Predicate_zextload
/*  7278*/    OPC_CheckPredicate, 23, // Predicate_zextloadvi32
/*  7280*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  7282*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7283*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7285*/    OPC_EmitMergeInputChains1_0,
/*  7286*/    OPC_EmitInteger32, 0,  // 0 #4
/*  7288*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7297*/   /*Scope*/ 21, /*->7319*/
/*  7298*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7300*/    OPC_CheckPredicate, 23, // Predicate_extloadvi32
/*  7302*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  7304*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7305*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7307*/    OPC_EmitMergeInputChains1_0,
/*  7308*/    OPC_EmitInteger32, 0,  // 0 #4
/*  7310*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7319*/   /*Scope*/ 56, /*->7376*/
/*  7320*/    OPC_CheckPredicate6,  // Predicate_load
/*  7321*/    OPC_SwitchType /*3 cases */, 15, /*MVT::v4f32*/111, // ->7339
/*  7324*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7325*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7327*/     OPC_EmitMergeInputChains1_0,
/*  7328*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7330*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/111, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7339*/    /*SwitchType*/ 16, /*MVT::v2f64*/1|128,1/*129*/, // ->7358
/*  7342*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7343*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7345*/     OPC_EmitMergeInputChains1_0,
/*  7346*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7348*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7358*/    /*SwitchType*/ 15, /*MVT::v8f16*/92, // ->7375
/*  7360*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7361*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7363*/     OPC_EmitMergeInputChains1_0,
/*  7364*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7366*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v8f16*/92, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8f16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v8f16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7375*/    0, // EndSwitchType
/*  7376*/   /*Scope*/ 30, /*->7407*/
/*  7377*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7379*/    OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/*  7382*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7383*/    OPC_EmitMergeInputChains1_0,
/*  7384*/    OPC_EmitInteger32, 0,  // 0 #2
/*  7386*/    OPC_EmitInteger64, 0,  // 0 #3
/*  7388*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v16i8*/39, 3/*#Ops*/, 2, 3, 1,  // Results = #4
/*  7397*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 4,  // Results = #5
/*  7404*/    OPC_CompleteMatch, 1, 5, 
               // Src: (ld:{ *:[v2f64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>> - Complexity = 4
               // Dst: (promote_low_F64x2:{ *:[v2f64] } (LOAD_ZERO_64_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr))
/*  7407*/   0, /*End of Scope*/
/*  7408*/  0, /*End of Scope*/
/*  7409*/ /*SwitchOpcode*/ 31|128,1/*159*/, TARGET_VAL(ISD::ATOMIC_LOAD),// ->7572
/*  7413*/  OPC_RecordMemRef,
/*  7414*/  OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  7415*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7416*/  OPC_Scope, 76, /*->7494*/ // 2 children in Scope
/*  7418*/   OPC_CheckChild1TypeI32,
/*  7419*/   OPC_SwitchType /*2 cases */, 53, /*MVT::i32*/7, // ->7475
/*  7422*/    OPC_Scope, 16, /*->7440*/ // 3 children in Scope
/*  7424*/     OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  7425*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  7426*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7428*/     OPC_EmitMergeInputChains1_0,
/*  7429*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7431*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
               // Dst: (ATOMIC_LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7440*/    /*Scope*/ 16, /*->7457*/
/*  7441*/     OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  7442*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  7443*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7445*/     OPC_EmitMergeInputChains1_0,
/*  7446*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7448*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>> - Complexity = 13
               // Dst: (ATOMIC_LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7457*/    /*Scope*/ 16, /*->7474*/
/*  7458*/     OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  7459*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  7460*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7462*/     OPC_EmitMergeInputChains1_0,
/*  7463*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7465*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>> - Complexity = 13
               // Dst: (ATOMIC_LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7474*/    0, /*End of Scope*/
/*  7475*/   /*SwitchType*/ 16, /*MVT::i64*/8, // ->7493
/*  7477*/    OPC_CheckPredicate7,  // Predicate_atomic_load_64
/*  7478*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  7479*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7481*/    OPC_EmitMergeInputChains1_0,
/*  7482*/    OPC_EmitInteger32, 0,  // 0 #4
/*  7484*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
              // Src: (atomic_load:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7493*/   0, // EndSwitchType
/*  7494*/  /*Scope*/ 76, /*->7571*/
/*  7495*/   OPC_CheckChild1TypeI64,
/*  7496*/   OPC_SwitchType /*2 cases */, 53, /*MVT::i32*/7, // ->7552
/*  7499*/    OPC_Scope, 16, /*->7517*/ // 3 children in Scope
/*  7501*/     OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  7502*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7503*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7505*/     OPC_EmitMergeInputChains1_0,
/*  7506*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7508*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
               // Dst: (ATOMIC_LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7517*/    /*Scope*/ 16, /*->7534*/
/*  7518*/     OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  7519*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7520*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7522*/     OPC_EmitMergeInputChains1_0,
/*  7523*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7525*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>> - Complexity = 13
               // Dst: (ATOMIC_LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7534*/    /*Scope*/ 16, /*->7551*/
/*  7535*/     OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  7536*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7537*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7539*/     OPC_EmitMergeInputChains1_0,
/*  7540*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7542*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>> - Complexity = 13
               // Dst: (ATOMIC_LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7551*/    0, /*End of Scope*/
/*  7552*/   /*SwitchType*/ 16, /*MVT::i64*/8, // ->7570
/*  7554*/    OPC_CheckPredicate7,  // Predicate_atomic_load_64
/*  7555*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7556*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7558*/    OPC_EmitMergeInputChains1_0,
/*  7559*/    OPC_EmitInteger32, 0,  // 0 #4
/*  7561*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
              // Src: (atomic_load:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7570*/   0, // EndSwitchType
/*  7571*/  0, /*End of Scope*/
/*  7572*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->7817
/*  7576*/  OPC_RecordMemRef,
/*  7577*/  OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  7578*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7579*/  OPC_Scope, 117, /*->7698*/ // 2 children in Scope
/*  7581*/   OPC_CheckChild1TypeI32,
/*  7582*/   OPC_RecordChild2, // #2 = $val
/*  7583*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->7678
/*  7586*/    OPC_Scope, 17, /*->7605*/ // 5 children in Scope
/*  7588*/     OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*  7589*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7590*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7592*/     OPC_EmitMergeInputChains1_0,
/*  7593*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7595*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7605*/    /*Scope*/ 17, /*->7623*/
/*  7606*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7607*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7608*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7610*/     OPC_EmitMergeInputChains1_0,
/*  7611*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7613*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7623*/    /*Scope*/ 17, /*->7641*/
/*  7624*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7625*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7626*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7628*/     OPC_EmitMergeInputChains1_0,
/*  7629*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7631*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7641*/    /*Scope*/ 17, /*->7659*/
/*  7642*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7643*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7644*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7646*/     OPC_EmitMergeInputChains1_0,
/*  7647*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7649*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7659*/    /*Scope*/ 17, /*->7677*/
/*  7660*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7661*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7662*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7664*/     OPC_EmitMergeInputChains1_0,
/*  7665*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7667*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7677*/    0, /*End of Scope*/
/*  7678*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->7697
/*  7680*/    OPC_CheckPredicate7,  // Predicate_atomic_load_add_i64
/*  7681*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7682*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7684*/    OPC_EmitMergeInputChains1_0,
/*  7685*/    OPC_EmitInteger32, 0,  // 0 #5
/*  7687*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_add:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  7697*/   0, // EndSwitchType
/*  7698*/  /*Scope*/ 117, /*->7816*/
/*  7699*/   OPC_CheckChild1TypeI64,
/*  7700*/   OPC_RecordChild2, // #2 = $val
/*  7701*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->7796
/*  7704*/    OPC_Scope, 17, /*->7723*/ // 5 children in Scope
/*  7706*/     OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*  7707*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7708*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7710*/     OPC_EmitMergeInputChains1_0,
/*  7711*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7713*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7723*/    /*Scope*/ 17, /*->7741*/
/*  7724*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7725*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7726*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7728*/     OPC_EmitMergeInputChains1_0,
/*  7729*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7731*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7741*/    /*Scope*/ 17, /*->7759*/
/*  7742*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7743*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7744*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7746*/     OPC_EmitMergeInputChains1_0,
/*  7747*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7749*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7759*/    /*Scope*/ 17, /*->7777*/
/*  7760*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7761*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7762*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7764*/     OPC_EmitMergeInputChains1_0,
/*  7765*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7767*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7777*/    /*Scope*/ 17, /*->7795*/
/*  7778*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7779*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7780*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7782*/     OPC_EmitMergeInputChains1_0,
/*  7783*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7785*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7795*/    0, /*End of Scope*/
/*  7796*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->7815
/*  7798*/    OPC_CheckPredicate7,  // Predicate_atomic_load_add_i64
/*  7799*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7800*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7802*/    OPC_EmitMergeInputChains1_0,
/*  7803*/    OPC_EmitInteger32, 0,  // 0 #5
/*  7805*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_add:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  7815*/   0, // EndSwitchType
/*  7816*/  0, /*End of Scope*/
/*  7817*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->8062
/*  7821*/  OPC_RecordMemRef,
/*  7822*/  OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  7823*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7824*/  OPC_Scope, 117, /*->7943*/ // 2 children in Scope
/*  7826*/   OPC_CheckChild1TypeI32,
/*  7827*/   OPC_RecordChild2, // #2 = $val
/*  7828*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->7923
/*  7831*/    OPC_Scope, 17, /*->7850*/ // 5 children in Scope
/*  7833*/     OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*  7834*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7835*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7837*/     OPC_EmitMergeInputChains1_0,
/*  7838*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7840*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7850*/    /*Scope*/ 17, /*->7868*/
/*  7851*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  7852*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7853*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7855*/     OPC_EmitMergeInputChains1_0,
/*  7856*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7858*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7868*/    /*Scope*/ 17, /*->7886*/
/*  7869*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  7870*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7871*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7873*/     OPC_EmitMergeInputChains1_0,
/*  7874*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7876*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7886*/    /*Scope*/ 17, /*->7904*/
/*  7887*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  7888*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7889*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7891*/     OPC_EmitMergeInputChains1_0,
/*  7892*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7894*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7904*/    /*Scope*/ 17, /*->7922*/
/*  7905*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  7906*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7907*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7909*/     OPC_EmitMergeInputChains1_0,
/*  7910*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7912*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7922*/    0, /*End of Scope*/
/*  7923*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->7942
/*  7925*/    OPC_CheckPredicate7,  // Predicate_atomic_load_sub_i64
/*  7926*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7927*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7929*/    OPC_EmitMergeInputChains1_0,
/*  7930*/    OPC_EmitInteger32, 0,  // 0 #5
/*  7932*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_sub:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  7942*/   0, // EndSwitchType
/*  7943*/  /*Scope*/ 117, /*->8061*/
/*  7944*/   OPC_CheckChild1TypeI64,
/*  7945*/   OPC_RecordChild2, // #2 = $val
/*  7946*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8041
/*  7949*/    OPC_Scope, 17, /*->7968*/ // 5 children in Scope
/*  7951*/     OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*  7952*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7953*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7955*/     OPC_EmitMergeInputChains1_0,
/*  7956*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7958*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7968*/    /*Scope*/ 17, /*->7986*/
/*  7969*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  7970*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7971*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7973*/     OPC_EmitMergeInputChains1_0,
/*  7974*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7976*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7986*/    /*Scope*/ 17, /*->8004*/
/*  7987*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  7988*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7989*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7991*/     OPC_EmitMergeInputChains1_0,
/*  7992*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7994*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8004*/    /*Scope*/ 17, /*->8022*/
/*  8005*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  8006*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8007*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8009*/     OPC_EmitMergeInputChains1_0,
/*  8010*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8012*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8022*/    /*Scope*/ 17, /*->8040*/
/*  8023*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  8024*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8025*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8027*/     OPC_EmitMergeInputChains1_0,
/*  8028*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8030*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8040*/    0, /*End of Scope*/
/*  8041*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8060
/*  8043*/    OPC_CheckPredicate7,  // Predicate_atomic_load_sub_i64
/*  8044*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8045*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8047*/    OPC_EmitMergeInputChains1_0,
/*  8048*/    OPC_EmitInteger32, 0,  // 0 #5
/*  8050*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_sub:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8060*/   0, // EndSwitchType
/*  8061*/  0, /*End of Scope*/
/*  8062*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->8307
/*  8066*/  OPC_RecordMemRef,
/*  8067*/  OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  8068*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8069*/  OPC_Scope, 117, /*->8188*/ // 2 children in Scope
/*  8071*/   OPC_CheckChild1TypeI32,
/*  8072*/   OPC_RecordChild2, // #2 = $val
/*  8073*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8168
/*  8076*/    OPC_Scope, 17, /*->8095*/ // 5 children in Scope
/*  8078*/     OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*  8079*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8080*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8082*/     OPC_EmitMergeInputChains1_0,
/*  8083*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8085*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8095*/    /*Scope*/ 17, /*->8113*/
/*  8096*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8097*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8098*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8100*/     OPC_EmitMergeInputChains1_0,
/*  8101*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8103*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8113*/    /*Scope*/ 17, /*->8131*/
/*  8114*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8115*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8116*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8118*/     OPC_EmitMergeInputChains1_0,
/*  8119*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8121*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8131*/    /*Scope*/ 17, /*->8149*/
/*  8132*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8133*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8134*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8136*/     OPC_EmitMergeInputChains1_0,
/*  8137*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8139*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8149*/    /*Scope*/ 17, /*->8167*/
/*  8150*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8151*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8152*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8154*/     OPC_EmitMergeInputChains1_0,
/*  8155*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8157*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8167*/    0, /*End of Scope*/
/*  8168*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8187
/*  8170*/    OPC_CheckPredicate7,  // Predicate_atomic_load_and_i64
/*  8171*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8172*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8174*/    OPC_EmitMergeInputChains1_0,
/*  8175*/    OPC_EmitInteger32, 0,  // 0 #5
/*  8177*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_and:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8187*/   0, // EndSwitchType
/*  8188*/  /*Scope*/ 117, /*->8306*/
/*  8189*/   OPC_CheckChild1TypeI64,
/*  8190*/   OPC_RecordChild2, // #2 = $val
/*  8191*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8286
/*  8194*/    OPC_Scope, 17, /*->8213*/ // 5 children in Scope
/*  8196*/     OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*  8197*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8198*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8200*/     OPC_EmitMergeInputChains1_0,
/*  8201*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8203*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8213*/    /*Scope*/ 17, /*->8231*/
/*  8214*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8215*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8216*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8218*/     OPC_EmitMergeInputChains1_0,
/*  8219*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8221*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8231*/    /*Scope*/ 17, /*->8249*/
/*  8232*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8233*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8234*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8236*/     OPC_EmitMergeInputChains1_0,
/*  8237*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8239*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8249*/    /*Scope*/ 17, /*->8267*/
/*  8250*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8251*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8252*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8254*/     OPC_EmitMergeInputChains1_0,
/*  8255*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8257*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8267*/    /*Scope*/ 17, /*->8285*/
/*  8268*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8269*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8270*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8272*/     OPC_EmitMergeInputChains1_0,
/*  8273*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8275*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8285*/    0, /*End of Scope*/
/*  8286*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8305
/*  8288*/    OPC_CheckPredicate7,  // Predicate_atomic_load_and_i64
/*  8289*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8290*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8292*/    OPC_EmitMergeInputChains1_0,
/*  8293*/    OPC_EmitInteger32, 0,  // 0 #5
/*  8295*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_and:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8305*/   0, // EndSwitchType
/*  8306*/  0, /*End of Scope*/
/*  8307*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->8552
/*  8311*/  OPC_RecordMemRef,
/*  8312*/  OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  8313*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8314*/  OPC_Scope, 117, /*->8433*/ // 2 children in Scope
/*  8316*/   OPC_CheckChild1TypeI32,
/*  8317*/   OPC_RecordChild2, // #2 = $val
/*  8318*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8413
/*  8321*/    OPC_Scope, 17, /*->8340*/ // 5 children in Scope
/*  8323*/     OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*  8324*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8325*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8327*/     OPC_EmitMergeInputChains1_0,
/*  8328*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8330*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8340*/    /*Scope*/ 17, /*->8358*/
/*  8341*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8342*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8343*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8345*/     OPC_EmitMergeInputChains1_0,
/*  8346*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8348*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8358*/    /*Scope*/ 17, /*->8376*/
/*  8359*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8360*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8361*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8363*/     OPC_EmitMergeInputChains1_0,
/*  8364*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8366*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8376*/    /*Scope*/ 17, /*->8394*/
/*  8377*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8378*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8379*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8381*/     OPC_EmitMergeInputChains1_0,
/*  8382*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8384*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8394*/    /*Scope*/ 17, /*->8412*/
/*  8395*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8396*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8397*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8399*/     OPC_EmitMergeInputChains1_0,
/*  8400*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8402*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8412*/    0, /*End of Scope*/
/*  8413*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8432
/*  8415*/    OPC_CheckPredicate7,  // Predicate_atomic_load_or_i64
/*  8416*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8417*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8419*/    OPC_EmitMergeInputChains1_0,
/*  8420*/    OPC_EmitInteger32, 0,  // 0 #5
/*  8422*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_or:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8432*/   0, // EndSwitchType
/*  8433*/  /*Scope*/ 117, /*->8551*/
/*  8434*/   OPC_CheckChild1TypeI64,
/*  8435*/   OPC_RecordChild2, // #2 = $val
/*  8436*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8531
/*  8439*/    OPC_Scope, 17, /*->8458*/ // 5 children in Scope
/*  8441*/     OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*  8442*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8443*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8445*/     OPC_EmitMergeInputChains1_0,
/*  8446*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8448*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8458*/    /*Scope*/ 17, /*->8476*/
/*  8459*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8460*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8461*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8463*/     OPC_EmitMergeInputChains1_0,
/*  8464*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8466*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8476*/    /*Scope*/ 17, /*->8494*/
/*  8477*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8478*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8479*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8481*/     OPC_EmitMergeInputChains1_0,
/*  8482*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8484*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8494*/    /*Scope*/ 17, /*->8512*/
/*  8495*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8496*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8497*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8499*/     OPC_EmitMergeInputChains1_0,
/*  8500*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8502*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8512*/    /*Scope*/ 17, /*->8530*/
/*  8513*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8514*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8515*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8517*/     OPC_EmitMergeInputChains1_0,
/*  8518*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8520*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8530*/    0, /*End of Scope*/
/*  8531*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8550
/*  8533*/    OPC_CheckPredicate7,  // Predicate_atomic_load_or_i64
/*  8534*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8535*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8537*/    OPC_EmitMergeInputChains1_0,
/*  8538*/    OPC_EmitInteger32, 0,  // 0 #5
/*  8540*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_or:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8550*/   0, // EndSwitchType
/*  8551*/  0, /*End of Scope*/
/*  8552*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->8797
/*  8556*/  OPC_RecordMemRef,
/*  8557*/  OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  8558*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8559*/  OPC_Scope, 117, /*->8678*/ // 2 children in Scope
/*  8561*/   OPC_CheckChild1TypeI32,
/*  8562*/   OPC_RecordChild2, // #2 = $val
/*  8563*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8658
/*  8566*/    OPC_Scope, 17, /*->8585*/ // 5 children in Scope
/*  8568*/     OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*  8569*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8570*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8572*/     OPC_EmitMergeInputChains1_0,
/*  8573*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8575*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8585*/    /*Scope*/ 17, /*->8603*/
/*  8586*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8587*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8588*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8590*/     OPC_EmitMergeInputChains1_0,
/*  8591*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8593*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8603*/    /*Scope*/ 17, /*->8621*/
/*  8604*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8605*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8606*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8608*/     OPC_EmitMergeInputChains1_0,
/*  8609*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8611*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8621*/    /*Scope*/ 17, /*->8639*/
/*  8622*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8623*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8624*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8626*/     OPC_EmitMergeInputChains1_0,
/*  8627*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8629*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8639*/    /*Scope*/ 17, /*->8657*/
/*  8640*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8641*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8642*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8644*/     OPC_EmitMergeInputChains1_0,
/*  8645*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8647*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8657*/    0, /*End of Scope*/
/*  8658*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8677
/*  8660*/    OPC_CheckPredicate7,  // Predicate_atomic_load_xor_i64
/*  8661*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8662*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8664*/    OPC_EmitMergeInputChains1_0,
/*  8665*/    OPC_EmitInteger32, 0,  // 0 #5
/*  8667*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_xor:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8677*/   0, // EndSwitchType
/*  8678*/  /*Scope*/ 117, /*->8796*/
/*  8679*/   OPC_CheckChild1TypeI64,
/*  8680*/   OPC_RecordChild2, // #2 = $val
/*  8681*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8776
/*  8684*/    OPC_Scope, 17, /*->8703*/ // 5 children in Scope
/*  8686*/     OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*  8687*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8688*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8690*/     OPC_EmitMergeInputChains1_0,
/*  8691*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8693*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8703*/    /*Scope*/ 17, /*->8721*/
/*  8704*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8705*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8706*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8708*/     OPC_EmitMergeInputChains1_0,
/*  8709*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8711*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8721*/    /*Scope*/ 17, /*->8739*/
/*  8722*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8723*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8724*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8726*/     OPC_EmitMergeInputChains1_0,
/*  8727*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8729*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8739*/    /*Scope*/ 17, /*->8757*/
/*  8740*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8741*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8742*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8744*/     OPC_EmitMergeInputChains1_0,
/*  8745*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8747*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8757*/    /*Scope*/ 17, /*->8775*/
/*  8758*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8759*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8760*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8762*/     OPC_EmitMergeInputChains1_0,
/*  8763*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8765*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8775*/    0, /*End of Scope*/
/*  8776*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8795
/*  8778*/    OPC_CheckPredicate7,  // Predicate_atomic_load_xor_i64
/*  8779*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8780*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8782*/    OPC_EmitMergeInputChains1_0,
/*  8783*/    OPC_EmitInteger32, 0,  // 0 #5
/*  8785*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_xor:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8795*/   0, // EndSwitchType
/*  8796*/  0, /*End of Scope*/
/*  8797*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->9042
/*  8801*/  OPC_RecordMemRef,
/*  8802*/  OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  8803*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8804*/  OPC_Scope, 117, /*->8923*/ // 2 children in Scope
/*  8806*/   OPC_CheckChild1TypeI32,
/*  8807*/   OPC_RecordChild2, // #2 = $val
/*  8808*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8903
/*  8811*/    OPC_Scope, 17, /*->8830*/ // 5 children in Scope
/*  8813*/     OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*  8814*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8815*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8817*/     OPC_EmitMergeInputChains1_0,
/*  8818*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8820*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8830*/    /*Scope*/ 17, /*->8848*/
/*  8831*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  8832*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8833*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8835*/     OPC_EmitMergeInputChains1_0,
/*  8836*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8838*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8848*/    /*Scope*/ 17, /*->8866*/
/*  8849*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  8850*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8851*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8853*/     OPC_EmitMergeInputChains1_0,
/*  8854*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8856*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8866*/    /*Scope*/ 17, /*->8884*/
/*  8867*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  8868*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8869*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8871*/     OPC_EmitMergeInputChains1_0,
/*  8872*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8874*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8884*/    /*Scope*/ 17, /*->8902*/
/*  8885*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  8886*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8887*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8889*/     OPC_EmitMergeInputChains1_0,
/*  8890*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8892*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8902*/    0, /*End of Scope*/
/*  8903*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8922
/*  8905*/    OPC_CheckPredicate7,  // Predicate_atomic_swap_i64
/*  8906*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8907*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8909*/    OPC_EmitMergeInputChains1_0,
/*  8910*/    OPC_EmitInteger32, 0,  // 0 #5
/*  8912*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_swap:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8922*/   0, // EndSwitchType
/*  8923*/  /*Scope*/ 117, /*->9041*/
/*  8924*/   OPC_CheckChild1TypeI64,
/*  8925*/   OPC_RecordChild2, // #2 = $val
/*  8926*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->9021
/*  8929*/    OPC_Scope, 17, /*->8948*/ // 5 children in Scope
/*  8931*/     OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*  8932*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8933*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8935*/     OPC_EmitMergeInputChains1_0,
/*  8936*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8938*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8948*/    /*Scope*/ 17, /*->8966*/
/*  8949*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  8950*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8951*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8953*/     OPC_EmitMergeInputChains1_0,
/*  8954*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8956*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8966*/    /*Scope*/ 17, /*->8984*/
/*  8967*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  8968*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8969*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8971*/     OPC_EmitMergeInputChains1_0,
/*  8972*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8974*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8984*/    /*Scope*/ 17, /*->9002*/
/*  8985*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  8986*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8987*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8989*/     OPC_EmitMergeInputChains1_0,
/*  8990*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8992*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9002*/    /*Scope*/ 17, /*->9020*/
/*  9003*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  9004*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9005*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9007*/     OPC_EmitMergeInputChains1_0,
/*  9008*/     OPC_EmitInteger32, 0,  // 0 #5
/*  9010*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9020*/    0, /*End of Scope*/
/*  9021*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->9040
/*  9023*/    OPC_CheckPredicate7,  // Predicate_atomic_swap_i64
/*  9024*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9025*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9027*/    OPC_EmitMergeInputChains1_0,
/*  9028*/    OPC_EmitInteger32, 0,  // 0 #5
/*  9030*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_swap:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  9040*/   0, // EndSwitchType
/*  9041*/  0, /*End of Scope*/
/*  9042*/ /*SwitchOpcode*/ 127|128,1/*255*/, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->9301
/*  9046*/  OPC_RecordMemRef,
/*  9047*/  OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  9048*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  9049*/  OPC_Scope, 124, /*->9175*/ // 2 children in Scope
/*  9051*/   OPC_CheckChild1TypeI32,
/*  9052*/   OPC_RecordChild2, // #2 = $exp
/*  9053*/   OPC_RecordChild3, // #3 = $new
/*  9054*/   OPC_SwitchType /*2 cases */, 97, /*MVT::i32*/7, // ->9154
/*  9057*/    OPC_Scope, 18, /*->9077*/ // 5 children in Scope
/*  9059*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*  9060*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9061*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9063*/     OPC_EmitMergeInputChains1_0,
/*  9064*/     OPC_EmitInteger32, 0,  // 0 #6
/*  9066*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9077*/    /*Scope*/ 18, /*->9096*/
/*  9078*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9079*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9080*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9082*/     OPC_EmitMergeInputChains1_0,
/*  9083*/     OPC_EmitInteger32, 0,  // 0 #6
/*  9085*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9096*/    /*Scope*/ 18, /*->9115*/
/*  9097*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9098*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9099*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9101*/     OPC_EmitMergeInputChains1_0,
/*  9102*/     OPC_EmitInteger32, 0,  // 0 #6
/*  9104*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9115*/    /*Scope*/ 18, /*->9134*/
/*  9116*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9117*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9118*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9120*/     OPC_EmitMergeInputChains1_0,
/*  9121*/     OPC_EmitInteger32, 0,  // 0 #6
/*  9123*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9134*/    /*Scope*/ 18, /*->9153*/
/*  9135*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9136*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9137*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9139*/     OPC_EmitMergeInputChains1_0,
/*  9140*/     OPC_EmitInteger32, 0,  // 0 #6
/*  9142*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9153*/    0, /*End of Scope*/
/*  9154*/   /*SwitchType*/ 18, /*MVT::i64*/8, // ->9174
/*  9156*/    OPC_CheckPredicate7,  // Predicate_atomic_cmp_swap_i64
/*  9157*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9158*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9160*/    OPC_EmitMergeInputChains1_0,
/*  9161*/    OPC_EmitInteger32, 0,  // 0 #6
/*  9163*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  9174*/   0, // EndSwitchType
/*  9175*/  /*Scope*/ 124, /*->9300*/
/*  9176*/   OPC_CheckChild1TypeI64,
/*  9177*/   OPC_RecordChild2, // #2 = $exp
/*  9178*/   OPC_RecordChild3, // #3 = $new
/*  9179*/   OPC_SwitchType /*2 cases */, 97, /*MVT::i32*/7, // ->9279
/*  9182*/    OPC_Scope, 18, /*->9202*/ // 5 children in Scope
/*  9184*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*  9185*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9186*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9188*/     OPC_EmitMergeInputChains1_0,
/*  9189*/     OPC_EmitInteger32, 0,  // 0 #6
/*  9191*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9202*/    /*Scope*/ 18, /*->9221*/
/*  9203*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9204*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9205*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9207*/     OPC_EmitMergeInputChains1_0,
/*  9208*/     OPC_EmitInteger32, 0,  // 0 #6
/*  9210*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9221*/    /*Scope*/ 18, /*->9240*/
/*  9222*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9223*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9224*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9226*/     OPC_EmitMergeInputChains1_0,
/*  9227*/     OPC_EmitInteger32, 0,  // 0 #6
/*  9229*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9240*/    /*Scope*/ 18, /*->9259*/
/*  9241*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9242*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9243*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9245*/     OPC_EmitMergeInputChains1_0,
/*  9246*/     OPC_EmitInteger32, 0,  // 0 #6
/*  9248*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9259*/    /*Scope*/ 18, /*->9278*/
/*  9260*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9261*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9262*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9264*/     OPC_EmitMergeInputChains1_0,
/*  9265*/     OPC_EmitInteger32, 0,  // 0 #6
/*  9267*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9278*/    0, /*End of Scope*/
/*  9279*/   /*SwitchType*/ 18, /*MVT::i64*/8, // ->9299
/*  9281*/    OPC_CheckPredicate7,  // Predicate_atomic_cmp_swap_i64
/*  9282*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9283*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9285*/    OPC_EmitMergeInputChains1_0,
/*  9286*/    OPC_EmitInteger32, 0,  // 0 #6
/*  9288*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  9299*/   0, // EndSwitchType
/*  9300*/  0, /*End of Scope*/
/*  9301*/ /*SwitchOpcode*/ 89, TARGET_VAL(ISD::BRCOND),// ->9393
/*  9304*/  OPC_RecordNode, // #0 = 'brcond' chained node
/*  9305*/  OPC_Scope, 69, /*->9376*/ // 2 children in Scope
/*  9307*/   OPC_MoveChild1,
/*  9308*/   OPC_SwitchOpcode /*2 cases */, 21, TARGET_VAL(ISD::XOR),// ->9333
/*  9312*/    OPC_RecordChild0, // #1 = $cond
/*  9313*/    OPC_MoveChild0,
/*  9314*/    OPC_CheckPredicate, 26, // Predicate_bool_node
/*  9316*/    OPC_MoveParent,
/*  9317*/    OPC_CheckChild1Integer, 2, 
/*  9319*/    OPC_CheckTypeI32,
/*  9320*/    OPC_MoveSibling2,
/*  9321*/    OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9324*/    OPC_RecordNode, // #2 = $dst
/*  9325*/    OPC_MoveParent,
/*  9326*/    OPC_EmitMergeInputChains1_0,
/*  9327*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_UNLESS),
                  2/*#Ops*/, 2, 1, 
              // Src: (brcond (xor:{ *:[i32] } I32:{ *:[i32] }<<P:Predicate_bool_node>>:$cond, 1:{ *:[i32] }), (bb:{ *:[Other] }):$dst) - Complexity = 12
              // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9333*/   /*SwitchOpcode*/ 39, TARGET_VAL(ISD::SETCC),// ->9375
/*  9336*/    OPC_RecordChild0, // #1 = $cond
/*  9337*/    OPC_CheckChild0TypeI32,
/*  9338*/    OPC_CheckChild1Integer, 0, 
/*  9340*/    OPC_CheckTypeI32,
/*  9341*/    OPC_Scope, 15, /*->9358*/ // 2 children in Scope
/*  9343*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  9345*/     OPC_MoveSibling2,
/*  9346*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9349*/     OPC_RecordNode, // #2 = $dst
/*  9350*/     OPC_MoveParent,
/*  9351*/     OPC_EmitMergeInputChains1_0,
/*  9352*/     OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_IF),
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_IF bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9358*/    /*Scope*/ 15, /*->9374*/
/*  9359*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9361*/     OPC_MoveSibling2,
/*  9362*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9365*/     OPC_RecordNode, // #2 = $dst
/*  9366*/     OPC_MoveParent,
/*  9367*/     OPC_EmitMergeInputChains1_0,
/*  9368*/     OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_UNLESS),
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9374*/    0, /*End of Scope*/
/*  9375*/   0, // EndSwitchOpcode
/*  9376*/  /*Scope*/ 15, /*->9392*/
/*  9377*/   OPC_RecordChild1, // #1 = $cond
/*  9378*/   OPC_CheckChild1TypeI32,
/*  9379*/   OPC_RecordChild2, // #2 = $dst
/*  9380*/   OPC_MoveChild2,
/*  9381*/   OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9384*/   OPC_MoveParent,
/*  9385*/   OPC_EmitMergeInputChains1_0,
/*  9386*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_IF),
                 2/*#Ops*/, 2, 1, 
             // Src: (brcond I32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst) - Complexity = 3
             // Dst: (BR_IF (bb:{ *:[Other] }):$dst, I32:{ *:[i32] }:$cond)
/*  9392*/  0, /*End of Scope*/
/*  9393*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SHL),// ->9455
/*  9396*/  OPC_RecordChild0, // #0 = $lhs
/*  9397*/  OPC_Scope, 31, /*->9430*/ // 2 children in Scope
/*  9399*/   OPC_MoveChild1,
/*  9400*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9415
/*  9403*/    OPC_CheckAndImm, 31, 
/*  9405*/    OPC_RecordChild0, // #1 = $rhs
/*  9406*/    OPC_MoveParent,
/*  9407*/    OPC_CheckTypeI32,
/*  9408*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9415*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9429
/*  9417*/    OPC_CheckAndImm, 63, 
/*  9419*/    OPC_RecordChild0, // #1 = $rhs
/*  9420*/    OPC_MoveParent,
/*  9421*/    OPC_CheckTypeI64,
/*  9422*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9429*/   0, // EndSwitchType
/*  9430*/  /*Scope*/ 23, /*->9454*/
/*  9431*/   OPC_RecordChild1, // #1 = $rhs
/*  9432*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9443
/*  9435*/    OPC_CheckChild1TypeI32,
/*  9436*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9443*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9453
/*  9445*/    OPC_CheckChild1TypeI64,
/*  9446*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9453*/   0, // EndSwitchType
/*  9454*/  0, /*End of Scope*/
/*  9455*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SRA),// ->9517
/*  9458*/  OPC_RecordChild0, // #0 = $lhs
/*  9459*/  OPC_Scope, 31, /*->9492*/ // 2 children in Scope
/*  9461*/   OPC_MoveChild1,
/*  9462*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9477
/*  9465*/    OPC_CheckAndImm, 31, 
/*  9467*/    OPC_RecordChild0, // #1 = $rhs
/*  9468*/    OPC_MoveParent,
/*  9469*/    OPC_CheckTypeI32,
/*  9470*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9477*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9491
/*  9479*/    OPC_CheckAndImm, 63, 
/*  9481*/    OPC_RecordChild0, // #1 = $rhs
/*  9482*/    OPC_MoveParent,
/*  9483*/    OPC_CheckTypeI64,
/*  9484*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9491*/   0, // EndSwitchType
/*  9492*/  /*Scope*/ 23, /*->9516*/
/*  9493*/   OPC_RecordChild1, // #1 = $rhs
/*  9494*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9505
/*  9497*/    OPC_CheckChild1TypeI32,
/*  9498*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9505*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9515
/*  9507*/    OPC_CheckChild1TypeI64,
/*  9508*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9515*/   0, // EndSwitchType
/*  9516*/  0, /*End of Scope*/
/*  9517*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SRL),// ->9579
/*  9520*/  OPC_RecordChild0, // #0 = $lhs
/*  9521*/  OPC_Scope, 31, /*->9554*/ // 2 children in Scope
/*  9523*/   OPC_MoveChild1,
/*  9524*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9539
/*  9527*/    OPC_CheckAndImm, 31, 
/*  9529*/    OPC_RecordChild0, // #1 = $rhs
/*  9530*/    OPC_MoveParent,
/*  9531*/    OPC_CheckTypeI32,
/*  9532*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9539*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9553
/*  9541*/    OPC_CheckAndImm, 63, 
/*  9543*/    OPC_RecordChild0, // #1 = $rhs
/*  9544*/    OPC_MoveParent,
/*  9545*/    OPC_CheckTypeI64,
/*  9546*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9553*/   0, // EndSwitchType
/*  9554*/  /*Scope*/ 23, /*->9578*/
/*  9555*/   OPC_RecordChild1, // #1 = $rhs
/*  9556*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9567
/*  9559*/    OPC_CheckChild1TypeI32,
/*  9560*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9567*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9577
/*  9569*/    OPC_CheckChild1TypeI64,
/*  9570*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9577*/   0, // EndSwitchType
/*  9578*/  0, /*End of Scope*/
/*  9579*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::ROTL),// ->9641
/*  9582*/  OPC_RecordChild0, // #0 = $lhs
/*  9583*/  OPC_Scope, 31, /*->9616*/ // 2 children in Scope
/*  9585*/   OPC_MoveChild1,
/*  9586*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9601
/*  9589*/    OPC_CheckAndImm, 31, 
/*  9591*/    OPC_RecordChild0, // #1 = $rhs
/*  9592*/    OPC_MoveParent,
/*  9593*/    OPC_CheckTypeI32,
/*  9594*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9601*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9615
/*  9603*/    OPC_CheckAndImm, 63, 
/*  9605*/    OPC_RecordChild0, // #1 = $rhs
/*  9606*/    OPC_MoveParent,
/*  9607*/    OPC_CheckTypeI64,
/*  9608*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9615*/   0, // EndSwitchType
/*  9616*/  /*Scope*/ 23, /*->9640*/
/*  9617*/   OPC_RecordChild1, // #1 = $rhs
/*  9618*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9629
/*  9621*/    OPC_CheckChild1TypeI32,
/*  9622*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9629*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9639
/*  9631*/    OPC_CheckChild1TypeI64,
/*  9632*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9639*/   0, // EndSwitchType
/*  9640*/  0, /*End of Scope*/
/*  9641*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::ROTR),// ->9703
/*  9644*/  OPC_RecordChild0, // #0 = $lhs
/*  9645*/  OPC_Scope, 31, /*->9678*/ // 2 children in Scope
/*  9647*/   OPC_MoveChild1,
/*  9648*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9663
/*  9651*/    OPC_CheckAndImm, 31, 
/*  9653*/    OPC_RecordChild0, // #1 = $rhs
/*  9654*/    OPC_MoveParent,
/*  9655*/    OPC_CheckTypeI32,
/*  9656*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9663*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9677
/*  9665*/    OPC_CheckAndImm, 63, 
/*  9667*/    OPC_RecordChild0, // #1 = $rhs
/*  9668*/    OPC_MoveParent,
/*  9669*/    OPC_CheckTypeI64,
/*  9670*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9677*/   0, // EndSwitchType
/*  9678*/  /*Scope*/ 23, /*->9702*/
/*  9679*/   OPC_RecordChild1, // #1 = $rhs
/*  9680*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9691
/*  9683*/    OPC_CheckChild1TypeI32,
/*  9684*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9691*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9701
/*  9693*/    OPC_CheckChild1TypeI64,
/*  9694*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9701*/   0, // EndSwitchType
/*  9702*/  0, /*End of Scope*/
/*  9703*/ /*SwitchOpcode*/ 48|128,4/*560*/, TARGET_VAL(ISD::SELECT),// ->10267
/*  9707*/  OPC_Scope, 11|128,1/*139*/, /*->9849*/ // 8 children in Scope
/*  9710*/   OPC_MoveChild0,
/*  9711*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/*  9714*/   OPC_RecordChild0, // #0 = $cond
/*  9715*/   OPC_CheckChild0TypeI32,
/*  9716*/   OPC_CheckChild1Integer, 0, 
/*  9718*/   OPC_CheckTypeI32,
/*  9719*/   OPC_Scope, 63, /*->9784*/ // 2 children in Scope
/*  9721*/    OPC_CheckChild2CondCode, ISD::SETNE,
/*  9723*/    OPC_MoveParent,
/*  9724*/    OPC_RecordChild1, // #1 = $lhs
/*  9725*/    OPC_RecordChild2, // #2 = $rhs
/*  9726*/    OPC_SwitchType /*5 cases */, 8, /*MVT::i32*/7, // ->9737
/*  9729*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                   /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9737*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->9747
/*  9739*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                   /*MVT::i64*/8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9747*/    /*SwitchType*/ 9, /*MVT::funcref*/99|128,1/*227*/, // ->9759
/*  9750*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                   /*MVT::funcref*/99|128,1/*227*/, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9759*/    /*SwitchType*/ 9, /*MVT::externref*/100|128,1/*228*/, // ->9771
/*  9762*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                   /*MVT::externref*/100|128,1/*228*/, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9771*/    /*SwitchType*/ 9, /*MVT::exnref*/101|128,1/*229*/, // ->9783
/*  9774*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                   /*MVT::exnref*/101|128,1/*229*/, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[exnref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXNREF:{ *:[exnref] } EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9783*/    0, // EndSwitchType
/*  9784*/   /*Scope*/ 63, /*->9848*/
/*  9785*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9787*/    OPC_MoveParent,
/*  9788*/    OPC_RecordChild1, // #1 = $lhs
/*  9789*/    OPC_RecordChild2, // #2 = $rhs
/*  9790*/    OPC_SwitchType /*5 cases */, 8, /*MVT::i32*/7, // ->9801
/*  9793*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                   /*MVT::i32*/7, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9801*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->9811
/*  9803*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                   /*MVT::i64*/8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$rhs, I64:{ *:[i64] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9811*/    /*SwitchType*/ 9, /*MVT::funcref*/99|128,1/*227*/, // ->9823
/*  9814*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                   /*MVT::funcref*/99|128,1/*227*/, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$rhs, FUNCREF:{ *:[funcref] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9823*/    /*SwitchType*/ 9, /*MVT::externref*/100|128,1/*228*/, // ->9835
/*  9826*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                   /*MVT::externref*/100|128,1/*228*/, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$rhs, EXTERNREF:{ *:[externref] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9835*/    /*SwitchType*/ 9, /*MVT::exnref*/101|128,1/*229*/, // ->9847
/*  9838*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                   /*MVT::exnref*/101|128,1/*229*/, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[exnref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXNREF:{ *:[exnref] } EXNREF:{ *:[exnref] }:$rhs, EXNREF:{ *:[exnref] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9847*/    0, // EndSwitchType
/*  9848*/   0, /*End of Scope*/
/*  9849*/  /*Scope*/ 65, /*->9915*/
/*  9850*/   OPC_RecordChild0, // #0 = $cond
/*  9851*/   OPC_CheckChild0TypeI32,
/*  9852*/   OPC_RecordChild1, // #1 = $lhs
/*  9853*/   OPC_RecordChild2, // #2 = $rhs
/*  9854*/   OPC_SwitchType /*5 cases */, 8, /*MVT::i32*/7, // ->9865
/*  9857*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                  /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i32] } I32:{ *:[i32] }:$cond, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9865*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9875
/*  9867*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                  /*MVT::i64*/8, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i64] } I32:{ *:[i32] }:$cond, I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9875*/   /*SwitchType*/ 10, /*MVT::funcref*/99|128,1/*227*/, // ->9888
/*  9878*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  9879*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                  /*MVT::funcref*/99|128,1/*227*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[funcref] } I32:{ *:[i32] }:$cond, FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9888*/   /*SwitchType*/ 10, /*MVT::externref*/100|128,1/*228*/, // ->9901
/*  9891*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  9892*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                  /*MVT::externref*/100|128,1/*228*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[externref] } I32:{ *:[i32] }:$cond, EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9901*/   /*SwitchType*/ 10, /*MVT::exnref*/101|128,1/*229*/, // ->9914
/*  9904*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  9905*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                  /*MVT::exnref*/101|128,1/*229*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[exnref] } I32:{ *:[i32] }:$cond, EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_EXNREF:{ *:[exnref] } EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9914*/   0, // EndSwitchType
/*  9915*/  /*Scope*/ 67, /*->9983*/
/*  9916*/   OPC_MoveChild0,
/*  9917*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/*  9920*/   OPC_RecordChild0, // #0 = $cond
/*  9921*/   OPC_CheckChild0TypeI32,
/*  9922*/   OPC_CheckChild1Integer, 0, 
/*  9924*/   OPC_CheckTypeI32,
/*  9925*/   OPC_Scope, 27, /*->9954*/ // 2 children in Scope
/*  9927*/    OPC_CheckChild2CondCode, ISD::SETNE,
/*  9929*/    OPC_MoveParent,
/*  9930*/    OPC_RecordChild1, // #1 = $lhs
/*  9931*/    OPC_RecordChild2, // #2 = $rhs
/*  9932*/    OPC_SwitchType /*2 cases */, 8, /*MVT::f32*/12, // ->9943
/*  9935*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                   /*MVT::f32*/12, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9943*/    /*SwitchType*/ 8, /*MVT::f64*/13, // ->9953
/*  9945*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                   /*MVT::f64*/13, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9953*/    0, // EndSwitchType
/*  9954*/   /*Scope*/ 27, /*->9982*/
/*  9955*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9957*/    OPC_MoveParent,
/*  9958*/    OPC_RecordChild1, // #1 = $lhs
/*  9959*/    OPC_RecordChild2, // #2 = $rhs
/*  9960*/    OPC_SwitchType /*2 cases */, 8, /*MVT::f32*/12, // ->9971
/*  9963*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                   /*MVT::f32*/12, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$rhs, F32:{ *:[f32] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9971*/    /*SwitchType*/ 8, /*MVT::f64*/13, // ->9981
/*  9973*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                   /*MVT::f64*/13, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$rhs, F64:{ *:[f64] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9981*/    0, // EndSwitchType
/*  9982*/   0, /*End of Scope*/
/*  9983*/  /*Scope*/ 26, /*->10010*/
/*  9984*/   OPC_RecordChild0, // #0 = $cond
/*  9985*/   OPC_CheckChild0TypeI32,
/*  9986*/   OPC_RecordChild1, // #1 = $lhs
/*  9987*/   OPC_RecordChild2, // #2 = $rhs
/*  9988*/   OPC_SwitchType /*2 cases */, 8, /*MVT::f32*/12, // ->9999
/*  9991*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                  /*MVT::f32*/12, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f32] } I32:{ *:[i32] }:$cond, F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9999*/   /*SwitchType*/ 8, /*MVT::f64*/13, // ->10009
/* 10001*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                  /*MVT::f64*/13, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f64] } I32:{ *:[i32] }:$cond, F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10009*/   0, // EndSwitchType
/* 10010*/  /*Scope*/ 107, /*->10118*/
/* 10011*/   OPC_MoveChild0,
/* 10012*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 10015*/   OPC_RecordChild0, // #0 = $cond
/* 10016*/   OPC_CheckChild0TypeI32,
/* 10017*/   OPC_CheckChild1Integer, 0, 
/* 10019*/   OPC_CheckTypeI32,
/* 10020*/   OPC_Scope, 47, /*->10069*/ // 2 children in Scope
/* 10022*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 10024*/    OPC_MoveParent,
/* 10025*/    OPC_RecordChild1, // #1 = $lhs
/* 10026*/    OPC_RecordChild2, // #2 = $rhs
/* 10027*/    OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->10038
/* 10030*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10038*/    /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->10048
/* 10040*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10048*/    /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->10058
/* 10050*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10058*/    /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->10068
/* 10060*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10068*/    0, // EndSwitchType
/* 10069*/   /*Scope*/ 47, /*->10117*/
/* 10070*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 10072*/    OPC_MoveParent,
/* 10073*/    OPC_RecordChild1, // #1 = $lhs
/* 10074*/    OPC_RecordChild2, // #2 = $rhs
/* 10075*/    OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->10086
/* 10078*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$rhs, ?:{ *:[v16i8] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10086*/    /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->10096
/* 10088*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$rhs, ?:{ *:[v8i16] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10096*/    /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->10106
/* 10098*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$rhs, ?:{ *:[v4i32] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10106*/    /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->10116
/* 10108*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$rhs, ?:{ *:[v2i64] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10116*/    0, // EndSwitchType
/* 10117*/   0, /*End of Scope*/
/* 10118*/  /*Scope*/ 46, /*->10165*/
/* 10119*/   OPC_RecordChild0, // #0 = $cond
/* 10120*/   OPC_CheckChild0TypeI32,
/* 10121*/   OPC_RecordChild1, // #1 = $lhs
/* 10122*/   OPC_RecordChild2, // #2 = $rhs
/* 10123*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->10134
/* 10126*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v16i8] } I32:{ *:[i32] }:$cond, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10134*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->10144
/* 10136*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v8i16] } I32:{ *:[i32] }:$cond, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10144*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->10154
/* 10146*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4i32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10154*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->10164
/* 10156*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2i64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10164*/   0, // EndSwitchType
/* 10165*/  /*Scope*/ 71, /*->10237*/
/* 10166*/   OPC_MoveChild0,
/* 10167*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 10170*/   OPC_RecordChild0, // #0 = $cond
/* 10171*/   OPC_CheckChild0TypeI32,
/* 10172*/   OPC_CheckChild1Integer, 0, 
/* 10174*/   OPC_CheckTypeI32,
/* 10175*/   OPC_Scope, 29, /*->10206*/ // 2 children in Scope
/* 10177*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 10179*/    OPC_MoveParent,
/* 10180*/    OPC_RecordChild1, // #1 = $lhs
/* 10181*/    OPC_RecordChild2, // #2 = $rhs
/* 10182*/    OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/111, // ->10193
/* 10185*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v4f32*/111, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10193*/    /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->10205
/* 10196*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10205*/    0, // EndSwitchType
/* 10206*/   /*Scope*/ 29, /*->10236*/
/* 10207*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 10209*/    OPC_MoveParent,
/* 10210*/    OPC_RecordChild1, // #1 = $lhs
/* 10211*/    OPC_RecordChild2, // #2 = $rhs
/* 10212*/    OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/111, // ->10223
/* 10215*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v4f32*/111, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$rhs, ?:{ *:[v4f32] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10223*/    /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->10235
/* 10226*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$rhs, ?:{ *:[v2f64] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10235*/    0, // EndSwitchType
/* 10236*/   0, /*End of Scope*/
/* 10237*/  /*Scope*/ 28, /*->10266*/
/* 10238*/   OPC_RecordChild0, // #0 = $cond
/* 10239*/   OPC_CheckChild0TypeI32,
/* 10240*/   OPC_RecordChild1, // #1 = $lhs
/* 10241*/   OPC_RecordChild2, // #2 = $rhs
/* 10242*/   OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/111, // ->10253
/* 10245*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v4f32*/111, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4f32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10253*/   /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->10265
/* 10256*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2f64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10265*/   0, // EndSwitchType
/* 10266*/  0, /*End of Scope*/
/* 10267*/ /*SwitchOpcode*/ 1|128,1/*129*/, TARGET_VAL(ISD::SIGN_EXTEND_INREG),// ->10400
/* 10271*/  OPC_Scope, 57, /*->10330*/ // 2 children in Scope
/* 10273*/   OPC_MoveChild0,
/* 10274*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/* 10277*/   OPC_RecordChild0, // #0 = $vec
/* 10278*/   OPC_Scope, 24, /*->10304*/ // 2 children in Scope
/* 10280*/    OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 10282*/    OPC_RecordChild1, // #1 = $idx
/* 10283*/    OPC_MoveChild1,
/* 10284*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10287*/    OPC_CheckPredicate, 18, // Predicate_LaneIdx16
/* 10289*/    OPC_CheckTypeI32,
/* 10290*/    OPC_MoveParent,
/* 10291*/    OPC_MoveSibling1,
/* 10292*/    OPC_CheckValueType, /*MVT::i8*/5, 
/* 10294*/    OPC_MoveParent,
/* 10295*/    OPC_CheckTypeI32,
/* 10296*/    OPC_EmitConvertToTarget1, // #2
/* 10297*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_s),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), i8:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I8x16_s:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 10304*/   /*Scope*/ 24, /*->10329*/
/* 10305*/    OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 10307*/    OPC_RecordChild1, // #1 = $idx
/* 10308*/    OPC_MoveChild1,
/* 10309*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10312*/    OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/* 10314*/    OPC_CheckTypeI32,
/* 10315*/    OPC_MoveParent,
/* 10316*/    OPC_MoveSibling1,
/* 10317*/    OPC_CheckValueType, /*MVT::i16*/6, 
/* 10319*/    OPC_MoveParent,
/* 10320*/    OPC_CheckTypeI32,
/* 10321*/    OPC_EmitConvertToTarget1, // #2
/* 10322*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_s),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), i16:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I16x8_s:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 10329*/   0, /*End of Scope*/
/* 10330*/  /*Scope*/ 68, /*->10399*/
/* 10331*/   OPC_RecordChild0, // #0 = $src
/* 10332*/   OPC_MoveChild1,
/* 10333*/   OPC_Scope, 25, /*->10360*/ // 3 children in Scope
/* 10335*/    OPC_CheckValueType, /*MVT::i8*/5, 
/* 10337*/    OPC_MoveParent,
/* 10338*/    OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->10349
/* 10341*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10343*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_EXTEND8_S_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND8_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 10349*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->10359
/* 10351*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10353*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND8_S_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND8_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10359*/    0, // EndSwitchType
/* 10360*/   /*Scope*/ 25, /*->10386*/
/* 10361*/    OPC_CheckValueType, /*MVT::i16*/6, 
/* 10363*/    OPC_MoveParent,
/* 10364*/    OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->10375
/* 10367*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10369*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_EXTEND16_S_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND16_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 10375*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->10385
/* 10377*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10379*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND16_S_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND16_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10385*/    0, // EndSwitchType
/* 10386*/   /*Scope*/ 11, /*->10398*/
/* 10387*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 10389*/    OPC_MoveParent,
/* 10390*/    OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10392*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND32_S_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_EXTEND32_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10398*/   0, /*End of Scope*/
/* 10399*/  0, /*End of Scope*/
/* 10400*/ /*SwitchOpcode*/ 46|128,1/*174*/, TARGET_VAL(WebAssemblyISD::GLOBAL_GET),// ->10578
/* 10404*/  OPC_RecordMemRef,
/* 10405*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_get' chained node
/* 10406*/  OPC_MoveChild1,
/* 10407*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10410*/  OPC_RecordChild0, // #1 = $addr
/* 10411*/  OPC_MoveChild0,
/* 10412*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10415*/  OPC_MoveParent,
/* 10416*/  OPC_MoveParent,
/* 10417*/  OPC_SwitchType /*14 cases */, 8, /*MVT::i32*/7, // ->10428
/* 10420*/   OPC_EmitMergeInputChains1_0,
/* 10421*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::i32*/7, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10428*/  /*SwitchType*/ 8, /*MVT::i64*/8, // ->10438
/* 10430*/   OPC_EmitMergeInputChains1_0,
/* 10431*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::i64*/8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 10438*/  /*SwitchType*/ 10, /*MVT::funcref*/99|128,1/*227*/, // ->10451
/* 10441*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10442*/   OPC_EmitMergeInputChains1_0,
/* 10443*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::funcref*/99|128,1/*227*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[funcref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10451*/  /*SwitchType*/ 10, /*MVT::externref*/100|128,1/*228*/, // ->10464
/* 10454*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10455*/   OPC_EmitMergeInputChains1_0,
/* 10456*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::externref*/100|128,1/*228*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[externref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10464*/  /*SwitchType*/ 11, /*MVT::exnref*/101|128,1/*229*/, // ->10478
/* 10467*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 10469*/   OPC_EmitMergeInputChains1_0,
/* 10470*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::exnref*/101|128,1/*229*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[exnref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_EXNREF:{ *:[exnref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10478*/  /*SwitchType*/ 8, /*MVT::f32*/12, // ->10488
/* 10480*/   OPC_EmitMergeInputChains1_0,
/* 10481*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::f32*/12, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F32:{ *:[f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10488*/  /*SwitchType*/ 8, /*MVT::f64*/13, // ->10498
/* 10490*/   OPC_EmitMergeInputChains1_0,
/* 10491*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::f64*/13, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F64:{ *:[f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10498*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->10509
/* 10500*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10501*/   OPC_EmitMergeInputChains1_0,
/* 10502*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v2i64*/78, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2i64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2i64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10509*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->10520
/* 10511*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10512*/   OPC_EmitMergeInputChains1_0,
/* 10513*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v4i32*/60, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4i32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10520*/  /*SwitchType*/ 9, /*MVT::v16i8*/39, // ->10531
/* 10522*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10523*/   OPC_EmitMergeInputChains1_0,
/* 10524*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v16i8*/39, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v16i8] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v16i8] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10531*/  /*SwitchType*/ 9, /*MVT::v8i16*/50, // ->10542
/* 10533*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10534*/   OPC_EmitMergeInputChains1_0,
/* 10535*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v8i16*/50, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v8i16] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v8i16] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10542*/  /*SwitchType*/ 9, /*MVT::v8f16*/92, // ->10553
/* 10544*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10545*/   OPC_EmitMergeInputChains1_0,
/* 10546*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v8f16*/92, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v8f16] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v8f16] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10553*/  /*SwitchType*/ 9, /*MVT::v4f32*/111, // ->10564
/* 10555*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10556*/   OPC_EmitMergeInputChains1_0,
/* 10557*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v4f32*/111, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4f32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10564*/  /*SwitchType*/ 10, /*MVT::v2f64*/1|128,1/*129*/, // ->10577
/* 10567*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10568*/   OPC_EmitMergeInputChains1_0,
/* 10569*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2f64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10577*/  0, // EndSwitchType
/* 10578*/ /*SwitchOpcode*/ 70|128,2/*326*/, TARGET_VAL(WebAssemblyISD::GLOBAL_SET),// ->10908
/* 10582*/  OPC_RecordMemRef,
/* 10583*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_set' chained node
/* 10584*/  OPC_RecordChild1, // #1 = $src
/* 10585*/  OPC_Scope, 20, /*->10607*/ // 14 children in Scope
/* 10587*/   OPC_CheckChild1TypeI32,
/* 10588*/   OPC_MoveChild2,
/* 10589*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10592*/   OPC_RecordChild0, // #2 = $addr
/* 10593*/   OPC_MoveChild0,
/* 10594*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10597*/   OPC_MoveParent,
/* 10598*/   OPC_MoveParent,
/* 10599*/   OPC_EmitMergeInputChains1_0,
/* 10600*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i32:{ *:[i32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I32 (tglobaladdr:{ *:[i32] }):$addr, i32:{ *:[i32] }:$src)
/* 10607*/  /*Scope*/ 20, /*->10628*/
/* 10608*/   OPC_CheckChild1TypeI64,
/* 10609*/   OPC_MoveChild2,
/* 10610*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10613*/   OPC_RecordChild0, // #2 = $addr
/* 10614*/   OPC_MoveChild0,
/* 10615*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10618*/   OPC_MoveParent,
/* 10619*/   OPC_MoveParent,
/* 10620*/   OPC_EmitMergeInputChains1_0,
/* 10621*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i64:{ *:[i64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I64 (tglobaladdr:{ *:[i64] }):$addr, i64:{ *:[i64] }:$src)
/* 10628*/  /*Scope*/ 21, /*->10650*/
/* 10629*/   OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 10631*/   OPC_MoveChild2,
/* 10632*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10635*/   OPC_RecordChild0, // #2 = $addr
/* 10636*/   OPC_MoveChild0,
/* 10637*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10640*/   OPC_MoveParent,
/* 10641*/   OPC_MoveParent,
/* 10642*/   OPC_EmitMergeInputChains1_0,
/* 10643*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f32:{ *:[f32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F32 (tglobaladdr:{ *:[i32] }):$addr, f32:{ *:[f32] }:$src)
/* 10650*/  /*Scope*/ 21, /*->10672*/
/* 10651*/   OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 10653*/   OPC_MoveChild2,
/* 10654*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10657*/   OPC_RecordChild0, // #2 = $addr
/* 10658*/   OPC_MoveChild0,
/* 10659*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10662*/   OPC_MoveParent,
/* 10663*/   OPC_MoveParent,
/* 10664*/   OPC_EmitMergeInputChains1_0,
/* 10665*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f64:{ *:[f64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F64 (tglobaladdr:{ *:[i32] }):$addr, f64:{ *:[f64] }:$src)
/* 10672*/  /*Scope*/ 22, /*->10695*/
/* 10673*/   OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 10675*/   OPC_MoveChild2,
/* 10676*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10679*/   OPC_RecordChild0, // #2 = $addr
/* 10680*/   OPC_MoveChild0,
/* 10681*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10684*/   OPC_MoveParent,
/* 10685*/   OPC_MoveParent,
/* 10686*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10687*/   OPC_EmitMergeInputChains1_0,
/* 10688*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v8f16:{ *:[v8f16] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v8f16:{ *:[v8f16] }:$src)
/* 10695*/  /*Scope*/ 22, /*->10718*/
/* 10696*/   OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 10698*/   OPC_MoveChild2,
/* 10699*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10702*/   OPC_RecordChild0, // #2 = $addr
/* 10703*/   OPC_MoveChild0,
/* 10704*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10707*/   OPC_MoveParent,
/* 10708*/   OPC_MoveParent,
/* 10709*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10710*/   OPC_EmitMergeInputChains1_0,
/* 10711*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4f32:{ *:[v4f32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4f32:{ *:[v4f32] }:$src)
/* 10718*/  /*Scope*/ 23, /*->10742*/
/* 10719*/   OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 10722*/   OPC_MoveChild2,
/* 10723*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10726*/   OPC_RecordChild0, // #2 = $addr
/* 10727*/   OPC_MoveChild0,
/* 10728*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10731*/   OPC_MoveParent,
/* 10732*/   OPC_MoveParent,
/* 10733*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10734*/   OPC_EmitMergeInputChains1_0,
/* 10735*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2f64:{ *:[v2f64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2f64:{ *:[v2f64] }:$src)
/* 10742*/  /*Scope*/ 22, /*->10765*/
/* 10743*/   OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 10745*/   OPC_MoveChild2,
/* 10746*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10749*/   OPC_RecordChild0, // #2 = $addr
/* 10750*/   OPC_MoveChild0,
/* 10751*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10754*/   OPC_MoveParent,
/* 10755*/   OPC_MoveParent,
/* 10756*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10757*/   OPC_EmitMergeInputChains1_0,
/* 10758*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2i64:{ *:[v2i64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2i64:{ *:[v2i64] }:$src)
/* 10765*/  /*Scope*/ 22, /*->10788*/
/* 10766*/   OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 10768*/   OPC_MoveChild2,
/* 10769*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10772*/   OPC_RecordChild0, // #2 = $addr
/* 10773*/   OPC_MoveChild0,
/* 10774*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10777*/   OPC_MoveParent,
/* 10778*/   OPC_MoveParent,
/* 10779*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10780*/   OPC_EmitMergeInputChains1_0,
/* 10781*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4i32:{ *:[v4i32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4i32:{ *:[v4i32] }:$src)
/* 10788*/  /*Scope*/ 22, /*->10811*/
/* 10789*/   OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 10791*/   OPC_MoveChild2,
/* 10792*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10795*/   OPC_RecordChild0, // #2 = $addr
/* 10796*/   OPC_MoveChild0,
/* 10797*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10800*/   OPC_MoveParent,
/* 10801*/   OPC_MoveParent,
/* 10802*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10803*/   OPC_EmitMergeInputChains1_0,
/* 10804*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v16i8:{ *:[v16i8] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v16i8:{ *:[v16i8] }:$src)
/* 10811*/  /*Scope*/ 22, /*->10834*/
/* 10812*/   OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 10814*/   OPC_MoveChild2,
/* 10815*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10818*/   OPC_RecordChild0, // #2 = $addr
/* 10819*/   OPC_MoveChild0,
/* 10820*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10823*/   OPC_MoveParent,
/* 10824*/   OPC_MoveParent,
/* 10825*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10826*/   OPC_EmitMergeInputChains1_0,
/* 10827*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v8i16:{ *:[v8i16] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v8i16:{ *:[v8i16] }:$src)
/* 10834*/  /*Scope*/ 23, /*->10858*/
/* 10835*/   OPC_CheckChild1Type, /*MVT::funcref*/99|128,1/*227*/, 
/* 10838*/   OPC_MoveChild2,
/* 10839*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10842*/   OPC_RecordChild0, // #2 = $addr
/* 10843*/   OPC_MoveChild0,
/* 10844*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10847*/   OPC_MoveParent,
/* 10848*/   OPC_MoveParent,
/* 10849*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10850*/   OPC_EmitMergeInputChains1_0,
/* 10851*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set funcref:{ *:[funcref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$addr, funcref:{ *:[funcref] }:$src)
/* 10858*/  /*Scope*/ 23, /*->10882*/
/* 10859*/   OPC_CheckChild1Type, /*MVT::externref*/100|128,1/*228*/, 
/* 10862*/   OPC_MoveChild2,
/* 10863*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10866*/   OPC_RecordChild0, // #2 = $addr
/* 10867*/   OPC_MoveChild0,
/* 10868*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10871*/   OPC_MoveParent,
/* 10872*/   OPC_MoveParent,
/* 10873*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10874*/   OPC_EmitMergeInputChains1_0,
/* 10875*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set externref:{ *:[externref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$addr, externref:{ *:[externref] }:$src)
/* 10882*/  /*Scope*/ 24, /*->10907*/
/* 10883*/   OPC_CheckChild1Type, /*MVT::exnref*/101|128,1/*229*/, 
/* 10886*/   OPC_MoveChild2,
/* 10887*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10890*/   OPC_RecordChild0, // #2 = $addr
/* 10891*/   OPC_MoveChild0,
/* 10892*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10895*/   OPC_MoveParent,
/* 10896*/   OPC_MoveParent,
/* 10897*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 10899*/   OPC_EmitMergeInputChains1_0,
/* 10900*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set exnref:{ *:[exnref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_EXNREF (tglobaladdr:{ *:[i32] }):$addr, exnref:{ *:[exnref] }:$src)
/* 10907*/  0, /*End of Scope*/
/* 10908*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CALLSEQ_START),// ->10932
/* 10911*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_start' chained node
/* 10912*/  OPC_RecordChild1, // #1 = $amt
/* 10913*/  OPC_MoveChild1,
/* 10914*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10917*/  OPC_MoveSibling2,
/* 10918*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10921*/  OPC_RecordNode, // #2 = $amt2
/* 10922*/  OPC_MoveParent,
/* 10923*/  OPC_EmitMergeInputChains1_0,
/* 10924*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKDOWN), 0|OPFL_Chain|OPFL_GlueOutput,
                /*MVT::i32*/7, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_start (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKDOWN:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 10932*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::CALLSEQ_END),// ->10957
/* 10935*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_end' chained node
/* 10936*/  OPC_CaptureGlueInput,
/* 10937*/  OPC_RecordChild1, // #1 = $amt
/* 10938*/  OPC_MoveChild1,
/* 10939*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10942*/  OPC_MoveSibling2,
/* 10943*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10946*/  OPC_RecordNode, // #2 = $amt2
/* 10947*/  OPC_MoveParent,
/* 10948*/  OPC_EmitMergeInputChains1_0,
/* 10949*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKUP), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput,
                /*MVT::i32*/7, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_end (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKUP:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 10957*/ /*SwitchOpcode*/ 60, TARGET_VAL(WebAssemblyISD::TABLE_GET),// ->11020
/* 10960*/  OPC_RecordMemRef,
/* 10961*/  OPC_RecordNode, // #0 = 'WebAssemblyTableGet' chained node
/* 10962*/  OPC_MoveChild1,
/* 10963*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10966*/  OPC_RecordChild0, // #1 = $table
/* 10967*/  OPC_MoveChild0,
/* 10968*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10971*/  OPC_MoveParent,
/* 10972*/  OPC_MoveParent,
/* 10973*/  OPC_RecordChild2, // #2 = $idx
/* 10974*/  OPC_CheckChild2TypeI32,
/* 10975*/  OPC_SwitchType /*3 cases */, 11, /*MVT::funcref*/99|128,1/*227*/, // ->10990
/* 10979*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10980*/   OPC_EmitMergeInputChains1_0,
/* 10981*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::funcref*/99|128,1/*227*/, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[funcref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 10990*/  /*SwitchType*/ 11, /*MVT::externref*/100|128,1/*228*/, // ->11004
/* 10993*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10994*/   OPC_EmitMergeInputChains1_0,
/* 10995*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::externref*/100|128,1/*228*/, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[externref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 11004*/  /*SwitchType*/ 12, /*MVT::exnref*/101|128,1/*229*/, // ->11019
/* 11007*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 11009*/   OPC_EmitMergeInputChains1_0,
/* 11010*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::exnref*/101|128,1/*229*/, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[exnref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_EXNREF:{ *:[exnref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 11019*/  0, // EndSwitchType
/* 11020*/ /*SwitchOpcode*/ 87, TARGET_VAL(WebAssemblyISD::TABLE_SET),// ->11110
/* 11023*/  OPC_RecordMemRef,
/* 11024*/  OPC_RecordNode, // #0 = 'WebAssemblyTableSet' chained node
/* 11025*/  OPC_Scope, 59, /*->11086*/ // 2 children in Scope
/* 11027*/   OPC_MoveChild1,
/* 11028*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11031*/   OPC_RecordChild0, // #1 = $table
/* 11032*/   OPC_MoveChild0,
/* 11033*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11036*/   OPC_MoveParent,
/* 11037*/   OPC_MoveParent,
/* 11038*/   OPC_RecordChild2, // #2 = $idx
/* 11039*/   OPC_CheckChild2TypeI32,
/* 11040*/   OPC_RecordChild3, // #3 = $src
/* 11041*/   OPC_Scope, 13, /*->11056*/ // 3 children in Scope
/* 11043*/    OPC_CheckChild3Type, /*MVT::funcref*/99|128,1/*227*/, 
/* 11046*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11047*/    OPC_EmitMergeInputChains1_0,
/* 11048*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$src)
/* 11056*/   /*Scope*/ 13, /*->11070*/
/* 11057*/    OPC_CheckChild3Type, /*MVT::externref*/100|128,1/*228*/, 
/* 11060*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11061*/    OPC_EmitMergeInputChains1_0,
/* 11062*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$src)
/* 11070*/   /*Scope*/ 14, /*->11085*/
/* 11071*/    OPC_CheckChild3Type, /*MVT::exnref*/101|128,1/*229*/, 
/* 11074*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 11076*/    OPC_EmitMergeInputChains1_0,
/* 11077*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, exnref:{ *:[exnref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_EXNREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, exnref:{ *:[exnref] }:$src)
/* 11085*/   0, /*End of Scope*/
/* 11086*/  /*Scope*/ 22, /*->11109*/
/* 11087*/   OPC_RecordChild1, // #1 = $table
/* 11088*/   OPC_MoveChild1,
/* 11089*/   OPC_CheckOpcode, TARGET_VAL(ISD::MCSymbol),
/* 11092*/   OPC_MoveParent,
/* 11093*/   OPC_RecordChild2, // #2 = $idx
/* 11094*/   OPC_CheckChild2TypeI32,
/* 11095*/   OPC_RecordChild3, // #3 = $r
/* 11096*/   OPC_CheckChild3Type, /*MVT::funcref*/99|128,1/*227*/, 
/* 11099*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11100*/   OPC_EmitMergeInputChains1_0,
/* 11101*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 3/*#Ops*/, 1, 2, 3, 
             // Src: (WebAssemblyTableSet (mcsym:{ *:[iPTR] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r) - Complexity = 6
             // Dst: (TABLE_SET_FUNCREF (mcsym:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r)
/* 11109*/  0, /*End of Scope*/
/* 11110*/ /*SwitchOpcode*/ 57, TARGET_VAL(WebAssemblyISD::MEMCPY),// ->11170
/* 11113*/  OPC_RecordNode, // #0 = 'wasm_memcpy' chained node
/* 11114*/  OPC_RecordChild1, // #1 = $src_idx
/* 11115*/  OPC_MoveChild1,
/* 11116*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11119*/  OPC_CheckTypeI32,
/* 11120*/  OPC_MoveSibling2,
/* 11121*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11124*/  OPC_RecordNode, // #2 = $dst_idx
/* 11125*/  OPC_CheckTypeI32,
/* 11126*/  OPC_MoveParent,
/* 11127*/  OPC_RecordChild3, // #3 = $dst
/* 11128*/  OPC_Scope, 19, /*->11149*/ // 2 children in Scope
/* 11130*/   OPC_CheckChild3TypeI32,
/* 11131*/   OPC_RecordChild4, // #4 = $src
/* 11132*/   OPC_CheckChild4TypeI32,
/* 11133*/   OPC_RecordChild5, // #5 = $len
/* 11134*/   OPC_CheckChild5TypeI32,
/* 11135*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemoryOpt())
/* 11137*/   OPC_EmitMergeInputChains1_0,
/* 11138*/   OPC_EmitConvertToTarget1, // #6
/* 11139*/   OPC_EmitConvertToTarget2, // #7
/* 11140*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::MEMCPY_A32),
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len) - Complexity = 9
             // Dst: (MEMCPY_A32 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len)
/* 11149*/  /*Scope*/ 19, /*->11169*/
/* 11150*/   OPC_CheckChild3TypeI64,
/* 11151*/   OPC_RecordChild4, // #4 = $src
/* 11152*/   OPC_CheckChild4TypeI64,
/* 11153*/   OPC_RecordChild5, // #5 = $len
/* 11154*/   OPC_CheckChild5TypeI64,
/* 11155*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemoryOpt())
/* 11157*/   OPC_EmitMergeInputChains1_0,
/* 11158*/   OPC_EmitConvertToTarget1, // #6
/* 11159*/   OPC_EmitConvertToTarget2, // #7
/* 11160*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::MEMCPY_A64),
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len) - Complexity = 9
             // Dst: (MEMCPY_A64 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len)
/* 11169*/  0, /*End of Scope*/
/* 11170*/ /*SwitchOpcode*/ 119|128,9/*1271*/, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),// ->12445
/* 11174*/  OPC_Scope, 49, /*->11225*/ // 39 children in Scope
/* 11176*/   OPC_CheckChild0Integer, 94|128,78|128,1/*26462*/, 
/* 11180*/   OPC_RecordChild1, // #0 = $src
/* 11181*/   OPC_Scope, 20, /*->11203*/ // 2 children in Scope
/* 11183*/    OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 11185*/    OPC_SwitchType /*2 cases */, 6, /*MVT::i32*/7, // ->11194
/* 11188*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 13231:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 11194*/    /*SwitchType*/ 6, /*MVT::i64*/8, // ->11202
/* 11196*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 13231:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 11202*/    0, // EndSwitchType
/* 11203*/   /*Scope*/ 20, /*->11224*/
/* 11204*/    OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 11206*/    OPC_SwitchType /*2 cases */, 6, /*MVT::i32*/7, // ->11215
/* 11209*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 13231:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 11215*/    /*SwitchType*/ 6, /*MVT::i64*/8, // ->11223
/* 11217*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 13231:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 11223*/    0, // EndSwitchType
/* 11224*/   0, /*End of Scope*/
/* 11225*/  /*Scope*/ 49, /*->11275*/
/* 11226*/   OPC_CheckChild0Integer, 96|128,78|128,1/*26464*/, 
/* 11230*/   OPC_RecordChild1, // #0 = $src
/* 11231*/   OPC_Scope, 20, /*->11253*/ // 2 children in Scope
/* 11233*/    OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 11235*/    OPC_SwitchType /*2 cases */, 6, /*MVT::i32*/7, // ->11244
/* 11238*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 13232:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 11244*/    /*SwitchType*/ 6, /*MVT::i64*/8, // ->11252
/* 11246*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 13232:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 11252*/    0, // EndSwitchType
/* 11253*/   /*Scope*/ 20, /*->11274*/
/* 11254*/    OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 11256*/    OPC_SwitchType /*2 cases */, 6, /*MVT::i32*/7, // ->11265
/* 11259*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 13232:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 11265*/    /*SwitchType*/ 6, /*MVT::i64*/8, // ->11273
/* 11267*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 13232:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 11273*/    0, // EndSwitchType
/* 11274*/   0, /*End of Scope*/
/* 11275*/  /*Scope*/ 43, /*->11319*/
/* 11276*/   OPC_CheckChild0Integer, 82|128,77|128,1/*26322*/, 
/* 11280*/   OPC_RecordChild1, // #0 = $vec
/* 11281*/   OPC_Scope, 8, /*->11291*/ // 4 children in Scope
/* 11283*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11285*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 13161:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11291*/   /*Scope*/ 8, /*->11300*/
/* 11292*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11294*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 13161:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11300*/   /*Scope*/ 8, /*->11309*/
/* 11301*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11303*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 13161:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11309*/   /*Scope*/ 8, /*->11318*/
/* 11310*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 11312*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 13161:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11318*/   0, /*End of Scope*/
/* 11319*/  /*Scope*/ 47, /*->11367*/
/* 11320*/   OPC_CheckChild0Integer, 80|128,77|128,1/*26320*/, 
/* 11324*/   OPC_RecordChild1, // #0 = $vec
/* 11325*/   OPC_Scope, 9, /*->11336*/ // 4 children in Scope
/* 11327*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11329*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11330*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 13160:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11336*/   /*Scope*/ 9, /*->11346*/
/* 11337*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11339*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11340*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 13160:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11346*/   /*Scope*/ 9, /*->11356*/
/* 11347*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11349*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11350*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 13160:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11356*/   /*Scope*/ 9, /*->11366*/
/* 11357*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 11359*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11360*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 13160:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11366*/   0, /*End of Scope*/
/* 11367*/  /*Scope*/ 47, /*->11415*/
/* 11368*/   OPC_CheckChild0Integer, 86|128,77|128,1/*26326*/, 
/* 11372*/   OPC_RecordChild1, // #0 = $vec
/* 11373*/   OPC_Scope, 9, /*->11384*/ // 4 children in Scope
/* 11375*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11377*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11378*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I8x16),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 13163:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11384*/   /*Scope*/ 9, /*->11394*/
/* 11385*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11387*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11388*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I16x8),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 13163:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11394*/   /*Scope*/ 9, /*->11404*/
/* 11395*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11397*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11398*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I32x4),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 13163:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11404*/   /*Scope*/ 9, /*->11414*/
/* 11405*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 11407*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11408*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I64x2),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 13163:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11414*/   0, /*End of Scope*/
/* 11415*/  /*Scope*/ 11, /*->11427*/
/* 11416*/   OPC_CheckChild0Integer, 12|128,78|128,1/*26380*/, 
/* 11420*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11421*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_FUNCREF),
                 /*MVT::funcref*/99|128,1/*227*/, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[funcref] } 13190:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_FUNCREF:{ *:[funcref] })
/* 11427*/  /*Scope*/ 12, /*->11440*/
/* 11428*/   OPC_CheckChild0Integer, 6|128,78|128,1/*26374*/, 
/* 11432*/   OPC_RecordChild1, // #0 = $ref
/* 11433*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11434*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_FUNCREF),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 13187:{ *:[iPTR] }, FUNCREF:{ *:[funcref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_FUNCREF:{ *:[i32] } FUNCREF:{ *:[funcref] }:$ref)
/* 11440*/  /*Scope*/ 11, /*->11452*/
/* 11441*/   OPC_CheckChild0Integer, 10|128,78|128,1/*26378*/, 
/* 11445*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11446*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_EXTERNREF),
                 /*MVT::externref*/100|128,1/*228*/, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[externref] } 13189:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_EXTERNREF:{ *:[externref] })
/* 11452*/  /*Scope*/ 12, /*->11465*/
/* 11453*/   OPC_CheckChild0Integer, 4|128,78|128,1/*26372*/, 
/* 11457*/   OPC_RecordChild1, // #0 = $ref
/* 11458*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11459*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_EXTERNREF),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 13186:{ *:[iPTR] }, EXTERNREF:{ *:[externref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_EXTERNREF:{ *:[i32] } EXTERNREF:{ *:[externref] }:$ref)
/* 11465*/  /*Scope*/ 11, /*->11477*/
/* 11466*/   OPC_CheckChild0Integer, 8|128,78|128,1/*26376*/, 
/* 11470*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11471*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_EXNREF),
                 /*MVT::exnref*/101|128,1/*229*/, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[exnref] } 13188:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_EXNREF:{ *:[exnref] })
/* 11477*/  /*Scope*/ 12, /*->11490*/
/* 11478*/   OPC_CheckChild0Integer, 2|128,78|128,1/*26370*/, 
/* 11482*/   OPC_RecordChild1, // #0 = $ref
/* 11483*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11484*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_EXNREF),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 13185:{ *:[iPTR] }, EXNREF:{ *:[exnref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_EXNREF:{ *:[i32] } EXNREF:{ *:[exnref] }:$ref)
/* 11490*/  /*Scope*/ 23, /*->11514*/
/* 11491*/   OPC_CheckChild0Integer, 98|128,77|128,1/*26338*/, 
/* 11495*/   OPC_RecordChild1, // #0 = $vec
/* 11496*/   OPC_RecordChild2, // #1 = $idx
/* 11497*/   OPC_MoveChild2,
/* 11498*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11501*/   OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/* 11503*/   OPC_MoveParent,
/* 11504*/   OPC_CheckPatternPredicate, 16, // (Subtarget->hasFP16())
/* 11506*/   OPC_EmitConvertToTarget1, // #2
/* 11507*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F16x8),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 2, 
             // Src: (intrinsic_wo_chain:{ *:[f32] } 13169:{ *:[iPTR] }, V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 12
             // Dst: (EXTRACT_LANE_F16x8:{ *:[f32] } V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 11514*/  /*Scope*/ 13, /*->11528*/
/* 11515*/   OPC_CheckChild0Integer, 52|128,78|128,1/*26420*/, 
/* 11519*/   OPC_RecordChild1, // #0 = $src
/* 11520*/   OPC_RecordChild2, // #1 = $mask
/* 11521*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SWIZZLE),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 13210:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (SWIZZLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$src, ?:{ *:[v16i8] }:$mask)
/* 11528*/  /*Scope*/ 120, /*->11649*/
/* 11529*/   OPC_CheckChild0Integer, 88|128,77|128,1/*26328*/, 
/* 11533*/   OPC_RecordChild1, // #0 = $v1
/* 11534*/   OPC_SwitchType /*6 cases */, 16, /*MVT::v16i8*/39, // ->11553
/* 11537*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11539*/    OPC_RecordChild2, // #1 = $v2
/* 11540*/    OPC_CheckChild2Type, /*MVT::v16i8*/39, 
/* 11542*/    OPC_RecordChild3, // #2 = $c
/* 11543*/    OPC_CheckChild3Type, /*MVT::v16i8*/39, 
/* 11545*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 13164:{ *:[iPTR] }, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 11553*/   /*SwitchType*/ 16, /*MVT::v8i16*/50, // ->11571
/* 11555*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11557*/    OPC_RecordChild2, // #1 = $v2
/* 11558*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11560*/    OPC_RecordChild3, // #2 = $c
/* 11561*/    OPC_CheckChild3Type, /*MVT::v8i16*/50, 
/* 11563*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 13164:{ *:[iPTR] }, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 11571*/   /*SwitchType*/ 16, /*MVT::v4i32*/60, // ->11589
/* 11573*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11575*/    OPC_RecordChild2, // #1 = $v2
/* 11576*/    OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 11578*/    OPC_RecordChild3, // #2 = $c
/* 11579*/    OPC_CheckChild3Type, /*MVT::v4i32*/60, 
/* 11581*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 13164:{ *:[iPTR] }, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 11589*/   /*SwitchType*/ 16, /*MVT::v2i64*/78, // ->11607
/* 11591*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 11593*/    OPC_RecordChild2, // #1 = $v2
/* 11594*/    OPC_CheckChild2Type, /*MVT::v2i64*/78, 
/* 11596*/    OPC_RecordChild3, // #2 = $c
/* 11597*/    OPC_CheckChild3Type, /*MVT::v2i64*/78, 
/* 11599*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 13164:{ *:[iPTR] }, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 11607*/   /*SwitchType*/ 16, /*MVT::v4f32*/111, // ->11625
/* 11609*/    OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 11611*/    OPC_RecordChild2, // #1 = $v2
/* 11612*/    OPC_CheckChild2Type, /*MVT::v4f32*/111, 
/* 11614*/    OPC_RecordChild3, // #2 = $c
/* 11615*/    OPC_CheckChild3Type, /*MVT::v4f32*/111, 
/* 11617*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4f32*/111, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 13164:{ *:[iPTR] }, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4f32] }:$c)
/* 11625*/   /*SwitchType*/ 20, /*MVT::v2f64*/1|128,1/*129*/, // ->11648
/* 11628*/    OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 11631*/    OPC_RecordChild2, // #1 = $v2
/* 11632*/    OPC_CheckChild2Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 11635*/    OPC_RecordChild3, // #2 = $c
/* 11636*/    OPC_CheckChild3Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 11639*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 13164:{ *:[iPTR] }, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2f64] }:$c)
/* 11648*/   0, // EndSwitchType
/* 11649*/  /*Scope*/ 37, /*->11687*/
/* 11650*/   OPC_CheckChild0Integer, 84|128,77|128,1/*26324*/, 
/* 11654*/   OPC_RecordChild1, // #0 = $lhs
/* 11655*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v16i8*/39, // ->11671
/* 11658*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11660*/    OPC_RecordChild2, // #1 = $rhs
/* 11661*/    OPC_CheckChild2Type, /*MVT::v16i8*/39, 
/* 11663*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11664*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 13162:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11671*/   /*SwitchType*/ 13, /*MVT::v8i16*/50, // ->11686
/* 11673*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11675*/    OPC_RecordChild2, // #1 = $rhs
/* 11676*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11678*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11679*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 13162:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11686*/   0, // EndSwitchType
/* 11687*/  /*Scope*/ 14, /*->11702*/
/* 11688*/   OPC_CheckChild0Integer, 92|128,77|128,1/*26332*/, 
/* 11692*/   OPC_RecordChild1, // #0 = $lhs
/* 11693*/   OPC_RecordChild2, // #1 = $rhs
/* 11694*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11695*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DOT),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 13166:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (DOT:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11702*/  /*Scope*/ 37, /*->11740*/
/* 11703*/   OPC_CheckChild0Integer, 120|128,77|128,1/*26360*/, 
/* 11707*/   OPC_RecordChild1, // #0 = $low
/* 11708*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v16i8*/39, // ->11724
/* 11711*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11713*/    OPC_RecordChild2, // #1 = $high
/* 11714*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11716*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11717*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_S_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 13180:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 11724*/   /*SwitchType*/ 13, /*MVT::v8i16*/50, // ->11739
/* 11726*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11728*/    OPC_RecordChild2, // #1 = $high
/* 11729*/    OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 11731*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11732*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_S_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 13180:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 11739*/   0, // EndSwitchType
/* 11740*/  /*Scope*/ 37, /*->11778*/
/* 11741*/   OPC_CheckChild0Integer, 122|128,77|128,1/*26362*/, 
/* 11745*/   OPC_RecordChild1, // #0 = $low
/* 11746*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v16i8*/39, // ->11762
/* 11749*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11751*/    OPC_RecordChild2, // #1 = $high
/* 11752*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11754*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11755*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 13181:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 11762*/   /*SwitchType*/ 13, /*MVT::v8i16*/50, // ->11777
/* 11764*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11766*/    OPC_RecordChild2, // #1 = $high
/* 11767*/    OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 11769*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11770*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 13181:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 11777*/   0, // EndSwitchType
/* 11778*/  /*Scope*/ 29, /*->11808*/
/* 11779*/   OPC_CheckChild0Integer, 94|128,77|128,1/*26334*/, 
/* 11783*/   OPC_RecordChild1, // #0 = $vec
/* 11784*/   OPC_SwitchType /*2 cases */, 9, /*MVT::v8i16*/50, // ->11796
/* 11787*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11789*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11790*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 13167:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 11796*/   /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->11807
/* 11798*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11800*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11801*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 13167:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 11807*/   0, // EndSwitchType
/* 11808*/  /*Scope*/ 29, /*->11838*/
/* 11809*/   OPC_CheckChild0Integer, 96|128,77|128,1/*26336*/, 
/* 11813*/   OPC_RecordChild1, // #0 = $vec
/* 11814*/   OPC_SwitchType /*2 cases */, 9, /*MVT::v8i16*/50, // ->11826
/* 11817*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11819*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11820*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 13168:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 11826*/   /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->11837
/* 11828*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11830*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11831*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 13168:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 11837*/   0, // EndSwitchType
/* 11838*/  /*Scope*/ 14, /*->11853*/
/* 11839*/   OPC_CheckChild0Integer, 0|128,78|128,1/*26368*/, 
/* 11843*/   OPC_RecordChild1, // #0 = $lhs
/* 11844*/   OPC_RecordChild2, // #1 = $rhs
/* 11845*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11846*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::Q15MULR_SAT_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 13184:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (Q15MULR_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11853*/  /*Scope*/ 14, /*->11868*/
/* 11854*/   OPC_CheckChild0Integer, 32|128,78|128,1/*26400*/, 
/* 11858*/   OPC_RecordChild1, // #0 = $src
/* 11859*/   OPC_RecordChild2, // #1 = $mask
/* 11860*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11861*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_SWIZZLE),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 13200:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (RELAXED_SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 11868*/  /*Scope*/ 12, /*->11881*/
/* 11869*/   OPC_CheckChild0Integer, 34|128,78|128,1/*26402*/, 
/* 11873*/   OPC_RecordChild1, // #0 = $vec
/* 11874*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11875*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 13201:{ *:[iPTR] }, V128:{ *:[v4f32] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_signed_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 11881*/  /*Scope*/ 12, /*->11894*/
/* 11882*/   OPC_CheckChild0Integer, 38|128,78|128,1/*26406*/, 
/* 11886*/   OPC_RecordChild1, // #0 = $vec
/* 11887*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11888*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 13203:{ *:[iPTR] }, V128:{ *:[v4f32] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 11894*/  /*Scope*/ 12, /*->11907*/
/* 11895*/   OPC_CheckChild0Integer, 36|128,78|128,1/*26404*/, 
/* 11899*/   OPC_RecordChild1, // #0 = $vec
/* 11900*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11901*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_zero_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 13202:{ *:[iPTR] }, V128:{ *:[v2f64] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_signed_zero_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 11907*/  /*Scope*/ 12, /*->11920*/
/* 11908*/   OPC_CheckChild0Integer, 40|128,78|128,1/*26408*/, 
/* 11912*/   OPC_RecordChild1, // #0 = $vec
/* 11913*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11914*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_zero_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 13204:{ *:[iPTR] }, V128:{ *:[v2f64] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_unsigned_zero_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 11920*/  /*Scope*/ 83, /*->12004*/
/* 11921*/   OPC_CheckChild0Integer, 20|128,78|128,1/*26388*/, 
/* 11925*/   OPC_RecordChild1, // #0 = $a
/* 11926*/   OPC_SwitchType /*4 cases */, 17, /*MVT::v16i8*/39, // ->11946
/* 11929*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11931*/    OPC_RecordChild2, // #1 = $b
/* 11932*/    OPC_CheckChild2Type, /*MVT::v16i8*/39, 
/* 11934*/    OPC_RecordChild3, // #2 = $c
/* 11935*/    OPC_CheckChild3Type, /*MVT::v16i8*/39, 
/* 11937*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11938*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I8x16),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 13194:{ *:[iPTR] }, V128:{ *:[v16i8] }:$a, V128:{ *:[v16i8] }:$b, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$a, V128:{ *:[v16i8] }:$b, V128:{ *:[v16i8] }:$c)
/* 11946*/   /*SwitchType*/ 17, /*MVT::v8i16*/50, // ->11965
/* 11948*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11950*/    OPC_RecordChild2, // #1 = $b
/* 11951*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11953*/    OPC_RecordChild3, // #2 = $c
/* 11954*/    OPC_CheckChild3Type, /*MVT::v8i16*/50, 
/* 11956*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11957*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I16x8),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 13194:{ *:[iPTR] }, V128:{ *:[v8i16] }:$a, V128:{ *:[v8i16] }:$b, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$a, V128:{ *:[v8i16] }:$b, V128:{ *:[v8i16] }:$c)
/* 11965*/   /*SwitchType*/ 17, /*MVT::v4i32*/60, // ->11984
/* 11967*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11969*/    OPC_RecordChild2, // #1 = $b
/* 11970*/    OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 11972*/    OPC_RecordChild3, // #2 = $c
/* 11973*/    OPC_CheckChild3Type, /*MVT::v4i32*/60, 
/* 11975*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11976*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I32x4),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 13194:{ *:[iPTR] }, V128:{ *:[v4i32] }:$a, V128:{ *:[v4i32] }:$b, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$a, V128:{ *:[v4i32] }:$b, V128:{ *:[v4i32] }:$c)
/* 11984*/   /*SwitchType*/ 17, /*MVT::v2i64*/78, // ->12003
/* 11986*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 11988*/    OPC_RecordChild2, // #1 = $b
/* 11989*/    OPC_CheckChild2Type, /*MVT::v2i64*/78, 
/* 11991*/    OPC_RecordChild3, // #2 = $c
/* 11992*/    OPC_CheckChild3Type, /*MVT::v2i64*/78, 
/* 11994*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11995*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I64x2),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 13194:{ *:[iPTR] }, V128:{ *:[v2i64] }:$a, V128:{ *:[v2i64] }:$b, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$a, V128:{ *:[v2i64] }:$b, V128:{ *:[v2i64] }:$c)
/* 12003*/   0, // EndSwitchType
/* 12004*/  /*Scope*/ 14, /*->12019*/
/* 12005*/   OPC_CheckChild0Integer, 30|128,78|128,1/*26398*/, 
/* 12009*/   OPC_RecordChild1, // #0 = $lhs
/* 12010*/   OPC_RecordChild2, // #1 = $rhs
/* 12011*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12012*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_Q15MULR_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 13199:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (RELAXED_Q15MULR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 12019*/  /*Scope*/ 14, /*->12034*/
/* 12020*/   OPC_CheckChild0Integer, 18|128,78|128,1/*26386*/, 
/* 12024*/   OPC_RecordChild1, // #0 = $lhs
/* 12025*/   OPC_RecordChild2, // #1 = $rhs
/* 12026*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12027*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 13193:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
             // Dst: (RELAXED_DOT:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 12034*/  /*Scope*/ 16, /*->12051*/
/* 12035*/   OPC_CheckChild0Integer, 16|128,78|128,1/*26384*/, 
/* 12039*/   OPC_RecordChild1, // #0 = $lhs
/* 12040*/   OPC_RecordChild2, // #1 = $rhs
/* 12041*/   OPC_RecordChild3, // #2 = $acc
/* 12042*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12043*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT_ADD),
                 /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 13192:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, V128:{ *:[v4i32] }:$acc) - Complexity = 8
             // Dst: (RELAXED_DOT_ADD:{ *:[v4i32] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, V128:{ *:[v4i32] }:$acc)
/* 12051*/  /*Scope*/ 25, /*->12077*/
/* 12052*/   OPC_CheckChild0Integer, 42|128,78|128,1/*26410*/, 
/* 12056*/   OPC_RecordChild1, // #0 = $vec
/* 12057*/   OPC_RecordChild2, // #1 = $idx
/* 12058*/   OPC_MoveChild2,
/* 12059*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12062*/   OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/* 12064*/   OPC_MoveParent,
/* 12065*/   OPC_RecordChild3, // #2 = $x
/* 12066*/   OPC_CheckPatternPredicate, 16, // (Subtarget->hasFP16())
/* 12068*/   OPC_EmitConvertToTarget1, // #3
/* 12069*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F16x8),
                 /*MVT::v8f16*/92, 3/*#Ops*/, 0, 3, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v8f16] } 13205:{ *:[iPTR] }, V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx, F32:{ *:[f32] }:$x) - Complexity = 12
             // Dst: (REPLACE_LANE_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] }):$idx, F32:{ *:[f32] }:$x)
/* 12077*/  /*Scope*/ 13, /*->12091*/
/* 12078*/   OPC_CheckChild0Integer, 48|128,78|128,1/*26416*/, 
/* 12082*/   OPC_RecordChild1, // #0 = $x
/* 12083*/   OPC_CheckPatternPredicate, 16, // (Subtarget->hasFP16())
/* 12085*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v8f16] } 13208:{ *:[iPTR] }, F32:{ *:[f32] }:$x) - Complexity = 8
             // Dst: (SPLAT_F16x8:{ *:[v8f16] } F32:{ *:[f32] }:$x)
/* 12091*/  /*Scope*/ 53, /*->12145*/
/* 12092*/   OPC_CheckChild0Integer, 126|128,77|128,1/*26366*/, 
/* 12096*/   OPC_RecordChild1, // #0 = $lhs
/* 12097*/   OPC_SwitchType /*3 cases */, 12, /*MVT::v4f32*/111, // ->12112
/* 12100*/    OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 12102*/    OPC_RecordChild2, // #1 = $rhs
/* 12103*/    OPC_CheckChild2Type, /*MVT::v4f32*/111, 
/* 12105*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                  /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 13183:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12112*/   /*SwitchType*/ 15, /*MVT::v2f64*/1|128,1/*129*/, // ->12130
/* 12115*/    OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12118*/    OPC_RecordChild2, // #1 = $rhs
/* 12119*/    OPC_CheckChild2Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12122*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 13183:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12130*/   /*SwitchType*/ 12, /*MVT::v8f16*/92, // ->12144
/* 12132*/    OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 12134*/    OPC_RecordChild2, // #1 = $rhs
/* 12135*/    OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 12137*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                  /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 13183:{ *:[iPTR] }, V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 12144*/   0, // EndSwitchType
/* 12145*/  /*Scope*/ 53, /*->12199*/
/* 12146*/   OPC_CheckChild0Integer, 124|128,77|128,1/*26364*/, 
/* 12150*/   OPC_RecordChild1, // #0 = $lhs
/* 12151*/   OPC_SwitchType /*3 cases */, 12, /*MVT::v4f32*/111, // ->12166
/* 12154*/    OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 12156*/    OPC_RecordChild2, // #1 = $rhs
/* 12157*/    OPC_CheckChild2Type, /*MVT::v4f32*/111, 
/* 12159*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                  /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 13182:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12166*/   /*SwitchType*/ 15, /*MVT::v2f64*/1|128,1/*129*/, // ->12184
/* 12169*/    OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12172*/    OPC_RecordChild2, // #1 = $rhs
/* 12173*/    OPC_CheckChild2Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12176*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 13182:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12184*/   /*SwitchType*/ 12, /*MVT::v8f16*/92, // ->12198
/* 12186*/    OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 12188*/    OPC_RecordChild2, // #1 = $rhs
/* 12189*/    OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 12191*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                  /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 13182:{ *:[iPTR] }, V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 12198*/   0, // EndSwitchType
/* 12199*/  /*Scope*/ 71, /*->12271*/
/* 12200*/   OPC_CheckChild0Integer, 22|128,78|128,1/*26390*/, 
/* 12204*/   OPC_RecordChild1, // #0 = $a
/* 12205*/   OPC_SwitchType /*3 cases */, 18, /*MVT::v4f32*/111, // ->12226
/* 12208*/    OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 12210*/    OPC_RecordChild2, // #1 = $b
/* 12211*/    OPC_CheckChild2Type, /*MVT::v4f32*/111, 
/* 12213*/    OPC_RecordChild3, // #2 = $c
/* 12214*/    OPC_CheckChild3Type, /*MVT::v4f32*/111, 
/* 12216*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12218*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F32x4),
                  /*MVT::v4f32*/111, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 13195:{ *:[iPTR] }, V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (MADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c)
/* 12226*/   /*SwitchType*/ 22, /*MVT::v2f64*/1|128,1/*129*/, // ->12251
/* 12229*/    OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12232*/    OPC_RecordChild2, // #1 = $b
/* 12233*/    OPC_CheckChild2Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12236*/    OPC_RecordChild3, // #2 = $c
/* 12237*/    OPC_CheckChild3Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12240*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12242*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 13195:{ *:[iPTR] }, V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (MADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c)
/* 12251*/   /*SwitchType*/ 17, /*MVT::v8f16*/92, // ->12270
/* 12253*/    OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 12255*/    OPC_RecordChild2, // #1 = $b
/* 12256*/    OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 12258*/    OPC_RecordChild3, // #2 = $c
/* 12259*/    OPC_CheckChild3Type, /*MVT::v8f16*/92, 
/* 12261*/    OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 12262*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F16x8),
                  /*MVT::v8f16*/92, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 13195:{ *:[iPTR] }, V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c) - Complexity = 8
              // Dst: (MADD_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c)
/* 12270*/   0, // EndSwitchType
/* 12271*/  /*Scope*/ 71, /*->12343*/
/* 12272*/   OPC_CheckChild0Integer, 28|128,78|128,1/*26396*/, 
/* 12276*/   OPC_RecordChild1, // #0 = $a
/* 12277*/   OPC_SwitchType /*3 cases */, 18, /*MVT::v4f32*/111, // ->12298
/* 12280*/    OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 12282*/    OPC_RecordChild2, // #1 = $b
/* 12283*/    OPC_CheckChild2Type, /*MVT::v4f32*/111, 
/* 12285*/    OPC_RecordChild3, // #2 = $c
/* 12286*/    OPC_CheckChild3Type, /*MVT::v4f32*/111, 
/* 12288*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12290*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F32x4),
                  /*MVT::v4f32*/111, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 13198:{ *:[iPTR] }, V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (NMADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c)
/* 12298*/   /*SwitchType*/ 22, /*MVT::v2f64*/1|128,1/*129*/, // ->12323
/* 12301*/    OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12304*/    OPC_RecordChild2, // #1 = $b
/* 12305*/    OPC_CheckChild2Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12308*/    OPC_RecordChild3, // #2 = $c
/* 12309*/    OPC_CheckChild3Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12312*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12314*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 13198:{ *:[iPTR] }, V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (NMADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c)
/* 12323*/   /*SwitchType*/ 17, /*MVT::v8f16*/92, // ->12342
/* 12325*/    OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 12327*/    OPC_RecordChild2, // #1 = $b
/* 12328*/    OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 12330*/    OPC_RecordChild3, // #2 = $c
/* 12331*/    OPC_CheckChild3Type, /*MVT::v8f16*/92, 
/* 12333*/    OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 12334*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F16x8),
                  /*MVT::v8f16*/92, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 13198:{ *:[iPTR] }, V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c) - Complexity = 8
              // Dst: (NMADD_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c)
/* 12342*/   0, // EndSwitchType
/* 12343*/  /*Scope*/ 41, /*->12385*/
/* 12344*/   OPC_CheckChild0Integer, 26|128,78|128,1/*26394*/, 
/* 12348*/   OPC_RecordChild1, // #0 = $lhs
/* 12349*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v4f32*/111, // ->12365
/* 12352*/    OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 12354*/    OPC_RecordChild2, // #1 = $rhs
/* 12355*/    OPC_CheckChild2Type, /*MVT::v4f32*/111, 
/* 12357*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12358*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F32x4),
                  /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 13197:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12365*/   /*SwitchType*/ 16, /*MVT::v2f64*/1|128,1/*129*/, // ->12384
/* 12368*/    OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12371*/    OPC_RecordChild2, // #1 = $rhs
/* 12372*/    OPC_CheckChild2Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12375*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12376*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 13197:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12384*/   0, // EndSwitchType
/* 12385*/  /*Scope*/ 41, /*->12427*/
/* 12386*/   OPC_CheckChild0Integer, 24|128,78|128,1/*26392*/, 
/* 12390*/   OPC_RecordChild1, // #0 = $lhs
/* 12391*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v4f32*/111, // ->12407
/* 12394*/    OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 12396*/    OPC_RecordChild2, // #1 = $rhs
/* 12397*/    OPC_CheckChild2Type, /*MVT::v4f32*/111, 
/* 12399*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12400*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F32x4),
                  /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 13196:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12407*/   /*SwitchType*/ 16, /*MVT::v2f64*/1|128,1/*129*/, // ->12426
/* 12410*/    OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12413*/    OPC_RecordChild2, // #1 = $rhs
/* 12414*/    OPC_CheckChild2Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12417*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12418*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 13196:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12426*/   0, // EndSwitchType
/* 12427*/  /*Scope*/ 16, /*->12444*/
/* 12428*/   OPC_CheckChild0Integer, 14|128,78|128,1/*26382*/, 
/* 12432*/   OPC_RecordChild1, // #0 = $lhs
/* 12433*/   OPC_RecordChild2, // #1 = $rhs
/* 12434*/   OPC_RecordChild3, // #2 = $acc
/* 12435*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12436*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT_BFLOAT),
                 /*MVT::v4f32*/111, 3/*#Ops*/, 0, 1, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v4f32] } 13191:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, V128:{ *:[v4f32] }:$acc) - Complexity = 8
             // Dst: (RELAXED_DOT_BFLOAT:{ *:[v4f32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, V128:{ *:[v4f32] }:$acc)
/* 12444*/  0, /*End of Scope*/
/* 12445*/ /*SwitchOpcode*/ 4|128,1/*132*/, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),// ->12581
/* 12449*/  OPC_RecordChild0, // #0 = $vec
/* 12450*/  OPC_Scope, 20, /*->12472*/ // 6 children in Scope
/* 12452*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 12454*/   OPC_RecordChild1, // #1 = $idx
/* 12455*/   OPC_MoveChild1,
/* 12456*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12459*/   OPC_CheckPredicate, 18, // Predicate_LaneIdx16
/* 12461*/   OPC_CheckTypeI32,
/* 12462*/   OPC_MoveParent,
/* 12463*/   OPC_CheckTypeI32,
/* 12464*/   OPC_EmitConvertToTarget1, // #2
/* 12465*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12472*/  /*Scope*/ 20, /*->12493*/
/* 12473*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 12475*/   OPC_RecordChild1, // #1 = $idx
/* 12476*/   OPC_MoveChild1,
/* 12477*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12480*/   OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/* 12482*/   OPC_CheckTypeI32,
/* 12483*/   OPC_MoveParent,
/* 12484*/   OPC_CheckTypeI32,
/* 12485*/   OPC_EmitConvertToTarget1, // #2
/* 12486*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12493*/  /*Scope*/ 20, /*->12514*/
/* 12494*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 12496*/   OPC_RecordChild1, // #1 = $idx
/* 12497*/   OPC_MoveChild1,
/* 12498*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12501*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 12503*/   OPC_CheckTypeI32,
/* 12504*/   OPC_MoveParent,
/* 12505*/   OPC_CheckTypeI32,
/* 12506*/   OPC_EmitConvertToTarget1, // #2
/* 12507*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I32x4),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12514*/  /*Scope*/ 20, /*->12535*/
/* 12515*/   OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 12517*/   OPC_RecordChild1, // #1 = $idx
/* 12518*/   OPC_MoveChild1,
/* 12519*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12522*/   OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 12524*/   OPC_CheckTypeI32,
/* 12525*/   OPC_MoveParent,
/* 12526*/   OPC_CheckTypeI64,
/* 12527*/   OPC_EmitConvertToTarget1, // #2
/* 12528*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I64x2:{ *:[i64] } ?:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12535*/  /*Scope*/ 21, /*->12557*/
/* 12536*/   OPC_CheckChild0Type, /*MVT::v4f32*/111, 
/* 12538*/   OPC_RecordChild1, // #1 = $idx
/* 12539*/   OPC_MoveChild1,
/* 12540*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12543*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 12545*/   OPC_CheckTypeI32,
/* 12546*/   OPC_MoveParent,
/* 12547*/   OPC_CheckType, /*MVT::f32*/12, 
/* 12549*/   OPC_EmitConvertToTarget1, // #2
/* 12550*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F32x4),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F32x4:{ *:[f32] } ?:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12557*/  /*Scope*/ 22, /*->12580*/
/* 12558*/   OPC_CheckChild0Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12561*/   OPC_RecordChild1, // #1 = $idx
/* 12562*/   OPC_MoveChild1,
/* 12563*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12566*/   OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 12568*/   OPC_CheckTypeI32,
/* 12569*/   OPC_MoveParent,
/* 12570*/   OPC_CheckType, /*MVT::f64*/13, 
/* 12572*/   OPC_EmitConvertToTarget1, // #2
/* 12573*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F64x2),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F64x2:{ *:[f64] } ?:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12580*/  0, /*End of Scope*/
/* 12581*/ /*SwitchOpcode*/ 0|128,1/*128*/, TARGET_VAL(WebAssemblyISD::ARGUMENT),// ->12713
/* 12585*/  OPC_RecordChild0, // #0 = $argno
/* 12586*/  OPC_MoveChild0,
/* 12587*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12590*/  OPC_MoveParent,
/* 12591*/  OPC_SwitchType /*14 cases */, 6, /*MVT::i32*/7, // ->12600
/* 12594*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_i32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i32:{ *:[i32] } (timm:{ *:[i32] }):$argno)
/* 12600*/  /*SwitchType*/ 6, /*MVT::i64*/8, // ->12608
/* 12602*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_i64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i64:{ *:[i64] } (timm:{ *:[i32] }):$argno)
/* 12608*/  /*SwitchType*/ 7, /*MVT::funcref*/99|128,1/*227*/, // ->12618
/* 12611*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_funcref),
                 /*MVT::funcref*/99|128,1/*227*/, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[funcref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_funcref:{ *:[funcref] } (timm:{ *:[i32] }):$argno)
/* 12618*/  /*SwitchType*/ 7, /*MVT::externref*/100|128,1/*228*/, // ->12628
/* 12621*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_externref),
                 /*MVT::externref*/100|128,1/*228*/, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[externref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_externref:{ *:[externref] } (timm:{ *:[i32] }):$argno)
/* 12628*/  /*SwitchType*/ 7, /*MVT::exnref*/101|128,1/*229*/, // ->12638
/* 12631*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_exnref),
                 /*MVT::exnref*/101|128,1/*229*/, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[exnref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_exnref:{ *:[exnref] } (timm:{ *:[i32] }):$argno)
/* 12638*/  /*SwitchType*/ 6, /*MVT::f32*/12, // ->12646
/* 12640*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_f32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f32:{ *:[f32] } (timm:{ *:[i32] }):$argno)
/* 12646*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->12654
/* 12648*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_f64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f64:{ *:[f64] } (timm:{ *:[i32] }):$argno)
/* 12654*/  /*SwitchType*/ 6, /*MVT::v16i8*/39, // ->12662
/* 12656*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v16i8),
                 /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v16i8] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v16i8:{ *:[v16i8] } (timm:{ *:[i32] }):$argno)
/* 12662*/  /*SwitchType*/ 6, /*MVT::v8i16*/50, // ->12670
/* 12664*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v8i16),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v8i16] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v8i16:{ *:[v8i16] } (timm:{ *:[i32] }):$argno)
/* 12670*/  /*SwitchType*/ 6, /*MVT::v4i32*/60, // ->12678
/* 12672*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v4i32),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4i32:{ *:[v4i32] } (timm:{ *:[i32] }):$argno)
/* 12678*/  /*SwitchType*/ 6, /*MVT::v2i64*/78, // ->12686
/* 12680*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v2i64),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2i64:{ *:[v2i64] } (timm:{ *:[i32] }):$argno)
/* 12686*/  /*SwitchType*/ 6, /*MVT::v4f32*/111, // ->12694
/* 12688*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v4f32),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4f32:{ *:[v4f32] } (timm:{ *:[i32] }):$argno)
/* 12694*/  /*SwitchType*/ 7, /*MVT::v2f64*/1|128,1/*129*/, // ->12704
/* 12697*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v2f64),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2f64:{ *:[v2f64] } (timm:{ *:[i32] }):$argno)
/* 12704*/  /*SwitchType*/ 6, /*MVT::v8f16*/92, // ->12712
/* 12706*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v8f16),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v8f16] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v8f16:{ *:[v8f16] } (timm:{ *:[i32] }):$argno)
/* 12712*/  0, // EndSwitchType
/* 12713*/ /*SwitchOpcode*/ 26|128,1/*154*/, TARGET_VAL(WebAssemblyISD::LOCAL_GET),// ->12871
/* 12717*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_get' chained node
/* 12718*/  OPC_RecordChild1, // #1 = $local
/* 12719*/  OPC_MoveChild1,
/* 12720*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12723*/  OPC_MoveParent,
/* 12724*/  OPC_SwitchType /*14 cases */, 7, /*MVT::i32*/7, // ->12734
/* 12727*/   OPC_EmitMergeInputChains1_0,
/* 12728*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I32:{ *:[i32] } (timm:{ *:[i32] }):$local)
/* 12734*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->12743
/* 12736*/   OPC_EmitMergeInputChains1_0,
/* 12737*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I64:{ *:[i64] } (timm:{ *:[i32] }):$local)
/* 12743*/  /*SwitchType*/ 9, /*MVT::funcref*/99|128,1/*227*/, // ->12755
/* 12746*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 12747*/   OPC_EmitMergeInputChains1_0,
/* 12748*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_FUNCREF),
                 /*MVT::funcref*/99|128,1/*227*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[funcref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_FUNCREF:{ *:[funcref] } (timm:{ *:[i32] }):$local)
/* 12755*/  /*SwitchType*/ 9, /*MVT::externref*/100|128,1/*228*/, // ->12767
/* 12758*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 12759*/   OPC_EmitMergeInputChains1_0,
/* 12760*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_EXTERNREF),
                 /*MVT::externref*/100|128,1/*228*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[externref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_EXTERNREF:{ *:[externref] } (timm:{ *:[i32] }):$local)
/* 12767*/  /*SwitchType*/ 10, /*MVT::exnref*/101|128,1/*229*/, // ->12780
/* 12770*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 12772*/   OPC_EmitMergeInputChains1_0,
/* 12773*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_EXNREF),
                 /*MVT::exnref*/101|128,1/*229*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[exnref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_EXNREF:{ *:[exnref] } (timm:{ *:[i32] }):$local)
/* 12780*/  /*SwitchType*/ 7, /*MVT::f32*/12, // ->12789
/* 12782*/   OPC_EmitMergeInputChains1_0,
/* 12783*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F32:{ *:[f32] } (timm:{ *:[i32] }):$local)
/* 12789*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->12798
/* 12791*/   OPC_EmitMergeInputChains1_0,
/* 12792*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F64:{ *:[f64] } (timm:{ *:[i32] }):$local)
/* 12798*/  /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->12808
/* 12800*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12801*/   OPC_EmitMergeInputChains1_0,
/* 12802*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2i64] } (timm:{ *:[i32] }):$local)
/* 12808*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->12818
/* 12810*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12811*/   OPC_EmitMergeInputChains1_0,
/* 12812*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4i32] } (timm:{ *:[i32] }):$local)
/* 12818*/  /*SwitchType*/ 8, /*MVT::v16i8*/39, // ->12828
/* 12820*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12821*/   OPC_EmitMergeInputChains1_0,
/* 12822*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v16i8*/39, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v16i8] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v16i8] } (timm:{ *:[i32] }):$local)
/* 12828*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->12838
/* 12830*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12831*/   OPC_EmitMergeInputChains1_0,
/* 12832*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v8i16] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v8i16] } (timm:{ *:[i32] }):$local)
/* 12838*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->12848
/* 12840*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12841*/   OPC_EmitMergeInputChains1_0,
/* 12842*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v8f16] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v8f16] } (timm:{ *:[i32] }):$local)
/* 12848*/  /*SwitchType*/ 8, /*MVT::v4f32*/111, // ->12858
/* 12850*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12851*/   OPC_EmitMergeInputChains1_0,
/* 12852*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4f32] } (timm:{ *:[i32] }):$local)
/* 12858*/  /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->12870
/* 12861*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12862*/   OPC_EmitMergeInputChains1_0,
/* 12863*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2f64] } (timm:{ *:[i32] }):$local)
/* 12870*/  0, // EndSwitchType
/* 12871*/ /*SwitchOpcode*/ 35|128,1/*163*/, TARGET_VAL(WebAssemblyISD::LOCAL_SET),// ->13038
/* 12875*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_set' chained node
/* 12876*/  OPC_RecordChild1, // #1 = $local
/* 12877*/  OPC_MoveChild1,
/* 12878*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12881*/  OPC_MoveParent,
/* 12882*/  OPC_RecordChild2, // #2 = $src
/* 12883*/  OPC_Scope, 8, /*->12893*/ // 14 children in Scope
/* 12885*/   OPC_CheckChild2TypeI32,
/* 12886*/   OPC_EmitMergeInputChains1_0,
/* 12887*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_I32),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I32 (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src)
/* 12893*/  /*Scope*/ 8, /*->12902*/
/* 12894*/   OPC_CheckChild2TypeI64,
/* 12895*/   OPC_EmitMergeInputChains1_0,
/* 12896*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_I64),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I64 (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src)
/* 12902*/  /*Scope*/ 9, /*->12912*/
/* 12903*/   OPC_CheckChild2Type, /*MVT::f32*/12, 
/* 12905*/   OPC_EmitMergeInputChains1_0,
/* 12906*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_F32),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F32 (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src)
/* 12912*/  /*Scope*/ 9, /*->12922*/
/* 12913*/   OPC_CheckChild2Type, /*MVT::f64*/13, 
/* 12915*/   OPC_EmitMergeInputChains1_0,
/* 12916*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_F64),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F64 (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src)
/* 12922*/  /*Scope*/ 10, /*->12933*/
/* 12923*/   OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 12925*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12926*/   OPC_EmitMergeInputChains1_0,
/* 12927*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v8f16:{ *:[v8f16] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v8f16:{ *:[v8f16] }:$src)
/* 12933*/  /*Scope*/ 10, /*->12944*/
/* 12934*/   OPC_CheckChild2Type, /*MVT::v4f32*/111, 
/* 12936*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12937*/   OPC_EmitMergeInputChains1_0,
/* 12938*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src)
/* 12944*/  /*Scope*/ 11, /*->12956*/
/* 12945*/   OPC_CheckChild2Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12948*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12949*/   OPC_EmitMergeInputChains1_0,
/* 12950*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src)
/* 12956*/  /*Scope*/ 10, /*->12967*/
/* 12957*/   OPC_CheckChild2Type, /*MVT::v2i64*/78, 
/* 12959*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12960*/   OPC_EmitMergeInputChains1_0,
/* 12961*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src)
/* 12967*/  /*Scope*/ 10, /*->12978*/
/* 12968*/   OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 12970*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12971*/   OPC_EmitMergeInputChains1_0,
/* 12972*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src)
/* 12978*/  /*Scope*/ 10, /*->12989*/
/* 12979*/   OPC_CheckChild2Type, /*MVT::v16i8*/39, 
/* 12981*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12982*/   OPC_EmitMergeInputChains1_0,
/* 12983*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src)
/* 12989*/  /*Scope*/ 10, /*->13000*/
/* 12990*/   OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 12992*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12993*/   OPC_EmitMergeInputChains1_0,
/* 12994*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src)
/* 13000*/  /*Scope*/ 11, /*->13012*/
/* 13001*/   OPC_CheckChild2Type, /*MVT::funcref*/99|128,1/*227*/, 
/* 13004*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 13005*/   OPC_EmitMergeInputChains1_0,
/* 13006*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_FUNCREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_FUNCREF (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src)
/* 13012*/  /*Scope*/ 11, /*->13024*/
/* 13013*/   OPC_CheckChild2Type, /*MVT::externref*/100|128,1/*228*/, 
/* 13016*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 13017*/   OPC_EmitMergeInputChains1_0,
/* 13018*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_EXTERNREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_EXTERNREF (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src)
/* 13024*/  /*Scope*/ 12, /*->13037*/
/* 13025*/   OPC_CheckChild2Type, /*MVT::exnref*/101|128,1/*229*/, 
/* 13028*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 13030*/   OPC_EmitMergeInputChains1_0,
/* 13031*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_EXNREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, exnref:{ *:[exnref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_EXNREF (timm:{ *:[i32] }):$local, exnref:{ *:[exnref] }:$src)
/* 13037*/  0, /*End of Scope*/
/* 13038*/ /*SwitchOpcode*/ 0|128,1/*128*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->13170
/* 13042*/  OPC_RecordChild0, // #0 = $addr
/* 13043*/  OPC_MoveChild0,
/* 13044*/  OPC_SwitchOpcode /*3 cases */, 47, TARGET_VAL(ISD::TargetGlobalAddress),// ->13095
/* 13048*/   OPC_MoveParent,
/* 13049*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->13072
/* 13052*/    OPC_Scope, 8, /*->13062*/ // 2 children in Scope
/* 13054*/     OPC_CheckPatternPredicate, 17, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13056*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 13062*/    /*Scope*/ 8, /*->13071*/
/* 13063*/     OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13065*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 13071*/    0, /*End of Scope*/
/* 13072*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->13094
/* 13074*/    OPC_Scope, 8, /*->13084*/ // 2 children in Scope
/* 13076*/     OPC_CheckPatternPredicate, 18, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13078*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 13084*/    /*Scope*/ 8, /*->13093*/
/* 13085*/     OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13087*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 13093*/    0, /*End of Scope*/
/* 13094*/   0, // EndSwitchType
/* 13095*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->13119
/* 13098*/   OPC_MoveParent,
/* 13099*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13109
/* 13102*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 13103*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 13109*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->13118
/* 13111*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 13112*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 13118*/   0, // EndSwitchType
/* 13119*/  /*SwitchOpcode*/ 47, TARGET_VAL(ISD::TargetExternalSymbol),// ->13169
/* 13122*/   OPC_MoveParent,
/* 13123*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->13146
/* 13126*/    OPC_Scope, 8, /*->13136*/ // 2 children in Scope
/* 13128*/     OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13130*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 13136*/    /*Scope*/ 8, /*->13145*/
/* 13137*/     OPC_CheckPatternPredicate, 17, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13139*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 13145*/    0, /*End of Scope*/
/* 13146*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->13168
/* 13148*/    OPC_Scope, 8, /*->13158*/ // 2 children in Scope
/* 13150*/     OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13152*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13158*/    /*Scope*/ 8, /*->13167*/
/* 13159*/     OPC_CheckPatternPredicate, 18, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13161*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13167*/    0, /*End of Scope*/
/* 13168*/   0, // EndSwitchType
/* 13169*/  0, // EndSwitchOpcode
/* 13170*/ /*SwitchOpcode*/ 80, TARGET_VAL(WebAssemblyISD::WrapperREL),// ->13253
/* 13173*/  OPC_RecordChild0, // #0 = $addr
/* 13174*/  OPC_MoveChild0,
/* 13175*/  OPC_SwitchOpcode /*3 cases */, 23, TARGET_VAL(ISD::TargetGlobalAddress),// ->13202
/* 13179*/   OPC_MoveParent,
/* 13180*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->13191
/* 13183*/    OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13185*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 13191*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->13201
/* 13193*/    OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13195*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 13201*/   0, // EndSwitchType
/* 13202*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->13226
/* 13205*/   OPC_MoveParent,
/* 13206*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13216
/* 13209*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 13210*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 13216*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->13225
/* 13218*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 13219*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 13225*/   0, // EndSwitchType
/* 13226*/  /*SwitchOpcode*/ 23, TARGET_VAL(ISD::TargetExternalSymbol),// ->13252
/* 13229*/   OPC_MoveParent,
/* 13230*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->13241
/* 13233*/    OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13235*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 13241*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->13251
/* 13243*/    OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13245*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13251*/   0, // EndSwitchType
/* 13252*/  0, // EndSwitchOpcode
/* 13253*/ /*SwitchOpcode*/ 47, TARGET_VAL(WebAssemblyISD::MEMSET),// ->13303
/* 13256*/  OPC_RecordNode, // #0 = 'wasm_memset' chained node
/* 13257*/  OPC_RecordChild1, // #1 = $idx
/* 13258*/  OPC_MoveChild1,
/* 13259*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13262*/  OPC_CheckTypeI32,
/* 13263*/  OPC_MoveParent,
/* 13264*/  OPC_RecordChild2, // #2 = $dst
/* 13265*/  OPC_Scope, 17, /*->13284*/ // 2 children in Scope
/* 13267*/   OPC_CheckChild2TypeI32,
/* 13268*/   OPC_RecordChild3, // #3 = $value
/* 13269*/   OPC_CheckChild3TypeI32,
/* 13270*/   OPC_RecordChild4, // #4 = $size
/* 13271*/   OPC_CheckChild4TypeI32,
/* 13272*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemoryOpt())
/* 13274*/   OPC_EmitMergeInputChains1_0,
/* 13275*/   OPC_EmitConvertToTarget1, // #5
/* 13276*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::MEMSET_A32),
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size) - Complexity = 6
             // Dst: (MEMSET_A32 (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size)
/* 13284*/  /*Scope*/ 17, /*->13302*/
/* 13285*/   OPC_CheckChild2TypeI64,
/* 13286*/   OPC_RecordChild3, // #3 = $value
/* 13287*/   OPC_CheckChild3TypeI32,
/* 13288*/   OPC_RecordChild4, // #4 = $size
/* 13289*/   OPC_CheckChild4TypeI64,
/* 13290*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemoryOpt())
/* 13292*/   OPC_EmitMergeInputChains1_0,
/* 13293*/   OPC_EmitConvertToTarget1, // #5
/* 13294*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::MEMSET_A64),
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size) - Complexity = 6
             // Dst: (MEMSET_A64 (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size)
/* 13302*/  0, /*End of Scope*/
/* 13303*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::Constant),// ->13327
/* 13306*/  OPC_RecordNode, // #0 = $imm
/* 13307*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13317
/* 13310*/   OPC_EmitConvertToTarget0, // #1
/* 13311*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i32] }):$imm - Complexity = 3
             // Dst: (CONST_I32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
/* 13317*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->13326
/* 13319*/   OPC_EmitConvertToTarget0, // #1
/* 13320*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i64] }):$imm - Complexity = 3
             // Dst: (CONST_I64:{ *:[i64] } (imm:{ *:[i64] }):$imm)
/* 13326*/  0, // EndSwitchType
/* 13327*/ /*SwitchOpcode*/ 13, TARGET_VAL(ISD::BR),// ->13343
/* 13330*/  OPC_RecordNode, // #0 = 'br' chained node
/* 13331*/  OPC_RecordChild1, // #1 = $dst
/* 13332*/  OPC_MoveChild1,
/* 13333*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13336*/  OPC_MoveParent,
/* 13337*/  OPC_EmitMergeInputChains1_0,
/* 13338*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR),
                1/*#Ops*/, 1, 
            // Src: (br (bb:{ *:[Other] }):$dst) - Complexity = 3
            // Dst: (BR (bb:{ *:[Other] }):$dst)
/* 13343*/ /*SwitchOpcode*/ 22, TARGET_VAL(WebAssemblyISD::BR_TABLE),// ->13368
/* 13346*/  OPC_RecordNode, // #0 = 'WebAssemblybr_table' chained node
/* 13347*/  OPC_RecordChild1, // #1 = $index
/* 13348*/  OPC_Scope, 8, /*->13358*/ // 2 children in Scope
/* 13350*/   OPC_CheckChild1TypeI32,
/* 13351*/   OPC_EmitMergeInputChains1_0,
/* 13352*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I32), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I32:{ *:[i32] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I32 I32:{ *:[i32] }:$index)
/* 13358*/  /*Scope*/ 8, /*->13367*/
/* 13359*/   OPC_CheckChild1TypeI64,
/* 13360*/   OPC_EmitMergeInputChains1_0,
/* 13361*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I64), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I64:{ *:[i64] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I64 I64:{ *:[i64] }:$index)
/* 13367*/  0, /*End of Scope*/
/* 13368*/ /*SwitchOpcode*/ 7, TARGET_VAL(WebAssemblyISD::RETURN),// ->13378
/* 13371*/  OPC_RecordNode, // #0 = 'WebAssemblyreturn' chained node
/* 13372*/  OPC_EmitMergeInputChains1_0,
/* 13373*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN), 0|OPFL_Chain|OPFL_Variadic0,
                0/*#Ops*/, 
            // Src: (WebAssemblyreturn) - Complexity = 3
            // Dst: (RETURN)
/* 13378*/ /*SwitchOpcode*/ 6, TARGET_VAL(ISD::TRAP),// ->13387
/* 13381*/  OPC_RecordNode, // #0 = 'trap' chained node
/* 13382*/  OPC_EmitMergeInputChains1_0,
/* 13383*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::UNREACHABLE),
                0/*#Ops*/, 
            // Src: (trap) - Complexity = 3
            // Dst: (UNREACHABLE)
/* 13387*/ /*SwitchOpcode*/ 6, TARGET_VAL(ISD::DEBUGTRAP),// ->13396
/* 13390*/  OPC_RecordNode, // #0 = 'debugtrap' chained node
/* 13391*/  OPC_EmitMergeInputChains1_0,
/* 13392*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::DEBUG_UNREACHABLE),
                0/*#Ops*/, 
            // Src: (debugtrap) - Complexity = 3
            // Dst: (DEBUG_UNREACHABLE)
/* 13396*/ /*SwitchOpcode*/ 15, TARGET_VAL(ISD::CLEANUPRET),// ->13414
/* 13399*/  OPC_RecordNode, // #0 = 'cleanupret' chained node
/* 13400*/  OPC_RecordChild1, // #1 = $ehpad
/* 13401*/  OPC_MoveChild1,
/* 13402*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13405*/  OPC_MoveParent,
/* 13406*/  OPC_CheckPatternPredicate, 19, // (Subtarget->hasExceptionHandling())
/* 13408*/  OPC_EmitMergeInputChains1_0,
/* 13409*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::CLEANUPRET),
                1/*#Ops*/, 1, 
            // Src: (cleanupret (bb:{ *:[Other] }):$ehpad) - Complexity = 3
            // Dst: (CLEANUPRET (bb:{ *:[Other] }):$ehpad)
/* 13414*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CATCHRET),// ->13438
/* 13417*/  OPC_RecordNode, // #0 = 'catchret' chained node
/* 13418*/  OPC_RecordChild1, // #1 = $dst
/* 13419*/  OPC_MoveChild1,
/* 13420*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13423*/  OPC_MoveSibling2,
/* 13424*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13427*/  OPC_RecordNode, // #2 = $from
/* 13428*/  OPC_MoveParent,
/* 13429*/  OPC_CheckPatternPredicate, 19, // (Subtarget->hasExceptionHandling())
/* 13431*/  OPC_EmitMergeInputChains1_0,
/* 13432*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::CATCHRET),
                2/*#Ops*/, 1, 2, 
            // Src: (catchret (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from) - Complexity = 3
            // Dst: (CATCHRET (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from)
/* 13438*/ /*SwitchOpcode*/ 62, TARGET_VAL(ISD::ADD),// ->13503
/* 13441*/  OPC_RecordChild0, // #0 = $lhs
/* 13442*/  OPC_RecordChild1, // #1 = $rhs
/* 13443*/  OPC_SwitchType /*6 cases */, 7, /*MVT::i32*/7, // ->13453
/* 13446*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13453*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->13462
/* 13455*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13462*/  /*SwitchType*/ 8, /*MVT::v16i8*/39, // ->13472
/* 13464*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13465*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13472*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->13482
/* 13474*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13475*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13482*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->13492
/* 13484*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13485*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13492*/  /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->13502
/* 13494*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13495*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I64x2),
                 /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13502*/  0, // EndSwitchType
/* 13503*/ /*SwitchOpcode*/ 113, TARGET_VAL(ISD::SUB),// ->13619
/* 13506*/  OPC_Scope, 22, /*->13530*/ // 3 children in Scope
/* 13508*/   OPC_RecordChild0, // #0 = $lhs
/* 13509*/   OPC_RecordChild1, // #1 = $rhs
/* 13510*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13520
/* 13513*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13520*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->13529
/* 13522*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13529*/   0, // EndSwitchType
/* 13530*/  /*Scope*/ 42, /*->13573*/
/* 13531*/   OPC_MoveChild0,
/* 13532*/   OPC_CheckImmAllZerosV,
/* 13533*/   OPC_MoveParent,
/* 13534*/   OPC_RecordChild1, // #0 = $v
/* 13535*/   OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->13545
/* 13538*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13539*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I8x16),
                  /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$v) - Complexity = 7
              // Dst: (NEG_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 13545*/   /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->13554
/* 13547*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13548*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$v) - Complexity = 7
              // Dst: (NEG_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 13554*/   /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->13563
/* 13556*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13557*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$v) - Complexity = 7
              // Dst: (NEG_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 13563*/   /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->13572
/* 13565*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13566*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I64x2),
                  /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$v) - Complexity = 7
              // Dst: (NEG_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 13572*/   0, // EndSwitchType
/* 13573*/  /*Scope*/ 44, /*->13618*/
/* 13574*/   OPC_RecordChild0, // #0 = $lhs
/* 13575*/   OPC_RecordChild1, // #1 = $rhs
/* 13576*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->13587
/* 13579*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13580*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SUB_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13587*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->13597
/* 13589*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13590*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SUB_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13597*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->13607
/* 13599*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13600*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13607*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->13617
/* 13609*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13610*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13617*/   0, // EndSwitchType
/* 13618*/  0, /*End of Scope*/
/* 13619*/ /*SwitchOpcode*/ 85|128,2/*341*/, TARGET_VAL(ISD::MUL),// ->13964
/* 13623*/  OPC_Scope, 22, /*->13647*/ // 3 children in Scope
/* 13625*/   OPC_RecordChild0, // #0 = $lhs
/* 13626*/   OPC_RecordChild1, // #1 = $rhs
/* 13627*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13637
/* 13630*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13637*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->13646
/* 13639*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13646*/   0, // EndSwitchType
/* 13647*/  /*Scope*/ 23|128,2/*279*/, /*->13928*/
/* 13649*/   OPC_MoveChild0,
/* 13650*/   OPC_SwitchOpcode /*4 cases */, 66, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->13720
/* 13654*/    OPC_RecordChild0, // #0 = $lhs
/* 13655*/    OPC_Scope, 20, /*->13677*/ // 3 children in Scope
/* 13657*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13659*/     OPC_MoveSibling1,
/* 13660*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13663*/     OPC_RecordChild0, // #1 = $rhs
/* 13664*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13666*/     OPC_MoveParent,
/* 13667*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 13669*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13670*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13677*/    /*Scope*/ 20, /*->13698*/
/* 13678*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13680*/     OPC_MoveSibling1,
/* 13681*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13684*/     OPC_RecordChild0, // #1 = $rhs
/* 13685*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13687*/     OPC_MoveParent,
/* 13688*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 13690*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13691*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13698*/    /*Scope*/ 20, /*->13719*/
/* 13699*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13701*/     OPC_MoveSibling1,
/* 13702*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13705*/     OPC_RecordChild0, // #1 = $rhs
/* 13706*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13708*/     OPC_MoveParent,
/* 13709*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 13711*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13712*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13719*/    0, /*End of Scope*/
/* 13720*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->13789
/* 13723*/    OPC_RecordChild0, // #0 = $lhs
/* 13724*/    OPC_Scope, 20, /*->13746*/ // 3 children in Scope
/* 13726*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13728*/     OPC_MoveSibling1,
/* 13729*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13732*/     OPC_RecordChild0, // #1 = $rhs
/* 13733*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13735*/     OPC_MoveParent,
/* 13736*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 13738*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13739*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13746*/    /*Scope*/ 20, /*->13767*/
/* 13747*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13749*/     OPC_MoveSibling1,
/* 13750*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13753*/     OPC_RecordChild0, // #1 = $rhs
/* 13754*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13756*/     OPC_MoveParent,
/* 13757*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 13759*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13760*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13767*/    /*Scope*/ 20, /*->13788*/
/* 13768*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13770*/     OPC_MoveSibling1,
/* 13771*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13774*/     OPC_RecordChild0, // #1 = $rhs
/* 13775*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13777*/     OPC_MoveParent,
/* 13778*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 13780*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13781*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13788*/    0, /*End of Scope*/
/* 13789*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->13858
/* 13792*/    OPC_RecordChild0, // #0 = $lhs
/* 13793*/    OPC_Scope, 20, /*->13815*/ // 3 children in Scope
/* 13795*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13797*/     OPC_MoveSibling1,
/* 13798*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13801*/     OPC_RecordChild0, // #1 = $rhs
/* 13802*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13804*/     OPC_MoveParent,
/* 13805*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 13807*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13808*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13815*/    /*Scope*/ 20, /*->13836*/
/* 13816*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13818*/     OPC_MoveSibling1,
/* 13819*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13822*/     OPC_RecordChild0, // #1 = $rhs
/* 13823*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13825*/     OPC_MoveParent,
/* 13826*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 13828*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13829*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13836*/    /*Scope*/ 20, /*->13857*/
/* 13837*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13839*/     OPC_MoveSibling1,
/* 13840*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13843*/     OPC_RecordChild0, // #1 = $rhs
/* 13844*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13846*/     OPC_MoveParent,
/* 13847*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 13849*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13850*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13857*/    0, /*End of Scope*/
/* 13858*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->13927
/* 13861*/    OPC_RecordChild0, // #0 = $lhs
/* 13862*/    OPC_Scope, 20, /*->13884*/ // 3 children in Scope
/* 13864*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13866*/     OPC_MoveSibling1,
/* 13867*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 13870*/     OPC_RecordChild0, // #1 = $rhs
/* 13871*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13873*/     OPC_MoveParent,
/* 13874*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 13876*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13877*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13884*/    /*Scope*/ 20, /*->13905*/
/* 13885*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13887*/     OPC_MoveSibling1,
/* 13888*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 13891*/     OPC_RecordChild0, // #1 = $rhs
/* 13892*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13894*/     OPC_MoveParent,
/* 13895*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 13897*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13898*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13905*/    /*Scope*/ 20, /*->13926*/
/* 13906*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13908*/     OPC_MoveSibling1,
/* 13909*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 13912*/     OPC_RecordChild0, // #1 = $rhs
/* 13913*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13915*/     OPC_MoveParent,
/* 13916*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 13918*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13919*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13926*/    0, /*End of Scope*/
/* 13927*/   0, // EndSwitchOpcode
/* 13928*/  /*Scope*/ 34, /*->13963*/
/* 13929*/   OPC_RecordChild0, // #0 = $lhs
/* 13930*/   OPC_RecordChild1, // #1 = $rhs
/* 13931*/   OPC_SwitchType /*3 cases */, 8, /*MVT::v8i16*/50, // ->13942
/* 13934*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13935*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (MUL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13942*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->13952
/* 13944*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13945*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13952*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->13962
/* 13954*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13955*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13962*/   0, // EndSwitchType
/* 13963*/  0, /*End of Scope*/
/* 13964*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::SDIV),// ->13989
/* 13967*/  OPC_RecordChild0, // #0 = $lhs
/* 13968*/  OPC_RecordChild1, // #1 = $rhs
/* 13969*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13979
/* 13972*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_S_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13979*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->13988
/* 13981*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_S_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13988*/  0, // EndSwitchType
/* 13989*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::UDIV),// ->14014
/* 13992*/  OPC_RecordChild0, // #0 = $lhs
/* 13993*/  OPC_RecordChild1, // #1 = $rhs
/* 13994*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14004
/* 13997*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_U_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14004*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->14013
/* 14006*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_U_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14013*/  0, // EndSwitchType
/* 14014*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::SREM),// ->14039
/* 14017*/  OPC_RecordChild0, // #0 = $lhs
/* 14018*/  OPC_RecordChild1, // #1 = $rhs
/* 14019*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14029
/* 14022*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_S_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14029*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->14038
/* 14031*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_S_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14038*/  0, // EndSwitchType
/* 14039*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::UREM),// ->14064
/* 14042*/  OPC_RecordChild0, // #0 = $lhs
/* 14043*/  OPC_RecordChild1, // #1 = $rhs
/* 14044*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14054
/* 14047*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_U_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14054*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->14063
/* 14056*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_U_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14063*/  0, // EndSwitchType
/* 14064*/ /*SwitchOpcode*/ 56|128,6/*824*/, TARGET_VAL(ISD::OR),// ->14892
/* 14068*/  OPC_Scope, 22, /*->14092*/ // 3 children in Scope
/* 14070*/   OPC_RecordChild0, // #0 = $lhs
/* 14071*/   OPC_RecordChild1, // #1 = $rhs
/* 14072*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14082
/* 14075*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (OR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14082*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->14091
/* 14084*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (OR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14091*/   0, // EndSwitchType
/* 14092*/  /*Scope*/ 116|128,5/*756*/, /*->14850*/
/* 14094*/   OPC_MoveChild0,
/* 14095*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14098*/   OPC_Scope, 4|128,1/*132*/, /*->14233*/ // 9 children in Scope
/* 14101*/    OPC_RecordChild0, // #0 = $c
/* 14102*/    OPC_RecordChild1, // #1 = $v1
/* 14103*/    OPC_MoveSibling1,
/* 14104*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14107*/    OPC_Scope, 54, /*->14163*/ // 4 children in Scope
/* 14109*/     OPC_MoveChild0,
/* 14110*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14113*/     OPC_CheckChild0Same, 0,
/* 14115*/     OPC_MoveChild1,
/* 14116*/     OPC_CheckImmAllOnesV,
/* 14117*/     OPC_MoveParent,
/* 14118*/     OPC_MoveParent,
/* 14119*/     OPC_RecordChild1, // #2 = $v2
/* 14120*/     OPC_MoveParent,
/* 14121*/     OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->14132
/* 14124*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14132*/     /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->14142
/* 14134*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14142*/     /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->14152
/* 14144*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14152*/     /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->14162
/* 14154*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14162*/     0, // EndSwitchType
/* 14163*/    /*Scope*/ 22, /*->14186*/
/* 14164*/     OPC_RecordChild0, // #2 = $v2
/* 14165*/     OPC_MoveChild1,
/* 14166*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14169*/     OPC_CheckChild0Same, 0,
/* 14171*/     OPC_MoveChild1,
/* 14172*/     OPC_CheckImmAllOnesV,
/* 14173*/     OPC_MoveParent,
/* 14174*/     OPC_MoveParent,
/* 14175*/     OPC_MoveParent,
/* 14176*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14178*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14186*/    /*Scope*/ 22, /*->14209*/
/* 14187*/     OPC_MoveChild0,
/* 14188*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14191*/     OPC_CheckChild0Same, 1,
/* 14193*/     OPC_MoveChild1,
/* 14194*/     OPC_CheckImmAllOnesV,
/* 14195*/     OPC_MoveParent,
/* 14196*/     OPC_MoveParent,
/* 14197*/     OPC_RecordChild1, // #2 = $v2
/* 14198*/     OPC_MoveParent,
/* 14199*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14201*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14209*/    /*Scope*/ 22, /*->14232*/
/* 14210*/     OPC_RecordChild0, // #2 = $v2
/* 14211*/     OPC_MoveChild1,
/* 14212*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14215*/     OPC_CheckChild0Same, 1,
/* 14217*/     OPC_MoveChild1,
/* 14218*/     OPC_CheckImmAllOnesV,
/* 14219*/     OPC_MoveParent,
/* 14220*/     OPC_MoveParent,
/* 14221*/     OPC_MoveParent,
/* 14222*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14224*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14232*/    0, /*End of Scope*/
/* 14233*/   /*Scope*/ 46, /*->14280*/
/* 14234*/    OPC_MoveChild0,
/* 14235*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14238*/    OPC_RecordChild0, // #0 = $c
/* 14239*/    OPC_MoveChild1,
/* 14240*/    OPC_CheckImmAllOnesV,
/* 14241*/    OPC_MoveParent,
/* 14242*/    OPC_MoveParent,
/* 14243*/    OPC_RecordChild1, // #1 = $v2
/* 14244*/    OPC_MoveSibling1,
/* 14245*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14248*/    OPC_Scope, 14, /*->14264*/ // 2 children in Scope
/* 14250*/     OPC_CheckChild0Same, 0,
/* 14252*/     OPC_RecordChild1, // #2 = $v1
/* 14253*/     OPC_MoveParent,
/* 14254*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14256*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14264*/    /*Scope*/ 14, /*->14279*/
/* 14265*/     OPC_RecordChild0, // #2 = $v1
/* 14266*/     OPC_CheckChild1Same, 0,
/* 14268*/     OPC_MoveParent,
/* 14269*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14271*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14279*/    0, /*End of Scope*/
/* 14280*/   /*Scope*/ 126, /*->14407*/
/* 14281*/    OPC_RecordChild0, // #0 = $v2
/* 14282*/    OPC_Scope, 45, /*->14329*/ // 2 children in Scope
/* 14284*/     OPC_MoveChild1,
/* 14285*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14288*/     OPC_RecordChild0, // #1 = $c
/* 14289*/     OPC_MoveChild1,
/* 14290*/     OPC_CheckImmAllOnesV,
/* 14291*/     OPC_MoveParent,
/* 14292*/     OPC_MoveParent,
/* 14293*/     OPC_MoveSibling1,
/* 14294*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14297*/     OPC_Scope, 14, /*->14313*/ // 2 children in Scope
/* 14299*/      OPC_CheckChild0Same, 1,
/* 14301*/      OPC_RecordChild1, // #2 = $v1
/* 14302*/      OPC_MoveParent,
/* 14303*/      OPC_CheckType, /*MVT::v16i8*/39, 
/* 14305*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14313*/     /*Scope*/ 14, /*->14328*/
/* 14314*/      OPC_RecordChild0, // #2 = $v1
/* 14315*/      OPC_CheckChild1Same, 1,
/* 14317*/      OPC_MoveParent,
/* 14318*/      OPC_CheckType, /*MVT::v16i8*/39, 
/* 14320*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14328*/     0, /*End of Scope*/
/* 14329*/    /*Scope*/ 76, /*->14406*/
/* 14330*/     OPC_RecordChild1, // #1 = $v1
/* 14331*/     OPC_MoveSibling1,
/* 14332*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14335*/     OPC_Scope, 22, /*->14359*/ // 3 children in Scope
/* 14337*/      OPC_RecordChild0, // #2 = $v2
/* 14338*/      OPC_MoveChild1,
/* 14339*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14342*/      OPC_CheckChild0Same, 0,
/* 14344*/      OPC_MoveChild1,
/* 14345*/      OPC_CheckImmAllOnesV,
/* 14346*/      OPC_MoveParent,
/* 14347*/      OPC_MoveParent,
/* 14348*/      OPC_MoveParent,
/* 14349*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14351*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14359*/     /*Scope*/ 22, /*->14382*/
/* 14360*/      OPC_MoveChild0,
/* 14361*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14364*/      OPC_CheckChild0Same, 1,
/* 14366*/      OPC_MoveChild1,
/* 14367*/      OPC_CheckImmAllOnesV,
/* 14368*/      OPC_MoveParent,
/* 14369*/      OPC_MoveParent,
/* 14370*/      OPC_RecordChild1, // #2 = $v2
/* 14371*/      OPC_MoveParent,
/* 14372*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14374*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14382*/     /*Scope*/ 22, /*->14405*/
/* 14383*/      OPC_RecordChild0, // #2 = $v2
/* 14384*/      OPC_MoveChild1,
/* 14385*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14388*/      OPC_CheckChild0Same, 1,
/* 14390*/      OPC_MoveChild1,
/* 14391*/      OPC_CheckImmAllOnesV,
/* 14392*/      OPC_MoveParent,
/* 14393*/      OPC_MoveParent,
/* 14394*/      OPC_MoveParent,
/* 14395*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14397*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14405*/     0, /*End of Scope*/
/* 14406*/    0, /*End of Scope*/
/* 14407*/   /*Scope*/ 46, /*->14454*/
/* 14408*/    OPC_MoveChild0,
/* 14409*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14412*/    OPC_RecordChild0, // #0 = $c
/* 14413*/    OPC_MoveChild1,
/* 14414*/    OPC_CheckImmAllOnesV,
/* 14415*/    OPC_MoveParent,
/* 14416*/    OPC_MoveParent,
/* 14417*/    OPC_RecordChild1, // #1 = $v2
/* 14418*/    OPC_MoveSibling1,
/* 14419*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14422*/    OPC_Scope, 14, /*->14438*/ // 2 children in Scope
/* 14424*/     OPC_CheckChild0Same, 0,
/* 14426*/     OPC_RecordChild1, // #2 = $v1
/* 14427*/     OPC_MoveParent,
/* 14428*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 14430*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14438*/    /*Scope*/ 14, /*->14453*/
/* 14439*/     OPC_RecordChild0, // #2 = $v1
/* 14440*/     OPC_CheckChild1Same, 0,
/* 14442*/     OPC_MoveParent,
/* 14443*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 14445*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14453*/    0, /*End of Scope*/
/* 14454*/   /*Scope*/ 126, /*->14581*/
/* 14455*/    OPC_RecordChild0, // #0 = $v2
/* 14456*/    OPC_Scope, 45, /*->14503*/ // 2 children in Scope
/* 14458*/     OPC_MoveChild1,
/* 14459*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14462*/     OPC_RecordChild0, // #1 = $c
/* 14463*/     OPC_MoveChild1,
/* 14464*/     OPC_CheckImmAllOnesV,
/* 14465*/     OPC_MoveParent,
/* 14466*/     OPC_MoveParent,
/* 14467*/     OPC_MoveSibling1,
/* 14468*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14471*/     OPC_Scope, 14, /*->14487*/ // 2 children in Scope
/* 14473*/      OPC_CheckChild0Same, 1,
/* 14475*/      OPC_RecordChild1, // #2 = $v1
/* 14476*/      OPC_MoveParent,
/* 14477*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14479*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14487*/     /*Scope*/ 14, /*->14502*/
/* 14488*/      OPC_RecordChild0, // #2 = $v1
/* 14489*/      OPC_CheckChild1Same, 1,
/* 14491*/      OPC_MoveParent,
/* 14492*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14494*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14502*/     0, /*End of Scope*/
/* 14503*/    /*Scope*/ 76, /*->14580*/
/* 14504*/     OPC_RecordChild1, // #1 = $v1
/* 14505*/     OPC_MoveSibling1,
/* 14506*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14509*/     OPC_Scope, 22, /*->14533*/ // 3 children in Scope
/* 14511*/      OPC_RecordChild0, // #2 = $v2
/* 14512*/      OPC_MoveChild1,
/* 14513*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14516*/      OPC_CheckChild0Same, 0,
/* 14518*/      OPC_MoveChild1,
/* 14519*/      OPC_CheckImmAllOnesV,
/* 14520*/      OPC_MoveParent,
/* 14521*/      OPC_MoveParent,
/* 14522*/      OPC_MoveParent,
/* 14523*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14525*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14533*/     /*Scope*/ 22, /*->14556*/
/* 14534*/      OPC_MoveChild0,
/* 14535*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14538*/      OPC_CheckChild0Same, 1,
/* 14540*/      OPC_MoveChild1,
/* 14541*/      OPC_CheckImmAllOnesV,
/* 14542*/      OPC_MoveParent,
/* 14543*/      OPC_MoveParent,
/* 14544*/      OPC_RecordChild1, // #2 = $v2
/* 14545*/      OPC_MoveParent,
/* 14546*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14548*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14556*/     /*Scope*/ 22, /*->14579*/
/* 14557*/      OPC_RecordChild0, // #2 = $v2
/* 14558*/      OPC_MoveChild1,
/* 14559*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14562*/      OPC_CheckChild0Same, 1,
/* 14564*/      OPC_MoveChild1,
/* 14565*/      OPC_CheckImmAllOnesV,
/* 14566*/      OPC_MoveParent,
/* 14567*/      OPC_MoveParent,
/* 14568*/      OPC_MoveParent,
/* 14569*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14571*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14579*/     0, /*End of Scope*/
/* 14580*/    0, /*End of Scope*/
/* 14581*/   /*Scope*/ 46, /*->14628*/
/* 14582*/    OPC_MoveChild0,
/* 14583*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14586*/    OPC_RecordChild0, // #0 = $c
/* 14587*/    OPC_MoveChild1,
/* 14588*/    OPC_CheckImmAllOnesV,
/* 14589*/    OPC_MoveParent,
/* 14590*/    OPC_MoveParent,
/* 14591*/    OPC_RecordChild1, // #1 = $v2
/* 14592*/    OPC_MoveSibling1,
/* 14593*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14596*/    OPC_Scope, 14, /*->14612*/ // 2 children in Scope
/* 14598*/     OPC_CheckChild0Same, 0,
/* 14600*/     OPC_RecordChild1, // #2 = $v1
/* 14601*/     OPC_MoveParent,
/* 14602*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 14604*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14612*/    /*Scope*/ 14, /*->14627*/
/* 14613*/     OPC_RecordChild0, // #2 = $v1
/* 14614*/     OPC_CheckChild1Same, 0,
/* 14616*/     OPC_MoveParent,
/* 14617*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 14619*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14627*/    0, /*End of Scope*/
/* 14628*/   /*Scope*/ 126, /*->14755*/
/* 14629*/    OPC_RecordChild0, // #0 = $v2
/* 14630*/    OPC_Scope, 45, /*->14677*/ // 2 children in Scope
/* 14632*/     OPC_MoveChild1,
/* 14633*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14636*/     OPC_RecordChild0, // #1 = $c
/* 14637*/     OPC_MoveChild1,
/* 14638*/     OPC_CheckImmAllOnesV,
/* 14639*/     OPC_MoveParent,
/* 14640*/     OPC_MoveParent,
/* 14641*/     OPC_MoveSibling1,
/* 14642*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14645*/     OPC_Scope, 14, /*->14661*/ // 2 children in Scope
/* 14647*/      OPC_CheckChild0Same, 1,
/* 14649*/      OPC_RecordChild1, // #2 = $v1
/* 14650*/      OPC_MoveParent,
/* 14651*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14653*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14661*/     /*Scope*/ 14, /*->14676*/
/* 14662*/      OPC_RecordChild0, // #2 = $v1
/* 14663*/      OPC_CheckChild1Same, 1,
/* 14665*/      OPC_MoveParent,
/* 14666*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14668*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14676*/     0, /*End of Scope*/
/* 14677*/    /*Scope*/ 76, /*->14754*/
/* 14678*/     OPC_RecordChild1, // #1 = $v1
/* 14679*/     OPC_MoveSibling1,
/* 14680*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14683*/     OPC_Scope, 22, /*->14707*/ // 3 children in Scope
/* 14685*/      OPC_RecordChild0, // #2 = $v2
/* 14686*/      OPC_MoveChild1,
/* 14687*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14690*/      OPC_CheckChild0Same, 0,
/* 14692*/      OPC_MoveChild1,
/* 14693*/      OPC_CheckImmAllOnesV,
/* 14694*/      OPC_MoveParent,
/* 14695*/      OPC_MoveParent,
/* 14696*/      OPC_MoveParent,
/* 14697*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 14699*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14707*/     /*Scope*/ 22, /*->14730*/
/* 14708*/      OPC_MoveChild0,
/* 14709*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14712*/      OPC_CheckChild0Same, 1,
/* 14714*/      OPC_MoveChild1,
/* 14715*/      OPC_CheckImmAllOnesV,
/* 14716*/      OPC_MoveParent,
/* 14717*/      OPC_MoveParent,
/* 14718*/      OPC_RecordChild1, // #2 = $v2
/* 14719*/      OPC_MoveParent,
/* 14720*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 14722*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14730*/     /*Scope*/ 22, /*->14753*/
/* 14731*/      OPC_RecordChild0, // #2 = $v2
/* 14732*/      OPC_MoveChild1,
/* 14733*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14736*/      OPC_CheckChild0Same, 1,
/* 14738*/      OPC_MoveChild1,
/* 14739*/      OPC_CheckImmAllOnesV,
/* 14740*/      OPC_MoveParent,
/* 14741*/      OPC_MoveParent,
/* 14742*/      OPC_MoveParent,
/* 14743*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 14745*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14753*/     0, /*End of Scope*/
/* 14754*/    0, /*End of Scope*/
/* 14755*/   /*Scope*/ 46, /*->14802*/
/* 14756*/    OPC_MoveChild0,
/* 14757*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14760*/    OPC_RecordChild0, // #0 = $c
/* 14761*/    OPC_MoveChild1,
/* 14762*/    OPC_CheckImmAllOnesV,
/* 14763*/    OPC_MoveParent,
/* 14764*/    OPC_MoveParent,
/* 14765*/    OPC_RecordChild1, // #1 = $v2
/* 14766*/    OPC_MoveSibling1,
/* 14767*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14770*/    OPC_Scope, 14, /*->14786*/ // 2 children in Scope
/* 14772*/     OPC_CheckChild0Same, 0,
/* 14774*/     OPC_RecordChild1, // #2 = $v1
/* 14775*/     OPC_MoveParent,
/* 14776*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 14778*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14786*/    /*Scope*/ 14, /*->14801*/
/* 14787*/     OPC_RecordChild0, // #2 = $v1
/* 14788*/     OPC_CheckChild1Same, 0,
/* 14790*/     OPC_MoveParent,
/* 14791*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 14793*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14801*/    0, /*End of Scope*/
/* 14802*/   /*Scope*/ 46, /*->14849*/
/* 14803*/    OPC_RecordChild0, // #0 = $v2
/* 14804*/    OPC_MoveChild1,
/* 14805*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14808*/    OPC_RecordChild0, // #1 = $c
/* 14809*/    OPC_MoveChild1,
/* 14810*/    OPC_CheckImmAllOnesV,
/* 14811*/    OPC_MoveParent,
/* 14812*/    OPC_MoveParent,
/* 14813*/    OPC_MoveSibling1,
/* 14814*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14817*/    OPC_Scope, 14, /*->14833*/ // 2 children in Scope
/* 14819*/     OPC_CheckChild0Same, 1,
/* 14821*/     OPC_RecordChild1, // #2 = $v1
/* 14822*/     OPC_MoveParent,
/* 14823*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 14825*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14833*/    /*Scope*/ 14, /*->14848*/
/* 14834*/     OPC_RecordChild0, // #2 = $v1
/* 14835*/     OPC_CheckChild1Same, 1,
/* 14837*/     OPC_MoveParent,
/* 14838*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 14840*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14848*/    0, /*End of Scope*/
/* 14849*/   0, /*End of Scope*/
/* 14850*/  /*Scope*/ 40, /*->14891*/
/* 14851*/   OPC_RecordChild0, // #0 = $lhs
/* 14852*/   OPC_RecordChild1, // #1 = $rhs
/* 14853*/   OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->14863
/* 14856*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 14863*/   /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->14872
/* 14865*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 14872*/   /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->14881
/* 14874*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 14881*/   /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->14890
/* 14883*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 14890*/   0, // EndSwitchType
/* 14891*/  0, /*End of Scope*/
/* 14892*/ /*SwitchOpcode*/ 121|128,11/*1529*/, TARGET_VAL(ISD::XOR),// ->16425
/* 14896*/  OPC_Scope, 22, /*->14920*/ // 17 children in Scope
/* 14898*/   OPC_RecordChild0, // #0 = $lhs
/* 14899*/   OPC_RecordChild1, // #1 = $rhs
/* 14900*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14910
/* 14903*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (XOR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14910*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->14919
/* 14912*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (XOR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14919*/   0, // EndSwitchType
/* 14920*/  /*Scope*/ 121, /*->15042*/
/* 14921*/   OPC_MoveChild0,
/* 14922*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14925*/   OPC_MoveChild0,
/* 14926*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14929*/   OPC_RecordChild0, // #0 = $v1
/* 14930*/   OPC_Scope, 71, /*->15003*/ // 2 children in Scope
/* 14932*/    OPC_RecordChild1, // #1 = $v2
/* 14933*/    OPC_MoveSibling1,
/* 14934*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14937*/    OPC_RecordChild0, // #2 = $c
/* 14938*/    OPC_MoveChild1,
/* 14939*/    OPC_CheckImmAllOnesV,
/* 14940*/    OPC_MoveParent,
/* 14941*/    OPC_MoveParent,
/* 14942*/    OPC_MoveParent,
/* 14943*/    OPC_Scope, 44, /*->14989*/ // 2 children in Scope
/* 14945*/     OPC_CheckChild1Same, 1,
/* 14947*/     OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->14958
/* 14950*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14958*/     /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->14968
/* 14960*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 14968*/     /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->14978
/* 14970*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 14978*/     /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->14988
/* 14980*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 14988*/     0, // EndSwitchType
/* 14989*/    /*Scope*/ 12, /*->15002*/
/* 14990*/     OPC_CheckChild1Same, 0,
/* 14992*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14994*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15002*/    0, /*End of Scope*/
/* 15003*/   /*Scope*/ 37, /*->15041*/
/* 15004*/    OPC_MoveChild1,
/* 15005*/    OPC_CheckImmAllOnesV,
/* 15006*/    OPC_MoveParent,
/* 15007*/    OPC_MoveSibling1,
/* 15008*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15011*/    OPC_RecordChild0, // #1 = $v1
/* 15012*/    OPC_RecordChild1, // #2 = $v2
/* 15013*/    OPC_MoveParent,
/* 15014*/    OPC_MoveParent,
/* 15015*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 15017*/    OPC_Scope, 10, /*->15029*/ // 2 children in Scope
/* 15019*/     OPC_CheckChild1Same, 2,
/* 15021*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2)), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15029*/    /*Scope*/ 10, /*->15040*/
/* 15030*/     OPC_CheckChild1Same, 1,
/* 15032*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1)), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15040*/    0, /*End of Scope*/
/* 15041*/   0, /*End of Scope*/
/* 15042*/  /*Scope*/ 102, /*->15145*/
/* 15043*/   OPC_RecordChild0, // #0 = $v2
/* 15044*/   OPC_MoveChild1,
/* 15045*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15048*/   OPC_MoveChild0,
/* 15049*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15052*/   OPC_Scope, 23, /*->15077*/ // 3 children in Scope
/* 15054*/    OPC_RecordChild0, // #1 = $v1
/* 15055*/    OPC_CheckChild1Same, 0,
/* 15057*/    OPC_MoveSibling1,
/* 15058*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15061*/    OPC_RecordChild0, // #2 = $c
/* 15062*/    OPC_MoveChild1,
/* 15063*/    OPC_CheckImmAllOnesV,
/* 15064*/    OPC_MoveParent,
/* 15065*/    OPC_MoveParent,
/* 15066*/    OPC_MoveParent,
/* 15067*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 15069*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15077*/   /*Scope*/ 23, /*->15101*/
/* 15078*/    OPC_CheckChild0Same, 0,
/* 15080*/    OPC_RecordChild1, // #1 = $v1
/* 15081*/    OPC_MoveSibling1,
/* 15082*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15085*/    OPC_RecordChild0, // #2 = $c
/* 15086*/    OPC_MoveChild1,
/* 15087*/    OPC_CheckImmAllOnesV,
/* 15088*/    OPC_MoveParent,
/* 15089*/    OPC_MoveParent,
/* 15090*/    OPC_MoveParent,
/* 15091*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 15093*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15101*/   /*Scope*/ 42, /*->15144*/
/* 15102*/    OPC_RecordChild0, // #1 = $c
/* 15103*/    OPC_MoveChild1,
/* 15104*/    OPC_CheckImmAllOnesV,
/* 15105*/    OPC_MoveParent,
/* 15106*/    OPC_MoveSibling1,
/* 15107*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15110*/    OPC_Scope, 15, /*->15127*/ // 2 children in Scope
/* 15112*/     OPC_RecordChild0, // #2 = $v1
/* 15113*/     OPC_CheckChild1Same, 0,
/* 15115*/     OPC_MoveParent,
/* 15116*/     OPC_MoveParent,
/* 15117*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15119*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15127*/    /*Scope*/ 15, /*->15143*/
/* 15128*/     OPC_CheckChild0Same, 0,
/* 15130*/     OPC_RecordChild1, // #2 = $v1
/* 15131*/     OPC_MoveParent,
/* 15132*/     OPC_MoveParent,
/* 15133*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15135*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15143*/    0, /*End of Scope*/
/* 15144*/   0, /*End of Scope*/
/* 15145*/  /*Scope*/ 73, /*->15219*/
/* 15146*/   OPC_MoveChild0,
/* 15147*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15150*/   OPC_MoveChild0,
/* 15151*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15154*/   OPC_RecordChild0, // #0 = $v2
/* 15155*/   OPC_Scope, 23, /*->15180*/ // 2 children in Scope
/* 15157*/    OPC_RecordChild1, // #1 = $v1
/* 15158*/    OPC_MoveSibling1,
/* 15159*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15162*/    OPC_RecordChild0, // #2 = $c
/* 15163*/    OPC_MoveChild1,
/* 15164*/    OPC_CheckImmAllOnesV,
/* 15165*/    OPC_MoveParent,
/* 15166*/    OPC_MoveParent,
/* 15167*/    OPC_MoveParent,
/* 15168*/    OPC_CheckChild1Same, 0,
/* 15170*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15172*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15180*/   /*Scope*/ 37, /*->15218*/
/* 15181*/    OPC_MoveChild1,
/* 15182*/    OPC_CheckImmAllOnesV,
/* 15183*/    OPC_MoveParent,
/* 15184*/    OPC_MoveSibling1,
/* 15185*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15188*/    OPC_RecordChild0, // #1 = $v1
/* 15189*/    OPC_RecordChild1, // #2 = $v2
/* 15190*/    OPC_MoveParent,
/* 15191*/    OPC_MoveParent,
/* 15192*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15194*/    OPC_Scope, 10, /*->15206*/ // 2 children in Scope
/* 15196*/     OPC_CheckChild1Same, 2,
/* 15198*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2)), V128:{ *:[v8i16] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15206*/    /*Scope*/ 10, /*->15217*/
/* 15207*/     OPC_CheckChild1Same, 1,
/* 15209*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1)), V128:{ *:[v8i16] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15217*/    0, /*End of Scope*/
/* 15218*/   0, /*End of Scope*/
/* 15219*/  /*Scope*/ 102, /*->15322*/
/* 15220*/   OPC_RecordChild0, // #0 = $v2
/* 15221*/   OPC_MoveChild1,
/* 15222*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15225*/   OPC_MoveChild0,
/* 15226*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15229*/   OPC_Scope, 23, /*->15254*/ // 3 children in Scope
/* 15231*/    OPC_RecordChild0, // #1 = $v1
/* 15232*/    OPC_CheckChild1Same, 0,
/* 15234*/    OPC_MoveSibling1,
/* 15235*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15238*/    OPC_RecordChild0, // #2 = $c
/* 15239*/    OPC_MoveChild1,
/* 15240*/    OPC_CheckImmAllOnesV,
/* 15241*/    OPC_MoveParent,
/* 15242*/    OPC_MoveParent,
/* 15243*/    OPC_MoveParent,
/* 15244*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15246*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15254*/   /*Scope*/ 23, /*->15278*/
/* 15255*/    OPC_CheckChild0Same, 0,
/* 15257*/    OPC_RecordChild1, // #1 = $v1
/* 15258*/    OPC_MoveSibling1,
/* 15259*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15262*/    OPC_RecordChild0, // #2 = $c
/* 15263*/    OPC_MoveChild1,
/* 15264*/    OPC_CheckImmAllOnesV,
/* 15265*/    OPC_MoveParent,
/* 15266*/    OPC_MoveParent,
/* 15267*/    OPC_MoveParent,
/* 15268*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15270*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15278*/   /*Scope*/ 42, /*->15321*/
/* 15279*/    OPC_RecordChild0, // #1 = $c
/* 15280*/    OPC_MoveChild1,
/* 15281*/    OPC_CheckImmAllOnesV,
/* 15282*/    OPC_MoveParent,
/* 15283*/    OPC_MoveSibling1,
/* 15284*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15287*/    OPC_Scope, 15, /*->15304*/ // 2 children in Scope
/* 15289*/     OPC_RecordChild0, // #2 = $v1
/* 15290*/     OPC_CheckChild1Same, 0,
/* 15292*/     OPC_MoveParent,
/* 15293*/     OPC_MoveParent,
/* 15294*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 15296*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15304*/    /*Scope*/ 15, /*->15320*/
/* 15305*/     OPC_CheckChild0Same, 0,
/* 15307*/     OPC_RecordChild1, // #2 = $v1
/* 15308*/     OPC_MoveParent,
/* 15309*/     OPC_MoveParent,
/* 15310*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 15312*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15320*/    0, /*End of Scope*/
/* 15321*/   0, /*End of Scope*/
/* 15322*/  /*Scope*/ 73, /*->15396*/
/* 15323*/   OPC_MoveChild0,
/* 15324*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15327*/   OPC_MoveChild0,
/* 15328*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15331*/   OPC_RecordChild0, // #0 = $v2
/* 15332*/   OPC_Scope, 23, /*->15357*/ // 2 children in Scope
/* 15334*/    OPC_RecordChild1, // #1 = $v1
/* 15335*/    OPC_MoveSibling1,
/* 15336*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15339*/    OPC_RecordChild0, // #2 = $c
/* 15340*/    OPC_MoveChild1,
/* 15341*/    OPC_CheckImmAllOnesV,
/* 15342*/    OPC_MoveParent,
/* 15343*/    OPC_MoveParent,
/* 15344*/    OPC_MoveParent,
/* 15345*/    OPC_CheckChild1Same, 0,
/* 15347*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 15349*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15357*/   /*Scope*/ 37, /*->15395*/
/* 15358*/    OPC_MoveChild1,
/* 15359*/    OPC_CheckImmAllOnesV,
/* 15360*/    OPC_MoveParent,
/* 15361*/    OPC_MoveSibling1,
/* 15362*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15365*/    OPC_RecordChild0, // #1 = $v1
/* 15366*/    OPC_RecordChild1, // #2 = $v2
/* 15367*/    OPC_MoveParent,
/* 15368*/    OPC_MoveParent,
/* 15369*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 15371*/    OPC_Scope, 10, /*->15383*/ // 2 children in Scope
/* 15373*/     OPC_CheckChild1Same, 2,
/* 15375*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2)), V128:{ *:[v4i32] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15383*/    /*Scope*/ 10, /*->15394*/
/* 15384*/     OPC_CheckChild1Same, 1,
/* 15386*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1)), V128:{ *:[v4i32] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15394*/    0, /*End of Scope*/
/* 15395*/   0, /*End of Scope*/
/* 15396*/  /*Scope*/ 102, /*->15499*/
/* 15397*/   OPC_RecordChild0, // #0 = $v2
/* 15398*/   OPC_MoveChild1,
/* 15399*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15402*/   OPC_MoveChild0,
/* 15403*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15406*/   OPC_Scope, 23, /*->15431*/ // 3 children in Scope
/* 15408*/    OPC_RecordChild0, // #1 = $v1
/* 15409*/    OPC_CheckChild1Same, 0,
/* 15411*/    OPC_MoveSibling1,
/* 15412*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15415*/    OPC_RecordChild0, // #2 = $c
/* 15416*/    OPC_MoveChild1,
/* 15417*/    OPC_CheckImmAllOnesV,
/* 15418*/    OPC_MoveParent,
/* 15419*/    OPC_MoveParent,
/* 15420*/    OPC_MoveParent,
/* 15421*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 15423*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15431*/   /*Scope*/ 23, /*->15455*/
/* 15432*/    OPC_CheckChild0Same, 0,
/* 15434*/    OPC_RecordChild1, // #1 = $v1
/* 15435*/    OPC_MoveSibling1,
/* 15436*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15439*/    OPC_RecordChild0, // #2 = $c
/* 15440*/    OPC_MoveChild1,
/* 15441*/    OPC_CheckImmAllOnesV,
/* 15442*/    OPC_MoveParent,
/* 15443*/    OPC_MoveParent,
/* 15444*/    OPC_MoveParent,
/* 15445*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 15447*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15455*/   /*Scope*/ 42, /*->15498*/
/* 15456*/    OPC_RecordChild0, // #1 = $c
/* 15457*/    OPC_MoveChild1,
/* 15458*/    OPC_CheckImmAllOnesV,
/* 15459*/    OPC_MoveParent,
/* 15460*/    OPC_MoveSibling1,
/* 15461*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15464*/    OPC_Scope, 15, /*->15481*/ // 2 children in Scope
/* 15466*/     OPC_RecordChild0, // #2 = $v1
/* 15467*/     OPC_CheckChild1Same, 0,
/* 15469*/     OPC_MoveParent,
/* 15470*/     OPC_MoveParent,
/* 15471*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 15473*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15481*/    /*Scope*/ 15, /*->15497*/
/* 15482*/     OPC_CheckChild0Same, 0,
/* 15484*/     OPC_RecordChild1, // #2 = $v1
/* 15485*/     OPC_MoveParent,
/* 15486*/     OPC_MoveParent,
/* 15487*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 15489*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15497*/    0, /*End of Scope*/
/* 15498*/   0, /*End of Scope*/
/* 15499*/  /*Scope*/ 73, /*->15573*/
/* 15500*/   OPC_MoveChild0,
/* 15501*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15504*/   OPC_MoveChild0,
/* 15505*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15508*/   OPC_RecordChild0, // #0 = $v2
/* 15509*/   OPC_Scope, 23, /*->15534*/ // 2 children in Scope
/* 15511*/    OPC_RecordChild1, // #1 = $v1
/* 15512*/    OPC_MoveSibling1,
/* 15513*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15516*/    OPC_RecordChild0, // #2 = $c
/* 15517*/    OPC_MoveChild1,
/* 15518*/    OPC_CheckImmAllOnesV,
/* 15519*/    OPC_MoveParent,
/* 15520*/    OPC_MoveParent,
/* 15521*/    OPC_MoveParent,
/* 15522*/    OPC_CheckChild1Same, 0,
/* 15524*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 15526*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15534*/   /*Scope*/ 37, /*->15572*/
/* 15535*/    OPC_MoveChild1,
/* 15536*/    OPC_CheckImmAllOnesV,
/* 15537*/    OPC_MoveParent,
/* 15538*/    OPC_MoveSibling1,
/* 15539*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15542*/    OPC_RecordChild0, // #1 = $v1
/* 15543*/    OPC_RecordChild1, // #2 = $v2
/* 15544*/    OPC_MoveParent,
/* 15545*/    OPC_MoveParent,
/* 15546*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 15548*/    OPC_Scope, 10, /*->15560*/ // 2 children in Scope
/* 15550*/     OPC_CheckChild1Same, 2,
/* 15552*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2)), V128:{ *:[v2i64] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15560*/    /*Scope*/ 10, /*->15571*/
/* 15561*/     OPC_CheckChild1Same, 1,
/* 15563*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1)), V128:{ *:[v2i64] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15571*/    0, /*End of Scope*/
/* 15572*/   0, /*End of Scope*/
/* 15573*/  /*Scope*/ 102, /*->15676*/
/* 15574*/   OPC_RecordChild0, // #0 = $v2
/* 15575*/   OPC_MoveChild1,
/* 15576*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15579*/   OPC_MoveChild0,
/* 15580*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15583*/   OPC_Scope, 23, /*->15608*/ // 3 children in Scope
/* 15585*/    OPC_RecordChild0, // #1 = $v1
/* 15586*/    OPC_CheckChild1Same, 0,
/* 15588*/    OPC_MoveSibling1,
/* 15589*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15592*/    OPC_RecordChild0, // #2 = $c
/* 15593*/    OPC_MoveChild1,
/* 15594*/    OPC_CheckImmAllOnesV,
/* 15595*/    OPC_MoveParent,
/* 15596*/    OPC_MoveParent,
/* 15597*/    OPC_MoveParent,
/* 15598*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 15600*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15608*/   /*Scope*/ 23, /*->15632*/
/* 15609*/    OPC_CheckChild0Same, 0,
/* 15611*/    OPC_RecordChild1, // #1 = $v1
/* 15612*/    OPC_MoveSibling1,
/* 15613*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15616*/    OPC_RecordChild0, // #2 = $c
/* 15617*/    OPC_MoveChild1,
/* 15618*/    OPC_CheckImmAllOnesV,
/* 15619*/    OPC_MoveParent,
/* 15620*/    OPC_MoveParent,
/* 15621*/    OPC_MoveParent,
/* 15622*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 15624*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15632*/   /*Scope*/ 42, /*->15675*/
/* 15633*/    OPC_RecordChild0, // #1 = $c
/* 15634*/    OPC_MoveChild1,
/* 15635*/    OPC_CheckImmAllOnesV,
/* 15636*/    OPC_MoveParent,
/* 15637*/    OPC_MoveSibling1,
/* 15638*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15641*/    OPC_Scope, 15, /*->15658*/ // 2 children in Scope
/* 15643*/     OPC_RecordChild0, // #2 = $v1
/* 15644*/     OPC_CheckChild1Same, 0,
/* 15646*/     OPC_MoveParent,
/* 15647*/     OPC_MoveParent,
/* 15648*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 15650*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15658*/    /*Scope*/ 15, /*->15674*/
/* 15659*/     OPC_CheckChild0Same, 0,
/* 15661*/     OPC_RecordChild1, // #2 = $v1
/* 15662*/     OPC_MoveParent,
/* 15663*/     OPC_MoveParent,
/* 15664*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 15666*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15674*/    0, /*End of Scope*/
/* 15675*/   0, /*End of Scope*/
/* 15676*/  /*Scope*/ 112, /*->15789*/
/* 15677*/   OPC_MoveChild0,
/* 15678*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15681*/   OPC_Scope, 69, /*->15752*/ // 2 children in Scope
/* 15683*/    OPC_MoveChild0,
/* 15684*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15687*/    OPC_RecordChild0, // #0 = $v1
/* 15688*/    OPC_RecordChild1, // #1 = $v2
/* 15689*/    OPC_MoveParent,
/* 15690*/    OPC_RecordChild1, // #2 = $c
/* 15691*/    OPC_MoveParent,
/* 15692*/    OPC_Scope, 44, /*->15738*/ // 2 children in Scope
/* 15694*/     OPC_CheckChild1Same, 1,
/* 15696*/     OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->15707
/* 15699*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15707*/     /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->15717
/* 15709*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15717*/     /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->15727
/* 15719*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15727*/     /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->15737
/* 15729*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15737*/     0, // EndSwitchType
/* 15738*/    /*Scope*/ 12, /*->15751*/
/* 15739*/     OPC_CheckChild1Same, 0,
/* 15741*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15743*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15751*/    0, /*End of Scope*/
/* 15752*/   /*Scope*/ 35, /*->15788*/
/* 15753*/    OPC_RecordChild0, // #0 = $c
/* 15754*/    OPC_MoveChild1,
/* 15755*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15758*/    OPC_RecordChild0, // #1 = $v1
/* 15759*/    OPC_RecordChild1, // #2 = $v2
/* 15760*/    OPC_MoveParent,
/* 15761*/    OPC_MoveParent,
/* 15762*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 15764*/    OPC_Scope, 10, /*->15776*/ // 2 children in Scope
/* 15766*/     OPC_CheckChild1Same, 2,
/* 15768*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2)), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15776*/    /*Scope*/ 10, /*->15787*/
/* 15777*/     OPC_CheckChild1Same, 1,
/* 15779*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1)), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15787*/    0, /*End of Scope*/
/* 15788*/   0, /*End of Scope*/
/* 15789*/  /*Scope*/ 88, /*->15878*/
/* 15790*/   OPC_RecordChild0, // #0 = $v2
/* 15791*/   OPC_MoveChild1,
/* 15792*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15795*/   OPC_Scope, 40, /*->15837*/ // 2 children in Scope
/* 15797*/    OPC_MoveChild0,
/* 15798*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15801*/    OPC_Scope, 16, /*->15819*/ // 2 children in Scope
/* 15803*/     OPC_RecordChild0, // #1 = $v1
/* 15804*/     OPC_CheckChild1Same, 0,
/* 15806*/     OPC_MoveParent,
/* 15807*/     OPC_RecordChild1, // #2 = $c
/* 15808*/     OPC_MoveParent,
/* 15809*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15811*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), V128:{ *:[v16i8] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15819*/    /*Scope*/ 16, /*->15836*/
/* 15820*/     OPC_CheckChild0Same, 0,
/* 15822*/     OPC_RecordChild1, // #1 = $v1
/* 15823*/     OPC_MoveParent,
/* 15824*/     OPC_RecordChild1, // #2 = $c
/* 15825*/     OPC_MoveParent,
/* 15826*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15828*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), V128:{ *:[v16i8] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15836*/    0, /*End of Scope*/
/* 15837*/   /*Scope*/ 39, /*->15877*/
/* 15838*/    OPC_RecordChild0, // #1 = $c
/* 15839*/    OPC_MoveChild1,
/* 15840*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15843*/    OPC_Scope, 15, /*->15860*/ // 2 children in Scope
/* 15845*/     OPC_RecordChild0, // #2 = $v1
/* 15846*/     OPC_CheckChild1Same, 0,
/* 15848*/     OPC_MoveParent,
/* 15849*/     OPC_MoveParent,
/* 15850*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15852*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15860*/    /*Scope*/ 15, /*->15876*/
/* 15861*/     OPC_CheckChild0Same, 0,
/* 15863*/     OPC_RecordChild1, // #2 = $v1
/* 15864*/     OPC_MoveParent,
/* 15865*/     OPC_MoveParent,
/* 15866*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15868*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15876*/    0, /*End of Scope*/
/* 15877*/   0, /*End of Scope*/
/* 15878*/  /*Scope*/ 64, /*->15943*/
/* 15879*/   OPC_MoveChild0,
/* 15880*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15883*/   OPC_Scope, 21, /*->15906*/ // 2 children in Scope
/* 15885*/    OPC_MoveChild0,
/* 15886*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15889*/    OPC_RecordChild0, // #0 = $v2
/* 15890*/    OPC_RecordChild1, // #1 = $v1
/* 15891*/    OPC_MoveParent,
/* 15892*/    OPC_RecordChild1, // #2 = $c
/* 15893*/    OPC_MoveParent,
/* 15894*/    OPC_CheckChild1Same, 0,
/* 15896*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15898*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15906*/   /*Scope*/ 35, /*->15942*/
/* 15907*/    OPC_RecordChild0, // #0 = $c
/* 15908*/    OPC_MoveChild1,
/* 15909*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15912*/    OPC_RecordChild0, // #1 = $v1
/* 15913*/    OPC_RecordChild1, // #2 = $v2
/* 15914*/    OPC_MoveParent,
/* 15915*/    OPC_MoveParent,
/* 15916*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15918*/    OPC_Scope, 10, /*->15930*/ // 2 children in Scope
/* 15920*/     OPC_CheckChild1Same, 2,
/* 15922*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2)), V128:{ *:[v8i16] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15930*/    /*Scope*/ 10, /*->15941*/
/* 15931*/     OPC_CheckChild1Same, 1,
/* 15933*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1)), V128:{ *:[v8i16] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15941*/    0, /*End of Scope*/
/* 15942*/   0, /*End of Scope*/
/* 15943*/  /*Scope*/ 88, /*->16032*/
/* 15944*/   OPC_RecordChild0, // #0 = $v2
/* 15945*/   OPC_MoveChild1,
/* 15946*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15949*/   OPC_Scope, 40, /*->15991*/ // 2 children in Scope
/* 15951*/    OPC_MoveChild0,
/* 15952*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15955*/    OPC_Scope, 16, /*->15973*/ // 2 children in Scope
/* 15957*/     OPC_RecordChild0, // #1 = $v1
/* 15958*/     OPC_CheckChild1Same, 0,
/* 15960*/     OPC_MoveParent,
/* 15961*/     OPC_RecordChild1, // #2 = $c
/* 15962*/     OPC_MoveParent,
/* 15963*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 15965*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), V128:{ *:[v8i16] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15973*/    /*Scope*/ 16, /*->15990*/
/* 15974*/     OPC_CheckChild0Same, 0,
/* 15976*/     OPC_RecordChild1, // #1 = $v1
/* 15977*/     OPC_MoveParent,
/* 15978*/     OPC_RecordChild1, // #2 = $c
/* 15979*/     OPC_MoveParent,
/* 15980*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 15982*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), V128:{ *:[v8i16] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15990*/    0, /*End of Scope*/
/* 15991*/   /*Scope*/ 39, /*->16031*/
/* 15992*/    OPC_RecordChild0, // #1 = $c
/* 15993*/    OPC_MoveChild1,
/* 15994*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15997*/    OPC_Scope, 15, /*->16014*/ // 2 children in Scope
/* 15999*/     OPC_RecordChild0, // #2 = $v1
/* 16000*/     OPC_CheckChild1Same, 0,
/* 16002*/     OPC_MoveParent,
/* 16003*/     OPC_MoveParent,
/* 16004*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 16006*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16014*/    /*Scope*/ 15, /*->16030*/
/* 16015*/     OPC_CheckChild0Same, 0,
/* 16017*/     OPC_RecordChild1, // #2 = $v1
/* 16018*/     OPC_MoveParent,
/* 16019*/     OPC_MoveParent,
/* 16020*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 16022*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16030*/    0, /*End of Scope*/
/* 16031*/   0, /*End of Scope*/
/* 16032*/  /*Scope*/ 64, /*->16097*/
/* 16033*/   OPC_MoveChild0,
/* 16034*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16037*/   OPC_Scope, 21, /*->16060*/ // 2 children in Scope
/* 16039*/    OPC_MoveChild0,
/* 16040*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16043*/    OPC_RecordChild0, // #0 = $v2
/* 16044*/    OPC_RecordChild1, // #1 = $v1
/* 16045*/    OPC_MoveParent,
/* 16046*/    OPC_RecordChild1, // #2 = $c
/* 16047*/    OPC_MoveParent,
/* 16048*/    OPC_CheckChild1Same, 0,
/* 16050*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 16052*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16060*/   /*Scope*/ 35, /*->16096*/
/* 16061*/    OPC_RecordChild0, // #0 = $c
/* 16062*/    OPC_MoveChild1,
/* 16063*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16066*/    OPC_RecordChild0, // #1 = $v1
/* 16067*/    OPC_RecordChild1, // #2 = $v2
/* 16068*/    OPC_MoveParent,
/* 16069*/    OPC_MoveParent,
/* 16070*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 16072*/    OPC_Scope, 10, /*->16084*/ // 2 children in Scope
/* 16074*/     OPC_CheckChild1Same, 2,
/* 16076*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2)), V128:{ *:[v4i32] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16084*/    /*Scope*/ 10, /*->16095*/
/* 16085*/     OPC_CheckChild1Same, 1,
/* 16087*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1)), V128:{ *:[v4i32] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16095*/    0, /*End of Scope*/
/* 16096*/   0, /*End of Scope*/
/* 16097*/  /*Scope*/ 88, /*->16186*/
/* 16098*/   OPC_RecordChild0, // #0 = $v2
/* 16099*/   OPC_MoveChild1,
/* 16100*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16103*/   OPC_Scope, 40, /*->16145*/ // 2 children in Scope
/* 16105*/    OPC_MoveChild0,
/* 16106*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16109*/    OPC_Scope, 16, /*->16127*/ // 2 children in Scope
/* 16111*/     OPC_RecordChild0, // #1 = $v1
/* 16112*/     OPC_CheckChild1Same, 0,
/* 16114*/     OPC_MoveParent,
/* 16115*/     OPC_RecordChild1, // #2 = $c
/* 16116*/     OPC_MoveParent,
/* 16117*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 16119*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), V128:{ *:[v4i32] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16127*/    /*Scope*/ 16, /*->16144*/
/* 16128*/     OPC_CheckChild0Same, 0,
/* 16130*/     OPC_RecordChild1, // #1 = $v1
/* 16131*/     OPC_MoveParent,
/* 16132*/     OPC_RecordChild1, // #2 = $c
/* 16133*/     OPC_MoveParent,
/* 16134*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 16136*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), V128:{ *:[v4i32] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16144*/    0, /*End of Scope*/
/* 16145*/   /*Scope*/ 39, /*->16185*/
/* 16146*/    OPC_RecordChild0, // #1 = $c
/* 16147*/    OPC_MoveChild1,
/* 16148*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16151*/    OPC_Scope, 15, /*->16168*/ // 2 children in Scope
/* 16153*/     OPC_RecordChild0, // #2 = $v1
/* 16154*/     OPC_CheckChild1Same, 0,
/* 16156*/     OPC_MoveParent,
/* 16157*/     OPC_MoveParent,
/* 16158*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 16160*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16168*/    /*Scope*/ 15, /*->16184*/
/* 16169*/     OPC_CheckChild0Same, 0,
/* 16171*/     OPC_RecordChild1, // #2 = $v1
/* 16172*/     OPC_MoveParent,
/* 16173*/     OPC_MoveParent,
/* 16174*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 16176*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16184*/    0, /*End of Scope*/
/* 16185*/   0, /*End of Scope*/
/* 16186*/  /*Scope*/ 64, /*->16251*/
/* 16187*/   OPC_MoveChild0,
/* 16188*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16191*/   OPC_Scope, 21, /*->16214*/ // 2 children in Scope
/* 16193*/    OPC_MoveChild0,
/* 16194*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16197*/    OPC_RecordChild0, // #0 = $v2
/* 16198*/    OPC_RecordChild1, // #1 = $v1
/* 16199*/    OPC_MoveParent,
/* 16200*/    OPC_RecordChild1, // #2 = $c
/* 16201*/    OPC_MoveParent,
/* 16202*/    OPC_CheckChild1Same, 0,
/* 16204*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 16206*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16214*/   /*Scope*/ 35, /*->16250*/
/* 16215*/    OPC_RecordChild0, // #0 = $c
/* 16216*/    OPC_MoveChild1,
/* 16217*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16220*/    OPC_RecordChild0, // #1 = $v1
/* 16221*/    OPC_RecordChild1, // #2 = $v2
/* 16222*/    OPC_MoveParent,
/* 16223*/    OPC_MoveParent,
/* 16224*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 16226*/    OPC_Scope, 10, /*->16238*/ // 2 children in Scope
/* 16228*/     OPC_CheckChild1Same, 2,
/* 16230*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2)), V128:{ *:[v2i64] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16238*/    /*Scope*/ 10, /*->16249*/
/* 16239*/     OPC_CheckChild1Same, 1,
/* 16241*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1)), V128:{ *:[v2i64] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16249*/    0, /*End of Scope*/
/* 16250*/   0, /*End of Scope*/
/* 16251*/  /*Scope*/ 43|128,1/*171*/, /*->16424*/
/* 16253*/   OPC_RecordChild0, // #0 = $v2
/* 16254*/   OPC_Scope, 127, /*->16383*/ // 2 children in Scope
/* 16256*/    OPC_MoveChild1,
/* 16257*/    OPC_Scope, 86, /*->16345*/ // 2 children in Scope
/* 16259*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16262*/     OPC_Scope, 40, /*->16304*/ // 2 children in Scope
/* 16264*/      OPC_MoveChild0,
/* 16265*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16268*/      OPC_Scope, 16, /*->16286*/ // 2 children in Scope
/* 16270*/       OPC_RecordChild0, // #1 = $v1
/* 16271*/       OPC_CheckChild1Same, 0,
/* 16273*/       OPC_MoveParent,
/* 16274*/       OPC_RecordChild1, // #2 = $c
/* 16275*/       OPC_MoveParent,
/* 16276*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 16278*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     /*MVT::v2i64*/78, 3/*#Ops*/, 1, 0, 2, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), V128:{ *:[v2i64] }:$c)) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16286*/      /*Scope*/ 16, /*->16303*/
/* 16287*/       OPC_CheckChild0Same, 0,
/* 16289*/       OPC_RecordChild1, // #1 = $v1
/* 16290*/       OPC_MoveParent,
/* 16291*/       OPC_RecordChild1, // #2 = $c
/* 16292*/       OPC_MoveParent,
/* 16293*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 16295*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     /*MVT::v2i64*/78, 3/*#Ops*/, 1, 0, 2, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), V128:{ *:[v2i64] }:$c)) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16303*/      0, /*End of Scope*/
/* 16304*/     /*Scope*/ 39, /*->16344*/
/* 16305*/      OPC_RecordChild0, // #1 = $c
/* 16306*/      OPC_MoveChild1,
/* 16307*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16310*/      OPC_Scope, 15, /*->16327*/ // 2 children in Scope
/* 16312*/       OPC_RecordChild0, // #2 = $v1
/* 16313*/       OPC_CheckChild1Same, 0,
/* 16315*/       OPC_MoveParent,
/* 16316*/       OPC_MoveParent,
/* 16317*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 16319*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     /*MVT::v2i64*/78, 3/*#Ops*/, 2, 0, 1, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2))) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16327*/      /*Scope*/ 15, /*->16343*/
/* 16328*/       OPC_CheckChild0Same, 0,
/* 16330*/       OPC_RecordChild1, // #2 = $v1
/* 16331*/       OPC_MoveParent,
/* 16332*/       OPC_MoveParent,
/* 16333*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 16335*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     /*MVT::v2i64*/78, 3/*#Ops*/, 2, 0, 1, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1))) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16343*/      0, /*End of Scope*/
/* 16344*/     0, /*End of Scope*/
/* 16345*/    /*Scope*/ 36, /*->16382*/
/* 16346*/     OPC_CheckImmAllOnesV,
/* 16347*/     OPC_MoveParent,
/* 16348*/     OPC_SwitchType /*4 cases */, 6, /*MVT::v16i8*/39, // ->16357
/* 16351*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v, immAllOnesV:{ *:[v16i8] }) - Complexity = 7
                // Dst: (NOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v)
/* 16357*/     /*SwitchType*/ 6, /*MVT::v8i16*/50, // ->16365
/* 16359*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v, immAllOnesV:{ *:[v8i16] }) - Complexity = 7
                // Dst: (NOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v)
/* 16365*/     /*SwitchType*/ 6, /*MVT::v4i32*/60, // ->16373
/* 16367*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v, immAllOnesV:{ *:[v4i32] }) - Complexity = 7
                // Dst: (NOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v)
/* 16373*/     /*SwitchType*/ 6, /*MVT::v2i64*/78, // ->16381
/* 16375*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v, immAllOnesV:{ *:[v2i64] }) - Complexity = 7
                // Dst: (NOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v)
/* 16381*/     0, // EndSwitchType
/* 16382*/    0, /*End of Scope*/
/* 16383*/   /*Scope*/ 39, /*->16423*/
/* 16384*/    OPC_RecordChild1, // #1 = $rhs
/* 16385*/    OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->16395
/* 16388*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 16395*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->16404
/* 16397*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 16404*/    /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->16413
/* 16406*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 16413*/    /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->16422
/* 16415*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 16422*/    0, // EndSwitchType
/* 16423*/   0, /*End of Scope*/
/* 16424*/  0, /*End of Scope*/
/* 16425*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CTLZ),// ->16449
/* 16428*/  OPC_RecordChild0, // #0 = $src
/* 16429*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->16439
/* 16432*/   OPC_CheckChild0TypeI32,
/* 16433*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CLZ_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CLZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16439*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->16448
/* 16441*/   OPC_CheckChild0TypeI64,
/* 16442*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CLZ_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CLZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16448*/  0, // EndSwitchType
/* 16449*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CTTZ),// ->16473
/* 16452*/  OPC_RecordChild0, // #0 = $src
/* 16453*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->16463
/* 16456*/   OPC_CheckChild0TypeI32,
/* 16457*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CTZ_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CTZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16463*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->16472
/* 16465*/   OPC_CheckChild0TypeI64,
/* 16466*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CTZ_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CTZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16472*/  0, // EndSwitchType
/* 16473*/ /*SwitchOpcode*/ 32, TARGET_VAL(ISD::CTPOP),// ->16508
/* 16476*/  OPC_RecordChild0, // #0 = $src
/* 16477*/  OPC_SwitchType /*3 cases */, 7, /*MVT::i32*/7, // ->16487
/* 16480*/   OPC_CheckChild0TypeI32,
/* 16481*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (POPCNT_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16487*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->16496
/* 16489*/   OPC_CheckChild0TypeI64,
/* 16490*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (POPCNT_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16496*/  /*SwitchType*/ 9, /*MVT::v16i8*/39, // ->16507
/* 16498*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 16500*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16501*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I8x16),
                 /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (POPCNT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 16507*/  0, // EndSwitchType
/* 16508*/ /*SwitchOpcode*/ 22, TARGET_VAL(WebAssemblyISD::I64_ADD128),// ->16533
/* 16511*/  OPC_RecordChild0, // #0 = $a
/* 16512*/  OPC_CheckChild0TypeI64,
/* 16513*/  OPC_RecordChild1, // #1 = $b
/* 16514*/  OPC_CheckChild1TypeI64,
/* 16515*/  OPC_RecordChild2, // #2 = $c
/* 16516*/  OPC_CheckChild2TypeI64,
/* 16517*/  OPC_RecordChild3, // #3 = $d
/* 16518*/  OPC_CheckChild3TypeI64,
/* 16519*/  OPC_CheckTypeI64,
/* 16520*/  OPC_CheckTypeRes, 1, /*MVT::i64*/8, 
/* 16523*/  OPC_MorphNodeTo2None, TARGET_VAL(WebAssembly::I64_ADD128),
                /*MVT::i64*/8, /*MVT::i64*/8, 4/*#Ops*/, 0, 1, 2, 3, 
            // Src: (wasm_add128:{ *:[i64] }:{ *:[i64] } I64:{ *:[i64] }:$a, I64:{ *:[i64] }:$b, I64:{ *:[i64] }:$c, I64:{ *:[i64] }:$d) - Complexity = 3
            // Dst: (I64_ADD128:{ *:[i64] }:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b, ?:{ *:[i64] }:$c, ?:{ *:[i64] }:$d)
/* 16533*/ /*SwitchOpcode*/ 22, TARGET_VAL(WebAssemblyISD::I64_SUB128),// ->16558
/* 16536*/  OPC_RecordChild0, // #0 = $a
/* 16537*/  OPC_CheckChild0TypeI64,
/* 16538*/  OPC_RecordChild1, // #1 = $b
/* 16539*/  OPC_CheckChild1TypeI64,
/* 16540*/  OPC_RecordChild2, // #2 = $c
/* 16541*/  OPC_CheckChild2TypeI64,
/* 16542*/  OPC_RecordChild3, // #3 = $d
/* 16543*/  OPC_CheckChild3TypeI64,
/* 16544*/  OPC_CheckTypeI64,
/* 16545*/  OPC_CheckTypeRes, 1, /*MVT::i64*/8, 
/* 16548*/  OPC_MorphNodeTo2None, TARGET_VAL(WebAssembly::I64_SUB128),
                /*MVT::i64*/8, /*MVT::i64*/8, 4/*#Ops*/, 0, 1, 2, 3, 
            // Src: (wasm_sub128:{ *:[i64] }:{ *:[i64] } I64:{ *:[i64] }:$a, I64:{ *:[i64] }:$b, I64:{ *:[i64] }:$c, I64:{ *:[i64] }:$d) - Complexity = 3
            // Dst: (I64_SUB128:{ *:[i64] }:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b, ?:{ *:[i64] }:$c, ?:{ *:[i64] }:$d)
/* 16558*/ /*SwitchOpcode*/ 16, TARGET_VAL(WebAssemblyISD::I64_MUL_WIDE_S),// ->16577
/* 16561*/  OPC_RecordChild0, // #0 = $x
/* 16562*/  OPC_CheckChild0TypeI64,
/* 16563*/  OPC_RecordChild1, // #1 = $y
/* 16564*/  OPC_CheckChild1TypeI64,
/* 16565*/  OPC_CheckTypeI64,
/* 16566*/  OPC_CheckTypeRes, 1, /*MVT::i64*/8, 
/* 16569*/  OPC_MorphNodeTo2None, TARGET_VAL(WebAssembly::I64_MUL_WIDE_S),
                /*MVT::i64*/8, /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
            // Src: (wasm_mul_wide_s:{ *:[i64] }:{ *:[i64] } I64:{ *:[i64] }:$x, I64:{ *:[i64] }:$y) - Complexity = 3
            // Dst: (I64_MUL_WIDE_S:{ *:[i64] }:{ *:[i64] } ?:{ *:[i64] }:$x, ?:{ *:[i64] }:$y)
/* 16577*/ /*SwitchOpcode*/ 16, TARGET_VAL(WebAssemblyISD::I64_MUL_WIDE_U),// ->16596
/* 16580*/  OPC_RecordChild0, // #0 = $x
/* 16581*/  OPC_CheckChild0TypeI64,
/* 16582*/  OPC_RecordChild1, // #1 = $y
/* 16583*/  OPC_CheckChild1TypeI64,
/* 16584*/  OPC_CheckTypeI64,
/* 16585*/  OPC_CheckTypeRes, 1, /*MVT::i64*/8, 
/* 16588*/  OPC_MorphNodeTo2None, TARGET_VAL(WebAssembly::I64_MUL_WIDE_U),
                /*MVT::i64*/8, /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
            // Src: (wasm_mul_wide_u:{ *:[i64] }:{ *:[i64] } I64:{ *:[i64] }:$x, I64:{ *:[i64] }:$y) - Complexity = 3
            // Dst: (I64_MUL_WIDE_U:{ *:[i64] }:{ *:[i64] } ?:{ *:[i64] }:$x, ?:{ *:[i64] }:$y)
/* 16596*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::TRUNCATE),// ->16606
/* 16599*/  OPC_RecordChild0, // #0 = $src
/* 16600*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                /*MVT::i32*/7, 1/*#Ops*/, 0, 
            // Src: (trunc:{ *:[i32] } I64:{ *:[i64] }:$src) - Complexity = 3
            // Dst: (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/* 16606*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::SIGN_EXTEND),// ->16616
/* 16609*/  OPC_RecordChild0, // #0 = $src
/* 16610*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_S_I32),
                /*MVT::i64*/8, 1/*#Ops*/, 0, 
            // Src: (sext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
            // Dst: (I64_EXTEND_S_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/* 16616*/ /*SwitchOpcode*/ 121, TARGET_VAL(ISD::FP_TO_SINT),// ->16740
/* 16619*/  OPC_RecordChild0, // #0 = $src
/* 16620*/  OPC_Scope, 48, /*->16670*/ // 4 children in Scope
/* 16622*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 16624*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->16647
/* 16627*/    OPC_Scope, 8, /*->16637*/ // 2 children in Scope
/* 16629*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16631*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16637*/    /*Scope*/ 8, /*->16646*/
/* 16638*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16640*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16646*/    0, /*End of Scope*/
/* 16647*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->16669
/* 16649*/    OPC_Scope, 8, /*->16659*/ // 2 children in Scope
/* 16651*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16653*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16659*/    /*Scope*/ 8, /*->16668*/
/* 16660*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16662*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16668*/    0, /*End of Scope*/
/* 16669*/   0, // EndSwitchType
/* 16670*/  /*Scope*/ 48, /*->16719*/
/* 16671*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 16673*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->16696
/* 16676*/    OPC_Scope, 8, /*->16686*/ // 2 children in Scope
/* 16678*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16680*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16686*/    /*Scope*/ 8, /*->16695*/
/* 16687*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16689*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16695*/    0, /*End of Scope*/
/* 16696*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->16718
/* 16698*/    OPC_Scope, 8, /*->16708*/ // 2 children in Scope
/* 16700*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16702*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16708*/    /*Scope*/ 8, /*->16717*/
/* 16709*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16711*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16717*/    0, /*End of Scope*/
/* 16718*/   0, // EndSwitchType
/* 16719*/  /*Scope*/ 9, /*->16729*/
/* 16720*/   OPC_CheckType, /*MVT::v4i32*/60, 
/* 16722*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16723*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 16729*/  /*Scope*/ 9, /*->16739*/
/* 16730*/   OPC_CheckType, /*MVT::v8i16*/50, 
/* 16732*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 16733*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$vec) - Complexity = 3
             // Dst: (fp_to_sint_I16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$vec)
/* 16739*/  0, /*End of Scope*/
/* 16740*/ /*SwitchOpcode*/ 121, TARGET_VAL(ISD::FP_TO_UINT),// ->16864
/* 16743*/  OPC_RecordChild0, // #0 = $src
/* 16744*/  OPC_Scope, 48, /*->16794*/ // 4 children in Scope
/* 16746*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 16748*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->16771
/* 16751*/    OPC_Scope, 8, /*->16761*/ // 2 children in Scope
/* 16753*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16755*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16761*/    /*Scope*/ 8, /*->16770*/
/* 16762*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16764*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16770*/    0, /*End of Scope*/
/* 16771*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->16793
/* 16773*/    OPC_Scope, 8, /*->16783*/ // 2 children in Scope
/* 16775*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16777*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16783*/    /*Scope*/ 8, /*->16792*/
/* 16784*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16786*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16792*/    0, /*End of Scope*/
/* 16793*/   0, // EndSwitchType
/* 16794*/  /*Scope*/ 48, /*->16843*/
/* 16795*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 16797*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->16820
/* 16800*/    OPC_Scope, 8, /*->16810*/ // 2 children in Scope
/* 16802*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16804*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16810*/    /*Scope*/ 8, /*->16819*/
/* 16811*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16813*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16819*/    0, /*End of Scope*/
/* 16820*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->16842
/* 16822*/    OPC_Scope, 8, /*->16832*/ // 2 children in Scope
/* 16824*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16826*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16832*/    /*Scope*/ 8, /*->16841*/
/* 16833*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16835*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16841*/    0, /*End of Scope*/
/* 16842*/   0, // EndSwitchType
/* 16843*/  /*Scope*/ 9, /*->16853*/
/* 16844*/   OPC_CheckType, /*MVT::v4i32*/60, 
/* 16846*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16847*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 16853*/  /*Scope*/ 9, /*->16863*/
/* 16854*/   OPC_CheckType, /*MVT::v8i16*/50, 
/* 16856*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 16857*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$vec) - Complexity = 3
             // Dst: (fp_to_uint_I16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$vec)
/* 16863*/  0, /*End of Scope*/
/* 16864*/ /*SwitchOpcode*/ 87, TARGET_VAL(ISD::FP_TO_SINT_SAT),// ->16954
/* 16867*/  OPC_RecordChild0, // #0 = $src
/* 16868*/  OPC_Scope, 27, /*->16897*/ // 3 children in Scope
/* 16870*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 16872*/   OPC_MoveChild1,
/* 16873*/   OPC_Scope, 10, /*->16885*/ // 2 children in Scope
/* 16875*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 16877*/    OPC_MoveParent,
/* 16878*/    OPC_CheckTypeI32,
/* 16879*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16885*/   /*Scope*/ 10, /*->16896*/
/* 16886*/    OPC_CheckValueType, /*MVT::i64*/8, 
/* 16888*/    OPC_MoveParent,
/* 16889*/    OPC_CheckTypeI64,
/* 16890*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16896*/   0, /*End of Scope*/
/* 16897*/  /*Scope*/ 27, /*->16925*/
/* 16898*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 16900*/   OPC_MoveChild1,
/* 16901*/   OPC_Scope, 10, /*->16913*/ // 2 children in Scope
/* 16903*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 16905*/    OPC_MoveParent,
/* 16906*/    OPC_CheckTypeI32,
/* 16907*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16913*/   /*Scope*/ 10, /*->16924*/
/* 16914*/    OPC_CheckValueType, /*MVT::i64*/8, 
/* 16916*/    OPC_MoveParent,
/* 16917*/    OPC_CheckTypeI64,
/* 16918*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16924*/   0, /*End of Scope*/
/* 16925*/  /*Scope*/ 27, /*->16953*/
/* 16926*/   OPC_MoveChild1,
/* 16927*/   OPC_Scope, 11, /*->16940*/ // 2 children in Scope
/* 16929*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 16931*/    OPC_MoveParent,
/* 16932*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 16934*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 16940*/   /*Scope*/ 11, /*->16952*/
/* 16941*/    OPC_CheckValueType, /*MVT::i16*/6, 
/* 16943*/    OPC_MoveParent,
/* 16944*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 16946*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[v8i16] } V128:{ *:[v8f16] }:$src, i16:{ *:[Other] }) - Complexity = 3
              // Dst: (fp_to_sint_I16x8:{ *:[v8i16] } ?:{ *:[v8f16] }:$src)
/* 16952*/   0, /*End of Scope*/
/* 16953*/  0, /*End of Scope*/
/* 16954*/ /*SwitchOpcode*/ 87, TARGET_VAL(ISD::FP_TO_UINT_SAT),// ->17044
/* 16957*/  OPC_RecordChild0, // #0 = $src
/* 16958*/  OPC_Scope, 27, /*->16987*/ // 3 children in Scope
/* 16960*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 16962*/   OPC_MoveChild1,
/* 16963*/   OPC_Scope, 10, /*->16975*/ // 2 children in Scope
/* 16965*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 16967*/    OPC_MoveParent,
/* 16968*/    OPC_CheckTypeI32,
/* 16969*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16975*/   /*Scope*/ 10, /*->16986*/
/* 16976*/    OPC_CheckValueType, /*MVT::i64*/8, 
/* 16978*/    OPC_MoveParent,
/* 16979*/    OPC_CheckTypeI64,
/* 16980*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16986*/   0, /*End of Scope*/
/* 16987*/  /*Scope*/ 27, /*->17015*/
/* 16988*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 16990*/   OPC_MoveChild1,
/* 16991*/   OPC_Scope, 10, /*->17003*/ // 2 children in Scope
/* 16993*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 16995*/    OPC_MoveParent,
/* 16996*/    OPC_CheckTypeI32,
/* 16997*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 17003*/   /*Scope*/ 10, /*->17014*/
/* 17004*/    OPC_CheckValueType, /*MVT::i64*/8, 
/* 17006*/    OPC_MoveParent,
/* 17007*/    OPC_CheckTypeI64,
/* 17008*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 17014*/   0, /*End of Scope*/
/* 17015*/  /*Scope*/ 27, /*->17043*/
/* 17016*/   OPC_MoveChild1,
/* 17017*/   OPC_Scope, 11, /*->17030*/ // 2 children in Scope
/* 17019*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 17021*/    OPC_MoveParent,
/* 17022*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 17024*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 17030*/   /*Scope*/ 11, /*->17042*/
/* 17031*/    OPC_CheckValueType, /*MVT::i16*/6, 
/* 17033*/    OPC_MoveParent,
/* 17034*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 17036*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[v8i16] } V128:{ *:[v8f16] }:$src, i16:{ *:[Other] }) - Complexity = 3
              // Dst: (fp_to_uint_I16x8:{ *:[v8i16] } ?:{ *:[v8f16] }:$src)
/* 17042*/   0, /*End of Scope*/
/* 17043*/  0, /*End of Scope*/
/* 17044*/ /*SwitchOpcode*/ 39|128,2/*295*/, TARGET_VAL(ISD::BITCAST),// ->17343
/* 17048*/  OPC_RecordChild0, // #0 = $src
/* 17049*/  OPC_Scope, 9, /*->17060*/ // 11 children in Scope
/* 17051*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 17053*/   OPC_CheckTypeI32,
/* 17054*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_REINTERPRET_F32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (I32_REINTERPRET_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 17060*/  /*Scope*/ 9, /*->17070*/
/* 17061*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 17063*/   OPC_CheckTypeI64,
/* 17064*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_REINTERPRET_F64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (I64_REINTERPRET_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 17070*/  /*Scope*/ 9, /*->17080*/
/* 17071*/   OPC_CheckChild0TypeI32,
/* 17072*/   OPC_CheckType, /*MVT::f32*/12, 
/* 17074*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_REINTERPRET_I32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (F32_REINTERPRET_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 17080*/  /*Scope*/ 9, /*->17090*/
/* 17081*/   OPC_CheckChild0TypeI64,
/* 17082*/   OPC_CheckType, /*MVT::f64*/13, 
/* 17084*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_REINTERPRET_I64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (F64_REINTERPRET_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 17090*/  /*Scope*/ 35, /*->17126*/
/* 17091*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 17093*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17099
/* 17096*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17099*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17104
/* 17101*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17104*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17109
/* 17106*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17109*/   /*SwitchType*/ 3, /*MVT::v4f32*/111, // ->17114
/* 17111*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17114*/   /*SwitchType*/ 3, /*MVT::v2f64*/1|128,1/*129*/, // ->17120
/* 17117*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17120*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17125
/* 17122*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17125*/   0, // EndSwitchType
/* 17126*/  /*Scope*/ 35, /*->17162*/
/* 17127*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 17129*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17135
/* 17132*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17135*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17140
/* 17137*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17140*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17145
/* 17142*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17145*/   /*SwitchType*/ 3, /*MVT::v4f32*/111, // ->17150
/* 17147*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17150*/   /*SwitchType*/ 3, /*MVT::v2f64*/1|128,1/*129*/, // ->17156
/* 17153*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17156*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17161
/* 17158*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17161*/   0, // EndSwitchType
/* 17162*/  /*Scope*/ 35, /*->17198*/
/* 17163*/   OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 17165*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17171
/* 17168*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17171*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17176
/* 17173*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17176*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17181
/* 17178*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17181*/   /*SwitchType*/ 3, /*MVT::v4f32*/111, // ->17186
/* 17183*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17186*/   /*SwitchType*/ 3, /*MVT::v2f64*/1|128,1/*129*/, // ->17192
/* 17189*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17192*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17197
/* 17194*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17197*/   0, // EndSwitchType
/* 17198*/  /*Scope*/ 35, /*->17234*/
/* 17199*/   OPC_CheckChild0Type, /*MVT::v4f32*/111, 
/* 17201*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17207
/* 17204*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17207*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17212
/* 17209*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17212*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17217
/* 17214*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17217*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17222
/* 17219*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17222*/   /*SwitchType*/ 3, /*MVT::v2f64*/1|128,1/*129*/, // ->17228
/* 17225*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17228*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17233
/* 17230*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17233*/   0, // EndSwitchType
/* 17234*/  /*Scope*/ 35, /*->17270*/
/* 17235*/   OPC_CheckChild0Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 17238*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17244
/* 17241*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17244*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17249
/* 17246*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17249*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17254
/* 17251*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17254*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17259
/* 17256*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17259*/   /*SwitchType*/ 3, /*MVT::v4f32*/111, // ->17264
/* 17261*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17264*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17269
/* 17266*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17269*/   0, // EndSwitchType
/* 17270*/  /*Scope*/ 35, /*->17306*/
/* 17271*/   OPC_CheckChild0Type, /*MVT::v8f16*/92, 
/* 17273*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17279
/* 17276*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17279*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17284
/* 17281*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17284*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17289
/* 17286*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17289*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17294
/* 17291*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17294*/   /*SwitchType*/ 3, /*MVT::v4f32*/111, // ->17299
/* 17296*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17299*/   /*SwitchType*/ 3, /*MVT::v2f64*/1|128,1/*129*/, // ->17305
/* 17302*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17305*/   0, // EndSwitchType
/* 17306*/  /*Scope*/ 35, /*->17342*/
/* 17307*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 17309*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v8i16*/50, // ->17315
/* 17312*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17315*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17320
/* 17317*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17320*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17325
/* 17322*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17325*/   /*SwitchType*/ 3, /*MVT::v4f32*/111, // ->17330
/* 17327*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17330*/   /*SwitchType*/ 3, /*MVT::v2f64*/1|128,1/*129*/, // ->17336
/* 17333*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17336*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17341
/* 17338*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17341*/   0, // EndSwitchType
/* 17342*/  0, /*End of Scope*/
/* 17343*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::ConstantFP),// ->17367
/* 17346*/  OPC_RecordNode, // #0 = $imm
/* 17347*/  OPC_SwitchType /*2 cases */, 7, /*MVT::f32*/12, // ->17357
/* 17350*/   OPC_EmitConvertToTarget0, // #1
/* 17351*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f32] }):$imm - Complexity = 3
             // Dst: (CONST_F32:{ *:[f32] } (fpimm:{ *:[f32] }):$imm)
/* 17357*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17366
/* 17359*/   OPC_EmitConvertToTarget0, // #1
/* 17360*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f64] }):$imm - Complexity = 3
             // Dst: (CONST_F64:{ *:[f64] } (fpimm:{ *:[f64] }):$imm)
/* 17366*/  0, // EndSwitchType
/* 17367*/ /*SwitchOpcode*/ 63, TARGET_VAL(ISD::SINT_TO_FP),// ->17433
/* 17370*/  OPC_RecordChild0, // #0 = $src
/* 17371*/  OPC_Scope, 19, /*->17392*/ // 4 children in Scope
/* 17373*/   OPC_CheckChild0TypeI32,
/* 17374*/   OPC_SwitchType /*2 cases */, 6, /*MVT::f32*/12, // ->17383
/* 17377*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_S_I32),
                  /*MVT::f32*/12, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 17383*/   /*SwitchType*/ 6, /*MVT::f64*/13, // ->17391
/* 17385*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_S_I32),
                  /*MVT::f64*/13, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 17391*/   0, // EndSwitchType
/* 17392*/  /*Scope*/ 19, /*->17412*/
/* 17393*/   OPC_CheckChild0TypeI64,
/* 17394*/   OPC_SwitchType /*2 cases */, 6, /*MVT::f32*/12, // ->17403
/* 17397*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_S_I64),
                  /*MVT::f32*/12, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 17403*/   /*SwitchType*/ 6, /*MVT::f64*/13, // ->17411
/* 17405*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_S_I64),
                  /*MVT::f64*/13, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 17411*/   0, // EndSwitchType
/* 17412*/  /*Scope*/ 9, /*->17422*/
/* 17413*/   OPC_CheckType, /*MVT::v4f32*/111, 
/* 17415*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17416*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::sint_to_fp_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (sint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 17422*/  /*Scope*/ 9, /*->17432*/
/* 17423*/   OPC_CheckType, /*MVT::v8f16*/92, 
/* 17425*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17426*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::sint_to_fp_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (sint_to_fp_F16x8:{ *:[v8f16] } V128:{ *:[v8i16] }:$vec)
/* 17432*/  0, /*End of Scope*/
/* 17433*/ /*SwitchOpcode*/ 63, TARGET_VAL(ISD::UINT_TO_FP),// ->17499
/* 17436*/  OPC_RecordChild0, // #0 = $src
/* 17437*/  OPC_Scope, 19, /*->17458*/ // 4 children in Scope
/* 17439*/   OPC_CheckChild0TypeI32,
/* 17440*/   OPC_SwitchType /*2 cases */, 6, /*MVT::f32*/12, // ->17449
/* 17443*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_U_I32),
                  /*MVT::f32*/12, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 17449*/   /*SwitchType*/ 6, /*MVT::f64*/13, // ->17457
/* 17451*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_U_I32),
                  /*MVT::f64*/13, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 17457*/   0, // EndSwitchType
/* 17458*/  /*Scope*/ 19, /*->17478*/
/* 17459*/   OPC_CheckChild0TypeI64,
/* 17460*/   OPC_SwitchType /*2 cases */, 6, /*MVT::f32*/12, // ->17469
/* 17463*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_U_I64),
                  /*MVT::f32*/12, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 17469*/   /*SwitchType*/ 6, /*MVT::f64*/13, // ->17477
/* 17471*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_U_I64),
                  /*MVT::f64*/13, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 17477*/   0, // EndSwitchType
/* 17478*/  /*Scope*/ 9, /*->17488*/
/* 17479*/   OPC_CheckType, /*MVT::v4f32*/111, 
/* 17481*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17482*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::uint_to_fp_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (uint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 17488*/  /*Scope*/ 9, /*->17498*/
/* 17489*/   OPC_CheckType, /*MVT::v8f16*/92, 
/* 17491*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17492*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::uint_to_fp_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (uint_to_fp_F16x8:{ *:[v8f16] } V128:{ *:[v8i16] }:$vec)
/* 17498*/  0, /*End of Scope*/
/* 17499*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::FP_EXTEND),// ->17509
/* 17502*/  OPC_RecordChild0, // #0 = $src
/* 17503*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_PROMOTE_F32),
                /*MVT::f64*/13, 1/*#Ops*/, 0, 
            // Src: (fpextend:{ *:[f64] } F32:{ *:[f32] }:$src) - Complexity = 3
            // Dst: (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$src)
/* 17509*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::FP_ROUND),// ->17519
/* 17512*/  OPC_RecordChild0, // #0 = $src
/* 17513*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_DEMOTE_F64),
                /*MVT::f32*/12, 1/*#Ops*/, 0, 
            // Src: (fpround:{ *:[f32] } F64:{ *:[f64] }:$src) - Complexity = 3
            // Dst: (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$src)
/* 17519*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FADD),// ->17576
/* 17522*/  OPC_RecordChild0, // #0 = $lhs
/* 17523*/  OPC_RecordChild1, // #1 = $rhs
/* 17524*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17534
/* 17527*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17534*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17543
/* 17536*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17543*/  /*SwitchType*/ 8, /*MVT::v4f32*/111, // ->17553
/* 17545*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17546*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F32x4),
                 /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17553*/  /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->17565
/* 17556*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17557*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17565*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->17575
/* 17567*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17568*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (ADD_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17575*/  0, // EndSwitchType
/* 17576*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FSUB),// ->17633
/* 17579*/  OPC_RecordChild0, // #0 = $lhs
/* 17580*/  OPC_RecordChild1, // #1 = $rhs
/* 17581*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17591
/* 17584*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17591*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17600
/* 17593*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17600*/  /*SwitchType*/ 8, /*MVT::v4f32*/111, // ->17610
/* 17602*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17603*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F32x4),
                 /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17610*/  /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->17622
/* 17613*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17614*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17622*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->17632
/* 17624*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17625*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (SUB_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17632*/  0, // EndSwitchType
/* 17633*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FMUL),// ->17690
/* 17636*/  OPC_RecordChild0, // #0 = $lhs
/* 17637*/  OPC_RecordChild1, // #1 = $rhs
/* 17638*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17648
/* 17641*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17648*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17657
/* 17650*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17657*/  /*SwitchType*/ 8, /*MVT::v4f32*/111, // ->17667
/* 17659*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17660*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F32x4),
                 /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17667*/  /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->17679
/* 17670*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17671*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17679*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->17689
/* 17681*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17682*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (MUL_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17689*/  0, // EndSwitchType
/* 17690*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FDIV),// ->17747
/* 17693*/  OPC_RecordChild0, // #0 = $lhs
/* 17694*/  OPC_RecordChild1, // #1 = $rhs
/* 17695*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17705
/* 17698*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17705*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17714
/* 17707*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17714*/  /*SwitchType*/ 8, /*MVT::v4f32*/111, // ->17724
/* 17716*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17717*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F32x4),
                 /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17724*/  /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->17736
/* 17727*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17728*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17736*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->17746
/* 17738*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17739*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (DIV_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17746*/  0, // EndSwitchType
/* 17747*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FSQRT),// ->17798
/* 17750*/  OPC_RecordChild0, // #0 = $src
/* 17751*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->17760
/* 17754*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (SQRT_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17760*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->17768
/* 17762*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (SQRT_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17768*/  /*SwitchType*/ 7, /*MVT::v4f32*/111, // ->17777
/* 17770*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17771*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (SQRT_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17777*/  /*SwitchType*/ 8, /*MVT::v2f64*/1|128,1/*129*/, // ->17788
/* 17780*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17781*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (SQRT_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17788*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->17797
/* 17790*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17791*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (SQRT_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17797*/  0, // EndSwitchType
/* 17798*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FABS),// ->17849
/* 17801*/  OPC_RecordChild0, // #0 = $src
/* 17802*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->17811
/* 17805*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (ABS_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17811*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->17819
/* 17813*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (ABS_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17819*/  /*SwitchType*/ 7, /*MVT::v4f32*/111, // ->17828
/* 17821*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17822*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (ABS_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17828*/  /*SwitchType*/ 8, /*MVT::v2f64*/1|128,1/*129*/, // ->17839
/* 17831*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17832*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (ABS_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17839*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->17848
/* 17841*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17842*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (ABS_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17848*/  0, // EndSwitchType
/* 17849*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FNEG),// ->17900
/* 17852*/  OPC_RecordChild0, // #0 = $src
/* 17853*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->17862
/* 17856*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEG_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17862*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->17870
/* 17864*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEG_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17870*/  /*SwitchType*/ 7, /*MVT::v4f32*/111, // ->17879
/* 17872*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17873*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEG_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17879*/  /*SwitchType*/ 8, /*MVT::v2f64*/1|128,1/*129*/, // ->17890
/* 17882*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17883*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEG_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17890*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->17899
/* 17892*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17893*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (NEG_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17899*/  0, // EndSwitchType
/* 17900*/ /*SwitchOpcode*/ 62, TARGET_VAL(ISD::FCOPYSIGN),// ->17965
/* 17903*/  OPC_RecordChild0, // #0 = $lhs
/* 17904*/  OPC_RecordChild1, // #1 = $rhs
/* 17905*/  OPC_Scope, 28, /*->17935*/ // 2 children in Scope
/* 17907*/   OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 17909*/   OPC_SwitchType /*2 cases */, 7, /*MVT::f32*/12, // ->17919
/* 17912*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F32),
                  /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17919*/   /*SwitchType*/ 13, /*MVT::f64*/13, // ->17934
/* 17921*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::F64_PROMOTE_F32),
                  /*MVT::f64*/13, 1/*#Ops*/, 1,  // Results = #2
/* 17927*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F64),
                  /*MVT::f64*/13, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$rhs))
/* 17934*/   0, // EndSwitchType
/* 17935*/  /*Scope*/ 28, /*->17964*/
/* 17936*/   OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 17938*/   OPC_SwitchType /*2 cases */, 7, /*MVT::f64*/13, // ->17948
/* 17941*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F64),
                  /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17948*/   /*SwitchType*/ 13, /*MVT::f32*/12, // ->17963
/* 17950*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::F32_DEMOTE_F64),
                  /*MVT::f32*/12, 1/*#Ops*/, 1,  // Results = #2
/* 17956*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F32),
                  /*MVT::f32*/12, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$rhs))
/* 17963*/   0, // EndSwitchType
/* 17964*/  0, /*End of Scope*/
/* 17965*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FMINIMUM),// ->18022
/* 17968*/  OPC_RecordChild0, // #0 = $lhs
/* 17969*/  OPC_RecordChild1, // #1 = $rhs
/* 17970*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17980
/* 17973*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17980*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17989
/* 17982*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17989*/  /*SwitchType*/ 8, /*MVT::v4f32*/111, // ->17999
/* 17991*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17992*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F32x4),
                 /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17999*/  /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->18011
/* 18002*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18003*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 18011*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->18021
/* 18013*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18014*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (MIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 18021*/  0, // EndSwitchType
/* 18022*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FMAXIMUM),// ->18079
/* 18025*/  OPC_RecordChild0, // #0 = $lhs
/* 18026*/  OPC_RecordChild1, // #1 = $rhs
/* 18027*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->18037
/* 18030*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 18037*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->18046
/* 18039*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 18046*/  /*SwitchType*/ 8, /*MVT::v4f32*/111, // ->18056
/* 18048*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18049*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F32x4),
                 /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 18056*/  /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->18068
/* 18059*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18060*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 18068*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->18078
/* 18070*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18071*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (MAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 18078*/  0, // EndSwitchType
/* 18079*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FCEIL),// ->18130
/* 18082*/  OPC_RecordChild0, // #0 = $src
/* 18083*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18092
/* 18086*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (CEIL_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18092*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18100
/* 18094*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (CEIL_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18100*/  /*SwitchType*/ 7, /*MVT::v4f32*/111, // ->18109
/* 18102*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18103*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (CEIL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18109*/  /*SwitchType*/ 8, /*MVT::v2f64*/1|128,1/*129*/, // ->18120
/* 18112*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18113*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (CEIL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18120*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->18129
/* 18122*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18123*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (CEIL_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 18129*/  0, // EndSwitchType
/* 18130*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FFLOOR),// ->18181
/* 18133*/  OPC_RecordChild0, // #0 = $src
/* 18134*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18143
/* 18137*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (FLOOR_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18143*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18151
/* 18145*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (FLOOR_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18151*/  /*SwitchType*/ 7, /*MVT::v4f32*/111, // ->18160
/* 18153*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18154*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (FLOOR_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18160*/  /*SwitchType*/ 8, /*MVT::v2f64*/1|128,1/*129*/, // ->18171
/* 18163*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18164*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (FLOOR_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18171*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->18180
/* 18173*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18174*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (FLOOR_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 18180*/  0, // EndSwitchType
/* 18181*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FTRUNC),// ->18232
/* 18184*/  OPC_RecordChild0, // #0 = $src
/* 18185*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18194
/* 18188*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (TRUNC_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18194*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18202
/* 18196*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (TRUNC_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18202*/  /*SwitchType*/ 7, /*MVT::v4f32*/111, // ->18211
/* 18204*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18205*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (TRUNC_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18211*/  /*SwitchType*/ 8, /*MVT::v2f64*/1|128,1/*129*/, // ->18222
/* 18214*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18215*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (TRUNC_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18222*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->18231
/* 18224*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18225*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (TRUNC_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 18231*/  0, // EndSwitchType
/* 18232*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FNEARBYINT),// ->18283
/* 18235*/  OPC_RecordChild0, // #0 = $src
/* 18236*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18245
/* 18239*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18245*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18253
/* 18247*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18253*/  /*SwitchType*/ 7, /*MVT::v4f32*/111, // ->18262
/* 18255*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18256*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18262*/  /*SwitchType*/ 8, /*MVT::v2f64*/1|128,1/*129*/, // ->18273
/* 18265*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18266*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18273*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->18282
/* 18275*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18276*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (NEAREST_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 18282*/  0, // EndSwitchType
/* 18283*/ /*SwitchOpcode*/ 45, TARGET_VAL(ISD::FRINT),// ->18331
/* 18286*/  OPC_RecordChild0, // #0 = $src
/* 18287*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18296
/* 18290*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 18296*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18304
/* 18298*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 18304*/  /*SwitchType*/ 6, /*MVT::v4f32*/111, // ->18312
/* 18306*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$src)
/* 18312*/  /*SwitchType*/ 7, /*MVT::v2f64*/1|128,1/*129*/, // ->18322
/* 18315*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$src)
/* 18322*/  /*SwitchType*/ 6, /*MVT::v8f16*/92, // ->18330
/* 18324*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$src) - Complexity = 3
             // Dst: (NEAREST_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$src)
/* 18330*/  0, // EndSwitchType
/* 18331*/ /*SwitchOpcode*/ 45, TARGET_VAL(ISD::FROUNDEVEN),// ->18379
/* 18334*/  OPC_RecordChild0, // #0 = $src
/* 18335*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18344
/* 18338*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 18344*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18352
/* 18346*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 18352*/  /*SwitchType*/ 6, /*MVT::v4f32*/111, // ->18360
/* 18354*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$src)
/* 18360*/  /*SwitchType*/ 7, /*MVT::v2f64*/1|128,1/*129*/, // ->18370
/* 18363*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$src)
/* 18370*/  /*SwitchType*/ 6, /*MVT::v8f16*/92, // ->18378
/* 18372*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$src) - Complexity = 3
             // Dst: (NEAREST_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$src)
/* 18378*/  0, // EndSwitchType
/* 18379*/ /*SwitchOpcode*/ 22|128,3/*406*/, TARGET_VAL(ISD::BUILD_VECTOR),// ->18789
/* 18383*/  OPC_RecordChild0, // #0 = $i0
/* 18384*/  OPC_MoveChild0,
/* 18385*/  OPC_SwitchOpcode /*2 cases */, 73|128,2/*329*/, TARGET_VAL(ISD::Constant),// ->18719
/* 18390*/   OPC_SwitchType /*2 cases */, 47|128,2/*303*/, /*MVT::i32*/7, // ->18697
/* 18394*/    OPC_Scope, 51|128,1/*179*/, /*->18576*/ // 3 children in Scope
/* 18397*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18399*/     OPC_MoveSibling1,
/* 18400*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18403*/     OPC_RecordNode, // #1 = $i1
/* 18404*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18406*/     OPC_CheckTypeI32,
/* 18407*/     OPC_MoveSibling2,
/* 18408*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18411*/     OPC_RecordNode, // #2 = $i2
/* 18412*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18414*/     OPC_CheckTypeI32,
/* 18415*/     OPC_MoveSibling3,
/* 18416*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18419*/     OPC_RecordNode, // #3 = $i3
/* 18420*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18422*/     OPC_CheckTypeI32,
/* 18423*/     OPC_MoveSibling4,
/* 18424*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18427*/     OPC_RecordNode, // #4 = $i4
/* 18428*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18430*/     OPC_CheckTypeI32,
/* 18431*/     OPC_MoveSibling5,
/* 18432*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18435*/     OPC_RecordNode, // #5 = $i5
/* 18436*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18438*/     OPC_CheckTypeI32,
/* 18439*/     OPC_MoveSibling6,
/* 18440*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18443*/     OPC_RecordNode, // #6 = $i6
/* 18444*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18446*/     OPC_CheckTypeI32,
/* 18447*/     OPC_MoveSibling7,
/* 18448*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18451*/     OPC_RecordNode, // #7 = $i7
/* 18452*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18454*/     OPC_CheckTypeI32,
/* 18455*/     OPC_MoveSibling, 8,
/* 18457*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18460*/     OPC_RecordNode, // #8 = $i8
/* 18461*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18463*/     OPC_CheckTypeI32,
/* 18464*/     OPC_MoveSibling, 9,
/* 18466*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18469*/     OPC_RecordNode, // #9 = $i9
/* 18470*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18472*/     OPC_CheckTypeI32,
/* 18473*/     OPC_MoveSibling, 10,
/* 18475*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18478*/     OPC_RecordNode, // #10 = $iA
/* 18479*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18481*/     OPC_CheckTypeI32,
/* 18482*/     OPC_MoveSibling, 11,
/* 18484*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18487*/     OPC_RecordNode, // #11 = $iB
/* 18488*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18490*/     OPC_CheckTypeI32,
/* 18491*/     OPC_MoveSibling, 12,
/* 18493*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18496*/     OPC_RecordNode, // #12 = $iC
/* 18497*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18499*/     OPC_CheckTypeI32,
/* 18500*/     OPC_MoveSibling, 13,
/* 18502*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18505*/     OPC_RecordNode, // #13 = $iD
/* 18506*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18508*/     OPC_CheckTypeI32,
/* 18509*/     OPC_MoveSibling, 14,
/* 18511*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18514*/     OPC_RecordNode, // #14 = $iE
/* 18515*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18517*/     OPC_CheckTypeI32,
/* 18518*/     OPC_MoveSibling, 15,
/* 18520*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18523*/     OPC_RecordNode, // #15 = $iF
/* 18524*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18526*/     OPC_CheckTypeI32,
/* 18527*/     OPC_MoveParent,
/* 18528*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 18530*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18531*/     OPC_EmitConvertToTarget0, // #16
/* 18532*/     OPC_EmitConvertToTarget1, // #17
/* 18533*/     OPC_EmitConvertToTarget2, // #18
/* 18534*/     OPC_EmitConvertToTarget3, // #19
/* 18535*/     OPC_EmitConvertToTarget4, // #20
/* 18536*/     OPC_EmitConvertToTarget5, // #21
/* 18537*/     OPC_EmitConvertToTarget6, // #22
/* 18538*/     OPC_EmitConvertToTarget7, // #23
/* 18539*/     OPC_EmitConvertToTarget, 8, // #24
/* 18541*/     OPC_EmitConvertToTarget, 9, // #25
/* 18543*/     OPC_EmitConvertToTarget, 10, // #26
/* 18545*/     OPC_EmitConvertToTarget, 11, // #27
/* 18547*/     OPC_EmitConvertToTarget, 12, // #28
/* 18549*/     OPC_EmitConvertToTarget, 13, // #29
/* 18551*/     OPC_EmitConvertToTarget, 14, // #30
/* 18553*/     OPC_EmitConvertToTarget, 15, // #31
/* 18555*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I8x16),
                   /*MVT::v16i8*/39, 16/*#Ops*/, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 
               // Src: (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i7, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i8, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i9, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iA, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iB, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iC, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iD, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iE, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iF) - Complexity = 67
               // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7, (imm:{ *:[i32] }):$i8, (imm:{ *:[i32] }):$i9, (imm:{ *:[i32] }):$iA, (imm:{ *:[i32] }):$iB, (imm:{ *:[i32] }):$iC, (imm:{ *:[i32] }):$iD, (imm:{ *:[i32] }):$iE, (imm:{ *:[i32] }):$iF)
/* 18576*/    /*Scope*/ 83, /*->18660*/
/* 18577*/     OPC_CheckPredicate, 17, // Predicate_ImmI16
/* 18579*/     OPC_MoveSibling1,
/* 18580*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18583*/     OPC_RecordNode, // #1 = $i1
/* 18584*/     OPC_CheckPredicate, 17, // Predicate_ImmI16
/* 18586*/     OPC_CheckTypeI32,
/* 18587*/     OPC_MoveSibling2,
/* 18588*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18591*/     OPC_RecordNode, // #2 = $i2
/* 18592*/     OPC_CheckPredicate, 17, // Predicate_ImmI16
/* 18594*/     OPC_CheckTypeI32,
/* 18595*/     OPC_MoveSibling3,
/* 18596*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18599*/     OPC_RecordNode, // #3 = $i3
/* 18600*/     OPC_CheckPredicate, 17, // Predicate_ImmI16
/* 18602*/     OPC_CheckTypeI32,
/* 18603*/     OPC_MoveSibling4,
/* 18604*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18607*/     OPC_RecordNode, // #4 = $i4
/* 18608*/     OPC_CheckPredicate, 17, // Predicate_ImmI16
/* 18610*/     OPC_CheckTypeI32,
/* 18611*/     OPC_MoveSibling5,
/* 18612*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18615*/     OPC_RecordNode, // #5 = $i5
/* 18616*/     OPC_CheckPredicate, 17, // Predicate_ImmI16
/* 18618*/     OPC_CheckTypeI32,
/* 18619*/     OPC_MoveSibling6,
/* 18620*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18623*/     OPC_RecordNode, // #6 = $i6
/* 18624*/     OPC_CheckPredicate, 17, // Predicate_ImmI16
/* 18626*/     OPC_CheckTypeI32,
/* 18627*/     OPC_MoveSibling7,
/* 18628*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18631*/     OPC_RecordNode, // #7 = $i7
/* 18632*/     OPC_CheckPredicate, 17, // Predicate_ImmI16
/* 18634*/     OPC_CheckTypeI32,
/* 18635*/     OPC_MoveParent,
/* 18636*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 18638*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18639*/     OPC_EmitConvertToTarget0, // #8
/* 18640*/     OPC_EmitConvertToTarget1, // #9
/* 18641*/     OPC_EmitConvertToTarget2, // #10
/* 18642*/     OPC_EmitConvertToTarget3, // #11
/* 18643*/     OPC_EmitConvertToTarget4, // #12
/* 18644*/     OPC_EmitConvertToTarget5, // #13
/* 18645*/     OPC_EmitConvertToTarget6, // #14
/* 18646*/     OPC_EmitConvertToTarget7, // #15
/* 18647*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I16x8),
                   /*MVT::v8i16*/50, 8/*#Ops*/, 8, 9, 10, 11, 12, 13, 14, 15, 
               // Src: (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i7) - Complexity = 35
               // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7)
/* 18660*/    /*Scope*/ 35, /*->18696*/
/* 18661*/     OPC_MoveSibling1,
/* 18662*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18665*/     OPC_RecordNode, // #1 = $i1
/* 18666*/     OPC_CheckTypeI32,
/* 18667*/     OPC_MoveSibling2,
/* 18668*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18671*/     OPC_RecordNode, // #2 = $i2
/* 18672*/     OPC_CheckTypeI32,
/* 18673*/     OPC_MoveSibling3,
/* 18674*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18677*/     OPC_RecordNode, // #3 = $i3
/* 18678*/     OPC_CheckTypeI32,
/* 18679*/     OPC_MoveParent,
/* 18680*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 18682*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18683*/     OPC_EmitConvertToTarget0, // #4
/* 18684*/     OPC_EmitConvertToTarget1, // #5
/* 18685*/     OPC_EmitConvertToTarget2, // #6
/* 18686*/     OPC_EmitConvertToTarget3, // #7
/* 18687*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I32x4),
                   /*MVT::v4i32*/60, 4/*#Ops*/, 4, 5, 6, 7, 
               // Src: (build_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3) - Complexity = 15
               // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3)
/* 18696*/    0, /*End of Scope*/
/* 18697*/   /*SwitchType*/ 19, /*MVT::i64*/8, // ->18718
/* 18699*/    OPC_MoveSibling1,
/* 18700*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18703*/    OPC_RecordNode, // #1 = $i1
/* 18704*/    OPC_CheckTypeI64,
/* 18705*/    OPC_MoveParent,
/* 18706*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 18708*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18709*/    OPC_EmitConvertToTarget0, // #2
/* 18710*/    OPC_EmitConvertToTarget1, // #3
/* 18711*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1)
/* 18718*/   0, // EndSwitchType
/* 18719*/  /*SwitchOpcode*/ 66, TARGET_VAL(ISD::ConstantFP),// ->18788
/* 18722*/   OPC_SwitchType /*2 cases */, 38, /*MVT::f32*/12, // ->18763
/* 18725*/    OPC_MoveSibling1,
/* 18726*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18729*/    OPC_RecordNode, // #1 = $i1
/* 18730*/    OPC_CheckType, /*MVT::f32*/12, 
/* 18732*/    OPC_MoveSibling2,
/* 18733*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18736*/    OPC_RecordNode, // #2 = $i2
/* 18737*/    OPC_CheckType, /*MVT::f32*/12, 
/* 18739*/    OPC_MoveSibling3,
/* 18740*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18743*/    OPC_RecordNode, // #3 = $i3
/* 18744*/    OPC_CheckType, /*MVT::f32*/12, 
/* 18746*/    OPC_MoveParent,
/* 18747*/    OPC_CheckType, /*MVT::v4f32*/111, 
/* 18749*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18750*/    OPC_EmitConvertToTarget0, // #4
/* 18751*/    OPC_EmitConvertToTarget1, // #5
/* 18752*/    OPC_EmitConvertToTarget2, // #6
/* 18753*/    OPC_EmitConvertToTarget3, // #7
/* 18754*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F32x4),
                  /*MVT::v4f32*/111, 4/*#Ops*/, 4, 5, 6, 7, 
              // Src: (build_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3) - Complexity = 15
              // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3)
/* 18763*/   /*SwitchType*/ 22, /*MVT::f64*/13, // ->18787
/* 18765*/    OPC_MoveSibling1,
/* 18766*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18769*/    OPC_RecordNode, // #1 = $i1
/* 18770*/    OPC_CheckType, /*MVT::f64*/13, 
/* 18772*/    OPC_MoveParent,
/* 18773*/    OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 18776*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18777*/    OPC_EmitConvertToTarget0, // #2
/* 18778*/    OPC_EmitConvertToTarget1, // #3
/* 18779*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1)
/* 18787*/   0, // EndSwitchType
/* 18788*/  0, // EndSwitchOpcode
/* 18789*/ /*SwitchOpcode*/ 92|128,18/*2396*/, TARGET_VAL(WebAssemblyISD::SHUFFLE),// ->21189
/* 18793*/  OPC_RecordChild0, // #0 = $x
/* 18794*/  OPC_Scope, 83|128,2/*339*/, /*->19136*/ // 7 children in Scope
/* 18797*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 18799*/   OPC_RecordChild1, // #1 = $y
/* 18800*/   OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 18802*/   OPC_RecordChild2, // #2 = $m0
/* 18803*/   OPC_MoveChild2,
/* 18804*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->18978
/* 18809*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18810*/    OPC_CheckTypeI32,
/* 18811*/    OPC_MoveSibling3,
/* 18812*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18815*/    OPC_RecordNode, // #3 = $m1
/* 18816*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18817*/    OPC_CheckTypeI32,
/* 18818*/    OPC_MoveSibling4,
/* 18819*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18822*/    OPC_RecordNode, // #4 = $m2
/* 18823*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18824*/    OPC_CheckTypeI32,
/* 18825*/    OPC_MoveSibling5,
/* 18826*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18829*/    OPC_RecordNode, // #5 = $m3
/* 18830*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18831*/    OPC_CheckTypeI32,
/* 18832*/    OPC_MoveSibling6,
/* 18833*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18836*/    OPC_RecordNode, // #6 = $m4
/* 18837*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18838*/    OPC_CheckTypeI32,
/* 18839*/    OPC_MoveSibling7,
/* 18840*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18843*/    OPC_RecordNode, // #7 = $m5
/* 18844*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18845*/    OPC_CheckTypeI32,
/* 18846*/    OPC_MoveSibling, 8,
/* 18848*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18851*/    OPC_RecordNode, // #8 = $m6
/* 18852*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18853*/    OPC_CheckTypeI32,
/* 18854*/    OPC_MoveSibling, 9,
/* 18856*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18859*/    OPC_RecordNode, // #9 = $m7
/* 18860*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18861*/    OPC_CheckTypeI32,
/* 18862*/    OPC_MoveSibling, 10,
/* 18864*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18867*/    OPC_RecordNode, // #10 = $m8
/* 18868*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18869*/    OPC_CheckTypeI32,
/* 18870*/    OPC_MoveSibling, 11,
/* 18872*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18875*/    OPC_RecordNode, // #11 = $m9
/* 18876*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18877*/    OPC_CheckTypeI32,
/* 18878*/    OPC_MoveSibling, 12,
/* 18880*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18883*/    OPC_RecordNode, // #12 = $mA
/* 18884*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18885*/    OPC_CheckTypeI32,
/* 18886*/    OPC_MoveSibling, 13,
/* 18888*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18891*/    OPC_RecordNode, // #13 = $mB
/* 18892*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18893*/    OPC_CheckTypeI32,
/* 18894*/    OPC_MoveSibling, 14,
/* 18896*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18899*/    OPC_RecordNode, // #14 = $mC
/* 18900*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18901*/    OPC_CheckTypeI32,
/* 18902*/    OPC_MoveSibling, 15,
/* 18904*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18907*/    OPC_RecordNode, // #15 = $mD
/* 18908*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18909*/    OPC_CheckTypeI32,
/* 18910*/    OPC_MoveSibling, 16,
/* 18912*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18915*/    OPC_RecordNode, // #16 = $mE
/* 18916*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18917*/    OPC_CheckTypeI32,
/* 18918*/    OPC_MoveSibling, 17,
/* 18920*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18923*/    OPC_RecordNode, // #17 = $mF
/* 18924*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18925*/    OPC_CheckTypeI32,
/* 18926*/    OPC_MoveParent,
/* 18927*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 18929*/    OPC_EmitConvertToTarget2, // #18
/* 18930*/    OPC_EmitConvertToTarget3, // #19
/* 18931*/    OPC_EmitConvertToTarget4, // #20
/* 18932*/    OPC_EmitConvertToTarget5, // #21
/* 18933*/    OPC_EmitConvertToTarget6, // #22
/* 18934*/    OPC_EmitConvertToTarget7, // #23
/* 18935*/    OPC_EmitConvertToTarget, 8, // #24
/* 18937*/    OPC_EmitConvertToTarget, 9, // #25
/* 18939*/    OPC_EmitConvertToTarget, 10, // #26
/* 18941*/    OPC_EmitConvertToTarget, 11, // #27
/* 18943*/    OPC_EmitConvertToTarget, 12, // #28
/* 18945*/    OPC_EmitConvertToTarget, 13, // #29
/* 18947*/    OPC_EmitConvertToTarget, 14, // #30
/* 18949*/    OPC_EmitConvertToTarget, 15, // #31
/* 18951*/    OPC_EmitConvertToTarget, 16, // #32
/* 18953*/    OPC_EmitConvertToTarget, 17, // #33
/* 18955*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v16i8*/39, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$x, ?:{ *:[v16i8] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 18978*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19135
/* 18982*/    OPC_CheckTypeI32,
/* 18983*/    OPC_MoveSibling3,
/* 18984*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18987*/    OPC_RecordNode, // #3 = $m1
/* 18988*/    OPC_CheckTypeI32,
/* 18989*/    OPC_MoveSibling4,
/* 18990*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18993*/    OPC_RecordNode, // #4 = $m2
/* 18994*/    OPC_CheckTypeI32,
/* 18995*/    OPC_MoveSibling5,
/* 18996*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18999*/    OPC_RecordNode, // #5 = $m3
/* 19000*/    OPC_CheckTypeI32,
/* 19001*/    OPC_MoveSibling6,
/* 19002*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19005*/    OPC_RecordNode, // #6 = $m4
/* 19006*/    OPC_CheckTypeI32,
/* 19007*/    OPC_MoveSibling7,
/* 19008*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19011*/    OPC_RecordNode, // #7 = $m5
/* 19012*/    OPC_CheckTypeI32,
/* 19013*/    OPC_MoveSibling, 8,
/* 19015*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19018*/    OPC_RecordNode, // #8 = $m6
/* 19019*/    OPC_CheckTypeI32,
/* 19020*/    OPC_MoveSibling, 9,
/* 19022*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19025*/    OPC_RecordNode, // #9 = $m7
/* 19026*/    OPC_CheckTypeI32,
/* 19027*/    OPC_MoveSibling, 10,
/* 19029*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19032*/    OPC_RecordNode, // #10 = $m8
/* 19033*/    OPC_CheckTypeI32,
/* 19034*/    OPC_MoveSibling, 11,
/* 19036*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19039*/    OPC_RecordNode, // #11 = $m9
/* 19040*/    OPC_CheckTypeI32,
/* 19041*/    OPC_MoveSibling, 12,
/* 19043*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19046*/    OPC_RecordNode, // #12 = $mA
/* 19047*/    OPC_CheckTypeI32,
/* 19048*/    OPC_MoveSibling, 13,
/* 19050*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19053*/    OPC_RecordNode, // #13 = $mB
/* 19054*/    OPC_CheckTypeI32,
/* 19055*/    OPC_MoveSibling, 14,
/* 19057*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19060*/    OPC_RecordNode, // #14 = $mC
/* 19061*/    OPC_CheckTypeI32,
/* 19062*/    OPC_MoveSibling, 15,
/* 19064*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19067*/    OPC_RecordNode, // #15 = $mD
/* 19068*/    OPC_CheckTypeI32,
/* 19069*/    OPC_MoveSibling, 16,
/* 19071*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19074*/    OPC_RecordNode, // #16 = $mE
/* 19075*/    OPC_CheckTypeI32,
/* 19076*/    OPC_MoveSibling, 17,
/* 19078*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19081*/    OPC_RecordNode, // #17 = $mF
/* 19082*/    OPC_CheckTypeI32,
/* 19083*/    OPC_MoveParent,
/* 19084*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 19086*/    OPC_EmitConvertToTarget2, // #18
/* 19087*/    OPC_EmitConvertToTarget3, // #19
/* 19088*/    OPC_EmitConvertToTarget4, // #20
/* 19089*/    OPC_EmitConvertToTarget5, // #21
/* 19090*/    OPC_EmitConvertToTarget6, // #22
/* 19091*/    OPC_EmitConvertToTarget7, // #23
/* 19092*/    OPC_EmitConvertToTarget, 8, // #24
/* 19094*/    OPC_EmitConvertToTarget, 9, // #25
/* 19096*/    OPC_EmitConvertToTarget, 10, // #26
/* 19098*/    OPC_EmitConvertToTarget, 11, // #27
/* 19100*/    OPC_EmitConvertToTarget, 12, // #28
/* 19102*/    OPC_EmitConvertToTarget, 13, // #29
/* 19104*/    OPC_EmitConvertToTarget, 14, // #30
/* 19106*/    OPC_EmitConvertToTarget, 15, // #31
/* 19108*/    OPC_EmitConvertToTarget, 16, // #32
/* 19110*/    OPC_EmitConvertToTarget, 17, // #33
/* 19112*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v16i8*/39, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$x, ?:{ *:[v16i8] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19135*/   0, // EndSwitchOpcode
/* 19136*/  /*Scope*/ 83|128,2/*339*/, /*->19477*/
/* 19138*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 19140*/   OPC_RecordChild1, // #1 = $y
/* 19141*/   OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 19143*/   OPC_RecordChild2, // #2 = $m0
/* 19144*/   OPC_MoveChild2,
/* 19145*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->19319
/* 19150*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19151*/    OPC_CheckTypeI32,
/* 19152*/    OPC_MoveSibling3,
/* 19153*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19156*/    OPC_RecordNode, // #3 = $m1
/* 19157*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19158*/    OPC_CheckTypeI32,
/* 19159*/    OPC_MoveSibling4,
/* 19160*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19163*/    OPC_RecordNode, // #4 = $m2
/* 19164*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19165*/    OPC_CheckTypeI32,
/* 19166*/    OPC_MoveSibling5,
/* 19167*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19170*/    OPC_RecordNode, // #5 = $m3
/* 19171*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19172*/    OPC_CheckTypeI32,
/* 19173*/    OPC_MoveSibling6,
/* 19174*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19177*/    OPC_RecordNode, // #6 = $m4
/* 19178*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19179*/    OPC_CheckTypeI32,
/* 19180*/    OPC_MoveSibling7,
/* 19181*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19184*/    OPC_RecordNode, // #7 = $m5
/* 19185*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19186*/    OPC_CheckTypeI32,
/* 19187*/    OPC_MoveSibling, 8,
/* 19189*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19192*/    OPC_RecordNode, // #8 = $m6
/* 19193*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19194*/    OPC_CheckTypeI32,
/* 19195*/    OPC_MoveSibling, 9,
/* 19197*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19200*/    OPC_RecordNode, // #9 = $m7
/* 19201*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19202*/    OPC_CheckTypeI32,
/* 19203*/    OPC_MoveSibling, 10,
/* 19205*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19208*/    OPC_RecordNode, // #10 = $m8
/* 19209*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19210*/    OPC_CheckTypeI32,
/* 19211*/    OPC_MoveSibling, 11,
/* 19213*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19216*/    OPC_RecordNode, // #11 = $m9
/* 19217*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19218*/    OPC_CheckTypeI32,
/* 19219*/    OPC_MoveSibling, 12,
/* 19221*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19224*/    OPC_RecordNode, // #12 = $mA
/* 19225*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19226*/    OPC_CheckTypeI32,
/* 19227*/    OPC_MoveSibling, 13,
/* 19229*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19232*/    OPC_RecordNode, // #13 = $mB
/* 19233*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19234*/    OPC_CheckTypeI32,
/* 19235*/    OPC_MoveSibling, 14,
/* 19237*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19240*/    OPC_RecordNode, // #14 = $mC
/* 19241*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19242*/    OPC_CheckTypeI32,
/* 19243*/    OPC_MoveSibling, 15,
/* 19245*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19248*/    OPC_RecordNode, // #15 = $mD
/* 19249*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19250*/    OPC_CheckTypeI32,
/* 19251*/    OPC_MoveSibling, 16,
/* 19253*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19256*/    OPC_RecordNode, // #16 = $mE
/* 19257*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19258*/    OPC_CheckTypeI32,
/* 19259*/    OPC_MoveSibling, 17,
/* 19261*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19264*/    OPC_RecordNode, // #17 = $mF
/* 19265*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19266*/    OPC_CheckTypeI32,
/* 19267*/    OPC_MoveParent,
/* 19268*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 19270*/    OPC_EmitConvertToTarget2, // #18
/* 19271*/    OPC_EmitConvertToTarget3, // #19
/* 19272*/    OPC_EmitConvertToTarget4, // #20
/* 19273*/    OPC_EmitConvertToTarget5, // #21
/* 19274*/    OPC_EmitConvertToTarget6, // #22
/* 19275*/    OPC_EmitConvertToTarget7, // #23
/* 19276*/    OPC_EmitConvertToTarget, 8, // #24
/* 19278*/    OPC_EmitConvertToTarget, 9, // #25
/* 19280*/    OPC_EmitConvertToTarget, 10, // #26
/* 19282*/    OPC_EmitConvertToTarget, 11, // #27
/* 19284*/    OPC_EmitConvertToTarget, 12, // #28
/* 19286*/    OPC_EmitConvertToTarget, 13, // #29
/* 19288*/    OPC_EmitConvertToTarget, 14, // #30
/* 19290*/    OPC_EmitConvertToTarget, 15, // #31
/* 19292*/    OPC_EmitConvertToTarget, 16, // #32
/* 19294*/    OPC_EmitConvertToTarget, 17, // #33
/* 19296*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v8i16*/50, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v8i16] } ?:{ *:[v8i16] }:$x, ?:{ *:[v8i16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19319*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19476
/* 19323*/    OPC_CheckTypeI32,
/* 19324*/    OPC_MoveSibling3,
/* 19325*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19328*/    OPC_RecordNode, // #3 = $m1
/* 19329*/    OPC_CheckTypeI32,
/* 19330*/    OPC_MoveSibling4,
/* 19331*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19334*/    OPC_RecordNode, // #4 = $m2
/* 19335*/    OPC_CheckTypeI32,
/* 19336*/    OPC_MoveSibling5,
/* 19337*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19340*/    OPC_RecordNode, // #5 = $m3
/* 19341*/    OPC_CheckTypeI32,
/* 19342*/    OPC_MoveSibling6,
/* 19343*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19346*/    OPC_RecordNode, // #6 = $m4
/* 19347*/    OPC_CheckTypeI32,
/* 19348*/    OPC_MoveSibling7,
/* 19349*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19352*/    OPC_RecordNode, // #7 = $m5
/* 19353*/    OPC_CheckTypeI32,
/* 19354*/    OPC_MoveSibling, 8,
/* 19356*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19359*/    OPC_RecordNode, // #8 = $m6
/* 19360*/    OPC_CheckTypeI32,
/* 19361*/    OPC_MoveSibling, 9,
/* 19363*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19366*/    OPC_RecordNode, // #9 = $m7
/* 19367*/    OPC_CheckTypeI32,
/* 19368*/    OPC_MoveSibling, 10,
/* 19370*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19373*/    OPC_RecordNode, // #10 = $m8
/* 19374*/    OPC_CheckTypeI32,
/* 19375*/    OPC_MoveSibling, 11,
/* 19377*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19380*/    OPC_RecordNode, // #11 = $m9
/* 19381*/    OPC_CheckTypeI32,
/* 19382*/    OPC_MoveSibling, 12,
/* 19384*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19387*/    OPC_RecordNode, // #12 = $mA
/* 19388*/    OPC_CheckTypeI32,
/* 19389*/    OPC_MoveSibling, 13,
/* 19391*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19394*/    OPC_RecordNode, // #13 = $mB
/* 19395*/    OPC_CheckTypeI32,
/* 19396*/    OPC_MoveSibling, 14,
/* 19398*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19401*/    OPC_RecordNode, // #14 = $mC
/* 19402*/    OPC_CheckTypeI32,
/* 19403*/    OPC_MoveSibling, 15,
/* 19405*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19408*/    OPC_RecordNode, // #15 = $mD
/* 19409*/    OPC_CheckTypeI32,
/* 19410*/    OPC_MoveSibling, 16,
/* 19412*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19415*/    OPC_RecordNode, // #16 = $mE
/* 19416*/    OPC_CheckTypeI32,
/* 19417*/    OPC_MoveSibling, 17,
/* 19419*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19422*/    OPC_RecordNode, // #17 = $mF
/* 19423*/    OPC_CheckTypeI32,
/* 19424*/    OPC_MoveParent,
/* 19425*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 19427*/    OPC_EmitConvertToTarget2, // #18
/* 19428*/    OPC_EmitConvertToTarget3, // #19
/* 19429*/    OPC_EmitConvertToTarget4, // #20
/* 19430*/    OPC_EmitConvertToTarget5, // #21
/* 19431*/    OPC_EmitConvertToTarget6, // #22
/* 19432*/    OPC_EmitConvertToTarget7, // #23
/* 19433*/    OPC_EmitConvertToTarget, 8, // #24
/* 19435*/    OPC_EmitConvertToTarget, 9, // #25
/* 19437*/    OPC_EmitConvertToTarget, 10, // #26
/* 19439*/    OPC_EmitConvertToTarget, 11, // #27
/* 19441*/    OPC_EmitConvertToTarget, 12, // #28
/* 19443*/    OPC_EmitConvertToTarget, 13, // #29
/* 19445*/    OPC_EmitConvertToTarget, 14, // #30
/* 19447*/    OPC_EmitConvertToTarget, 15, // #31
/* 19449*/    OPC_EmitConvertToTarget, 16, // #32
/* 19451*/    OPC_EmitConvertToTarget, 17, // #33
/* 19453*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v8i16*/50, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v8i16] } ?:{ *:[v8i16] }:$x, ?:{ *:[v8i16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19476*/   0, // EndSwitchOpcode
/* 19477*/  /*Scope*/ 83|128,2/*339*/, /*->19818*/
/* 19479*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 19481*/   OPC_RecordChild1, // #1 = $y
/* 19482*/   OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 19484*/   OPC_RecordChild2, // #2 = $m0
/* 19485*/   OPC_MoveChild2,
/* 19486*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->19660
/* 19491*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19492*/    OPC_CheckTypeI32,
/* 19493*/    OPC_MoveSibling3,
/* 19494*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19497*/    OPC_RecordNode, // #3 = $m1
/* 19498*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19499*/    OPC_CheckTypeI32,
/* 19500*/    OPC_MoveSibling4,
/* 19501*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19504*/    OPC_RecordNode, // #4 = $m2
/* 19505*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19506*/    OPC_CheckTypeI32,
/* 19507*/    OPC_MoveSibling5,
/* 19508*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19511*/    OPC_RecordNode, // #5 = $m3
/* 19512*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19513*/    OPC_CheckTypeI32,
/* 19514*/    OPC_MoveSibling6,
/* 19515*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19518*/    OPC_RecordNode, // #6 = $m4
/* 19519*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19520*/    OPC_CheckTypeI32,
/* 19521*/    OPC_MoveSibling7,
/* 19522*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19525*/    OPC_RecordNode, // #7 = $m5
/* 19526*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19527*/    OPC_CheckTypeI32,
/* 19528*/    OPC_MoveSibling, 8,
/* 19530*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19533*/    OPC_RecordNode, // #8 = $m6
/* 19534*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19535*/    OPC_CheckTypeI32,
/* 19536*/    OPC_MoveSibling, 9,
/* 19538*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19541*/    OPC_RecordNode, // #9 = $m7
/* 19542*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19543*/    OPC_CheckTypeI32,
/* 19544*/    OPC_MoveSibling, 10,
/* 19546*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19549*/    OPC_RecordNode, // #10 = $m8
/* 19550*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19551*/    OPC_CheckTypeI32,
/* 19552*/    OPC_MoveSibling, 11,
/* 19554*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19557*/    OPC_RecordNode, // #11 = $m9
/* 19558*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19559*/    OPC_CheckTypeI32,
/* 19560*/    OPC_MoveSibling, 12,
/* 19562*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19565*/    OPC_RecordNode, // #12 = $mA
/* 19566*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19567*/    OPC_CheckTypeI32,
/* 19568*/    OPC_MoveSibling, 13,
/* 19570*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19573*/    OPC_RecordNode, // #13 = $mB
/* 19574*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19575*/    OPC_CheckTypeI32,
/* 19576*/    OPC_MoveSibling, 14,
/* 19578*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19581*/    OPC_RecordNode, // #14 = $mC
/* 19582*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19583*/    OPC_CheckTypeI32,
/* 19584*/    OPC_MoveSibling, 15,
/* 19586*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19589*/    OPC_RecordNode, // #15 = $mD
/* 19590*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19591*/    OPC_CheckTypeI32,
/* 19592*/    OPC_MoveSibling, 16,
/* 19594*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19597*/    OPC_RecordNode, // #16 = $mE
/* 19598*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19599*/    OPC_CheckTypeI32,
/* 19600*/    OPC_MoveSibling, 17,
/* 19602*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19605*/    OPC_RecordNode, // #17 = $mF
/* 19606*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19607*/    OPC_CheckTypeI32,
/* 19608*/    OPC_MoveParent,
/* 19609*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 19611*/    OPC_EmitConvertToTarget2, // #18
/* 19612*/    OPC_EmitConvertToTarget3, // #19
/* 19613*/    OPC_EmitConvertToTarget4, // #20
/* 19614*/    OPC_EmitConvertToTarget5, // #21
/* 19615*/    OPC_EmitConvertToTarget6, // #22
/* 19616*/    OPC_EmitConvertToTarget7, // #23
/* 19617*/    OPC_EmitConvertToTarget, 8, // #24
/* 19619*/    OPC_EmitConvertToTarget, 9, // #25
/* 19621*/    OPC_EmitConvertToTarget, 10, // #26
/* 19623*/    OPC_EmitConvertToTarget, 11, // #27
/* 19625*/    OPC_EmitConvertToTarget, 12, // #28
/* 19627*/    OPC_EmitConvertToTarget, 13, // #29
/* 19629*/    OPC_EmitConvertToTarget, 14, // #30
/* 19631*/    OPC_EmitConvertToTarget, 15, // #31
/* 19633*/    OPC_EmitConvertToTarget, 16, // #32
/* 19635*/    OPC_EmitConvertToTarget, 17, // #33
/* 19637*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v4i32*/60, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v4i32] } ?:{ *:[v4i32] }:$x, ?:{ *:[v4i32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19660*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19817
/* 19664*/    OPC_CheckTypeI32,
/* 19665*/    OPC_MoveSibling3,
/* 19666*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19669*/    OPC_RecordNode, // #3 = $m1
/* 19670*/    OPC_CheckTypeI32,
/* 19671*/    OPC_MoveSibling4,
/* 19672*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19675*/    OPC_RecordNode, // #4 = $m2
/* 19676*/    OPC_CheckTypeI32,
/* 19677*/    OPC_MoveSibling5,
/* 19678*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19681*/    OPC_RecordNode, // #5 = $m3
/* 19682*/    OPC_CheckTypeI32,
/* 19683*/    OPC_MoveSibling6,
/* 19684*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19687*/    OPC_RecordNode, // #6 = $m4
/* 19688*/    OPC_CheckTypeI32,
/* 19689*/    OPC_MoveSibling7,
/* 19690*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19693*/    OPC_RecordNode, // #7 = $m5
/* 19694*/    OPC_CheckTypeI32,
/* 19695*/    OPC_MoveSibling, 8,
/* 19697*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19700*/    OPC_RecordNode, // #8 = $m6
/* 19701*/    OPC_CheckTypeI32,
/* 19702*/    OPC_MoveSibling, 9,
/* 19704*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19707*/    OPC_RecordNode, // #9 = $m7
/* 19708*/    OPC_CheckTypeI32,
/* 19709*/    OPC_MoveSibling, 10,
/* 19711*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19714*/    OPC_RecordNode, // #10 = $m8
/* 19715*/    OPC_CheckTypeI32,
/* 19716*/    OPC_MoveSibling, 11,
/* 19718*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19721*/    OPC_RecordNode, // #11 = $m9
/* 19722*/    OPC_CheckTypeI32,
/* 19723*/    OPC_MoveSibling, 12,
/* 19725*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19728*/    OPC_RecordNode, // #12 = $mA
/* 19729*/    OPC_CheckTypeI32,
/* 19730*/    OPC_MoveSibling, 13,
/* 19732*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19735*/    OPC_RecordNode, // #13 = $mB
/* 19736*/    OPC_CheckTypeI32,
/* 19737*/    OPC_MoveSibling, 14,
/* 19739*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19742*/    OPC_RecordNode, // #14 = $mC
/* 19743*/    OPC_CheckTypeI32,
/* 19744*/    OPC_MoveSibling, 15,
/* 19746*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19749*/    OPC_RecordNode, // #15 = $mD
/* 19750*/    OPC_CheckTypeI32,
/* 19751*/    OPC_MoveSibling, 16,
/* 19753*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19756*/    OPC_RecordNode, // #16 = $mE
/* 19757*/    OPC_CheckTypeI32,
/* 19758*/    OPC_MoveSibling, 17,
/* 19760*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19763*/    OPC_RecordNode, // #17 = $mF
/* 19764*/    OPC_CheckTypeI32,
/* 19765*/    OPC_MoveParent,
/* 19766*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 19768*/    OPC_EmitConvertToTarget2, // #18
/* 19769*/    OPC_EmitConvertToTarget3, // #19
/* 19770*/    OPC_EmitConvertToTarget4, // #20
/* 19771*/    OPC_EmitConvertToTarget5, // #21
/* 19772*/    OPC_EmitConvertToTarget6, // #22
/* 19773*/    OPC_EmitConvertToTarget7, // #23
/* 19774*/    OPC_EmitConvertToTarget, 8, // #24
/* 19776*/    OPC_EmitConvertToTarget, 9, // #25
/* 19778*/    OPC_EmitConvertToTarget, 10, // #26
/* 19780*/    OPC_EmitConvertToTarget, 11, // #27
/* 19782*/    OPC_EmitConvertToTarget, 12, // #28
/* 19784*/    OPC_EmitConvertToTarget, 13, // #29
/* 19786*/    OPC_EmitConvertToTarget, 14, // #30
/* 19788*/    OPC_EmitConvertToTarget, 15, // #31
/* 19790*/    OPC_EmitConvertToTarget, 16, // #32
/* 19792*/    OPC_EmitConvertToTarget, 17, // #33
/* 19794*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v4i32*/60, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v4i32] } ?:{ *:[v4i32] }:$x, ?:{ *:[v4i32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19817*/   0, // EndSwitchOpcode
/* 19818*/  /*Scope*/ 83|128,2/*339*/, /*->20159*/
/* 19820*/   OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 19822*/   OPC_RecordChild1, // #1 = $y
/* 19823*/   OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 19825*/   OPC_RecordChild2, // #2 = $m0
/* 19826*/   OPC_MoveChild2,
/* 19827*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->20001
/* 19832*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19833*/    OPC_CheckTypeI32,
/* 19834*/    OPC_MoveSibling3,
/* 19835*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19838*/    OPC_RecordNode, // #3 = $m1
/* 19839*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19840*/    OPC_CheckTypeI32,
/* 19841*/    OPC_MoveSibling4,
/* 19842*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19845*/    OPC_RecordNode, // #4 = $m2
/* 19846*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19847*/    OPC_CheckTypeI32,
/* 19848*/    OPC_MoveSibling5,
/* 19849*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19852*/    OPC_RecordNode, // #5 = $m3
/* 19853*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19854*/    OPC_CheckTypeI32,
/* 19855*/    OPC_MoveSibling6,
/* 19856*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19859*/    OPC_RecordNode, // #6 = $m4
/* 19860*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19861*/    OPC_CheckTypeI32,
/* 19862*/    OPC_MoveSibling7,
/* 19863*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19866*/    OPC_RecordNode, // #7 = $m5
/* 19867*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19868*/    OPC_CheckTypeI32,
/* 19869*/    OPC_MoveSibling, 8,
/* 19871*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19874*/    OPC_RecordNode, // #8 = $m6
/* 19875*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19876*/    OPC_CheckTypeI32,
/* 19877*/    OPC_MoveSibling, 9,
/* 19879*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19882*/    OPC_RecordNode, // #9 = $m7
/* 19883*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19884*/    OPC_CheckTypeI32,
/* 19885*/    OPC_MoveSibling, 10,
/* 19887*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19890*/    OPC_RecordNode, // #10 = $m8
/* 19891*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19892*/    OPC_CheckTypeI32,
/* 19893*/    OPC_MoveSibling, 11,
/* 19895*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19898*/    OPC_RecordNode, // #11 = $m9
/* 19899*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19900*/    OPC_CheckTypeI32,
/* 19901*/    OPC_MoveSibling, 12,
/* 19903*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19906*/    OPC_RecordNode, // #12 = $mA
/* 19907*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19908*/    OPC_CheckTypeI32,
/* 19909*/    OPC_MoveSibling, 13,
/* 19911*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19914*/    OPC_RecordNode, // #13 = $mB
/* 19915*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19916*/    OPC_CheckTypeI32,
/* 19917*/    OPC_MoveSibling, 14,
/* 19919*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19922*/    OPC_RecordNode, // #14 = $mC
/* 19923*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19924*/    OPC_CheckTypeI32,
/* 19925*/    OPC_MoveSibling, 15,
/* 19927*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19930*/    OPC_RecordNode, // #15 = $mD
/* 19931*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19932*/    OPC_CheckTypeI32,
/* 19933*/    OPC_MoveSibling, 16,
/* 19935*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19938*/    OPC_RecordNode, // #16 = $mE
/* 19939*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19940*/    OPC_CheckTypeI32,
/* 19941*/    OPC_MoveSibling, 17,
/* 19943*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19946*/    OPC_RecordNode, // #17 = $mF
/* 19947*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19948*/    OPC_CheckTypeI32,
/* 19949*/    OPC_MoveParent,
/* 19950*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 19952*/    OPC_EmitConvertToTarget2, // #18
/* 19953*/    OPC_EmitConvertToTarget3, // #19
/* 19954*/    OPC_EmitConvertToTarget4, // #20
/* 19955*/    OPC_EmitConvertToTarget5, // #21
/* 19956*/    OPC_EmitConvertToTarget6, // #22
/* 19957*/    OPC_EmitConvertToTarget7, // #23
/* 19958*/    OPC_EmitConvertToTarget, 8, // #24
/* 19960*/    OPC_EmitConvertToTarget, 9, // #25
/* 19962*/    OPC_EmitConvertToTarget, 10, // #26
/* 19964*/    OPC_EmitConvertToTarget, 11, // #27
/* 19966*/    OPC_EmitConvertToTarget, 12, // #28
/* 19968*/    OPC_EmitConvertToTarget, 13, // #29
/* 19970*/    OPC_EmitConvertToTarget, 14, // #30
/* 19972*/    OPC_EmitConvertToTarget, 15, // #31
/* 19974*/    OPC_EmitConvertToTarget, 16, // #32
/* 19976*/    OPC_EmitConvertToTarget, 17, // #33
/* 19978*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v2i64*/78, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v2i64] } ?:{ *:[v2i64] }:$x, ?:{ *:[v2i64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20001*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->20158
/* 20005*/    OPC_CheckTypeI32,
/* 20006*/    OPC_MoveSibling3,
/* 20007*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20010*/    OPC_RecordNode, // #3 = $m1
/* 20011*/    OPC_CheckTypeI32,
/* 20012*/    OPC_MoveSibling4,
/* 20013*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20016*/    OPC_RecordNode, // #4 = $m2
/* 20017*/    OPC_CheckTypeI32,
/* 20018*/    OPC_MoveSibling5,
/* 20019*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20022*/    OPC_RecordNode, // #5 = $m3
/* 20023*/    OPC_CheckTypeI32,
/* 20024*/    OPC_MoveSibling6,
/* 20025*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20028*/    OPC_RecordNode, // #6 = $m4
/* 20029*/    OPC_CheckTypeI32,
/* 20030*/    OPC_MoveSibling7,
/* 20031*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20034*/    OPC_RecordNode, // #7 = $m5
/* 20035*/    OPC_CheckTypeI32,
/* 20036*/    OPC_MoveSibling, 8,
/* 20038*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20041*/    OPC_RecordNode, // #8 = $m6
/* 20042*/    OPC_CheckTypeI32,
/* 20043*/    OPC_MoveSibling, 9,
/* 20045*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20048*/    OPC_RecordNode, // #9 = $m7
/* 20049*/    OPC_CheckTypeI32,
/* 20050*/    OPC_MoveSibling, 10,
/* 20052*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20055*/    OPC_RecordNode, // #10 = $m8
/* 20056*/    OPC_CheckTypeI32,
/* 20057*/    OPC_MoveSibling, 11,
/* 20059*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20062*/    OPC_RecordNode, // #11 = $m9
/* 20063*/    OPC_CheckTypeI32,
/* 20064*/    OPC_MoveSibling, 12,
/* 20066*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20069*/    OPC_RecordNode, // #12 = $mA
/* 20070*/    OPC_CheckTypeI32,
/* 20071*/    OPC_MoveSibling, 13,
/* 20073*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20076*/    OPC_RecordNode, // #13 = $mB
/* 20077*/    OPC_CheckTypeI32,
/* 20078*/    OPC_MoveSibling, 14,
/* 20080*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20083*/    OPC_RecordNode, // #14 = $mC
/* 20084*/    OPC_CheckTypeI32,
/* 20085*/    OPC_MoveSibling, 15,
/* 20087*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20090*/    OPC_RecordNode, // #15 = $mD
/* 20091*/    OPC_CheckTypeI32,
/* 20092*/    OPC_MoveSibling, 16,
/* 20094*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20097*/    OPC_RecordNode, // #16 = $mE
/* 20098*/    OPC_CheckTypeI32,
/* 20099*/    OPC_MoveSibling, 17,
/* 20101*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20104*/    OPC_RecordNode, // #17 = $mF
/* 20105*/    OPC_CheckTypeI32,
/* 20106*/    OPC_MoveParent,
/* 20107*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 20109*/    OPC_EmitConvertToTarget2, // #18
/* 20110*/    OPC_EmitConvertToTarget3, // #19
/* 20111*/    OPC_EmitConvertToTarget4, // #20
/* 20112*/    OPC_EmitConvertToTarget5, // #21
/* 20113*/    OPC_EmitConvertToTarget6, // #22
/* 20114*/    OPC_EmitConvertToTarget7, // #23
/* 20115*/    OPC_EmitConvertToTarget, 8, // #24
/* 20117*/    OPC_EmitConvertToTarget, 9, // #25
/* 20119*/    OPC_EmitConvertToTarget, 10, // #26
/* 20121*/    OPC_EmitConvertToTarget, 11, // #27
/* 20123*/    OPC_EmitConvertToTarget, 12, // #28
/* 20125*/    OPC_EmitConvertToTarget, 13, // #29
/* 20127*/    OPC_EmitConvertToTarget, 14, // #30
/* 20129*/    OPC_EmitConvertToTarget, 15, // #31
/* 20131*/    OPC_EmitConvertToTarget, 16, // #32
/* 20133*/    OPC_EmitConvertToTarget, 17, // #33
/* 20135*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v2i64*/78, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v2i64] } ?:{ *:[v2i64] }:$x, ?:{ *:[v2i64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20158*/   0, // EndSwitchOpcode
/* 20159*/  /*Scope*/ 83|128,2/*339*/, /*->20500*/
/* 20161*/   OPC_CheckChild0Type, /*MVT::v4f32*/111, 
/* 20163*/   OPC_RecordChild1, // #1 = $y
/* 20164*/   OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 20166*/   OPC_RecordChild2, // #2 = $m0
/* 20167*/   OPC_MoveChild2,
/* 20168*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->20342
/* 20173*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20174*/    OPC_CheckTypeI32,
/* 20175*/    OPC_MoveSibling3,
/* 20176*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20179*/    OPC_RecordNode, // #3 = $m1
/* 20180*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20181*/    OPC_CheckTypeI32,
/* 20182*/    OPC_MoveSibling4,
/* 20183*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20186*/    OPC_RecordNode, // #4 = $m2
/* 20187*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20188*/    OPC_CheckTypeI32,
/* 20189*/    OPC_MoveSibling5,
/* 20190*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20193*/    OPC_RecordNode, // #5 = $m3
/* 20194*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20195*/    OPC_CheckTypeI32,
/* 20196*/    OPC_MoveSibling6,
/* 20197*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20200*/    OPC_RecordNode, // #6 = $m4
/* 20201*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20202*/    OPC_CheckTypeI32,
/* 20203*/    OPC_MoveSibling7,
/* 20204*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20207*/    OPC_RecordNode, // #7 = $m5
/* 20208*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20209*/    OPC_CheckTypeI32,
/* 20210*/    OPC_MoveSibling, 8,
/* 20212*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20215*/    OPC_RecordNode, // #8 = $m6
/* 20216*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20217*/    OPC_CheckTypeI32,
/* 20218*/    OPC_MoveSibling, 9,
/* 20220*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20223*/    OPC_RecordNode, // #9 = $m7
/* 20224*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20225*/    OPC_CheckTypeI32,
/* 20226*/    OPC_MoveSibling, 10,
/* 20228*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20231*/    OPC_RecordNode, // #10 = $m8
/* 20232*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20233*/    OPC_CheckTypeI32,
/* 20234*/    OPC_MoveSibling, 11,
/* 20236*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20239*/    OPC_RecordNode, // #11 = $m9
/* 20240*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20241*/    OPC_CheckTypeI32,
/* 20242*/    OPC_MoveSibling, 12,
/* 20244*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20247*/    OPC_RecordNode, // #12 = $mA
/* 20248*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20249*/    OPC_CheckTypeI32,
/* 20250*/    OPC_MoveSibling, 13,
/* 20252*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20255*/    OPC_RecordNode, // #13 = $mB
/* 20256*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20257*/    OPC_CheckTypeI32,
/* 20258*/    OPC_MoveSibling, 14,
/* 20260*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20263*/    OPC_RecordNode, // #14 = $mC
/* 20264*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20265*/    OPC_CheckTypeI32,
/* 20266*/    OPC_MoveSibling, 15,
/* 20268*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20271*/    OPC_RecordNode, // #15 = $mD
/* 20272*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20273*/    OPC_CheckTypeI32,
/* 20274*/    OPC_MoveSibling, 16,
/* 20276*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20279*/    OPC_RecordNode, // #16 = $mE
/* 20280*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20281*/    OPC_CheckTypeI32,
/* 20282*/    OPC_MoveSibling, 17,
/* 20284*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20287*/    OPC_RecordNode, // #17 = $mF
/* 20288*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20289*/    OPC_CheckTypeI32,
/* 20290*/    OPC_MoveParent,
/* 20291*/    OPC_CheckType, /*MVT::v4f32*/111, 
/* 20293*/    OPC_EmitConvertToTarget2, // #18
/* 20294*/    OPC_EmitConvertToTarget3, // #19
/* 20295*/    OPC_EmitConvertToTarget4, // #20
/* 20296*/    OPC_EmitConvertToTarget5, // #21
/* 20297*/    OPC_EmitConvertToTarget6, // #22
/* 20298*/    OPC_EmitConvertToTarget7, // #23
/* 20299*/    OPC_EmitConvertToTarget, 8, // #24
/* 20301*/    OPC_EmitConvertToTarget, 9, // #25
/* 20303*/    OPC_EmitConvertToTarget, 10, // #26
/* 20305*/    OPC_EmitConvertToTarget, 11, // #27
/* 20307*/    OPC_EmitConvertToTarget, 12, // #28
/* 20309*/    OPC_EmitConvertToTarget, 13, // #29
/* 20311*/    OPC_EmitConvertToTarget, 14, // #30
/* 20313*/    OPC_EmitConvertToTarget, 15, // #31
/* 20315*/    OPC_EmitConvertToTarget, 16, // #32
/* 20317*/    OPC_EmitConvertToTarget, 17, // #33
/* 20319*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v4f32*/111, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v4f32] } ?:{ *:[v4f32] }:$x, ?:{ *:[v4f32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20342*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->20499
/* 20346*/    OPC_CheckTypeI32,
/* 20347*/    OPC_MoveSibling3,
/* 20348*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20351*/    OPC_RecordNode, // #3 = $m1
/* 20352*/    OPC_CheckTypeI32,
/* 20353*/    OPC_MoveSibling4,
/* 20354*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20357*/    OPC_RecordNode, // #4 = $m2
/* 20358*/    OPC_CheckTypeI32,
/* 20359*/    OPC_MoveSibling5,
/* 20360*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20363*/    OPC_RecordNode, // #5 = $m3
/* 20364*/    OPC_CheckTypeI32,
/* 20365*/    OPC_MoveSibling6,
/* 20366*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20369*/    OPC_RecordNode, // #6 = $m4
/* 20370*/    OPC_CheckTypeI32,
/* 20371*/    OPC_MoveSibling7,
/* 20372*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20375*/    OPC_RecordNode, // #7 = $m5
/* 20376*/    OPC_CheckTypeI32,
/* 20377*/    OPC_MoveSibling, 8,
/* 20379*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20382*/    OPC_RecordNode, // #8 = $m6
/* 20383*/    OPC_CheckTypeI32,
/* 20384*/    OPC_MoveSibling, 9,
/* 20386*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20389*/    OPC_RecordNode, // #9 = $m7
/* 20390*/    OPC_CheckTypeI32,
/* 20391*/    OPC_MoveSibling, 10,
/* 20393*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20396*/    OPC_RecordNode, // #10 = $m8
/* 20397*/    OPC_CheckTypeI32,
/* 20398*/    OPC_MoveSibling, 11,
/* 20400*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20403*/    OPC_RecordNode, // #11 = $m9
/* 20404*/    OPC_CheckTypeI32,
/* 20405*/    OPC_MoveSibling, 12,
/* 20407*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20410*/    OPC_RecordNode, // #12 = $mA
/* 20411*/    OPC_CheckTypeI32,
/* 20412*/    OPC_MoveSibling, 13,
/* 20414*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20417*/    OPC_RecordNode, // #13 = $mB
/* 20418*/    OPC_CheckTypeI32,
/* 20419*/    OPC_MoveSibling, 14,
/* 20421*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20424*/    OPC_RecordNode, // #14 = $mC
/* 20425*/    OPC_CheckTypeI32,
/* 20426*/    OPC_MoveSibling, 15,
/* 20428*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20431*/    OPC_RecordNode, // #15 = $mD
/* 20432*/    OPC_CheckTypeI32,
/* 20433*/    OPC_MoveSibling, 16,
/* 20435*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20438*/    OPC_RecordNode, // #16 = $mE
/* 20439*/    OPC_CheckTypeI32,
/* 20440*/    OPC_MoveSibling, 17,
/* 20442*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20445*/    OPC_RecordNode, // #17 = $mF
/* 20446*/    OPC_CheckTypeI32,
/* 20447*/    OPC_MoveParent,
/* 20448*/    OPC_CheckType, /*MVT::v4f32*/111, 
/* 20450*/    OPC_EmitConvertToTarget2, // #18
/* 20451*/    OPC_EmitConvertToTarget3, // #19
/* 20452*/    OPC_EmitConvertToTarget4, // #20
/* 20453*/    OPC_EmitConvertToTarget5, // #21
/* 20454*/    OPC_EmitConvertToTarget6, // #22
/* 20455*/    OPC_EmitConvertToTarget7, // #23
/* 20456*/    OPC_EmitConvertToTarget, 8, // #24
/* 20458*/    OPC_EmitConvertToTarget, 9, // #25
/* 20460*/    OPC_EmitConvertToTarget, 10, // #26
/* 20462*/    OPC_EmitConvertToTarget, 11, // #27
/* 20464*/    OPC_EmitConvertToTarget, 12, // #28
/* 20466*/    OPC_EmitConvertToTarget, 13, // #29
/* 20468*/    OPC_EmitConvertToTarget, 14, // #30
/* 20470*/    OPC_EmitConvertToTarget, 15, // #31
/* 20472*/    OPC_EmitConvertToTarget, 16, // #32
/* 20474*/    OPC_EmitConvertToTarget, 17, // #33
/* 20476*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v4f32*/111, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v4f32] } ?:{ *:[v4f32] }:$x, ?:{ *:[v4f32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20499*/   0, // EndSwitchOpcode
/* 20500*/  /*Scope*/ 89|128,2/*345*/, /*->20847*/
/* 20502*/   OPC_CheckChild0Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 20505*/   OPC_RecordChild1, // #1 = $y
/* 20506*/   OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 20509*/   OPC_RecordChild2, // #2 = $m0
/* 20510*/   OPC_MoveChild2,
/* 20511*/   OPC_SwitchOpcode /*2 cases */, 43|128,1/*171*/, TARGET_VAL(ISD::Constant),// ->20687
/* 20516*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20517*/    OPC_CheckTypeI32,
/* 20518*/    OPC_MoveSibling3,
/* 20519*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20522*/    OPC_RecordNode, // #3 = $m1
/* 20523*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20524*/    OPC_CheckTypeI32,
/* 20525*/    OPC_MoveSibling4,
/* 20526*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20529*/    OPC_RecordNode, // #4 = $m2
/* 20530*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20531*/    OPC_CheckTypeI32,
/* 20532*/    OPC_MoveSibling5,
/* 20533*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20536*/    OPC_RecordNode, // #5 = $m3
/* 20537*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20538*/    OPC_CheckTypeI32,
/* 20539*/    OPC_MoveSibling6,
/* 20540*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20543*/    OPC_RecordNode, // #6 = $m4
/* 20544*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20545*/    OPC_CheckTypeI32,
/* 20546*/    OPC_MoveSibling7,
/* 20547*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20550*/    OPC_RecordNode, // #7 = $m5
/* 20551*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20552*/    OPC_CheckTypeI32,
/* 20553*/    OPC_MoveSibling, 8,
/* 20555*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20558*/    OPC_RecordNode, // #8 = $m6
/* 20559*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20560*/    OPC_CheckTypeI32,
/* 20561*/    OPC_MoveSibling, 9,
/* 20563*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20566*/    OPC_RecordNode, // #9 = $m7
/* 20567*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20568*/    OPC_CheckTypeI32,
/* 20569*/    OPC_MoveSibling, 10,
/* 20571*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20574*/    OPC_RecordNode, // #10 = $m8
/* 20575*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20576*/    OPC_CheckTypeI32,
/* 20577*/    OPC_MoveSibling, 11,
/* 20579*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20582*/    OPC_RecordNode, // #11 = $m9
/* 20583*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20584*/    OPC_CheckTypeI32,
/* 20585*/    OPC_MoveSibling, 12,
/* 20587*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20590*/    OPC_RecordNode, // #12 = $mA
/* 20591*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20592*/    OPC_CheckTypeI32,
/* 20593*/    OPC_MoveSibling, 13,
/* 20595*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20598*/    OPC_RecordNode, // #13 = $mB
/* 20599*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20600*/    OPC_CheckTypeI32,
/* 20601*/    OPC_MoveSibling, 14,
/* 20603*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20606*/    OPC_RecordNode, // #14 = $mC
/* 20607*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20608*/    OPC_CheckTypeI32,
/* 20609*/    OPC_MoveSibling, 15,
/* 20611*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20614*/    OPC_RecordNode, // #15 = $mD
/* 20615*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20616*/    OPC_CheckTypeI32,
/* 20617*/    OPC_MoveSibling, 16,
/* 20619*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20622*/    OPC_RecordNode, // #16 = $mE
/* 20623*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20624*/    OPC_CheckTypeI32,
/* 20625*/    OPC_MoveSibling, 17,
/* 20627*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20630*/    OPC_RecordNode, // #17 = $mF
/* 20631*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20632*/    OPC_CheckTypeI32,
/* 20633*/    OPC_MoveParent,
/* 20634*/    OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 20637*/    OPC_EmitConvertToTarget2, // #18
/* 20638*/    OPC_EmitConvertToTarget3, // #19
/* 20639*/    OPC_EmitConvertToTarget4, // #20
/* 20640*/    OPC_EmitConvertToTarget5, // #21
/* 20641*/    OPC_EmitConvertToTarget6, // #22
/* 20642*/    OPC_EmitConvertToTarget7, // #23
/* 20643*/    OPC_EmitConvertToTarget, 8, // #24
/* 20645*/    OPC_EmitConvertToTarget, 9, // #25
/* 20647*/    OPC_EmitConvertToTarget, 10, // #26
/* 20649*/    OPC_EmitConvertToTarget, 11, // #27
/* 20651*/    OPC_EmitConvertToTarget, 12, // #28
/* 20653*/    OPC_EmitConvertToTarget, 13, // #29
/* 20655*/    OPC_EmitConvertToTarget, 14, // #30
/* 20657*/    OPC_EmitConvertToTarget, 15, // #31
/* 20659*/    OPC_EmitConvertToTarget, 16, // #32
/* 20661*/    OPC_EmitConvertToTarget, 17, // #33
/* 20663*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v2f64*/1|128,1/*129*/, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v2f64] } ?:{ *:[v2f64] }:$x, ?:{ *:[v2f64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20687*/   /*SwitchOpcode*/ 27|128,1/*155*/, TARGET_VAL(ISD::TargetConstant),// ->20846
/* 20691*/    OPC_CheckTypeI32,
/* 20692*/    OPC_MoveSibling3,
/* 20693*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20696*/    OPC_RecordNode, // #3 = $m1
/* 20697*/    OPC_CheckTypeI32,
/* 20698*/    OPC_MoveSibling4,
/* 20699*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20702*/    OPC_RecordNode, // #4 = $m2
/* 20703*/    OPC_CheckTypeI32,
/* 20704*/    OPC_MoveSibling5,
/* 20705*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20708*/    OPC_RecordNode, // #5 = $m3
/* 20709*/    OPC_CheckTypeI32,
/* 20710*/    OPC_MoveSibling6,
/* 20711*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20714*/    OPC_RecordNode, // #6 = $m4
/* 20715*/    OPC_CheckTypeI32,
/* 20716*/    OPC_MoveSibling7,
/* 20717*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20720*/    OPC_RecordNode, // #7 = $m5
/* 20721*/    OPC_CheckTypeI32,
/* 20722*/    OPC_MoveSibling, 8,
/* 20724*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20727*/    OPC_RecordNode, // #8 = $m6
/* 20728*/    OPC_CheckTypeI32,
/* 20729*/    OPC_MoveSibling, 9,
/* 20731*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20734*/    OPC_RecordNode, // #9 = $m7
/* 20735*/    OPC_CheckTypeI32,
/* 20736*/    OPC_MoveSibling, 10,
/* 20738*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20741*/    OPC_RecordNode, // #10 = $m8
/* 20742*/    OPC_CheckTypeI32,
/* 20743*/    OPC_MoveSibling, 11,
/* 20745*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20748*/    OPC_RecordNode, // #11 = $m9
/* 20749*/    OPC_CheckTypeI32,
/* 20750*/    OPC_MoveSibling, 12,
/* 20752*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20755*/    OPC_RecordNode, // #12 = $mA
/* 20756*/    OPC_CheckTypeI32,
/* 20757*/    OPC_MoveSibling, 13,
/* 20759*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20762*/    OPC_RecordNode, // #13 = $mB
/* 20763*/    OPC_CheckTypeI32,
/* 20764*/    OPC_MoveSibling, 14,
/* 20766*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20769*/    OPC_RecordNode, // #14 = $mC
/* 20770*/    OPC_CheckTypeI32,
/* 20771*/    OPC_MoveSibling, 15,
/* 20773*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20776*/    OPC_RecordNode, // #15 = $mD
/* 20777*/    OPC_CheckTypeI32,
/* 20778*/    OPC_MoveSibling, 16,
/* 20780*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20783*/    OPC_RecordNode, // #16 = $mE
/* 20784*/    OPC_CheckTypeI32,
/* 20785*/    OPC_MoveSibling, 17,
/* 20787*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20790*/    OPC_RecordNode, // #17 = $mF
/* 20791*/    OPC_CheckTypeI32,
/* 20792*/    OPC_MoveParent,
/* 20793*/    OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 20796*/    OPC_EmitConvertToTarget2, // #18
/* 20797*/    OPC_EmitConvertToTarget3, // #19
/* 20798*/    OPC_EmitConvertToTarget4, // #20
/* 20799*/    OPC_EmitConvertToTarget5, // #21
/* 20800*/    OPC_EmitConvertToTarget6, // #22
/* 20801*/    OPC_EmitConvertToTarget7, // #23
/* 20802*/    OPC_EmitConvertToTarget, 8, // #24
/* 20804*/    OPC_EmitConvertToTarget, 9, // #25
/* 20806*/    OPC_EmitConvertToTarget, 10, // #26
/* 20808*/    OPC_EmitConvertToTarget, 11, // #27
/* 20810*/    OPC_EmitConvertToTarget, 12, // #28
/* 20812*/    OPC_EmitConvertToTarget, 13, // #29
/* 20814*/    OPC_EmitConvertToTarget, 14, // #30
/* 20816*/    OPC_EmitConvertToTarget, 15, // #31
/* 20818*/    OPC_EmitConvertToTarget, 16, // #32
/* 20820*/    OPC_EmitConvertToTarget, 17, // #33
/* 20822*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v2f64*/1|128,1/*129*/, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v2f64] } ?:{ *:[v2f64] }:$x, ?:{ *:[v2f64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20846*/   0, // EndSwitchOpcode
/* 20847*/  /*Scope*/ 83|128,2/*339*/, /*->21188*/
/* 20849*/   OPC_CheckChild0Type, /*MVT::v8f16*/92, 
/* 20851*/   OPC_RecordChild1, // #1 = $y
/* 20852*/   OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 20854*/   OPC_RecordChild2, // #2 = $m0
/* 20855*/   OPC_MoveChild2,
/* 20856*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->21030
/* 20861*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20862*/    OPC_CheckTypeI32,
/* 20863*/    OPC_MoveSibling3,
/* 20864*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20867*/    OPC_RecordNode, // #3 = $m1
/* 20868*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20869*/    OPC_CheckTypeI32,
/* 20870*/    OPC_MoveSibling4,
/* 20871*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20874*/    OPC_RecordNode, // #4 = $m2
/* 20875*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20876*/    OPC_CheckTypeI32,
/* 20877*/    OPC_MoveSibling5,
/* 20878*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20881*/    OPC_RecordNode, // #5 = $m3
/* 20882*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20883*/    OPC_CheckTypeI32,
/* 20884*/    OPC_MoveSibling6,
/* 20885*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20888*/    OPC_RecordNode, // #6 = $m4
/* 20889*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20890*/    OPC_CheckTypeI32,
/* 20891*/    OPC_MoveSibling7,
/* 20892*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20895*/    OPC_RecordNode, // #7 = $m5
/* 20896*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20897*/    OPC_CheckTypeI32,
/* 20898*/    OPC_MoveSibling, 8,
/* 20900*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20903*/    OPC_RecordNode, // #8 = $m6
/* 20904*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20905*/    OPC_CheckTypeI32,
/* 20906*/    OPC_MoveSibling, 9,
/* 20908*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20911*/    OPC_RecordNode, // #9 = $m7
/* 20912*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20913*/    OPC_CheckTypeI32,
/* 20914*/    OPC_MoveSibling, 10,
/* 20916*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20919*/    OPC_RecordNode, // #10 = $m8
/* 20920*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20921*/    OPC_CheckTypeI32,
/* 20922*/    OPC_MoveSibling, 11,
/* 20924*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20927*/    OPC_RecordNode, // #11 = $m9
/* 20928*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20929*/    OPC_CheckTypeI32,
/* 20930*/    OPC_MoveSibling, 12,
/* 20932*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20935*/    OPC_RecordNode, // #12 = $mA
/* 20936*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20937*/    OPC_CheckTypeI32,
/* 20938*/    OPC_MoveSibling, 13,
/* 20940*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20943*/    OPC_RecordNode, // #13 = $mB
/* 20944*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20945*/    OPC_CheckTypeI32,
/* 20946*/    OPC_MoveSibling, 14,
/* 20948*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20951*/    OPC_RecordNode, // #14 = $mC
/* 20952*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20953*/    OPC_CheckTypeI32,
/* 20954*/    OPC_MoveSibling, 15,
/* 20956*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20959*/    OPC_RecordNode, // #15 = $mD
/* 20960*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20961*/    OPC_CheckTypeI32,
/* 20962*/    OPC_MoveSibling, 16,
/* 20964*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20967*/    OPC_RecordNode, // #16 = $mE
/* 20968*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20969*/    OPC_CheckTypeI32,
/* 20970*/    OPC_MoveSibling, 17,
/* 20972*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20975*/    OPC_RecordNode, // #17 = $mF
/* 20976*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20977*/    OPC_CheckTypeI32,
/* 20978*/    OPC_MoveParent,
/* 20979*/    OPC_CheckType, /*MVT::v8f16*/92, 
/* 20981*/    OPC_EmitConvertToTarget2, // #18
/* 20982*/    OPC_EmitConvertToTarget3, // #19
/* 20983*/    OPC_EmitConvertToTarget4, // #20
/* 20984*/    OPC_EmitConvertToTarget5, // #21
/* 20985*/    OPC_EmitConvertToTarget6, // #22
/* 20986*/    OPC_EmitConvertToTarget7, // #23
/* 20987*/    OPC_EmitConvertToTarget, 8, // #24
/* 20989*/    OPC_EmitConvertToTarget, 9, // #25
/* 20991*/    OPC_EmitConvertToTarget, 10, // #26
/* 20993*/    OPC_EmitConvertToTarget, 11, // #27
/* 20995*/    OPC_EmitConvertToTarget, 12, // #28
/* 20997*/    OPC_EmitConvertToTarget, 13, // #29
/* 20999*/    OPC_EmitConvertToTarget, 14, // #30
/* 21001*/    OPC_EmitConvertToTarget, 15, // #31
/* 21003*/    OPC_EmitConvertToTarget, 16, // #32
/* 21005*/    OPC_EmitConvertToTarget, 17, // #33
/* 21007*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v8f16*/92, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8f16] } V128:{ *:[v8f16] }:$x, V128:{ *:[v8f16] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v8f16] } ?:{ *:[v8f16] }:$x, ?:{ *:[v8f16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 21030*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->21187
/* 21034*/    OPC_CheckTypeI32,
/* 21035*/    OPC_MoveSibling3,
/* 21036*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21039*/    OPC_RecordNode, // #3 = $m1
/* 21040*/    OPC_CheckTypeI32,
/* 21041*/    OPC_MoveSibling4,
/* 21042*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21045*/    OPC_RecordNode, // #4 = $m2
/* 21046*/    OPC_CheckTypeI32,
/* 21047*/    OPC_MoveSibling5,
/* 21048*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21051*/    OPC_RecordNode, // #5 = $m3
/* 21052*/    OPC_CheckTypeI32,
/* 21053*/    OPC_MoveSibling6,
/* 21054*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21057*/    OPC_RecordNode, // #6 = $m4
/* 21058*/    OPC_CheckTypeI32,
/* 21059*/    OPC_MoveSibling7,
/* 21060*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21063*/    OPC_RecordNode, // #7 = $m5
/* 21064*/    OPC_CheckTypeI32,
/* 21065*/    OPC_MoveSibling, 8,
/* 21067*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21070*/    OPC_RecordNode, // #8 = $m6
/* 21071*/    OPC_CheckTypeI32,
/* 21072*/    OPC_MoveSibling, 9,
/* 21074*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21077*/    OPC_RecordNode, // #9 = $m7
/* 21078*/    OPC_CheckTypeI32,
/* 21079*/    OPC_MoveSibling, 10,
/* 21081*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21084*/    OPC_RecordNode, // #10 = $m8
/* 21085*/    OPC_CheckTypeI32,
/* 21086*/    OPC_MoveSibling, 11,
/* 21088*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21091*/    OPC_RecordNode, // #11 = $m9
/* 21092*/    OPC_CheckTypeI32,
/* 21093*/    OPC_MoveSibling, 12,
/* 21095*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21098*/    OPC_RecordNode, // #12 = $mA
/* 21099*/    OPC_CheckTypeI32,
/* 21100*/    OPC_MoveSibling, 13,
/* 21102*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21105*/    OPC_RecordNode, // #13 = $mB
/* 21106*/    OPC_CheckTypeI32,
/* 21107*/    OPC_MoveSibling, 14,
/* 21109*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21112*/    OPC_RecordNode, // #14 = $mC
/* 21113*/    OPC_CheckTypeI32,
/* 21114*/    OPC_MoveSibling, 15,
/* 21116*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21119*/    OPC_RecordNode, // #15 = $mD
/* 21120*/    OPC_CheckTypeI32,
/* 21121*/    OPC_MoveSibling, 16,
/* 21123*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21126*/    OPC_RecordNode, // #16 = $mE
/* 21127*/    OPC_CheckTypeI32,
/* 21128*/    OPC_MoveSibling, 17,
/* 21130*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21133*/    OPC_RecordNode, // #17 = $mF
/* 21134*/    OPC_CheckTypeI32,
/* 21135*/    OPC_MoveParent,
/* 21136*/    OPC_CheckType, /*MVT::v8f16*/92, 
/* 21138*/    OPC_EmitConvertToTarget2, // #18
/* 21139*/    OPC_EmitConvertToTarget3, // #19
/* 21140*/    OPC_EmitConvertToTarget4, // #20
/* 21141*/    OPC_EmitConvertToTarget5, // #21
/* 21142*/    OPC_EmitConvertToTarget6, // #22
/* 21143*/    OPC_EmitConvertToTarget7, // #23
/* 21144*/    OPC_EmitConvertToTarget, 8, // #24
/* 21146*/    OPC_EmitConvertToTarget, 9, // #25
/* 21148*/    OPC_EmitConvertToTarget, 10, // #26
/* 21150*/    OPC_EmitConvertToTarget, 11, // #27
/* 21152*/    OPC_EmitConvertToTarget, 12, // #28
/* 21154*/    OPC_EmitConvertToTarget, 13, // #29
/* 21156*/    OPC_EmitConvertToTarget, 14, // #30
/* 21158*/    OPC_EmitConvertToTarget, 15, // #31
/* 21160*/    OPC_EmitConvertToTarget, 16, // #32
/* 21162*/    OPC_EmitConvertToTarget, 17, // #33
/* 21164*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v8f16*/92, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8f16] } V128:{ *:[v8f16] }:$x, V128:{ *:[v8f16] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v8f16] } ?:{ *:[v8f16] }:$x, ?:{ *:[v8f16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 21187*/   0, // EndSwitchOpcode
/* 21188*/  0, /*End of Scope*/
/* 21189*/ /*SwitchOpcode*/ 73|128,8/*1097*/, TARGET_VAL(ISD::INSERT_VECTOR_ELT),// ->22290
/* 21193*/  OPC_Scope, 6|128,1/*134*/, /*->21330*/ // 2 children in Scope
/* 21196*/   OPC_MoveChild0,
/* 21197*/   OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
/* 21200*/   OPC_CheckChild0Integer, 0, 
/* 21202*/   OPC_Scope, 62, /*->21266*/ // 2 children in Scope
/* 21204*/    OPC_CheckChild0TypeI32,
/* 21205*/    OPC_MoveSibling1,
/* 21206*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21209*/    OPC_RecordMemRef,
/* 21210*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 21211*/    OPC_CheckFoldableChainNode,
/* 21212*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 21213*/    OPC_CheckTypeI32,
/* 21214*/    OPC_Scope, 24, /*->21240*/ // 2 children in Scope
/* 21216*/     OPC_CheckChild1TypeI32,
/* 21217*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 21219*/     OPC_CheckPredicate6,  // Predicate_load
/* 21220*/     OPC_MoveParent,
/* 21221*/     OPC_CheckChild2Integer, 0, 
/* 21223*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 21225*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21226*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21228*/     OPC_EmitMergeInputChains1_0,
/* 21229*/     OPC_EmitInteger32, 0,  // 0 #4
/* 21231*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v4i32] } (splat_vector:{ *:[v4i32] } 0:{ *:[i32] }), (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_32_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21240*/    /*Scope*/ 24, /*->21265*/
/* 21241*/     OPC_CheckChild1TypeI64,
/* 21242*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 21244*/     OPC_CheckPredicate6,  // Predicate_load
/* 21245*/     OPC_MoveParent,
/* 21246*/     OPC_CheckChild2Integer, 0, 
/* 21248*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 21250*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21251*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21253*/     OPC_EmitMergeInputChains1_0,
/* 21254*/     OPC_EmitInteger32, 0,  // 0 #4
/* 21256*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v4i32] } (splat_vector:{ *:[v4i32] } 0:{ *:[i32] }), (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_32_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21265*/    0, /*End of Scope*/
/* 21266*/   /*Scope*/ 62, /*->21329*/
/* 21267*/    OPC_CheckChild0TypeI64,
/* 21268*/    OPC_MoveSibling1,
/* 21269*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21272*/    OPC_RecordMemRef,
/* 21273*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 21274*/    OPC_CheckFoldableChainNode,
/* 21275*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 21276*/    OPC_CheckTypeI64,
/* 21277*/    OPC_Scope, 24, /*->21303*/ // 2 children in Scope
/* 21279*/     OPC_CheckChild1TypeI32,
/* 21280*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 21282*/     OPC_CheckPredicate6,  // Predicate_load
/* 21283*/     OPC_MoveParent,
/* 21284*/     OPC_CheckChild2Integer, 0, 
/* 21286*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 21288*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21289*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21291*/     OPC_EmitMergeInputChains1_0,
/* 21292*/     OPC_EmitInteger32, 0,  // 0 #4
/* 21294*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v2i64] } (splat_vector:{ *:[v2i64] } 0:{ *:[i64] }), (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_64_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21303*/    /*Scope*/ 24, /*->21328*/
/* 21304*/     OPC_CheckChild1TypeI64,
/* 21305*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 21307*/     OPC_CheckPredicate6,  // Predicate_load
/* 21308*/     OPC_MoveParent,
/* 21309*/     OPC_CheckChild2Integer, 0, 
/* 21311*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 21313*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21314*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21316*/     OPC_EmitMergeInputChains1_0,
/* 21317*/     OPC_EmitInteger32, 0,  // 0 #4
/* 21319*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v2i64] } (splat_vector:{ *:[v2i64] } 0:{ *:[i64] }), (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_64_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21328*/    0, /*End of Scope*/
/* 21329*/   0, /*End of Scope*/
/* 21330*/  /*Scope*/ 61|128,7/*957*/, /*->22289*/
/* 21332*/   OPC_RecordChild0, // #0 = $vec
/* 21333*/   OPC_Scope, 32|128,3/*416*/, /*->21752*/ // 4 children in Scope
/* 21336*/    OPC_MoveChild1,
/* 21337*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21340*/    OPC_RecordMemRef,
/* 21341*/    OPC_RecordNode, // #1 = 'ld' chained node
/* 21342*/    OPC_CheckFoldableChainNode,
/* 21343*/    OPC_RecordChild1, // #2 = $addr
/* 21344*/    OPC_Scope, 73|128,1/*201*/, /*->21548*/ // 2 children in Scope
/* 21347*/     OPC_CheckChild1TypeI32,
/* 21348*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 21350*/     OPC_Scope, 67, /*->21419*/ // 2 children in Scope
/* 21352*/      OPC_CheckPredicate, 10, // Predicate_extload
/* 21354*/      OPC_CheckTypeI32,
/* 21355*/      OPC_Scope, 30, /*->21387*/ // 2 children in Scope
/* 21357*/       OPC_CheckPredicate1,  // Predicate_extloadi8
/* 21358*/       OPC_MoveSibling2,
/* 21359*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21362*/       OPC_RecordNode, // #3 = $idx
/* 21363*/       OPC_CheckPredicate, 18, // Predicate_LaneIdx16
/* 21365*/       OPC_CheckTypeI32,
/* 21366*/       OPC_MoveParent,
/* 21367*/       OPC_CheckType, /*MVT::v16i8*/39, 
/* 21369*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21370*/       OPC_EmitMergeInputChains1_1,
/* 21371*/       OPC_EmitInteger32, 0,  // 0 #4
/* 21373*/       OPC_EmitInteger32, 0,  // 0 #5
/* 21375*/       OPC_EmitConvertToTarget3, // #6
/* 21376*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v16i8*/39, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_8_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 21387*/      /*Scope*/ 30, /*->21418*/
/* 21388*/       OPC_CheckPredicate2,  // Predicate_extloadi16
/* 21389*/       OPC_MoveSibling2,
/* 21390*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21393*/       OPC_RecordNode, // #3 = $idx
/* 21394*/       OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/* 21396*/       OPC_CheckTypeI32,
/* 21397*/       OPC_MoveParent,
/* 21398*/       OPC_CheckType, /*MVT::v8i16*/50, 
/* 21400*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21401*/       OPC_EmitMergeInputChains1_1,
/* 21402*/       OPC_EmitInteger32, 0,  // 0 #4
/* 21404*/       OPC_EmitInteger32, 0,  // 0 #5
/* 21406*/       OPC_EmitConvertToTarget3, // #6
/* 21407*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v8i16*/50, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_16_A32:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 21418*/      0, /*End of Scope*/
/* 21419*/     /*Scope*/ 127, /*->21547*/
/* 21420*/      OPC_CheckPredicate6,  // Predicate_load
/* 21421*/      OPC_SwitchType /*4 cases */, 29, /*MVT::i32*/7, // ->21453
/* 21424*/       OPC_MoveSibling2,
/* 21425*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21428*/       OPC_RecordNode, // #3 = $idx
/* 21429*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21431*/       OPC_CheckTypeI32,
/* 21432*/       OPC_MoveParent,
/* 21433*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21435*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21436*/       OPC_EmitMergeInputChains1_1,
/* 21437*/       OPC_EmitInteger32, 0,  // 0 #4
/* 21439*/       OPC_EmitInteger32, 0,  // 0 #5
/* 21441*/       OPC_EmitConvertToTarget3, // #6
/* 21442*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v4i32*/60, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_32_A32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 21453*/      /*SwitchType*/ 29, /*MVT::f32*/12, // ->21484
/* 21455*/       OPC_MoveSibling2,
/* 21456*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21459*/       OPC_RecordNode, // #3 = $idx
/* 21460*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21462*/       OPC_CheckTypeI32,
/* 21463*/       OPC_MoveParent,
/* 21464*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21466*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21467*/       OPC_EmitMergeInputChains1_1,
/* 21468*/       OPC_EmitInteger32, 0,  // 0 #4
/* 21470*/       OPC_EmitInteger32, 0,  // 0 #5
/* 21472*/       OPC_EmitConvertToTarget3, // #6
/* 21473*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v4i32*/60, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[f32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_32_A32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 21484*/      /*SwitchType*/ 29, /*MVT::i64*/8, // ->21515
/* 21486*/       OPC_MoveSibling2,
/* 21487*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21490*/       OPC_RecordNode, // #3 = $idx
/* 21491*/       OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21493*/       OPC_CheckTypeI32,
/* 21494*/       OPC_MoveParent,
/* 21495*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 21497*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21498*/       OPC_EmitMergeInputChains1_1,
/* 21499*/       OPC_EmitInteger32, 0,  // 0 #4
/* 21501*/       OPC_EmitInteger32, 0,  // 0 #5
/* 21503*/       OPC_EmitConvertToTarget3, // #6
/* 21504*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v2i64*/78, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_64_A32:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 21515*/      /*SwitchType*/ 29, /*MVT::f64*/13, // ->21546
/* 21517*/       OPC_MoveSibling2,
/* 21518*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21521*/       OPC_RecordNode, // #3 = $idx
/* 21522*/       OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21524*/       OPC_CheckTypeI32,
/* 21525*/       OPC_MoveParent,
/* 21526*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 21528*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21529*/       OPC_EmitMergeInputChains1_1,
/* 21530*/       OPC_EmitInteger32, 0,  // 0 #4
/* 21532*/       OPC_EmitInteger32, 0,  // 0 #5
/* 21534*/       OPC_EmitConvertToTarget3, // #6
/* 21535*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v2i64*/78, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_64_A32:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 21546*/      0, // EndSwitchType
/* 21547*/     0, /*End of Scope*/
/* 21548*/    /*Scope*/ 73|128,1/*201*/, /*->21751*/
/* 21550*/     OPC_CheckChild1TypeI64,
/* 21551*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 21553*/     OPC_Scope, 67, /*->21622*/ // 2 children in Scope
/* 21555*/      OPC_CheckPredicate, 10, // Predicate_extload
/* 21557*/      OPC_CheckTypeI32,
/* 21558*/      OPC_Scope, 30, /*->21590*/ // 2 children in Scope
/* 21560*/       OPC_CheckPredicate1,  // Predicate_extloadi8
/* 21561*/       OPC_MoveSibling2,
/* 21562*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21565*/       OPC_RecordNode, // #3 = $idx
/* 21566*/       OPC_CheckPredicate, 18, // Predicate_LaneIdx16
/* 21568*/       OPC_CheckTypeI32,
/* 21569*/       OPC_MoveParent,
/* 21570*/       OPC_CheckType, /*MVT::v16i8*/39, 
/* 21572*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21573*/       OPC_EmitMergeInputChains1_1,
/* 21574*/       OPC_EmitInteger32, 0,  // 0 #4
/* 21576*/       OPC_EmitInteger64, 0,  // 0 #5
/* 21578*/       OPC_EmitConvertToTarget3, // #6
/* 21579*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v16i8*/39, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_8_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 21590*/      /*Scope*/ 30, /*->21621*/
/* 21591*/       OPC_CheckPredicate2,  // Predicate_extloadi16
/* 21592*/       OPC_MoveSibling2,
/* 21593*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21596*/       OPC_RecordNode, // #3 = $idx
/* 21597*/       OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/* 21599*/       OPC_CheckTypeI32,
/* 21600*/       OPC_MoveParent,
/* 21601*/       OPC_CheckType, /*MVT::v8i16*/50, 
/* 21603*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21604*/       OPC_EmitMergeInputChains1_1,
/* 21605*/       OPC_EmitInteger32, 0,  // 0 #4
/* 21607*/       OPC_EmitInteger64, 0,  // 0 #5
/* 21609*/       OPC_EmitConvertToTarget3, // #6
/* 21610*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v8i16*/50, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_16_A64:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 21621*/      0, /*End of Scope*/
/* 21622*/     /*Scope*/ 127, /*->21750*/
/* 21623*/      OPC_CheckPredicate6,  // Predicate_load
/* 21624*/      OPC_SwitchType /*4 cases */, 29, /*MVT::i32*/7, // ->21656
/* 21627*/       OPC_MoveSibling2,
/* 21628*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21631*/       OPC_RecordNode, // #3 = $idx
/* 21632*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21634*/       OPC_CheckTypeI32,
/* 21635*/       OPC_MoveParent,
/* 21636*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21638*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21639*/       OPC_EmitMergeInputChains1_1,
/* 21640*/       OPC_EmitInteger32, 0,  // 0 #4
/* 21642*/       OPC_EmitInteger64, 0,  // 0 #5
/* 21644*/       OPC_EmitConvertToTarget3, // #6
/* 21645*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v4i32*/60, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_32_A64:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 21656*/      /*SwitchType*/ 29, /*MVT::f32*/12, // ->21687
/* 21658*/       OPC_MoveSibling2,
/* 21659*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21662*/       OPC_RecordNode, // #3 = $idx
/* 21663*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21665*/       OPC_CheckTypeI32,
/* 21666*/       OPC_MoveParent,
/* 21667*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21669*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21670*/       OPC_EmitMergeInputChains1_1,
/* 21671*/       OPC_EmitInteger32, 0,  // 0 #4
/* 21673*/       OPC_EmitInteger64, 0,  // 0 #5
/* 21675*/       OPC_EmitConvertToTarget3, // #6
/* 21676*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v4i32*/60, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[f32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_32_A64:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 21687*/      /*SwitchType*/ 29, /*MVT::i64*/8, // ->21718
/* 21689*/       OPC_MoveSibling2,
/* 21690*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21693*/       OPC_RecordNode, // #3 = $idx
/* 21694*/       OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21696*/       OPC_CheckTypeI32,
/* 21697*/       OPC_MoveParent,
/* 21698*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 21700*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21701*/       OPC_EmitMergeInputChains1_1,
/* 21702*/       OPC_EmitInteger32, 0,  // 0 #4
/* 21704*/       OPC_EmitInteger64, 0,  // 0 #5
/* 21706*/       OPC_EmitConvertToTarget3, // #6
/* 21707*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v2i64*/78, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_64_A64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 21718*/      /*SwitchType*/ 29, /*MVT::f64*/13, // ->21749
/* 21720*/       OPC_MoveSibling2,
/* 21721*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21724*/       OPC_RecordNode, // #3 = $idx
/* 21725*/       OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21727*/       OPC_CheckTypeI32,
/* 21728*/       OPC_MoveParent,
/* 21729*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 21731*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21732*/       OPC_EmitMergeInputChains1_1,
/* 21733*/       OPC_EmitInteger32, 0,  // 0 #4
/* 21735*/       OPC_EmitInteger64, 0,  // 0 #5
/* 21737*/       OPC_EmitConvertToTarget3, // #6
/* 21738*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v2i64*/78, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[f64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_64_A64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 21749*/      0, // EndSwitchType
/* 21750*/     0, /*End of Scope*/
/* 21751*/    0, /*End of Scope*/
/* 21752*/   /*Scope*/ 24|128,1/*152*/, /*->21906*/
/* 21754*/    OPC_RecordChild1, // #1 = $x
/* 21755*/    OPC_Scope, 104, /*->21861*/ // 2 children in Scope
/* 21757*/     OPC_CheckChild1TypeI32,
/* 21758*/     OPC_Scope, 56, /*->21816*/ // 2 children in Scope
/* 21760*/      OPC_RecordChild2, // #2 = $idx
/* 21761*/      OPC_MoveChild2,
/* 21762*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21765*/      OPC_CheckTypeI32,
/* 21766*/      OPC_Scope, 15, /*->21783*/ // 3 children in Scope
/* 21768*/       OPC_CheckPredicate, 18, // Predicate_LaneIdx16
/* 21770*/       OPC_MoveParent,
/* 21771*/       OPC_CheckType, /*MVT::v16i8*/39, 
/* 21773*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21774*/       OPC_EmitConvertToTarget2, // #3
/* 21775*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16),
                     /*MVT::v16i8*/39, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 21783*/      /*Scope*/ 15, /*->21799*/
/* 21784*/       OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/* 21786*/       OPC_MoveParent,
/* 21787*/       OPC_CheckType, /*MVT::v8i16*/50, 
/* 21789*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21790*/       OPC_EmitConvertToTarget2, // #3
/* 21791*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8),
                     /*MVT::v8i16*/50, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 21799*/      /*Scope*/ 15, /*->21815*/
/* 21800*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21802*/       OPC_MoveParent,
/* 21803*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21805*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21806*/       OPC_EmitConvertToTarget2, // #3
/* 21807*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4),
                     /*MVT::v4i32*/60, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 21815*/      0, /*End of Scope*/
/* 21816*/     /*Scope*/ 43, /*->21860*/
/* 21817*/      OPC_MoveChild2,
/* 21818*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21821*/      OPC_MoveParent,
/* 21822*/      OPC_SwitchType /*3 cases */, 10, /*MVT::v16i8*/39, // ->21835
/* 21825*/       OPC_EmitInteger32, 0,  // 0 #2
/* 21827*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16),
                     /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 21835*/      /*SwitchType*/ 10, /*MVT::v8i16*/50, // ->21847
/* 21837*/       OPC_EmitInteger32, 0,  // 0 #2
/* 21839*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8),
                     /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 21847*/      /*SwitchType*/ 10, /*MVT::v4i32*/60, // ->21859
/* 21849*/       OPC_EmitInteger32, 0,  // 0 #2
/* 21851*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4),
                     /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 21859*/      0, // EndSwitchType
/* 21860*/     0, /*End of Scope*/
/* 21861*/    /*Scope*/ 43, /*->21905*/
/* 21862*/     OPC_CheckChild1TypeI64,
/* 21863*/     OPC_Scope, 21, /*->21886*/ // 2 children in Scope
/* 21865*/      OPC_RecordChild2, // #2 = $idx
/* 21866*/      OPC_MoveChild2,
/* 21867*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21870*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21872*/      OPC_CheckTypeI32,
/* 21873*/      OPC_MoveParent,
/* 21874*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 21876*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21877*/      OPC_EmitConvertToTarget2, // #3
/* 21878*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$x)
/* 21886*/     /*Scope*/ 17, /*->21904*/
/* 21887*/      OPC_MoveChild2,
/* 21888*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21891*/      OPC_MoveParent,
/* 21892*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 21894*/      OPC_EmitInteger32, 0,  // 0 #2
/* 21896*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$vec, 0:{ *:[i32] }, ?:{ *:[i64] }:$x)
/* 21904*/     0, /*End of Scope*/
/* 21905*/    0, /*End of Scope*/
/* 21906*/   /*Scope*/ 26|128,2/*282*/, /*->22190*/
/* 21908*/    OPC_MoveChild1,
/* 21909*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21912*/    OPC_RecordMemRef,
/* 21913*/    OPC_RecordNode, // #1 = 'ld' chained node
/* 21914*/    OPC_CheckFoldableChainNode,
/* 21915*/    OPC_RecordChild1, // #2 = $addr
/* 21916*/    OPC_Scope, 6|128,1/*134*/, /*->22053*/ // 2 children in Scope
/* 21919*/     OPC_CheckChild1TypeI32,
/* 21920*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 21922*/     OPC_CheckPredicate6,  // Predicate_load
/* 21923*/     OPC_SwitchType /*4 cases */, 29, /*MVT::i32*/7, // ->21955
/* 21926*/      OPC_MoveSibling2,
/* 21927*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21930*/      OPC_RecordNode, // #3 = $idx
/* 21931*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21933*/      OPC_CheckTypeI32,
/* 21934*/      OPC_MoveParent,
/* 21935*/      OPC_CheckType, /*MVT::v4f32*/111, 
/* 21937*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21938*/      OPC_EmitMergeInputChains1_1,
/* 21939*/      OPC_EmitInteger32, 0,  // 0 #4
/* 21941*/      OPC_EmitInteger32, 0,  // 0 #5
/* 21943*/      OPC_EmitConvertToTarget3, // #6
/* 21944*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4f32*/111, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_32_A32:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4f32] }:$vec)
/* 21955*/     /*SwitchType*/ 29, /*MVT::f32*/12, // ->21986
/* 21957*/      OPC_MoveSibling2,
/* 21958*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21961*/      OPC_RecordNode, // #3 = $idx
/* 21962*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21964*/      OPC_CheckTypeI32,
/* 21965*/      OPC_MoveParent,
/* 21966*/      OPC_CheckType, /*MVT::v4f32*/111, 
/* 21968*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21969*/      OPC_EmitMergeInputChains1_1,
/* 21970*/      OPC_EmitInteger32, 0,  // 0 #4
/* 21972*/      OPC_EmitInteger32, 0,  // 0 #5
/* 21974*/      OPC_EmitConvertToTarget3, // #6
/* 21975*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4f32*/111, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (ld:{ *:[f32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_32_A32:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4f32] }:$vec)
/* 21986*/     /*SwitchType*/ 31, /*MVT::i64*/8, // ->22019
/* 21988*/      OPC_MoveSibling2,
/* 21989*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21992*/      OPC_RecordNode, // #3 = $idx
/* 21993*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21995*/      OPC_CheckTypeI32,
/* 21996*/      OPC_MoveParent,
/* 21997*/      OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 22000*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22001*/      OPC_EmitMergeInputChains1_1,
/* 22002*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22004*/      OPC_EmitInteger32, 0,  // 0 #5
/* 22006*/      OPC_EmitConvertToTarget3, // #6
/* 22007*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2f64*/1|128,1/*129*/, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_64_A32:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2f64] }:$vec)
/* 22019*/     /*SwitchType*/ 31, /*MVT::f64*/13, // ->22052
/* 22021*/      OPC_MoveSibling2,
/* 22022*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22025*/      OPC_RecordNode, // #3 = $idx
/* 22026*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 22028*/      OPC_CheckTypeI32,
/* 22029*/      OPC_MoveParent,
/* 22030*/      OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 22033*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22034*/      OPC_EmitMergeInputChains1_1,
/* 22035*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22037*/      OPC_EmitInteger32, 0,  // 0 #5
/* 22039*/      OPC_EmitConvertToTarget3, // #6
/* 22040*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2f64*/1|128,1/*129*/, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (ld:{ *:[f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_64_A32:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2f64] }:$vec)
/* 22052*/     0, // EndSwitchType
/* 22053*/    /*Scope*/ 6|128,1/*134*/, /*->22189*/
/* 22055*/     OPC_CheckChild1TypeI64,
/* 22056*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22058*/     OPC_CheckPredicate6,  // Predicate_load
/* 22059*/     OPC_SwitchType /*4 cases */, 29, /*MVT::i32*/7, // ->22091
/* 22062*/      OPC_MoveSibling2,
/* 22063*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22066*/      OPC_RecordNode, // #3 = $idx
/* 22067*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 22069*/      OPC_CheckTypeI32,
/* 22070*/      OPC_MoveParent,
/* 22071*/      OPC_CheckType, /*MVT::v4f32*/111, 
/* 22073*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22074*/      OPC_EmitMergeInputChains1_1,
/* 22075*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22077*/      OPC_EmitInteger64, 0,  // 0 #5
/* 22079*/      OPC_EmitConvertToTarget3, // #6
/* 22080*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4f32*/111, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_32_A64:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4f32] }:$vec)
/* 22091*/     /*SwitchType*/ 29, /*MVT::f32*/12, // ->22122
/* 22093*/      OPC_MoveSibling2,
/* 22094*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22097*/      OPC_RecordNode, // #3 = $idx
/* 22098*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 22100*/      OPC_CheckTypeI32,
/* 22101*/      OPC_MoveParent,
/* 22102*/      OPC_CheckType, /*MVT::v4f32*/111, 
/* 22104*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22105*/      OPC_EmitMergeInputChains1_1,
/* 22106*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22108*/      OPC_EmitInteger64, 0,  // 0 #5
/* 22110*/      OPC_EmitConvertToTarget3, // #6
/* 22111*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4f32*/111, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (ld:{ *:[f32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_32_A64:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4f32] }:$vec)
/* 22122*/     /*SwitchType*/ 31, /*MVT::i64*/8, // ->22155
/* 22124*/      OPC_MoveSibling2,
/* 22125*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22128*/      OPC_RecordNode, // #3 = $idx
/* 22129*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 22131*/      OPC_CheckTypeI32,
/* 22132*/      OPC_MoveParent,
/* 22133*/      OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 22136*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22137*/      OPC_EmitMergeInputChains1_1,
/* 22138*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22140*/      OPC_EmitInteger64, 0,  // 0 #5
/* 22142*/      OPC_EmitConvertToTarget3, // #6
/* 22143*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2f64*/1|128,1/*129*/, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_64_A64:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2f64] }:$vec)
/* 22155*/     /*SwitchType*/ 31, /*MVT::f64*/13, // ->22188
/* 22157*/      OPC_MoveSibling2,
/* 22158*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22161*/      OPC_RecordNode, // #3 = $idx
/* 22162*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 22164*/      OPC_CheckTypeI32,
/* 22165*/      OPC_MoveParent,
/* 22166*/      OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 22169*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22170*/      OPC_EmitMergeInputChains1_1,
/* 22171*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22173*/      OPC_EmitInteger64, 0,  // 0 #5
/* 22175*/      OPC_EmitConvertToTarget3, // #6
/* 22176*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2f64*/1|128,1/*129*/, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (ld:{ *:[f64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_64_A64:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2f64] }:$vec)
/* 22188*/     0, // EndSwitchType
/* 22189*/    0, /*End of Scope*/
/* 22190*/   /*Scope*/ 97, /*->22288*/
/* 22191*/    OPC_RecordChild1, // #1 = $x
/* 22192*/    OPC_Scope, 44, /*->22238*/ // 2 children in Scope
/* 22194*/     OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 22196*/     OPC_Scope, 21, /*->22219*/ // 2 children in Scope
/* 22198*/      OPC_RecordChild2, // #2 = $idx
/* 22199*/      OPC_MoveChild2,
/* 22200*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22203*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 22205*/      OPC_CheckTypeI32,
/* 22206*/      OPC_MoveParent,
/* 22207*/      OPC_CheckType, /*MVT::v4f32*/111, 
/* 22209*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22210*/      OPC_EmitConvertToTarget2, // #3
/* 22211*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4),
                    /*MVT::v4f32*/111, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx, F32:{ *:[f32] }:$x)
/* 22219*/     /*Scope*/ 17, /*->22237*/
/* 22220*/      OPC_MoveChild2,
/* 22221*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 22224*/      OPC_MoveParent,
/* 22225*/      OPC_CheckType, /*MVT::v4f32*/111, 
/* 22227*/      OPC_EmitInteger32, 0,  // 0 #2
/* 22229*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4),
                    /*MVT::v4f32*/111, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } ?:{ *:[v4f32] }:$vec, 0:{ *:[i32] }, ?:{ *:[f32] }:$x)
/* 22237*/     0, /*End of Scope*/
/* 22238*/    /*Scope*/ 48, /*->22287*/
/* 22239*/     OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 22241*/     OPC_Scope, 23, /*->22266*/ // 2 children in Scope
/* 22243*/      OPC_RecordChild2, // #2 = $idx
/* 22244*/      OPC_MoveChild2,
/* 22245*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22248*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 22250*/      OPC_CheckTypeI32,
/* 22251*/      OPC_MoveParent,
/* 22252*/      OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 22255*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22256*/      OPC_EmitConvertToTarget2, // #3
/* 22257*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx, F64:{ *:[f64] }:$x)
/* 22266*/     /*Scope*/ 19, /*->22286*/
/* 22267*/      OPC_MoveChild2,
/* 22268*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 22271*/      OPC_MoveParent,
/* 22272*/      OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 22275*/      OPC_EmitInteger32, 0,  // 0 #2
/* 22277*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } ?:{ *:[v2f64] }:$vec, 0:{ *:[i32] }, ?:{ *:[f64] }:$x)
/* 22286*/     0, /*End of Scope*/
/* 22287*/    0, /*End of Scope*/
/* 22288*/   0, /*End of Scope*/
/* 22289*/  0, /*End of Scope*/
/* 22290*/ /*SwitchOpcode*/ 96|128,1/*224*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_U),// ->22518
/* 22294*/  OPC_Scope, 87, /*->22383*/ // 2 children in Scope
/* 22296*/   OPC_MoveChild0,
/* 22297*/   OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 22300*/   OPC_MoveChild0,
/* 22301*/   OPC_SwitchOpcode /*2 cases */, 37, TARGET_VAL(ISD::ADD),// ->22342
/* 22305*/    OPC_RecordChild0, // #0 = $lhs
/* 22306*/    OPC_RecordChild1, // #1 = $rhs
/* 22307*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 22309*/    OPC_MoveSibling1,
/* 22310*/    OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
/* 22313*/    OPC_CheckChild0Integer, 2, 
/* 22315*/    OPC_CheckChild0TypeI32,
/* 22316*/    OPC_MoveParent,
/* 22317*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 22319*/    OPC_MoveParent,
/* 22320*/    OPC_CheckChild1Integer, 2, 
/* 22322*/    OPC_SwitchType /*2 cases */, 7, /*MVT::v16i8*/39, // ->22332
/* 22325*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>, (splat_vector:{ *:[v16i8] } 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 22332*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->22341
/* 22334*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>, (splat_vector:{ *:[v8i16] } 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 22341*/    0, // EndSwitchType
/* 22342*/   /*SwitchOpcode*/ 37, TARGET_VAL(ISD::SPLAT_VECTOR),// ->22382
/* 22345*/    OPC_CheckChild0Integer, 2, 
/* 22347*/    OPC_CheckChild0TypeI32,
/* 22348*/    OPC_MoveSibling1,
/* 22349*/    OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 22352*/    OPC_RecordChild0, // #0 = $lhs
/* 22353*/    OPC_RecordChild1, // #1 = $rhs
/* 22354*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 22356*/    OPC_MoveParent,
/* 22357*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 22359*/    OPC_MoveParent,
/* 22360*/    OPC_CheckChild1Integer, 2, 
/* 22362*/    OPC_SwitchType /*2 cases */, 7, /*MVT::v16i8*/39, // ->22372
/* 22365*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (splat_vector:{ *:[v16i8] } 1:{ *:[i32] }), (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 22372*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->22381
/* 22374*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (splat_vector:{ *:[v8i16] } 1:{ *:[i32] }), (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 22381*/    0, // EndSwitchType
/* 22382*/   0, // EndSwitchOpcode
/* 22383*/  /*Scope*/ 4|128,1/*132*/, /*->22517*/
/* 22385*/   OPC_RecordChild0, // #0 = $lhs
/* 22386*/   OPC_Scope, 84, /*->22472*/ // 2 children in Scope
/* 22388*/    OPC_MoveChild1,
/* 22389*/    OPC_Scope, 24, /*->22415*/ // 5 children in Scope
/* 22391*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22394*/     OPC_MoveChild0,
/* 22395*/     OPC_CheckAndImm, 63, 
/* 22397*/     OPC_RecordChild0, // #1 = $rhs
/* 22398*/     OPC_MoveParent,
/* 22399*/     OPC_MoveParent,
/* 22400*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 22402*/     OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                   /*MVT::i32*/7, 1/*#Ops*/, 1,  // Results = #2
/* 22408*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 2, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 22415*/    /*Scope*/ 13, /*->22429*/
/* 22416*/     OPC_CheckAndImm, 7, 
/* 22418*/     OPC_RecordChild0, // #1 = $rhs
/* 22419*/     OPC_MoveParent,
/* 22420*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 22422*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22429*/    /*Scope*/ 13, /*->22443*/
/* 22430*/     OPC_CheckAndImm, 15, 
/* 22432*/     OPC_RecordChild0, // #1 = $rhs
/* 22433*/     OPC_MoveParent,
/* 22434*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 22436*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22443*/    /*Scope*/ 13, /*->22457*/
/* 22444*/     OPC_CheckAndImm, 31, 
/* 22446*/     OPC_RecordChild0, // #1 = $rhs
/* 22447*/     OPC_MoveParent,
/* 22448*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 22450*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22457*/    /*Scope*/ 13, /*->22471*/
/* 22458*/     OPC_CheckAndImm, 63, 
/* 22460*/     OPC_RecordChild0, // #1 = $rhs
/* 22461*/     OPC_MoveParent,
/* 22462*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 22464*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22471*/    0, /*End of Scope*/
/* 22472*/   /*Scope*/ 43, /*->22516*/
/* 22473*/    OPC_RecordChild1, // #1 = $x
/* 22474*/    OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->22485
/* 22477*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22478*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 22485*/    /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->22495
/* 22487*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22488*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 22495*/    /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->22505
/* 22497*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22498*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 22505*/    /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->22515
/* 22507*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22508*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 22515*/    0, // EndSwitchType
/* 22516*/   0, /*End of Scope*/
/* 22517*/  0, /*End of Scope*/
/* 22518*/ /*SwitchOpcode*/ 22|128,4/*534*/, TARGET_VAL(ISD::SPLAT_VECTOR),// ->23056
/* 22522*/  OPC_Scope, 73|128,1/*201*/, /*->22726*/ // 4 children in Scope
/* 22525*/   OPC_MoveChild0,
/* 22526*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 22529*/   OPC_RecordMemRef,
/* 22530*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 22531*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 22532*/   OPC_Scope, 95, /*->22629*/ // 2 children in Scope
/* 22534*/    OPC_CheckChild1TypeI32,
/* 22535*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22537*/    OPC_Scope, 45, /*->22584*/ // 2 children in Scope
/* 22539*/     OPC_CheckPredicate, 10, // Predicate_extload
/* 22541*/     OPC_CheckTypeI32,
/* 22542*/     OPC_Scope, 19, /*->22563*/ // 2 children in Scope
/* 22544*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/* 22545*/      OPC_MoveParent,
/* 22546*/      OPC_CheckType, /*MVT::v16i8*/39, 
/* 22548*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22549*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22551*/      OPC_EmitMergeInputChains1_0,
/* 22552*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22554*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v16i8*/39, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v16i8] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>) - Complexity = 16
                // Dst: (LOAD8_SPLAT_A32:{ *:[v16i8] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22563*/     /*Scope*/ 19, /*->22583*/
/* 22564*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/* 22565*/      OPC_MoveParent,
/* 22566*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 22568*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22569*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22571*/      OPC_EmitMergeInputChains1_0,
/* 22572*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22574*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v8i16] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>) - Complexity = 16
                // Dst: (LOAD16_SPLAT_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22583*/     0, /*End of Scope*/
/* 22584*/    /*Scope*/ 43, /*->22628*/
/* 22585*/     OPC_CheckPredicate6,  // Predicate_load
/* 22586*/     OPC_SwitchType /*2 cases */, 18, /*MVT::i32*/7, // ->22607
/* 22589*/      OPC_MoveParent,
/* 22590*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 22592*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22593*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22595*/      OPC_EmitMergeInputChains1_0,
/* 22596*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22598*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD32_SPLAT_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22607*/     /*SwitchType*/ 18, /*MVT::i64*/8, // ->22627
/* 22609*/      OPC_MoveParent,
/* 22610*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 22612*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22613*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22615*/      OPC_EmitMergeInputChains1_0,
/* 22616*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22618*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD64_SPLAT_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22627*/     0, // EndSwitchType
/* 22628*/    0, /*End of Scope*/
/* 22629*/   /*Scope*/ 95, /*->22725*/
/* 22630*/    OPC_CheckChild1TypeI64,
/* 22631*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22633*/    OPC_Scope, 45, /*->22680*/ // 2 children in Scope
/* 22635*/     OPC_CheckPredicate, 10, // Predicate_extload
/* 22637*/     OPC_CheckTypeI32,
/* 22638*/     OPC_Scope, 19, /*->22659*/ // 2 children in Scope
/* 22640*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/* 22641*/      OPC_MoveParent,
/* 22642*/      OPC_CheckType, /*MVT::v16i8*/39, 
/* 22644*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22645*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22647*/      OPC_EmitMergeInputChains1_0,
/* 22648*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22650*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v16i8*/39, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v16i8] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>) - Complexity = 16
                // Dst: (LOAD8_SPLAT_A64:{ *:[v16i8] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22659*/     /*Scope*/ 19, /*->22679*/
/* 22660*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/* 22661*/      OPC_MoveParent,
/* 22662*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 22664*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22665*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22667*/      OPC_EmitMergeInputChains1_0,
/* 22668*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22670*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v8i16] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>) - Complexity = 16
                // Dst: (LOAD16_SPLAT_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22679*/     0, /*End of Scope*/
/* 22680*/    /*Scope*/ 43, /*->22724*/
/* 22681*/     OPC_CheckPredicate6,  // Predicate_load
/* 22682*/     OPC_SwitchType /*2 cases */, 18, /*MVT::i32*/7, // ->22703
/* 22685*/      OPC_MoveParent,
/* 22686*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 22688*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22689*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22691*/      OPC_EmitMergeInputChains1_0,
/* 22692*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22694*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD32_SPLAT_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22703*/     /*SwitchType*/ 18, /*MVT::i64*/8, // ->22723
/* 22705*/      OPC_MoveParent,
/* 22706*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 22708*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22709*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22711*/      OPC_EmitMergeInputChains1_0,
/* 22712*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22714*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD64_SPLAT_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22723*/     0, // EndSwitchType
/* 22724*/    0, /*End of Scope*/
/* 22725*/   0, /*End of Scope*/
/* 22726*/  /*Scope*/ 20|128,1/*148*/, /*->22876*/
/* 22728*/   OPC_RecordChild0, // #0 = $x
/* 22729*/   OPC_Scope, 102, /*->22833*/ // 3 children in Scope
/* 22731*/    OPC_MoveChild0,
/* 22732*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22735*/    OPC_SwitchType /*2 cases */, 80, /*MVT::i32*/7, // ->22818
/* 22738*/     OPC_MoveParent,
/* 22739*/     OPC_SwitchType /*3 cases */, 37, /*MVT::v16i8*/39, // ->22779
/* 22742*/      OPC_EmitConvertToTarget0, // #1
/* 22743*/      OPC_EmitConvertToTarget0, // #2
/* 22744*/      OPC_EmitConvertToTarget0, // #3
/* 22745*/      OPC_EmitConvertToTarget0, // #4
/* 22746*/      OPC_EmitConvertToTarget0, // #5
/* 22747*/      OPC_EmitConvertToTarget0, // #6
/* 22748*/      OPC_EmitConvertToTarget0, // #7
/* 22749*/      OPC_EmitConvertToTarget0, // #8
/* 22750*/      OPC_EmitConvertToTarget0, // #9
/* 22751*/      OPC_EmitConvertToTarget0, // #10
/* 22752*/      OPC_EmitConvertToTarget0, // #11
/* 22753*/      OPC_EmitConvertToTarget0, // #12
/* 22754*/      OPC_EmitConvertToTarget0, // #13
/* 22755*/      OPC_EmitConvertToTarget0, // #14
/* 22756*/      OPC_EmitConvertToTarget0, // #15
/* 22757*/      OPC_EmitConvertToTarget0, // #16
/* 22758*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I8x16),
                    /*MVT::v16i8*/39, 16/*#Ops*/, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 
                // Src: (splat_vector:{ *:[v16i8] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 22779*/     /*SwitchType*/ 21, /*MVT::v8i16*/50, // ->22802
/* 22781*/      OPC_EmitConvertToTarget0, // #1
/* 22782*/      OPC_EmitConvertToTarget0, // #2
/* 22783*/      OPC_EmitConvertToTarget0, // #3
/* 22784*/      OPC_EmitConvertToTarget0, // #4
/* 22785*/      OPC_EmitConvertToTarget0, // #5
/* 22786*/      OPC_EmitConvertToTarget0, // #6
/* 22787*/      OPC_EmitConvertToTarget0, // #7
/* 22788*/      OPC_EmitConvertToTarget0, // #8
/* 22789*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I16x8),
                    /*MVT::v8i16*/50, 8/*#Ops*/, 1, 2, 3, 4, 5, 6, 7, 8, 
                // Src: (splat_vector:{ *:[v8i16] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 22802*/     /*SwitchType*/ 13, /*MVT::v4i32*/60, // ->22817
/* 22804*/      OPC_EmitConvertToTarget0, // #1
/* 22805*/      OPC_EmitConvertToTarget0, // #2
/* 22806*/      OPC_EmitConvertToTarget0, // #3
/* 22807*/      OPC_EmitConvertToTarget0, // #4
/* 22808*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I32x4),
                    /*MVT::v4i32*/60, 4/*#Ops*/, 1, 2, 3, 4, 
                // Src: (splat_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 22817*/     0, // EndSwitchType
/* 22818*/    /*SwitchType*/ 12, /*MVT::i64*/8, // ->22832
/* 22820*/     OPC_MoveParent,
/* 22821*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 22823*/     OPC_EmitConvertToTarget0, // #1
/* 22824*/     OPC_EmitConvertToTarget0, // #2
/* 22825*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 1, 2, 
               // Src: (splat_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$x) - Complexity = 6
               // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$x, (imm:{ *:[i64] }):$x)
/* 22832*/    0, // EndSwitchType
/* 22833*/   /*Scope*/ 30, /*->22864*/
/* 22834*/    OPC_CheckChild0TypeI32,
/* 22835*/    OPC_SwitchType /*3 cases */, 7, /*MVT::v16i8*/39, // ->22845
/* 22838*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22839*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I8x16),
                   /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } I32:{ *:[i32] }:$x)
/* 22845*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->22854
/* 22847*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22848*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I16x8),
                   /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } I32:{ *:[i32] }:$x)
/* 22854*/    /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->22863
/* 22856*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22857*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I32x4),
                   /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I32x4:{ *:[v4i32] } I32:{ *:[i32] }:$x)
/* 22863*/    0, // EndSwitchType
/* 22864*/   /*Scope*/ 10, /*->22875*/
/* 22865*/    OPC_CheckChild0TypeI64,
/* 22866*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 22868*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22869*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I64x2),
                  /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
              // Dst: (SPLAT_I64x2:{ *:[v2i64] } I64:{ *:[i64] }:$x)
/* 22875*/   0, /*End of Scope*/
/* 22876*/  /*Scope*/ 107, /*->22984*/
/* 22877*/   OPC_MoveChild0,
/* 22878*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 22881*/   OPC_RecordMemRef,
/* 22882*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 22883*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 22884*/   OPC_Scope, 48, /*->22934*/ // 2 children in Scope
/* 22886*/    OPC_CheckChild1TypeI32,
/* 22887*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22889*/    OPC_CheckPredicate6,  // Predicate_load
/* 22890*/    OPC_SwitchType /*2 cases */, 18, /*MVT::f32*/12, // ->22911
/* 22893*/     OPC_MoveParent,
/* 22894*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 22896*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22897*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22899*/     OPC_EmitMergeInputChains1_0,
/* 22900*/     OPC_EmitInteger32, 0,  // 0 #4
/* 22902*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/111, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD32_SPLAT_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22911*/    /*SwitchType*/ 20, /*MVT::f64*/13, // ->22933
/* 22913*/     OPC_MoveParent,
/* 22914*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 22917*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22918*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22920*/     OPC_EmitMergeInputChains1_0,
/* 22921*/     OPC_EmitInteger32, 0,  // 0 #4
/* 22923*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD64_SPLAT_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22933*/    0, // EndSwitchType
/* 22934*/   /*Scope*/ 48, /*->22983*/
/* 22935*/    OPC_CheckChild1TypeI64,
/* 22936*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22938*/    OPC_CheckPredicate6,  // Predicate_load
/* 22939*/    OPC_SwitchType /*2 cases */, 18, /*MVT::f32*/12, // ->22960
/* 22942*/     OPC_MoveParent,
/* 22943*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 22945*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22946*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22948*/     OPC_EmitMergeInputChains1_0,
/* 22949*/     OPC_EmitInteger32, 0,  // 0 #4
/* 22951*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/111, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD32_SPLAT_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22960*/    /*SwitchType*/ 20, /*MVT::f64*/13, // ->22982
/* 22962*/     OPC_MoveParent,
/* 22963*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 22966*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22967*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22969*/     OPC_EmitMergeInputChains1_0,
/* 22970*/     OPC_EmitInteger32, 0,  // 0 #4
/* 22972*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD64_SPLAT_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22982*/    0, // EndSwitchType
/* 22983*/   0, /*End of Scope*/
/* 22984*/  /*Scope*/ 70, /*->23055*/
/* 22985*/   OPC_RecordChild0, // #0 = $x
/* 22986*/   OPC_Scope, 40, /*->23028*/ // 3 children in Scope
/* 22988*/    OPC_MoveChild0,
/* 22989*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 22992*/    OPC_SwitchType /*2 cases */, 16, /*MVT::f32*/12, // ->23011
/* 22995*/     OPC_MoveParent,
/* 22996*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 22998*/     OPC_EmitConvertToTarget0, // #1
/* 22999*/     OPC_EmitConvertToTarget0, // #2
/* 23000*/     OPC_EmitConvertToTarget0, // #3
/* 23001*/     OPC_EmitConvertToTarget0, // #4
/* 23002*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F32x4),
                   /*MVT::v4f32*/111, 4/*#Ops*/, 1, 2, 3, 4, 
               // Src: (splat_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$x) - Complexity = 6
               // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x)
/* 23011*/    /*SwitchType*/ 14, /*MVT::f64*/13, // ->23027
/* 23013*/     OPC_MoveParent,
/* 23014*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 23017*/     OPC_EmitConvertToTarget0, // #1
/* 23018*/     OPC_EmitConvertToTarget0, // #2
/* 23019*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F64x2),
                   /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 1, 2, 
               // Src: (splat_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$x) - Complexity = 6
               // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$x, (fpimm:{ *:[f64] }):$x)
/* 23027*/    0, // EndSwitchType
/* 23028*/   /*Scope*/ 11, /*->23040*/
/* 23029*/    OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 23031*/    OPC_CheckType, /*MVT::v4f32*/111, 
/* 23033*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23034*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F32x4),
                  /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
              // Dst: (SPLAT_F32x4:{ *:[v4f32] } F32:{ *:[f32] }:$x)
/* 23040*/   /*Scope*/ 13, /*->23054*/
/* 23041*/    OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 23043*/    OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 23046*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23047*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
              // Dst: (SPLAT_F64x2:{ *:[v2f64] } F64:{ *:[f64] }:$x)
/* 23054*/   0, /*End of Scope*/
/* 23055*/  0, /*End of Scope*/
/* 23056*/ /*SwitchOpcode*/ 26|128,2/*282*/, TARGET_VAL(ISD::SCALAR_TO_VECTOR),// ->23342
/* 23060*/  OPC_Scope, 103, /*->23165*/ // 4 children in Scope
/* 23062*/   OPC_MoveChild0,
/* 23063*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 23066*/   OPC_RecordMemRef,
/* 23067*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 23068*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 23069*/   OPC_Scope, 46, /*->23117*/ // 2 children in Scope
/* 23071*/    OPC_CheckChild1TypeI32,
/* 23072*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 23074*/    OPC_CheckPredicate6,  // Predicate_load
/* 23075*/    OPC_SwitchType /*2 cases */, 18, /*MVT::i32*/7, // ->23096
/* 23078*/     OPC_MoveParent,
/* 23079*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 23081*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 23082*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 23084*/     OPC_EmitMergeInputChains1_0,
/* 23085*/     OPC_EmitInteger32, 0,  // 0 #4
/* 23087*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_32_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 23096*/    /*SwitchType*/ 18, /*MVT::i64*/8, // ->23116
/* 23098*/     OPC_MoveParent,
/* 23099*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 23101*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 23102*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 23104*/     OPC_EmitMergeInputChains1_0,
/* 23105*/     OPC_EmitInteger32, 0,  // 0 #4
/* 23107*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_64_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 23116*/    0, // EndSwitchType
/* 23117*/   /*Scope*/ 46, /*->23164*/
/* 23118*/    OPC_CheckChild1TypeI64,
/* 23119*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 23121*/    OPC_CheckPredicate6,  // Predicate_load
/* 23122*/    OPC_SwitchType /*2 cases */, 18, /*MVT::i32*/7, // ->23143
/* 23125*/     OPC_MoveParent,
/* 23126*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 23128*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 23129*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 23131*/     OPC_EmitMergeInputChains1_0,
/* 23132*/     OPC_EmitInteger32, 0,  // 0 #4
/* 23134*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_32_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 23143*/    /*SwitchType*/ 18, /*MVT::i64*/8, // ->23163
/* 23145*/     OPC_MoveParent,
/* 23146*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 23148*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 23149*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 23151*/     OPC_EmitMergeInputChains1_0,
/* 23152*/     OPC_EmitInteger32, 0,  // 0 #4
/* 23154*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_64_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 23163*/    0, // EndSwitchType
/* 23164*/   0, /*End of Scope*/
/* 23165*/  /*Scope*/ 41, /*->23207*/
/* 23166*/   OPC_RecordChild0, // #0 = $x
/* 23167*/   OPC_Scope, 27, /*->23196*/ // 2 children in Scope
/* 23169*/    OPC_CheckChild0TypeI32,
/* 23170*/    OPC_SwitchType /*3 cases */, 6, /*MVT::v16i8*/39, // ->23179
/* 23173*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I8x16),
                   /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } ?:{ *:[i32] }:$x)
/* 23179*/    /*SwitchType*/ 6, /*MVT::v8i16*/50, // ->23187
/* 23181*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I16x8),
                   /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } ?:{ *:[i32] }:$x)
/* 23187*/    /*SwitchType*/ 6, /*MVT::v4i32*/60, // ->23195
/* 23189*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I32x4),
                   /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I32x4:{ *:[v4i32] } ?:{ *:[i32] }:$x)
/* 23195*/    0, // EndSwitchType
/* 23196*/   /*Scope*/ 9, /*->23206*/
/* 23197*/    OPC_CheckChild0TypeI64,
/* 23198*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23200*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I64x2),
                  /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
              // Dst: (SPLAT_I64x2:{ *:[v2i64] } ?:{ *:[i64] }:$x)
/* 23206*/   0, /*End of Scope*/
/* 23207*/  /*Scope*/ 107, /*->23315*/
/* 23208*/   OPC_MoveChild0,
/* 23209*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 23212*/   OPC_RecordMemRef,
/* 23213*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 23214*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 23215*/   OPC_Scope, 48, /*->23265*/ // 2 children in Scope
/* 23217*/    OPC_CheckChild1TypeI32,
/* 23218*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 23220*/    OPC_CheckPredicate6,  // Predicate_load
/* 23221*/    OPC_SwitchType /*2 cases */, 18, /*MVT::f32*/12, // ->23242
/* 23224*/     OPC_MoveParent,
/* 23225*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 23227*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 23228*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 23230*/     OPC_EmitMergeInputChains1_0,
/* 23231*/     OPC_EmitInteger32, 0,  // 0 #4
/* 23233*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/111, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_32_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 23242*/    /*SwitchType*/ 20, /*MVT::f64*/13, // ->23264
/* 23244*/     OPC_MoveParent,
/* 23245*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 23248*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 23249*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 23251*/     OPC_EmitMergeInputChains1_0,
/* 23252*/     OPC_EmitInteger32, 0,  // 0 #4
/* 23254*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_64_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 23264*/    0, // EndSwitchType
/* 23265*/   /*Scope*/ 48, /*->23314*/
/* 23266*/    OPC_CheckChild1TypeI64,
/* 23267*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 23269*/    OPC_CheckPredicate6,  // Predicate_load
/* 23270*/    OPC_SwitchType /*2 cases */, 18, /*MVT::f32*/12, // ->23291
/* 23273*/     OPC_MoveParent,
/* 23274*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 23276*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 23277*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 23279*/     OPC_EmitMergeInputChains1_0,
/* 23280*/     OPC_EmitInteger32, 0,  // 0 #4
/* 23282*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/111, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_32_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 23291*/    /*SwitchType*/ 20, /*MVT::f64*/13, // ->23313
/* 23293*/     OPC_MoveParent,
/* 23294*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 23297*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 23298*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 23300*/     OPC_EmitMergeInputChains1_0,
/* 23301*/     OPC_EmitInteger32, 0,  // 0 #4
/* 23303*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_64_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 23313*/    0, // EndSwitchType
/* 23314*/   0, /*End of Scope*/
/* 23315*/  /*Scope*/ 25, /*->23341*/
/* 23316*/   OPC_RecordChild0, // #0 = $x
/* 23317*/   OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/111, // ->23328
/* 23320*/    OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 23322*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F32x4),
                  /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
              // Dst: (SPLAT_F32x4:{ *:[v4f32] } ?:{ *:[f32] }:$x)
/* 23328*/   /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->23340
/* 23331*/    OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 23333*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
              // Dst: (SPLAT_F64x2:{ *:[v2f64] } ?:{ *:[f64] }:$x)
/* 23340*/   0, // EndSwitchType
/* 23341*/  0, /*End of Scope*/
/* 23342*/ /*SwitchOpcode*/ 4|128,1/*132*/, TARGET_VAL(WebAssemblyISD::VEC_SHL),// ->23478
/* 23346*/  OPC_RecordChild0, // #0 = $lhs
/* 23347*/  OPC_Scope, 84, /*->23433*/ // 2 children in Scope
/* 23349*/   OPC_MoveChild1,
/* 23350*/   OPC_Scope, 24, /*->23376*/ // 5 children in Scope
/* 23352*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23355*/    OPC_MoveChild0,
/* 23356*/    OPC_CheckAndImm, 63, 
/* 23358*/    OPC_RecordChild0, // #1 = $rhs
/* 23359*/    OPC_MoveParent,
/* 23360*/    OPC_MoveParent,
/* 23361*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23363*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                  /*MVT::i32*/7, 1/*#Ops*/, 1,  // Results = #2
/* 23369*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 23376*/   /*Scope*/ 13, /*->23390*/
/* 23377*/    OPC_CheckAndImm, 7, 
/* 23379*/    OPC_RecordChild0, // #1 = $rhs
/* 23380*/    OPC_MoveParent,
/* 23381*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 23383*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23390*/   /*Scope*/ 13, /*->23404*/
/* 23391*/    OPC_CheckAndImm, 15, 
/* 23393*/    OPC_RecordChild0, // #1 = $rhs
/* 23394*/    OPC_MoveParent,
/* 23395*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 23397*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23404*/   /*Scope*/ 13, /*->23418*/
/* 23405*/    OPC_CheckAndImm, 31, 
/* 23407*/    OPC_RecordChild0, // #1 = $rhs
/* 23408*/    OPC_MoveParent,
/* 23409*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 23411*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23418*/   /*Scope*/ 13, /*->23432*/
/* 23419*/    OPC_CheckAndImm, 63, 
/* 23421*/    OPC_RecordChild0, // #1 = $rhs
/* 23422*/    OPC_MoveParent,
/* 23423*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23425*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23432*/   0, /*End of Scope*/
/* 23433*/  /*Scope*/ 43, /*->23477*/
/* 23434*/   OPC_RecordChild1, // #1 = $x
/* 23435*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->23446
/* 23438*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23439*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 23446*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->23456
/* 23448*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23449*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 23456*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->23466
/* 23458*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23459*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 23466*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->23476
/* 23468*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23469*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 23476*/   0, // EndSwitchType
/* 23477*/  0, /*End of Scope*/
/* 23478*/ /*SwitchOpcode*/ 4|128,1/*132*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_S),// ->23614
/* 23482*/  OPC_RecordChild0, // #0 = $lhs
/* 23483*/  OPC_Scope, 84, /*->23569*/ // 2 children in Scope
/* 23485*/   OPC_MoveChild1,
/* 23486*/   OPC_Scope, 24, /*->23512*/ // 5 children in Scope
/* 23488*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23491*/    OPC_MoveChild0,
/* 23492*/    OPC_CheckAndImm, 63, 
/* 23494*/    OPC_RecordChild0, // #1 = $rhs
/* 23495*/    OPC_MoveParent,
/* 23496*/    OPC_MoveParent,
/* 23497*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23499*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                  /*MVT::i32*/7, 1/*#Ops*/, 1,  // Results = #2
/* 23505*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 23512*/   /*Scope*/ 13, /*->23526*/
/* 23513*/    OPC_CheckAndImm, 7, 
/* 23515*/    OPC_RecordChild0, // #1 = $rhs
/* 23516*/    OPC_MoveParent,
/* 23517*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 23519*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23526*/   /*Scope*/ 13, /*->23540*/
/* 23527*/    OPC_CheckAndImm, 15, 
/* 23529*/    OPC_RecordChild0, // #1 = $rhs
/* 23530*/    OPC_MoveParent,
/* 23531*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 23533*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23540*/   /*Scope*/ 13, /*->23554*/
/* 23541*/    OPC_CheckAndImm, 31, 
/* 23543*/    OPC_RecordChild0, // #1 = $rhs
/* 23544*/    OPC_MoveParent,
/* 23545*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 23547*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23554*/   /*Scope*/ 13, /*->23568*/
/* 23555*/    OPC_CheckAndImm, 63, 
/* 23557*/    OPC_RecordChild0, // #1 = $rhs
/* 23558*/    OPC_MoveParent,
/* 23559*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23561*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23568*/   0, /*End of Scope*/
/* 23569*/  /*Scope*/ 43, /*->23613*/
/* 23570*/   OPC_RecordChild1, // #1 = $x
/* 23571*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->23582
/* 23574*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23575*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 23582*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->23592
/* 23584*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23585*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 23592*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->23602
/* 23594*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23595*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 23602*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->23612
/* 23604*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23605*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 23612*/   0, // EndSwitchType
/* 23613*/  0, /*End of Scope*/
/* 23614*/ /*SwitchOpcode*/ 66|128,8/*1090*/, TARGET_VAL(ISD::VSELECT),// ->24708
/* 23618*/  OPC_Scope, 13|128,1/*141*/, /*->23762*/ // 4 children in Scope
/* 23621*/   OPC_MoveChild0,
/* 23622*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 23625*/   OPC_MoveChild0,
/* 23626*/   OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 23629*/   OPC_RecordChild0, // #0 = $rhs
/* 23630*/   OPC_SwitchType /*3 cases */, 41, /*MVT::v4f32*/111, // ->23674
/* 23633*/    OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 23635*/    OPC_MoveSibling1,
/* 23636*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 23639*/    OPC_RecordChild0, // #1 = $lhs
/* 23640*/    OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 23642*/    OPC_MoveParent,
/* 23643*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23645*/    OPC_MoveParent,
/* 23646*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 23648*/    OPC_Scope, 11, /*->23661*/ // 2 children in Scope
/* 23650*/     OPC_CheckChild1Same, 0,
/* 23652*/     OPC_CheckChild2Same, 1,
/* 23654*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 23661*/    /*Scope*/ 11, /*->23673*/
/* 23662*/     OPC_CheckChild1Same, 1,
/* 23664*/     OPC_CheckChild2Same, 0,
/* 23666*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 23673*/    0, /*End of Scope*/
/* 23674*/   /*SwitchType*/ 41, /*MVT::v2f64*/1|128,1/*129*/, // ->23718
/* 23677*/    OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 23679*/    OPC_MoveSibling1,
/* 23680*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 23683*/    OPC_RecordChild0, // #1 = $lhs
/* 23684*/    OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 23686*/    OPC_MoveParent,
/* 23687*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23689*/    OPC_MoveParent,
/* 23690*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23692*/    OPC_Scope, 11, /*->23705*/ // 2 children in Scope
/* 23694*/     OPC_CheckChild1Same, 0,
/* 23696*/     OPC_CheckChild2Same, 1,
/* 23698*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 23705*/    /*Scope*/ 11, /*->23717*/
/* 23706*/     OPC_CheckChild1Same, 1,
/* 23708*/     OPC_CheckChild2Same, 0,
/* 23710*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 23717*/    0, /*End of Scope*/
/* 23718*/   /*SwitchType*/ 41, /*MVT::v8f16*/92, // ->23761
/* 23720*/    OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 23722*/    OPC_MoveSibling1,
/* 23723*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 23726*/    OPC_RecordChild0, // #1 = $lhs
/* 23727*/    OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 23729*/    OPC_MoveParent,
/* 23730*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23732*/    OPC_MoveParent,
/* 23733*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 23735*/    OPC_Scope, 11, /*->23748*/ // 2 children in Scope
/* 23737*/     OPC_CheckChild1Same, 0,
/* 23739*/     OPC_CheckChild2Same, 1,
/* 23741*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v8i16] } (setcc:{ *:[v8i16] } (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$rhs), (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v8i16] }:$rhs, V128:{ *:[v8i16] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 23748*/    /*Scope*/ 11, /*->23760*/
/* 23749*/     OPC_CheckChild1Same, 1,
/* 23751*/     OPC_CheckChild2Same, 0,
/* 23753*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v8i16] } (setcc:{ *:[v8i16] } (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$lhs), (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v8i16] }:$rhs, V128:{ *:[v8i16] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 23760*/    0, /*End of Scope*/
/* 23761*/   0, // EndSwitchType
/* 23762*/  /*Scope*/ 45, /*->23808*/
/* 23763*/   OPC_RecordChild0, // #0 = $c
/* 23764*/   OPC_RecordChild1, // #1 = $v1
/* 23765*/   OPC_RecordChild2, // #2 = $v2
/* 23766*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->23777
/* 23769*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 23777*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->23787
/* 23779*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 23787*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->23797
/* 23789*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 23797*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->23807
/* 23799*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 23807*/   0, // EndSwitchType
/* 23808*/  /*Scope*/ 101|128,6/*869*/, /*->24679*/
/* 23810*/   OPC_MoveChild0,
/* 23811*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 23814*/   OPC_RecordChild0, // #0 = $rhs
/* 23815*/   OPC_Scope, 21|128,2/*277*/, /*->24095*/ // 3 children in Scope
/* 23818*/    OPC_CheckChild0Type, /*MVT::v4f32*/111, 
/* 23820*/    OPC_RecordChild1, // #1 = $lhs
/* 23821*/    OPC_Scope, 33, /*->23856*/ // 8 children in Scope
/* 23823*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23825*/     OPC_MoveParent,
/* 23826*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 23828*/     OPC_Scope, 12, /*->23842*/ // 2 children in Scope
/* 23830*/      OPC_CheckChild1Same, 0,
/* 23832*/      OPC_CheckChild2Same, 1,
/* 23834*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23835*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23842*/     /*Scope*/ 12, /*->23855*/
/* 23843*/      OPC_CheckChild1Same, 1,
/* 23845*/      OPC_CheckChild2Same, 0,
/* 23847*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23848*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23855*/     0, /*End of Scope*/
/* 23856*/    /*Scope*/ 33, /*->23890*/
/* 23857*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 23859*/     OPC_MoveParent,
/* 23860*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 23862*/     OPC_Scope, 12, /*->23876*/ // 2 children in Scope
/* 23864*/      OPC_CheckChild1Same, 0,
/* 23866*/      OPC_CheckChild2Same, 1,
/* 23868*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23869*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23876*/     /*Scope*/ 12, /*->23889*/
/* 23877*/      OPC_CheckChild1Same, 1,
/* 23879*/      OPC_CheckChild2Same, 0,
/* 23881*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23882*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23889*/     0, /*End of Scope*/
/* 23890*/    /*Scope*/ 33, /*->23924*/
/* 23891*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 23893*/     OPC_MoveParent,
/* 23894*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 23896*/     OPC_Scope, 12, /*->23910*/ // 2 children in Scope
/* 23898*/      OPC_CheckChild1Same, 1,
/* 23900*/      OPC_CheckChild2Same, 0,
/* 23902*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23903*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23910*/     /*Scope*/ 12, /*->23923*/
/* 23911*/      OPC_CheckChild1Same, 0,
/* 23913*/      OPC_CheckChild2Same, 1,
/* 23915*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23916*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23923*/     0, /*End of Scope*/
/* 23924*/    /*Scope*/ 33, /*->23958*/
/* 23925*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 23927*/     OPC_MoveParent,
/* 23928*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 23930*/     OPC_Scope, 12, /*->23944*/ // 2 children in Scope
/* 23932*/      OPC_CheckChild1Same, 1,
/* 23934*/      OPC_CheckChild2Same, 0,
/* 23936*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23937*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23944*/     /*Scope*/ 12, /*->23957*/
/* 23945*/      OPC_CheckChild1Same, 0,
/* 23947*/      OPC_CheckChild2Same, 1,
/* 23949*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23950*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23957*/     0, /*End of Scope*/
/* 23958*/    /*Scope*/ 33, /*->23992*/
/* 23959*/     OPC_CheckChild2CondCode, ISD::SETLT,
/* 23961*/     OPC_MoveParent,
/* 23962*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 23964*/     OPC_Scope, 12, /*->23978*/ // 2 children in Scope
/* 23966*/      OPC_CheckChild1Same, 0,
/* 23968*/      OPC_CheckChild2Same, 1,
/* 23970*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23971*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23978*/     /*Scope*/ 12, /*->23991*/
/* 23979*/      OPC_CheckChild1Same, 1,
/* 23981*/      OPC_CheckChild2Same, 0,
/* 23983*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23984*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23991*/     0, /*End of Scope*/
/* 23992*/    /*Scope*/ 33, /*->24026*/
/* 23993*/     OPC_CheckChild2CondCode, ISD::SETLE,
/* 23995*/     OPC_MoveParent,
/* 23996*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 23998*/     OPC_Scope, 12, /*->24012*/ // 2 children in Scope
/* 24000*/      OPC_CheckChild1Same, 0,
/* 24002*/      OPC_CheckChild2Same, 1,
/* 24004*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24005*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 24012*/     /*Scope*/ 12, /*->24025*/
/* 24013*/      OPC_CheckChild1Same, 1,
/* 24015*/      OPC_CheckChild2Same, 0,
/* 24017*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24018*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 24025*/     0, /*End of Scope*/
/* 24026*/    /*Scope*/ 33, /*->24060*/
/* 24027*/     OPC_CheckChild2CondCode, ISD::SETGT,
/* 24029*/     OPC_MoveParent,
/* 24030*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 24032*/     OPC_Scope, 12, /*->24046*/ // 2 children in Scope
/* 24034*/      OPC_CheckChild1Same, 1,
/* 24036*/      OPC_CheckChild2Same, 0,
/* 24038*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24039*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 24046*/     /*Scope*/ 12, /*->24059*/
/* 24047*/      OPC_CheckChild1Same, 0,
/* 24049*/      OPC_CheckChild2Same, 1,
/* 24051*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24052*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 24059*/     0, /*End of Scope*/
/* 24060*/    /*Scope*/ 33, /*->24094*/
/* 24061*/     OPC_CheckChild2CondCode, ISD::SETGE,
/* 24063*/     OPC_MoveParent,
/* 24064*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 24066*/     OPC_Scope, 12, /*->24080*/ // 2 children in Scope
/* 24068*/      OPC_CheckChild1Same, 1,
/* 24070*/      OPC_CheckChild2Same, 0,
/* 24072*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24073*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 24080*/     /*Scope*/ 12, /*->24093*/
/* 24081*/      OPC_CheckChild1Same, 0,
/* 24083*/      OPC_CheckChild2Same, 1,
/* 24085*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24086*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 24093*/     0, /*End of Scope*/
/* 24094*/    0, /*End of Scope*/
/* 24095*/   /*Scope*/ 46|128,2/*302*/, /*->24399*/
/* 24097*/    OPC_CheckChild0Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24100*/    OPC_RecordChild1, // #1 = $lhs
/* 24101*/    OPC_Scope, 36, /*->24139*/ // 8 children in Scope
/* 24103*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 24105*/     OPC_MoveParent,
/* 24106*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24109*/     OPC_Scope, 13, /*->24124*/ // 2 children in Scope
/* 24111*/      OPC_CheckChild1Same, 0,
/* 24113*/      OPC_CheckChild2Same, 1,
/* 24115*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24116*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24124*/     /*Scope*/ 13, /*->24138*/
/* 24125*/      OPC_CheckChild1Same, 1,
/* 24127*/      OPC_CheckChild2Same, 0,
/* 24129*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24130*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24138*/     0, /*End of Scope*/
/* 24139*/    /*Scope*/ 36, /*->24176*/
/* 24140*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 24142*/     OPC_MoveParent,
/* 24143*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24146*/     OPC_Scope, 13, /*->24161*/ // 2 children in Scope
/* 24148*/      OPC_CheckChild1Same, 0,
/* 24150*/      OPC_CheckChild2Same, 1,
/* 24152*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24153*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24161*/     /*Scope*/ 13, /*->24175*/
/* 24162*/      OPC_CheckChild1Same, 1,
/* 24164*/      OPC_CheckChild2Same, 0,
/* 24166*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24167*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24175*/     0, /*End of Scope*/
/* 24176*/    /*Scope*/ 36, /*->24213*/
/* 24177*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 24179*/     OPC_MoveParent,
/* 24180*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24183*/     OPC_Scope, 13, /*->24198*/ // 2 children in Scope
/* 24185*/      OPC_CheckChild1Same, 1,
/* 24187*/      OPC_CheckChild2Same, 0,
/* 24189*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24190*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24198*/     /*Scope*/ 13, /*->24212*/
/* 24199*/      OPC_CheckChild1Same, 0,
/* 24201*/      OPC_CheckChild2Same, 1,
/* 24203*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24204*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24212*/     0, /*End of Scope*/
/* 24213*/    /*Scope*/ 36, /*->24250*/
/* 24214*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 24216*/     OPC_MoveParent,
/* 24217*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24220*/     OPC_Scope, 13, /*->24235*/ // 2 children in Scope
/* 24222*/      OPC_CheckChild1Same, 1,
/* 24224*/      OPC_CheckChild2Same, 0,
/* 24226*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24227*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24235*/     /*Scope*/ 13, /*->24249*/
/* 24236*/      OPC_CheckChild1Same, 0,
/* 24238*/      OPC_CheckChild2Same, 1,
/* 24240*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24241*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24249*/     0, /*End of Scope*/
/* 24250*/    /*Scope*/ 36, /*->24287*/
/* 24251*/     OPC_CheckChild2CondCode, ISD::SETLT,
/* 24253*/     OPC_MoveParent,
/* 24254*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24257*/     OPC_Scope, 13, /*->24272*/ // 2 children in Scope
/* 24259*/      OPC_CheckChild1Same, 0,
/* 24261*/      OPC_CheckChild2Same, 1,
/* 24263*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24264*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24272*/     /*Scope*/ 13, /*->24286*/
/* 24273*/      OPC_CheckChild1Same, 1,
/* 24275*/      OPC_CheckChild2Same, 0,
/* 24277*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24278*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24286*/     0, /*End of Scope*/
/* 24287*/    /*Scope*/ 36, /*->24324*/
/* 24288*/     OPC_CheckChild2CondCode, ISD::SETLE,
/* 24290*/     OPC_MoveParent,
/* 24291*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24294*/     OPC_Scope, 13, /*->24309*/ // 2 children in Scope
/* 24296*/      OPC_CheckChild1Same, 0,
/* 24298*/      OPC_CheckChild2Same, 1,
/* 24300*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24301*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24309*/     /*Scope*/ 13, /*->24323*/
/* 24310*/      OPC_CheckChild1Same, 1,
/* 24312*/      OPC_CheckChild2Same, 0,
/* 24314*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24315*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24323*/     0, /*End of Scope*/
/* 24324*/    /*Scope*/ 36, /*->24361*/
/* 24325*/     OPC_CheckChild2CondCode, ISD::SETGT,
/* 24327*/     OPC_MoveParent,
/* 24328*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24331*/     OPC_Scope, 13, /*->24346*/ // 2 children in Scope
/* 24333*/      OPC_CheckChild1Same, 1,
/* 24335*/      OPC_CheckChild2Same, 0,
/* 24337*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24338*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24346*/     /*Scope*/ 13, /*->24360*/
/* 24347*/      OPC_CheckChild1Same, 0,
/* 24349*/      OPC_CheckChild2Same, 1,
/* 24351*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24352*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24360*/     0, /*End of Scope*/
/* 24361*/    /*Scope*/ 36, /*->24398*/
/* 24362*/     OPC_CheckChild2CondCode, ISD::SETGE,
/* 24364*/     OPC_MoveParent,
/* 24365*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24368*/     OPC_Scope, 13, /*->24383*/ // 2 children in Scope
/* 24370*/      OPC_CheckChild1Same, 1,
/* 24372*/      OPC_CheckChild2Same, 0,
/* 24374*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24375*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24383*/     /*Scope*/ 13, /*->24397*/
/* 24384*/      OPC_CheckChild1Same, 0,
/* 24386*/      OPC_CheckChild2Same, 1,
/* 24388*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24389*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24397*/     0, /*End of Scope*/
/* 24398*/    0, /*End of Scope*/
/* 24399*/   /*Scope*/ 21|128,2/*277*/, /*->24678*/
/* 24401*/    OPC_CheckChild0Type, /*MVT::v8f16*/92, 
/* 24403*/    OPC_RecordChild1, // #1 = $lhs
/* 24404*/    OPC_Scope, 33, /*->24439*/ // 8 children in Scope
/* 24406*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 24408*/     OPC_MoveParent,
/* 24409*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24411*/     OPC_Scope, 12, /*->24425*/ // 2 children in Scope
/* 24413*/      OPC_CheckChild1Same, 0,
/* 24415*/      OPC_CheckChild2Same, 1,
/* 24417*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24418*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24425*/     /*Scope*/ 12, /*->24438*/
/* 24426*/      OPC_CheckChild1Same, 1,
/* 24428*/      OPC_CheckChild2Same, 0,
/* 24430*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24431*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24438*/     0, /*End of Scope*/
/* 24439*/    /*Scope*/ 33, /*->24473*/
/* 24440*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 24442*/     OPC_MoveParent,
/* 24443*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24445*/     OPC_Scope, 12, /*->24459*/ // 2 children in Scope
/* 24447*/      OPC_CheckChild1Same, 0,
/* 24449*/      OPC_CheckChild2Same, 1,
/* 24451*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24452*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24459*/     /*Scope*/ 12, /*->24472*/
/* 24460*/      OPC_CheckChild1Same, 1,
/* 24462*/      OPC_CheckChild2Same, 0,
/* 24464*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24465*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24472*/     0, /*End of Scope*/
/* 24473*/    /*Scope*/ 33, /*->24507*/
/* 24474*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 24476*/     OPC_MoveParent,
/* 24477*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24479*/     OPC_Scope, 12, /*->24493*/ // 2 children in Scope
/* 24481*/      OPC_CheckChild1Same, 1,
/* 24483*/      OPC_CheckChild2Same, 0,
/* 24485*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24486*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24493*/     /*Scope*/ 12, /*->24506*/
/* 24494*/      OPC_CheckChild1Same, 0,
/* 24496*/      OPC_CheckChild2Same, 1,
/* 24498*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24499*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24506*/     0, /*End of Scope*/
/* 24507*/    /*Scope*/ 33, /*->24541*/
/* 24508*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 24510*/     OPC_MoveParent,
/* 24511*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24513*/     OPC_Scope, 12, /*->24527*/ // 2 children in Scope
/* 24515*/      OPC_CheckChild1Same, 1,
/* 24517*/      OPC_CheckChild2Same, 0,
/* 24519*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24520*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24527*/     /*Scope*/ 12, /*->24540*/
/* 24528*/      OPC_CheckChild1Same, 0,
/* 24530*/      OPC_CheckChild2Same, 1,
/* 24532*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24533*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24540*/     0, /*End of Scope*/
/* 24541*/    /*Scope*/ 33, /*->24575*/
/* 24542*/     OPC_CheckChild2CondCode, ISD::SETLT,
/* 24544*/     OPC_MoveParent,
/* 24545*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24547*/     OPC_Scope, 12, /*->24561*/ // 2 children in Scope
/* 24549*/      OPC_CheckChild1Same, 0,
/* 24551*/      OPC_CheckChild2Same, 1,
/* 24553*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24554*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24561*/     /*Scope*/ 12, /*->24574*/
/* 24562*/      OPC_CheckChild1Same, 1,
/* 24564*/      OPC_CheckChild2Same, 0,
/* 24566*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24567*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24574*/     0, /*End of Scope*/
/* 24575*/    /*Scope*/ 33, /*->24609*/
/* 24576*/     OPC_CheckChild2CondCode, ISD::SETLE,
/* 24578*/     OPC_MoveParent,
/* 24579*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24581*/     OPC_Scope, 12, /*->24595*/ // 2 children in Scope
/* 24583*/      OPC_CheckChild1Same, 0,
/* 24585*/      OPC_CheckChild2Same, 1,
/* 24587*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24588*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24595*/     /*Scope*/ 12, /*->24608*/
/* 24596*/      OPC_CheckChild1Same, 1,
/* 24598*/      OPC_CheckChild2Same, 0,
/* 24600*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24601*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24608*/     0, /*End of Scope*/
/* 24609*/    /*Scope*/ 33, /*->24643*/
/* 24610*/     OPC_CheckChild2CondCode, ISD::SETGT,
/* 24612*/     OPC_MoveParent,
/* 24613*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24615*/     OPC_Scope, 12, /*->24629*/ // 2 children in Scope
/* 24617*/      OPC_CheckChild1Same, 1,
/* 24619*/      OPC_CheckChild2Same, 0,
/* 24621*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24622*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24629*/     /*Scope*/ 12, /*->24642*/
/* 24630*/      OPC_CheckChild1Same, 0,
/* 24632*/      OPC_CheckChild2Same, 1,
/* 24634*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24635*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24642*/     0, /*End of Scope*/
/* 24643*/    /*Scope*/ 33, /*->24677*/
/* 24644*/     OPC_CheckChild2CondCode, ISD::SETGE,
/* 24646*/     OPC_MoveParent,
/* 24647*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24649*/     OPC_Scope, 12, /*->24663*/ // 2 children in Scope
/* 24651*/      OPC_CheckChild1Same, 1,
/* 24653*/      OPC_CheckChild2Same, 0,
/* 24655*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24656*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24663*/     /*Scope*/ 12, /*->24676*/
/* 24664*/      OPC_CheckChild1Same, 0,
/* 24666*/      OPC_CheckChild2Same, 1,
/* 24668*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24669*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24676*/     0, /*End of Scope*/
/* 24677*/    0, /*End of Scope*/
/* 24678*/   0, /*End of Scope*/
/* 24679*/  /*Scope*/ 27, /*->24707*/
/* 24680*/   OPC_RecordChild0, // #0 = $c
/* 24681*/   OPC_RecordChild1, // #1 = $v1
/* 24682*/   OPC_RecordChild2, // #2 = $v2
/* 24683*/   OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/111, // ->24694
/* 24686*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4f32*/111, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4f32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 24694*/   /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->24706
/* 24697*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2f64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 24706*/   0, // EndSwitchType
/* 24707*/  0, /*End of Scope*/
/* 24708*/ /*SwitchOpcode*/ 16, TARGET_VAL(WebAssemblyISD::SWIZZLE),// ->24727
/* 24711*/  OPC_RecordChild0, // #0 = $src
/* 24712*/  OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 24714*/  OPC_RecordChild1, // #1 = $mask
/* 24715*/  OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 24717*/  OPC_CheckType, /*MVT::v16i8*/39, 
/* 24719*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24720*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SWIZZLE),
                /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
            // Src: (wasm_swizzle:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 3
            // Dst: (SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 24727*/ /*SwitchOpcode*/ 39, TARGET_VAL(ISD::ABS),// ->24769
/* 24730*/  OPC_RecordChild0, // #0 = $v
/* 24731*/  OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->24741
/* 24734*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24735*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I8x16),
                 /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (ABS_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 24741*/  /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->24750
/* 24743*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24744*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$v) - Complexity = 3
             // Dst: (ABS_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 24750*/  /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->24759
/* 24752*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24753*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
             // Dst: (ABS_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 24759*/  /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->24768
/* 24761*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24762*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
             // Dst: (ABS_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 24768*/  0, // EndSwitchType
/* 24769*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::SADDSAT),// ->24796
/* 24772*/  OPC_RecordChild0, // #0 = $lhs
/* 24773*/  OPC_RecordChild1, // #1 = $rhs
/* 24774*/  OPC_SwitchType /*2 cases */, 8, /*MVT::v16i8*/39, // ->24785
/* 24777*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24778*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_S_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24785*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24795
/* 24787*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24788*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24795*/  0, // EndSwitchType
/* 24796*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::UADDSAT),// ->24823
/* 24799*/  OPC_RecordChild0, // #0 = $lhs
/* 24800*/  OPC_RecordChild1, // #1 = $rhs
/* 24801*/  OPC_SwitchType /*2 cases */, 8, /*MVT::v16i8*/39, // ->24812
/* 24804*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24805*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_U_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24812*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24822
/* 24814*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24815*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_U_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24822*/  0, // EndSwitchType
/* 24823*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::SSUBSAT),// ->24850
/* 24826*/  OPC_RecordChild0, // #0 = $lhs
/* 24827*/  OPC_RecordChild1, // #1 = $rhs
/* 24828*/  OPC_SwitchType /*2 cases */, 8, /*MVT::v16i8*/39, // ->24839
/* 24831*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24832*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_S_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (SUB_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24839*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24849
/* 24841*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24842*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (SUB_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24849*/  0, // EndSwitchType
/* 24850*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::USUBSAT),// ->24877
/* 24853*/  OPC_RecordChild0, // #0 = $lhs
/* 24854*/  OPC_RecordChild1, // #1 = $rhs
/* 24855*/  OPC_SwitchType /*2 cases */, 8, /*MVT::v16i8*/39, // ->24866
/* 24858*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24859*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_U_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (SUB_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24866*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24876
/* 24868*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24869*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_U_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (SUB_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24876*/  0, // EndSwitchType
/* 24877*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::SMIN),// ->24914
/* 24880*/  OPC_RecordChild0, // #0 = $lhs
/* 24881*/  OPC_RecordChild1, // #1 = $rhs
/* 24882*/  OPC_SwitchType /*3 cases */, 8, /*MVT::v16i8*/39, // ->24893
/* 24885*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24886*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24893*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24903
/* 24895*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24896*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24903*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->24913
/* 24905*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24906*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 24913*/  0, // EndSwitchType
/* 24914*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::UMIN),// ->24951
/* 24917*/  OPC_RecordChild0, // #0 = $lhs
/* 24918*/  OPC_RecordChild1, // #1 = $rhs
/* 24919*/  OPC_SwitchType /*3 cases */, 8, /*MVT::v16i8*/39, // ->24930
/* 24922*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24923*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24930*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24940
/* 24932*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24933*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24940*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->24950
/* 24942*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24943*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 24950*/  0, // EndSwitchType
/* 24951*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::SMAX),// ->24988
/* 24954*/  OPC_RecordChild0, // #0 = $lhs
/* 24955*/  OPC_RecordChild1, // #1 = $rhs
/* 24956*/  OPC_SwitchType /*3 cases */, 8, /*MVT::v16i8*/39, // ->24967
/* 24959*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24960*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24967*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24977
/* 24969*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24970*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24977*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->24987
/* 24979*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24980*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 24987*/  0, // EndSwitchType
/* 24988*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::UMAX),// ->25025
/* 24991*/  OPC_RecordChild0, // #0 = $lhs
/* 24992*/  OPC_RecordChild1, // #1 = $rhs
/* 24993*/  OPC_SwitchType /*3 cases */, 8, /*MVT::v16i8*/39, // ->25004
/* 24996*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24997*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 25004*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->25014
/* 25006*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25007*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 25014*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->25024
/* 25016*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25017*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 25024*/  0, // EndSwitchType
/* 25025*/ /*SwitchOpcode*/ 9, TARGET_VAL(WebAssemblyISD::DOT),// ->25037
/* 25028*/  OPC_RecordChild0, // #0 = $lhs
/* 25029*/  OPC_RecordChild1, // #1 = $rhs
/* 25030*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DOT),
                /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
            // Src: (wasm_dot:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
            // Dst: (DOT:{ *:[v4i32] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 25037*/ /*SwitchOpcode*/ 13, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_S),// ->25053
/* 25040*/  OPC_RecordChild0, // #0 = $vec
/* 25041*/  OPC_CheckChild0Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 25044*/  OPC_CheckType, /*MVT::v4i32*/60, 
/* 25046*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25047*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::trunc_sat_zero_s_I32x4),
                /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_s:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_s_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 25053*/ /*SwitchOpcode*/ 13, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_U),// ->25069
/* 25056*/  OPC_RecordChild0, // #0 = $vec
/* 25057*/  OPC_CheckChild0Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 25060*/  OPC_CheckType, /*MVT::v4i32*/60, 
/* 25062*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25063*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::trunc_sat_zero_u_I32x4),
                /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_u:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_u_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 25069*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->25108
/* 25072*/  OPC_RecordChild0, // #0 = $vec
/* 25073*/  OPC_SwitchType /*3 cases */, 9, /*MVT::v8i16*/50, // ->25085
/* 25076*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 25078*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25079*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 25085*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->25096
/* 25087*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 25089*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25090*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 25096*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->25107
/* 25098*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 25100*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25101*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 25107*/  0, // EndSwitchType
/* 25108*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->25147
/* 25111*/  OPC_RecordChild0, // #0 = $vec
/* 25112*/  OPC_SwitchType /*3 cases */, 9, /*MVT::v8i16*/50, // ->25124
/* 25115*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 25117*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25118*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 25124*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->25135
/* 25126*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 25128*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25129*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 25135*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->25146
/* 25137*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 25139*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25140*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 25146*/  0, // EndSwitchType
/* 25147*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->25186
/* 25150*/  OPC_RecordChild0, // #0 = $vec
/* 25151*/  OPC_SwitchType /*3 cases */, 9, /*MVT::v8i16*/50, // ->25163
/* 25154*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 25156*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25157*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 25163*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->25174
/* 25165*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 25167*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25168*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 25174*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->25185
/* 25176*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 25178*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25179*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 25185*/  0, // EndSwitchType
/* 25186*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->25225
/* 25189*/  OPC_RecordChild0, // #0 = $vec
/* 25190*/  OPC_SwitchType /*3 cases */, 9, /*MVT::v8i16*/50, // ->25202
/* 25193*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 25195*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25196*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 25202*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->25213
/* 25204*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 25206*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25207*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 25213*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->25224
/* 25215*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 25217*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25218*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 25224*/  0, // EndSwitchType
/* 25225*/ /*SwitchOpcode*/ 31, TARGET_VAL(WebAssemblyISD::NARROW_U),// ->25259
/* 25228*/  OPC_RecordChild0, // #0 = $left
/* 25229*/  OPC_SwitchType /*2 cases */, 12, /*MVT::v16i8*/39, // ->25244
/* 25232*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 25234*/   OPC_RecordChild1, // #1 = $right
/* 25235*/   OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 25237*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (wasm_narrow_u:{ *:[v16i8] } V128:{ *:[v8i16] }:$left, V128:{ *:[v8i16] }:$right) - Complexity = 3
             // Dst: (NARROW_U_I8x16:{ *:[v16i8] } ?:{ *:[v8i16] }:$left, ?:{ *:[v8i16] }:$right)
/* 25244*/  /*SwitchType*/ 12, /*MVT::v8i16*/50, // ->25258
/* 25246*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 25248*/   OPC_RecordChild1, // #1 = $right
/* 25249*/   OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 25251*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (wasm_narrow_u:{ *:[v8i16] } V128:{ *:[v4i32] }:$left, V128:{ *:[v4i32] }:$right) - Complexity = 3
             // Dst: (NARROW_U_I16x8:{ *:[v8i16] } ?:{ *:[v4i32] }:$left, ?:{ *:[v4i32] }:$right)
/* 25258*/  0, // EndSwitchType
/* 25259*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_S),// ->25276
/* 25262*/  OPC_RecordChild0, // #0 = $vec
/* 25263*/  OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 25265*/  OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 25268*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25269*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::convert_low_s_F64x2),
                /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
            // Src: (convert_low_s:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_s_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 25276*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_U),// ->25293
/* 25279*/  OPC_RecordChild0, // #0 = $vec
/* 25280*/  OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 25282*/  OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 25285*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25286*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::convert_low_u_F64x2),
                /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
            // Src: (convert_low_u:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_u_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 25293*/ /*SwitchOpcode*/ 13, TARGET_VAL(WebAssemblyISD::DEMOTE_ZERO),// ->25309
/* 25296*/  OPC_RecordChild0, // #0 = $vec
/* 25297*/  OPC_CheckChild0Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 25300*/  OPC_CheckType, /*MVT::v4f32*/111, 
/* 25302*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25303*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::demote_zero_F32x4),
                /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
            // Src: (demote_zero:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (demote_zero_F32x4:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec)
/* 25309*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::PROMOTE_LOW),// ->25326
/* 25312*/  OPC_RecordChild0, // #0 = $vec
/* 25313*/  OPC_CheckChild0Type, /*MVT::v4f32*/111, 
/* 25315*/  OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 25318*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25319*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
            // Src: (promote_low:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
            // Dst: (promote_low_F64x2:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec)
/* 25326*/ 0, // EndSwitchOpcode
    0
  }; // Total Array size is 25328 bytes

  // Opcode Histogram:
  // #OPC_Scope                                = 360
  // #OPC_RecordNode                           = 329
  // #OPC_RecordChild                          = 763
  // #OPC_RecordMemRef                         = 43
  // #OPC_CaptureGlueInput                     = 1
  // #OPC_MoveChild                            = 299
  // #OPC_MoveSibling                          = 327
  // #OPC_MoveParent                           = 614
  // #OPC_CheckSame                            = 0
  // #OPC_CheckChildSame                       = 195
  // #OPC_CheckPatternPredicate                = 761
  // #OPC_CheckPredicate                       = 573
  // #OPC_CheckOpcode                          = 549
  // #OPC_SwitchOpcode                         = 16
  // #OPC_CheckType                            = 608
  // #OPC_SwitchType                           = 184
  // #OPC_CheckChildType                       = 470
  // #OPC_CheckInteger                         = 0
  // #OPC_CheckChildInteger                    = 105
  // #OPC_CheckCondCode                        = 0
  // #OPC_CheckChild2CondCode                  = 165
  // #OPC_CheckValueType                       = 17
  // #OPC_CheckComplexPat                      = 330
  // #OPC_CheckAndImm                          = 27
  // #OPC_CheckOrImm                           = 0
  // #OPC_CheckImmAllOnesV                     = 44
  // #OPC_CheckImmAllZerosV                    = 1
  // #OPC_CheckFoldableChainNode               = 6
  // #OPC_EmitInteger                          = 380
  // #OPC_EmitStringInteger                    = 0
  // #OPC_EmitRegister                         = 0
  // #OPC_EmitConvertToTarget                  = 356
  // #OPC_EmitMergeInputChains                 = 451
  // #OPC_EmitCopyToReg                        = 0
  // #OPC_EmitNode                             = 9
  // #OPC_EmitNodeXForm                        = 0
  // #OPC_CompleteMatch                        = 44
  // #OPC_MorphNodeTo                          = 1268

  #undef COVERAGE_IDX_VAL
  #undef TARGET_VAL
  SelectCodeCommon(N, MatcherTable, sizeof(MatcherTable));
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckPatternPredicate(unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckPatternPredicate(unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: return (Subtarget->hasSIMD128());
  case 1: return (!Subtarget->hasAddr64());
  case 2: return (Subtarget->hasAddr64());
  case 3: return (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 4: return (Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 5: return (Subtarget->hasFP16()) && (Subtarget->hasSIMD128());
  case 6: return (Subtarget->hasReferenceTypes());
  case 7: return (Subtarget->hasRelaxedSIMD());
  case 8: return (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes());
  case 9: return (Subtarget->hasNontrappingFPToInt());
  case 10: return (!Subtarget->hasNontrappingFPToInt());
  case 11: return (Subtarget->hasSignExt());
  case 12: return (Subtarget->hasBulkMemoryOpt());
  case 13: return (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128());
  case 14: return (!Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 15: return (Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 16: return (Subtarget->hasFP16());
  case 17: return (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  case 18: return (Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  case 19: return (Subtarget->hasExceptionHandling());
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckNodePredicate(SDNode *Node, unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckNodePredicate(SDNode *Node, unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: {
    // Predicate_LaneIdx32
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 32;
  }
  case 1: {
    // Predicate_atomic_cmp_swap_i8
    // Predicate_atomic_load_8
    // Predicate_atomic_load_add_i8
    // Predicate_atomic_load_and_i8
    // Predicate_atomic_load_or_i8
    // Predicate_atomic_load_sub_i8
    // Predicate_atomic_load_xor_i8
    // Predicate_atomic_store_8
    // Predicate_atomic_swap_i8
    // Predicate_extloadi8
    // Predicate_sextloadi8
    // Predicate_zextloadi8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
return true;

  }
  case 2: {
    // Predicate_atomic_cmp_swap_i16
    // Predicate_atomic_load_16
    // Predicate_atomic_load_add_i16
    // Predicate_atomic_load_and_i16
    // Predicate_atomic_load_or_i16
    // Predicate_atomic_load_sub_i16
    // Predicate_atomic_load_xor_i16
    // Predicate_atomic_store_16
    // Predicate_atomic_swap_i16
    // Predicate_extloadi16
    // Predicate_sextloadi16
    // Predicate_zextloadi16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
return true;

  }
  case 3: {
    // Predicate_atomic_cmp_swap_i32
    // Predicate_atomic_load_32
    // Predicate_atomic_load_add_i32
    // Predicate_atomic_load_and_i32
    // Predicate_atomic_load_or_i32
    // Predicate_atomic_load_sub_i32
    // Predicate_atomic_load_xor_i32
    // Predicate_atomic_store_32
    // Predicate_atomic_swap_i32
    // Predicate_extloadi32
    // Predicate_sextloadi32
    // Predicate_zextloadi32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
return true;

  }
  case 4: {
    // Predicate_unindexedstore
    SDNode *N = Node;
    (void)N;
if (cast<StoreSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 5: {
    // Predicate_store
    SDNode *N = Node;
    (void)N;
 if (cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 6: {
    // Predicate_load
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::NON_EXTLOAD) return false;
return true;

  }
  case 7: {
    // Predicate_atomic_cmp_swap_i64
    // Predicate_atomic_load_64
    // Predicate_atomic_load_add_i64
    // Predicate_atomic_load_and_i64
    // Predicate_atomic_load_or_i64
    // Predicate_atomic_load_sub_i64
    // Predicate_atomic_load_xor_i64
    // Predicate_atomic_store_64
    // Predicate_atomic_swap_i64
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i64) return false;
return true;

  }
  case 8: {
    // Predicate_unindexedload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 9: {
    // Predicate_ImmI8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (8 - 1)) <= Imm && Imm < (1 << 8);
  }
  case 10: {
    // Predicate_extload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::EXTLOAD) return false;
return true;

  }
  case 11: {
    // Predicate_LaneIdx4
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 4;
  }
  case 12: {
    // Predicate_LaneIdx2
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 2;
  }
  case 13: {
    // Predicate_LaneIdx8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 8;
  }
  case 14: {
    // Predicate_truncstore
    SDNode *N = Node;
    (void)N;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 15: {
    // Predicate_sextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::SEXTLOAD) return false;
return true;

  }
  case 16: {
    // Predicate_zextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::ZEXTLOAD) return false;
return true;

  }
  case 17: {
    // Predicate_ImmI16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (16 - 1)) <= Imm && Imm < (1 << 16);
  }
  case 18: {
    // Predicate_LaneIdx16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 16;
  }
  case 19: {
    // Predicate_truncstorei8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 20: {
    // Predicate_truncstorei16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 21: {
    // Predicate_extloadvi8
    // Predicate_sextloadvi8
    // Predicate_zextloadvi8
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i8) return false;
return true;

  }
  case 22: {
    // Predicate_extloadvi16
    // Predicate_sextloadvi16
    // Predicate_zextloadvi16
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i16) return false;
return true;

  }
  case 23: {
    // Predicate_extloadvi32
    // Predicate_sextloadvi32
    // Predicate_zextloadvi32
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i32) return false;
return true;

  }
  case 24: {
    // Predicate_add_nuw
    SDNode *N = Node;
    (void)N;
return N->getFlags().hasNoUnsignedWrap();
  }
  case 25: {
    // Predicate_truncstorei32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 26: {
    // Predicate_bool_node
    SDNode *N = Node;
    (void)N;

  return CurDAG->computeKnownBits(SDValue(N, 0)).countMinLeadingZeros() == 31;

  }
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result) override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result)
#if DAGISEL_INLINE
  override
#endif
{
  unsigned NextRes = Result.size();
  switch (PatternNo) {
  default: llvm_unreachable("Invalid pattern # in table?");
  case 0:
    Result.resize(NextRes+2);
  return SelectAddrOperands32(N, Result[NextRes+0].first, Result[NextRes+1].first);
  case 1:
    Result.resize(NextRes+2);
  return SelectAddrOperands64(N, Result[NextRes+0].first, Result[NextRes+1].first);
  }
}
#endif // GET_DAGISEL_BODY


#ifdef DAGISEL_INLINE
#undef DAGISEL_INLINE
#endif
#ifdef DAGISEL_CLASS_COLONCOLON
#undef DAGISEL_CLASS_COLONCOLON
#endif
#ifdef GET_DAGISEL_DECL
#undef GET_DAGISEL_DECL
#endif
#ifdef GET_DAGISEL_BODY
#undef GET_DAGISEL_BODY
#endif
